/*********************************************************************************

	Copyright.h

	Alphabet Rosetta

	(c)Copyright 2017-2020  Alphabet AB, Sweden (Jan Bergstrom)

	http://www.alphabet.se

	Licensed under the Apache License, Version 2.0 (the "License");
	you may not use this file except in compliance with the License.
	You may obtain a copy of the License at

	http://www.apache.org/licenses/LICENSE-2.0

	Unless required by applicable law or agreed to in writing, software
	distributed under the License is distributed on an "AS IS" BASIS,
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the License for the specific language governing permissions and
	limitations under the License.

	We ask for attribution to us, when used.

******************************************************************************************

The Copyright.h file contains the basic app specific definitions.

**********************************************************************************/
#ifndef FALSE
#define FALSE						0
#endif
#ifndef TRUE
#define TRUE						1
#endif

#if __APPLE__
#include <TargetConditionals.h>
#if TARGET_IPHONE_SIMULATOR == 1
#define IOS							1 // Apple iOS
#elif TARGET_OS_IPHONE == 1
#define IOS							1 // Apple iOS
#elif TARGET_OS_MAC == 1
#define OSX							1 // Apple OSX
#endif
//#define TRUE						1
//#define FALSE						0
#endif


#define EDITOR						FALSE
#define TRIAL_VERSION				FALSE
#if TRIAL_VERSION
#define SAVE_FILES					FALSE
#else
#define SAVE_FILES					TRUE
#endif
//#define VIEW_DEMO					Set in the demo file
//#define FIO_DEMO					Set in the demo file

#if SAVE_FILES
// Windows adverts	
#define ADVERTS						FALSE 
#else
#define ADVERTS						TRUE	// Windows adverts	
#endif
// Windows substitute own adverts
#define WINDOWS_ADV					TRUE
#define ANDROID_ADV					TRUE
#define IPHONE_ADV					FALSE  
#define MACINTOSH_ADV				FALSE

#define SECTION_ANALYSE				FALSE  
#define SECTION_ERROR				FALSE  
#define SECTION_IMVOICE				FALSE  
#define SECTION_BANKSTATEMENT		FALSE  

#define ROSETTA_FIO					TRUE  
#define SIE_FIO						TRUE 
#define XGL_FIO						TRUE

#if VIEW_DEMO
#define PROGRAM_NAME				"Rosetta View Demo"
#elif FIO_DEMO
#define PROGRAM_NAME				"Rosetta Fio demo"
#elif TRIAL_VERSION
#define PROGRAM_NAME				"Rosetta SIE-XBRL/GL Viewer"
#elif EDITOR
#define PROGRAM_NAME				"Rosetta Accounting"
#else
#define PROGRAM_NAME				"Rosetta SIE-XBRL/GL Viewer"
#endif
#define PROGRAM_COPYRIGHT			"Copyright (c) 2016-2020 Alphabet AB (Jan Bergstrom)"
#define PROGRAM_DOMAIN				"se.alphabet.rosetta"
#define PROGRAM_WEB					"www.Alphabet.se"
#define OWNER_COMPANY_TEXT			"Alphabet AB\0"
#define DEV_COMPANY_TEXT			"Alphabet"
#define FILE_NAME_TEXT				"Rosetta.exe\0"
#define PROJECT						"Rosetta Accounting" 

#define EXPIRE_DATE					20220101
#define FIO_VERSION					"1.6"
#define VIEW_VERSION				"1.6"
#define WINDOWS_PROGRAM_VERSION		"1.6.48"
#define ANDROID_PROGRAM_VERSION		"1.6.41"
#define IOS_PROGRAM_VERSION			"1.6.0"
#define OSX_PROGRAM_VERSION			"1.6.0"
#define ROSETTA_VERSION				"1.6"
#define FOR_WINDOWS					"for Windows"
#define FOR_ANDROID					"for Android"
#define FOR_IOS						"for iPhone (iOS)"
#define FOR_OSX						"for Macintosh (OSX)"
#define FOR_GENERIC					"for any OS"
#define VIEW_LIB					"Viewer library"
#define FIO_LIB						"File I/O library"
#define DEMO						"Demo"
#define XML_SCHEMAS					"XML Schemas"

#define APP_XSD						"http://www.alphabet.se/Rosetta/Rosetta.xsd"
#define APP_XSL						""
#define APP_VIEWER_MS				"https://www.microsoft.com/store/apps/9PP9F5K2JV3J"
#define APP_VIEWER_GP				"https://play.google.com/store/apps/details?id=se.alphabet.rosetta.Rosetta"
#define W_PROGRAM_WEB				L"http://www.Alphabet.se"
#define W_APP_VIEWER_MS				L"https://www.microsoft.com/store/apps/9PP9F5K2JV3J"
#define W_APP_VIEWER_GP				L"https://play.google.com/store/apps/details?id=se.alphabet.rosetta.Rosetta"

#if ANDROID
#define PROGRAM_NAME_SHORT			"Rosetta"
#define PROGRAM_NAME_LONG			PROGRAM_NAME" "FOR_ANDROID
#define PROGRAM_VERSION				ANDROID_PROGRAM_VERSION
#elif IOS
#define PROGRAM_NAME_SHORT			"Rosetta"
#define PROGRAM_NAME_LONG			PROGRAM_NAME" "FOR_IOS
#define PROGRAM_VERSION				IOS_PROGRAM_VERSION
#elif OSX
#define PROGRAM_NAME_SHORT			"Rosetta"
#define PROGRAM_NAME_LONG			PROGRAM_NAME" "FOR_OSX
#define PROGRAM_VERSION				OSX_PROGRAM_VERSION
#elif WIN32
#define PROGRAM_NAME_SHORT			"Rosetta"
#define PROGRAM_NAME_LONG			PROGRAM_NAME" "FOR_WINDOWS
#define PROGRAM_VERSION				WINDOWS_PROGRAM_VERSION
#elif VIEW_DEMO
#define PROGRAM_NAME_SHORT			"RosettaView"
#define PROGRAM_NAME_LONG			PROGRAM_NAME" open "VIEW_LIB" "FOR_GENERIC
#define PROGRAM_VERSION				VIEW_VERSION
#elif FIO_DEMO 
#define PROGRAM_NAME_SHORT			"RosettaFio"
#define PROGRAM_NAME_LONG			PROGRAM_NAME" open "FIO_LIB" "FOR_GENERIC
#define PROGRAM_VERSION				FIO_VERSION
#else
#define PROGRAM_NAME_LONG			PROGRAM_NAME" open "FIO_LIB" "FOR_GENERIC
#define PROGRAM_VERSION				FIO_VERSION
#endif
#define EXT_RESTRICTION				FALSE

#define BRAND_TEXT					DEV_COMPANY_TEXT" "PROGRAM_NAME
#define BRAND_TEXT_LONG				DEV_COMPANY_TEXT" "PROGRAM_NAME_LONG

#define PRODUCT_DECLARATION  BRAND_TEXT_LONG", v. "PROGRAM_VERSION"\n"DEV_COMPANY_TEXT" "PROJECT" "VIEW_LIB", v. "VIEW_VERSION"\n"DEV_COMPANY_TEXT" "PROJECT" "FIO_LIB", v. "FIO_VERSION"\n"DEV_COMPANY_TEXT" "PROJECT" "XML_SCHEMAS", v. "ROSETTA_VERSION"\n"APP_XSD"\n"APP_XSL
#if FIO_DEMO 
#define DEMO_HELP_TEXT "\n\nDemonstration version of the "PROGRAM_NAME_LONG".\n------------------\nIt is showing the OS independent usability of the code supporting opening and writing:\n"PROJECT" and Invoice XML file format ("APP_XSD").\nThe basic idea is that a API open source code is liberating from specification\ninterpret dialects in programming code.\n\nThis is open source by Apache Licence, "PROGRAM_COPYRIGHT"\n\n"PROGRAM_NAME_SHORT" openFilePathName -Z(y)[saveFilePathName] ...\nZ is for filetype R=Rosetta, S=SIE, X=XBRL/GL\n[saveFilePathName] is optional else a fileName will be created from file data\nWith (y) = B (balance), L (ledger), J (vouchers)\n... save file argument can be repeated\n\n"
#elif VIEW_DEMO
#define DEMO_HELP_TEXT "\n\nDemonstration version of the "PROGRAM_NAME_LONG".\n------------------\nIt is showing the OS independent usability of the code supporting opening and writing:\n"PROJECT" and Invoice XML file format ("APP_XSD").\nThe basic idea is that a API open source code is liberating from specification\ninterpret dialects in programming code.\n\nThis is open source by Apache Licence, "PROGRAM_COPYRIGHT"\n\n"PROGRAM_NAME_SHORT" openFilePathName -Z(y)[saveFilePathName] ...\nZ is for filetype R=Rosetta, S=SIE, X=XBRL/GL, T=Text file and C=CSV file\n[saveFilePathName] is optional else a fileName will be created from file data\nWith (y) = B (balance), L (ledger), J (vouchers)\n... save file argument can be repeated\n\nNote that ANSI C does not support ISO639 lanuage codes in its Locale (and Java NDK does not \nsupport locales what so ever). Excel CSV only works with the same settings (semi-colon or \ncomma) dependent on the fact the comma is decimal separator in the SI measure countries.\nThe -L[ISO639 lanuage code] change the language setting.\n\n"
#endif

#define PROGRAM_FEATURES_BROWSE	0x000001
#define PROGRAM_FEATURES_EDIT		0x000002
#if ROSETTA_FIO
#define PROGRAM_FEATURES_ROSETTA	0x000010
#else
#define PROGRAM_FEATURES_ROSETTA	0x000000
#endif
#if SIE_FIO
#define PROGRAM_FEATURES_SIE		0x000020
#else
#define PROGRAM_FEATURES_SIE		0x000000
#endif
#if XGL_FIO
#define PROGRAM_FEATURES_XGL		0x000040
#else
#define PROGRAM_FEATURES_XGL		0x000000
#endif
#if EDITOR
#define PROGRAM_FEATURES_MASK		(PROGRAM_FEATURES_BROWSE | PROGRAM_FEATURES_EDIT | PROGRAM_FEATURES_SIE | PROGRAM_FEATURES_XGL | PROGRAM_FEATURES_ROSETTA)
#else
#define PROGRAM_FEATURES_MASK		(PROGRAM_FEATURES_BROWSE | PROGRAM_FEATURES_SIE | PROGRAM_FEATURES_XGL | PROGRAM_FEATURES_ROSETTA)
#endif

#if ANDROID
#define INFOTIP		TRUE
#elif IOS
#define INFOTIP		TRUE
#elif OSX
#define INFOTIP		TRUE
#elif WIN32
#define INFOTIP		TRUE
#endif

// Print defines
#define				PRINT_BACKGROUND			FALSE
#define				PRINT_FONT_NORMAL_HIGHT		9	// Standard PDF Postscript foint size line hight in 1/72 inch
#define				PRINT_FONT_REPORT_HIGHT		8	// Standard PDF Postscript foint size line hight in 1/72 inch
#define				LIST_LEFT_MARGIN_TABS_BAL	2
#define				LIST_LEFT_MARGIN_TABS		1
#define				LIST_RIGHT_MARGIN_TABS		1
#define				PAGE_MARGIN_BOTTOM_LINES	3
#define				PAGE_MARGIN_TOP_LINES		2
#define				MARGIN_LANDSCAPE_TOP		5
#define				NON_BREAK_LINES				3
#define				RIGHT_ADJUST_SPACE			3
