/********************************************************************

	RosettaFIO.h

	Alphabet Rosetta

	(c)Copyright 2017-2020  Alphabet AB, Sweden (Jan Bergstrom)

	http://www.alphabet.se

	Licensed under the Apache License, Version 2.0 (the "License");
	you may not use this file except in compliance with the License.
	You may obtain a copy of the License at
	
	http://www.apache.org/licenses/LICENSE-2.0
	
	Unless required by applicable law or agreed to in writing, software
	distributed under the License is distributed on an "AS IS" BASIS,
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the License for the specific language governing permissions and
	limitations under the License.

	We ask for attribution to us, when used.

********************************************************************

	This is a machine generated file
		- It is made from the content of an XSD
		- It is made to read, write and handle data in an XML of the XSD
	RosettaProcess.c holds the OS independent application logics.
	MainView.c holds the OS independent screen mirror data.
	OS dependent (first letters i file names) holds user interface.

Content of RosettaFIO.h
1.) Alphabet Rosetta Application data Struct Type Ids
2.) Alphabet Rosetta Application data C Structs
3.) Alphabet Rosetta Enumerations declarations
4.) Alphabet Rosetta External C function declarations

********************************************************************/
#define SUPPORTED_LANGUAGES	12

extern char NulString[1]; 
extern char szString[TEMPSTRING_LENGTH];

/********************************************************************

Alphabet Rosetta Application data Struct Type Ids

********************************************************************/

#define SCT_ACCOUNTING							1
#define SCT_ATTEST								2
#define SCT_PARTY								3
#define SCT_CONTACT								4
#define SCT_ACCOUNTSCHART						5
#define SCT_ACCOUNT								6
#define SCT_ACCOUNTCODE							7
#define SCT_OBJECTSCHART						8
#define SCT_DIMENSION							9
#define SCT_OBJECT								10
#define SCT_LEDGERSCHART						11
#define SCT_LEDGER								12
#define SCT_BALANCEREPORT						13
#define SCT_BALANCETOTAL						14
#define SCT_BALANCETOTALPERIOD					15
#define SCT_BALANCEACCOUNT						16
#define SCT_BALANCEACCOUNTPERIOD				17
#define SCT_VOUCHER								18
#define SCT_VOUCHERENTRY						19
#define SCT_INVOICECHART						20
#define SCT_INVOICE								21
#define SCT_INVOICEENTRY						22
#define SCT_TRADEITEMDATA						23
#define SCT_PAY									24
#define SCT_DEPRECIATIONS						25
#define SCT_DEPRECIATIONENTRY					26
#define SCT_CITRADESETTLEMENTPAYMENTMEANS		27
#define SCT_CIDEBTORFINANCIALACCOUNT			28
#define SCT_CIDEBTORFINANCIALINSTITUTION		29
#define SCT_CICREDITORFINANCIALACCOUNT			30
#define SCT_CICREDITORFINANCIALINSTITUTION		31
#define SCT_TRADESETTLEMENTFINANCIALCARD		32
#define SCT_BRANCHFINANCIALINSTITUTION			33
#define SCT_FINANCIALINSTITUTIONADDRESS			34
#define SCT_AMOUNTCURRENCY						35
#define SCT_TEXT								36
#define SCT_OPERATORINFO						37
#define SCT_PROGRAMINFO							38
#define SCT_SERIESID							39


/********************************************************************

Alphabet Rosetta Application data C Structs

********************************************************************/


//	ProgramInfoType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	char *									pProgramInfo;									// rac:IdToken
	char *									pversion;										// rac:IdToken
	} ProgramInfoType;


//	InvoiceChartType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	LLIST									pListInvoice;									// rac:InvoiceType
	} InvoiceChartType;


//	LedgersChartType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	LLIST									pListLedger;									// rac:LedgerType
	} LedgersChartType;


//	ObjectsChartType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	LLIST									pListDimension;									// rac:DimensionType
	} ObjectsChartType;


//	AccountsChartType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	LLIST									pListAccount;									// rac:AccountType
	} AccountsChartType;


//	PartyType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	char *									pName;											// xs:token
	LLIST									pListAddress;									// xs:token
	char *									pPostalCode;									// xs:token
	char *									pPostalAddress;									// xs:token
	char *									pPostalCountry;									// xs:token
	char *									pEntityPhone;									// rac:Phone
	char *									pEntityEmail;									// rac:Email
	LLIST									pListLogotypeFileUrl;							// rac:FileUrl
	LLIST									pListWebPage;									// rac:FileUrl
	LLIST									pListCrmRef;									// rac:FileUrl
	LLIST									pListFileUrl;									// rac:FileUrl
	LLIST									pListNote;										// xs:string
	LLIST									pListContact;									// rac:ContactType
	char *									pProprietaryId;									// xs:token
	char *									pLegalRegId;									// xs:token
	char *									pJurisdiction;									// rac:Country
	char *									pEntityType;									// xs:token
	char *									pStatisticalClass;								// xs:token
	LLIST									pListLegalFileUrl;								// rac:FileUrl
	char *									pVatRegId;										// xs:token
	char *									pVatCurrency;									// rac:Currency
	BOOL									CashAccounting;									// xs:boolean
	LLIST									pListVatFileUrl;								// rac:FileUrl
	LLIST									pListIncomeTaxFileUrl;							// rac:FileUrl
	} PartyType;


//	OperatorInfoType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	char *									pOperatorInfo;									// rac:IdToken
	DATEINT									date;											// xs:date
	} OperatorInfoType;

/********************************************************************

Alphabet Rosetta Application data C Structs

********************************************************************/
//	AccountingType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	char *									pContent;										// rac:ContentType
	LLIST									pListComment;									// rac:TextType
	char *									pGaap;											// xs:token
	char *									pCurrency;										// rac:Currency
	char *									pDefaultLanguage;								// xs:language
	DATEINT									LastEntryDate;									// xs:date
	LLIST									pListFileUrl;									// rac:FileUrl
	ProgramInfoType *						pProgram;										// rac:ProgramInfoType
	OperatorInfoType *						pGeneratingUser;								// rac:OperatorInfoType
	LLIST									pListAuditApproved;								// rac:AttestType
	PartyType *								pEntity;										// rac:PartyType
	PartyType *								pAccountant;									// rac:PartyType
	PartyType *								pAudit;											// rac:PartyType
	AccountsChartType *						pAccountsChart;									// rac:AccountsChartType
	ObjectsChartType *						pObjectsChart;									// rac:ObjectsChartType
	LedgersChartType *						pLedgersChart;									// rac:LedgersChartType
	InvoiceChartType *						pIssuedInvoiceChart;							// rac:InvoiceChartType
	InvoiceChartType *						pBankAccountsChart;								// rac:InvoiceChartType
	} AccountingType;


//	AttestType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	OperatorInfoType *						pAttestant;										// rac:OperatorInfoType
	LLIST									pListNote;										// rac:TextType
	LLIST									pListPkiNote;									// xs:token
	LLIST									pListFileUrl;									// rac:FileUrl
	} AttestType;


//	ContactType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	char *									pFunction;										// xs:token
	char *									pName;											// xs:token
	LLIST									pListAddress;									// xs:token
	char *									pPostalCode;									// xs:token
	char *									pPostalAddress;									// xs:token
	char *									pPostalCountry;									// xs:token
	LLIST									pListPhone;										// rac:Phone
	LLIST									pListEmail;										// rac:Email
	LLIST									pListWebPage;									// rac:FileUrl
	LLIST									pListSocialMedia;								// rac:FileUrl
	LLIST									pListContactLog;								// rac:FileUrl
	LLIST									pListCrmRef;									// rac:FileUrl
	LLIST									pListNote;										// xs:string
	} ContactType;


//	DepreciationsType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	DATEINT									Deprecated;										// xs:date
	LLIST									pListDescription;								// rac:TextType
	char *									pDepreciationSchedule;							// rac:DepreciationScheduleType
	char *									pDepreciationPeriods;							// rac:DepreciationPeriodsType
	COUNTER									Periods;										// xs:nonNegativeInteger
	DATEINT									FirstDepreciation;								// xs:date
	DATEINT									LastDepreciation;								// xs:date
	QUANT									InterestRate;									// xs:decimal
	LLIST									pListDepreciationQuantityUnit;					// rac:TextType
	AMOUNT									Base;											// rac:Amount
	QUANT									BaseQuantity;									// xs:decimal
	AMOUNT									ResIdual;										// rac:Amount
	QUANT									ResIdualQuantity;								// xs:decimal
	AMOUNT									Depreciations;									// rac:Amount
	QUANT									DepreciationsQuantity;							// xs:decimal
	AMOUNT									Balance;										// rac:Amount
	QUANT									BalanceQuantity;								// xs:decimal
	LLIST									pListDepreciation;								// rac:DepreciationEntryType
	LLIST									pListRevaluation;								// rac:DepreciationEntryType
	} DepreciationsType;


//	AccountType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	char *									pId;											// rac:IdToken
	LLIST									pListName;										// rac:TextType
	LLIST									pListQuantityUnit;								// rac:TextType
	BOOL									InActive;										// xs:boolean
	LLIST									pListFileUrl;									// rac:FileUrl
	char *									pType;											// rac:AccountTypeType
	BOOL									MiniChart;										// xs:boolean
	LLIST									pListAccountCode;								// rac:AccountCodeType
	LLIST									pListOtherGaapAccountId;						// rac:AccountCodeType
	DepreciationsType *						pDepreciation;									// rac:DepreciationsType
	LLIST									pListVoucherEntries;							// Internal use
	} AccountType;


//	AccountCodeType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	char *									pCodeType;										// xs:token
	char *									pCode;											// xs:token
	char *									pValidYear;										// rac:Year
	LLIST									pListApplicableDomain;							// rac:Country
	char *									pIssuer;										// xs:token
	LLIST									pListDescription;								// rac:TextType
	} AccountCodeType;


//	DimensionType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	COUNTER									Id;												// xs:positiveInteger
	LLIST									pListName;										// rac:TextType
	void *									pSuperDimension;								// rac:DimensionType
	BOOL									InActive;										// xs:boolean
	LLIST									pListObject;									// rac:ObjectType
	} DimensionType;


//	ObjectType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	DimensionType *							pDimension;										// rac:DimensionType
	char *									pId;											// rac:IdToken
	LLIST									pListName;										// rac:TextType
	BOOL									InActive;										// xs:boolean
	LLIST									pListFileUrl;									// rac:FileUrl
	PartyType *								pParty;											// rac:PartyType
	} ObjectType;


//	LedgerType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	NUMERIC									Id;												// xs:nonPositiveInteger
	DATEINT									YearStart;										// xs:date
	DATEINT									YearEnd;										// xs:date
	LLIST									pListFileUrl;									// rac:FileUrl
	LLIST									pListReport;									// rac:BalanceReportType
	LLIST									pListVoucher;									// rac:VoucherType
	} LedgerType;


//	BalanceTotalType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	AMOUNT									Opening;										// rac:Amount
	AMOUNT									Forward;										// rac:Amount
	LLIST									pListMonth;										// rac:BalanceTotalPeriodType
	LLIST									pListQuarter;									// rac:BalanceTotalPeriodType
	LLIST									pListTertial;									// rac:BalanceTotalPeriodType
	LLIST									pListSemi;										// rac:BalanceTotalPeriodType
	LLIST									pListAnnual;									// rac:BalanceTotalPeriodType
	} BalanceTotalType;


//	BalanceReportType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	ObjectType *							pObject;										// rac:ObjectType
	BalanceTotalType *						pTangible;										// rac:BalanceTotalType
	BalanceTotalType *						pStock;											// rac:BalanceTotalType
	BalanceTotalType *						pReceivables;									// rac:BalanceTotalType
	BalanceTotalType *						pAssets;										// rac:BalanceTotalType
	BalanceTotalType *						pActive;										// rac:BalanceTotalType
	BalanceTotalType *						pEquities;										// rac:BalanceTotalType
	BalanceTotalType *						pProvisions;									// rac:BalanceTotalType
	BalanceTotalType *						pLiabilities;									// rac:BalanceTotalType
	BalanceTotalType *						pPassive;										// rac:BalanceTotalType
	BalanceTotalType *						pBalance;										// rac:BalanceTotalType
	BalanceTotalType *						pRevenues;										// rac:BalanceTotalType
	BalanceTotalType *						pSupplies;										// rac:BalanceTotalType
	BalanceTotalType *						pProfit;										// rac:BalanceTotalType
	BalanceTotalType *						pExpenses;										// rac:BalanceTotalType
	BalanceTotalType *						pStaff;											// rac:BalanceTotalType
	BalanceTotalType *						pEarning;										// rac:BalanceTotalType
	BalanceTotalType *						pLossGains;										// rac:BalanceTotalType
	BalanceTotalType *						pFinancial;										// rac:BalanceTotalType
	BalanceTotalType *						pOutcome;										// rac:BalanceTotalType
	BalanceTotalType *						pAuxiliary;										// rac:BalanceTotalType
	BalanceTotalType *						pResult;										// rac:BalanceTotalType
	BalanceTotalType *						pTotal;											// rac:BalanceTotalType
	LLIST									pListBalanceAccount;							// rac:BalanceAccountType
	} BalanceReportType;


//	BalanceTotalPeriodType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	DATEINT									End;											// xs:date
	AMOUNT									Outcome;										// rac:Amount
	AMOUNT									Budget;											// rac:Amount
	} BalanceTotalPeriodType;


//	BalanceAccountType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	AccountType *							pAccount;										// rac:AccountType
	AMOUNT									Opening;										// rac:Amount
	QUANT									OpeningQuantity;								// xs:decimal
	AMOUNT									Forward;										// rac:Amount
	QUANT									ForwardQuantity;								// xs:decimal
	LLIST									pListMonth;										// rac:BalanceAccountPeriodType
	LLIST									pListQuarter;									// rac:BalanceAccountPeriodType
	LLIST									pListTertial;									// rac:BalanceAccountPeriodType
	LLIST									pListSemi;										// rac:BalanceAccountPeriodType
	LLIST									pListAnnual;									// rac:BalanceAccountPeriodType
	} BalanceAccountType;


//	BalanceAccountPeriodType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	DATEINT									End;											// xs:date
	AMOUNT									Outcome;										// rac:Amount
	QUANT									OutcomeQuantity;								// xs:decimal
	AMOUNT									Budget;											// rac:Amount
	QUANT									BudgetQuantity;									// xs:decimal
	} BalanceAccountPeriodType;


//	SeriesIdType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	COUNTER									SeriesId;										// xs:positiveInteger
	char *									pseries;										// rac:IdToken
	} SeriesIdType;


//	VoucherType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	SeriesIdType *							pId;											// rac:SeriesIdType
	DATEINT									Date;											// xs:date
	LLIST									pListTitle;										// rac:TextType
	OperatorInfoType *						pAccountant;									// rac:OperatorInfoType
	LLIST									pListEntry;										// rac:VoucherEntryType
	} VoucherType;


//	AmountCurrencyType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	AMOUNT									AmountCurrency;									// rac:Amount
	char *									pcurr;											// rac:Currency
	} AmountCurrencyType;


//	InvoiceType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	char *									pPurpose;										// rac:InvoiceTypeType
	char *									pLegalLanguage;									// xs:language
	DATEINT									Deprecated;										// xs:date
	LLIST									pListTitle;										// rac:TextType
	SeriesIdType *							pInvoiceId;										// rac:SeriesIdType
	SeriesIdType *							pPayableId;										// rac:SeriesIdType
	LLIST									pListPayObject;									// rac:ObjectType
	DATEINT									PaidDate;										// xs:date
	DATEINT									DateOfIssue;									// xs:date
	DATEINT									DateOfArrival;									// xs:date
	DATEINT									DueDate;										// xs:date
	QUANT									LatePayInterestRate;							// xs:decimal
	AmountCurrencyType *					pCreditLimit;									// rac:AmountCurrencyType
	char *									pPayReference;									// xs:token
	char *									pPayCurrency;									// rac:Currency
	AMOUNT									PayAmount;										// rac:Amount
	AMOUNT									VatAmountPayCurrency;							// rac:Amount
	AMOUNT									NetAmountPayCurrency;							// rac:Amount
	AMOUNT									VatAmountTaxCurrency;							// rac:Amount
	AMOUNT									NetAmountTaxCurrency;							// rac:Amount
	LLIST									pListBuyersNote;								// xs:string
	LLIST									pListSellersNote;								// xs:string
	LLIST									pListFactoringNote;								// xs:string
	LLIST									pListCollectingNote;							// xs:string
	LLIST									pListBailiffNote;								// xs:string
	LLIST									pListOriginalInvoiceFileUrl;					// rac:FileUrl
	LLIST									pListRelatedDocumentFileUrl;					// rac:FileUrl
	LLIST									pListIssuer;									// rac:AttestType
	LLIST									pListPayApproved;								// rac:AttestType
	LLIST									pListPayOrderd;									// rac:AttestType
	LLIST									pListInvoiceEntry;								// rac:InvoiceEntryType
	LLIST									pListAllowanceCharge;							// rac:InvoiceEntryType
	LLIST									pListLogisticsServiceCharge;					// rac:InvoiceEntryType
	LLIST									pListCollectionCharge;							// rac:InvoiceEntryType
	LLIST									pListDiscounts;									// rac:InvoiceEntryType
	PartyType *								pBuyer;											// rac:PartyType
	PartyType *								pSeller;										// rac:PartyType
	PartyType *								pTaxRepresentative;								// rac:PartyType
	PartyType *								pFactor;										// rac:PartyType
	PartyType *								pCollector;										// rac:PartyType
	PartyType *								pBailiff;										// rac:PartyType
	LLIST									pListReferenceAccounting;						// rac:SeriesIdType
	char *									pAmortisationSchedule;							// rac:AmortisationScheduleType
	LLIST									pListPay;										// rac:PayType
	} InvoiceType;


//	VoucherEntryType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	OperatorInfoType *						pDeprecated;									// rac:OperatorInfoType
	AMOUNT									Amount;											// rac:Amount
	QUANT									Quantity;										// xs:decimal
	LLIST									pListTitle;										// rac:TextType
	DATEINT									AuxDate;										// xs:date
	AccountType *							pAccount;										// rac:AccountType
	InvoiceType *							pInvoice;										// rac:InvoiceType
	OperatorInfoType *						pAccountant;									// rac:OperatorInfoType
	LLIST									pListObject;									// rac:ObjectType
	} VoucherEntryType;


//	InvoiceEntryType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	QUANT									Quantity;										// xs:decimal
	LLIST									pListDescription;								// rac:TextType
	LLIST									pListTradeItemData;								// rac:TradeItemDataType
	QUANT									Quota;											// xs:decimal
	QUANT									QuotaBalance;									// xs:decimal
	LLIST									pListQuantityUnit;								// rac:TextType
	AmountCurrencyType *					pQuotaAgreedUnitNetAmount;						// rac:AmountCurrencyType
	char *									pId;											// xs:token
	SeriesIdType *							pInvoiceId;										// rac:SeriesIdType
	DATEINT									AccountingDate;									// xs:date
	DATEINT									AvailabilityDate;								// xs:date
	DATEINT									RateOfIntrestDate;								// xs:date
	LLIST									pListSalesReference;							// xs:token
	LLIST									pListSalesObject;								// rac:ObjectType
	LLIST									pListCostReference;								// xs:token
	LLIST									pListCostObject;								// rac:ObjectType
	LLIST									pListNote;										// rac:TextType
	DATEINT									DeliveryDate;									// xs:date
	LLIST									pListDeliveryNote;								// rac:TextType
	LLIST									pListLocationNote;								// rac:TextType
	char *									pLocation;										// xs:token
	LLIST									pListDispatchFileUrl;							// rac:FileUrl
	char *									pOrderId;										// xs:token
	char *									pContractId;									// xs:token
	char *									pPriceListId;									// xs:token
	LLIST									pListOrderResponseFileUrl;						// rac:FileUrl
	LLIST									pListSellersNoteToBuyer;						// xs:string
	char *									pSuggestedBasAccount;							// xs:token
	AMOUNT									UnitNetAmount;									// rac:Amount
	AMOUNT									NetAmount;										// rac:Amount
	char *									pVatReduced;									// rac:VatReducedType
	char *									pVatSpecial;									// rac:VatSpecialType
	LLIST									pListVehicleVatDocFileUrl;						// rac:FileUrl
	QUANT									VatRate;										// xs:decimal
	AMOUNT									VatAmountTaxCurrency;							// rac:Amount
	AMOUNT									PayAmount;										// rac:Amount
	LLIST									pListReceivingApproved;							// rac:AttestType
	InvoiceType *							pStackedInvoice;								// rac:InvoiceType
	DepreciationsType *						pDepreciation;									// rac:DepreciationsType
	} InvoiceEntryType;


//	TradeItemDataType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	LLIST									pListDescription;								// rac:TextType
	char *									pSerialId;										// xs:token
	char *									pGlobalProductId;								// xs:token
	char *									pProducersProductId;							// xs:token
	char *									pSuppliersProductId;							// xs:token
	char *									pDomesticProductId;								// xs:token
	char *									pRevisionId;									// xs:token
	LLIST									pListCustomsId;									// xs:token
	LLIST									pListTaxId;										// xs:token
	LLIST									pListPicture;									// rac:FileUrl
	LLIST									pListProductDescriptionFileUrl;					// rac:FileUrl
	LLIST									pListProductSpecificationFileUrl;				// rac:FileUrl
	LLIST									pListGuaranteeFileUrl;							// rac:FileUrl
	LLIST									pListRepairFileUrl;								// rac:FileUrl
	LLIST									pListUpgradeFileUrl;							// rac:FileUrl
	LLIST									pListUserManualFileUrl;							// rac:FileUrl
	LLIST									pListProductInformationWebPage;					// rac:FileUrl
	char *									pTransportPackingGroup;							// xs:token
	LLIST									pListDangerousGoodsClass;						// xs:token
	QUANT									MaxTempC;										// xs:decimal
	QUANT									MinTempC;										// xs:decimal
	LLIST									pListStoringTransportMessage;					// rac:TextType
	LLIST									pListSaftyAndEnvironmentalMessage;				// rac:TextType
	LLIST									pListSaftyAndEnvironmentalFileUrl;				// rac:FileUrl
	LLIST									pListAgriculturalFileUrl;						// rac:FileUrl
	LLIST									pListRecyclingCode;								// xs:token
	LLIST									pListDisposalMessage;							// rac:TextType
	LLIST									pListDisposalFileUrl;							// rac:FileUrl
	LLIST									pListFileUrl;									// rac:FileUrl
	} TradeItemDataType;


//	PayType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	DATEINT									RegDate;										// xs:date
	DATEINT									PayDate;										// xs:date
	AMOUNT									Amount;											// rac:Amount
	LLIST									pListPaymentMeans;								// rac:CITradeSettlementPaymentMeansType
	InvoiceEntryType *						pReferenceBankAccount;							// rac:InvoiceEntryType
	SeriesIdType *							pReferenceAccounting;							// rac:SeriesIdType
	} PayType;


//	DepreciationEntryType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	DATEINT									Date;											// xs:date
	AMOUNT									Amount;											// rac:Amount
	QUANT									AmountQuantity;									// xs:decimal
	InvoiceEntryType *						pReferenceBankAccount;							// rac:InvoiceEntryType
	SeriesIdType *							pReferenceAccounting;							// rac:SeriesIdType
	} DepreciationEntryType;


//	TradeSettlementFinancialCardType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	BOOL									MicrochipIndicator;								// xs:boolean
	char *									pId;											// xs:token
	char *									pTypeCode;										// xs:token
	char *									pCardholderName;								// xs:string
	DATEINT									ExpiryDate;										// xs:date
	NUMERIC									VerificationNumeric;							// xs:integer
	DATETIMEINT								ValidFromDateTime;								// xs:dateTime
	LLIST									pListCreditLimitAmount;							// rac:AmountCurrencyType
	LLIST									pListCreditAvailableAmount;						// rac:AmountCurrencyType
	QUANT									InterestRatePercent;							// xs:decimal
	char *									pIssuingCompanyName;							// xs:string
	char *									pDescription;									// xs:string
	} TradeSettlementFinancialCardType;


//	FinancialInstitutionAddressType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	char *									pPostcodeCode;									// xs:token
	char *									pBuildingNumber;								// xs:string
	char *									pLineOne;										// xs:string
	char *									pLineTwo;										// xs:string
	char *									pLineThree;										// xs:string
	char *									pLineFour;										// xs:string
	char *									pLineFive;										// xs:string
	char *									pStreetName;									// xs:string
	char *									pCityName;										// xs:string
	char *									pCountrySubDivisionId;							// xs:token
	char *									pCountryId;										// rac:Country
	char *									pTypeCode;										// xs:token
	char *									pDepartmentName;								// xs:string
	char *									pPostOfficeBox;									// xs:string
	char *									pCityId;										// xs:token
	char *									pCountrySubDivisionName;						// xs:string
	char *									pCountryName;									// xs:string
	} FinancialInstitutionAddressType;


//	BranchFinancialInstitutionType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	char *									pId;											// xs:token
	char *									pName;											// xs:string
	FinancialInstitutionAddressType *		pLocationFinancialInstitutionAddress;			// rac:FinancialInstitutionAddressType
	} BranchFinancialInstitutionType;


//	CICreditorFinancialInstitutionType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	char *									pBICId;											// xs:token
	char *									pClearingSystemName;							// xs:string
	char *									pCHIPSUniversalId;								// xs:token
	char *									pNewZealandNCCId;								// xs:token
	char *									pIrishNSCId;									// xs:token
	char *									pUKSortCodeId;									// xs:token
	char *									pCHIPSParticipantId;							// xs:token
	char *									pSwissBCId;										// xs:token
	char *									pFedwireRoutingNumberId;						// xs:token
	char *									pPortugueseNCCId;								// xs:token
	char *									pRussianCentralBankId;							// xs:token
	char *									pItalianDomesticId;								// xs:token
	char *									pAustrianBankleitzahlId;						// xs:token
	char *									pCanadianPaymentsAssociationId;					// xs:token
	char *									pSICId;											// xs:token
	char *									pGermanBankleitzahlId;							// xs:token
	char *									pSpanishDomesticInterbankingId;					// xs:token
	char *									pSouthAfricanNCCId;								// xs:token
	char *									pHongKongBankId;								// xs:token
	char *									pAustralianBSBId;								// xs:token
	char *									pIndianFinancialSystemId;						// xs:token
	char *									pHellenicBankId;								// xs:token
	char *									pPolishNationalClearingId;						// xs:token
	char *									pName;											// xs:string
	char *									pJapanFinancialInstitutionCommonId;				// xs:token
	FinancialInstitutionAddressType *		pLocationFinancialInstitutionAddress;			// rac:FinancialInstitutionAddressType
	BranchFinancialInstitutionType *		pSubDivisionBranchFinancialInstitution;			// rac:BranchFinancialInstitutionType
	} CICreditorFinancialInstitutionType;


//	CICreditorFinancialAccountType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	char *									pIBANId;										// xs:token
	char *									pAccountName;									// xs:string
	char *									pProprietaryId;									// xs:token
	} CICreditorFinancialAccountType;


//	CIDebtorFinancialInstitutionType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	char *									pBICId;											// xs:token
	char *									pClearingSystemName;							// xs:string
	char *									pCHIPSUniversalId;								// xs:token
	char *									pNewZealandNCCId;								// xs:token
	char *									pIrishNSCId;									// xs:token
	char *									pUKSortCodeId;									// xs:token
	char *									pCHIPSParticipantId;							// xs:token
	char *									pSwissBCId;										// xs:token
	char *									pFedwireRoutingNumberId;						// xs:token
	char *									pPortugueseNCCId;								// xs:token
	char *									pRussianCentralBankId;							// xs:token
	char *									pItalianDomesticId;								// xs:token
	char *									pAustrianBankleitzahlId;						// xs:token
	char *									pCanadianPaymentsAssociationId;					// xs:token
	char *									pSICId;											// xs:token
	char *									pGermanBankleitzahlId;							// xs:token
	char *									pSpanishDomesticInterbankingId;					// xs:token
	char *									pSouthAfricanNCCId;								// xs:token
	char *									pHongKongBankId;								// xs:token
	char *									pAustralianBSBId;								// xs:token
	char *									pIndianFinancialSystemId;						// xs:token
	char *									pHellenicBankId;								// xs:token
	char *									pPolishNationalClearingId;						// xs:token
	char *									pName;											// xs:string
	char *									pJapanFinancialInstitutionCommonId;				// xs:token
	FinancialInstitutionAddressType *		pLocationFinancialInstitutionAddress;			// rac:FinancialInstitutionAddressType
	BranchFinancialInstitutionType *		pSubDivisionBranchFinancialInstitution;			// rac:BranchFinancialInstitutionType
	} CIDebtorFinancialInstitutionType;


//	CIDebtorFinancialAccountType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	char *									pIBANId;										// xs:token
	char *									pAccountName;									// xs:string
	char *									pProprietaryId;									// xs:token
	} CIDebtorFinancialAccountType;


//	CITradeSettlementPaymentMeansType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	char *									pPaymentChannelCode;							// rac:PaymentMeansChannelCodeType
	char *									pTypeCode;										// rac:PaymentMeansCodeType
	char *									pGuaranteeMethodCode;							// rac:PaymentGuaranteeMeansCodeType
	char *									pPaymentMethodCode;								// rac:PaymentMethodCodeType
	LLIST									pListId;										// xs:token
	LLIST									pListInformation;								// xs:string
	CIDebtorFinancialAccountType *			pPayerPartyCIDebtorFinancialAccount;			// rac:CIDebtorFinancialAccountType
	CICreditorFinancialAccountType *		pPayeePartyCICreditorFinancialAccount;			// rac:CICreditorFinancialAccountType
	CIDebtorFinancialInstitutionType *		pPayerSpecifiedCIDebtorFinancialInstitution;	// rac:CIDebtorFinancialInstitutionType
	CICreditorFinancialInstitutionType *	pPayeeSpecifiedCICreditorFinancialInstitution;	// rac:CICreditorFinancialInstitutionType
	TradeSettlementFinancialCardType *		pApplicableTradeSettlementFinancialCard;		// rac:TradeSettlementFinancialCardType
	} CITradeSettlementPaymentMeansType;


//	TextType

typedef struct {
	COUNTER DataType;																		// To make the structure identifiable in void ptr cases
	void *pStructDocTop;																	// To make vertical data retrievable quickly 
	void *pStructParent;																	// To make vertical data retrievable quickly 
	char *									pText;											// xs:token
	char *									plang;											// xs:language
	} TextType;


/*********************************************************************

Alphabet Rosetta Text Enumerations

*********************************************************************/

#define ENUM_DOCUMENTCONTENTTYPE 3
#define ENUM_FOLDERTYPE 8
#define ENUM_CONTENTTYPE 4
#define ENUM_ACCOUNTTOTALTYPETYPE 8
#define ENUM_ACCOUNTTYPETYPE 14
#define ENUM_DIMENSIONTITLETYPE 9
#define ENUM_AMORTISATIONSCHEDULETYPE 6
#define ENUM_DEPRECIATIONSCHEDULETYPE 7
#define ENUM_DEPRECIATIONPERIODSTYPE 7
#define ENUM_INVOICETYPETYPE 28
#define ENUM_VATREDUCEDTYPE 3
#define ENUM_VATSPECIALTYPE 12
#define ENUM_PAYMENTMEANSCHANNELCODETYPE 16
#define ENUM_PAYMENTMEANSCODETYPE 75
#define ENUM_PAYMENTGUARANTEEMEANSCODETYPE 12
#define ENUM_PAYMENTMETHODCODETYPE 52
#define ENUM_APPLICATIONTEXTTYPE 58


/********************************************************************

Alphabet Rosetta Enumerations declarations

********************************************************************/

//	EnumType

typedef struct {
	char *									EnumerationID;									// rac:IDtoken
	TextType								pListDescription[SUPPORTED_LANGUAGES+1];							// rac:TextType
} EnumType;

extern EnumType EnumDocumentContentType[];
extern EnumType EnumFolderType[];
extern EnumType EnumContentType[];
extern EnumType EnumAccountTotalTypeType[];
extern EnumType EnumAccountTypeType[];
extern EnumType EnumDimensionTitleType[];
extern EnumType EnumAmortisationScheduleType[];
extern EnumType EnumDepreciationScheduleType[];
extern EnumType EnumDepreciationPeriodsType[];
extern EnumType EnumInvoiceTypeType[];
extern EnumType EnumVatReducedType[];
extern EnumType EnumVatSpecialType[];
extern EnumType EnumPaymentMeansChannelCodeType[];
extern EnumType EnumPaymentMeansCodeType[];
extern EnumType EnumPaymentGuaranteeMeansCodeType[];
extern EnumType EnumPaymentMethodCodeType[];
extern EnumType EnumApplicationTextType[];
extern EnumType EnumHelpTextType[];

/********************************************************************

Alphabet Rosetta External C function declarations

********************************************************************/
void *ReadWorkData(char *pBuffer);
void DestroyWorkData(void **vppWorkData);
char *GetProgramFileName(void *vpWorkData);
int WriteWorkData(void *vpWorkData, char *pContent, char *pFilePathName);

BOOL WriteAccounting(FILE *pStream, AccountingType *pAccounting, char *pContent);
AccountingType *ReadAccounting(char *pBuffer);
BOOL WriteInvoice(FILE *pStream, InvoiceType *pInvoice);
InvoiceType *ReadInvoice(char *pBuffer);

//	Accounting
char **GetLeadTextAccounting(char *pLang);
AccountingType *CreateAccounting(void *pStructDocTop, void *pStructParent);
AccountingType *DestroyAccounting(AccountingType **pAccounting);
AccountingType *CopyAccounting(void *pStructDocTop, void *pStructParent, AccountingType *pAccounting);
BOOL IsDataAccounting(AccountingType *pAccounting);
AccountingType *UpdateAccounting(AccountingType *pStructAccounting, char *pContent, char *pGaap, char *pCurrency, char *pDefaultLanguage, DATEINT LastEntryDate);

//	Attest
char **GetLeadTextAttest(char *pLang);
AttestType *CreateAttest(void *pStructDocTop, void *pStructParent);
AttestType *DestroyAttest(AttestType **pAttest);
AttestType *CopyAttest(void *pStructDocTop, void *pStructParent, AttestType *pAttest);
BOOL IsDataAttest(AttestType *pAttest);
AttestType *UpdateAttest(AttestType *pStructAttest);

//	Party
char **GetLeadTextParty(char *pLang);
PartyType *CreateParty(void *pStructDocTop, void *pStructParent);
PartyType *DestroyParty(PartyType **pParty);
PartyType *CopyParty(void *pStructDocTop, void *pStructParent, PartyType *pParty);
BOOL IsDataParty(PartyType *pParty);
PartyType *UpdateParty(PartyType *pStructParty, char *pName, char *pPostalCode, char *pPostalAddress, char *pPostalCountry, char *pEntityPhone, char *pEntityEmail, char *pProprietaryId, char *pLegalRegId, char *pJurisdiction, char *pEntityType, char *pStatisticalClass, char *pVatRegId, char *pVatCurrency, BOOL bCashAccounting);

//	Contact
char **GetLeadTextContact(char *pLang);
ContactType *CreateContact(void *pStructDocTop, void *pStructParent);
ContactType *DestroyContact(ContactType **pContact);
ContactType *CopyContact(void *pStructDocTop, void *pStructParent, ContactType *pContact);
BOOL IsDataContact(ContactType *pContact);
ContactType *UpdateContact(ContactType *pStructContact, char *pFunction, char *pName, char *pPostalCode, char *pPostalAddress, char *pPostalCountry);

//	AccountsChart
char **GetLeadTextAccountsChart(char *pLang);
AccountsChartType *CreateAccountsChart(void *pStructDocTop, void *pStructParent);
AccountsChartType *DestroyAccountsChart(AccountsChartType **pAccountsChart);
AccountsChartType *CopyAccountsChart(void *pStructDocTop, void *pStructParent, AccountsChartType *pAccountsChart);
BOOL IsDataAccountsChart(AccountsChartType *pAccountsChart);
AccountsChartType *UpdateAccountsChart(AccountsChartType *pStructAccountsChart);

//	Account
char **GetLeadTextAccount(char *pLang);
AccountType *CreateAccount(void *pStructDocTop, void *pStructParent);
AccountType *DestroyAccount(AccountType **pAccount);
AccountType *CopyAccount(void *pStructDocTop, void *pStructParent, AccountType *pAccount);
BOOL IsDataAccount(AccountType *pAccount);
AccountType *UpdateAccount(AccountType *pStructAccount, char *pId, BOOL bInActive, char *pType, BOOL bMiniChart);

//	AccountCode
char **GetLeadTextAccountCode(char *pLang);
AccountCodeType *CreateAccountCode(void *pStructDocTop, void *pStructParent);
AccountCodeType *DestroyAccountCode(AccountCodeType **pAccountCode);
AccountCodeType *CopyAccountCode(void *pStructDocTop, void *pStructParent, AccountCodeType *pAccountCode);
BOOL IsDataAccountCode(AccountCodeType *pAccountCode);
AccountCodeType *UpdateAccountCode(AccountCodeType *pStructAccountCode, char *pCodeType, char *pCode, char *pValidYear, char *pIssuer);

//	ObjectsChart
char **GetLeadTextObjectsChart(char *pLang);
ObjectsChartType *CreateObjectsChart(void *pStructDocTop, void *pStructParent);
ObjectsChartType *DestroyObjectsChart(ObjectsChartType **pObjectsChart);
ObjectsChartType *CopyObjectsChart(void *pStructDocTop, void *pStructParent, ObjectsChartType *pObjectsChart);
BOOL IsDataObjectsChart(ObjectsChartType *pObjectsChart);
ObjectsChartType *UpdateObjectsChart(ObjectsChartType *pStructObjectsChart);

//	Dimension
char **GetLeadTextDimension(char *pLang);
DimensionType *CreateDimension(void *pStructDocTop, void *pStructParent);
DimensionType *DestroyDimension(DimensionType **pDimension);
DimensionType *CopyDimension(void *pStructDocTop, void *pStructParent, DimensionType *pDimension);
BOOL IsDataDimension(DimensionType *pDimension);
DimensionType *UpdateDimension(DimensionType *pStructDimension, unsigned long long Id, BOOL bInActive);

//	Object
char **GetLeadTextObject(char *pLang);
ObjectType *CreateObject(void *pStructDocTop, void *pStructParent);
ObjectType *DestroyObject(ObjectType **pObject);
ObjectType *CopyObject(void *pStructDocTop, void *pStructParent, ObjectType *pObject);
BOOL IsDataObject(ObjectType *pObject);
ObjectType *UpdateObject(ObjectType *pStructObject, char *pId, BOOL bInActive);

//	LedgersChart
char **GetLeadTextLedgersChart(char *pLang);
LedgersChartType *CreateLedgersChart(void *pStructDocTop, void *pStructParent);
LedgersChartType *DestroyLedgersChart(LedgersChartType **pLedgersChart);
LedgersChartType *CopyLedgersChart(void *pStructDocTop, void *pStructParent, LedgersChartType *pLedgersChart);
BOOL IsDataLedgersChart(LedgersChartType *pLedgersChart);
LedgersChartType *UpdateLedgersChart(LedgersChartType *pStructLedgersChart);

//	Ledger
char **GetLeadTextLedger(char *pLang);
LedgerType *CreateLedger(void *pStructDocTop, void *pStructParent);
LedgerType *DestroyLedger(LedgerType **pLedger);
LedgerType *CopyLedger(void *pStructDocTop, void *pStructParent, LedgerType *pLedger);
BOOL IsDataLedger(LedgerType *pLedger);
LedgerType *UpdateLedger(LedgerType *pStructLedger, long long Id, DATEINT YearStart, DATEINT YearEnd);

//	BalanceReport
char **GetLeadTextBalanceReport(char *pLang);
BalanceReportType *CreateBalanceReport(void *pStructDocTop, void *pStructParent);
BalanceReportType *DestroyBalanceReport(BalanceReportType **pBalanceReport);
BalanceReportType *CopyBalanceReport(void *pStructDocTop, void *pStructParent, BalanceReportType *pBalanceReport);
BOOL IsDataBalanceReport(BalanceReportType *pBalanceReport);
BalanceReportType *UpdateBalanceReport(BalanceReportType *pStructBalanceReport);

//	BalanceTotal
char **GetLeadTextBalanceTotal(char *pLang);
BalanceTotalType *CreateBalanceTotal(void *pStructDocTop, void *pStructParent);
BalanceTotalType *DestroyBalanceTotal(BalanceTotalType **pBalanceTotal);
BalanceTotalType *CopyBalanceTotal(void *pStructDocTop, void *pStructParent, BalanceTotalType *pBalanceTotal);
BOOL IsDataBalanceTotal(BalanceTotalType *pBalanceTotal);
BalanceTotalType *UpdateBalanceTotal(BalanceTotalType *pStructBalanceTotal, AMOUNT Opening, AMOUNT Forward);

//	BalanceTotalPeriod
char **GetLeadTextBalanceTotalPeriod(char *pLang);
BalanceTotalPeriodType *CreateBalanceTotalPeriod(void *pStructDocTop, void *pStructParent);
BalanceTotalPeriodType *DestroyBalanceTotalPeriod(BalanceTotalPeriodType **pBalanceTotalPeriod);
BalanceTotalPeriodType *CopyBalanceTotalPeriod(void *pStructDocTop, void *pStructParent, BalanceTotalPeriodType *pBalanceTotalPeriod);
BOOL IsDataBalanceTotalPeriod(BalanceTotalPeriodType *pBalanceTotalPeriod);
BalanceTotalPeriodType *UpdateBalanceTotalPeriod(BalanceTotalPeriodType *pStructBalanceTotalPeriod, DATEINT End, AMOUNT Outcome, AMOUNT Budget);

//	BalanceAccount
char **GetLeadTextBalanceAccount(char *pLang);
BalanceAccountType *CreateBalanceAccount(void *pStructDocTop, void *pStructParent);
BalanceAccountType *DestroyBalanceAccount(BalanceAccountType **pBalanceAccount);
BalanceAccountType *CopyBalanceAccount(void *pStructDocTop, void *pStructParent, BalanceAccountType *pBalanceAccount);
BOOL IsDataBalanceAccount(BalanceAccountType *pBalanceAccount);
BalanceAccountType *UpdateBalanceAccount(BalanceAccountType *pStructBalanceAccount, AMOUNT Opening, QUANT OpeningQuantity, AMOUNT Forward, QUANT ForwardQuantity);

//	BalanceAccountPeriod
char **GetLeadTextBalanceAccountPeriod(char *pLang);
BalanceAccountPeriodType *CreateBalanceAccountPeriod(void *pStructDocTop, void *pStructParent);
BalanceAccountPeriodType *DestroyBalanceAccountPeriod(BalanceAccountPeriodType **pBalanceAccountPeriod);
BalanceAccountPeriodType *CopyBalanceAccountPeriod(void *pStructDocTop, void *pStructParent, BalanceAccountPeriodType *pBalanceAccountPeriod);
BOOL IsDataBalanceAccountPeriod(BalanceAccountPeriodType *pBalanceAccountPeriod);
BalanceAccountPeriodType *UpdateBalanceAccountPeriod(BalanceAccountPeriodType *pStructBalanceAccountPeriod, DATEINT End, AMOUNT Outcome, QUANT OutcomeQuantity, AMOUNT Budget, QUANT BudgetQuantity);

//	Voucher
char **GetLeadTextVoucher(char *pLang);
VoucherType *CreateVoucher(void *pStructDocTop, void *pStructParent);
VoucherType *DestroyVoucher(VoucherType **pVoucher);
VoucherType *CopyVoucher(void *pStructDocTop, void *pStructParent, VoucherType *pVoucher);
BOOL IsDataVoucher(VoucherType *pVoucher);
VoucherType *UpdateVoucher(VoucherType *pStructVoucher, DATEINT Date);

//	VoucherEntry
char **GetLeadTextVoucherEntry(char *pLang);
VoucherEntryType *CreateVoucherEntry(void *pStructDocTop, void *pStructParent);
VoucherEntryType *DestroyVoucherEntry(VoucherEntryType **pVoucherEntry);
VoucherEntryType *CopyVoucherEntry(void *pStructDocTop, void *pStructParent, VoucherEntryType *pVoucherEntry);
BOOL IsDataVoucherEntry(VoucherEntryType *pVoucherEntry);
VoucherEntryType *UpdateVoucherEntry(VoucherEntryType *pStructVoucherEntry, AMOUNT Amount, QUANT Quantity, DATEINT AuxDate);

//	InvoiceChart
char **GetLeadTextInvoiceChart(char *pLang);
InvoiceChartType *CreateInvoiceChart(void *pStructDocTop, void *pStructParent);
InvoiceChartType *DestroyInvoiceChart(InvoiceChartType **pInvoiceChart);
InvoiceChartType *CopyInvoiceChart(void *pStructDocTop, void *pStructParent, InvoiceChartType *pInvoiceChart);
BOOL IsDataInvoiceChart(InvoiceChartType *pInvoiceChart);
InvoiceChartType *UpdateInvoiceChart(InvoiceChartType *pStructInvoiceChart);

//	Invoice
char **GetLeadTextInvoice(char *pLang);
InvoiceType *CreateInvoice(void *pStructDocTop, void *pStructParent);
InvoiceType *DestroyInvoice(InvoiceType **pInvoice);
InvoiceType *CopyInvoice(void *pStructDocTop, void *pStructParent, InvoiceType *pInvoice);
BOOL IsDataInvoice(InvoiceType *pInvoice);
InvoiceType *UpdateInvoice(InvoiceType *pStructInvoice, char *pPurpose, char *pLegalLanguage, DATEINT Deprecated, DATEINT PaidDate, DATEINT DateOfIssue, DATEINT DateOfArrival, DATEINT DueDate, QUANT LatePayInterestRate, char *pPayReference, char *pPayCurrency, AMOUNT PayAmount, AMOUNT VatAmountPayCurrency, AMOUNT NetAmountPayCurrency, AMOUNT VatAmountTaxCurrency, AMOUNT NetAmountTaxCurrency, char *pAmortisationSchedule);

//	InvoiceEntry
char **GetLeadTextInvoiceEntry(char *pLang);
InvoiceEntryType *CreateInvoiceEntry(void *pStructDocTop, void *pStructParent);
InvoiceEntryType *DestroyInvoiceEntry(InvoiceEntryType **pInvoiceEntry);
InvoiceEntryType *CopyInvoiceEntry(void *pStructDocTop, void *pStructParent, InvoiceEntryType *pInvoiceEntry);
BOOL IsDataInvoiceEntry(InvoiceEntryType *pInvoiceEntry);
InvoiceEntryType *UpdateInvoiceEntry(InvoiceEntryType *pStructInvoiceEntry, QUANT Quantity, QUANT Quota, QUANT QuotaBalance, char *pId, DATEINT AccountingDate, DATEINT AvailabilityDate, DATEINT RateOfIntrestDate, DATEINT DeliveryDate, char *pLocation, char *pOrderId, char *pContractId, char *pPriceListId, char *pSuggestedBasAccount, AMOUNT UnitNetAmount, AMOUNT NetAmount, char *pVatReduced, char *pVatSpecial, QUANT VatRate, AMOUNT VatAmountTaxCurrency, AMOUNT PayAmount);

//	TradeItemData
char **GetLeadTextTradeItemData(char *pLang);
TradeItemDataType *CreateTradeItemData(void *pStructDocTop, void *pStructParent);
TradeItemDataType *DestroyTradeItemData(TradeItemDataType **pTradeItemData);
TradeItemDataType *CopyTradeItemData(void *pStructDocTop, void *pStructParent, TradeItemDataType *pTradeItemData);
BOOL IsDataTradeItemData(TradeItemDataType *pTradeItemData);
TradeItemDataType *UpdateTradeItemData(TradeItemDataType *pStructTradeItemData, char *pSerialId, char *pGlobalProductId, char *pProducersProductId, char *pSuppliersProductId, char *pDomesticProductId, char *pRevisionId, char *pTransportPackingGroup, QUANT MaxTempC, QUANT MinTempC);

//	Pay
char **GetLeadTextPay(char *pLang);
PayType *CreatePay(void *pStructDocTop, void *pStructParent);
PayType *DestroyPay(PayType **pPay);
PayType *CopyPay(void *pStructDocTop, void *pStructParent, PayType *pPay);
BOOL IsDataPay(PayType *pPay);
PayType *UpdatePay(PayType *pStructPay, DATEINT RegDate, DATEINT PayDate, AMOUNT Amount);

//	Depreciations
char **GetLeadTextDepreciations(char *pLang);
DepreciationsType *CreateDepreciations(void *pStructDocTop, void *pStructParent);
DepreciationsType *DestroyDepreciations(DepreciationsType **pDepreciations);
DepreciationsType *CopyDepreciations(void *pStructDocTop, void *pStructParent, DepreciationsType *pDepreciations);
BOOL IsDataDepreciations(DepreciationsType *pDepreciations);
DepreciationsType *UpdateDepreciations(DepreciationsType *pStructDepreciations, DATEINT Deprecated, char *pDepreciationSchedule, char *pDepreciationPeriods, unsigned long long Periods, DATEINT FirstDepreciation, DATEINT LastDepreciation, QUANT InterestRate, AMOUNT Base, QUANT BaseQuantity, AMOUNT ResIdual, QUANT ResIdualQuantity, AMOUNT Depreciations, QUANT DepreciationsQuantity, AMOUNT Balance, QUANT BalanceQuantity);

//	DepreciationEntry
char **GetLeadTextDepreciationEntry(char *pLang);
DepreciationEntryType *CreateDepreciationEntry(void *pStructDocTop, void *pStructParent);
DepreciationEntryType *DestroyDepreciationEntry(DepreciationEntryType **pDepreciationEntry);
DepreciationEntryType *CopyDepreciationEntry(void *pStructDocTop, void *pStructParent, DepreciationEntryType *pDepreciationEntry);
BOOL IsDataDepreciationEntry(DepreciationEntryType *pDepreciationEntry);
DepreciationEntryType *UpdateDepreciationEntry(DepreciationEntryType *pStructDepreciationEntry, DATEINT Date, AMOUNT Amount, QUANT AmountQuantity);

//	CITradeSettlementPaymentMeans
char **GetLeadTextCITradeSettlementPaymentMeans(char *pLang);
CITradeSettlementPaymentMeansType *CreateCITradeSettlementPaymentMeans(void *pStructDocTop, void *pStructParent);
CITradeSettlementPaymentMeansType *DestroyCITradeSettlementPaymentMeans(CITradeSettlementPaymentMeansType **pCITradeSettlementPaymentMeans);
CITradeSettlementPaymentMeansType *CopyCITradeSettlementPaymentMeans(void *pStructDocTop, void *pStructParent, CITradeSettlementPaymentMeansType *pCITradeSettlementPaymentMeans);
BOOL IsDataCITradeSettlementPaymentMeans(CITradeSettlementPaymentMeansType *pCITradeSettlementPaymentMeans);
CITradeSettlementPaymentMeansType *UpdateCITradeSettlementPaymentMeans(CITradeSettlementPaymentMeansType *pStructCITradeSettlementPaymentMeans, char *pPaymentChannelCode, char *pTypeCode, char *pGuaranteeMethodCode, char *pPaymentMethodCode);

//	CIDebtorFinancialAccount
char **GetLeadTextCIDebtorFinancialAccount(char *pLang);
CIDebtorFinancialAccountType *CreateCIDebtorFinancialAccount(void *pStructDocTop, void *pStructParent);
CIDebtorFinancialAccountType *DestroyCIDebtorFinancialAccount(CIDebtorFinancialAccountType **pCIDebtorFinancialAccount);
CIDebtorFinancialAccountType *CopyCIDebtorFinancialAccount(void *pStructDocTop, void *pStructParent, CIDebtorFinancialAccountType *pCIDebtorFinancialAccount);
BOOL IsDataCIDebtorFinancialAccount(CIDebtorFinancialAccountType *pCIDebtorFinancialAccount);
CIDebtorFinancialAccountType *UpdateCIDebtorFinancialAccount(CIDebtorFinancialAccountType *pStructCIDebtorFinancialAccount, char *pIBANId, char *pAccountName, char *pProprietaryId);

//	CIDebtorFinancialInstitution
char **GetLeadTextCIDebtorFinancialInstitution(char *pLang);
CIDebtorFinancialInstitutionType *CreateCIDebtorFinancialInstitution(void *pStructDocTop, void *pStructParent);
CIDebtorFinancialInstitutionType *DestroyCIDebtorFinancialInstitution(CIDebtorFinancialInstitutionType **pCIDebtorFinancialInstitution);
CIDebtorFinancialInstitutionType *CopyCIDebtorFinancialInstitution(void *pStructDocTop, void *pStructParent, CIDebtorFinancialInstitutionType *pCIDebtorFinancialInstitution);
BOOL IsDataCIDebtorFinancialInstitution(CIDebtorFinancialInstitutionType *pCIDebtorFinancialInstitution);
CIDebtorFinancialInstitutionType *UpdateCIDebtorFinancialInstitution(CIDebtorFinancialInstitutionType *pStructCIDebtorFinancialInstitution, char *pBICId, char *pClearingSystemName, char *pCHIPSUniversalId, char *pNewZealandNCCId, char *pIrishNSCId, char *pUKSortCodeId, char *pCHIPSParticipantId, char *pSwissBCId, char *pFedwireRoutingNumberId, char *pPortugueseNCCId, char *pRussianCentralBankId, char *pItalianDomesticId, char *pAustrianBankleitzahlId, char *pCanadianPaymentsAssociationId, char *pSICId, char *pGermanBankleitzahlId, char *pSpanishDomesticInterbankingId, char *pSouthAfricanNCCId, char *pHongKongBankId, char *pAustralianBSBId, char *pIndianFinancialSystemId, char *pHellenicBankId, char *pPolishNationalClearingId, char *pName, char *pJapanFinancialInstitutionCommonId);

//	CICreditorFinancialAccount
char **GetLeadTextCICreditorFinancialAccount(char *pLang);
CICreditorFinancialAccountType *CreateCICreditorFinancialAccount(void *pStructDocTop, void *pStructParent);
CICreditorFinancialAccountType *DestroyCICreditorFinancialAccount(CICreditorFinancialAccountType **pCICreditorFinancialAccount);
CICreditorFinancialAccountType *CopyCICreditorFinancialAccount(void *pStructDocTop, void *pStructParent, CICreditorFinancialAccountType *pCICreditorFinancialAccount);
BOOL IsDataCICreditorFinancialAccount(CICreditorFinancialAccountType *pCICreditorFinancialAccount);
CICreditorFinancialAccountType *UpdateCICreditorFinancialAccount(CICreditorFinancialAccountType *pStructCICreditorFinancialAccount, char *pIBANId, char *pAccountName, char *pProprietaryId);

//	CICreditorFinancialInstitution
char **GetLeadTextCICreditorFinancialInstitution(char *pLang);
CICreditorFinancialInstitutionType *CreateCICreditorFinancialInstitution(void *pStructDocTop, void *pStructParent);
CICreditorFinancialInstitutionType *DestroyCICreditorFinancialInstitution(CICreditorFinancialInstitutionType **pCICreditorFinancialInstitution);
CICreditorFinancialInstitutionType *CopyCICreditorFinancialInstitution(void *pStructDocTop, void *pStructParent, CICreditorFinancialInstitutionType *pCICreditorFinancialInstitution);
BOOL IsDataCICreditorFinancialInstitution(CICreditorFinancialInstitutionType *pCICreditorFinancialInstitution);
CICreditorFinancialInstitutionType *UpdateCICreditorFinancialInstitution(CICreditorFinancialInstitutionType *pStructCICreditorFinancialInstitution, char *pBICId, char *pClearingSystemName, char *pCHIPSUniversalId, char *pNewZealandNCCId, char *pIrishNSCId, char *pUKSortCodeId, char *pCHIPSParticipantId, char *pSwissBCId, char *pFedwireRoutingNumberId, char *pPortugueseNCCId, char *pRussianCentralBankId, char *pItalianDomesticId, char *pAustrianBankleitzahlId, char *pCanadianPaymentsAssociationId, char *pSICId, char *pGermanBankleitzahlId, char *pSpanishDomesticInterbankingId, char *pSouthAfricanNCCId, char *pHongKongBankId, char *pAustralianBSBId, char *pIndianFinancialSystemId, char *pHellenicBankId, char *pPolishNationalClearingId, char *pName, char *pJapanFinancialInstitutionCommonId);

//	TradeSettlementFinancialCard
char **GetLeadTextTradeSettlementFinancialCard(char *pLang);
TradeSettlementFinancialCardType *CreateTradeSettlementFinancialCard(void *pStructDocTop, void *pStructParent);
TradeSettlementFinancialCardType *DestroyTradeSettlementFinancialCard(TradeSettlementFinancialCardType **pTradeSettlementFinancialCard);
TradeSettlementFinancialCardType *CopyTradeSettlementFinancialCard(void *pStructDocTop, void *pStructParent, TradeSettlementFinancialCardType *pTradeSettlementFinancialCard);
BOOL IsDataTradeSettlementFinancialCard(TradeSettlementFinancialCardType *pTradeSettlementFinancialCard);
TradeSettlementFinancialCardType *UpdateTradeSettlementFinancialCard(TradeSettlementFinancialCardType *pStructTradeSettlementFinancialCard, BOOL bMicrochipIndicator, char *pId, char *pTypeCode, char *pCardholderName, DATEINT ExpiryDate, long long VerificationNumeric, DATETIMEINT ValidFromDateTime, QUANT InterestRatePercent, char *pIssuingCompanyName, char *pDescription);

//	BranchFinancialInstitution
char **GetLeadTextBranchFinancialInstitution(char *pLang);
BranchFinancialInstitutionType *CreateBranchFinancialInstitution(void *pStructDocTop, void *pStructParent);
BranchFinancialInstitutionType *DestroyBranchFinancialInstitution(BranchFinancialInstitutionType **pBranchFinancialInstitution);
BranchFinancialInstitutionType *CopyBranchFinancialInstitution(void *pStructDocTop, void *pStructParent, BranchFinancialInstitutionType *pBranchFinancialInstitution);
BOOL IsDataBranchFinancialInstitution(BranchFinancialInstitutionType *pBranchFinancialInstitution);
BranchFinancialInstitutionType *UpdateBranchFinancialInstitution(BranchFinancialInstitutionType *pStructBranchFinancialInstitution, char *pId, char *pName);

//	FinancialInstitutionAddress
char **GetLeadTextFinancialInstitutionAddress(char *pLang);
FinancialInstitutionAddressType *CreateFinancialInstitutionAddress(void *pStructDocTop, void *pStructParent);
FinancialInstitutionAddressType *DestroyFinancialInstitutionAddress(FinancialInstitutionAddressType **pFinancialInstitutionAddress);
FinancialInstitutionAddressType *CopyFinancialInstitutionAddress(void *pStructDocTop, void *pStructParent, FinancialInstitutionAddressType *pFinancialInstitutionAddress);
BOOL IsDataFinancialInstitutionAddress(FinancialInstitutionAddressType *pFinancialInstitutionAddress);
FinancialInstitutionAddressType *UpdateFinancialInstitutionAddress(FinancialInstitutionAddressType *pStructFinancialInstitutionAddress, char *pPostcodeCode, char *pBuildingNumber, char *pLineOne, char *pLineTwo, char *pLineThree, char *pLineFour, char *pLineFive, char *pStreetName, char *pCityName, char *pCountrySubDivisionId, char *pCountryId, char *pTypeCode, char *pDepartmentName, char *pPostOfficeBox, char *pCityId, char *pCountrySubDivisionName, char *pCountryName);

//	AmountCurrency
char **GetLeadTextAmountCurrency(char *pLang);
AmountCurrencyType *CreateAmountCurrency(void *pStructDocTop, void *pStructParent);
AmountCurrencyType *DestroyAmountCurrency(AmountCurrencyType **pAmountCurrency);
AmountCurrencyType *CopyAmountCurrency(void *pStructDocTop, void *pStructParent, AmountCurrencyType *pAmountCurrency);
BOOL IsDataAmountCurrency(AmountCurrencyType *pAmountCurrency);
AmountCurrencyType *UpdateAmountCurrency(AmountCurrencyType *pStructAmountCurrency, AMOUNT AmountCurrency, char *pcurr);

//	Text
char **GetLeadTextText(char *pLang);
TextType *CreateText(void *pStructDocTop, void *pStructParent);
TextType *DestroyText(TextType **pText);
TextType *CopyText(void *pStructDocTop, void *pStructParent, TextType *pText);
BOOL IsDataText(TextType *pText);
TextType *UpdateText(TextType *pStructText, char *pText, char *plang);

//	OperatorInfo
char **GetLeadTextOperatorInfo(char *pLang);
OperatorInfoType *CreateOperatorInfo(void *pStructDocTop, void *pStructParent);
OperatorInfoType *DestroyOperatorInfo(OperatorInfoType **pOperatorInfo);
OperatorInfoType *CopyOperatorInfo(void *pStructDocTop, void *pStructParent, OperatorInfoType *pOperatorInfo);
BOOL IsDataOperatorInfo(OperatorInfoType *pOperatorInfo);
OperatorInfoType *UpdateOperatorInfo(OperatorInfoType *pStructOperatorInfo, char *pOperatorInfo, DATEINT date);

//	ProgramInfo
char **GetLeadTextProgramInfo(char *pLang);
ProgramInfoType *CreateProgramInfo(void *pStructDocTop, void *pStructParent);
ProgramInfoType *DestroyProgramInfo(ProgramInfoType **pProgramInfo);
ProgramInfoType *CopyProgramInfo(void *pStructDocTop, void *pStructParent, ProgramInfoType *pProgramInfo);
BOOL IsDataProgramInfo(ProgramInfoType *pProgramInfo);
ProgramInfoType *UpdateProgramInfo(ProgramInfoType *pStructProgramInfo, char *pProgramInfo, char *pversion);

//	SeriesId
char **GetLeadTextSeriesId(char *pLang);
SeriesIdType *CreateSeriesId(void *pStructDocTop, void *pStructParent);
SeriesIdType *DestroySeriesId(SeriesIdType **pSeriesId);
SeriesIdType *CopySeriesId(void *pStructDocTop, void *pStructParent, SeriesIdType *pSeriesId);
BOOL IsDataSeriesId(SeriesIdType *pSeriesId);
SeriesIdType *UpdateSeriesId(SeriesIdType *pStructSeriesId, unsigned long long SeriesId, char *pseries);
