/*********************************************************************************

	RosettaFioTypes.h

	Alphabet Rosetta

	(c)Copyright 2017-2020  Alphabet AB, Sweden (Jan Bergstrom)

	http://www.alphabet.se

	Licensed under the Apache License, Version 2.0 (the "License");
	you may not use this file except in compliance with the License.
	You may obtain a copy of the License at

	http://www.apache.org/licenses/LICENSE-2.0

	Unless required by applicable law or agreed to in writing, software
	distributed under the License is distributed on an "AS IS" BASIS,
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the License for the specific language governing permissions and
	limitations under the License.

	We ask for attribution to us, when used.

******************************************************************************************

The RosettaFioTypes.h file contains the general app specific external definitions.

**********************************************************************************/
#ifndef _CRT_SECURE_NO_WARNINGS
#define _CRT_SECURE_NO_WARNINGS
#endif
#include "Copyright.h"
#include <ctype.h> 
#include <stdio.h>
#include <string.h>
typedef long long int				NUMERIC;
typedef long long int				AMOUNT;
typedef long double					QUANT;
typedef unsigned long long int		COUNTER;
typedef unsigned long long int		BITMASK;
typedef unsigned long long int		DATETIMEINT;
typedef unsigned long long int		DATEINT;
typedef unsigned long long int		TIMEINT;
#include "RosettaFioUtils.h"
#include "RosettaFio.h"
#include "RosettaFioSie.h"
#include "RosettaFioXbrlGl.h"

typedef struct {
	void			*vpWorkData;
	LLIST			plErrorList;
	LocaleDataType *pLocaleData;
	char			*ProgramFilePath;
	char			*ProgramFilePathName;
//	char			*Switches[MAX_PATH+1];
	char			*pWorkFileName;
	char			*pWorkFilePath;
	char			*pWorkFilePathName;
	int				iFiletype;
	BOOL			bIsEntity;
	BOOL			bIsObject;
	BOOL			bIsBalance;
	BOOL			bIsQuantity;
	BOOL			bIsBudget;
	BOOL			bIsVouchers;
	int				iAccountLength;
	int				iThousandSets;
} InstanceDataType;

typedef struct {
	COUNTER			iType;
	char			*pTabText;
	BITMASK			bmTabType;
	BOOL			bAudit;
	BOOL			bExpand;
	size_t			ztCursor;
	char			*pSearchText;
	NUMERIC			nSubTab;
	NUMERIC			nSubTabs;
	char			*pSelSeries;
	char			**ppSeriesLabels;
	NUMERIC			nPeriodicTabs;
	NUMERIC			nSelectedPeriodicTab;
	char			*pPeriodLabel;
	char			**ppPeriodLabels;
	DATEINT			 *pdPeriodDates;
	DATEINT			dPeriod;
	void *			vpObject;
	void *			hSelTreeItem;
	size_t			ztLines;
	size_t			ztMainListFields;
	size_t			*pztMainFieldsWidth;
	NUMERIC			*pnMainFieldsAlign;
	char			**ppMainFieldsHeader;
	void			*vpRosettaView;
	InstanceDataType *pInstanceData;
	} TabDataType;

/*
typedef struct {
int					StructType;
void				*pWorkData;
void				*vpItemData;
void				*vpObj;
BOOL				Audit;
} DataClipType;

typedef struct {
int					StructType;
} DataTypesType;
*/
#include "RosettaFioProcess.h"

#define VOUCHER_INFOTIP_SIZE		0x1000
#define VOUCHER_INFOTIP_ENTRIES		15
#define MAX_PROGRAM_ARGUMENTS		16
//#define XSL_RAC "http://www.alphabet.se/Rosetta/Rosetta.xsd"
#define XSL_XBRLGL "http://www.alphabet.se/XBRL/xsl/xbrlgl.xsl"


