/*********************************************************************

	RosettaFIO.c

	Alphabet Rosetta

	(c)Copyright 2017-2020  Alphabet AB, Sweden (Jan Bergstrom)

	http://www.alphabet.se

	Licensed under the Apache License, Version 2.0 (the "License");
	you may not use this file except in compliance with the License.
	You may obtain a copy of the License at
	
	http://www.apache.org/licenses/LICENSE-2.0
	
	Unless required by applicable law or agreed to in writing, software
	distributed under the License is distributed on an "AS IS" BASIS,
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the License for the specific language governing permissions and
	limitations under the License.

	We ask for attribution to us, when used.

********************************************************************

	This is a machine generated file
		- It is made from the content of an XSD
		- It is made to read, write and handle data in an XML of the XSD
	RosettaProcess.c holds the OS independent application logics.
	MainView.c holds the OS independent screen mirror data.
	OS dependent (first letters i file names) holds user interface.

Content of RosettaFIO.c
1.) Alphabet Rosetta Internal (static) C function declarations
2.) Alphabet Rosetta Enumerations
3.) Alphabet Rosetta C-functions

*********************************************************************/
#include "RosettaFioTypes.h"
char NulString[1] = { "\0" };
char szString[TEMPSTRING_LENGTH] = { "\0" };
char szAttribData[TEMPSTRING_LENGTH]={"\0"};

/*********************************************************************

Alphabet Rosetta Internal (static) C function declarations

*********************************************************************/

static AccountingType *ReadSectionAccounting(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionAccounting(FILE *pStream, int iTab, char *pLabel, char *pAttr, AccountingType *pAccounting, char *pContent);
static AttestType *ReadSectionAttest(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionAttest(FILE *pStream, int iTab, char *pLabel, char *pAttr, AttestType *pAttest);
static PartyType *ReadSectionParty(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionParty(FILE *pStream, int iTab, char *pLabel, char *pAttr, PartyType *pParty);
static ContactType *ReadSectionContact(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionContact(FILE *pStream, int iTab, char *pLabel, char *pAttr, ContactType *pContact);
static AccountsChartType *ReadSectionAccountsChart(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionAccountsChart(FILE *pStream, int iTab, char *pLabel, char *pAttr, AccountsChartType *pAccountsChart, char *pContent);
static AccountType *ReadSectionAccount(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionAccount(FILE *pStream, int iTab, char *pLabel, char *pAttr, AccountType *pAccount, BOOL bLean);
static AccountCodeType *ReadSectionAccountCode(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionAccountCode(FILE *pStream, int iTab, char *pLabel, char *pAttr, AccountCodeType *pAccountCode);
static ObjectsChartType *ReadSectionObjectsChart(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionObjectsChart(FILE *pStream, int iTab, char *pLabel, char *pAttr, ObjectsChartType *pObjectsChart, char *pContent);
static DimensionType *ReadSectionDimension(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionDimension(FILE *pStream, int iTab, char *pLabel, char *pAttr, DimensionType *pDimension, BOOL bLean);
static ObjectType *ReadSectionObject(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionObject(FILE *pStream, int iTab, char *pLabel, char *pAttr, ObjectType *pObject, BOOL bLean);
static LedgersChartType *ReadSectionLedgersChart(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionLedgersChart(FILE *pStream, int iTab, char *pLabel, char *pAttr, LedgersChartType *pLedgersChart, char *pContent);
static LedgerType *ReadSectionLedger(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionLedger(FILE *pStream, int iTab, char *pLabel, char *pAttr, LedgerType *pLedger, char *pContent);
static BalanceReportType *ReadSectionBalanceReport(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionBalanceReport(FILE *pStream, int iTab, char *pLabel, char *pAttr, BalanceReportType *pBalanceReport);
static BalanceTotalType *ReadSectionBalanceTotal(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionBalanceTotal(FILE *pStream, int iTab, char *pLabel, char *pAttr, BalanceTotalType *pBalanceTotal);
static BalanceTotalPeriodType *ReadSectionBalanceTotalPeriod(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionBalanceTotalPeriod(FILE *pStream, int iTab, char *pLabel, char *pAttr, BalanceTotalPeriodType *pBalanceTotalPeriod);
static BalanceAccountType *ReadSectionBalanceAccount(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionBalanceAccount(FILE *pStream, int iTab, char *pLabel, char *pAttr, BalanceAccountType *pBalanceAccount);
static BalanceAccountPeriodType *ReadSectionBalanceAccountPeriod(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionBalanceAccountPeriod(FILE *pStream, int iTab, char *pLabel, char *pAttr, BalanceAccountPeriodType *pBalanceAccountPeriod);
static VoucherType *ReadSectionVoucher(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionVoucher(FILE *pStream, int iTab, char *pLabel, char *pAttr, VoucherType *pVoucher);
static VoucherEntryType *ReadSectionVoucherEntry(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionVoucherEntry(FILE *pStream, int iTab, char *pLabel, char *pAttr, VoucherEntryType *pVoucherEntry);
static InvoiceChartType *ReadSectionInvoiceChart(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionInvoiceChart(FILE *pStream, int iTab, char *pLabel, char *pAttr, InvoiceChartType *pInvoiceChart);
static InvoiceType *ReadSectionInvoice(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionInvoice(FILE *pStream, int iTab, char *pLabel, char *pAttr, InvoiceType *pInvoice);
static InvoiceEntryType *ReadSectionInvoiceEntry(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionInvoiceEntry(FILE *pStream, int iTab, char *pLabel, char *pAttr, InvoiceEntryType *pInvoiceEntry);
static TradeItemDataType *ReadSectionTradeItemData(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionTradeItemData(FILE *pStream, int iTab, char *pLabel, char *pAttr, TradeItemDataType *pTradeItemData);
static PayType *ReadSectionPay(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionPay(FILE *pStream, int iTab, char *pLabel, char *pAttr, PayType *pPay);
static DepreciationsType *ReadSectionDepreciations(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionDepreciations(FILE *pStream, int iTab, char *pLabel, char *pAttr, DepreciationsType *pDepreciations);
static DepreciationEntryType *ReadSectionDepreciationEntry(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionDepreciationEntry(FILE *pStream, int iTab, char *pLabel, char *pAttr, DepreciationEntryType *pDepreciationEntry);
static CITradeSettlementPaymentMeansType *ReadSectionCITradeSettlementPaymentMeans(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionCITradeSettlementPaymentMeans(FILE *pStream, int iTab, char *pLabel, char *pAttr, CITradeSettlementPaymentMeansType *pCITradeSettlementPaymentMeans);
static CIDebtorFinancialAccountType *ReadSectionCIDebtorFinancialAccount(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionCIDebtorFinancialAccount(FILE *pStream, int iTab, char *pLabel, char *pAttr, CIDebtorFinancialAccountType *pCIDebtorFinancialAccount);
static CIDebtorFinancialInstitutionType *ReadSectionCIDebtorFinancialInstitution(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionCIDebtorFinancialInstitution(FILE *pStream, int iTab, char *pLabel, char *pAttr, CIDebtorFinancialInstitutionType *pCIDebtorFinancialInstitution);
static CICreditorFinancialAccountType *ReadSectionCICreditorFinancialAccount(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionCICreditorFinancialAccount(FILE *pStream, int iTab, char *pLabel, char *pAttr, CICreditorFinancialAccountType *pCICreditorFinancialAccount);
static CICreditorFinancialInstitutionType *ReadSectionCICreditorFinancialInstitution(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionCICreditorFinancialInstitution(FILE *pStream, int iTab, char *pLabel, char *pAttr, CICreditorFinancialInstitutionType *pCICreditorFinancialInstitution);
static TradeSettlementFinancialCardType *ReadSectionTradeSettlementFinancialCard(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionTradeSettlementFinancialCard(FILE *pStream, int iTab, char *pLabel, char *pAttr, TradeSettlementFinancialCardType *pTradeSettlementFinancialCard);
static BranchFinancialInstitutionType *ReadSectionBranchFinancialInstitution(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionBranchFinancialInstitution(FILE *pStream, int iTab, char *pLabel, char *pAttr, BranchFinancialInstitutionType *pBranchFinancialInstitution);
static FinancialInstitutionAddressType *ReadSectionFinancialInstitutionAddress(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionFinancialInstitutionAddress(FILE *pStream, int iTab, char *pLabel, char *pAttr, FinancialInstitutionAddressType *pFinancialInstitutionAddress);
static AmountCurrencyType *ReadSectionAmountCurrency(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionAmountCurrency(FILE *pStream, int iTab, char *pLabel, char *pAttr, AmountCurrencyType *pAmountCurrency);
static TextType *ReadSectionText(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionText(FILE *pStream, int iTab, char *pLabel, char *pAttr, TextType *pText);
static OperatorInfoType *ReadSectionOperatorInfo(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionOperatorInfo(FILE *pStream, int iTab, char *pLabel, char *pAttr, OperatorInfoType *pOperatorInfo);
static ProgramInfoType *ReadSectionProgramInfo(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionProgramInfo(FILE *pStream, int iTab, char *pLabel, char *pAttr, ProgramInfoType *pProgramInfo);
static SeriesIdType *ReadSectionSeriesId(void *pStructDocTop, void *pStructParent, XmlTagDataType *pXmlTagData, char *pEndTag);
static BOOL WriteSectionSeriesId(FILE *pStream, int iTab, char *pLabel, char *pAttr, SeriesIdType *pSeriesId);


/*********************************************************************

Alphabet Rosetta Enumerations

*********************************************************************/

EnumType EnumDocumentContentType[]=
{
	{"Accounting",{
		{SCT_TEXT, NULL, NULL, "Accounting", "en"},
		{SCT_TEXT, NULL, NULL, "Bokföring", "sv"},
		{SCT_TEXT, NULL, NULL, "Regnskab", "da"},
		{SCT_TEXT, NULL, NULL, "Regnskap", "no"},
		{SCT_TEXT, NULL, NULL, "Bókhald", "is"},
		{SCT_TEXT, NULL, NULL, "Kirjanpito", "fi"},
		{SCT_TEXT, NULL, NULL, "Buchhaltung", "de"},
		{SCT_TEXT, NULL, NULL, "Boekhouding", "nl"},
		{SCT_TEXT, NULL, NULL, "Comptabilité", "fr"},
		{SCT_TEXT, NULL, NULL, "Contabilidad", "es"},
		{SCT_TEXT, NULL, NULL, "Contabilidade", "pt"},
		{SCT_TEXT, NULL, NULL, "Contabilità", "it"}, {0}}},
	{"Invoice",{
		{SCT_TEXT, NULL, NULL, "Invoice", "en"},
		{SCT_TEXT, NULL, NULL, "Faktura", "sv"},
		{SCT_TEXT, NULL, NULL, "Faktura", "da"},
		{SCT_TEXT, NULL, NULL, "Faktura", "no"},
		{SCT_TEXT, NULL, NULL, "Reikningur", "is"},
		{SCT_TEXT, NULL, NULL, "Lasku", "fi"},
		{SCT_TEXT, NULL, NULL, "Rechnung", "de"},
		{SCT_TEXT, NULL, NULL, "Factuur", "nl"},
		{SCT_TEXT, NULL, NULL, "Facture", "fr"},
		{SCT_TEXT, NULL, NULL, "Factura", "es"},
		{SCT_TEXT, NULL, NULL, "Fatura", "pt"},
		{SCT_TEXT, NULL, NULL, "Fattura", "it"}, {0}}},
	{"BankAccountStatement",{
		{SCT_TEXT, NULL, NULL, "Bank Statement", "en"},
		{SCT_TEXT, NULL, NULL, "Bankkontoutdrag", "sv"},
		{SCT_TEXT, NULL, NULL, "Bankkontoudtog", "da"},
		{SCT_TEXT, NULL, NULL, "Bankkontoutdrag", "no"},
		{SCT_TEXT, NULL, NULL, "Bankayfirlit", "is"},
		{SCT_TEXT, NULL, NULL, "Pankin tiliote", "fi"},
		{SCT_TEXT, NULL, NULL, "Bankauszug", "de"},
		{SCT_TEXT, NULL, NULL, "Bankafschrift", "nl"},
		{SCT_TEXT, NULL, NULL, "Relevé bancaire", "fr"},
		{SCT_TEXT, NULL, NULL, "Extracto bancario", "es"},
		{SCT_TEXT, NULL, NULL, "Extrato bancário", "pt"},
		{SCT_TEXT, NULL, NULL, "Rendiconto bancario", "it"}, {0}}},
	{0}
};

EnumType EnumFolderType[]=
{
	{"Presentation",{
		{SCT_TEXT, NULL, NULL, "Presentation", "en"},
		{SCT_TEXT, NULL, NULL, "Presentation", "sv"},
		{SCT_TEXT, NULL, NULL, "Præsentation", "da"},
		{SCT_TEXT, NULL, NULL, "Presentasjon", "no"},
		{SCT_TEXT, NULL, NULL, "Kynning", "is"},
		{SCT_TEXT, NULL, NULL, "Esittely", "fi"},
		{SCT_TEXT, NULL, NULL, "Präsentation", "de"},
		{SCT_TEXT, NULL, NULL, "Presentatie", "nl"},
		{SCT_TEXT, NULL, NULL, "Présentation", "fr"},
		{SCT_TEXT, NULL, NULL, "Presentación", "es"},
		{SCT_TEXT, NULL, NULL, "Apresentação", "pt"},
		{SCT_TEXT, NULL, NULL, "Presentazione", "it"}, {0}}},
	{"Entity",{
		{SCT_TEXT, NULL, NULL, "Entity", "en"},
		{SCT_TEXT, NULL, NULL, "Företagsdata", "sv"},
		{SCT_TEXT, NULL, NULL, "Virksomhed", "da"},
		{SCT_TEXT, NULL, NULL, "Bedriftsdata", "no"},
		{SCT_TEXT, NULL, NULL, "Fyrirtæki Gögn", "is"},
		{SCT_TEXT, NULL, NULL, "Yrityksen tiedot", "fi"},
		{SCT_TEXT, NULL, NULL, "Firmendaten", "de"},
		{SCT_TEXT, NULL, NULL, "Bedrijven", "nl"},
		{SCT_TEXT, NULL, NULL, "Entité", "fr"},
		{SCT_TEXT, NULL, NULL, "Entidad", "es"},
		{SCT_TEXT, NULL, NULL, "Entidade", "pt"},
		{SCT_TEXT, NULL, NULL, "Entità", "it"}, {0}}},
	{"Analyse",{
		{SCT_TEXT, NULL, NULL, "Analyse", "en"},
		{SCT_TEXT, NULL, NULL, "Analys", "sv"},
		{SCT_TEXT, NULL, NULL, "Analyse", "da"},
		{SCT_TEXT, NULL, NULL, "Analyse", "no"},
		{SCT_TEXT, NULL, NULL, "Greining", "is"},
		{SCT_TEXT, NULL, NULL, "Analyysi", "fi"},
		{SCT_TEXT, NULL, NULL, "Analyse", "de"},
		{SCT_TEXT, NULL, NULL, "Analyse", "nl"},
		{SCT_TEXT, NULL, NULL, "Analyse", "fr"},
		{SCT_TEXT, NULL, NULL, "Análisis", "es"},
		{SCT_TEXT, NULL, NULL, "Análise", "pt"},
		{SCT_TEXT, NULL, NULL, "Analisi", "it"}, {0}}},
	{"Errors",{
		{SCT_TEXT, NULL, NULL, "Error", "en"},
		{SCT_TEXT, NULL, NULL, "Fel", "sv"},
		{SCT_TEXT, NULL, NULL, "Fejl", "da"},
		{SCT_TEXT, NULL, NULL, "Feil", "no"},
		{SCT_TEXT, NULL, NULL, "Villa", "is"},
		{SCT_TEXT, NULL, NULL, "Virhe", "fi"},
		{SCT_TEXT, NULL, NULL, "Fehler", "de"},
		{SCT_TEXT, NULL, NULL, "Fout", "nl"},
		{SCT_TEXT, NULL, NULL, "Erreur", "fr"},
		{SCT_TEXT, NULL, NULL, "Error", "es"},
		{SCT_TEXT, NULL, NULL, "Erro", "pt"},
		{SCT_TEXT, NULL, NULL, "Errore", "it"}, {0}}},
	{"Objects",{
		{SCT_TEXT, NULL, NULL, "Objects", "en"},
		{SCT_TEXT, NULL, NULL, "Objekt", "sv"},
		{SCT_TEXT, NULL, NULL, "Objekter", "da"},
		{SCT_TEXT, NULL, NULL, "Objekter", "no"},
		{SCT_TEXT, NULL, NULL, "Hlutir", "is"},
		{SCT_TEXT, NULL, NULL, "Objekti", "fi"},
		{SCT_TEXT, NULL, NULL, "Objekte", "de"},
		{SCT_TEXT, NULL, NULL, "Object", "nl"},
		{SCT_TEXT, NULL, NULL, "Objets", "fr"},
		{SCT_TEXT, NULL, NULL, "Objetos", "es"},
		{SCT_TEXT, NULL, NULL, "Objetos", "pt"},
		{SCT_TEXT, NULL, NULL, "Oggetti", "it"}, {0}}},
	{"Attest",{
		{SCT_TEXT, NULL, NULL, "Attest", "en"},
		{SCT_TEXT, NULL, NULL, "Attest", "sv"},
		{SCT_TEXT, NULL, NULL, "Attest", "da"},
		{SCT_TEXT, NULL, NULL, "Attest", "no"},
		{SCT_TEXT, NULL, NULL, "Vitnisburður", "is"},
		{SCT_TEXT, NULL, NULL, "Todentaminen", "fi"},
		{SCT_TEXT, NULL, NULL, "Attest", "de"},
		{SCT_TEXT, NULL, NULL, "Attest", "nl"},
		{SCT_TEXT, NULL, NULL, "Attester", "fr"},
		{SCT_TEXT, NULL, NULL, "Atestiguar", "es"},
		{SCT_TEXT, NULL, NULL, "Atestar", "pt"},
		{SCT_TEXT, NULL, NULL, "Attestare", "it"}, {0}}},
	{"Accountant",{
		{SCT_TEXT, NULL, NULL, "Accountant", "en"},
		{SCT_TEXT, NULL, NULL, "Redovisningskonsult", "sv"},
		{SCT_TEXT, NULL, NULL, "Bogholder", "da"},
		{SCT_TEXT, NULL, NULL, "Regnskapsfører", "no"},
		{SCT_TEXT, NULL, NULL, "Bókhaldari", "is"},
		{SCT_TEXT, NULL, NULL, "Kirjanpitäjä", "fi"},
		{SCT_TEXT, NULL, NULL, "Buchhalter", "de"},
		{SCT_TEXT, NULL, NULL, "Boekhouder", "nl"},
		{SCT_TEXT, NULL, NULL, "Comptable", "fr"},
		{SCT_TEXT, NULL, NULL, "Contador", "es"},
		{SCT_TEXT, NULL, NULL, "Contador", "pt"},
		{SCT_TEXT, NULL, NULL, "Contabile", "it"}, {0}}},
	{"Audit",{
		{SCT_TEXT, NULL, NULL, "Audit", "en"},
		{SCT_TEXT, NULL, NULL, "Revisor", "sv"},
		{SCT_TEXT, NULL, NULL, "Revisor", "da"},
		{SCT_TEXT, NULL, NULL, "Revisor", "no"},
		{SCT_TEXT, NULL, NULL, "Endurskoðandi", "is"},
		{SCT_TEXT, NULL, NULL, "Tilintarkastaja", "fi"},
		{SCT_TEXT, NULL, NULL, "Rechnungsprüfer", "de"},
		{SCT_TEXT, NULL, NULL, "Revisor", "nl"},
		{SCT_TEXT, NULL, NULL, "Auditeur", "fr"},
		{SCT_TEXT, NULL, NULL, "Auditor", "es"},
		{SCT_TEXT, NULL, NULL, "Auditor", "pt"},
		{SCT_TEXT, NULL, NULL, "Uditore", "it"}, {0}}},
	{0}
};

EnumType EnumContentType[]=
{
	{"Charts",{
		{SCT_TEXT, NULL, NULL, "Chart of accounts", "en"},
		{SCT_TEXT, NULL, NULL, "Kontoplan", "sv"},
		{SCT_TEXT, NULL, NULL, "Kontoplan", "da"},
		{SCT_TEXT, NULL, NULL, "Kontoplan", "no"},
		{SCT_TEXT, NULL, NULL, "Bókhaldslykill", "is"},
		{SCT_TEXT, NULL, NULL, "Tilikartta", "fi"},
		{SCT_TEXT, NULL, NULL, "Kontenplan", "de"},
		{SCT_TEXT, NULL, NULL, "Rekeningschema", "nl"},
		{SCT_TEXT, NULL, NULL, "Plan de comptes", "fr"},
		{SCT_TEXT, NULL, NULL, "Plan de cuentas", "es"},
		{SCT_TEXT, NULL, NULL, "Plano de contas", "pt"},
		{SCT_TEXT, NULL, NULL, "Piano dei conti", "it"}, {0}}},
	{"Balances",{
		{SCT_TEXT, NULL, NULL, "Balances", "en"},
		{SCT_TEXT, NULL, NULL, "Balanser", "sv"},
		{SCT_TEXT, NULL, NULL, "Balance", "da"},
		{SCT_TEXT, NULL, NULL, "Balanse", "no"},
		{SCT_TEXT, NULL, NULL, "Efnahag", "is"},
		{SCT_TEXT, NULL, NULL, "Tase", "fi"},
		{SCT_TEXT, NULL, NULL, "Bilanz", "de"},
		{SCT_TEXT, NULL, NULL, "Balans", "nl"},
		{SCT_TEXT, NULL, NULL, "Bilan", "fr"},
		{SCT_TEXT, NULL, NULL, "Balance", "es"},
		{SCT_TEXT, NULL, NULL, "Balanço", "pt"},
		{SCT_TEXT, NULL, NULL, "Patrimoniale", "it"}, {0}}},
	{"Ledger",{
		{SCT_TEXT, NULL, NULL, "Ledger", "en"},
		{SCT_TEXT, NULL, NULL, "Huvudbok", "sv"},
		{SCT_TEXT, NULL, NULL, "Hovedbog", "da"},
		{SCT_TEXT, NULL, NULL, "Hovedbok", "no"},
		{SCT_TEXT, NULL, NULL, "Fjárhagur", "is"},
		{SCT_TEXT, NULL, NULL, "Päiväkirja", "fi"},
		{SCT_TEXT, NULL, NULL, "Hauptbuch", "de"},
		{SCT_TEXT, NULL, NULL, "Grootboek", "nl"},
		{SCT_TEXT, NULL, NULL, "Comptabilité", "fr"},
		{SCT_TEXT, NULL, NULL, "Libro mayor", "es"},
		{SCT_TEXT, NULL, NULL, "Razão geral", "pt"},
		{SCT_TEXT, NULL, NULL, "Contabilità", "it"}, {0}}},
	{"Vouchers",{
		{SCT_TEXT, NULL, NULL, "Journal", "en"},
		{SCT_TEXT, NULL, NULL, "Verifikationer", "sv"},
		{SCT_TEXT, NULL, NULL, "Journal", "da"},
		{SCT_TEXT, NULL, NULL, "Journal", "no"},
		{SCT_TEXT, NULL, NULL, "Færslubók", "is"},
		{SCT_TEXT, NULL, NULL, "Pitää", "fi"},
		{SCT_TEXT, NULL, NULL, "Journal", "de"},
		{SCT_TEXT, NULL, NULL, "Journaal", "nl"},
		{SCT_TEXT, NULL, NULL, "Journal", "fr"},
		{SCT_TEXT, NULL, NULL, "Diario", "es"},
		{SCT_TEXT, NULL, NULL, "Diário", "pt"},
		{SCT_TEXT, NULL, NULL, "Giornale", "it"}, {0}}},
	{0}
};

EnumType EnumAccountTotalTypeType[]=
{
	{"Active",{
		{SCT_TEXT, NULL, NULL, "Active", "en"},
		{SCT_TEXT, NULL, NULL, "Aktiva", "sv"},
		{SCT_TEXT, NULL, NULL, "Aktiva", "da"},
		{SCT_TEXT, NULL, NULL, "Aktiva", "no"},
		{SCT_TEXT, NULL, NULL, "Aktiva", "is"},
		{SCT_TEXT, NULL, NULL, "Aktiivinen", "fi"},
		{SCT_TEXT, NULL, NULL, "Aktiva", "de"},
		{SCT_TEXT, NULL, NULL, "Aktiva", "nl"},
		{SCT_TEXT, NULL, NULL, "Actif", "fr"},
		{SCT_TEXT, NULL, NULL, "Activo", "es"},
		{SCT_TEXT, NULL, NULL, "Ativo", "pt"},
		{SCT_TEXT, NULL, NULL, "Attivo", "it"}, {0}}},
	{"Passive",{
		{SCT_TEXT, NULL, NULL, "Passive", "en"},
		{SCT_TEXT, NULL, NULL, "Passiva", "sv"},
		{SCT_TEXT, NULL, NULL, "Passiva", "da"},
		{SCT_TEXT, NULL, NULL, "Passiva", "no"},
		{SCT_TEXT, NULL, NULL, "Passiva", "is"},
		{SCT_TEXT, NULL, NULL, "Passiivinen", "fi"},
		{SCT_TEXT, NULL, NULL, "Passiva", "de"},
		{SCT_TEXT, NULL, NULL, "Passiva", "nl"},
		{SCT_TEXT, NULL, NULL, "Passif", "fr"},
		{SCT_TEXT, NULL, NULL, "Pasivo", "es"},
		{SCT_TEXT, NULL, NULL, "Passiva", "pt"},
		{SCT_TEXT, NULL, NULL, "Passivo", "it"}, {0}}},
	{"Balance",{
		{SCT_TEXT, NULL, NULL, "Balance", "en"},
		{SCT_TEXT, NULL, NULL, "Balans", "sv"},
		{SCT_TEXT, NULL, NULL, "Balance", "da"},
		{SCT_TEXT, NULL, NULL, "Balanse", "no"},
		{SCT_TEXT, NULL, NULL, "Efnahag", "is"},
		{SCT_TEXT, NULL, NULL, "Tase", "fi"},
		{SCT_TEXT, NULL, NULL, "Bilanz", "de"},
		{SCT_TEXT, NULL, NULL, "Balans", "nl"},
		{SCT_TEXT, NULL, NULL, "Bilan", "fr"},
		{SCT_TEXT, NULL, NULL, "Balance", "es"},
		{SCT_TEXT, NULL, NULL, "Balancete", "pt"},
		{SCT_TEXT, NULL, NULL, "Bilancia", "it"}, {0}}},
	{"Profit",{
		{SCT_TEXT, NULL, NULL, "Profit", "en"},
		{SCT_TEXT, NULL, NULL, "Vinst", "sv"},
		{SCT_TEXT, NULL, NULL, "Gevinst", "da"},
		{SCT_TEXT, NULL, NULL, "Profitt", "no"},
		{SCT_TEXT, NULL, NULL, "Græða", "is"},
		{SCT_TEXT, NULL, NULL, "Voitto", "fi"},
		{SCT_TEXT, NULL, NULL, "Gewinn", "de"},
		{SCT_TEXT, NULL, NULL, "Winst", "nl"},
		{SCT_TEXT, NULL, NULL, "Profit", "fr"},
		{SCT_TEXT, NULL, NULL, "Ganancias", "es"},
		{SCT_TEXT, NULL, NULL, "Ganhos", "pt"},
		{SCT_TEXT, NULL, NULL, "Profitto", "it"}, {0}}},
	{"Earning",{
		{SCT_TEXT, NULL, NULL, "Operational Earnings (EBIT)", "en"},
		{SCT_TEXT, NULL, NULL, "Rörelseresultat (EBIT)", "sv"},
		{SCT_TEXT, NULL, NULL, "Driftsresultat (EBIT)", "da"},
		{SCT_TEXT, NULL, NULL, "Driftsresultat (EBIT)", "no"},
		{SCT_TEXT, NULL, NULL, "Rekstrarhagnaður (EBIT)", "is"},
		{SCT_TEXT, NULL, NULL, "Liiketulos (EBIT)", "fi"},
		{SCT_TEXT, NULL, NULL, "Betriebsergebnis (EBIT)", "de"},
		{SCT_TEXT, NULL, NULL, "Bedrijfsresultaat (EBIT)", "nl"},
		{SCT_TEXT, NULL, NULL, "Bénéfice (BAII)", "fr"},
		{SCT_TEXT, NULL, NULL, "Beneficio (BAII)", "es"},
		{SCT_TEXT, NULL, NULL, "Lucro (LAIR)", "pt"},
		{SCT_TEXT, NULL, NULL, "Guadagno (EBIT)", "it"}, {0}}},
	{"Outcome",{
		{SCT_TEXT, NULL, NULL, "Earnings before taxes (EBT)", "en"},
		{SCT_TEXT, NULL, NULL, "Resultat före skatt (EBT)", "sv"},
		{SCT_TEXT, NULL, NULL, "Resultat før skat (EBT)", "da"},
		{SCT_TEXT, NULL, NULL, "Resultat før skatt (EBT)", "no"},
		{SCT_TEXT, NULL, NULL, "Hagnaður fyrir skatta (EBT)", "is"},
		{SCT_TEXT, NULL, NULL, "Tulos ennen veroja (EBT)", "fi"},
		{SCT_TEXT, NULL, NULL, "Gewinn vor Steuern (EBT)", "de"},
		{SCT_TEXT, NULL, NULL, "Inkomsten voor belastingen (EBT)", "nl"},
		{SCT_TEXT, NULL, NULL, "Bénéfice avant impôt (BAI)", "fr"},
		{SCT_TEXT, NULL, NULL, "Beneficio antes de impuestos (BAI)", "es"},
		{SCT_TEXT, NULL, NULL, "Lucro antes dos impostos (LAI)", "pt"},
		{SCT_TEXT, NULL, NULL, "Risultato ante imposte (EBT)", "it"}, {0}}},
	{"Result",{
		{SCT_TEXT, NULL, NULL, "Result", "en"},
		{SCT_TEXT, NULL, NULL, "Resultat", "sv"},
		{SCT_TEXT, NULL, NULL, "Resultater", "da"},
		{SCT_TEXT, NULL, NULL, "Resultat", "no"},
		{SCT_TEXT, NULL, NULL, "Rekstraryfirlit", "is"},
		{SCT_TEXT, NULL, NULL, "Tulos", "fi"},
		{SCT_TEXT, NULL, NULL, "Ergebnis", "de"},
		{SCT_TEXT, NULL, NULL, "Resultaat", "nl"},
		{SCT_TEXT, NULL, NULL, "Résultat", "fr"},
		{SCT_TEXT, NULL, NULL, "Resultado", "es"},
		{SCT_TEXT, NULL, NULL, "Resultado", "pt"},
		{SCT_TEXT, NULL, NULL, "Risultato", "it"}, {0}}},
	{"Total",{
		{SCT_TEXT, NULL, NULL, "Total", "en"},
		{SCT_TEXT, NULL, NULL, "Totalt", "sv"},
		{SCT_TEXT, NULL, NULL, "Totalt", "da"},
		{SCT_TEXT, NULL, NULL, "Total", "no"},
		{SCT_TEXT, NULL, NULL, "Alls", "is"},
		{SCT_TEXT, NULL, NULL, "Yhteissumma", "fi"},
		{SCT_TEXT, NULL, NULL, "Gesamt", "de"},
		{SCT_TEXT, NULL, NULL, "Totaal", "nl"},
		{SCT_TEXT, NULL, NULL, "Total", "fr"},
		{SCT_TEXT, NULL, NULL, "Total", "es"},
		{SCT_TEXT, NULL, NULL, "Total", "pt"},
		{SCT_TEXT, NULL, NULL, "Totale", "it"}, {0}}},
	{0}
};

EnumType EnumAccountTypeType[]=
{
	{"Tangible",{
		{SCT_TEXT, NULL, NULL, "Tangible", "en"},
		{SCT_TEXT, NULL, NULL, "Anläggningstillgångar", "sv"},
		{SCT_TEXT, NULL, NULL, "Anlægsaktiver", "da"},
		{SCT_TEXT, NULL, NULL, "Anleggsmidler", "no"},
		{SCT_TEXT, NULL, NULL, "Fastafjármunir", "is"},
		{SCT_TEXT, NULL, NULL, "Käyttöomaisuus", "fi"},
		{SCT_TEXT, NULL, NULL, "Anlagevermögen", "de"},
		{SCT_TEXT, NULL, NULL, "Vaste activa", "nl"},
		{SCT_TEXT, NULL, NULL, "Immobilisation", "fr"},
		{SCT_TEXT, NULL, NULL, "Activo fijo", "es"},
		{SCT_TEXT, NULL, NULL, "Ativo fixo", "pt"},
		{SCT_TEXT, NULL, NULL, "Immobilizzazione", "it"}, {0}}},
	{"Stock",{
		{SCT_TEXT, NULL, NULL, "Inventory", "en"},
		{SCT_TEXT, NULL, NULL, "Lager", "sv"},
		{SCT_TEXT, NULL, NULL, "Lager", "da"},
		{SCT_TEXT, NULL, NULL, "Beholdning", "no"},
		{SCT_TEXT, NULL, NULL, "Birgðir", "is"},
		{SCT_TEXT, NULL, NULL, "Varasto", "fi"},
		{SCT_TEXT, NULL, NULL, "Lagerbestand", "de"},
		{SCT_TEXT, NULL, NULL, "Voorraad", "nl"},
		{SCT_TEXT, NULL, NULL, "Stock", "fr"},
		{SCT_TEXT, NULL, NULL, "Inventarios", "es"},
		{SCT_TEXT, NULL, NULL, "Inventários", "pt"},
		{SCT_TEXT, NULL, NULL, "Scorte", "it"}, {0}}},
	{"Receivables",{
		{SCT_TEXT, NULL, NULL, "Receivables", "en"},
		{SCT_TEXT, NULL, NULL, "Fordringar", "sv"},
		{SCT_TEXT, NULL, NULL, "Tilgodehavender", "da"},
		{SCT_TEXT, NULL, NULL, "Fordringer", "no"},
		{SCT_TEXT, NULL, NULL, "Skammtímakröfur", "is"},
		{SCT_TEXT, NULL, NULL, "Saatavat", "fi"},
		{SCT_TEXT, NULL, NULL, "Forderungen", "de"},
		{SCT_TEXT, NULL, NULL, "Handelsvorderingen", "nl"},
		{SCT_TEXT, NULL, NULL, "Créance client", "fr"},
		{SCT_TEXT, NULL, NULL, "Cobros", "es"},
		{SCT_TEXT, NULL, NULL, "Cobranças", "pt"},
		{SCT_TEXT, NULL, NULL, "Contabilità clienti", "it"}, {0}}},
	{"Assets",{
		{SCT_TEXT, NULL, NULL, "Liquid assets", "en"},
		{SCT_TEXT, NULL, NULL, "Likvida medel", "sv"},
		{SCT_TEXT, NULL, NULL, "Likvide aktiver", "da"},
		{SCT_TEXT, NULL, NULL, "Likvide midler", "no"},
		{SCT_TEXT, NULL, NULL, "Lausafjármunir", "is"},
		{SCT_TEXT, NULL, NULL, "Käyttövarat", "fi"},
		{SCT_TEXT, NULL, NULL, "Flüssige Mittel", "de"},
		{SCT_TEXT, NULL, NULL, "Liquide middelen", "nl"},
		{SCT_TEXT, NULL, NULL, "Liquidités", "fr"},
		{SCT_TEXT, NULL, NULL, "Activo líquido", "es"},
		{SCT_TEXT, NULL, NULL, "Activos Líquidos", "pt"},
		{SCT_TEXT, NULL, NULL, "Cespiti liquidi", "it"}, {0}}},
	{"Equities",{
		{SCT_TEXT, NULL, NULL, "Equities", "en"},
		{SCT_TEXT, NULL, NULL, "Eget kapital", "sv"},
		{SCT_TEXT, NULL, NULL, "Egenkapital", "da"},
		{SCT_TEXT, NULL, NULL, "Egenkapital", "no"},
		{SCT_TEXT, NULL, NULL, "Eigið fé", "is"},
		{SCT_TEXT, NULL, NULL, "Pääoma", "fi"},
		{SCT_TEXT, NULL, NULL, "Eigenkapital", "de"},
		{SCT_TEXT, NULL, NULL, "Vermogen", "nl"},
		{SCT_TEXT, NULL, NULL, "Capitaux propres", "fr"},
		{SCT_TEXT, NULL, NULL, "Equidad", "es"},
		{SCT_TEXT, NULL, NULL, "Equidade", "pt"},
		{SCT_TEXT, NULL, NULL, "Equità", "it"}, {0}}},
	{"Provisions",{
		{SCT_TEXT, NULL, NULL, "Provisions", "en"},
		{SCT_TEXT, NULL, NULL, "Avsättningar", "sv"},
		{SCT_TEXT, NULL, NULL, "Hensættelse", "da"},
		{SCT_TEXT, NULL, NULL, "Avsetninger", "no"},
		{SCT_TEXT, NULL, NULL, "Ráðstafanir", "is"},
		{SCT_TEXT, NULL, NULL, "Varaukset", "fi"},
		{SCT_TEXT, NULL, NULL, "Rückstellungen", "de"},
		{SCT_TEXT, NULL, NULL, "Voorzieningen", "nl"},
		{SCT_TEXT, NULL, NULL, "Provisions", "fr"},
		{SCT_TEXT, NULL, NULL, "Provisiones", "es"},
		{SCT_TEXT, NULL, NULL, "Provisões", "pt"},
		{SCT_TEXT, NULL, NULL, "Accantonamenti", "it"}, {0}}},
	{"Liabilities",{
		{SCT_TEXT, NULL, NULL, "Liabilities", "en"},
		{SCT_TEXT, NULL, NULL, "Skulder", "sv"},
		{SCT_TEXT, NULL, NULL, "Gæld", "da"},
		{SCT_TEXT, NULL, NULL, "Gjeld", "no"},
		{SCT_TEXT, NULL, NULL, "Skuldir", "is"},
		{SCT_TEXT, NULL, NULL, "Velat", "fi"},
		{SCT_TEXT, NULL, NULL, "Verbindlichkeiten", "de"},
		{SCT_TEXT, NULL, NULL, "Verplichtingen", "nl"},
		{SCT_TEXT, NULL, NULL, "Dettes", "fr"},
		{SCT_TEXT, NULL, NULL, "Deuda", "es"},
		{SCT_TEXT, NULL, NULL, "Dívida", "pt"},
		{SCT_TEXT, NULL, NULL, "Debiti", "it"}, {0}}},
	{"Revenues",{
		{SCT_TEXT, NULL, NULL, "Revenues", "en"},
		{SCT_TEXT, NULL, NULL, "Intäkter", "sv"},
		{SCT_TEXT, NULL, NULL, "Indtægter", "da"},
		{SCT_TEXT, NULL, NULL, "Inntekter", "no"},
		{SCT_TEXT, NULL, NULL, "Tekjur", "is"},
		{SCT_TEXT, NULL, NULL, "Tuotot", "fi"},
		{SCT_TEXT, NULL, NULL, "Einnahmen", "de"},
		{SCT_TEXT, NULL, NULL, "Opbrengsten", "nl"},
		{SCT_TEXT, NULL, NULL, "Revenus", "fr"},
		{SCT_TEXT, NULL, NULL, "Ingresos", "es"},
		{SCT_TEXT, NULL, NULL, "Rendimentos", "pt"},
		{SCT_TEXT, NULL, NULL, "Ricavi", "it"}, {0}}},
	{"Supplies",{
		{SCT_TEXT, NULL, NULL, "Direct costs", "en"},
		{SCT_TEXT, NULL, NULL, "Direkt kostnad", "sv"},
		{SCT_TEXT, NULL, NULL, "Direkte omkostninger", "da"},
		{SCT_TEXT, NULL, NULL, "Direkte kostnader", "no"},
		{SCT_TEXT, NULL, NULL, "Beinn kostnaður", "is"},
		{SCT_TEXT, NULL, NULL, "Suorat kustannukset", "fi"},
		{SCT_TEXT, NULL, NULL, "Einzelkosten", "de"},
		{SCT_TEXT, NULL, NULL, "Directe kosten", "nl"},
		{SCT_TEXT, NULL, NULL, "Coût direct", "fr"},
		{SCT_TEXT, NULL, NULL, "Costes directos", "es"},
		{SCT_TEXT, NULL, NULL, "Custos diretos", "pt"},
		{SCT_TEXT, NULL, NULL, "Costi diretti", "it"}, {0}}},
	{"Expenses",{
		{SCT_TEXT, NULL, NULL, "Expenses", "en"},
		{SCT_TEXT, NULL, NULL, "Kostnader", "sv"},
		{SCT_TEXT, NULL, NULL, "Omkostninger", "da"},
		{SCT_TEXT, NULL, NULL, "Kostnader", "no"},
		{SCT_TEXT, NULL, NULL, "Kostnaður", "is"},
		{SCT_TEXT, NULL, NULL, "Kulut", "fi"},
		{SCT_TEXT, NULL, NULL, "Ausgaben", "de"},
		{SCT_TEXT, NULL, NULL, "Onkosten", "nl"},
		{SCT_TEXT, NULL, NULL, "Dépenses", "fr"},
		{SCT_TEXT, NULL, NULL, "Gastos", "es"},
		{SCT_TEXT, NULL, NULL, "Gastos", "pt"},
		{SCT_TEXT, NULL, NULL, "Spese", "it"}, {0}}},
	{"Staff",{
		{SCT_TEXT, NULL, NULL, "Staff", "en"},
		{SCT_TEXT, NULL, NULL, "Personal", "sv"},
		{SCT_TEXT, NULL, NULL, "Personale", "da"},
		{SCT_TEXT, NULL, NULL, "Stab", "no"},
		{SCT_TEXT, NULL, NULL, "Starfsfólk", "is"},
		{SCT_TEXT, NULL, NULL, "Henkilökunta", "fi"},
		{SCT_TEXT, NULL, NULL, "Personal", "de"},
		{SCT_TEXT, NULL, NULL, "Personeel", "nl"},
		{SCT_TEXT, NULL, NULL, "Personnel", "fr"},
		{SCT_TEXT, NULL, NULL, "Personal", "es"},
		{SCT_TEXT, NULL, NULL, "Pessoal", "pt"},
		{SCT_TEXT, NULL, NULL, "Personale", "it"}, {0}}},
	{"LossGains",{
		{SCT_TEXT, NULL, NULL, "Loss/Gains", "en"},
		{SCT_TEXT, NULL, NULL, "Förlust/Vinst", "sv"},
		{SCT_TEXT, NULL, NULL, "Tab/gevinster", "da"},
		{SCT_TEXT, NULL, NULL, "Tap/Gevinst", "no"},
		{SCT_TEXT, NULL, NULL, "Tap/hagnaður", "is"},
		{SCT_TEXT, NULL, NULL, "Tappio/voitot", "fi"},
		{SCT_TEXT, NULL, NULL, "Verlust/Gewinn", "de"},
		{SCT_TEXT, NULL, NULL, "Verlies/Winst", "nl"},
		{SCT_TEXT, NULL, NULL, "Perte/Gains", "fr"},
		{SCT_TEXT, NULL, NULL, "Pérdida/Ganancias", "es"},
		{SCT_TEXT, NULL, NULL, "Perda/Ganhos", "pt"},
		{SCT_TEXT, NULL, NULL, "Perdita/Guadagni", "it"}, {0}}},
	{"Financial",{
		{SCT_TEXT, NULL, NULL, "Finance costs", "en"},
		{SCT_TEXT, NULL, NULL, "Finansiella kostnader", "sv"},
		{SCT_TEXT, NULL, NULL, "Finansomkostninger", "da"},
		{SCT_TEXT, NULL, NULL, "Finanskostnader", "no"},
		{SCT_TEXT, NULL, NULL, "Fjármagnskostnaður", "is"},
		{SCT_TEXT, NULL, NULL, "Rahoituskulut", "fi"},
		{SCT_TEXT, NULL, NULL, "Finanzkosten", "de"},
		{SCT_TEXT, NULL, NULL, "Financiële kosten", "nl"},
		{SCT_TEXT, NULL, NULL, "Frais financiers", "fr"},
		{SCT_TEXT, NULL, NULL, "Gastos financieros", "es"},
		{SCT_TEXT, NULL, NULL, "Despesas Financeiras", "pt"},
		{SCT_TEXT, NULL, NULL, "Spese finanziarie", "it"}, {0}}},
	{"Auxiliary",{
		{SCT_TEXT, NULL, NULL, "Auxiliary costs", "en"},
		{SCT_TEXT, NULL, NULL, "Övriga kostnader", "sv"},
		{SCT_TEXT, NULL, NULL, "Andre omkostninger", "da"},
		{SCT_TEXT, NULL, NULL, "Andre kostnader", "no"},
		{SCT_TEXT, NULL, NULL, "Aðrir kostnaður", "is"},
		{SCT_TEXT, NULL, NULL, "Muut kulut", "fi"},
		{SCT_TEXT, NULL, NULL, "Andere Kosten", "de"},
		{SCT_TEXT, NULL, NULL, "Andere kosten", "nl"},
		{SCT_TEXT, NULL, NULL, "Frais auxiliaires", "fr"},
		{SCT_TEXT, NULL, NULL, "Costes auxiliares", "es"},
		{SCT_TEXT, NULL, NULL, "Custos auxiliares", "pt"},
		{SCT_TEXT, NULL, NULL, "Costi ausiliari", "it"}, {0}}},
	{0}
};

EnumType EnumDimensionTitleType[]=
{
	{"CostCentre",{
		{SCT_TEXT, NULL, NULL, "Cost centre", "en"},
		{SCT_TEXT, NULL, NULL, "Kostnadsställe", "sv"},
		{SCT_TEXT, NULL, NULL, "Omkostningssteder", "da"},
		{SCT_TEXT, NULL, NULL, "Kostnadssted", "no"},
		{SCT_TEXT, NULL, NULL, "Kostnaðarstað", "is"},
		{SCT_TEXT, NULL, NULL, "Kustannuspaikka", "fi"},
		{SCT_TEXT, NULL, NULL, "Kostenstelle", "de"},
		{SCT_TEXT, NULL, NULL, "Kostenplaatsen", "nl"},
		{SCT_TEXT, NULL, NULL, "Centre de coûts", "fr"},
		{SCT_TEXT, NULL, NULL, "Centro de coste", "es"},
		{SCT_TEXT, NULL, NULL, "Centro de custo", "pt"},
		{SCT_TEXT, NULL, NULL, "Centro di costo", "it"}, {0}}},
	{"CostBearer",{
		{SCT_TEXT, NULL, NULL, "Cost Objects", "en"},
		{SCT_TEXT, NULL, NULL, "Kostnadsbärare", "sv"},
		{SCT_TEXT, NULL, NULL, "Omkostningsobjekter", "da"},
		{SCT_TEXT, NULL, NULL, "Kostnadsobjekt", "no"},
		{SCT_TEXT, NULL, NULL, "kostnaðarhluti", "is"},
		{SCT_TEXT, NULL, NULL, "Kustannuskohde", "fi"},
		{SCT_TEXT, NULL, NULL, "Kostenträger", "de"},
		{SCT_TEXT, NULL, NULL, "Kostenobjecten", "nl"},
		{SCT_TEXT, NULL, NULL, "Coûts associés", "fr"},
		{SCT_TEXT, NULL, NULL, "Objetos de coste", "es"},
		{SCT_TEXT, NULL, NULL, "Objetos de custo", "pt"},
		{SCT_TEXT, NULL, NULL, "Oggetti di costo", "it"}, {0}}},
	{"PointOfSales",{
		{SCT_TEXT, NULL, NULL, "Point of sales", "en"},
		{SCT_TEXT, NULL, NULL, "Försäljningsställe", "sv"},
		{SCT_TEXT, NULL, NULL, "Salgssted", "da"},
		{SCT_TEXT, NULL, NULL, "Salgssted", "no"},
		{SCT_TEXT, NULL, NULL, "Sölustaður", "is"},
		{SCT_TEXT, NULL, NULL, "Myyntipiste", "fi"},
		{SCT_TEXT, NULL, NULL, "Verkaufsstelle", "de"},
		{SCT_TEXT, NULL, NULL, "Verkooppunt", "nl"},
		{SCT_TEXT, NULL, NULL, "Point de vente", "fr"},
		{SCT_TEXT, NULL, NULL, "Punto de venta", "es"},
		{SCT_TEXT, NULL, NULL, "Ponto de venda", "pt"},
		{SCT_TEXT, NULL, NULL, "Punto di vendita", "it"}, {0}}},
	{"Branch",{
		{SCT_TEXT, NULL, NULL, "Branch", "en"},
		{SCT_TEXT, NULL, NULL, "Verksamhetsgren", "sv"},
		{SCT_TEXT, NULL, NULL, "Gren", "da"},
		{SCT_TEXT, NULL, NULL, "Avdeling", "no"},
		{SCT_TEXT, NULL, NULL, "Grein", "is"},
		{SCT_TEXT, NULL, NULL, "Yrityshaara", "fi"},
		{SCT_TEXT, NULL, NULL, "Zweig", "de"},
		{SCT_TEXT, NULL, NULL, "Vertakking", "nl"},
		{SCT_TEXT, NULL, NULL, "Branche", "fr"},
		{SCT_TEXT, NULL, NULL, "Rama", "es"},
		{SCT_TEXT, NULL, NULL, "Ramo", "pt"},
		{SCT_TEXT, NULL, NULL, "Ramo", "it"}, {0}}},
	{"Project",{
		{SCT_TEXT, NULL, NULL, "Project", "en"},
		{SCT_TEXT, NULL, NULL, "Projekt", "sv"},
		{SCT_TEXT, NULL, NULL, "Projekt", "da"},
		{SCT_TEXT, NULL, NULL, "Prosjekt", "no"},
		{SCT_TEXT, NULL, NULL, "Verkefni", "is"},
		{SCT_TEXT, NULL, NULL, "Projekti", "fi"},
		{SCT_TEXT, NULL, NULL, "Projekt", "de"},
		{SCT_TEXT, NULL, NULL, "Projecten", "nl"},
		{SCT_TEXT, NULL, NULL, "Projets", "fr"},
		{SCT_TEXT, NULL, NULL, "Proyectos", "es"},
		{SCT_TEXT, NULL, NULL, "Projetos", "pt"},
		{SCT_TEXT, NULL, NULL, "Progetti", "it"}, {0}}},
	{"Employee",{
		{SCT_TEXT, NULL, NULL, "Employee", "en"},
		{SCT_TEXT, NULL, NULL, "Anställd", "sv"},
		{SCT_TEXT, NULL, NULL, "Medarbejder", "da"},
		{SCT_TEXT, NULL, NULL, "Ansatt", "no"},
		{SCT_TEXT, NULL, NULL, "Starfsmaður", "is"},
		{SCT_TEXT, NULL, NULL, "Työntekijä", "fi"},
		{SCT_TEXT, NULL, NULL, "Mitarbeiter", "de"},
		{SCT_TEXT, NULL, NULL, "Werknemer", "nl"},
		{SCT_TEXT, NULL, NULL, "Employé", "fr"},
		{SCT_TEXT, NULL, NULL, "Empleado", "es"},
		{SCT_TEXT, NULL, NULL, "Empregado", "pt"},
		{SCT_TEXT, NULL, NULL, "Dipendente", "it"}, {0}}},
	{"Customer",{
		{SCT_TEXT, NULL, NULL, "Customer", "en"},
		{SCT_TEXT, NULL, NULL, "Kund", "sv"},
		{SCT_TEXT, NULL, NULL, "Kunde", "da"},
		{SCT_TEXT, NULL, NULL, "Kunde", "no"},
		{SCT_TEXT, NULL, NULL, "Viðskiptavinur", "is"},
		{SCT_TEXT, NULL, NULL, "Asiakas", "fi"},
		{SCT_TEXT, NULL, NULL, "Kunde", "de"},
		{SCT_TEXT, NULL, NULL, "Klant", "nl"},
		{SCT_TEXT, NULL, NULL, "Client", "fr"},
		{SCT_TEXT, NULL, NULL, "Cliente", "es"},
		{SCT_TEXT, NULL, NULL, "Cliente", "pt"},
		{SCT_TEXT, NULL, NULL, "Cliente", "it"}, {0}}},
	{"Supplier",{
		{SCT_TEXT, NULL, NULL, "Supplier", "en"},
		{SCT_TEXT, NULL, NULL, "Leverantör", "sv"},
		{SCT_TEXT, NULL, NULL, "Leverandør", "da"},
		{SCT_TEXT, NULL, NULL, "Leverandør", "no"},
		{SCT_TEXT, NULL, NULL, "Birgir", "is"},
		{SCT_TEXT, NULL, NULL, "Toimittaja", "fi"},
		{SCT_TEXT, NULL, NULL, "Lieferant", "de"},
		{SCT_TEXT, NULL, NULL, "Leverancier", "nl"},
		{SCT_TEXT, NULL, NULL, "Fournisseur", "fr"},
		{SCT_TEXT, NULL, NULL, "Distribuidor", "es"},
		{SCT_TEXT, NULL, NULL, "Prestador", "pt"},
		{SCT_TEXT, NULL, NULL, "Produttore", "it"}, {0}}},
	{"Invoice",{
		{SCT_TEXT, NULL, NULL, "Invoice", "en"},
		{SCT_TEXT, NULL, NULL, "Faktura", "sv"},
		{SCT_TEXT, NULL, NULL, "Faktura", "da"},
		{SCT_TEXT, NULL, NULL, "Faktura", "no"},
		{SCT_TEXT, NULL, NULL, "Reikningur", "is"},
		{SCT_TEXT, NULL, NULL, "Lasku", "fi"},
		{SCT_TEXT, NULL, NULL, "Rechnung", "de"},
		{SCT_TEXT, NULL, NULL, "Factuur", "nl"},
		{SCT_TEXT, NULL, NULL, "Facture", "fr"},
		{SCT_TEXT, NULL, NULL, "Factura", "es"},
		{SCT_TEXT, NULL, NULL, "Fatura", "pt"},
		{SCT_TEXT, NULL, NULL, "Fattura", "it"}, {0}}},
	{0}
};

EnumType EnumAmortisationScheduleType[]=
{
	{"Linear",{
		{SCT_TEXT, NULL, NULL, "Linear", "en"},
		{SCT_TEXT, NULL, NULL, "Linjär", "sv"},
		{SCT_TEXT, NULL, NULL, "Lineær", "da"},
		{SCT_TEXT, NULL, NULL, "Lineær", "no"},
		{SCT_TEXT, NULL, NULL, "Línuletur", "is"},
		{SCT_TEXT, NULL, NULL, "Suoraviivainen", "fi"},
		{SCT_TEXT, NULL, NULL, "Linear", "de"},
		{SCT_TEXT, NULL, NULL, "Lineair", "nl"},
		{SCT_TEXT, NULL, NULL, "Linéaire", "fr"},
		{SCT_TEXT, NULL, NULL, "Lineal", "es"},
		{SCT_TEXT, NULL, NULL, "Linear", "pt"},
		{SCT_TEXT, NULL, NULL, "Lineare", "it"}, {0}}},
	{"Declining",{
		{SCT_TEXT, NULL, NULL, "Declining", "en"},
		{SCT_TEXT, NULL, NULL, "Avtagande", "sv"},
		{SCT_TEXT, NULL, NULL, "Faldende", "da"},
		{SCT_TEXT, NULL, NULL, "Minkende", "no"},
		{SCT_TEXT, NULL, NULL, "Minnkandi", "is"},
		{SCT_TEXT, NULL, NULL, "Laskussa", "fi"},
		{SCT_TEXT, NULL, NULL, "Abnehmend", "de"},
		{SCT_TEXT, NULL, NULL, "Afnemende", "nl"},
		{SCT_TEXT, NULL, NULL, "Décroissant", "fr"},
		{SCT_TEXT, NULL, NULL, "Decreciente", "es"},
		{SCT_TEXT, NULL, NULL, "Diminuindo", "pt"},
		{SCT_TEXT, NULL, NULL, "Decrescente", "it"}, {0}}},
	{"Annuity",{
		{SCT_TEXT, NULL, NULL, "Annuity", "en"},
		{SCT_TEXT, NULL, NULL, "Annuitet", "sv"},
		{SCT_TEXT, NULL, NULL, "Annuitet", "da"},
		{SCT_TEXT, NULL, NULL, "Annuitet", "no"},
		{SCT_TEXT, NULL, NULL, "Annuitet", "is"},
		{SCT_TEXT, NULL, NULL, "Annuiteetti", "fi"},
		{SCT_TEXT, NULL, NULL, "Annuität", "de"},
		{SCT_TEXT, NULL, NULL, "Annuïteit", "nl"},
		{SCT_TEXT, NULL, NULL, "Annuité", "fr"},
		{SCT_TEXT, NULL, NULL, "Anualidad", "es"},
		{SCT_TEXT, NULL, NULL, "Anuidade", "pt"},
		{SCT_TEXT, NULL, NULL, "Annualità", "it"}, {0}}},
	{"Bullet",{
		{SCT_TEXT, NULL, NULL, "Bullet", "en"},
		{SCT_TEXT, NULL, NULL, "Engångs", "sv"},
		{SCT_TEXT, NULL, NULL, "Engang", "da"},
		{SCT_TEXT, NULL, NULL, "Engang", "no"},
		{SCT_TEXT, NULL, NULL, "Einnota", "is"},
		{SCT_TEXT, NULL, NULL, "Kertakäyttöiset", "fi"},
		{SCT_TEXT, NULL, NULL, "Einmal", "de"},
		{SCT_TEXT, NULL, NULL, "Eenmaal", "nl"},
		{SCT_TEXT, NULL, NULL, "Balle", "fr"},
		{SCT_TEXT, NULL, NULL, "Bala", "es"},
		{SCT_TEXT, NULL, NULL, "Bala", "pt"},
		{SCT_TEXT, NULL, NULL, "Proiettile", "it"}, {0}}},
	{"Balloon",{
		{SCT_TEXT, NULL, NULL, "Balloon", "en"},
		{SCT_TEXT, NULL, NULL, "Ballong", "sv"},
		{SCT_TEXT, NULL, NULL, "Ballon", "da"},
		{SCT_TEXT, NULL, NULL, "Ballong", "no"},
		{SCT_TEXT, NULL, NULL, "Loftbelgur", "is"},
		{SCT_TEXT, NULL, NULL, "Ilmapallo", "fi"},
		{SCT_TEXT, NULL, NULL, "Ballon", "de"},
		{SCT_TEXT, NULL, NULL, "Ballon", "nl"},
		{SCT_TEXT, NULL, NULL, "Ballon", "fr"},
		{SCT_TEXT, NULL, NULL, "Globo", "es"},
		{SCT_TEXT, NULL, NULL, "Balão", "pt"},
		{SCT_TEXT, NULL, NULL, "Palloncino", "it"}, {0}}},
	{"Increasing",{
		{SCT_TEXT, NULL, NULL, "Increasing", "en"},
		{SCT_TEXT, NULL, NULL, "Tilltagande", "sv"},
		{SCT_TEXT, NULL, NULL, "Stigend", "da"},
		{SCT_TEXT, NULL, NULL, "Økende", "no"},
		{SCT_TEXT, NULL, NULL, "Aukning", "is"},
		{SCT_TEXT, NULL, NULL, "Lisääntyvä", "fi"},
		{SCT_TEXT, NULL, NULL, "Zunehmend", "de"},
		{SCT_TEXT, NULL, NULL, "Toenemende", "nl"},
		{SCT_TEXT, NULL, NULL, "Croissant", "fr"},
		{SCT_TEXT, NULL, NULL, "Creciente", "es"},
		{SCT_TEXT, NULL, NULL, "Aumentando", "pt"},
		{SCT_TEXT, NULL, NULL, "Crescente", "it"}, {0}}},
	{0}
};

EnumType EnumDepreciationScheduleType[]=
{
	{"Linear",{
		{SCT_TEXT, NULL, NULL, "Linear", "en"},
		{SCT_TEXT, NULL, NULL, "Linjär", "sv"},
		{SCT_TEXT, NULL, NULL, "Lineær", "da"},
		{SCT_TEXT, NULL, NULL, "Lineær", "no"},
		{SCT_TEXT, NULL, NULL, "Línuletur", "is"},
		{SCT_TEXT, NULL, NULL, "Lineaarinen", "fi"},
		{SCT_TEXT, NULL, NULL, "Linear", "de"},
		{SCT_TEXT, NULL, NULL, "Lineair", "nl"},
		{SCT_TEXT, NULL, NULL, "Linéaire", "fr"},
		{SCT_TEXT, NULL, NULL, "Lineal", "es"},
		{SCT_TEXT, NULL, NULL, "Linear", "pt"},
		{SCT_TEXT, NULL, NULL, "Lineare", "it"}, {0}}},
	{"Double",{
		{SCT_TEXT, NULL, NULL, "Double", "en"},
		{SCT_TEXT, NULL, NULL, "Dubbel", "sv"},
		{SCT_TEXT, NULL, NULL, "Dobbel", "da"},
		{SCT_TEXT, NULL, NULL, "Dobbel", "no"},
		{SCT_TEXT, NULL, NULL, "Tvöfaldur", "is"},
		{SCT_TEXT, NULL, NULL, "Kaksinkertainen", "fi"},
		{SCT_TEXT, NULL, NULL, "Doppelt", "de"},
		{SCT_TEXT, NULL, NULL, "Dubbel", "nl"},
		{SCT_TEXT, NULL, NULL, "Double", "fr"},
		{SCT_TEXT, NULL, NULL, "Doble", "es"},
		{SCT_TEXT, NULL, NULL, "Duplo", "pt"},
		{SCT_TEXT, NULL, NULL, "Doppio", "it"}, {0}}},
	{"Annuity",{
		{SCT_TEXT, NULL, NULL, "Annuity", "en"},
		{SCT_TEXT, NULL, NULL, "Annuitet", "sv"},
		{SCT_TEXT, NULL, NULL, "Annuitet", "da"},
		{SCT_TEXT, NULL, NULL, "Annuitet", "no"},
		{SCT_TEXT, NULL, NULL, "Annuitet", "is"},
		{SCT_TEXT, NULL, NULL, "Annuiteetti", "fi"},
		{SCT_TEXT, NULL, NULL, "Annuität", "de"},
		{SCT_TEXT, NULL, NULL, "Annuïteit", "nl"},
		{SCT_TEXT, NULL, NULL, "Annuité", "fr"},
		{SCT_TEXT, NULL, NULL, "Anualidad", "es"},
		{SCT_TEXT, NULL, NULL, "Anuidade", "pt"},
		{SCT_TEXT, NULL, NULL, "Annualità", "it"}, {0}}},
	{"Years",{
		{SCT_TEXT, NULL, NULL, "Years", "en"},
		{SCT_TEXT, NULL, NULL, "År", "sv"},
		{SCT_TEXT, NULL, NULL, "År", "da"},
		{SCT_TEXT, NULL, NULL, "År", "no"},
		{SCT_TEXT, NULL, NULL, "Ár", "is"},
		{SCT_TEXT, NULL, NULL, "Vuosi", "fi"},
		{SCT_TEXT, NULL, NULL, "Jahre", "de"},
		{SCT_TEXT, NULL, NULL, "Jaar", "nl"},
		{SCT_TEXT, NULL, NULL, "Ans", "fr"},
		{SCT_TEXT, NULL, NULL, "Años", "es"},
		{SCT_TEXT, NULL, NULL, "Anos", "pt"},
		{SCT_TEXT, NULL, NULL, "Anni", "it"}, {0}}},
	{"Production",{
		{SCT_TEXT, NULL, NULL, "Production", "en"},
		{SCT_TEXT, NULL, NULL, "Produktion", "sv"},
		{SCT_TEXT, NULL, NULL, "Produktion", "da"},
		{SCT_TEXT, NULL, NULL, "Produksjon", "no"},
		{SCT_TEXT, NULL, NULL, "Framleiðsla", "is"},
		{SCT_TEXT, NULL, NULL, "Tuotanto", "fi"},
		{SCT_TEXT, NULL, NULL, "Produktion", "de"},
		{SCT_TEXT, NULL, NULL, "Productie", "nl"},
		{SCT_TEXT, NULL, NULL, "Production", "fr"},
		{SCT_TEXT, NULL, NULL, "Producción", "es"},
		{SCT_TEXT, NULL, NULL, "Produção", "pt"},
		{SCT_TEXT, NULL, NULL, "Produzione", "it"}, {0}}},
	{"Time",{
		{SCT_TEXT, NULL, NULL, "Time", "en"},
		{SCT_TEXT, NULL, NULL, "Tid", "sv"},
		{SCT_TEXT, NULL, NULL, "Tid", "da"},
		{SCT_TEXT, NULL, NULL, "Tid", "no"},
		{SCT_TEXT, NULL, NULL, "Tími", "is"},
		{SCT_TEXT, NULL, NULL, "Aika", "fi"},
		{SCT_TEXT, NULL, NULL, "Zeit", "de"},
		{SCT_TEXT, NULL, NULL, "Tijd", "nl"},
		{SCT_TEXT, NULL, NULL, "Temps", "fr"},
		{SCT_TEXT, NULL, NULL, "Tiempo", "es"},
		{SCT_TEXT, NULL, NULL, "Tempo", "pt"},
		{SCT_TEXT, NULL, NULL, "Tempo", "it"}, {0}}},
	{"Other",{
		{SCT_TEXT, NULL, NULL, "Other", "en"},
		{SCT_TEXT, NULL, NULL, "Annan", "sv"},
		{SCT_TEXT, NULL, NULL, "Andre", "da"},
		{SCT_TEXT, NULL, NULL, "Annen", "no"},
		{SCT_TEXT, NULL, NULL, "Annað", "is"},
		{SCT_TEXT, NULL, NULL, "Muut", "fi"},
		{SCT_TEXT, NULL, NULL, "Andere", "de"},
		{SCT_TEXT, NULL, NULL, "Anders", "nl"},
		{SCT_TEXT, NULL, NULL, "Autres", "fr"},
		{SCT_TEXT, NULL, NULL, "Otro", "es"},
		{SCT_TEXT, NULL, NULL, "Outro", "pt"},
		{SCT_TEXT, NULL, NULL, "Altro", "it"}, {0}}},
	{0}
};

EnumType EnumDepreciationPeriodsType[]=
{
	{"Annually",{
		{SCT_TEXT, NULL, NULL, "Annually", "en"},
		{SCT_TEXT, NULL, NULL, "Årligen", "sv"},
		{SCT_TEXT, NULL, NULL, "Årligt", "da"},
		{SCT_TEXT, NULL, NULL, "Årlig", "no"},
		{SCT_TEXT, NULL, NULL, "Árlega", "is"},
		{SCT_TEXT, NULL, NULL, "Vuosittain", "fi"},
		{SCT_TEXT, NULL, NULL, "Jährlich", "de"},
		{SCT_TEXT, NULL, NULL, "Jaarlijks", "nl"},
		{SCT_TEXT, NULL, NULL, "Annuellement", "fr"},
		{SCT_TEXT, NULL, NULL, "Anualmente", "es"},
		{SCT_TEXT, NULL, NULL, "Anualmente", "pt"},
		{SCT_TEXT, NULL, NULL, "Annualmente", "it"}, {0}}},
	{"Semiannually",{
		{SCT_TEXT, NULL, NULL, "Semiannually", "en"},
		{SCT_TEXT, NULL, NULL, "Halvårsvis", "sv"},
		{SCT_TEXT, NULL, NULL, "Halvårlige", "da"},
		{SCT_TEXT, NULL, NULL, "Halvårlig", "no"},
		{SCT_TEXT, NULL, NULL, "Hálfsárslega", "is"},
		{SCT_TEXT, NULL, NULL, "Puolivuosittain", "fi"},
		{SCT_TEXT, NULL, NULL, "Halbjährlich", "de"},
		{SCT_TEXT, NULL, NULL, "Halfjaarlijks", "nl"},
		{SCT_TEXT, NULL, NULL, "Semestriellement", "fr"},
		{SCT_TEXT, NULL, NULL, "Semestralmente", "es"},
		{SCT_TEXT, NULL, NULL, "Semestralmente", "pt"},
		{SCT_TEXT, NULL, NULL, "Semestralmente", "it"}, {0}}},
	{"Tertialy",{
		{SCT_TEXT, NULL, NULL, "Tertialy", "en"},
		{SCT_TEXT, NULL, NULL, "Tertiärsvis", "sv"},
		{SCT_TEXT, NULL, NULL, "Tertiærsvis", "da"},
		{SCT_TEXT, NULL, NULL, "Tertiærlig", "no"},
		{SCT_TEXT, NULL, NULL, "Tertíerslega", "is"},
		{SCT_TEXT, NULL, NULL, "Tertiäärinen", "fi"},
		{SCT_TEXT, NULL, NULL, "Tertiärlich", "de"},
		{SCT_TEXT, NULL, NULL, "Tertiairlijks", "nl"},
		{SCT_TEXT, NULL, NULL, "Tertiaire", "fr"},
		{SCT_TEXT, NULL, NULL, "Terciario", "es"},
		{SCT_TEXT, NULL, NULL, "Terciário", "pt"},
		{SCT_TEXT, NULL, NULL, "Terziario", "it"}, {0}}},
	{"Quarterly",{
		{SCT_TEXT, NULL, NULL, "Quarterly", "en"},
		{SCT_TEXT, NULL, NULL, "Kvartalsvis", "sv"},
		{SCT_TEXT, NULL, NULL, "Kvartalsvis", "da"},
		{SCT_TEXT, NULL, NULL, "Kvartalig", "no"},
		{SCT_TEXT, NULL, NULL, "Ársfjórðungslega", "is"},
		{SCT_TEXT, NULL, NULL, "Neljännesvuosittain", "fi"},
		{SCT_TEXT, NULL, NULL, "Vierteljährlich", "de"},
		{SCT_TEXT, NULL, NULL, "Driemaandelijks", "nl"},
		{SCT_TEXT, NULL, NULL, "Trimestriel", "fr"},
		{SCT_TEXT, NULL, NULL, "Trimestral", "es"},
		{SCT_TEXT, NULL, NULL, "Trimestral", "pt"},
		{SCT_TEXT, NULL, NULL, "Trimestrale", "it"}, {0}}},
	{"Monthly",{
		{SCT_TEXT, NULL, NULL, "Monthly", "en"},
		{SCT_TEXT, NULL, NULL, "Månatlig", "sv"},
		{SCT_TEXT, NULL, NULL, "Månedlige", "da"},
		{SCT_TEXT, NULL, NULL, "Månedlig", "no"},
		{SCT_TEXT, NULL, NULL, "Mánaðarlega", "is"},
		{SCT_TEXT, NULL, NULL, "Kuukausittain", "fi"},
		{SCT_TEXT, NULL, NULL, "Monatlich", "de"},
		{SCT_TEXT, NULL, NULL, "Maandelijks", "nl"},
		{SCT_TEXT, NULL, NULL, "Mensuel", "fr"},
		{SCT_TEXT, NULL, NULL, "Mensual", "es"},
		{SCT_TEXT, NULL, NULL, "Mensal", "pt"},
		{SCT_TEXT, NULL, NULL, "Mensile", "it"}, {0}}},
	{"Weekly",{
		{SCT_TEXT, NULL, NULL, "Weekly", "en"},
		{SCT_TEXT, NULL, NULL, "Veckovis", "sv"},
		{SCT_TEXT, NULL, NULL, "Ugentlig", "da"},
		{SCT_TEXT, NULL, NULL, "Ukentlig", "no"},
		{SCT_TEXT, NULL, NULL, "Vikulega", "is"},
		{SCT_TEXT, NULL, NULL, "Viikoittain", "fi"},
		{SCT_TEXT, NULL, NULL, "Wöchentlich", "de"},
		{SCT_TEXT, NULL, NULL, "Wekelijks", "nl"},
		{SCT_TEXT, NULL, NULL, "Hebdomadaire", "fr"},
		{SCT_TEXT, NULL, NULL, "Semanal", "es"},
		{SCT_TEXT, NULL, NULL, "Semanal", "pt"},
		{SCT_TEXT, NULL, NULL, "Settimanale", "it"}, {0}}},
	{"Dayly",{
		{SCT_TEXT, NULL, NULL, "Dayly", "en"},
		{SCT_TEXT, NULL, NULL, "Dagligen", "sv"},
		{SCT_TEXT, NULL, NULL, "Daglig", "da"},
		{SCT_TEXT, NULL, NULL, "Daglig", "no"},
		{SCT_TEXT, NULL, NULL, "Daglega", "is"},
		{SCT_TEXT, NULL, NULL, "Päivittäin", "fi"},
		{SCT_TEXT, NULL, NULL, "Täglich", "de"},
		{SCT_TEXT, NULL, NULL, "Dagelijks", "nl"},
		{SCT_TEXT, NULL, NULL, "Quotidien", "fr"},
		{SCT_TEXT, NULL, NULL, "Diario", "es"},
		{SCT_TEXT, NULL, NULL, "Diariamente", "pt"},
		{SCT_TEXT, NULL, NULL, "Quotidiano", "it"}, {0}}},
	{0}
};

EnumType EnumInvoiceTypeType[]=
{
	{"Simple",{
		{SCT_TEXT, NULL, NULL, "Simple", "en"},
		{SCT_TEXT, NULL, NULL, "Förenklad", "sv"},
		{SCT_TEXT, NULL, NULL, "Forenklet", "da"},
		{SCT_TEXT, NULL, NULL, "Forenklet", "no"},
		{SCT_TEXT, NULL, NULL, "Einfalt", "is"},
		{SCT_TEXT, NULL, NULL, "Yksinkertainen", "fi"},
		{SCT_TEXT, NULL, NULL, "Vereinfachten", "de"},
		{SCT_TEXT, NULL, NULL, "Eenvoudig", "nl"},
		{SCT_TEXT, NULL, NULL, "Simplifiées", "fr"},
		{SCT_TEXT, NULL, NULL, "Simplificadas", "es"},
		{SCT_TEXT, NULL, NULL, "Simplificada", "pt"},
		{SCT_TEXT, NULL, NULL, "Semplificate", "it"}, {0}}},
	{"Receipt",{
		{SCT_TEXT, NULL, NULL, "Receipt", "en"},
		{SCT_TEXT, NULL, NULL, "Kvitto", "sv"},
		{SCT_TEXT, NULL, NULL, "Kvittering", "da"},
		{SCT_TEXT, NULL, NULL, "Kvittering", "no"},
		{SCT_TEXT, NULL, NULL, "Kvittun", "is"},
		{SCT_TEXT, NULL, NULL, "Kuitti", "fi"},
		{SCT_TEXT, NULL, NULL, "Quittung", "de"},
		{SCT_TEXT, NULL, NULL, "Ontvangst", "nl"},
		{SCT_TEXT, NULL, NULL, "Encaissement", "fr"},
		{SCT_TEXT, NULL, NULL, "Recibo", "es"},
		{SCT_TEXT, NULL, NULL, "Recibo", "pt"},
		{SCT_TEXT, NULL, NULL, "Ricevuta", "it"}, {0}}},
	{"Invoice",{
		{SCT_TEXT, NULL, NULL, "Invoice", "en"},
		{SCT_TEXT, NULL, NULL, "Faktura", "sv"},
		{SCT_TEXT, NULL, NULL, "Faktura", "da"},
		{SCT_TEXT, NULL, NULL, "Faktura", "no"},
		{SCT_TEXT, NULL, NULL, "Reikningur", "is"},
		{SCT_TEXT, NULL, NULL, "Lasku", "fi"},
		{SCT_TEXT, NULL, NULL, "Rechnung", "de"},
		{SCT_TEXT, NULL, NULL, "Factuur", "nl"},
		{SCT_TEXT, NULL, NULL, "Facture", "fr"},
		{SCT_TEXT, NULL, NULL, "Factura", "es"},
		{SCT_TEXT, NULL, NULL, "Fatura", "pt"},
		{SCT_TEXT, NULL, NULL, "Fattura", "it"}, {0}}},
	{"Factoring",{
		{SCT_TEXT, NULL, NULL, "Invoice factoring", "en"},
		{SCT_TEXT, NULL, NULL, "Faktura factoring", "sv"},
		{SCT_TEXT, NULL, NULL, "Faktura factoring", "da"},
		{SCT_TEXT, NULL, NULL, "Faktura factoring", "no"},
		{SCT_TEXT, NULL, NULL, "Reikningur factoring", "is"},
		{SCT_TEXT, NULL, NULL, "Laskujen factoring", "fi"},
		{SCT_TEXT, NULL, NULL, "Rechnung factoring", "de"},
		{SCT_TEXT, NULL, NULL, "Factuur factoring", "nl"},
		{SCT_TEXT, NULL, NULL, "Facture factoring", "fr"},
		{SCT_TEXT, NULL, NULL, "Factura factoring", "es"},
		{SCT_TEXT, NULL, NULL, "Fatura factoring", "pt"},
		{SCT_TEXT, NULL, NULL, "Fatture factoring", "it"}, {0}}},
	{"Credit",{
		{SCT_TEXT, NULL, NULL, "Invoice credit note", "en"},
		{SCT_TEXT, NULL, NULL, "Kreditfaktura", "sv"},
		{SCT_TEXT, NULL, NULL, "Kreditnote", "da"},
		{SCT_TEXT, NULL, NULL, "Kredittnota", "no"},
		{SCT_TEXT, NULL, NULL, "Kreditnóta", "is"},
		{SCT_TEXT, NULL, NULL, "Hyvityslasku", "fi"},
		{SCT_TEXT, NULL, NULL, "Gutschrift", "de"},
		{SCT_TEXT, NULL, NULL, "Creditnota", "nl"},
		{SCT_TEXT, NULL, NULL, "Crédit de facture", "fr"},
		{SCT_TEXT, NULL, NULL, "Factura de crédito", "es"},
		{SCT_TEXT, NULL, NULL, "Crédito de fatura", "pt"},
		{SCT_TEXT, NULL, NULL, "Credito della fattura", "it"}, {0}}},
	{"Reminder",{
		{SCT_TEXT, NULL, NULL, "Invoice reminder", "en"},
		{SCT_TEXT, NULL, NULL, "Påminnelsekrav", "sv"},
		{SCT_TEXT, NULL, NULL, "Faktura indkaldelse", "da"},
		{SCT_TEXT, NULL, NULL, "Faktura påminnelse", "no"},
		{SCT_TEXT, NULL, NULL, "Reikningasímtal", "is"},
		{SCT_TEXT, NULL, NULL, "Muistutus vaatimukset", "fi"},
		{SCT_TEXT, NULL, NULL, "Rechnung Anruf", "de"},
		{SCT_TEXT, NULL, NULL, "Factuuroproep", "nl"},
		{SCT_TEXT, NULL, NULL, "Appel facture", "fr"},
		{SCT_TEXT, NULL, NULL, "Aviso de factura", "es"},
		{SCT_TEXT, NULL, NULL, "Aviso de fatura", "pt"},
		{SCT_TEXT, NULL, NULL, "Solleciti con fattura", "it"}, {0}}},
	{"Collection",{
		{SCT_TEXT, NULL, NULL, "Invoice collection", "en"},
		{SCT_TEXT, NULL, NULL, "Inkassokrav", "sv"},
		{SCT_TEXT, NULL, NULL, "Faktura indsamling", "da"},
		{SCT_TEXT, NULL, NULL, "Faktura innsamling", "no"},
		{SCT_TEXT, NULL, NULL, "Reikningasafn", "is"},
		{SCT_TEXT, NULL, NULL, "Perintätoimisto vaatimukset", "fi"},
		{SCT_TEXT, NULL, NULL, "Rechnung Sammlung", "de"},
		{SCT_TEXT, NULL, NULL, "Factuur collectie", "nl"},
		{SCT_TEXT, NULL, NULL, "Collection facture", "fr"},
		{SCT_TEXT, NULL, NULL, "Colección factura", "es"},
		{SCT_TEXT, NULL, NULL, "Coleção de fatura", "pt"},
		{SCT_TEXT, NULL, NULL, "Collezione di fattur", "it"}, {0}}},
	{"Bailiff",{
		{SCT_TEXT, NULL, NULL, "Distraint", "en"},
		{SCT_TEXT, NULL, NULL, "Kronofogdekrav", "sv"},
		{SCT_TEXT, NULL, NULL, "Beslaglæggelse", "da"},
		{SCT_TEXT, NULL, NULL, "Beslag", "no"},
		{SCT_TEXT, NULL, NULL, "Hald", "is"},
		{SCT_TEXT, NULL, NULL, "Ulosotto", "fi"},
		{SCT_TEXT, NULL, NULL, "Pfändung", "de"},
		{SCT_TEXT, NULL, NULL, "Beslag", "nl"},
		{SCT_TEXT, NULL, NULL, "Saisie", "fr"},
		{SCT_TEXT, NULL, NULL, "Embargo", "es"},
		{SCT_TEXT, NULL, NULL, "Confiscação", "pt"},
		{SCT_TEXT, NULL, NULL, "Pignoramento", "it"}, {0}}},
	{"SelfDebit",{
		{SCT_TEXT, NULL, NULL, "Self-billing", "en"},
		{SCT_TEXT, NULL, NULL, "Självfaktura", "sv"},
		{SCT_TEXT, NULL, NULL, "Selvfakturering", "da"},
		{SCT_TEXT, NULL, NULL, "Selvfaktura", "no"},
		{SCT_TEXT, NULL, NULL, "Sjálfreikningur", "is"},
		{SCT_TEXT, NULL, NULL, "Itselaskutus", "fi"},
		{SCT_TEXT, NULL, NULL, "Gutschriften", "de"},
		{SCT_TEXT, NULL, NULL, "Self-billing", "nl"},
		{SCT_TEXT, NULL, NULL, "Autofacturation", "fr"},
		{SCT_TEXT, NULL, NULL, "Facturación por el destinatario", "es"},
		{SCT_TEXT, NULL, NULL, "Autofacturação", "pt"},
		{SCT_TEXT, NULL, NULL, "Autofatturazione", "it"}, {0}}},
	{"SelfCredit",{
		{SCT_TEXT, NULL, NULL, "Self billed invoice credit note", "en"},
		{SCT_TEXT, NULL, NULL, "Självkreditfaktura", "sv"},
		{SCT_TEXT, NULL, NULL, "Selvkreditnota", "da"},
		{SCT_TEXT, NULL, NULL, "Selvkredittnota", "no"},
		{SCT_TEXT, NULL, NULL, "Sjálfkreditnóta", "is"},
		{SCT_TEXT, NULL, NULL, "Luotto itselaskutus", "fi"},
		{SCT_TEXT, NULL, NULL, "Eigengutschrift", "de"},
		{SCT_TEXT, NULL, NULL, "Self-billing creditnota", "nl"},
		{SCT_TEXT, NULL, NULL, "Autofacturation crédit", "fr"},
		{SCT_TEXT, NULL, NULL, "Crédito por el destinatario", "es"},
		{SCT_TEXT, NULL, NULL, "Crédito Autofacturação", "pt"},
		{SCT_TEXT, NULL, NULL, "Autofatturazione credito", "it"}, {0}}},
	{"Salary",{
		{SCT_TEXT, NULL, NULL, "Salary/Reimbursement statement, Self-billed", "en"},
		{SCT_TEXT, NULL, NULL, "Lön/ersättning, Självfaktura", "sv"},
		{SCT_TEXT, NULL, NULL, "Løn/refusion, selvfaktura", "da"},
		{SCT_TEXT, NULL, NULL, "Lønn/refusjon, selvregning", "no"},
		{SCT_TEXT, NULL, NULL, "Laun/uppbót, sjálfreikningur", "is"},
		{SCT_TEXT, NULL, NULL, "Palkka/hyvitys, itselaskutus", "fi"},
		{SCT_TEXT, NULL, NULL, "Gehalt/Rückerstattung, Eigenrechnung", "de"},
		{SCT_TEXT, NULL, NULL, "Salaris/terugbetaling, eigen factuur", "nl"},
		{SCT_TEXT, NULL, NULL, "Salaire/remboursement, propre facture", "fr"},
		{SCT_TEXT, NULL, NULL, "Salario/reembolso, factura propia", "es"},
		{SCT_TEXT, NULL, NULL, "Salário/remuneração, fatura própria", "pt"},
		{SCT_TEXT, NULL, NULL, "Salario/rimborso, fattura propria", "it"}, {0}}},
	{"Reimbursement",{
		{SCT_TEXT, NULL, NULL, "Reimbursement", "en"},
		{SCT_TEXT, NULL, NULL, "Ersättning", "sv"},
		{SCT_TEXT, NULL, NULL, "Refusion", "da"},
		{SCT_TEXT, NULL, NULL, "Refusjong", "no"},
		{SCT_TEXT, NULL, NULL, "Endurgreiðsla", "is"},
		{SCT_TEXT, NULL, NULL, "Korvaus", "fi"},
		{SCT_TEXT, NULL, NULL, "Rückerstattung", "de"},
		{SCT_TEXT, NULL, NULL, "Vergoeding", "nl"},
		{SCT_TEXT, NULL, NULL, "Remboursement", "fr"},
		{SCT_TEXT, NULL, NULL, "Reembolso", "es"},
		{SCT_TEXT, NULL, NULL, "Reembolso", "pt"},
		{SCT_TEXT, NULL, NULL, "Rimborso", "it"}, {0}}},
	{"PayOrder",{
		{SCT_TEXT, NULL, NULL, "Pay order", "en"},
		{SCT_TEXT, NULL, NULL, "Betalorder", "sv"},
		{SCT_TEXT, NULL, NULL, "Betalingsordre", "da"},
		{SCT_TEXT, NULL, NULL, "Betalingsordre", "no"},
		{SCT_TEXT, NULL, NULL, "Greiðslufyrirmæli", "is"},
		{SCT_TEXT, NULL, NULL, "Maksumääräyksen", "fi"},
		{SCT_TEXT, NULL, NULL, "Zahlungsauftrag", "de"},
		{SCT_TEXT, NULL, NULL, "Betalingsopdracht", "nl"},
		{SCT_TEXT, NULL, NULL, "Ordre de paiement", "fr"},
		{SCT_TEXT, NULL, NULL, "Orden de pago", "es"},
		{SCT_TEXT, NULL, NULL, "Ordem de pagamento", "pt"},
		{SCT_TEXT, NULL, NULL, "Ordine di pagamento", "it"}, {0}}},
	{"VAT",{
		{SCT_TEXT, NULL, NULL, "VAT declaration, Self billed invoice", "en"},
		{SCT_TEXT, NULL, NULL, "Momsdeklaration, Självfaktura", "sv"},
		{SCT_TEXT, NULL, NULL, "Momsangivelse, selvfakturering", "da"},
		{SCT_TEXT, NULL, NULL, "MVA-erklæring, selvregning", "no"},
		{SCT_TEXT, NULL, NULL, "VSK-yfirlýsing, sjálfreikningur", "is"},
		{SCT_TEXT, NULL, NULL, "Arvonlisäveroilmoitus, itselaskutus", "fi"},
		{SCT_TEXT, NULL, NULL, "MwSt-Erklärung, Eigenrechnung", "de"},
		{SCT_TEXT, NULL, NULL, "BTW-aangifte, eigen factuur", "nl"},
		{SCT_TEXT, NULL, NULL, "Déclaration de TVA, propre facture", "fr"},
		{SCT_TEXT, NULL, NULL, "Devolución del IVA, factura propia", "es"},
		{SCT_TEXT, NULL, NULL, "Declaração de IVA, fatura própria", "pt"},
		{SCT_TEXT, NULL, NULL, "Dichiarazione IVA, fattura propria", "it"}, {0}}},
	{"PayrollTax",{
		{SCT_TEXT, NULL, NULL, "Payroll tax declaration, Self billed invoice", "en"},
		{SCT_TEXT, NULL, NULL, "Arbetsgivaravgiftsdeklaration, Självfaktura", "sv"},
		{SCT_TEXT, NULL, NULL, "Arbejdsgiverens erklæring, selvfaktura", "da"},
		{SCT_TEXT, NULL, NULL, "arbeidsgiveravgiftdeklarasjon, selvregning", "no"},
		{SCT_TEXT, NULL, NULL, "Yfirlýsing vinnuveitanda, sjálfreikningur", "is"},
		{SCT_TEXT, NULL, NULL, "Palkkasummailmoitus, itselaskutus", "fi"},
		{SCT_TEXT, NULL, NULL, "Erklärung des Lohnsteuer, Eigenrechnung", "de"},
		{SCT_TEXT, NULL, NULL, "Verklaring van loonbelasting, eigen factuur", "nl"},
		{SCT_TEXT, NULL, NULL, "Explication de taxes sur les salaires, propre facture", "fr"},
		{SCT_TEXT, NULL, NULL, "Explicación del impuestos de nómina, factura propia", "es"},
		{SCT_TEXT, NULL, NULL, "Explicação do impostos sobre folha de pagamento, fatura própria", "pt"},
		{SCT_TEXT, NULL, NULL, "Spiegazione del imposta sulle retribuzioni, fattura propria", "it"}, {0}}},
	{"INC",{
		{SCT_TEXT, NULL, NULL, "Income Tax declaration, Self billed invoice", "en"},
		{SCT_TEXT, NULL, NULL, "Inkomstskattedeklaration, Självfaktura", "sv"},
		{SCT_TEXT, NULL, NULL, "Selvangivelse, selvfaktura", "da"},
		{SCT_TEXT, NULL, NULL, "Inntektsskatt, selvregning", "no"},
		{SCT_TEXT, NULL, NULL, "Tekjuskattur, sjálfreikningur", "is"},
		{SCT_TEXT, NULL, NULL, "Tuloverolain ilmoitus, itselaskutus", "fi"},
		{SCT_TEXT, NULL, NULL, "Einkommensteuererklärung, Eigenrechnung", "de"},
		{SCT_TEXT, NULL, NULL, "Inkomstenbelastingangifte, eigen factuur", "nl"},
		{SCT_TEXT, NULL, NULL, "Déclaration de revenus, propre facture", "fr"},
		{SCT_TEXT, NULL, NULL, "Declaración de ingresos, factura propia", "es"},
		{SCT_TEXT, NULL, NULL, "Declaração de rendimento, factura própria", "pt"},
		{SCT_TEXT, NULL, NULL, "Dichiarazione di reddito, fattura propria", "it"}, {0}}},
	{"TAX",{
		{SCT_TEXT, NULL, NULL, "Tax declaration, Self billed invoice", "en"},
		{SCT_TEXT, NULL, NULL, "Skattedeklaration, Självfaktura", "sv"},
		{SCT_TEXT, NULL, NULL, "Skatteangivelse, selvfaktura", "da"},
		{SCT_TEXT, NULL, NULL, "Skatteanmeldelse, selvregning", "no"},
		{SCT_TEXT, NULL, NULL, "Skattframtal, sjálfreikningur", "is"},
		{SCT_TEXT, NULL, NULL, "Veroilmoitus, itselaskutus", "fi"},
		{SCT_TEXT, NULL, NULL, "Steuererklärung, Eigenrechnung", "de"},
		{SCT_TEXT, NULL, NULL, "Belastingaangifte, eigen factuur", "nl"},
		{SCT_TEXT, NULL, NULL, "Déclaration de tax, propre facture", "fr"},
		{SCT_TEXT, NULL, NULL, "Declaración de impuestos, factura propia", "es"},
		{SCT_TEXT, NULL, NULL, "Declaração de imposto, fatura própria", "pt"},
		{SCT_TEXT, NULL, NULL, "Dichiarazione fiscale, fattura propria", "it"}, {0}}},
	{"BankStatements",{
		{SCT_TEXT, NULL, NULL, "Bank Statement", "en"},
		{SCT_TEXT, NULL, NULL, "Bankkontoutdrag", "sv"},
		{SCT_TEXT, NULL, NULL, "Kontoudtog", "da"},
		{SCT_TEXT, NULL, NULL, "Kontoutskrift", "no"},
		{SCT_TEXT, NULL, NULL, "Bankayfirlit", "is"},
		{SCT_TEXT, NULL, NULL, "Pankkitiliote", "fi"},
		{SCT_TEXT, NULL, NULL, "Bankkontoauszug", "de"},
		{SCT_TEXT, NULL, NULL, "Bankafschrift", "nl"},
		{SCT_TEXT, NULL, NULL, "Déclaration bancaire", "fr"},
		{SCT_TEXT, NULL, NULL, "Extracto bancario", "es"},
		{SCT_TEXT, NULL, NULL, "Extrato bancário", "pt"},
		{SCT_TEXT, NULL, NULL, "Estratto conto bancario", "it"}, {0}}},
	{"Clearing",{
		{SCT_TEXT, NULL, NULL, "Clearing statement", "en"},
		{SCT_TEXT, NULL, NULL, "Avräkning", "sv"},
		{SCT_TEXT, NULL, NULL, "Afregningutdrag", "da"},
		{SCT_TEXT, NULL, NULL, "Oppgjørutskrift", "no"},
		{SCT_TEXT, NULL, NULL, "Hreinsa reikning", "is"},
		{SCT_TEXT, NULL, NULL, "Selvityslausunto", "fi"},
		{SCT_TEXT, NULL, NULL, "Clearing-Anweisung", "de"},
		{SCT_TEXT, NULL, NULL, "Clearing Verklaring", "nl"},
		{SCT_TEXT, NULL, NULL, "Déclaration de compensation", "fr"},
		{SCT_TEXT, NULL, NULL, "Extracto de compensación", "es"},
		{SCT_TEXT, NULL, NULL, "Extrato de compensação", "pt"},
		{SCT_TEXT, NULL, NULL, "Estratto di compensazione", "it"}, {0}}},
	{"PriceList",{
		{SCT_TEXT, NULL, NULL, "Price List", "en"},
		{SCT_TEXT, NULL, NULL, "Prislista", "sv"},
		{SCT_TEXT, NULL, NULL, "Prisliste", "da"},
		{SCT_TEXT, NULL, NULL, "Prisliste", "no"},
		{SCT_TEXT, NULL, NULL, "Verðlisti", "is"},
		{SCT_TEXT, NULL, NULL, "Hinnasto", "fi"},
		{SCT_TEXT, NULL, NULL, "Preisliste", "de"},
		{SCT_TEXT, NULL, NULL, "Prijslijst", "nl"},
		{SCT_TEXT, NULL, NULL, "Liste des prix", "fr"},
		{SCT_TEXT, NULL, NULL, "Lista de precios", "es"},
		{SCT_TEXT, NULL, NULL, "Lista de preços", "pt"},
		{SCT_TEXT, NULL, NULL, "Listino prezzi", "it"}, {0}}},
	{"Tender",{
		{SCT_TEXT, NULL, NULL, "Tender inquiry", "en"},
		{SCT_TEXT, NULL, NULL, "Offertförfrågan", "sv"},
		{SCT_TEXT, NULL, NULL, "Tilbudsanmodning", "da"},
		{SCT_TEXT, NULL, NULL, "Tilbudsforespørsel", "no"},
		{SCT_TEXT, NULL, NULL, "Tilboðsbeiðni", "is"},
		{SCT_TEXT, NULL, NULL, "Tarjousten pyytäminen", "fi"},
		{SCT_TEXT, NULL, NULL, "Angebotsanfrage", "de"},
		{SCT_TEXT, NULL, NULL, "Offerte aanvraag", "nl"},
		{SCT_TEXT, NULL, NULL, "Demande d'offre", "fr"},
		{SCT_TEXT, NULL, NULL, "Solicitud de oferta", "es"},
		{SCT_TEXT, NULL, NULL, "Pedido de oferta", "pt"},
		{SCT_TEXT, NULL, NULL, "Richiesta di offerta", "it"}, {0}}},
	{"Offer",{
		{SCT_TEXT, NULL, NULL, "Quote", "en"},
		{SCT_TEXT, NULL, NULL, "Offert", "sv"},
		{SCT_TEXT, NULL, NULL, "Tilbud", "da"},
		{SCT_TEXT, NULL, NULL, "Tilbud", "no"},
		{SCT_TEXT, NULL, NULL, "Tilboð", "is"},
		{SCT_TEXT, NULL, NULL, "Tarjous", "fi"},
		{SCT_TEXT, NULL, NULL, "Angebote", "de"},
		{SCT_TEXT, NULL, NULL, "Offerte", "nl"},
		{SCT_TEXT, NULL, NULL, "Devis", "fr"},
		{SCT_TEXT, NULL, NULL, "Oferta", "es"},
		{SCT_TEXT, NULL, NULL, "Proposta", "pt"},
		{SCT_TEXT, NULL, NULL, "Offerta", "it"}, {0}}},
	{"Order",{
		{SCT_TEXT, NULL, NULL, "Order of purchase", "en"},
		{SCT_TEXT, NULL, NULL, "Beställning", "sv"},
		{SCT_TEXT, NULL, NULL, "Bestilling", "da"},
		{SCT_TEXT, NULL, NULL, "Bestilling", "no"},
		{SCT_TEXT, NULL, NULL, "Pöntun", "is"},
		{SCT_TEXT, NULL, NULL, "Ostotilaukset", "fi"},
		{SCT_TEXT, NULL, NULL, "Bestellung", "de"},
		{SCT_TEXT, NULL, NULL, "Order", "nl"},
		{SCT_TEXT, NULL, NULL, "Commande", "fr"},
		{SCT_TEXT, NULL, NULL, "Pedido", "es"},
		{SCT_TEXT, NULL, NULL, "Encomenda", "pt"},
		{SCT_TEXT, NULL, NULL, "Ordine", "it"}, {0}}},
	{"Response",{
		{SCT_TEXT, NULL, NULL, "Order confirmation", "en"},
		{SCT_TEXT, NULL, NULL, "Ordererkännande", "sv"},
		{SCT_TEXT, NULL, NULL, "Ordrebekræftelse", "da"},
		{SCT_TEXT, NULL, NULL, "Ordrebekreftelse", "no"},
		{SCT_TEXT, NULL, NULL, "Pöntunarstaðfesting", "is"},
		{SCT_TEXT, NULL, NULL, "Tilausvahvistus", "fi"},
		{SCT_TEXT, NULL, NULL, "Bestellbestätigung", "de"},
		{SCT_TEXT, NULL, NULL, "Orderbevestiging", "nl"},
		{SCT_TEXT, NULL, NULL, "Confirmation de commande", "fr"},
		{SCT_TEXT, NULL, NULL, "Confirmación pedido", "es"},
		{SCT_TEXT, NULL, NULL, "Confirmação Encomenda", "pt"},
		{SCT_TEXT, NULL, NULL, "Conferma dell'ordine", "it"}, {0}}},
	{"Contract",{
		{SCT_TEXT, NULL, NULL, "Contract", "en"},
		{SCT_TEXT, NULL, NULL, "Kontrakt", "sv"},
		{SCT_TEXT, NULL, NULL, "Kontrakt", "da"},
		{SCT_TEXT, NULL, NULL, "Kontrakt", "no"},
		{SCT_TEXT, NULL, NULL, "Samningur", "is"},
		{SCT_TEXT, NULL, NULL, "Sopimus", "fi"},
		{SCT_TEXT, NULL, NULL, "Vertrag", "de"},
		{SCT_TEXT, NULL, NULL, "Contract", "nl"},
		{SCT_TEXT, NULL, NULL, "Contrat", "fr"},
		{SCT_TEXT, NULL, NULL, "Contrato", "es"},
		{SCT_TEXT, NULL, NULL, "Contrato", "pt"},
		{SCT_TEXT, NULL, NULL, "Contrarre", "it"}, {0}}},
	{"Proforma",{
		{SCT_TEXT, NULL, NULL, "Proforma", "en"},
		{SCT_TEXT, NULL, NULL, "Proforma", "sv"},
		{SCT_TEXT, NULL, NULL, "Proforma", "da"},
		{SCT_TEXT, NULL, NULL, "Proforma", "no"},
		{SCT_TEXT, NULL, NULL, "Proforma", "is"},
		{SCT_TEXT, NULL, NULL, "Proforma", "fi"},
		{SCT_TEXT, NULL, NULL, "Proforma", "de"},
		{SCT_TEXT, NULL, NULL, "Proforma", "nl"},
		{SCT_TEXT, NULL, NULL, "Proforma", "fr"},
		{SCT_TEXT, NULL, NULL, "Proforma", "es"},
		{SCT_TEXT, NULL, NULL, "Proforma", "pt"},
		{SCT_TEXT, NULL, NULL, "Proforma", "it"}, {0}}},
	{"Depreciation",{
		{SCT_TEXT, NULL, NULL, "Depreciation", "en"},
		{SCT_TEXT, NULL, NULL, "Avskrivning", "sv"},
		{SCT_TEXT, NULL, NULL, "Afskrivning", "da"},
		{SCT_TEXT, NULL, NULL, "Avskrivning", "no"},
		{SCT_TEXT, NULL, NULL, "Afskriftir", "is"},
		{SCT_TEXT, NULL, NULL, "Poisto", "fi"},
		{SCT_TEXT, NULL, NULL, "Abschreibung", "de"},
		{SCT_TEXT, NULL, NULL, "Afschrijving", "nl"},
		{SCT_TEXT, NULL, NULL, "Amortissement", "fr"},
		{SCT_TEXT, NULL, NULL, "Depreciación", "es"},
		{SCT_TEXT, NULL, NULL, "Depreciação", "pt"},
		{SCT_TEXT, NULL, NULL, "Ammortamento", "it"}, {0}}},
	{"Note",{
		{SCT_TEXT, NULL, NULL, "Note", "en"},
		{SCT_TEXT, NULL, NULL, "Not", "sv"},
		{SCT_TEXT, NULL, NULL, "Nota", "da"},
		{SCT_TEXT, NULL, NULL, "Nota", "no"},
		{SCT_TEXT, NULL, NULL, "Nota", "is"},
		{SCT_TEXT, NULL, NULL, "Huomautus", "fi"},
		{SCT_TEXT, NULL, NULL, "Nota", "de"},
		{SCT_TEXT, NULL, NULL, "Nota", "nl"},
		{SCT_TEXT, NULL, NULL, "Note", "fr"},
		{SCT_TEXT, NULL, NULL, "Nota", "es"},
		{SCT_TEXT, NULL, NULL, "Nota", "pt"},
		{SCT_TEXT, NULL, NULL, "Nota", "it"}, {0}}},
	{0}
};

EnumType EnumVatReducedType[]=
{
	{"0",{
		{SCT_TEXT, NULL, NULL, "Exemption", "en"},
		{SCT_TEXT, NULL, NULL, "Undantaget", "sv"},
		{SCT_TEXT, NULL, NULL, "Fritaget", "da"},
		{SCT_TEXT, NULL, NULL, "Fritatt", "no"},
		{SCT_TEXT, NULL, NULL, "Undanþegnir", "is"},
		{SCT_TEXT, NULL, NULL, "Vapautusta", "fi"},
		{SCT_TEXT, NULL, NULL, "Befreit", "de"},
		{SCT_TEXT, NULL, NULL, "Vrijstelling", "nl"},
		{SCT_TEXT, NULL, NULL, "Exonération", "fr"},
		{SCT_TEXT, NULL, NULL, "Exenciones", "es"},
		{SCT_TEXT, NULL, NULL, "Isenções", "pt"},
		{SCT_TEXT, NULL, NULL, "Esenzioni", "it"}, {0}}},
	{"1",{
		{SCT_TEXT, NULL, NULL, "Reduced 1", "en"},
		{SCT_TEXT, NULL, NULL, "Reducerad 1", "sv"},
		{SCT_TEXT, NULL, NULL, "Reduceret 1", "da"},
		{SCT_TEXT, NULL, NULL, "Redusert 1", "no"},
		{SCT_TEXT, NULL, NULL, "Minnkað 1", "is"},
		{SCT_TEXT, NULL, NULL, "Alennettua 1", "fi"},
		{SCT_TEXT, NULL, NULL, "Ermäßigten 1", "de"},
		{SCT_TEXT, NULL, NULL, "Verlaagde 1", "nl"},
		{SCT_TEXT, NULL, NULL, "Réduit 1", "fr"},
		{SCT_TEXT, NULL, NULL, "Reducido 1", "es"},
		{SCT_TEXT, NULL, NULL, "Reduzido 1", "pt"},
		{SCT_TEXT, NULL, NULL, "Ridotto 1", "it"}, {0}}},
	{"2",{
		{SCT_TEXT, NULL, NULL, "Reduced 2", "en"},
		{SCT_TEXT, NULL, NULL, "Reducerad 2", "sv"},
		{SCT_TEXT, NULL, NULL, "Reduceret 2", "da"},
		{SCT_TEXT, NULL, NULL, "Redusert 2", "no"},
		{SCT_TEXT, NULL, NULL, "Minnkað 2", "is"},
		{SCT_TEXT, NULL, NULL, "Alennettua 2", "fi"},
		{SCT_TEXT, NULL, NULL, "Ermäßigten 2", "de"},
		{SCT_TEXT, NULL, NULL, "Verlaagde 2", "nl"},
		{SCT_TEXT, NULL, NULL, "Réduit 2", "fr"},
		{SCT_TEXT, NULL, NULL, "Reducido 2", "es"},
		{SCT_TEXT, NULL, NULL, "Reduzido 2", "pt"},
		{SCT_TEXT, NULL, NULL, "Ridotto 2", "it"}, {0}}},
	{0}
};

EnumType EnumVatSpecialType[]=
{
	{"ExportGoods",{
		{SCT_TEXT, NULL, NULL, "Goods Export, Reverse VAT", "en"},
		{SCT_TEXT, NULL, NULL, "Varuexport, omvänd moms", "sv"},
		{SCT_TEXT, NULL, NULL, "Godseksport, omvendt moms", "da"},
		{SCT_TEXT, NULL, NULL, "Vareeksport, omvendt moms", "no"},
		{SCT_TEXT, NULL, NULL, "Vöruútflutningur, bakvirði VSK", "is"},
		{SCT_TEXT, NULL, NULL, "Tavaroiden vientiä, käännetty verovelvollisuus", "fi"},
		{SCT_TEXT, NULL, NULL, "Warenexport, umgekehrte Mwst", "de"},
		{SCT_TEXT, NULL, NULL, "Goederenexport, omgekeerde btw", "nl"},
		{SCT_TEXT, NULL, NULL, "Exportation de marchandises, TVA inverse", "fr"},
		{SCT_TEXT, NULL, NULL, "Exportación de mercancías, IVA reverso", "es"},
		{SCT_TEXT, NULL, NULL, "Exportação de mercadorias, IVA reverso", "pt"},
		{SCT_TEXT, NULL, NULL, "Beni Esportazione, IVA inversa", "it"}, {0}}},
	{"ExportServices",{
		{SCT_TEXT, NULL, NULL, "Services Export, Reverse VAT", "en"},
		{SCT_TEXT, NULL, NULL, "Tjänsteexport, omvänd moms", "sv"},
		{SCT_TEXT, NULL, NULL, "Serviceeksport, omvendt moms", "da"},
		{SCT_TEXT, NULL, NULL, "Service eksport, omvendt moms", "no"},
		{SCT_TEXT, NULL, NULL, "Þjónusta útflutningur, bakvirði VSK", "is"},
		{SCT_TEXT, NULL, NULL, "Palvelujen vientiä, käännetty verovelvollisuus", "fi"},
		{SCT_TEXT, NULL, NULL, "Dienstexport, umgekehrte Mwst", "de"},
		{SCT_TEXT, NULL, NULL, "Serviceexport, omgekeerde btw", "nl"},
		{SCT_TEXT, NULL, NULL, "Services d'exportation, TVA inverse", "fr"},
		{SCT_TEXT, NULL, NULL, "Servicios de exportación, IVA reverso", "es"},
		{SCT_TEXT, NULL, NULL, "Serviços de exportação, IVA reverso", "pt"},
		{SCT_TEXT, NULL, NULL, "Servizi Esportazione, IVA inversa", "it"}, {0}}},
	{"DomesticReverseVat",{
		{SCT_TEXT, NULL, NULL, "Domestic, Reverse VAT", "en"},
		{SCT_TEXT, NULL, NULL, "Inrikes, omvänd moms", "sv"},
		{SCT_TEXT, NULL, NULL, "Indenlandsk, omvendt moms", "da"},
		{SCT_TEXT, NULL, NULL, "Innenlandsk, omvendt moms", "no"},
		{SCT_TEXT, NULL, NULL, "Innlendar, bakvirði VSK", "is"},
		{SCT_TEXT, NULL, NULL, "Kotimainen, käännetty verovelvollisuus", "fi"},
		{SCT_TEXT, NULL, NULL, "Inland, umgekehrte Mwst", "de"},
		{SCT_TEXT, NULL, NULL, "Binnenlandse, omgekeerde btw", "nl"},
		{SCT_TEXT, NULL, NULL, "Domestique, TVA inverse", "fr"},
		{SCT_TEXT, NULL, NULL, "Doméstico, IVA reverso", "es"},
		{SCT_TEXT, NULL, NULL, "Doméstico, IVA reverso", "pt"},
		{SCT_TEXT, NULL, NULL, "Domestico, IVA inversa", "it"}, {0}}},
	{"OtherReverseVat",{
		{SCT_TEXT, NULL, NULL, "Other, Reverse VAT", "en"},
		{SCT_TEXT, NULL, NULL, "Annan, omvänd moms", "sv"},
		{SCT_TEXT, NULL, NULL, "Andet, omvendt moms", "da"},
		{SCT_TEXT, NULL, NULL, "Andre, omvendt moms", "no"},
		{SCT_TEXT, NULL, NULL, "Öðru, bakvirði VSK", "is"},
		{SCT_TEXT, NULL, NULL, "Muuten, käännetty verovelvollisuus", "fi"},
		{SCT_TEXT, NULL, NULL, "Andere, umgekehrte Mwst", "de"},
		{SCT_TEXT, NULL, NULL, "Anders, omgekeerde btw", "nl"},
		{SCT_TEXT, NULL, NULL, "Autre, TVA inverse", "fr"},
		{SCT_TEXT, NULL, NULL, "Otros, IVA reverso", "es"},
		{SCT_TEXT, NULL, NULL, "Outro, IVA reverso", "pt"},
		{SCT_TEXT, NULL, NULL, "Altro, IVA inversa", "it"}, {0}}},
	{"MarginSchemeTravelAgents",{
		{SCT_TEXT, NULL, NULL, "Travel Agents, Margin Scheme", "en"},
		{SCT_TEXT, NULL, NULL, "Resebyråer, marginalbeskattning", "sv"},
		{SCT_TEXT, NULL, NULL, "Rejsebureau, marginalskat", "da"},
		{SCT_TEXT, NULL, NULL, "Reisebyrå, marginalskatt", "no"},
		{SCT_TEXT, NULL, NULL, "Ferðaskrifstofa, jaðargjald", "is"},
		{SCT_TEXT, NULL, NULL, "Matkatoimistot, Voittomarginaalijärjestelmä", "fi"},
		{SCT_TEXT, NULL, NULL, "Reisebüro, Margensystem", "de"},
		{SCT_TEXT, NULL, NULL, "Reisbureau, margesysteem", "nl"},
		{SCT_TEXT, NULL, NULL, "Agences de voyages, régime de marge", "fr"},
		{SCT_TEXT, NULL, NULL, "Agencias de viajes, esquema de margen", "es"},
		{SCT_TEXT, NULL, NULL, "Agente de viagens, esquema de margem", "pt"},
		{SCT_TEXT, NULL, NULL, "Agenzie di viaggio, regime del margine", "it"}, {0}}},
	{"MarginSchemeSecondHandGoods",{
		{SCT_TEXT, NULL, NULL, "Second Hand Goods, Margin Scheme", "en"},
		{SCT_TEXT, NULL, NULL, "Second hand, marginalbeskattning", "sv"},
		{SCT_TEXT, NULL, NULL, "Brugt varer, marginalskat", "da"},
		{SCT_TEXT, NULL, NULL, "Brukt varer, marginalskatt", "no"},
		{SCT_TEXT, NULL, NULL, "Notað vörur, jaðargjald", "is"},
		{SCT_TEXT, NULL, NULL, "Käytetyt tavarat, Voittomarginaalijärjestelmä", "fi"},
		{SCT_TEXT, NULL, NULL, "Gebrauchtwaren, Margensystem", "de"},
		{SCT_TEXT, NULL, NULL, "Tweedehands goederen, margesysteem", "nl"},
		{SCT_TEXT, NULL, NULL, "Marchandises usagées, régime de marge", "fr"},
		{SCT_TEXT, NULL, NULL, "Mercancías usados, esquema de margen", "es"},
		{SCT_TEXT, NULL, NULL, "Mercadorias de segunda mão, esquema de margem", "pt"},
		{SCT_TEXT, NULL, NULL, "Beni d'occasione, regime del margine", "it"}, {0}}},
	{"MarginSchemeWorksOfArt",{
		{SCT_TEXT, NULL, NULL, "Art, Margin Scheme", "en"},
		{SCT_TEXT, NULL, NULL, "Konst, marginalbeskattning", "sv"},
		{SCT_TEXT, NULL, NULL, "Kunst, marginalskat", "da"},
		{SCT_TEXT, NULL, NULL, "Kunst, marginalskatt", "no"},
		{SCT_TEXT, NULL, NULL, "List, jaðargjald", "is"},
		{SCT_TEXT, NULL, NULL, "Taide-esineet, Voittomarginaalijärjestelmä", "fi"},
		{SCT_TEXT, NULL, NULL, "Kunst, Margensystem", "de"},
		{SCT_TEXT, NULL, NULL, "Kunst, margesysteem", "nl"},
		{SCT_TEXT, NULL, NULL, "D'art, régime de marge", "fr"},
		{SCT_TEXT, NULL, NULL, "De arte, esquema de margen", "es"},
		{SCT_TEXT, NULL, NULL, "De Arte, esquema de margem", "pt"},
		{SCT_TEXT, NULL, NULL, "D'arte, regime del margine", "it"}, {0}}},
	{"MarginSchemeCollectorsItemsAntiques",{
		{SCT_TEXT, NULL, NULL, "Collectors Items or Antiques, Margin Scheme", "en"},
		{SCT_TEXT, NULL, NULL, "Samlarobjekt/Antikviteter, marginalbeskattning", "sv"},
		{SCT_TEXT, NULL, NULL, "Samleobjekter/antikviteter, marginalskat", "da"},
		{SCT_TEXT, NULL, NULL, "Samleobjekter/antikviteter, marginalskatt", "no"},
		{SCT_TEXT, NULL, NULL, "Safngripir/fornminjar, jaðargjald", "is"},
		{SCT_TEXT, NULL, NULL, "Keräily/antiikkiesineet, Voittomarginaalijärjestelmä", "fi"},
		{SCT_TEXT, NULL, NULL, "Sammlerstücke oder Antiquitäten, Margensystem", "de"},
		{SCT_TEXT, NULL, NULL, "Collectibles of antiek, margesysteem", "nl"},
		{SCT_TEXT, NULL, NULL, "Objets de collection ou antiquités, régime de marge", "fr"},
		{SCT_TEXT, NULL, NULL, "Artículos de coleccionista o antigüedades, esquema de margen", "es"},
		{SCT_TEXT, NULL, NULL, "Itens de colecionadores ou de antiguidades, esquema de margem", "pt"},
		{SCT_TEXT, NULL, NULL, "Oggetti da collezione o d'antiquariato, regime del margine", "it"}, {0}}},
	{"UnionTradeGoods",{
		{SCT_TEXT, NULL, NULL, "Goods Union Trade, Reverse VAT", "en"},
		{SCT_TEXT, NULL, NULL, "Varor, unionshandel, omvänd moms", "sv"},
		{SCT_TEXT, NULL, NULL, "Fællesskabsvarer, omvendt moms", "da"},
		{SCT_TEXT, NULL, NULL, "Fellesskapsvarer, omvendt moms", "no"},
		{SCT_TEXT, NULL, NULL, "Samfélagvöru, bakvirði VSK", "is"},
		{SCT_TEXT, NULL, NULL, "Tavaroiden EU-kauppaa, käännetty verovelvollisuus", "fi"},
		{SCT_TEXT, NULL, NULL, "Gemeinschaftswaren, Reverse VAT", "de"},
		{SCT_TEXT, NULL, NULL, "Communautaire goederen, omgekeerde btw", "nl"},
		{SCT_TEXT, NULL, NULL, "Marchandises, commerce dans la communauté, TVA inverse", "fr"},
		{SCT_TEXT, NULL, NULL, "Mercancías, comercio en la comunidad, IVA inverso", "es"},
		{SCT_TEXT, NULL, NULL, "Mercadorias de comunitária, IVA reverso", "pt"},
		{SCT_TEXT, NULL, NULL, "Beni, commercio dell'comunità, IVA inversa", "it"}, {0}}},
	{"UnionTradeServices",{
		{SCT_TEXT, NULL, NULL, "Services, Union Trade, Reverse VAT", "en"},
		{SCT_TEXT, NULL, NULL, "Tjänster, unionshandel, omvänd moms", "sv"},
		{SCT_TEXT, NULL, NULL, "Fællesskabstjenester, omvendt moms", "da"},
		{SCT_TEXT, NULL, NULL, "Fellesskapstjenester, omvendt moms", "no"},
		{SCT_TEXT, NULL, NULL, "Samfélagsþjónusta, bakvirði VSK", "is"},
		{SCT_TEXT, NULL, NULL, "Palvelujen EU-kauppaa, käännetty verovelvollisuus", "fi"},
		{SCT_TEXT, NULL, NULL, "Gemeinschaftsdienste, Reverse VAT", "de"},
		{SCT_TEXT, NULL, NULL, "Communautaire services, omgekeerde btw", "nl"},
		{SCT_TEXT, NULL, NULL, "Services, affaires communautaires, TVA inverse", "fr"},
		{SCT_TEXT, NULL, NULL, "Servicios, negocios de la comunidad, IVA inverso", "es"},
		{SCT_TEXT, NULL, NULL, "Serviços comunitária, IVA reverso", "pt"},
		{SCT_TEXT, NULL, NULL, "Servizi, commercio dell'comunità, IVA inversa", "it"}, {0}}},
	{"UnionTriangulationSales",{
		{SCT_TEXT, NULL, NULL, "Sales Triangulation Union Trade, Reverse VAT", "en"},
		{SCT_TEXT, NULL, NULL, "Trepartsförsäljning unionshandel, omvänd moms", "sv"},
		{SCT_TEXT, NULL, NULL, "Triangulationshandel i Fællesskabet, omvendt moms", "da"},
		{SCT_TEXT, NULL, NULL, "Triangulasjonshandel i Fellesskapet, omvendt MVA", "no"},
		{SCT_TEXT, NULL, NULL, "Samfélagstriangulation, bakvirði VSK", "is"},
		{SCT_TEXT, NULL, NULL, "EU-Kolmikantakauppa, käännetty verovelvollisuus", "fi"},
		{SCT_TEXT, NULL, NULL, "Triangulationshandel in der Gemeinschaft, umgekehrte Mwst", "de"},
		{SCT_TEXT, NULL, NULL, "Triangulatiehandel in de Gemeenschap, omgekeerde btw", "nl"},
		{SCT_TEXT, NULL, NULL, "Commerce triangulaire communautaire, TVA inverse", "fr"},
		{SCT_TEXT, NULL, NULL, "Comercio de triangulación comunitaria, IVA reverso", "es"},
		{SCT_TEXT, NULL, NULL, "Comércio de triangulação comunitária, IVA reverso", "pt"},
		{SCT_TEXT, NULL, NULL, "Vendite Triangolazione, commercio dell'comunità, IVA inversa", "it"}, {0}}},
	{"UnionTriangulationSupply",{
		{SCT_TEXT, NULL, NULL, "Supply Triangulation Union Trade, VAT Exemption", "en"},
		{SCT_TEXT, NULL, NULL, "TrepartslLeverans unionshandel, momsfri", "sv"},
		{SCT_TEXT, NULL, NULL, "Leverandør fællesskab Triangulation, momsfritagelse", "da"},
		{SCT_TEXT, NULL, NULL, "Leverandør fellesskap Triangulasjon, MVA fri", "no"},
		{SCT_TEXT, NULL, NULL, "Birgir Triangulation, VSK undanþága", "is"},
		{SCT_TEXT, NULL, NULL, "EU-Yhteisömyynti, veroton hinta", "fi"},
		{SCT_TEXT, NULL, NULL, "Bereitstellung bei Gemeinschaft Triangulation, Mwst-befreiungen", "de"},
		{SCT_TEXT, NULL, NULL, "Het bieden van community triangulatie, btw - vrijstellingen", "nl"},
		{SCT_TEXT, NULL, NULL, "Provision de triangulation communautaire, exonérations de TVA", "fr"},
		{SCT_TEXT, NULL, NULL, "Suministro de triangulación comunitaria, exenciones del IVA", "es"},
		{SCT_TEXT, NULL, NULL, "Fornecimento de triangulação comunitária, isenções de IVA", "pt"},
		{SCT_TEXT, NULL, NULL, "Fornitura Triangolazione comunità, Esenzioni de IVA", "it"}, {0}}},
	{0}
};

EnumType EnumPaymentMeansChannelCodeType[]=
{
	{"1",{
		{SCT_TEXT, NULL, NULL, "Ordinary post", "en"},
		{SCT_TEXT, NULL, NULL, "Brev", "sv"},
		{SCT_TEXT, NULL, NULL, "Brev", "da"},
		{SCT_TEXT, NULL, NULL, "Brev", "no"},
		{SCT_TEXT, NULL, NULL, "Bréf", "is"},
		{SCT_TEXT, NULL, NULL, "Kirjain", "fi"},
		{SCT_TEXT, NULL, NULL, "Brief", "de"},
		{SCT_TEXT, NULL, NULL, "Brief", "nl"},
		{SCT_TEXT, NULL, NULL, "Lettre", "fr"},
		{SCT_TEXT, NULL, NULL, "Letra", "es"},
		{SCT_TEXT, NULL, NULL, "Letra", "pt"},
		{SCT_TEXT, NULL, NULL, "Lettera", "it"}, {0}}},
	{"2",{
		{SCT_TEXT, NULL, NULL, "Air mail", "en"},
		{SCT_TEXT, NULL, NULL, "Flygpost", "sv"},
		{SCT_TEXT, NULL, NULL, "Luftpost", "da"},
		{SCT_TEXT, NULL, NULL, "Luftpost", "no"},
		{SCT_TEXT, NULL, NULL, "Flugpóstur", "is"},
		{SCT_TEXT, NULL, NULL, "Lentoposti", "fi"},
		{SCT_TEXT, NULL, NULL, "Luftpost", "de"},
		{SCT_TEXT, NULL, NULL, "Luchtpost", "nl"},
		{SCT_TEXT, NULL, NULL, "Lettre par avion", "fr"},
		{SCT_TEXT, NULL, NULL, "Letra aereo", "es"},
		{SCT_TEXT, NULL, NULL, "Letra aéreo", "pt"},
		{SCT_TEXT, NULL, NULL, "Posta aerea", "it"}, {0}}},
	{"3",{
		{SCT_TEXT, NULL, NULL, "Telegraph", "en"},
		{SCT_TEXT, NULL, NULL, "Telegraf", "sv"},
		{SCT_TEXT, NULL, NULL, "Telegraf", "da"},
		{SCT_TEXT, NULL, NULL, "Telegraf", "no"},
		{SCT_TEXT, NULL, NULL, "Sími", "is"},
		{SCT_TEXT, NULL, NULL, "Lennätin", "fi"},
		{SCT_TEXT, NULL, NULL, "Telegraf", "de"},
		{SCT_TEXT, NULL, NULL, "Telegraaf", "nl"},
		{SCT_TEXT, NULL, NULL, "Télégraphe", "fr"},
		{SCT_TEXT, NULL, NULL, "Telégrafo", "es"},
		{SCT_TEXT, NULL, NULL, "Telégrafo", "pt"},
		{SCT_TEXT, NULL, NULL, "Telegrafo", "it"}, {0}}},
	{"4",{
		{SCT_TEXT, NULL, NULL, "Telex", "en"},
		{SCT_TEXT, NULL, NULL, "Telex", "sv"},
		{SCT_TEXT, NULL, NULL, "Telex", "da"},
		{SCT_TEXT, NULL, NULL, "Telex", "no"},
		{SCT_TEXT, NULL, NULL, "Telex", "is"},
		{SCT_TEXT, NULL, NULL, "Telex", "fi"},
		{SCT_TEXT, NULL, NULL, "Fernschreiber", "de"},
		{SCT_TEXT, NULL, NULL, "Telex", "nl"},
		{SCT_TEXT, NULL, NULL, "Telex", "fr"},
		{SCT_TEXT, NULL, NULL, "Telex", "es"},
		{SCT_TEXT, NULL, NULL, "Telex", "pt"},
		{SCT_TEXT, NULL, NULL, "Telex", "it"}, {0}}},
	{"5",{
		{SCT_TEXT, NULL, NULL, "S.W.I.F.T.", "en"},
		{SCT_TEXT, NULL, NULL, "S.W.I.F.T.", "sv"},
		{SCT_TEXT, NULL, NULL, "S.W.I.F.T.", "da"},
		{SCT_TEXT, NULL, NULL, "S.W.I.F.T.", "no"},
		{SCT_TEXT, NULL, NULL, "S.W.I.F.T.", "is"},
		{SCT_TEXT, NULL, NULL, "S.W.I.F.T.", "fi"},
		{SCT_TEXT, NULL, NULL, "S.W.I.F.T.", "de"},
		{SCT_TEXT, NULL, NULL, "S.W.I.F.T.", "nl"},
		{SCT_TEXT, NULL, NULL, "S.W.I.F.T.", "fr"},
		{SCT_TEXT, NULL, NULL, "S.W.I.F.T.", "es"},
		{SCT_TEXT, NULL, NULL, "S.W.I.F.T.", "pt"},
		{SCT_TEXT, NULL, NULL, "S.W.I.F.T.", "it"}, {0}}},
	{"6",{
		{SCT_TEXT, NULL, NULL, "Other transmission networks", "en"},
		{SCT_TEXT, NULL, NULL, "Annan överföring", "sv"},
		{SCT_TEXT, NULL, NULL, "Andre netværk", "da"},
		{SCT_TEXT, NULL, NULL, "Andre nettverk", "no"},
		{SCT_TEXT, NULL, NULL, "Önnur flutningskerfi", "is"},
		{SCT_TEXT, NULL, NULL, "Muu siirt", "fi"},
		{SCT_TEXT, NULL, NULL, "Andere Netze", "de"},
		{SCT_TEXT, NULL, NULL, "Andere netwerken", "nl"},
		{SCT_TEXT, NULL, NULL, "Autres réseaux", "fr"},
		{SCT_TEXT, NULL, NULL, "Otras redes", "es"},
		{SCT_TEXT, NULL, NULL, "Outras redes", "pt"},
		{SCT_TEXT, NULL, NULL, "Altre reti", "it"}, {0}}},
	{"7",{
		{SCT_TEXT, NULL, NULL, "Networks not defined", "en"},
		{SCT_TEXT, NULL, NULL, "Ospecificerad överföring", "sv"},
		{SCT_TEXT, NULL, NULL, "Netværk er ikke defineret", "da"},
		{SCT_TEXT, NULL, NULL, "Nettverk ikke definert", "no"},
		{SCT_TEXT, NULL, NULL, "Net ekki skilgreint", "is"},
		{SCT_TEXT, NULL, NULL, "Muu siirt", "fi"},
		{SCT_TEXT, NULL, NULL, "Netzwerk nicht definiert", "de"},
		{SCT_TEXT, NULL, NULL, "Netwerk niet gedefinieerd", "nl"},
		{SCT_TEXT, NULL, NULL, "Réseau non défini", "fr"},
		{SCT_TEXT, NULL, NULL, "Red no definida", "es"},
		{SCT_TEXT, NULL, NULL, "Rede não definida", "pt"},
		{SCT_TEXT, NULL, NULL, "Rete non definita", "it"}, {0}}},
	{"8",{
		{SCT_TEXT, NULL, NULL, "Fedwire", "en"},
		{SCT_TEXT, NULL, NULL, "Fedwire", "sv"},
		{SCT_TEXT, NULL, NULL, "Fedwire", "da"},
		{SCT_TEXT, NULL, NULL, "Fedwire", "no"},
		{SCT_TEXT, NULL, NULL, "Fedwire", "is"},
		{SCT_TEXT, NULL, NULL, "Fedwire", "fi"},
		{SCT_TEXT, NULL, NULL, "Fedwire", "de"},
		{SCT_TEXT, NULL, NULL, "Fedwire", "nl"},
		{SCT_TEXT, NULL, NULL, "Fedwire", "fr"},
		{SCT_TEXT, NULL, NULL, "Fedwire", "es"},
		{SCT_TEXT, NULL, NULL, "Fedwire", "pt"},
		{SCT_TEXT, NULL, NULL, "Fedwire", "it"}, {0}}},
	{"9",{
		{SCT_TEXT, NULL, NULL, "Personal (face-to-face)", "en"},
		{SCT_TEXT, NULL, NULL, "Personligen", "sv"},
		{SCT_TEXT, NULL, NULL, "Personlig", "da"},
		{SCT_TEXT, NULL, NULL, "Personlig", "no"},
		{SCT_TEXT, NULL, NULL, "Persónulega", "is"},
		{SCT_TEXT, NULL, NULL, "Henkilökohtaisesti", "fi"},
		{SCT_TEXT, NULL, NULL, "Persönlich", "de"},
		{SCT_TEXT, NULL, NULL, "Persoonlijk", "nl"},
		{SCT_TEXT, NULL, NULL, "Personnellement", "fr"},
		{SCT_TEXT, NULL, NULL, "Personalmente", "es"},
		{SCT_TEXT, NULL, NULL, "Pessoalmente", "pt"},
		{SCT_TEXT, NULL, NULL, "Personalmente", "it"}, {0}}},
	{"10",{
		{SCT_TEXT, NULL, NULL, "Registered air mail", "en"},
		{SCT_TEXT, NULL, NULL, "Rekommenderad flygpost", "sv"},
		{SCT_TEXT, NULL, NULL, "Anbefalt luftpost", "da"},
		{SCT_TEXT, NULL, NULL, "Anbefalt luftpost", "no"},
		{SCT_TEXT, NULL, NULL, "Skráður flugpóstur", "is"},
		{SCT_TEXT, NULL, NULL, "Suositeltava lentoposti", "fi"},
		{SCT_TEXT, NULL, NULL, "Empfohlene Luftpost", "de"},
		{SCT_TEXT, NULL, NULL, "Aanbevolen luchtpost", "nl"},
		{SCT_TEXT, NULL, NULL, "Lettre recommandée par avion", "fr"},
		{SCT_TEXT, NULL, NULL, "Recomendado por avión", "es"},
		{SCT_TEXT, NULL, NULL, "Recomendado por avião", "pt"},
		{SCT_TEXT, NULL, NULL, "Consigliato in aereo", "it"}, {0}}},
	{"11",{
		{SCT_TEXT, NULL, NULL, "Registered mail", "en"},
		{SCT_TEXT, NULL, NULL, "Rekommenderad post", "sv"},
		{SCT_TEXT, NULL, NULL, "Anbefalt brev", "da"},
		{SCT_TEXT, NULL, NULL, "Anbefalt brev", "no"},
		{SCT_TEXT, NULL, NULL, "Skráður bréf", "is"},
		{SCT_TEXT, NULL, NULL, "Suositeltava kirjain", "fi"},
		{SCT_TEXT, NULL, NULL, "Empfohlener Brief", "de"},
		{SCT_TEXT, NULL, NULL, "Aanbevolen brief", "nl"},
		{SCT_TEXT, NULL, NULL, "Lettre recommandée", "fr"},
		{SCT_TEXT, NULL, NULL, "Letra certificada", "es"},
		{SCT_TEXT, NULL, NULL, "Letra registrada", "pt"},
		{SCT_TEXT, NULL, NULL, "Lettera raccomandata", "it"}, {0}}},
	{"12",{
		{SCT_TEXT, NULL, NULL, "Courier", "en"},
		{SCT_TEXT, NULL, NULL, "Kurir", "sv"},
		{SCT_TEXT, NULL, NULL, "Kurer", "da"},
		{SCT_TEXT, NULL, NULL, "Kurer", "no"},
		{SCT_TEXT, NULL, NULL, "Hraðboði", "is"},
		{SCT_TEXT, NULL, NULL, "Kuriiri", "fi"},
		{SCT_TEXT, NULL, NULL, "Kurier", "de"},
		{SCT_TEXT, NULL, NULL, "Koerier", "nl"},
		{SCT_TEXT, NULL, NULL, "Courrier", "fr"},
		{SCT_TEXT, NULL, NULL, "Correo", "es"},
		{SCT_TEXT, NULL, NULL, "Correio", "pt"},
		{SCT_TEXT, NULL, NULL, "Corriere", "it"}, {0}}},
	{"13",{
		{SCT_TEXT, NULL, NULL, "Messenger", "en"},
		{SCT_TEXT, NULL, NULL, "Bud", "sv"},
		{SCT_TEXT, NULL, NULL, "Bud", "da"},
		{SCT_TEXT, NULL, NULL, "Bud", "no"},
		{SCT_TEXT, NULL, NULL, "Sendiboði", "is"},
		{SCT_TEXT, NULL, NULL, "Budille", "fi"},
		{SCT_TEXT, NULL, NULL, "Gebote", "de"},
		{SCT_TEXT, NULL, NULL, "Biedingen", "nl"},
		{SCT_TEXT, NULL, NULL, "Messagers", "fr"},
		{SCT_TEXT, NULL, NULL, "Mensajeros", "es"},
		{SCT_TEXT, NULL, NULL, "Mensageiro", "pt"},
		{SCT_TEXT, NULL, NULL, "Messaggero", "it"}, {0}}},
	{"14",{
		{SCT_TEXT, NULL, NULL, "National ACH", "en"},
		{SCT_TEXT, NULL, NULL, "Inrikes clearing", "sv"},
		{SCT_TEXT, NULL, NULL, "Indenlandske clearing", "da"},
		{SCT_TEXT, NULL, NULL, "Innenlandsk clearing", "no"},
		{SCT_TEXT, NULL, NULL, "Innlendar clearing", "is"},
		{SCT_TEXT, NULL, NULL, "Kotimaan clearing", "fi"},
		{SCT_TEXT, NULL, NULL, "Inlandsclearing", "de"},
		{SCT_TEXT, NULL, NULL, "Binnenlandse clearing", "nl"},
		{SCT_TEXT, NULL, NULL, "Clearing domestique", "fr"},
		{SCT_TEXT, NULL, NULL, "Clearing interior", "es"},
		{SCT_TEXT, NULL, NULL, "Clearing doméstica", "pt"},
		{SCT_TEXT, NULL, NULL, "Clearing domestico", "it"}, {0}}},
	{"15",{
		{SCT_TEXT, NULL, NULL, "Other ACH", "en"},
		{SCT_TEXT, NULL, NULL, "Annan clearing", "sv"},
		{SCT_TEXT, NULL, NULL, "Anden clearing", "da"},
		{SCT_TEXT, NULL, NULL, "Annen clearing", "no"},
		{SCT_TEXT, NULL, NULL, "Annað clearing", "is"},
		{SCT_TEXT, NULL, NULL, "Toinen clearing", "fi"},
		{SCT_TEXT, NULL, NULL, "Andere clearing", "de"},
		{SCT_TEXT, NULL, NULL, "Andere clearing", "nl"},
		{SCT_TEXT, NULL, NULL, "Autre Clearing", "fr"},
		{SCT_TEXT, NULL, NULL, "Otra Clearing", "es"},
		{SCT_TEXT, NULL, NULL, "Clearing outros", "pt"},
		{SCT_TEXT, NULL, NULL, "Clearing degli altri", "it"}, {0}}},
	{"ZZZ",{
		{SCT_TEXT, NULL, NULL, "Mutually defined", "en"},
		{SCT_TEXT, NULL, NULL, "Annan överenskommelse", "sv"},
		{SCT_TEXT, NULL, NULL, "Gensidigt defineret", "da"},
		{SCT_TEXT, NULL, NULL, "Gjensidig definert", "no"},
		{SCT_TEXT, NULL, NULL, "Gagnkvæmt skilgreint", "is"},
		{SCT_TEXT, NULL, NULL, "Muu sopimus", "fi"},
		{SCT_TEXT, NULL, NULL, "Zueinander definiert", "de"},
		{SCT_TEXT, NULL, NULL, "Wederom gedefinieerd", "nl"},
		{SCT_TEXT, NULL, NULL, "Définis l'un par rapport à l'autre", "fr"},
		{SCT_TEXT, NULL, NULL, "Definido con respecto el uno al otro", "es"},
		{SCT_TEXT, NULL, NULL, "Definido em relação um ao outro", "pt"},
		{SCT_TEXT, NULL, NULL, "Definiti l'uno rispetto all'altro", "it"}, {0}}},
	{0}
};

EnumType EnumPaymentMeansCodeType[]=
{
	{"1",{
		{SCT_TEXT, NULL, NULL, "Instrument not defined", "en"}, {0}}},
	{"2",{
		{SCT_TEXT, NULL, NULL, "Automated clearing house credit", "en"}, {0}}},
	{"3",{
		{SCT_TEXT, NULL, NULL, "Automated clearing house debit", "en"}, {0}}},
	{"4",{
		{SCT_TEXT, NULL, NULL, "ACH demand debit reversal", "en"}, {0}}},
	{"5",{
		{SCT_TEXT, NULL, NULL, "ACH demand credit reversal", "en"}, {0}}},
	{"6",{
		{SCT_TEXT, NULL, NULL, "ACH demand credit", "en"}, {0}}},
	{"7",{
		{SCT_TEXT, NULL, NULL, "ACH demand debit", "en"}, {0}}},
	{"8",{
		{SCT_TEXT, NULL, NULL, "Hold", "en"}, {0}}},
	{"9",{
		{SCT_TEXT, NULL, NULL, "National or regional clearing", "en"}, {0}}},
	{"10",{
		{SCT_TEXT, NULL, NULL, "In cash", "en"}, {0}}},
	{"11",{
		{SCT_TEXT, NULL, NULL, "ACH savings credit reversal", "en"}, {0}}},
	{"12",{
		{SCT_TEXT, NULL, NULL, "ACH savings debit reversal", "en"}, {0}}},
	{"13",{
		{SCT_TEXT, NULL, NULL, "ACH savings credit", "en"}, {0}}},
	{"14",{
		{SCT_TEXT, NULL, NULL, "ACH savings debit", "en"}, {0}}},
	{"15",{
		{SCT_TEXT, NULL, NULL, "Bookentry credit", "en"}, {0}}},
	{"16",{
		{SCT_TEXT, NULL, NULL, "Bookentry debit", "en"}, {0}}},
	{"17",{
		{SCT_TEXT, NULL, NULL, "ACH demand cash concentration/disbursement (CCD) credit", "en"}, {0}}},
	{"18",{
		{SCT_TEXT, NULL, NULL, "ACH demand cash concentration/disbursement (CCD) debit", "en"}, {0}}},
	{"19",{
		{SCT_TEXT, NULL, NULL, "ACH demand corporate trade payment (CTP) credit", "en"}, {0}}},
	{"20",{
		{SCT_TEXT, NULL, NULL, "Cheque", "en"}, {0}}},
	{"21",{
		{SCT_TEXT, NULL, NULL, "Banker's draft", "en"}, {0}}},
	{"22",{
		{SCT_TEXT, NULL, NULL, "Certified banker's draft", "en"}, {0}}},
	{"23",{
		{SCT_TEXT, NULL, NULL, "Bank cheque (issued by a banking or similar establishment)", "en"}, {0}}},
	{"24",{
		{SCT_TEXT, NULL, NULL, "Bill of exchange awaiting acceptance", "en"}, {0}}},
	{"25",{
		{SCT_TEXT, NULL, NULL, "Certified cheque", "en"}, {0}}},
	{"26",{
		{SCT_TEXT, NULL, NULL, "Local cheque", "en"}, {0}}},
	{"27",{
		{SCT_TEXT, NULL, NULL, "ACH demand corporate trade payment (CTP) debit", "en"}, {0}}},
	{"28",{
		{SCT_TEXT, NULL, NULL, "ACH demand corporate trade exchange (CTX) credit", "en"}, {0}}},
	{"29",{
		{SCT_TEXT, NULL, NULL, "ACH demand corporate trade exchange (CTX) debit", "en"}, {0}}},
	{"30",{
		{SCT_TEXT, NULL, NULL, "Credit transfer", "en"}, {0}}},
	{"31",{
		{SCT_TEXT, NULL, NULL, "Debit transfer", "en"}, {0}}},
	{"32",{
		{SCT_TEXT, NULL, NULL, "ACH demand cash concentration/disbursement plus (CCD+) credit", "en"}, {0}}},
	{"33",{
		{SCT_TEXT, NULL, NULL, "ACH demand cash concentration/disbursement plus (CCD+) debit", "en"}, {0}}},
	{"34",{
		{SCT_TEXT, NULL, NULL, "ACH prearranged payment and deposit (PPD)", "en"}, {0}}},
	{"35",{
		{SCT_TEXT, NULL, NULL, "ACH savings cash concentration/disbursement (CCD) credit", "en"}, {0}}},
	{"36",{
		{SCT_TEXT, NULL, NULL, "ACH savings cash concentration/disbursement (CCD) debit", "en"}, {0}}},
	{"37",{
		{SCT_TEXT, NULL, NULL, "ACH savings corporate trade payment (CTP) credit", "en"}, {0}}},
	{"38",{
		{SCT_TEXT, NULL, NULL, "ACH savings corporate trade payment (CTP) debit", "en"}, {0}}},
	{"39",{
		{SCT_TEXT, NULL, NULL, "ACH savings corporate trade exchange (CTX) credit", "en"}, {0}}},
	{"40",{
		{SCT_TEXT, NULL, NULL, "ACH savings corporate trade exchange (CTX) debit", "en"}, {0}}},
	{"41",{
		{SCT_TEXT, NULL, NULL, "ACH savings cash concentration/disbursement plus (CCD+) credit", "en"}, {0}}},
	{"42",{
		{SCT_TEXT, NULL, NULL, "Payment to bank account", "en"}, {0}}},
	{"43",{
		{SCT_TEXT, NULL, NULL, "ACH savings cash concentration/disbursement plus (CCD+) debit", "en"}, {0}}},
	{"44",{
		{SCT_TEXT, NULL, NULL, "Accepted bill of exchange", "en"}, {0}}},
	{"45",{
		{SCT_TEXT, NULL, NULL, "Referenced home-banking credit transfer", "en"}, {0}}},
	{"46",{
		{SCT_TEXT, NULL, NULL, "Interbank debit transfer", "en"}, {0}}},
	{"47",{
		{SCT_TEXT, NULL, NULL, "Home-banking debit transfer", "en"}, {0}}},
	{"48",{
		{SCT_TEXT, NULL, NULL, "Bank card", "en"}, {0}}},
	{"49",{
		{SCT_TEXT, NULL, NULL, "Direct debit", "en"}, {0}}},
	{"50",{
		{SCT_TEXT, NULL, NULL, "Payment by postgiro", "en"}, {0}}},
	{"51",{
		{SCT_TEXT, NULL, NULL, "FR, norme 6 97-Telereglement CFONB (French Organisation for Banking Standards)", "en"}, {0}}},
	{"52",{
		{SCT_TEXT, NULL, NULL, "Urgent commercial payment", "en"}, {0}}},
	{"53",{
		{SCT_TEXT, NULL, NULL, "Urgent Treasury Payment", "en"}, {0}}},
	{"60",{
		{SCT_TEXT, NULL, NULL, "Promissory note", "en"}, {0}}},
	{"61",{
		{SCT_TEXT, NULL, NULL, "Promissory note signed by the debtor", "en"}, {0}}},
	{"62",{
		{SCT_TEXT, NULL, NULL, "Promissory note signed by the debtor and endorsed by a bank", "en"}, {0}}},
	{"63",{
		{SCT_TEXT, NULL, NULL, "Promissory note signed by the debtor and endorsed by a third party", "en"}, {0}}},
	{"64",{
		{SCT_TEXT, NULL, NULL, "Promissory note signed by a bank", "en"}, {0}}},
	{"65",{
		{SCT_TEXT, NULL, NULL, "Promissory note signed by a bank and endorsed by another bank", "en"}, {0}}},
	{"66",{
		{SCT_TEXT, NULL, NULL, "Promissory note signed by a third party", "en"}, {0}}},
	{"67",{
		{SCT_TEXT, NULL, NULL, "Promissory note signed by a third party and endorsed by a bank", "en"}, {0}}},
	{"70",{
		{SCT_TEXT, NULL, NULL, "Bill drawn by the creditor on the debtor.", "en"}, {0}}},
	{"74",{
		{SCT_TEXT, NULL, NULL, "Bill drawn by the creditor on a bank.", "en"}, {0}}},
	{"75",{
		{SCT_TEXT, NULL, NULL, "Bill drawn by the creditor, endorsed by another bank.", "en"}, {0}}},
	{"76",{
		{SCT_TEXT, NULL, NULL, "Bill drawn by the creditor on a bank and endorsed by a third party.", "en"}, {0}}},
	{"77",{
		{SCT_TEXT, NULL, NULL, "Bill drawn by the creditor on a third party.", "en"}, {0}}},
	{"78",{
		{SCT_TEXT, NULL, NULL, "Bill drawn by creditor on third party, accepted and endorsed by bank.", "en"}, {0}}},
	{"91",{
		{SCT_TEXT, NULL, NULL, "Not transferable banker's draft", "en"}, {0}}},
	{"92",{
		{SCT_TEXT, NULL, NULL, "Not transferable local cheque", "en"}, {0}}},
	{"93",{
		{SCT_TEXT, NULL, NULL, "Reference giro", "en"}, {0}}},
	{"94",{
		{SCT_TEXT, NULL, NULL, "Urgent giro", "en"}, {0}}},
	{"95",{
		{SCT_TEXT, NULL, NULL, "Free format giro", "en"}, {0}}},
	{"96",{
		{SCT_TEXT, NULL, NULL, "Requested method for payment was not used", "en"}, {0}}},
	{"97",{
		{SCT_TEXT, NULL, NULL, "Clearing between partners", "en"}, {0}}},
	{"ZZZ",{
		{SCT_TEXT, NULL, NULL, "Mutually defined", "en"}, {0}}},
	{0}
};

EnumType EnumPaymentGuaranteeMeansCodeType[]=
{
	{"1",{
		{SCT_TEXT, NULL, NULL, "Factor guarantee", "en"}, {0}}},
	{"10",{
		{SCT_TEXT, NULL, NULL, "Bank guarantee", "en"}, {0}}},
	{"11",{
		{SCT_TEXT, NULL, NULL, "Public authority guarantee", "en"}, {0}}},
	{"12",{
		{SCT_TEXT, NULL, NULL, "Third party guarantee", "en"}, {0}}},
	{"13",{
		{SCT_TEXT, NULL, NULL, "Standby letter of credit", "en"}, {0}}},
	{"14",{
		{SCT_TEXT, NULL, NULL, "No guarantee", "en"}, {0}}},
	{"20",{
		{SCT_TEXT, NULL, NULL, "Goods as security", "en"}, {0}}},
	{"21",{
		{SCT_TEXT, NULL, NULL, "Business as security", "en"}, {0}}},
	{"23",{
		{SCT_TEXT, NULL, NULL, "Warrant or similar (warehouse receipts)", "en"}, {0}}},
	{"24",{
		{SCT_TEXT, NULL, NULL, "Mortgage", "en"}, {0}}},
	{"45",{
		{SCT_TEXT, NULL, NULL, "Insurance certificate", "en"}, {0}}},
	{"ZZZ",{
		{SCT_TEXT, NULL, NULL, "Mutually defined", "en"}, {0}}},
	{0}
};

EnumType EnumPaymentMethodCodeType[]=
{
	{"1",{
		{SCT_TEXT, NULL, NULL, "Direct payment", "en"}, {0}}},
	{"2",{
		{SCT_TEXT, NULL, NULL, "Automatic clearing house credit", "en"}, {0}}},
	{"3",{
		{SCT_TEXT, NULL, NULL, "Automatic clearing house debit", "en"}, {0}}},
	{"4",{
		{SCT_TEXT, NULL, NULL, "Automatic clearing house credit-savings account", "en"}, {0}}},
	{"5",{
		{SCT_TEXT, NULL, NULL, "Automatic clearing house debit-demand account", "en"}, {0}}},
	{"6",{
		{SCT_TEXT, NULL, NULL, "Bank book transfer (credit)", "en"}, {0}}},
	{"7",{
		{SCT_TEXT, NULL, NULL, "Bank book transfer (debit)", "en"}, {0}}},
	{"8",{
		{SCT_TEXT, NULL, NULL, "Doc collection via 3rd party with bill of EX", "en"}, {0}}},
	{"9",{
		{SCT_TEXT, NULL, NULL, "Doc collection via 3rd party no bill of EX", "en"}, {0}}},
	{"10",{
		{SCT_TEXT, NULL, NULL, "Irrevocable documentary credit", "en"}, {0}}},
	{"11",{
		{SCT_TEXT, NULL, NULL, "Transferable irrevocable documentary credit", "en"}, {0}}},
	{"12",{
		{SCT_TEXT, NULL, NULL, "Confirmed irrevocable documentary credit", "en"}, {0}}},
	{"13",{
		{SCT_TEXT, NULL, NULL, "Transferable confirmed irrevocable documentary credit", "en"}, {0}}},
	{"14",{
		{SCT_TEXT, NULL, NULL, "Revocable documentary credit", "en"}, {0}}},
	{"15",{
		{SCT_TEXT, NULL, NULL, "Irrevocable letter of credit-confirmed", "en"}, {0}}},
	{"16",{
		{SCT_TEXT, NULL, NULL, "Letter of guarantee", "en"}, {0}}},
	{"17",{
		{SCT_TEXT, NULL, NULL, "Revocable letter of credit", "en"}, {0}}},
	{"18",{
		{SCT_TEXT, NULL, NULL, "Standby letter of credit", "en"}, {0}}},
	{"19",{
		{SCT_TEXT, NULL, NULL, "Irrevocable letter of credit unconfirmed", "en"}, {0}}},
	{"20",{
		{SCT_TEXT, NULL, NULL, "Clean collection (ICC)", "en"}, {0}}},
	{"21",{
		{SCT_TEXT, NULL, NULL, "Documentary collection (ICC)", "en"}, {0}}},
	{"22",{
		{SCT_TEXT, NULL, NULL, "Documentary sight collection (ICC)", "en"}, {0}}},
	{"23",{
		{SCT_TEXT, NULL, NULL, "Documentary collection with date of expiry (ICC)", "en"}, {0}}},
	{"24",{
		{SCT_TEXT, NULL, NULL, "Documentary collection: bill of exchange against acceptance", "en"}, {0}}},
	{"25",{
		{SCT_TEXT, NULL, NULL, "Documentary collection: bill of exchange against payment", "en"}, {0}}},
	{"26",{
		{SCT_TEXT, NULL, NULL, "Collection subject to buyer's approval (ICC)", "en"}, {0}}},
	{"27",{
		{SCT_TEXT, NULL, NULL, "Collection by a bank consignee for the goods (ICC)", "en"}, {0}}},
	{"34",{
		{SCT_TEXT, NULL, NULL, "Seller to advise buyer", "en"}, {0}}},
	{"35",{
		{SCT_TEXT, NULL, NULL, "Documents through banks", "en"}, {0}}},
	{"36",{
		{SCT_TEXT, NULL, NULL, "Charging (to account)", "en"}, {0}}},
	{"37",{
		{SCT_TEXT, NULL, NULL, "Available with issuing bank", "en"}, {0}}},
	{"38",{
		{SCT_TEXT, NULL, NULL, "Available with advising bank", "en"}, {0}}},
	{"39",{
		{SCT_TEXT, NULL, NULL, "Available with named bank", "en"}, {0}}},
	{"40",{
		{SCT_TEXT, NULL, NULL, "Available with any bank", "en"}, {0}}},
	{"41",{
		{SCT_TEXT, NULL, NULL, "Available with any bank in ...", "en"}, {0}}},
	{"42",{
		{SCT_TEXT, NULL, NULL, "Indirect payment", "en"}, {0}}},
	{"43",{
		{SCT_TEXT, NULL, NULL, "Reassignment", "en"}, {0}}},
	{"44",{
		{SCT_TEXT, NULL, NULL, "Offset", "en"}, {0}}},
	{"45",{
		{SCT_TEXT, NULL, NULL, "Special entries", "en"}, {0}}},
	{"46",{
		{SCT_TEXT, NULL, NULL, "Instalment payment", "en"}, {0}}},
	{"47",{
		{SCT_TEXT, NULL, NULL, "Instalment payment with draft", "en"}, {0}}},
	{"48",{
		{SCT_TEXT, NULL, NULL, "Available with advise through bank", "en"}, {0}}},
	{"49",{
		{SCT_TEXT, NULL, NULL, "General conditions of sale", "en"}, {0}}},
	{"50",{
		{SCT_TEXT, NULL, NULL, "Special payment", "en"}, {0}}},
	{"61",{
		{SCT_TEXT, NULL, NULL, "Set-off by exchange of documents", "en"}, {0}}},
	{"62",{
		{SCT_TEXT, NULL, NULL, "Set-off by reciprocal credits", "en"}, {0}}},
	{"64",{
		{SCT_TEXT, NULL, NULL, "Set-off by exchange of goods", "en"}, {0}}},
	{"65",{
		{SCT_TEXT, NULL, NULL, "Reverse factoring", "en"}, {0}}},
	{"69",{
		{SCT_TEXT, NULL, NULL, "Other set-off", "en"}, {0}}},
	{"70",{
		{SCT_TEXT, NULL, NULL, "Supplier to invoice", "en"}, {0}}},
	{"71",{
		{SCT_TEXT, NULL, NULL, "Recipient to self bill", "en"}, {0}}},
	{"ZZZ",{
		{SCT_TEXT, NULL, NULL, "Mutually defined", "en"}, {0}}},
	{0}
};

EnumType EnumApplicationTextType[]=
{
	{"OK",{
		{SCT_TEXT, NULL, NULL, "OK", "en"},
		{SCT_TEXT, NULL, NULL, "OK", "sv"},
		{SCT_TEXT, NULL, NULL, "OK", "da"},
		{SCT_TEXT, NULL, NULL, "OK", "no"},
		{SCT_TEXT, NULL, NULL, "OK", "is"},
		{SCT_TEXT, NULL, NULL, "OK", "fi"},
		{SCT_TEXT, NULL, NULL, "OK", "de"},
		{SCT_TEXT, NULL, NULL, "OK", "nl"},
		{SCT_TEXT, NULL, NULL, "OK", "fr"},
		{SCT_TEXT, NULL, NULL, "OK", "es"},
		{SCT_TEXT, NULL, NULL, "OK", "pt"},
		{SCT_TEXT, NULL, NULL, "OK", "it"}, {0}}},
	{"Cancel",{
		{SCT_TEXT, NULL, NULL, "Cancel", "en"},
		{SCT_TEXT, NULL, NULL, "Avbryt", "sv"},
		{SCT_TEXT, NULL, NULL, "Afbryd", "da"},
		{SCT_TEXT, NULL, NULL, "Avbryt", "no"},
		{SCT_TEXT, NULL, NULL, "Afturkalla", "is"},
		{SCT_TEXT, NULL, NULL, "Peruuta", "fi"},
		{SCT_TEXT, NULL, NULL, "Abbrechen", "de"},
		{SCT_TEXT, NULL, NULL, "Annuleren", "nl"},
		{SCT_TEXT, NULL, NULL, "Annuler", "fr"},
		{SCT_TEXT, NULL, NULL, "Cancelar", "es"},
		{SCT_TEXT, NULL, NULL, "Cancelar", "pt"},
		{SCT_TEXT, NULL, NULL, "Annulla", "it"}, {0}}},
	{"Failure",{
		{SCT_TEXT, NULL, NULL, "Failure", "en"},
		{SCT_TEXT, NULL, NULL, "Fel", "sv"},
		{SCT_TEXT, NULL, NULL, "Fejl", "da"},
		{SCT_TEXT, NULL, NULL, "Feil", "no"},
		{SCT_TEXT, NULL, NULL, "Villa", "is"},
		{SCT_TEXT, NULL, NULL, "Virhe", "fi"},
		{SCT_TEXT, NULL, NULL, "Fehler", "de"},
		{SCT_TEXT, NULL, NULL, "Fout", "nl"},
		{SCT_TEXT, NULL, NULL, "Erreur", "fr"},
		{SCT_TEXT, NULL, NULL, "Error", "es"},
		{SCT_TEXT, NULL, NULL, "Erro", "pt"},
		{SCT_TEXT, NULL, NULL, "Errore", "it"}, {0}}},
	{"Quant",{
		{SCT_TEXT, NULL, NULL, "Quantity", "en"},
		{SCT_TEXT, NULL, NULL, "Kvantitet", "sv"},
		{SCT_TEXT, NULL, NULL, "Kvantitet", "da"},
		{SCT_TEXT, NULL, NULL, "Kvantitet", "no"},
		{SCT_TEXT, NULL, NULL, "Magn", "is"},
		{SCT_TEXT, NULL, NULL, "Määrä", "fi"},
		{SCT_TEXT, NULL, NULL, "Menge", "de"},
		{SCT_TEXT, NULL, NULL, "Kwantiteit", "nl"},
		{SCT_TEXT, NULL, NULL, "Quantité", "fr"},
		{SCT_TEXT, NULL, NULL, "Cantidad", "es"},
		{SCT_TEXT, NULL, NULL, "Quantidade", "pt"},
		{SCT_TEXT, NULL, NULL, "Quantità", "it"}, {0}}},
	{"Change",{
		{SCT_TEXT, NULL, NULL, "Change", "en"},
		{SCT_TEXT, NULL, NULL, "Förändring", "sv"},
		{SCT_TEXT, NULL, NULL, "Forandring", "da"},
		{SCT_TEXT, NULL, NULL, "Endring", "no"},
		{SCT_TEXT, NULL, NULL, "Breyting", "is"},
		{SCT_TEXT, NULL, NULL, "Muutos", "fi"},
		{SCT_TEXT, NULL, NULL, "Veränderung", "de"},
		{SCT_TEXT, NULL, NULL, "Verandering", "nl"},
		{SCT_TEXT, NULL, NULL, "Changement", "fr"},
		{SCT_TEXT, NULL, NULL, "Cambio", "es"},
		{SCT_TEXT, NULL, NULL, "Mudança", "pt"},
		{SCT_TEXT, NULL, NULL, "Cambiamento", "it"}, {0}}},
	{"SumMonths",{
		{SCT_TEXT, NULL, NULL, "Sum Months", "en"},
		{SCT_TEXT, NULL, NULL, "Summa månader", "sv"},
		{SCT_TEXT, NULL, NULL, "I alt måneder", "da"},
		{SCT_TEXT, NULL, NULL, "Totale måneder", "no"},
		{SCT_TEXT, NULL, NULL, "Samtals mánuðir", "is"},
		{SCT_TEXT, NULL, NULL, "Kuukausi yhteensä", "fi"},
		{SCT_TEXT, NULL, NULL, "Gesamtmonate", "de"},
		{SCT_TEXT, NULL, NULL, "Totaal maanden", "nl"},
		{SCT_TEXT, NULL, NULL, "Total mois", "fr"},
		{SCT_TEXT, NULL, NULL, "Meses totales", "es"},
		{SCT_TEXT, NULL, NULL, "Meses totais", "pt"},
		{SCT_TEXT, NULL, NULL, "Mesi totali", "it"}, {0}}},
	{"File",{
		{SCT_TEXT, NULL, NULL, "File", "en"},
		{SCT_TEXT, NULL, NULL, "Arkiv", "sv"},
		{SCT_TEXT, NULL, NULL, "Filer", "da"},
		{SCT_TEXT, NULL, NULL, "Fil", "no"},
		{SCT_TEXT, NULL, NULL, "Skrá", "is"},
		{SCT_TEXT, NULL, NULL, "Tiedosto", "fi"},
		{SCT_TEXT, NULL, NULL, "Datei", "de"},
		{SCT_TEXT, NULL, NULL, "Bestand", "nl"},
		{SCT_TEXT, NULL, NULL, "Fichier", "fr"},
		{SCT_TEXT, NULL, NULL, "Archivo", "es"},
		{SCT_TEXT, NULL, NULL, "Ficheiro", "pt"},
		{SCT_TEXT, NULL, NULL, "File", "it"}, {0}}},
	{"Edit",{
		{SCT_TEXT, NULL, NULL, "Edit", "en"},
		{SCT_TEXT, NULL, NULL, "Redigera", "sv"},
		{SCT_TEXT, NULL, NULL, "Rediger", "da"},
		{SCT_TEXT, NULL, NULL, "Rediger", "no"},
		{SCT_TEXT, NULL, NULL, "Breyta", "is"},
		{SCT_TEXT, NULL, NULL, "Muokkaa", "fi"},
		{SCT_TEXT, NULL, NULL, "Bearbeiten", "de"},
		{SCT_TEXT, NULL, NULL, "Bewerken", "nl"},
		{SCT_TEXT, NULL, NULL, "Modifier", "fr"},
		{SCT_TEXT, NULL, NULL, "Edición", "es"},
		{SCT_TEXT, NULL, NULL, "Editar", "pt"},
		{SCT_TEXT, NULL, NULL, "Modifica", "it"}, {0}}},
	{"Exit",{
		{SCT_TEXT, NULL, NULL, "Exit", "en"},
		{SCT_TEXT, NULL, NULL, "Avsluta", "sv"},
		{SCT_TEXT, NULL, NULL, "Afslut", "da"},
		{SCT_TEXT, NULL, NULL, "Avslutt", "no"},
		{SCT_TEXT, NULL, NULL, "Hætta", "is"},
		{SCT_TEXT, NULL, NULL, "Lopeta", "fi"},
		{SCT_TEXT, NULL, NULL, "Beenden", "de"},
		{SCT_TEXT, NULL, NULL, "Afsluiten", "nl"},
		{SCT_TEXT, NULL, NULL, "Quitter", "fr"},
		{SCT_TEXT, NULL, NULL, "Salir", "es"},
		{SCT_TEXT, NULL, NULL, "Sair", "pt"},
		{SCT_TEXT, NULL, NULL, "Esci", "it"}, {0}}},
	{"Copy",{
		{SCT_TEXT, NULL, NULL, "Copy", "en"},
		{SCT_TEXT, NULL, NULL, "Kopiera", "sv"},
		{SCT_TEXT, NULL, NULL, "Kopier", "da"},
		{SCT_TEXT, NULL, NULL, "Kopier", "no"},
		{SCT_TEXT, NULL, NULL, "Afrita", "is"},
		{SCT_TEXT, NULL, NULL, "Kopioi", "fi"},
		{SCT_TEXT, NULL, NULL, "Kopieren", "de"},
		{SCT_TEXT, NULL, NULL, "Kopiëren", "nl"},
		{SCT_TEXT, NULL, NULL, "Copier", "fr"},
		{SCT_TEXT, NULL, NULL, "Copiar", "es"},
		{SCT_TEXT, NULL, NULL, "Copiar", "pt"},
		{SCT_TEXT, NULL, NULL, "Copia", "it"}, {0}}},
	{"About",{
		{SCT_TEXT, NULL, NULL, "About", "en"},
		{SCT_TEXT, NULL, NULL, "Om", "sv"},
		{SCT_TEXT, NULL, NULL, "Om", "da"},
		{SCT_TEXT, NULL, NULL, "Om", "no"},
		{SCT_TEXT, NULL, NULL, "Kringum", "is"},
		{SCT_TEXT, NULL, NULL, "Tietoja", "fi"},
		{SCT_TEXT, NULL, NULL, "Ûber", "de"},
		{SCT_TEXT, NULL, NULL, "Over", "nl"},
		{SCT_TEXT, NULL, NULL, "De", "fr"},
		{SCT_TEXT, NULL, NULL, "Sobre", "es"},
		{SCT_TEXT, NULL, NULL, "Sobre", "pt"},
		{SCT_TEXT, NULL, NULL, "Di", "it"}, {0}}},
	{"Help",{
		{SCT_TEXT, NULL, NULL, "Help", "en"},
		{SCT_TEXT, NULL, NULL, "Hjälp", "sv"},
		{SCT_TEXT, NULL, NULL, "Hjælp", "da"},
		{SCT_TEXT, NULL, NULL, "Hjelp", "no"},
		{SCT_TEXT, NULL, NULL, "Hjálp", "is"},
		{SCT_TEXT, NULL, NULL, "Ohje", "fi"},
		{SCT_TEXT, NULL, NULL, "Hilfe", "de"},
		{SCT_TEXT, NULL, NULL, "Help", "nl"},
		{SCT_TEXT, NULL, NULL, "Aide", "fr"},
		{SCT_TEXT, NULL, NULL, "Ayuda", "es"},
		{SCT_TEXT, NULL, NULL, "Ajuda", "pt"},
		{SCT_TEXT, NULL, NULL, "Guida", "it"}, {0}}},
	{"Open",{
		{SCT_TEXT, NULL, NULL, "Open", "en"},
		{SCT_TEXT, NULL, NULL, "Öppna", "sv"},
		{SCT_TEXT, NULL, NULL, "Åbn", "da"},
		{SCT_TEXT, NULL, NULL, "Åpen", "no"},
		{SCT_TEXT, NULL, NULL, "Opna", "is"},
		{SCT_TEXT, NULL, NULL, "Avaa", "fi"},
		{SCT_TEXT, NULL, NULL, "Öffnen", "de"},
		{SCT_TEXT, NULL, NULL, "Openen", "nl"},
		{SCT_TEXT, NULL, NULL, "Ouvrir", "fr"},
		{SCT_TEXT, NULL, NULL, "Abrir", "es"},
		{SCT_TEXT, NULL, NULL, "Abrir", "pt"},
		{SCT_TEXT, NULL, NULL, "Apri", "it"}, {0}}},
	{"Save",{
		{SCT_TEXT, NULL, NULL, "Save", "en"},
		{SCT_TEXT, NULL, NULL, "Spara", "sv"},
		{SCT_TEXT, NULL, NULL, "Gem", "da"},
		{SCT_TEXT, NULL, NULL, "Lagre", "no"},
		{SCT_TEXT, NULL, NULL, "Vista", "is"},
		{SCT_TEXT, NULL, NULL, "Tallenna", "fi"},
		{SCT_TEXT, NULL, NULL, "Speichern", "de"},
		{SCT_TEXT, NULL, NULL, "Opslaan", "nl"},
		{SCT_TEXT, NULL, NULL, "Enregistrer", "fr"},
		{SCT_TEXT, NULL, NULL, "Guardar", "es"},
		{SCT_TEXT, NULL, NULL, "Guardar", "pt"},
		{SCT_TEXT, NULL, NULL, "Salva", "it"}, {0}}},
	{"Refresh",{
		{SCT_TEXT, NULL, NULL, "Recount", "en"},
		{SCT_TEXT, NULL, NULL, "Räkna om", "sv"},
		{SCT_TEXT, NULL, NULL, "Tæl igen", "da"},
		{SCT_TEXT, NULL, NULL, "Tell på nytt", "no"},
		{SCT_TEXT, NULL, NULL, "Telja aftur", "is"},
		{SCT_TEXT, NULL, NULL, "Laske uudelleen", "fi"},
		{SCT_TEXT, NULL, NULL, "Erneut zählen", "de"},
		{SCT_TEXT, NULL, NULL, "Opnieuw tellen", "nl"},
		{SCT_TEXT, NULL, NULL, "Nouveau compte", "fr"},
		{SCT_TEXT, NULL, NULL, "Volver a contar", "es"},
		{SCT_TEXT, NULL, NULL, "Voltar a contar", "pt"},
		{SCT_TEXT, NULL, NULL, "Riconteggia", "it"}, {0}}},
	{"Print",{
		{SCT_TEXT, NULL, NULL, "Print", "en"},
		{SCT_TEXT, NULL, NULL, "Skriv ut", "sv"},
		{SCT_TEXT, NULL, NULL, "Udskriv", "da"},
		{SCT_TEXT, NULL, NULL, "Skriv ut", "no"},
		{SCT_TEXT, NULL, NULL, "Prenta", "is"},
		{SCT_TEXT, NULL, NULL, "Tulosta", "fi"},
		{SCT_TEXT, NULL, NULL, "Drucken", "de"},
		{SCT_TEXT, NULL, NULL, "Afdrukken", "nl"},
		{SCT_TEXT, NULL, NULL, "Imprimer", "fr"},
		{SCT_TEXT, NULL, NULL, "Imprimir", "es"},
		{SCT_TEXT, NULL, NULL, "Imprimir", "pt"},
		{SCT_TEXT, NULL, NULL, "Stampa", "it"}, {0}}},
	{"SaveAs",{
		{SCT_TEXT, NULL, NULL, "Save As", "en"},
		{SCT_TEXT, NULL, NULL, "Spara som", "sv"},
		{SCT_TEXT, NULL, NULL, "Gem som", "da"},
		{SCT_TEXT, NULL, NULL, "Lagre som", "no"},
		{SCT_TEXT, NULL, NULL, "Vista sem", "is"},
		{SCT_TEXT, NULL, NULL, "Tallenna nimellä", "fi"},
		{SCT_TEXT, NULL, NULL, "Speichern unter", "de"},
		{SCT_TEXT, NULL, NULL, "Opslaan als", "nl"},
		{SCT_TEXT, NULL, NULL, "Enregistrer sous", "fr"},
		{SCT_TEXT, NULL, NULL, "Guardar como", "es"},
		{SCT_TEXT, NULL, NULL, "Guardar como", "pt"},
		{SCT_TEXT, NULL, NULL, "Salva con", "it"}, {0}}},
	{"Do",{
		{SCT_TEXT, NULL, NULL, "Do", "en"},
		{SCT_TEXT, NULL, NULL, "Gör", "sv"},
		{SCT_TEXT, NULL, NULL, "Lave", "da"},
		{SCT_TEXT, NULL, NULL, "Gjør", "no"},
		{SCT_TEXT, NULL, NULL, "Gerðu", "is"},
		{SCT_TEXT, NULL, NULL, "Tehdä", "fi"},
		{SCT_TEXT, NULL, NULL, "Tun", "de"},
		{SCT_TEXT, NULL, NULL, "Doen", "nl"},
		{SCT_TEXT, NULL, NULL, "Faire", "fr"},
		{SCT_TEXT, NULL, NULL, "Hacer", "es"},
		{SCT_TEXT, NULL, NULL, "Fazer", "pt"},
		{SCT_TEXT, NULL, NULL, "Fai", "it"}, {0}}},
	{"New",{
		{SCT_TEXT, NULL, NULL, "New", "en"},
		{SCT_TEXT, NULL, NULL, "Ny", "sv"},
		{SCT_TEXT, NULL, NULL, "Ny", "da"},
		{SCT_TEXT, NULL, NULL, "Ny", "no"},
		{SCT_TEXT, NULL, NULL, "Nýtt", "is"},
		{SCT_TEXT, NULL, NULL, "Uusi", "fi"},
		{SCT_TEXT, NULL, NULL, "Neu", "de"},
		{SCT_TEXT, NULL, NULL, "Nieuw", "nl"},
		{SCT_TEXT, NULL, NULL, "Nouveau", "fr"},
		{SCT_TEXT, NULL, NULL, "Nuevo", "es"},
		{SCT_TEXT, NULL, NULL, "Novo", "pt"},
		{SCT_TEXT, NULL, NULL, "Nuovo", "it"}, {0}}},
	{"Delete",{
		{SCT_TEXT, NULL, NULL, "Delete", "en"},
		{SCT_TEXT, NULL, NULL, "Ta bort", "sv"},
		{SCT_TEXT, NULL, NULL, "Slet", "da"},
		{SCT_TEXT, NULL, NULL, "Slett", "no"},
		{SCT_TEXT, NULL, NULL, "Eyða", "is"},
		{SCT_TEXT, NULL, NULL, "Poista", "fi"},
		{SCT_TEXT, NULL, NULL, "Löschen", "de"},
		{SCT_TEXT, NULL, NULL, "Verwijderen", "nl"},
		{SCT_TEXT, NULL, NULL, "Supprimer", "fr"},
		{SCT_TEXT, NULL, NULL, "Eliminar", "es"},
		{SCT_TEXT, NULL, NULL, "Eliminar", "pt"},
		{SCT_TEXT, NULL, NULL, "Elimina", "it"}, {0}}},
	{"View",{
		{SCT_TEXT, NULL, NULL, "View", "en"},
		{SCT_TEXT, NULL, NULL, "Visa", "sv"},
		{SCT_TEXT, NULL, NULL, "Vis", "da"},
		{SCT_TEXT, NULL, NULL, "Visning", "no"},
		{SCT_TEXT, NULL, NULL, "Skoða", "is"},
		{SCT_TEXT, NULL, NULL, "Näytä", "fi"},
		{SCT_TEXT, NULL, NULL, "Ansicht", "de"},
		{SCT_TEXT, NULL, NULL, "Weergeven", "nl"},
		{SCT_TEXT, NULL, NULL, "Afficher", "fr"},
		{SCT_TEXT, NULL, NULL, "Vista", "es"},
		{SCT_TEXT, NULL, NULL, "Vista", "pt"},
		{SCT_TEXT, NULL, NULL, "Visualizza", "it"}, {0}}},
	{"Search",{
		{SCT_TEXT, NULL, NULL, "Search", "en"},
		{SCT_TEXT, NULL, NULL, "Sök", "sv"},
		{SCT_TEXT, NULL, NULL, "Søg", "da"},
		{SCT_TEXT, NULL, NULL, "Søk", "no"},
		{SCT_TEXT, NULL, NULL, "Leita", "is"},
		{SCT_TEXT, NULL, NULL, "Haku", "fi"},
		{SCT_TEXT, NULL, NULL, "Suche", "de"},
		{SCT_TEXT, NULL, NULL, "Zoeken", "nl"},
		{SCT_TEXT, NULL, NULL, "Rechercher", "fr"},
		{SCT_TEXT, NULL, NULL, "Buscar", "es"},
		{SCT_TEXT, NULL, NULL, "Pesquisar", "pt"},
		{SCT_TEXT, NULL, NULL, "Cerca", "it"}, {0}}},
	{"Select",{
		{SCT_TEXT, NULL, NULL, "Select", "en"},
		{SCT_TEXT, NULL, NULL, "Välj", "sv"},
		{SCT_TEXT, NULL, NULL, "Vælg", "da"},
		{SCT_TEXT, NULL, NULL, "Velg", "no"},
		{SCT_TEXT, NULL, NULL, "Velja", "is"},
		{SCT_TEXT, NULL, NULL, "Valitse", "fi"},
		{SCT_TEXT, NULL, NULL, "Auswählen", "de"},
		{SCT_TEXT, NULL, NULL, "Selecteren", "nl"},
		{SCT_TEXT, NULL, NULL, "Sélectionner", "fr"},
		{SCT_TEXT, NULL, NULL, "Seleccionar", "es"},
		{SCT_TEXT, NULL, NULL, "Selecionar", "pt"},
		{SCT_TEXT, NULL, NULL, "Seleziona", "it"}, {0}}},
	{"eMail",{
		{SCT_TEXT, NULL, NULL, "eMail", "en"},
		{SCT_TEXT, NULL, NULL, "ePost", "sv"},
		{SCT_TEXT, NULL, NULL, "eMail", "da"},
		{SCT_TEXT, NULL, NULL, "ePost", "no"},
		{SCT_TEXT, NULL, NULL, "Tölvupóstur", "is"},
		{SCT_TEXT, NULL, NULL, "Sähköposti", "fi"},
		{SCT_TEXT, NULL, NULL, "eMail", "de"},
		{SCT_TEXT, NULL, NULL, "eMail", "nl"},
		{SCT_TEXT, NULL, NULL, "Courrier électronique", "fr"},
		{SCT_TEXT, NULL, NULL, "Correo electrónico", "es"},
		{SCT_TEXT, NULL, NULL, "eMail", "pt"},
		{SCT_TEXT, NULL, NULL, "eMail", "it"}, {0}}},
	{"Waste",{
		{SCT_TEXT, NULL, NULL, "Waste", "en"},
		{SCT_TEXT, NULL, NULL, "Kasta", "sv"},
		{SCT_TEXT, NULL, NULL, "Smide", "da"},
		{SCT_TEXT, NULL, NULL, "Kaste", "no"},
		{SCT_TEXT, NULL, NULL, "Úrgangur", "is"},
		{SCT_TEXT, NULL, NULL, "Heittää", "fi"},
		{SCT_TEXT, NULL, NULL, "Werfen", "de"},
		{SCT_TEXT, NULL, NULL, "Werpen", "nl"},
		{SCT_TEXT, NULL, NULL, "Jeter", "fr"},
		{SCT_TEXT, NULL, NULL, "Tirar", "es"},
		{SCT_TEXT, NULL, NULL, "Jogar", "pt"},
		{SCT_TEXT, NULL, NULL, "Buttare", "it"}, {0}}},
	{"Dragdrop",{
		{SCT_TEXT, NULL, NULL, "Drag'n drop file here to open", "en"},
		{SCT_TEXT, NULL, NULL, "Släpp en fil här, för att öppna", "sv"},
		{SCT_TEXT, NULL, NULL, "Slip en fil her for at åbne", "da"},
		{SCT_TEXT, NULL, NULL, "Slepp en fil her for å åpne", "no"},
		{SCT_TEXT, NULL, NULL, "Slepptu skrá hér til að opna", "is"},
		{SCT_TEXT, NULL, NULL, "Vedä N pudota tiedosto avautumaan täältä", "fi"},
		{SCT_TEXT, NULL, NULL, "Lassen Sie hier eine Datei zum Öffnen", "de"},
		{SCT_TEXT, NULL, NULL, "Laat hier een bestand vrij om te openen", "nl"},
		{SCT_TEXT, NULL, NULL, "Déposez un fichier ici pour l'ouvrir", "fr"},
		{SCT_TEXT, NULL, NULL, "Suelta un archivo aquí para abrir", "es"},
		{SCT_TEXT, NULL, NULL, "Solte um arquivo aqui para abrir", "pt"},
		{SCT_TEXT, NULL, NULL, "Rilascia un file qui per aprirlo", "it"}, {0}}},
	{"SaveAsAll",{
		{SCT_TEXT, NULL, NULL, "¤", "en"},
		{SCT_TEXT, NULL, NULL, "¤", "sv"},
		{SCT_TEXT, NULL, NULL, "¤", "da"},
		{SCT_TEXT, NULL, NULL, "¤", "no"},
		{SCT_TEXT, NULL, NULL, "¤", "is"},
		{SCT_TEXT, NULL, NULL, "¤", "fi"},
		{SCT_TEXT, NULL, NULL, "¤", "de"},
		{SCT_TEXT, NULL, NULL, "¤", "nl"},
		{SCT_TEXT, NULL, NULL, "¤", "fr"},
		{SCT_TEXT, NULL, NULL, "¤", "es"},
		{SCT_TEXT, NULL, NULL, "¤", "pt"},
		{SCT_TEXT, NULL, NULL, "¤", "it"}, {0}}},
	{"Text",{
		{SCT_TEXT, NULL, NULL, "Text", "en"},
		{SCT_TEXT, NULL, NULL, "Text", "sv"},
		{SCT_TEXT, NULL, NULL, "Tekst", "da"},
		{SCT_TEXT, NULL, NULL, "Tekst", "no"},
		{SCT_TEXT, NULL, NULL, "Texti", "is"},
		{SCT_TEXT, NULL, NULL, "Teksti", "fi"},
		{SCT_TEXT, NULL, NULL, "Text", "de"},
		{SCT_TEXT, NULL, NULL, "Tekst", "nl"},
		{SCT_TEXT, NULL, NULL, "Texte", "fr"},
		{SCT_TEXT, NULL, NULL, "Texto", "es"},
		{SCT_TEXT, NULL, NULL, "Texto", "pt"},
		{SCT_TEXT, NULL, NULL, "Testo", "it"}, {0}}},
	{"Spreadsheet",{
		{SCT_TEXT, NULL, NULL, "Spreadsheet", "en"},
		{SCT_TEXT, NULL, NULL, "Kalkylprogram", "sv"},
		{SCT_TEXT, NULL, NULL, "Regnearkprogram", "da"},
		{SCT_TEXT, NULL, NULL, "Regnearkprogram", "no"},
		{SCT_TEXT, NULL, NULL, "Töflureiknir", "is"},
		{SCT_TEXT, NULL, NULL, "Laskentataulukkotiedosto", "fi"},
		{SCT_TEXT, NULL, NULL, "Tabellenkalkulation", "de"},
		{SCT_TEXT, NULL, NULL, "Spreadsheet", "nl"},
		{SCT_TEXT, NULL, NULL, "Tableur", "fr"},
		{SCT_TEXT, NULL, NULL, "Hoja de cálculo", "es"},
		{SCT_TEXT, NULL, NULL, "Planilha eletrônica", "pt"},
		{SCT_TEXT, NULL, NULL, "Foglio elettronico", "it"}, {0}}},
	{"Entity",{
		{SCT_TEXT, NULL, NULL, "Entity", "en"},
		{SCT_TEXT, NULL, NULL, "Företagsdata", "sv"},
		{SCT_TEXT, NULL, NULL, "Virksomhed", "da"},
		{SCT_TEXT, NULL, NULL, "Bedriftsdata", "no"},
		{SCT_TEXT, NULL, NULL, "Fyrirtæki Gögn", "is"},
		{SCT_TEXT, NULL, NULL, "Yrityksen tiedot", "fi"},
		{SCT_TEXT, NULL, NULL, "Firmendaten", "de"},
		{SCT_TEXT, NULL, NULL, "Bedrijven", "nl"},
		{SCT_TEXT, NULL, NULL, "Entité", "fr"},
		{SCT_TEXT, NULL, NULL, "Entidad", "es"},
		{SCT_TEXT, NULL, NULL, "Entidade", "pt"},
		{SCT_TEXT, NULL, NULL, "Entità", "it"}, {0}}},
	{"Accounts",{
		{SCT_TEXT, NULL, NULL, "Accounts", "en"},
		{SCT_TEXT, NULL, NULL, "Konton", "sv"},
		{SCT_TEXT, NULL, NULL, "Konton", "da"},
		{SCT_TEXT, NULL, NULL, "Kontoer", "no"},
		{SCT_TEXT, NULL, NULL, "Lykill", "is"},
		{SCT_TEXT, NULL, NULL, "Tili", "fi"},
		{SCT_TEXT, NULL, NULL, "Konten", "de"},
		{SCT_TEXT, NULL, NULL, "Conto", "nl"},
		{SCT_TEXT, NULL, NULL, "Comptes", "fr"},
		{SCT_TEXT, NULL, NULL, "Cuentas", "es"},
		{SCT_TEXT, NULL, NULL, "Contas", "pt"},
		{SCT_TEXT, NULL, NULL, "Conti", "it"}, {0}}},
	{"Dimensions",{
		{SCT_TEXT, NULL, NULL, "Dimension", "en"},
		{SCT_TEXT, NULL, NULL, "Dimension", "sv"},
		{SCT_TEXT, NULL, NULL, "Dimensjon", "da"},
		{SCT_TEXT, NULL, NULL, "Dimensjon", "no"},
		{SCT_TEXT, NULL, NULL, "Vídd", "is"},
		{SCT_TEXT, NULL, NULL, "Dimensio", "fi"},
		{SCT_TEXT, NULL, NULL, "Dimension", "de"},
		{SCT_TEXT, NULL, NULL, "Dimensie", "nl"},
		{SCT_TEXT, NULL, NULL, "Dimension", "fr"},
		{SCT_TEXT, NULL, NULL, "Dimensión", "es"},
		{SCT_TEXT, NULL, NULL, "Dimensão", "pt"},
		{SCT_TEXT, NULL, NULL, "Dimensione", "it"}, {0}}},
	{"Object",{
		{SCT_TEXT, NULL, NULL, "Object", "en"},
		{SCT_TEXT, NULL, NULL, "Objekt", "sv"},
		{SCT_TEXT, NULL, NULL, "Objekt", "da"},
		{SCT_TEXT, NULL, NULL, "Objekt", "no"},
		{SCT_TEXT, NULL, NULL, "Hlut", "is"},
		{SCT_TEXT, NULL, NULL, "Objekti", "fi"},
		{SCT_TEXT, NULL, NULL, "Objekt", "de"},
		{SCT_TEXT, NULL, NULL, "Object", "nl"},
		{SCT_TEXT, NULL, NULL, "Objet", "fr"},
		{SCT_TEXT, NULL, NULL, "Objeto", "es"},
		{SCT_TEXT, NULL, NULL, "Objeto", "pt"},
		{SCT_TEXT, NULL, NULL, "Oggetto", "it"}, {0}}},
	{"Series",{
		{SCT_TEXT, NULL, NULL, "Series", "en"},
		{SCT_TEXT, NULL, NULL, "Serie", "sv"},
		{SCT_TEXT, NULL, NULL, "Serie", "da"},
		{SCT_TEXT, NULL, NULL, "Serie", "no"},
		{SCT_TEXT, NULL, NULL, "Röð", "is"},
		{SCT_TEXT, NULL, NULL, "Sarja", "fi"},
		{SCT_TEXT, NULL, NULL, "Reihe", "de"},
		{SCT_TEXT, NULL, NULL, "Reeks", "nl"},
		{SCT_TEXT, NULL, NULL, "Série", "fr"},
		{SCT_TEXT, NULL, NULL, "Serie", "es"},
		{SCT_TEXT, NULL, NULL, "Série", "pt"},
		{SCT_TEXT, NULL, NULL, "Serie", "it"}, {0}}},
	{"Date",{
		{SCT_TEXT, NULL, NULL, "Date", "en"},
		{SCT_TEXT, NULL, NULL, "Datum", "sv"},
		{SCT_TEXT, NULL, NULL, "Dato", "da"},
		{SCT_TEXT, NULL, NULL, "Dato", "no"},
		{SCT_TEXT, NULL, NULL, "Dags", "is"},
		{SCT_TEXT, NULL, NULL, "Päivämäärä", "fi"},
		{SCT_TEXT, NULL, NULL, "Datum", "de"},
		{SCT_TEXT, NULL, NULL, "Datum", "nl"},
		{SCT_TEXT, NULL, NULL, "Date", "fr"},
		{SCT_TEXT, NULL, NULL, "Fecha", "es"},
		{SCT_TEXT, NULL, NULL, "Data", "pt"},
		{SCT_TEXT, NULL, NULL, "Data", "it"}, {0}}},
	{"Debit",{
		{SCT_TEXT, NULL, NULL, "Debit", "en"},
		{SCT_TEXT, NULL, NULL, "Debet", "sv"},
		{SCT_TEXT, NULL, NULL, "Debet", "da"},
		{SCT_TEXT, NULL, NULL, "Debet", "no"},
		{SCT_TEXT, NULL, NULL, "Debet", "is"},
		{SCT_TEXT, NULL, NULL, "Debet", "fi"},
		{SCT_TEXT, NULL, NULL, "Debet", "de"},
		{SCT_TEXT, NULL, NULL, "Debet", "nl"},
		{SCT_TEXT, NULL, NULL, "Débit", "fr"},
		{SCT_TEXT, NULL, NULL, "Débito", "es"},
		{SCT_TEXT, NULL, NULL, "Débito", "pt"},
		{SCT_TEXT, NULL, NULL, "Dare", "it"}, {0}}},
	{"Credit",{
		{SCT_TEXT, NULL, NULL, "Credit", "en"},
		{SCT_TEXT, NULL, NULL, "Kredit", "sv"},
		{SCT_TEXT, NULL, NULL, "Kredit", "da"},
		{SCT_TEXT, NULL, NULL, "Kredit", "no"},
		{SCT_TEXT, NULL, NULL, "Credit", "is"},
		{SCT_TEXT, NULL, NULL, "Kredit", "fi"},
		{SCT_TEXT, NULL, NULL, "Kredit", "de"},
		{SCT_TEXT, NULL, NULL, "Credit", "nl"},
		{SCT_TEXT, NULL, NULL, "Crédit", "fr"},
		{SCT_TEXT, NULL, NULL, "Crédito", "es"},
		{SCT_TEXT, NULL, NULL, "Crédito", "pt"},
		{SCT_TEXT, NULL, NULL, "Avere", "it"}, {0}}},
	{"NewAccounting",{
		{SCT_TEXT, NULL, NULL, "New Accounting", "en"},
		{SCT_TEXT, NULL, NULL, "Ny bokföring", "sv"},
		{SCT_TEXT, NULL, NULL, "Ny bogføring", "da"},
		{SCT_TEXT, NULL, NULL, "Ny bokføring", "no"},
		{SCT_TEXT, NULL, NULL, "Ný bókhald", "is"},
		{SCT_TEXT, NULL, NULL, "Uusi kirjanpito", "fi"},
		{SCT_TEXT, NULL, NULL, "Neue Buchhaltung", "de"},
		{SCT_TEXT, NULL, NULL, "Nieuwe boekhouding", "nl"},
		{SCT_TEXT, NULL, NULL, "Nouvelle comptabilité", "fr"},
		{SCT_TEXT, NULL, NULL, "Nueva contabilidad", "es"},
		{SCT_TEXT, NULL, NULL, "Nova contabilidade", "pt"},
		{SCT_TEXT, NULL, NULL, "Nuova contabilità", "it"}, {0}}},
	{"NewYear",{
		{SCT_TEXT, NULL, NULL, "New Year", "en"},
		{SCT_TEXT, NULL, NULL, "Nytt år", "sv"},
		{SCT_TEXT, NULL, NULL, "Nyt år", "da"},
		{SCT_TEXT, NULL, NULL, "Nytt år", "no"},
		{SCT_TEXT, NULL, NULL, "Nýtt ár", "is"},
		{SCT_TEXT, NULL, NULL, "Uusivuosi", "fi"},
		{SCT_TEXT, NULL, NULL, "Neu jahr", "de"},
		{SCT_TEXT, NULL, NULL, "Nieuw jaar", "nl"},
		{SCT_TEXT, NULL, NULL, "Nouvel an", "fr"},
		{SCT_TEXT, NULL, NULL, "Año Nuevo", "es"},
		{SCT_TEXT, NULL, NULL, "Ano Novo", "pt"},
		{SCT_TEXT, NULL, NULL, "Anno nuovo", "it"}, {0}}},
	{"Import",{
		{SCT_TEXT, NULL, NULL, "Import", "en"},
		{SCT_TEXT, NULL, NULL, "Import", "sv"},
		{SCT_TEXT, NULL, NULL, "Import", "da"},
		{SCT_TEXT, NULL, NULL, "Import", "no"},
		{SCT_TEXT, NULL, NULL, "Innflutningur", "is"},
		{SCT_TEXT, NULL, NULL, "Tuo", "fi"},
		{SCT_TEXT, NULL, NULL, "Importieren", "de"},
		{SCT_TEXT, NULL, NULL, "Importeren", "nl"},
		{SCT_TEXT, NULL, NULL, "Importer", "fr"},
		{SCT_TEXT, NULL, NULL, "Importar", "es"},
		{SCT_TEXT, NULL, NULL, "Importar", "pt"},
		{SCT_TEXT, NULL, NULL, "Importa", "it"}, {0}}},
	{"Audit",{
		{SCT_TEXT, NULL, NULL, "Audit", "en"},
		{SCT_TEXT, NULL, NULL, "Granska", "sv"},
		{SCT_TEXT, NULL, NULL, "Gennemgang", "da"},
		{SCT_TEXT, NULL, NULL, "Gjennomgang", "no"},
		{SCT_TEXT, NULL, NULL, "Endurskoðun", "is"},
		{SCT_TEXT, NULL, NULL, "Tarkastaa", "fi"},
		{SCT_TEXT, NULL, NULL, "Rezension", "de"},
		{SCT_TEXT, NULL, NULL, "Beoordeling", "nl"},
		{SCT_TEXT, NULL, NULL, "Révision", "fr"},
		{SCT_TEXT, NULL, NULL, "Revisión", "es"},
		{SCT_TEXT, NULL, NULL, "Revisão", "pt"},
		{SCT_TEXT, NULL, NULL, "Recensione", "it"}, {0}}},
	{"Expand",{
		{SCT_TEXT, NULL, NULL, "Expand", "en"},
		{SCT_TEXT, NULL, NULL, "Expandera", "sv"},
		{SCT_TEXT, NULL, NULL, "Udvid", "da"},
		{SCT_TEXT, NULL, NULL, "Utvid", "no"},
		{SCT_TEXT, NULL, NULL, "Útvíkka", "is"},
		{SCT_TEXT, NULL, NULL, "Laajenna", "fi"},
		{SCT_TEXT, NULL, NULL, "Erweitern", "de"},
		{SCT_TEXT, NULL, NULL, "Uitvouwen", "nl"},
		{SCT_TEXT, NULL, NULL, "Développer", "fr"},
		{SCT_TEXT, NULL, NULL, "Expandir", "es"},
		{SCT_TEXT, NULL, NULL, "Expandir", "pt"},
		{SCT_TEXT, NULL, NULL, "Espandi", "it"}, {0}}},
	{"Sector",{
		{SCT_TEXT, NULL, NULL, "Section", "en"},
		{SCT_TEXT, NULL, NULL, "Avsnitt", "sv"},
		{SCT_TEXT, NULL, NULL, "Sektion", "da"},
		{SCT_TEXT, NULL, NULL, "Seksjon", "no"},
		{SCT_TEXT, NULL, NULL, "Kafla", "is"},
		{SCT_TEXT, NULL, NULL, "Jakso", "fi"},
		{SCT_TEXT, NULL, NULL, "Abschnitt", "de"},
		{SCT_TEXT, NULL, NULL, "Sectie", "nl"},
		{SCT_TEXT, NULL, NULL, "Section", "fr"},
		{SCT_TEXT, NULL, NULL, "Sección", "es"},
		{SCT_TEXT, NULL, NULL, "Seção", "pt"},
		{SCT_TEXT, NULL, NULL, "Sezione", "it"}, {0}}},
	{"TabAdd",{
		{SCT_TEXT, NULL, NULL, "Tab New", "en"},
		{SCT_TEXT, NULL, NULL, "Flik Ny", "sv"},
		{SCT_TEXT, NULL, NULL, "Fane Ny", "da"},
		{SCT_TEXT, NULL, NULL, "Fane Ny", "no"},
		{SCT_TEXT, NULL, NULL, "Flipi Nýtt", "is"},
		{SCT_TEXT, NULL, NULL, "Uusi Välilehti", "fi"},
		{SCT_TEXT, NULL, NULL, "Registerkarte Neu", "de"},
		{SCT_TEXT, NULL, NULL, "Tab Nieuw", "nl"},
		{SCT_TEXT, NULL, NULL, "Onglet Nouveau", "fr"},
		{SCT_TEXT, NULL, NULL, "Pestaña Nuevo", "es"},
		{SCT_TEXT, NULL, NULL, "Separador Novo", "pt"},
		{SCT_TEXT, NULL, NULL, "Scheda Nuovo", "it"}, {0}}},
	{"TabDelete",{
		{SCT_TEXT, NULL, NULL, "Tab Delete", "en"},
		{SCT_TEXT, NULL, NULL, "Flik Ta bort", "sv"},
		{SCT_TEXT, NULL, NULL, "Fane Slet", "da"},
		{SCT_TEXT, NULL, NULL, "Fane Slett", "no"},
		{SCT_TEXT, NULL, NULL, "Flipi Eyða", "is"},
		{SCT_TEXT, NULL, NULL, "Välilehti poistetaa", "fi"},
		{SCT_TEXT, NULL, NULL, "Registerkarte Löschen", "de"},
		{SCT_TEXT, NULL, NULL, "Tab Verwijderen", "nl"},
		{SCT_TEXT, NULL, NULL, "Onglet Supprimer", "fr"},
		{SCT_TEXT, NULL, NULL, "Pestaña Eliminar", "es"},
		{SCT_TEXT, NULL, NULL, "Separador Eliminar", "pt"},
		{SCT_TEXT, NULL, NULL, "Scheda Elimina", "it"}, {0}}},
	{"Budget",{
		{SCT_TEXT, NULL, NULL, "Budget", "en"},
		{SCT_TEXT, NULL, NULL, "Budget", "sv"},
		{SCT_TEXT, NULL, NULL, "Budget", "da"},
		{SCT_TEXT, NULL, NULL, "Budsjett", "no"},
		{SCT_TEXT, NULL, NULL, "Áætlun", "is"},
		{SCT_TEXT, NULL, NULL, "Budjetti", "fi"},
		{SCT_TEXT, NULL, NULL, "Budget", "de"},
		{SCT_TEXT, NULL, NULL, "Budget", "nl"},
		{SCT_TEXT, NULL, NULL, "Budget", "fr"},
		{SCT_TEXT, NULL, NULL, "Presupuesto", "es"},
		{SCT_TEXT, NULL, NULL, "Orçamento", "pt"},
		{SCT_TEXT, NULL, NULL, "Budget", "it"}, {0}}},
	{"Note",{
		{SCT_TEXT, NULL, NULL, "Note", "en"},
		{SCT_TEXT, NULL, NULL, "Not", "sv"},
		{SCT_TEXT, NULL, NULL, "Nota", "da"},
		{SCT_TEXT, NULL, NULL, "Nota", "no"},
		{SCT_TEXT, NULL, NULL, "Nota", "is"},
		{SCT_TEXT, NULL, NULL, "Huomautus", "fi"},
		{SCT_TEXT, NULL, NULL, "Nota", "de"},
		{SCT_TEXT, NULL, NULL, "Nota", "nl"},
		{SCT_TEXT, NULL, NULL, "Note", "fr"},
		{SCT_TEXT, NULL, NULL, "Nota", "es"},
		{SCT_TEXT, NULL, NULL, "Nota", "pt"},
		{SCT_TEXT, NULL, NULL, "Nota", "it"}, {0}}},
	{"FileContent",{
		{SCT_TEXT, NULL, NULL, "File content", "en"},
		{SCT_TEXT, NULL, NULL, "Filinnehåll", "sv"},
		{SCT_TEXT, NULL, NULL, "Filindhold", "da"},
		{SCT_TEXT, NULL, NULL, "Filinnhold", "no"},
		{SCT_TEXT, NULL, NULL, "Skrá innihald", "is"},
		{SCT_TEXT, NULL, NULL, "Tiedoston sisältö", "fi"},
		{SCT_TEXT, NULL, NULL, "Dateiinhalt", "de"},
		{SCT_TEXT, NULL, NULL, "Bestandsinhoud", "nl"},
		{SCT_TEXT, NULL, NULL, "Contenu de fichier", "fr"},
		{SCT_TEXT, NULL, NULL, "Contenido de archivo", "es"},
		{SCT_TEXT, NULL, NULL, "Conteúdo de arquivo", "pt"},
		{SCT_TEXT, NULL, NULL, "Contenuto file", "it"}, {0}}},
	{"LastEntryDate",{
		{SCT_TEXT, NULL, NULL, "Last entry date", "en"},
		{SCT_TEXT, NULL, NULL, "Sista inmatningsdatum", "sv"},
		{SCT_TEXT, NULL, NULL, "Sidste indtastningsdato", "da"},
		{SCT_TEXT, NULL, NULL, "Siste innleveringsdato", "no"},
		{SCT_TEXT, NULL, NULL, "Síðasti dagsetningin", "is"},
		{SCT_TEXT, NULL, NULL, "Viimeinen merkintäpäivä", "fi"},
		{SCT_TEXT, NULL, NULL, "Datum des letzten Eintritts", "de"},
		{SCT_TEXT, NULL, NULL, "Laatste invoerdatum", "nl"},
		{SCT_TEXT, NULL, NULL, "Date de dernière entrée", "fr"},
		{SCT_TEXT, NULL, NULL, "Última fecha de entrada", "es"},
		{SCT_TEXT, NULL, NULL, "Data da última entrada", "pt"},
		{SCT_TEXT, NULL, NULL, "Ultima data di iscrizione", "it"}, {0}}},
	{"Currency",{
		{SCT_TEXT, NULL, NULL, "Currency", "en"},
		{SCT_TEXT, NULL, NULL, "Valuta", "sv"},
		{SCT_TEXT, NULL, NULL, "Valuta", "da"},
		{SCT_TEXT, NULL, NULL, "Valuta", "no"},
		{SCT_TEXT, NULL, NULL, "Gjaldmiðill", "is"},
		{SCT_TEXT, NULL, NULL, "Valuutta", "fi"},
		{SCT_TEXT, NULL, NULL, "Währung", "de"},
		{SCT_TEXT, NULL, NULL, "Valuta", "nl"},
		{SCT_TEXT, NULL, NULL, "Devise", "fr"},
		{SCT_TEXT, NULL, NULL, "Moneda", "es"},
		{SCT_TEXT, NULL, NULL, "Moeda", "pt"},
		{SCT_TEXT, NULL, NULL, "Valuta", "it"}, {0}}},
	{"MainLanguage",{
		{SCT_TEXT, NULL, NULL, "Main language", "en"},
		{SCT_TEXT, NULL, NULL, "Huvudspråk", "sv"},
		{SCT_TEXT, NULL, NULL, "Hovedsprog", "da"},
		{SCT_TEXT, NULL, NULL, "Hovedspråk", "no"},
		{SCT_TEXT, NULL, NULL, "Aðalmál", "is"},
		{SCT_TEXT, NULL, NULL, "Pääkieli", "fi"},
		{SCT_TEXT, NULL, NULL, "Hauptsprache", "de"},
		{SCT_TEXT, NULL, NULL, "Hoofdtaal", "nl"},
		{SCT_TEXT, NULL, NULL, "Langue principale", "fr"},
		{SCT_TEXT, NULL, NULL, "Lengua principal", "es"},
		{SCT_TEXT, NULL, NULL, "Língua principal", "pt"},
		{SCT_TEXT, NULL, NULL, "lingua principale", "it"}, {0}}},
	{"FailureNoFileName",{
		{SCT_TEXT, NULL, NULL, "Failure, no file name", "en"},
		{SCT_TEXT, NULL, NULL, "Fel, inget filnamn", "sv"},
		{SCT_TEXT, NULL, NULL, "Fejl, intet filnavn", "da"},
		{SCT_TEXT, NULL, NULL, "Feil, ikke filnavn", "no"},
		{SCT_TEXT, NULL, NULL, "Villa, engin skráarnöfn", "is"},
		{SCT_TEXT, NULL, NULL, "Virhe, ei tiedostonimeä", "fi"},
		{SCT_TEXT, NULL, NULL, "Fehler, kein Dateiname", "de"},
		{SCT_TEXT, NULL, NULL, "Fout, geen bestandsnaam", "nl"},
		{SCT_TEXT, NULL, NULL, "Erreur, pas de nom de fichier", "fr"},
		{SCT_TEXT, NULL, NULL, "Error, sin nombre de archivo", "es"},
		{SCT_TEXT, NULL, NULL, "Erro, sem nome de arquivo", "pt"},
		{SCT_TEXT, NULL, NULL, "Errore, nessun nome file", "it"}, {0}}},
	{"FailureNoneIncorrectFileContent",{
		{SCT_TEXT, NULL, NULL, "Failure, none or incorrect file content", "en"},
		{SCT_TEXT, NULL, NULL, "Fel, inget eller felaktigt filinnehåll", "sv"},
		{SCT_TEXT, NULL, NULL, "Fejl, intet eller forkert filindhold", "da"},
		{SCT_TEXT, NULL, NULL, "Feil, inget eller feil filinnhold", "no"},
		{SCT_TEXT, NULL, NULL, "Villa, Nei eða Rangt File Content", "is"},
		{SCT_TEXT, NULL, NULL, "Virhe, mikään tai virheellinen tiedoston sisältö", "fi"},
		{SCT_TEXT, NULL, NULL, "Fehler, kein oder falscher Dateiinhalt", "de"},
		{SCT_TEXT, NULL, NULL, "Fout, geen of onjuiste bestandsinhou", "nl"},
		{SCT_TEXT, NULL, NULL, "Erreur, contenu de fichier inexistant ou incorrect", "fr"},
		{SCT_TEXT, NULL, NULL, "Error, No o contenido de archivo incorrecto", "es"},
		{SCT_TEXT, NULL, NULL, "Erro, Não ou conteúdo de arquivo incorreto", "pt"},
		{SCT_TEXT, NULL, NULL, "Errore, no o contenuto file errato", "it"}, {0}}},
	{"FailureExpired",{
		{SCT_TEXT, NULL, NULL, "Failure, this program expire date is past", "en"},
		{SCT_TEXT, NULL, NULL, "Fel, programmets licens har utgått", "sv"},
		{SCT_TEXT, NULL, NULL, "Fejl, programlicens er udløbet", "da"},
		{SCT_TEXT, NULL, NULL, "Feil, programlisens er utløpt", "no"},
		{SCT_TEXT, NULL, NULL, "Villa, forritaleyfi hefur runnið út", "is"},
		{SCT_TEXT, NULL, NULL, "Virhe, Ohjelman käyttöoikeus on vanhentunut", "fi"},
		{SCT_TEXT, NULL, NULL, "Fehler, Programmlizenz ist abgelaufen", "de"},
		{SCT_TEXT, NULL, NULL, "Fout, programmalicentie is verlopen", "nl"},
		{SCT_TEXT, NULL, NULL, "Erreur, la licence du programme a expiré", "fr"},
		{SCT_TEXT, NULL, NULL, "Error, la licencia del programa ha expirado", "es"},
		{SCT_TEXT, NULL, NULL, "Erro, a licença do programa expirou", "pt"},
		{SCT_TEXT, NULL, NULL, "Errore, la licenza del programma è scaduta", "it"}, {0}}},
	{"FailureOsVersion",{
		{SCT_TEXT, NULL, NULL, "This feature is not supported by your unit's base softweare (Operating system)", "en"},
		{SCT_TEXT, NULL, NULL, "Denna funktion fungerar inte i din enhets grundprogram (operativsystemet)", "sv"},
		{SCT_TEXT, NULL, NULL, "Denne funktion virker ikke i enhedens grundlæggende program (operativsystem)", "da"},
		{SCT_TEXT, NULL, NULL, "Denne funksjonen støttes ikke av enhetens basisprogramvare (operativsystem)", "no"},
		{SCT_TEXT, NULL, NULL, "Þessi eiginleiki virkar ekki grunn hugbúnað einingarinnar þíns (stýrikerfi)", "is"},
		{SCT_TEXT, NULL, NULL, "Yksikön tukipalvelut eivät tue tätä toimintoa (käyttöjärjestelmä)", "fi"},
		{SCT_TEXT, NULL, NULL, "Diese Funktion wird von der Basis-Software Ihrer Einheit nicht unterstützt (Betriebssystem)", "de"},
		{SCT_TEXT, NULL, NULL, "Deze functie wordt niet ondersteund door de softweare van uw apparaat (besturingssysteem)", "nl"},
		{SCT_TEXT, NULL, NULL, "Cette fonctionnalité n'est pas prise en charge par le logiciel de base de votre appareil (système d'exploitation)", "fr"},
		{SCT_TEXT, NULL, NULL, "Den här funktionen är inte kompatibel med enhetens programvara (operativsystem)", "es"},
		{SCT_TEXT, NULL, NULL, "Este recurso não é suportado pelo softweare base da sua unidade (sistema operacional)", "pt"},
		{SCT_TEXT, NULL, NULL, "Questa funzione non è supportata dal software di base della tua unità (sistema operativo)", "it"}, {0}}},
	{"FailurePermission",{
		{SCT_TEXT, NULL, NULL, "Failure, no system permission", "en"},
		{SCT_TEXT, NULL, NULL, "Fel, saknar behörighet att öppna fil", "sv"},
		{SCT_TEXT, NULL, NULL, "Fejl, kan ikke åbne fil", "da"},
		{SCT_TEXT, NULL, NULL, "Feil, kan ikke åpne fil", "no"},
		{SCT_TEXT, NULL, NULL, "Villa, ekki hægt að opna skrá", "is"},
		{SCT_TEXT, NULL, NULL, "Virhe, Tiedostoa ei voi avata", "fi"},
		{SCT_TEXT, NULL, NULL, "Fehler, Datei kann nicht geöffnet werden", "de"},
		{SCT_TEXT, NULL, NULL, "Fout, kan bestand niet openen", "nl"},
		{SCT_TEXT, NULL, NULL, "Erreur, impossible d'ouvrir le fichier", "fr"},
		{SCT_TEXT, NULL, NULL, "Error, no se puede abrir el archivo", "es"},
		{SCT_TEXT, NULL, NULL, "Erro, não é possível abrir o arquivo", "pt"},
		{SCT_TEXT, NULL, NULL, "Errore, impossibile aprire il file", "it"}, {0}}},
	{"FailureCloseFile",{
		{SCT_TEXT, NULL, NULL, "Failure, close file", "en"},
		{SCT_TEXT, NULL, NULL, "Fel, stänga filen", "sv"},
		{SCT_TEXT, NULL, NULL, "Fejl, luk filen", "da"},
		{SCT_TEXT, NULL, NULL, "Feil, lukk filen", "no"},
		{SCT_TEXT, NULL, NULL, "Villa, loka skrá", "is"},
		{SCT_TEXT, NULL, NULL, "Virhe, Sulje tiedosto", "fi"},
		{SCT_TEXT, NULL, NULL, "Fehler, Datei schließen", "de"},
		{SCT_TEXT, NULL, NULL, "Fout, bestand sluiten", "nl"},
		{SCT_TEXT, NULL, NULL, "Erreur, fermer le fichier", "fr"},
		{SCT_TEXT, NULL, NULL, "Error, archivo cerrado", "es"},
		{SCT_TEXT, NULL, NULL, "Erro, fechar arquivo", "pt"},
		{SCT_TEXT, NULL, NULL, "Errore, chiudi il file", "it"}, {0}}},
	{"FailureSystemError",{
		{SCT_TEXT, NULL, NULL, "System error", "en"},
		{SCT_TEXT, NULL, NULL, "Systemfel", "sv"},
		{SCT_TEXT, NULL, NULL, "Systemfejl", "da"},
		{SCT_TEXT, NULL, NULL, "Systemfeil", "no"},
		{SCT_TEXT, NULL, NULL, "Kerfis Villa", "is"},
		{SCT_TEXT, NULL, NULL, "Virhe, Järjestelmävirhe", "fi"},
		{SCT_TEXT, NULL, NULL, "Systemfehler", "de"},
		{SCT_TEXT, NULL, NULL, "Systeemfout", "nl"},
		{SCT_TEXT, NULL, NULL, "Erreur système", "fr"},
		{SCT_TEXT, NULL, NULL, "Error del sistema", "es"},
		{SCT_TEXT, NULL, NULL, "Erro do sistema", "pt"},
		{SCT_TEXT, NULL, NULL, "Errore di sistema", "it"}, {0}}},
	{0}
};

EnumType EnumHelpTextType[]=
{
	{"AboutMessage",{
		{SCT_TEXT, NULL, NULL, "Read and analyze your accounting!\n\nRosetta displays reports from SIE and XBRL/GL accounting files. View files attached to an email, stored in computer memory, or provided by other programs, such as on an Internet server.\n\nThe reports can be displayed, printed, saved as text files, for use in spreadsheet programs for in-depth analysis and presentation. It can be saved and read in XBRL/GL file format. Click ahead!\n\nAll economy system programs that is distributed in Sweden the last 20 years supports SIE files for reading and writing, and so also much of the global market (SIE support is not marketed outside Sweden).\n\nAsk your provider of accounting system, about SIE support. Mail the user who can read the SIE file, which is displayed as an economic report for information retrieval.\n\nSIE - XBRL/GL\nSIE (www.sie.se) is a Swedish vendor interest group with general accounting file exchange format and applied methods. The basic idea is that all providers support the file format for information sharing, thus also the conversion of internal logical data formats into a common practice. The initial motivation for the SIE group was exchange of information with income tax reporting programs and pre systems like for payroll, payables and receivables.\n\nXBRL/GL is popular among audits and accountants internationally and is a file format with the same intent by XBRL/GL International: www.xbrl.org/the-standard/what/global-ledger/", "en"},
		{SCT_TEXT, NULL, NULL, "Läs och analysera din bokföring!\n\nRosetta visar rapporter från SIE och XBRL/GL bokföringsfiler. Det visar filer som bifogas ett e-postmeddelande, lagras i datorminnet eller som andra program tillhandahåller, ex på en Internet-server.\n\nRapporterna kan visas, skrivas ut och sparas som textfiler, för användning i kalkylarksprogram för djupare analys och presentation. Den kan sparas och läsas i XBRL/GL-filformat. Klicka dig fram!\n\nAlla ekonomiprogram som distribueras i Sverige de senaste 20 åren stöder SIE-filer för läsning och skrivning, och på så sätt mycket av den globala marknaden (SIE-stöd marknadsförs inte utanför Sverige).\n\nFråga din leverantör av bokföringssystem om SIE-support. Maila användaren som kan läsa SIE-filen, som visas som en ekonomisk rapport för informationsåterkoppling.\n\nSIE - XBRL/GL\nSIE (www.sie.se) är en svensk leverantörsinteressegrupp med ett allmänt utbytesformat för bokföringsfiler och tillämpade metoder. Grundtanken är att alla leverantörer stöder filformatet för informationsutbyte. Inte bara filformatet utan även omvandling av interna logiska dataformat till en gemensam praxis. Den inledande motivationen för SIE-gruppen var informationsutbyte med inkomstskattrapporteringsprogram och pre-system som för löner, inventarier, betalningar och fordringar (reskontra).\n\nXBRL/GL är populärt bland revisioner och redovisningskonsulter internationellt och är ett filformat, med samma avsikt av XBRL/GL International: www.xbrl.org/the-standard/what/global-ledger/", "sv"},
		{SCT_TEXT, NULL, NULL, "Læs og analyser dit regnskab!\n\nRosetta viser rapporter fra SIE og XBRL/GL regnskabs filer. Se filer, der er vedhæftet en e-mail, gemt i computerens hukommelse eller leveres af andre programmer, f.eks. på en internetserver.\n\nRapporterne kan vises, udskrives og gemmes som tekstfiler til brug i regnearksprogrammer til dybdegående analyse og præsentation. Det kan gemmes og læses i XBRL/GL filformat. Klik på dig!\n\nAlle økonomi-program som distribueres i Sverige i løbet af de seneste 20 år understøtter SIE-filer til læsning og skrivning, og så meget af det globale marked (SIE understøttelse er ikke markedsføres udenfor Sverige).\n\nSpørg din udbyder af regnskabssystem, om SIE-support. Send brugeren, der kan læse SIE-filen, som vises som en økonomisk rapport til hentning af oplysninger.\n\nSIE - XBRL/GL\nSIE (www.sie.se) er en svensk leverandør interessegruppe til en udveksling format til bogførings-filer og metoder, der anvendes. Den grundlæggende idé er, at alle leverandører støtte filformat til informationsudveksling. Ikke blot filen, men også omdannelsen af det indre logiske dataformat til en fælles praksis. Den oprindelige motivation for SIE-gruppe var udveksling af information med indkomstskatrapporteringsprogrammer og præsystemer som for lønninger, gæld og tilgodehavender.\n\nXBRL/GL er populært blandt revisioner og bogholder internationalt og er et filformat, med samme hensigt af XBRL/GL International: www.xbrl.org/the-standard/what/global-ledger/", "da"},
		{SCT_TEXT, NULL, NULL, "Les og analyser regnskapet ditt!\n\nRosetta viser rapporter fra SIE og XBRL/GL regnskapsfiler. Se filer som er koblet til en e-post som er lagret i datamaskinens minne eller levert av andre programmer, for eksempel på en internett-server.\n\nRapportene kan vises, skrives ut og lagres som tekstfiler, for bruk i regnearkprogrammer for grundig analyse og presentasjon. Den kan lagres og leses i XBRL/GL filformat. Klikk på deg!\n\nAlle økonomi-program som distribueres i Sverige i løpet av de siste 20 årene støtter SIE-filer for lesing og skriving, og så mye av det globale markedet (SIE-støtte er ikke markedsført utenfor Sverige).\n\nSpør leverandøren av regnskapssystemet, om SIE-støtte. Send brukeren som kan lese SIE-filen, som vises som en økonomisk rapport for innhenting av informasjon.\n\nSIE - XBRL/GL\nSIE (www.sie.se) er en svensk leverandør interesserte grupper med en felles utvekslingsformat for bokføringsfiler og metoder som brukes. Den grunnleggende ideen er at alle leverandører støtter filformatet for utveksling av informasjon. Ikke bare formatet, men også transformasjonen av interne logiske dataformater i en felles praksis. Den innledende motivasjon for SIE gruppen var utveksling av informasjon med skatterapporterings programmer og pre-system for lønn, gjeld og fordringer.\n\nXBRL/GL er populært blant revisjoner og regnskapsførere internasjonalt og er et filformat, med samme hensikt XBRL/GL International: www.xbrl.org/the-standard/what/global-ledger/", "no"},
		{SCT_TEXT, NULL, NULL, "Lesa og greina bókhald þitt!\n\nRosetta sýnir skýrslur frá SIE og XBRL/GL bókhaldsskrám. Skoða skrár sem eru tengdir tölvupósti, geymd í tölvu minni eða með öðrum forritum, svo sem á netþjón. Skýrslurnar geta verið sýndar, prentaðar og vistaðar sem textaskrár, til notkunar í töflureikni fyrir ítarlega greiningu og kynningu. Það er hægt að vista og lesa í XBRL/GL skráarsnið. Smelltu á þig!\n\nAllt hagkerfi programs sem er dreift í Svíþjóð síðastliðin 20 ár styður SIE skrár til að lesa og skrifa og svo mikið af heimsmarkaði (SIE stuðningur er ekki markaðssettur utan Svíþjóðar).\n\nSpyrðu fyrir hendi þína af bókhaldskerfi, um SIE stuðning. Sendu tölvupóst til notandans sem getur lesið SIE skrána, sem birtist sem efnahagsskýrsla til að fá upplýsingar.\n\nSIE - XBRL/GL\nSIE (www.sie.se) er sænskur birgir áhuga hóp til að skiptast snið fyrir reikningsskilatímabil skrár og aðferðir sem notaðar eru. Grunnhugmyndin er sú að allir framleiðendur styðja skráarsnið til að skiptast á upplýsingum. Ekki aðeins skrá, en einnig umbreyting innri rökfræði gögn snið til að algengt. Upprunalega hvatning fyrir SIE hópinn var að skiptast á upplýsingum með tekjuskatts skýrslugerð áætlanir og præsystemer sem fyrir laun, viðskiptaskulda og krafna.\n\nXBRL/GL er vinsælt meðal endurskoðunar og bókhaldar á alþjóðavettvangi og er skráarsnið með sömu áformi XBRL/GL International: www.xbrl.org/the-standard/what/global-ledger/", "is"},
		{SCT_TEXT, NULL, NULL, "Lue ja analysoi kirjanpito!\n\nRossetta raportoi SIE ja XBRL/GL kirjanpitotiedostoista. Se näyttää liitetiedostot sähköpostin viestin, tietokoneen muistiin tallennettujen tai muita ohjelmia, esimerkiksi siitä Internet-palvelimen.\n\nRaportit voidaan näyttää, tulostaa, tallentaa tekstitiedostoina ja käyttää niitä laskentataulukko-ohjelmissa analyysi ja esitys. Se voidaan tallentaa ja lukea XBRL/GL-tiedostomuodossa. Napsauta eteenpäin! \n\nKulmassa 20 vuoden aikana Ruotsissa jakamaa kirjanpitojärjestelmää tukee SIE-tiedostoja lukemista ja kirjoittamista varten ja niin paljon maailmanmarkkinoita (SIE-tukea ei markkinoida Ruotsin ulkopuolella).\n\nKokeile kirjanpitojärjestelmän tarjoaja, SIE-tukea. Lähetä käyttäjälle, joka osaa lukea SIE-tiedostoa, joka näkyy taloudellisena raporttina tiedonhakuun.\n\nSIE - XBRL/GL\nSIE (www.sie.se) on ruotsalainen tavarantoimittajaryhmä, jolla on yleinen kirjanpidon tiedostomuoto ja sovelletut menetelmät. Perusajatuksena on, että kaikki palveluntarjoajat tukevat tietojen jakamisen tiedostomuotoa, jolloin myös sisäisten loogisten datamuotojen muuntaminen yleiseksi käytännöksi. SIE-ryhmän ensisijainen motivaatio oli tiedonvaihto tuloverotusohjelmien ja ennakkojärjestelmien kanssa, kuten palkkasumma, velat ja saamiset.\n\nXBRL/GL on suosittu tilintarkastajien ja kirjanpitäjien välillä kansainvälisesti ja on tiedostomuoto, jonka XBRL/GL International: XBRL/GL International: www.xbrl.org/the-standard/what/global-ledger/", "fi"},
		{SCT_TEXT, NULL, NULL, "Lesen und analysieren Sie Ihre Buchhaltung!\n\nRosetta zeigt Berichte aus SIE und XBRL/GL Buchhaltungsdateien an. Dateien anzeigen, die an eine E-Mail angehängt sind, im Computerspeicher gespeichert sind oder von anderen Programmen bereitgestellt werden, z. B. auf einem Internetserver.\n\nDie Berichte können angezeigt, gedruckt und als Textdateien gespeichert werden, um sie in Tabellenkalkulationsprogrammen für eine detaillierte Analyse und Präsentation zu verwenden. Es kann gespeichert und im XBRL/GL-Dateiformat gelesen werden. Klicken Sie auf!\n\nAlle Buchhaltungsprogramme die in Schweden in den letzten 20 Jahren vertrieben wurden, unterstützen SIE-Dateien zum Lesen und speichern und damit auch einen große Teil des globalen Marktes (SIE-Unterstützung wird nicht außerhalb von Schweden vermarktet).\n\nFragen Sie Ihren Anbieter von Buchhaltungssystem, über SIE-Unterstützung. E-Mail an den Benutzer, der die SIE-Datei lesen kann, die als Wirtschaftsbericht für den Abruf von Informationen angezeigt wird./GL-Dateiformat gespeichert werden.\n\nSIE - XBRL/GL \nSIE (www.sie.se) ist eine schwedische Lieferanteninteressengruppe mit allgemeinem Format für die Dateien von Buchhaltungsdaten und angewendeten Methoden. Der Grundgedanke darin besteht, dass alle Anbieter das Dateiformat für den Informationsaustausch unterstützen, nicht nur das Dateiformat, sondern auch das Umwandeln von internen logischen Datenformaten in eine gängige Praxis. Die Ausgangsmotivation für die SIE-Gruppe war der Austausch von Informationen mit Einkommenssteuerberichterstattungsprogrammen und Vorsystemen wie Lohn-Schuld-und Forderungs-abrechnungen.\n\nXBRL/GL ist bei Rechnungsprüfer und Buchhalter international beliebt und hat ein Dateiformat, mit der gleichen Absicht von XBRL/GL International: www.xbrl.org/the-standard/what/global-ledger/", "de"},
		{SCT_TEXT, NULL, NULL, "Lees en analyseer uw boekhouding!\n\nRosetta geeft rapporten weer van SIE en XBRL/GL accountingbestanden. Bekijk bestanden die aan een e-mail zijn gekoppeld, die zijn opgeslagen in het computergeheugen of die zijn geleverd door andere programma's, zoals op een internetserver.\n\nDe rapporten kunnen worden bekeken, afgedrukt en opgeslagen als tekstbestanden voor gebruik in spreadsheetprogramma's voor gedetailleerde analyse en presentatie. Het kan worden opgeslagen en gelezen in de XBRL/GL-bestandsindeling. Klik op jou!\n\nAlle boekhoudprogramma's die in de afgelopen 20 jaar in Zweden zijn verspreid, ondersteunen SIE-bestanden voor lezen en opslaan, en daarmee een groot deel van de wereldmarkt (SIE-ondersteuning wordt niet buiten Zweden aangeboden).\n\nVraag uw leverancier van het boekhoudsysteem, over SIE - ondersteuning.E - mail naar de gebruiker die het SIE - bestand kan lezen, dat wordt weergegeven als een economisch rapport voor het ophalen van informatie.\n\nSIE - XBRL/GL\nSIE (www.sie.se) is een Zweedse leverancierbelangengroep met algemeen formaat voor boekhoudgegevens en toegepaste methodegegevens, waarbij het basisidee is dat alle leveranciers het bestandsformaat gebruiken voor informatie-uitwisseling. Ondersteunen niet alleen de bestandsindeling, maar ook de conversie van interne logische gegevensformaten naar een algemene praktijk. De startmotivatie voor de SIE-groep was de uitwisseling van informatie met programma's voor de rapportage van inkomstenbelasting en pre-systemen zoals afrekeningen van betalingen en vorderingen.\n\nXBRL/GL is internationaal populair bij revisors en boekhouders en is een bestandsformaat, met dezelfde bedoeling door XBRL/GL International: www.xbrl.org/the-standard/what/global-ledger/", "nl"},
		{SCT_TEXT, NULL, NULL, "Lisez et analysez votre comptabilité!\n\nRosetta affiche les rapports des fichiers de comptabilité SIE et XBRL/GL. Afficher des fichiers joints à un courrier électronique, stockés dans la mémoire de l'ordinateur ou fournis par d'autres programmes, tels que sur un serveur Internet.\n\nLes rapports peuvent être affichés, imprimés et enregistrés sous forme de fichiers texte, à utiliser dans les tableurs pour une analyse et une présentation en profondeur. Il peut être enregistré et lu au format de fichier XBRL/GL. Cliquez sur vous!\n\nTous programmes comptables distribués en Suède au cours des 20 dernières années soutiennent les fichiers SIE pour la lecture et l'écriture, et donc aussi une grande partie du marché mondial (le soutien de SIE n'est pas commercialisé en dehors de la Suède).\n\nDemandez à votre fournisseur de système de comptabilité à propos du support SIE. Envoyer un courrier électronique à l'utilisateur qui peut lire le fichier SIE, qui s'affiche sous la forme d'un rapport économique permettant de récupérer des informations.\n\nSIE - XBRL/GL\nSIE(www.sie.se) est un groupement d'intérêt de fournisseurs suédois avec un format d'échange de fichiers de comptabilité universel et des méthodes appliquées.L'idée de base étant que tous les fournisseurs supportent le même format de fichier pour le partage d'informations. Aussi la conversion des formats de données logiques internes en une pratique commune. La motivation initiale du groupe SIE était l'échange d'informations avec les programmes de déclaration de l'impôt sur le revenu et les pré-systèmes tels que salaires, les comptes créditeurs et les comptes débiteurs.\n\nXBRL/GL est populaire parmi les auditeurs et les comptables au niveau international et est un format de fichier, avec la même intention de XBRL/GL International: www.xbrl.org/the-standard/what/global-ledger/", "fr"},
		{SCT_TEXT, NULL, NULL, "¡Lee y analiza tu contabilidad!\n\nRosetta muestra los informes de los archivos de contabilidad SIE y XBRL/GL. Vea archivos adjuntos a un correo electrónico, almacenados en la memoria de la computadora o proporcionados por otros programas, como en un servidor de Internet.\n\nLos informes se pueden ver, imprimir y guardar como archivos de texto para usar en hojas de cálculo para un análisis y presentación en profundidad. Se puede guardar y leer en formato de archivo XBRL/GL. Haga clic en usted!\n\nTodos los programas de contabilidad distribuidos en Suecia en los últimos 20 años respaldan los archivos de SIE para lectura y escritura, y por lo tanto también una gran parte del mercado global (el soporte de SIE no se comercializa fuera de Suecia).\n\nPregúntele a su proveedor del sistema de contabilidad sobre el soporte de SIE. Envíe un correo electrónico al usuario que puede leer el archivo SIE, que se muestra como un informe económico para recuperar información.\n\nSIE - XBRL/GL\nSIE (www.sie.se) es un grupo de interés de proveedores suecos con un formato de intercambio de archivos de contabilidad general y métodos aplicados. la idea básica es que todos los proveedores admitan el formato de archivo para compartir información. También la conversión de formatos de datos lógicos internos en una práctica común. La motivación inicial del Grupo SIE fue el intercambio de información con programas y pre-sistemas de declaración de impuestos sobre la renta, tales como salarios, cuentas por pagar y cuentas por cobrar.\n\nXBRL/GL es popular entre auditorías y contadores a nivel internacional y es un formato de archivo, con la misma intención de XBRL/GL International: www.xbrl.org/the-standard/what/global-ledger/", "es"},
		{SCT_TEXT, NULL, NULL, "Leia e analise sua contabilidade!\n\nO Rosetta exibe relatórios dos arquivos contábeis do SIE o XBRL/GL. Visualize arquivos anexados a um email, armazenados na memória do computador ou fornecidos por outros programas, como em um servidor da Internet.\n\nOs relatórios podem ser visualizados, impressos e salvos como arquivos de texto para uso em planilhas para análise e apresentação em profundidade. Ele pode ser salvo e lido no formato de arquivo XBRL/GL. Clique em você!\n\nTodos os programas de contabilidade distribuídos na Suécia nos últimos 20 anos suportam arquivos SIE para leitura e escrita e, portanto, também uma grande parte do mercado global (o suporte SIE não é comercializado fora da Suécia).\n\nPergunte ao seu provedor de sistema de contabilidade sobre o suporte do SIE. Envie um email para o usuário que pode ler o arquivo SIE, que é exibido como um relatório econômico para recuperar informações.\n\nSIE - XBRL/GL\nSIE (www.sie.se) é um grupo de interesse de fornecedores suecos com um formato geral de troca de arquivos contábsie e métodos aplicados. A idéia básica é que todos os provedores suportam o formato do arquivo para compartilhamento de informações. Também a conversão de formatos de dados lógicos internos em uma prática comum. A motivação inicial do Grupo SIE foi o intercâmbio de informações com programas de relatórios de imposto de renda e pré-sistemas, como salários, contas a pagar e contas a receber.\n\nXBRL/GL é popular entre auditores e contadores internacionalmente e é um formato de arquivo, com a mesma intenção da XBRL/GL International: www.xbrl.org/the-standard/what/global-ledger/", "pt"},
		{SCT_TEXT, NULL, NULL, "Leggi e analizza la tua contabilità!\n\nRosetta visualizza i report dei file contabili SIE e XBRL/GL. Visualizza i file allegati a un'e-mail, archiviati nella memoria del computer o forniti da altri programmi, ad esempio su un server Internet.\n\nI report possono essere visualizzati, stampati e salvati come file di testo da utilizzare nei fogli di calcolo per analisi approfondite e presentazioni. Può essere salvato e letto nel formato file XBRL/GL. Clicca su di te!\n\nTutti i programmi di contabilità distribuiti in Svezia nel corso degli ultimi 20 anni supportano i file SIE per la lettura e la scrittura, e quindi gran parte del mercato mondiale (SIE non è commercializzato al di fuori della Svezia).\n\nChiedi al tuo fornitore di sistemi di contabilità in merito al supporto SIE. Invia un'email all'utente che può leggere il file SIE, che viene visualizzato come rapporto economico per recuperare le informazioni.\n\nSIE - XBRL/GL\nSIE (www.sie.se) è un gruppo di fornitore svedese con formato di scambio di file di contabilità generale e metodi applicati. L'idea di base è che tutti i fornitore supportino il formato di file per la condivisione delle informazioni, convertendo in tal modo i formati di dati logici interni in una pratica comune. La motivazione iniziale per il gruppo SIE era lo scambio di informazioni con i programmi di rendiconto delle imposte sul reddito e i pre-sistemi come per le buste paga, i debiti e i crediti.\n\nXBRL/GL è popolare tra uditori e contabili a livello internazionale ed è un formato di file, con lo stesso intento di XBRL/GL International: www.xbrl.org/the-standard/what/global-ledger/", "it"}, {0}}},
	{"AboutRosetta",{
		{SCT_TEXT, NULL, NULL, "Rosetta\nThis program is the first step in the Rosetta project for future information exchange between paperless accounting systems integrated with the internet bank, regardless of computer systems. Particularly the ambition of accounting in mobile phones on simple internet banking-based integration with integrated receipts and invoices. Rosetta file format works in all languages and countries and allow multiple language texts for international information exchange. The ambition is to support integration of international trade information.\n\nThis is applied technology of years of standard format work. The basics are the 20 years of the successful experience of SIE in Sweden and the EU VAT Directive with legal specifications for accounting, billing and tax reporting. But also continue the work within XBRL and UN/CEFACT to result in concrete products.", "en"},
		{SCT_TEXT, NULL, NULL, "Rosetta\nDetta program är det första steget i Rosetta-projektet för framtida informationsutbyte mellan papperslösa bokföringssystem integrerade med internetbanken, oavsett datorsystem. Särskilt ambitionen att bokföra i mobiltelefoner med enkel internetbankbaserad integration med integrerade kvitton och fakturor. Rosetta filformatet fungerar på alla språk och länder och tillåter flera språktexter för internationellt informationsutbyte. Ambitionen är att stödja integration av interantionell handelsinformation.\n\nDet här är tillämpad teknik av år med standardformatarbete. Grunderna är de 20 år av SIEs framgångsrika erfarenhet i Sverige och EU:s momsdirektiv med legala specifikationer för redovisning, fakturering och skatterapportering. Men också fortsätta arbetet inom XBRL och UN/CECFACT att resultera i konkreta produkter.", "sv"},
		{SCT_TEXT, NULL, NULL, "Rosetta\nDette program er det første skridt i Rosetta-projektet til fremtidig informationsudveksling mellem papirløse regnskabssystemer integreret med internetbanken, uanset computersystemer. Især ambitionen om at bogføre i mobiltelefoner på simpel internetbankbaseret integration med integrerede kvitteringer og fakturaer. Rosetta filformater fungerer på alle sprog og lande og tillader flere sprogtekster til international informationsudveksling. Ambitionen er at understøtte integration af international handelsinformation.\n\nDette er anvendt teknologi af år med standardformatarbejde. Grundlaget er de 20 år med SIEs succesfulde erfaring i Sverige og EU's momsdirektiv med juridiske specifikationer for regnskabsføring, fakturering og skatterapportering. Men fortsæt også arbejdet inden for XBRL og UN/CEFACT for at resultere i konkrete produkter.", "da"},
		{SCT_TEXT, NULL, NULL, "Rosetta\nDette programmet er det første trinnet i Rosetta-prosjektet for fremtidig informasjonsutveksling mellom papirløse regnskapssystemer integrert med internetbanken, uavhengig av datasystemer. Spesielt ambisjonen om regnskapsmessig bruk i mobiltelefoner på enkel nettbankbasert integrasjon med integrerte kvitteringer og fakturaer. Rosetta filformat fungerer på alle språk og land og tillater flere språktekster for internasjonal informasjonsutveksling. Ambisjonen er å støtte integrasjon av internasjonal handelsinformasjon.\n\nDette er anvendt teknologi av år med standardformatarbeid. Grunnleggende er det 20 års SIE vellykket erfaring i Sverige og EU MVA-direktiv med de lovlige spesifikasjoner for regnskap, fakturering og skattrapportering. Men fortsett også arbeidet i XBRL og UN/CEFACT for å resultere i konkrete produkter.", "no"},
		{SCT_TEXT, NULL, NULL, "Rosetta\nÞetta forrit er fyrsta skrefið í Rosetta verkefninu um framtíð upplýsingaskipti milli pappírslausa bókhaldskerfa sem er samþætt við netið bankar, án tillits til tölvukerfa. Sérstaklega metnað bókhald í farsíma á einfaldan netbanka-undirstaða samþættingu með samþættum kvittunum og reikningum. Rosetta skráarsnið vinnur á öllum tungumálum og löndum og leyfir mörgum tungumálum texta fyrir alþjóðlega upplýsingaskipti. Markmiðið er að styðja við samþættingu alþjóðaviðskiptaupplýsinga. \n\nÞetta er beitt tækni af mörgum venjulegum sniðum. Grunnurinn er 20 árin með árangursríka reynslu SIE í Svíþjóð og VSK tilskipun ESB með lagalegum forskriftum fyrir bókhald, innheimtu og skattframtal. En heldur áfram að vinna í XBRL og UN/CEFACT til að leiða til steypuvörur.", "is"},
		{SCT_TEXT, NULL, NULL, "Rosetta\nTämä ohjelma on ensimmäinen askel Rosetta-hankkeessa tulevasta tiedonvaihdosta internetpankin kanssa integroitujen paperittomien kirjanpitojärjestelmien välillä, riippumatta tietokonejärjestelmistä. Erityisesti tavoitteena on matkapuhelinten kirjanpidon tavoitteena yksinkertainen internetpankkipalveluiden yhdistäminen integroituihin Kuitti ja laskuihin. Rosetta tiedostomuoto toimii kaikilla kielillä ja maissa ja mahdollistaa useiden kielitietojen kansainvälisen tiedonvaihdon. Tavoitteena on tukea kansainvälisten kauppatietojen integrointia.\n\nTämä sovellettu teknologia on vuosien vakiomuotoista työtä. Perusteet ovat Ruotsin SIE: n menestyksekkään kokemuksen Ruotsissa ja EU: n arvonlisäverodirektiivissä, jossa on kirjanpitoa, laskutusta ja veroilmoituksia koskevia oikeudellisia eritelmiä. Jatka myös XBRL: n ja UN/CEFACTin työtä, jotta saataisiin aikaan konkreettisia tuotteita.", "fi"},
		{SCT_TEXT, NULL, NULL, "Rosetta\nDieses Programm ist der erste Schritt im Rosetta-Projekt für den zukünftigen Informationsaustausch zwischen papierlosen Buchungssystemen, die in die Internetbank integriert sind, unabhängig von Computersystemen. Insbesondere das Bestreben der Buchhaltung bei Mobiltelefonen nach einfacher Internetbanking-Integration mit integrierten Quittungeren und Rechnungen. Rosetta Dateiformat funktioniert in allen Sprachen und Ländern und ermöglicht mehrsprachige Texte für den internationalen Informationsaustausch. Das Ziel besteht darin, die Integration internationaler Handelsinformationen zu unterstützen.\n\nDies ist eine angewandte Technologie jahrelanger Standardformatarbeit. Die Grundlagen sind die 20-jährige erfolgreiche Erfahrung von SIE in Schweden und die EU-Mehrwertsteuerdirektive mit gesetzlichen Vorgaben für die Rechnungslegung, Fakturierung, Steuerberichterstattung. Setzen Sie aber auch die Arbeit innerhalb XBRL und UN/CEFACT fort, um konkrete Produkte herzustellen.", "de"},
		{SCT_TEXT, NULL, NULL, "Rosetta\nDit programma is de eerste stap in het Rosetta-project voor de toekomstige uitwisseling van informatie tussen papierloze reserveringssystemen die zijn geïntegreerd in de internetbank, onafhankelijk van computersystemen. In het bijzonder, het nastreven van accounting voor mobiele telefoons voor eenvoudige internetbankieren integratie met geïntegreerde ontvangsten en facturen. Rosetta bestandsformaat werkt in alle talen en landen en biedt meertalige teksten voor internationale uitwisseling van informatie. Het doel is om de integratie van internationale handelsinformatie te ondersteunen.\n\nDit is een toegepaste technologie van jarenlang standaardformaat werk. De basis is de 20 jaar succesvolle ervaring van SIE in Zweden en de EU-btw-richtlijn met wettelijke versieten voor boekhouding, boekhouding en belastingaangifte. Maar ook het werk binnen XBRL en UN/CEFACT voortzetten om te resulteren in concrete producten.", "nl"},
		{SCT_TEXT, NULL, NULL, "Rosetta\nCe programme constitue la première étape du projet Rosetta pour un futur échange d'informations entre systèmes de comptabilité sans papier intégrés à la banque Internet, quels que soient les systèmes informatiques. En particulier, l’ambition de la comptabilité dans les téléphones mobiles repose sur une intégration simple basée sur Internet banking avec des factures et des reçus intégrés. Rosetta format de fichier fonctionne dans toutes les langues et dans tous les pays et autorise l'utilisation de textes multilingues pour l'échange international d'informations. L’ambition est de soutenir l’intégration des informations sur le commerce international.\n\nC'est une technologie appliquée d'années de travail au format standard. Les fondations sont les 20 années d'expérience réussie de la SIE en Suède et la directive européenne sur la TVA avec des exigences légales en matière de comptabilité, de facturation et de rapport fiscal. Mais également poursuivre le travail au sein de XBRL et de l’UN/CEFACT afin d’obtenir des produits concrets.", "fr"},
		{SCT_TEXT, NULL, NULL, "Rosetta\nEste programa es el primer paso en el proyecto Rosetta para un futuro intercambio de información entre sistemas de contabilidad sin papel integrados en el banco de Internet, independientemente de los sistemas de información. En particular, la ambición de la contabilidad en los teléfonos móviles se basa en una integración sencilla basada en banca por Internet con facturas y recibos integrados. Rosetta formato de archivo funciona en todos los idiomas y en todos los países y permite el uso de textos multilingües para el intercambio internacional de información. La ambición es apoyar la integración de la información sobre el comercio internacional.\n\nLas bases son los 20 años de experiencia exitosa de SIE en Suecia y la Directiva Europea del IVA con requisitos legales para la contabilidad, la facturación y la declaración de impuestos. Pero también continúe el trabajo dentro de XBRL y UN/CEFACT para obtener productos concretos.", "es"},
		{SCT_TEXT, NULL, NULL, "Rosetta\nEste programa é o primeiro passo do projeto Rosetta para uma futura troca de informações entre sistemas de contabilidade sem papel integrados ao banco da Internet, independentemente dos sistemas de informação. Em particular, a ambição da contabilidade em telefones celulares é baseada em uma integração simples baseada em serviços bancários pela Internet com faturas e recibos integrados. Rosetta formato de arquivo trabalha em todas as línguas e em todos os países e permite o uso de textos multilíngües para o intercâmbio internacional de informações. A ambição é apoiar a integração de informações sobre o comércio internacional. \n\nAs bases são os 20 anos de experiência de sucesso da SIE na Suécia e a Directiva IVA Européia com requisitos legais para contabilidade, faturamento e relatórios tributários. Mas também continue o trabalho dentro de XBRL e UN/CEFACT para resultar em produtos concretos.", "pt"},
		{SCT_TEXT, NULL, NULL, "Rosetta\nQuesto programma è il primo passo nel progetto Rosetta per un futuro scambio di informazioni tra sistemi di contabilità senza carta integrati nella banca Internet, indipendentemente dai sistemi di informazione. In particolare, l'ambizione della contabilità nei telefoni cellulari si basa su una semplice integrazione basata su Internet banking con fatture e ricevute integrate. Rosetta formato di file funziona in tutte le lingue e in tutti i paesi e consente l'uso di testi multilingue per lo scambio internazionale di informazioni. L'ambizione è sostenere l'integrazione delle informazioni sul commercio internazionale.\n\nÈ una tecnologia applicata da anni di lavoro in formato standard. Le basi sono i 20 anni di esperienza di successo maturata dalla SIE in Svezia e la direttiva europea sull'IVA con i requisiti legali per la contabilità, la fatturazione e il reporting fiscale. Ma continua anche il lavoro all'interno di XBRL e UN/CEFACT per produrre prodotti in calcestruzzo.", "it"}, {0}}},
	{"AboutContact",{
		{SCT_TEXT, NULL, NULL, "Read more at our website: www.alphabet.se\n\nEmail for software support, corrections, bug reports, business and project proposals (also sells software code on OEM basis): Rosetta@Alphabet.se", "en"},
		{SCT_TEXT, NULL, NULL, "Läs mer på vår hemsida: www.alphabet.se\n\nE-post för programsupport, korrigeringar, felrapporter, affärs- och projektförslag (säljer även programkod på OEM-basis): Rosetta@Alphabet.se", "sv"},
		{SCT_TEXT, NULL, NULL, "Læs mere på vores hjemmeside: www.alphabet.se\n\nEmail for support, fejlrapporter og projektforslag (også sælger program på OEM-basis): Rosetta@Alphabet.se", "da"},
		{SCT_TEXT, NULL, NULL, "Les mer på vår hjemmeside: www.alphabet.se\n\nEpost for programvare støtte, oppdateringer, feilrapporter, prosjektforslag (også selger program på OEM-basis): Rosetta@Alphabet.se", "no"},
		{SCT_TEXT, NULL, NULL, "Lesa meira á heimasíðu okkar: www.alphabet.se\n\nTölvupóst til stuðnings, villuskýrslum og tillögur um verkefni (einnig selja forrit á OEM grundvelli): Rosetta@Alphabet.se", "is"},
		{SCT_TEXT, NULL, NULL, "Lue lisää verkkosivuillamme: www.alphabet.se\n\nEmail for software support, corrections, bug reports, business and project proposals (also sells software code on OEM basis): Rosetta@Alphabet.se", "fi"},
		{SCT_TEXT, NULL, NULL, "Lesen Sie mehr auf unserer Website : www.alphabet.se\n\nEmail für Software-Support, Korrekturen, Fehlerberichte, Geschäfts-und Projektvorschläge (verkauften auch Software-Code auf OEM-Basis) : Rosetta@Alphabet.se", "de"},
		{SCT_TEXT, NULL, NULL, "Lees meer op onze website: www.alphabet.se\n\nE-mail voor softwareondersteuning, fixes, bugrapporten, zakelijke en projectvoorstellen (ook verkoop van OEM-gebaseerde softwarecode): Rosetta@Alphabet.se", "nl"},
		{SCT_TEXT, NULL, NULL, "En savoir plus sur notre site : www.alphabet.se\n\nEmail pour le support logiciel, les corrections, les rapports d'erreurs, des affaires et des propositions de projet (également vendu de code logiciel sur une base OEM): Rosetta@Alphabet.se", "fr"},
		{SCT_TEXT, NULL, NULL, "Obtenga más información sobre nuestro sitio web: www.alphabet.se\n\nCorreo electrónico para soporte de software, correcciones, informes de errores, propuestas comerciales y de proyectos (también se vende código de software) en una base OEM): Rosetta@Alphabet.se", "es"},
		{SCT_TEXT, NULL, NULL, "Saiba mais sobre o nosso site: www.alphabet.se\n\nEmail para suporte de software, correções, relatórios de erros, propostas comerciais e de projetos (também código de software vendido por OEM): Rosetta@Alphabet.se", "pt"},
		{SCT_TEXT, NULL, NULL, "Per saperne di più sul nostro sito web: www.alphabet.se\n\nE-mail per il supporto software, correzioni, segnalazioni di errori, proposte commerciali e di progetto (codice del software venduto anche su base OEM): Rosetta@Alphabet.se", "it"}, {0}}},
	{"Expire",{
		{SCT_TEXT, NULL, NULL, ": is the expire date (then you need an update)", "en"},
		{SCT_TEXT, NULL, NULL, ": är utgångsdatumet (då behöver du en uppdatering)", "sv"},
		{SCT_TEXT, NULL, NULL, ": er udløbsdatoen (så skal du have en opdatering)", "da"},
		{SCT_TEXT, NULL, NULL, ": er utløpsdato (da trenger du en oppdatering)", "no"},
		{SCT_TEXT, NULL, NULL, ": er lokadagsetning (þá þarftu að uppfæra)", "is"},
		{SCT_TEXT, NULL, NULL, ": on vanhentumispäivä (sitten tarvitset päivityksen)", "fi"},
		{SCT_TEXT, NULL, NULL, ": ist das Ablaufdatum (dann benötigen Sie ein Update)", "de"},
		{SCT_TEXT, NULL, NULL, ": is de vervaldatum (daarna hebt u een update nodig)", "nl"},
		{SCT_TEXT, NULL, NULL, ": est la date d'expiration (alors vous avez besoin d'une mise à jour)", "fr"},
		{SCT_TEXT, NULL, NULL, ": es la fecha de vencimiento (luego necesita una actualización)", "es"},
		{SCT_TEXT, NULL, NULL, ": é a data de expiração (então você precisa de uma atualização)", "pt"},
		{SCT_TEXT, NULL, NULL, "è la data di scadenza (quindi è necessario un aggiornamento)", "it"}, {0}}},
	{"HelpMessage",{
		{SCT_TEXT, NULL, NULL, "This program displays reports from SIE and XBRL/GL accounting files. It only reads, sort, sum and displays the data, but not change it. When you save or import, is everything recalculated. By selecting the different tabs you are able to read the different reports. You can search for text in every page.\n\nOpen a SIE file, that is viewed as an economic report. It can be displayed, printed, saved as CSV or text files, for use in spreadsheet programs and also saved in XBRL/GL file format. You can import additional year files, thus creating in-depth analysis. Click ahead!", "en"},
		{SCT_TEXT, NULL, NULL, "Detta program visar rapporter från SIE och XBRL/GL bokföringsfiler. Det bara läser, sorterar, summerar och visar data, men inte ändrar dem. När du sparar eller importerar, räknas allt om. Genom att välja olika flikar kan du läsa de olika rapporterna. Du kan söka text på varje sida.\n\nÖppna en SIE-fil, den visas som en ekonomisk rapport. Den kan visas, skrivas ut, sparas som CSV och textfiler, för användning i kalkylprogram och sparas också i XBRL/GL-filformat. Man kan importera ytterligare års-filer och på så sätt skapa fördjupad analys. Klicka dig fram!", "sv"},
		{SCT_TEXT, NULL, NULL, "Dette program viser rapporter fra SIE og XBRL/GL bogføringsfiler. Den læser kun, sorterer, opsummerer og viser data, men ændrer dem ikke. Når du gemmer eller importerer, er alt omberegnet. Ved at vælge forskellige faner, kan du læse de forskellige rapporter. Du kan søge i teksten på hver side.\n\nÅbn en SIE-fil, der vises som en finansiel rapport. Den kan vises, udskrives, gemmes som CSV og tekstfiler, til brug i regnearksprogrammer og også gemt i XBRL/GL filformatet.\n\nDu kan importere yderligere års filer, hvilket giver en grundig analyse. Klik på dig!", "da"},
		{SCT_TEXT, NULL, NULL, "Dette programmet viser rapporter fra SIE og XBRL/GL bokføringsfiler. Den leser bare, sorterer, oppsummerer og viser data, men endrer ikke dem. Når du lagrer eller importerer, blir alt omberegnet. Ved å velge forskjellige faner, kan du lese de ulike rapportene. Du kan søke i teksten på hver side.\n\nÅpne en SIE-fil som vises som en økonomisk rapport. Den kan vises, skrives ut, lagres som CSV og tekstfiler, for bruk i regnearkprogrammer og også lagret i XBRL/GL filformat.\n\nDu kan importere flere års filer, og dermed skape grundig analyse. Klikk på deg!", "no"},
		{SCT_TEXT, NULL, NULL, "Þetta forrit skýrslur frá SIE og XBRL/GL bókhald skrár. Það les aðeins, raða, summa og birta gögnin, en ekki breytir þeim. Þegar þú vistar eða innflutningur er allt endurreiknað. Með því að velja mismunandi flipa getur þú lesið ýmsar skýrslur. Hægt er að leita í texta á hverri síðu.\n\nOpna SIE skrá sem birtist eins og fjárhagsleg skýrslu. Það er hægt að birta, prenta, vista sem CSV og textaskrár, til notkunar í töflureiknum og einnig geymd í XBRL/GL sniði.\n\nÞú getur flutt viðbótarársskrár, þannig að búa til ítarlega greiningu. Smelltu á þig!", "is"},
		{SCT_TEXT, NULL, NULL, "Rossetta raportoi SIE ja XBRL/GL kirjanpitotiedostoista. Se vain lukee, lajittelee, summaa ja näyttää tiedot, mutta ei muuta sitä. Kun tallennat tai tuodaan, lasketaanko kaikki uudelleen. Valitsemalla eri välilehdet voit lukea eri raportit. Voit etsiä tekstiä jokaisella sivulla.\n\nAvaa tiedosto, jota pidetään taloudellisena raporttina. Se voidaan näyttää, tulostaa, tallentaa oleviksi CSV ja tekstitiedostoiksi, käyttää niitä taulukkolaskentaohjelmissa ja tallentaa myös XBRL/GL-tiedostomuotoon.\n\nVoit tuoda lisää vuosi-tiedostoja ja luoda perusteellisen analyysin. Napsauta eteenpäin!", "fi"},
		{SCT_TEXT, NULL, NULL, "Dieses Programm zeigt Berichte aus SIE und XBRL/GL Buchhaltung-Dateien an. Es liest, sortiert, summiert und zeigt die Daten an, ändert sie aber nicht. Beim Speichern oder Importieren wird alles neu berechnet. Durch Auswahl der verschiedenen Registerkarten können Sie die verschiedenen Berichte lesen. Sie können nach Text auf jeder Seite suchen.\n\nÖffnen Sie eine SIE-Datei, die als Wirtschaftsbericht angezeigt wird. Die Berichte können angezeigt, gedruckt, als CSV und Textdateien, zur Verwendung in Tabellenkalkulationsprogrammen gespeichert und auch im XBRL/GL-Dateiformat gespeichert werden.\n\nSie können zusätzliche Jahresdateien importieren und so eine detaillierte Analyse erstellen.\n\nKlicken Sie auf!", "de"},
		{SCT_TEXT, NULL, NULL, "Dit programma toont rapporten van SIE en XBRL/GL boekhoudbestanden. Het leest, sorteert, somt en geeft de gegevens alleen weer, maar verandert deze niet. Wanneer u opslaat of importeert, wordt alles opnieuw berekend. Door de verschillende tabbladen te selecteren, kunt u de verschillende rapporten lezen. U kunt op naar tekst op elke pagina zoeken.\n\nEen SIE-bestand openen, dat wordt bekeken als een economisch rapport. Het kan worden weergegeven, afgedrukt, opgeslagen als CSV en tekstbestanden, voor gebruik in spreadsheets en ook in de XBRL/GL-bestandsindeling wordt opgeslagen.\n\nU kunt extra jaarbestanden importeren en zo een grondige analyse maken. Klik op jou!", "nl"},
		{SCT_TEXT, NULL, NULL, "Ce programme affiche les rapports des fichiers comptables SIE et XBRL/GL. Il lit, trie, compter et affiche les données, mais ne les modifie pas. Lorsque vous enregistrez ou importez, tout est recalculé. En sélectionnant les différents onglets, vous pouvez affiche les différents rapports. Vous pouvez rechercher du texte sur chaque page.\n\nOuvrez un fichier SIE, qui est affiché comme un rapport économique. Il peut être affiché, imprimé, enregistré en tant que fichiers texte et CSV, pour une utilisation dans des feuilles de tableur, et est également stockée dans le format fichier XBRL/GL.\n\nVous pouvez importer des fichiers d'année supplémentaires, créant ainsi une analyse approfondie. Cliquez sur vous!", "fr"},
		{SCT_TEXT, NULL, NULL, "Este programa muestra informes de archivos de contabilidad SIE y XBRL/GL. Lee, ordena, cuenta y muestra datos, pero no los modifica. Al guardar o importar, se recalcula todo. Al seleccionar las diferentes pestañas, puede visualizar los diferentes informes.Puede buscar texto en cada página.\n\nAbra un archivo SIE, que se muestra como un informe económico.Se puede visualizar, imprimir, guardar como archivos de texto y CSV, para su uso en las hojas de cálculo y también se almacena en formato de archivo XBRL/GL.\n\nPuede importar archivos anuales adicionales, creando así un análisis en profundidad. Haga clic en usted!", "es"},
		{SCT_TEXT, NULL, NULL, "Este programa exibe relatórios de arquivos contábsie SIE o XBRL/GL. Ele lê, classifica, conta e exibe dados, mas não o muda. Ao selecionar as abas diferentes, você pode exibir os diferentes relatórios. Quando você salva ou importa, tudo é recalculado. Você pode procurar texto em cada página.\n\nAbra um arquivo SIE, que é exibido como um relatório econômico.Pode ser visto, impresso, salvo como arquivos de texto e CSV, para uso em planilhas e também é armazenado no formato de arquivo XBRL/GL.\n\nVocê pode importar arquivos de ano adicionais, criando uma análise profunda. Clique em você!", "pt"},
		{SCT_TEXT, NULL, NULL, "Questo programma visualizza i report dei file contabili SIE e XBRL/GL. Legge, ordina, conta e visualizza i dati, ma non li modifica. Quando si salva o importa, viene ricalcolato tutto. Selezionando le diverse schede, è possibile visualizzare i diversi report.Puoi cercare il testo su ogni pagina.\n\nApri un file SIE, che viene visualizzato come rapporto economico.Può essere visualizzato, stampato, salvato come file di testo e CSV, per l'uso in fogli di foglio elettronico e anche file di formato XBRL/GL.\n\nÈ possibile importare file di anno aggiuntivo, creando così un'analisi approfondita. Clicca su di te!", "it"}, {0}}},
	{"HelpDesktop",{
		{SCT_TEXT, NULL, NULL, "In the View menu you are able to add more report tabs so you could compare and read different parts of the reports with different settings of the same report.\n\nSelect monthly periods by the tabs and accounting objects in the object selector down to the right for viewing them.\n\nTo open a file, you can also drag a file and drop it over the company information field in the centre below.\n\nUse the keys, arrows, F keys, - and 1-9.\n\nClick ahead!", "en"},
		{SCT_TEXT, NULL, NULL, "I menyn Visa kan du lägga till mer rapportflikar så att du kan jämföra och läsa olika delar av rapporterna med olika inställningar av samma rapport.\n\nVälj månadsperioder i period-tabbarna och bokföringsobjekten i objektväljaren ner till höger för att visa dem.\n\nFör att öppna en fil kan du också dra en fil och släppa den över företagsinformationsfältet i mitt under.\n\nAnvänd tangenterna, pilarna, F-tangenterna, - och 1-9.\n\nKlicka dig fram!", "sv"},
		{SCT_TEXT, NULL, NULL, "I menuen Vis, kan du tilføje mere Indberet faner, så du kan sammenligne og læse forskellige afsnit af rapporterne med forskellige indstillinger af samme rapport.\n\nVælg måneders perioder af faner og bogføringsobjekter i objektvælgeren ned til højre for at se dem.\n\nFor at åbne en fil, kan du også trække en fil og slippe den over forretningsoplysninger felt i midten af.\n\nBrug tasterne, pile, F-taster, - og 1-9.\n\nKlik på dig!", "da"},
		{SCT_TEXT, NULL, NULL, "I Visning-menyen, kan du legge til flere rapport faner, slik at du kan sammenligne og lese forskjellige deler av rapportene med forskjellige innstillinger av samme rapport.\n\nVelg måned perioder med faner og poste objekter i objektvelgeren ned til høyre for å se dem.\n\nHvis du vil åpne en fil, kan du også dra en fil og slippe den over forretningsinformasjon feltet i midten av.\n\nBruk tastene, pilene, F-tastene, - og 1-9.\n\nKlikk på deg!", "no"},
		{SCT_TEXT, NULL, NULL, "Í Skoða valmynd geturðu bætt fleiri skýrslu flipa, svo þú getur bera saman og lesa mismunandi kafla í skýrslum með mismunandi stillingar sömu skýrslu.\n\nVeldu mánaða tímabil af tabs og bókhald hlut val niður til hægri til að sjá þær.\n\nTil að opna skrá, þú getur einnig draga hana og láta hann falla yfir upplýsingar um fyrirtæki á sviði í miðri.\n\nNotaðu takkana, örvarnar, F takkana, - og 1-9.\n\nSmelltu á þig!", "is"},
		{SCT_TEXT, NULL, NULL, "Näytä-valikossa voit lisätä lisää raporttilehtiä, jotta voit verrata ja lukea raporttien eri osia saman raportin eri asetusten avulla.\n\nValitse kuukausittaiset jaksot kauden välilehdissä ja kirjoita kohteita oikealle alhaalla näyttääksesi ne.\n\nAvaa tiedosto, voit myös vetää tiedoston ja pudottaa sen alareunassa olevan yrityksen tiedot -kenttään.\n\nKäytä painikkeita, nuolia, F-näppäimiä, - ja 1-9.\n\nLue napsauttamalla!", "fi"},
		{SCT_TEXT, NULL, NULL, "Im Menü Ansicht können Sie weitere Berichtsregister hinzufügen. Sie können verschiedene Teile der Berichte mit unterschiedlichen Einstellungen desselben Berichts vergleichen und lesen.\n\nWählen Sie monatliche Perioden durch die Registerkarten und Buchhaltungsobjekte in der Objektauswahl unten rechts aus, um sie anzuzeigen.\n\nUm eine Datei zu öffnen, können Sie auch eine Datei ziehen und loslassen über das Firmeninformationsfeld in das Zentrum unten.\n\nVerwenden Sie die Tasten, Pfeile, F-Tasten, - und 1-9.\n\nKlicken Sie auf!", "de"},
		{SCT_TEXT, NULL, NULL, "In het menu Weergeven kunt u meer rapporttabbladen toevoegen, zodat u kunt verschillende delen van de rapporten vergelijken en lezen met verschillende instellingen van hetzelfde rapport.\n\nSelecteer maandelijkse periodes door de tabs en de boekhoudingsobjecten in de objectselectie aan de onderkant recht om het te laten zien.\n\nOm een bestand te openen, kunt u ook een bestand slepen en neerzetten op het bedrijfsinformatieveld in de midden onder.\n\nGebruik de toetsen, pijlen, F-toetsen, - en 1-9.\n\nKlik op jou!", "nl"},
		{SCT_TEXT, NULL, NULL, "Dans le menu Affichage, vous pouvez ajouter des onglets de rapport, ce qui vous permet de comparer les différentes parties des rapports et de lire avec des paramètres différents du même rapport.\n\nSélectionner des périodes mensuelles par les objets onglets et comptables dans la sélection d'objets en bas à droite pour l'afficher.\n\nPour ouvrir un fichier, vous pouvez faire glisser un fichier et le déposer dans le cadre de l'entreprise au milieu ci-dessous.\n\nUtilisez les claviers, les flèches, les touches F, - et 1-9.\n\nCliquez sur vous!", "fr"},
		{SCT_TEXT, NULL, NULL, "En el menú Vista, puede agregar fichas de informe, lo que le permite comparar las diferentes partes de los informes y leer con diferentes configuraciones del mismo informe.\n\nSeleccione períodos mensuales por las lengüetas y contables objetos en la selección de los objetos en la parte inferior derecha para que aparezca.\n\nPara abrir un archivo, puede arrastrar y soltar un archivo en área de negocios en el centro de abajo.\n\nUse los teclados, flechas, botones F, - y 1-9.\n\nHaga clic en usted!", "es"},
		{SCT_TEXT, NULL, NULL, "No menu Exibir, você pode adicionar guias de relatório, o que lhe permite comparar diferentes partes de relatórios e ler com diferentes parâmetros par mesmo relatório.\n\nSelecione períodos mensais por aba e objetos contábsie na seleção de objeto no canto inferior direito para exibi-lo.\n\nPara abrir um arquivo, você pode arrastar um arquivo e soltá-lo no área de negócios no meio abaixo.\n\nUse os teclados, setas, botões F, - e 1-9.\n\nClique em você!", "pt"},
		{SCT_TEXT, NULL, NULL, "Dal menu Visualizza, puoi aggiungere schede di rapporti, che ti permettono di confrontare parti diverse di rapporti e di leggere con parametri diversi dallo stesso rapporto.\n\nSeleziona i periodi mensili per scheda e oggetti contabili nella selezione oggetto in basso a destra per visualizzarlo.\n\nPer aprire un file, puoi trascinare un file e rilasciarlo sul area di business nella parte centrale di sotto.\n\nUtilizzare le tastiere, le frecce, i tasti F, - e 1-9.\n\nClicca su di te!", "it"}, {0}}},
	{"HelpHandset",{
		{SCT_TEXT, NULL, NULL, "By long-clicking the screen you get the View menu. In the View menu you are able to add more report tabs so you could compare and read different parts of the reports with different settings of the same report.\n\nSelect monthly periods by the left drawer (move your finger from left side to the centre of the screen) and accounting objects right drawer (move your finger from right side to the centre of the screen) for viewing them.\n\nReceiving an email with an appended SIE-file, point at it and select Rosetta for viewing and the file is opened.\n\nIn Chromebooks use the email app, not the web reader.\n\nUse the keyboard arrows, F buttons, - and 1-9.\n\nLong click ahead!", "en"},
		{SCT_TEXT, NULL, NULL, "Genom att klicka länge på skärmen får du menyn Visa. I menyn Visa kan du lägga till mer rapportflikar så att du kan jämföra och läsa olika delar av rapporterna med olika inställningar av samma rapport.\n\nVälj månadsperioder i vänster draperi (flytta fingret från vänster sida till mitten av skärmen) och bokföringsobjektets högra draperi (flytta fingret från höger sida till mitten av skärmen) för att visa dem.\n\nTa emot en epost med en bifogad SIE-fil, peka på den och välj Rosetta för visning och filen öppnas.\n\nI Chromebooks använd e-postappen, inte webbläsaren.\n\nMed tangentbord, använd pilar, F-knappar, - och 1-9.\n\nLång-klicka dig fram!", "sv"},
		{SCT_TEXT, NULL, NULL, "Ved at klikke på skærmen i lang tid får du menuen Vis. I menuen Vis, kan du tilføje mere Indberet faner, så du kan sammenligne og læse forskellige afsnit af rapporterne med forskellige indstillinger af samme rapport.\n\nVælg måneders periode på venstre gardin (flytte fingeren fra venstre til midten af skærmen), og bogføringsobjekter i højre gardin (flytte fingeren fra højre til midten af skærmen) for at vise dem.\n\nModtag en e-mail med et vedhæftet SIE-fil, peg det og vælg Rosetta for visning og filen åbnes.\n\nI Chromebooks bruger e-mail-appen, ikke browseren.\n\nMed tastatur kan du bruge pile, F knapper, - og 1-9.\n\nLangklik på dig!", "da"},
		{SCT_TEXT, NULL, NULL, "Ved å klikke på skjermen i lang tid, får du visningsmenyen. I Visning-menyen, kan du legge til flere rapport faner, slik at du kan sammenligne og lese forskjellige deler av rapportene med forskjellige innstillinger av samme rapport.\n\nVelg måned perioden til venstre gardin (flytte fingeren fra venstre til midten av skjermen), og legge ut gjenstander i riktig gardin (flytting fra høyre mot midten av skjermen) for å vise dem.\n\nMotta en e-post med en vedlagt SIE-fil, peke og velge Rosetta for visning og filen åpnes.\n\nI Chromebook bruker du e-postappen, ikke nettleseren.\n\nMed tastatur, bruk piler, F knapper, - og 1-9.\n\nLangklikk på deg!", "no"},
		{SCT_TEXT, NULL, NULL, "Með því að smella á skjáinn í langan tíma þú að fá Skoða valmyndina. Í Skoða valmynd geturðu bætt fleiri skýrslu flipa, svo þú getur bera saman og lesa mismunandi kafla í skýrslum með mismunandi stillingar sömu skýrslu.\n\nVeldu mánaða tímabil á vinstri fortjald (hreyfa fingurinn frá vinstri til miðju á skjánum), og bókhald hlut val í hægri fortjald (flytja frá hægri til miðju skjásins) til að birta þær.\n\nFáðu tölvupóst með meðfylgjandi SIE skrá, benda á það og veldu Rosetta til að skoða og skrá er opnuð.\n\nKNotaðu tölvupóstforritið, ekki vafrann, í Chromebooks.\n\nMeð lyklaborð, notaðu örvarnar, F takkana, - og 1-9.\n\nLangur smelltu á þig!", "is"},
		{SCT_TEXT, NULL, NULL, "Klikkaamalla näyttöä pitkään saat näkyviin Näytä-valikon. Näytä-valikossa voit lisätä lisää raporttilehtiä, jotta voit verrata ja lukea raporttien eri osia saman raportin eri asetusten avulla.\n\nValitse kuukausittaiset jaksot vasempaan laatikkoon (siirrä sormea vasemmalta puolelle näytön keskelle) ja objekti oikealle (siirrä sormea oikealta puolelta näytön keskustaan).\n\nLähetä sähköposti, jossa on liitteenä oleva SIE-tiedosto, osoita se ja valitse Rosetta katseluun ja tiedosto avautuu.\n\nChromebookeissa käytetään sähköpostisovellusta, ei selainta.\n\nKäytä näppäimistöä, nuolinäppäimillä, F-painikkeilla, - ja 1-9.\n\nPitkä klikkaus eteenpäin!", "fi"},
		{SCT_TEXT, NULL, NULL, "Durch lang-klicken auf den Bildschirm erhalten Sie das Menü Ansicht. Im Menü Ansicht können Sie weitere Berichtsregister hinzufügen. Sie können verschiedene Teile der Berichte mit unterschiedlichen Einstellungen desselben Berichts vergleichen und lesen.\n\nWählen Sie monatliche Perioden durch den linken Vorhang (bewegen Sie Ihren Finger von der linken Seite in die Mitte des Bildschirms) und Buchhaltung Objekte durch den rechten Vorhang (bewegen Sie Ihren Finger von der rechten Seite in die Mitte des Bildschirms) für die Betrachtung.\n\nEmpfangen einer E-Mail mit einer angefügten SIE-Datei: zeigen Sie darauf und wählen Sie Rosetta zum Anzeigen und die Datei wird geöffnet.\n\nVerwenden Sie in Chromebooks die E-Mail-App, nicht den Browser.\n\nVerwenden Sie bei Tastatur, die Pfeile, die Tasten F, - und 1-9.\n\nLangklicken Sie auf!", "de"},
		{SCT_TEXT, NULL, NULL, "Door lang op het scherm te klikken, krijgt u het menu Weergeven. In het menu Weergeven kunt u meer rapporttabbladen toevoegen, zodat u kunt verschillende delen van de rapporten vergelijken en lezen met verschillende instellingen van hetzelfde rapport.\n\nSelecteer maandelijkse perioden in de linker gordijn (beweeg uw vinger van links naar het midden van het scherm) en boekhoudingsobjecten recht gordijn (verplaats uw vinger van rechterkant naar het midden van het scherm) om ze te bekijken.\n\nOntvang een e-mail met een bijgevoegd SIE-bestand, wijs ernaar en selecteer Rosetta voor weergave en het bestand wordt geopend.\n\nGebruik de e-mail-app op Chromebooks, niet in de browser.\n\nGebruik met toetsenbord, pijlen, F-knoppen, - en 1-9.\n\nLangeklik op jou!", "nl"},
		{SCT_TEXT, NULL, NULL, "En cliquant longuement sur l'écran, vous obtenez le menu Affichage. Dans le menu Affichage, vous pouvez ajouter des onglets de rapport, ce qui vous permet de comparer les différentes parties des rapports et de lire avec des paramètres différents du même rapport.\n\nSélectionner des périodes mensuelles dans rideau gauche (déplacez votre doigt de la gauche vers le centre de l'écran) et des objets comptables rideau droit (déplacez votre doigt de la droite vers le centre de l'écran) pour les afficher.\n\nRecevez un e-mail avec un fichier SIE attaché, pointez dessus et sélectionnez Rosetta pour l'affichage et le fichier sera ouvert.\n\nUtilisez l'application de messagerie dans Chromebooks, pas le navigateur.\n\nAvec clavier, utilisez les flèches, les touches F, - et 1-9.\n\nLong-cliquez sur vous!", "fr"},
		{SCT_TEXT, NULL, NULL, "Al hacer clic largo en la pantalla, aparece el menú Vista. En el menú Vista, puede agregar fichas de informe, lo que le permite comparar las diferentes partes de los informes y leer con diferentes configuraciones del mismo informe.\n\nSeleccione períodos mensuales en cortina izquierda (mueva el dedo desde la izquierda hacia el centro de la pantalla) y artículos de contabilidad cortina derecha (mover el dedo de derecha al centro de la pantalla) para su visualización.\n\nrecibir correo electrónico con un archivo adjunto SIE, apunte con él y seleccione Rosetta para la pantalla y se abrirá el archivo.\n\nUtilice la aplicación de correo electrónico en Chromebooks, no el navegador..\n\nCon teclado, use las flechas, los botones F, - y 1-9.\n\nHaga clic largo en usted!", "es"},
		{SCT_TEXT, NULL, NULL, "Ao clicar longamente na tela, você obtém o menu Exibir. No menu Exibir, você pode adicionar guias de relatório, o que lhe permite comparar diferentes partes de relatórios e ler com diferentes parâmetros par mesmo relatório.\n\nSelecione os períodos mensais na cortina esquerda (mova o dedo do lado esquerdo para o centro da tela) e objetos contábsie da cortina direita (mova o dedo do lado direito para o centro da tela) para vê-los.\n\nReceba um e-mail com um arquivo SIE anexado, aponte para ele e selecione Rosetta para visualização e o arquivo será aberto.\n\nUse o aplicativo de e-mail nos Chromebooks, não o navegador.\n\nCom teclado, use as setas, os botões F, - e 1-9.\n\nClique longo em você!", "pt"},
		{SCT_TEXT, NULL, NULL, "Cliccando a lungo sullo schermo, si ottiene il menu Visualizza. Dal menu Visualizza, puoi aggiungere schede di rapporti, che ti permettono di confrontare parti diverse di rapporti e di leggere con parametri diversi dallo stesso rapporto.\n\nSelezionare i periodi mensili tenda a sinistra (spostare il dito da sinistra verso il centro dello schermo) e gli elementi contabili tenda a destra (spostare il dito da destra verso il centro dello schermo) per la visualizzazione.\n\nricevere e-mail con un file allegato SIE, puntarlo e selezionare Rosetta per la visualizzazione e sarà aperto il file.\n\nUtilizza l'applicazione email nei Chromebook, non nel browser.\n\nCon tastiera, utilizzare le frecce, i tasti F, - e 1-9.\n\nClicca lungo su di te!", "it"}, {0}}},
	{"Edition",{
		{SCT_TEXT, NULL, NULL, "This product is available in Windows and Android and we are working on iPhone and Macintosh support. Accounting will come.", "en"},
		{SCT_TEXT, NULL, NULL, "Den här produkten är tillgänglig i Windows och Android och vi arbetar med iPhone och Macintosh-support. Bokföring kommer.", "sv"},
		{SCT_TEXT, NULL, NULL, "Dette produkt er tilgængeligt i Windows og Android, og vi arbejder med iPhone og Macintosh support. Bogføring kommer.", "da"},
		{SCT_TEXT, NULL, NULL, "Dette produktet er tilgjengelig i Windows og Android, og vi jobber med iPhone og Macintosh-støtte. Bokføring kommer.", "no"},
		{SCT_TEXT, NULL, NULL, "Þessi vara er fáanleg í Windows og Android og við vinnum með iPhone og Macintosh stuðningi. Bókhald kemur.", "is"},
		{SCT_TEXT, NULL, NULL, "Tämä tuote on saatavana Windows ja Android ja työskentelemme iPhone ja Macintosh-tuki. Täysi kirjanpito tulee.", "fi"},
		{SCT_TEXT, NULL, NULL, "Dieses Produkt ist in Windows und Android verfügbar und wir arbeiten mit iPhone und Macintosh-Unterstützung. Buchhaltung kommt.", "de"},
		{SCT_TEXT, NULL, NULL, "Dit product is verkrijgbaar in Windows en Android en we werken met iPhone- en Macintosh-ondersteuning. Het boekhouden komt.", "nl"},
		{SCT_TEXT, NULL, NULL, "Ce produit est disponible sous Windows et Android et nous travaillons avec le support de l'iPhone et du Macintosh. La comptabilité vient.", "fr"},
		{SCT_TEXT, NULL, NULL, "Este producto está disponible en Windows y Android y trabajamos con soporte para iPhone y Macintosh. La contabilidad viene.", "es"},
		{SCT_TEXT, NULL, NULL, "Este produto está disponível em Windows e Android e trabalhamos com suporte para iPhone e Macintosh. A contabilidade vem.", "pt"},
		{SCT_TEXT, NULL, NULL, "Questo prodotto è disponibile in Windows e Android e lavoriamo con supporto per iPhone e Macintosh. Arriva la contabilità.", "it"}, {0}}},
	{"Responsibilities",{
		{SCT_TEXT, NULL, NULL, "This is a free product and when not paid for, so Alphabet AB will not take legal responsibility for malfunctions. You pay to avoid advertising banners.", "en"},
		{SCT_TEXT, NULL, NULL, "Detta är en gratisprodukt och när det inte betalas för, så Alphabet AB tar inget juridiskt ansvar för funktionsfel. Man betalar för att slippa reklambanners.", "sv"},
		{SCT_TEXT, NULL, NULL, "Dette er et gratis produkt, og når det ikke betales, har Alphabet AB intet juridisk ansvar for funktionsfejl. Du betaler for at undgå reklamebannere.", "da"},
		{SCT_TEXT, NULL, NULL, "Dette er et gratis produkt, og når ikke betalt, tar Alphabet AB ikke noe ansvar for feil. Du betaler for å unngå å annonsere bannere.", "no"},
		{SCT_TEXT, NULL, NULL, "Þetta er ókeypis vara og þegar ekki er greitt, mun Alphabet AB ekki taka lagalega ábyrgð á bilunum. Þú borgar til að forðast auglýsingar borðar.", "is"},
		{SCT_TEXT, NULL, NULL, "Tämä on ilmainen tuote ja kun sitä ei makseta, niin Alphabet AB ei ota lakisääteistä vastuuta häiriöistä. Maksat mainosbannerien välttämiseksi.", "fi"},
		{SCT_TEXT, NULL, NULL, "Dies ist ein kostenloses Produkt und wenn es nicht bezahlt wird, übernimmt Alphabet AB keine juristische Verantwortung für Fehlfunktionen. Sie zahlen, um Werbebanner zu vermeiden.", "de"},
		{SCT_TEXT, NULL, NULL, "Dit is een gratis product en wanneer het niet wordt betaald, is Alphabet AB niet verantwoordelijk voor storingen. U betaalt om reclamebanners te vermijden.", "nl"},
		{SCT_TEXT, NULL, NULL, "Ceci est un produit gratuit et quand il n'est pas payé, Alphabet AB n'est pas responsable des dysfonctionnements. Vous payez pour éviter les bannières publicitaires.", "fr"},
		{SCT_TEXT, NULL, NULL, "Este es un producto gratuito y, cuando no se paga, Alphabet AB no se responsabiliza por el mal funcionamiento. Usted paga para evitar banners publicitarios.", "es"},
		{SCT_TEXT, NULL, NULL, "Este é um produto gratuito e quando não é pago, o Alfabeto AB não é responsável por avarias. Você paga para evitar banners publicitários.", "pt"},
		{SCT_TEXT, NULL, NULL, "Questo è un prodotto gratuito e quando non è pagato, Alphabet AB non è responsabile per malfunzionamenti. Paghi per evitare banner pubblicitari.", "it"}, {0}}},
	{0}
};

/*********************************************************************

Alphabet Rosetta C-functions

*********************************************************************/

/*********************************************************************

Basic

*********************************************************************

void *ReadWorkData(

*********************************************************************/
void *ReadWorkData(
	char *pBuffer)
{
	if(strstr(pBuffer, "<Accounting "))
		return (void *)ReadAccounting(pBuffer);
	else if(strstr(pBuffer, "<Invoice "))
		return (void *)ReadInvoice(pBuffer);
	return 0;
}

/*********************************************************************

void DestroyWorkData(

*********************************************************************/
void DestroyWorkData(
	void **vppWorkData)
{
	ProgramInfoType *Info = *vppWorkData; 
	switch(Info->DataType) {
	case SCT_ACCOUNTING:
		DestroyAccounting((AccountingType **)vppWorkData);
		break;
	case SCT_INVOICE:
		DestroyInvoice((InvoiceType **)vppWorkData);
		break;
	default:
		break;
	}
}

/*********************************************************************

char *GetProgramFileName(

*********************************************************************/
char *GetProgramFileName(
	void *vpWorkData)
{
	ProgramInfoType *Info = vpWorkData; 
	switch(Info->DataType) {
	case SCT_ACCOUNTING:
		return("Accounting.xml");
		break;
	case SCT_INVOICE:
		return("Invoice.xml");
		break;
	default:
		return 0;
	}
}

/*********************************************************************

int WriteWorkData(

*********************************************************************/
int WriteWorkData(
	void *vpWorkData, 
	char *pContent, 
	char *pFilePathName)
{
	FILE *pStream = 0;
	ProgramInfoType *pInfo = vpWorkData; 
	
	if((!pFilePathName) || (!*pFilePathName))
		return ERR_FILE_NAME; 
	if(!pInfo)
		return ERR_FILE_CONTENT; 
	
	switch(pInfo->DataType) {
	case SCT_ACCOUNTING:
		pStream = FileOpen(pFilePathName, "wb");
		if(!pStream) {
			return ERR_OPEN_FILE; // Bad
		}
		WriteAccounting(pStream, vpWorkData, pContent);
		fclose(pStream);
		break;
	case SCT_INVOICE:
		pStream = FileOpen(pFilePathName, "wb");
		if(!pStream) {
			return ERR_OPEN_FILE; // Bad
		}
		WriteInvoice(pStream, vpWorkData);
		fclose(pStream);
		break;
	default:
		return ERR_FILE_CONTENT;
	}
	return 0;
}


/*********************************************************************

	Accounting

*********************************************************************

BOOL WriteAccounting(

*********************************************************************/
BOOL WriteAccounting(
	FILE *pStream, 
	AccountingType *pAccounting, 
	char *pContent)
{
BOOL bRetval = FALSE;
char pAttr[] = {"\n\txmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n\txmlns=\"urn:Rosetta\"\n\txsi:schemaLocation=\"urn:Rosetta http://www.alphabet.se/Rosetta/Rosetta.xsd\""}; 
char szContent[] = {CONTENT_LABEL_LEDGER}; 

	if(!pStream)
		return bRetval; 
	if (!pAccounting)
		return bRetval; 
	if ((!pContent) || (!*pContent))
		pContent = szContent; 
	bRetval = WriteSectionAccounting(pStream, 1, "Accounting", pAttr, pAccounting, pContent); 
	return bRetval; 
}

/*********************************************************************

	AccountingType *ReadAccounting(

*********************************************************************/
AccountingType *ReadAccounting(
	char *pBuffer)
{
AccountingType *pAccounting = (AccountingType *) (-99);

	if(pBuffer && *pBuffer && (strstr(pBuffer, "<Accounting") || strstr(pBuffer, "< Accounting"))) {
		XmlTagDataType *pXmlTagData = calloc(1, sizeof(XmlTagDataType));
		if(pXmlTagData) {
			pXmlTagData->pBuffer = pBuffer;
			pXmlTagData = GetNextXmlTag(pXmlTagData);
			if (pXmlTagData->pBuffer && *pXmlTagData->pBuffer)
				pAccounting = ReadSectionAccounting(0, 0, pXmlTagData, "Accounting");
			free(pXmlTagData);
		}
	}
	return pAccounting;
}


/*********************************************************************

	Invoice

*********************************************************************

BOOL WriteInvoice(

*********************************************************************/
BOOL WriteInvoice(
	FILE *pStream, 
	InvoiceType *pInvoice)
{
BOOL bRetval = FALSE;
char pAttr[] = {"\n\txmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n\txmlns=\"urn:Rosetta\"\n\txsi:schemaLocation=\"urn:Rosetta http://www.alphabet.se/Rosetta/Rosetta.xsd\""}; 
	if(!pStream)
		return bRetval; 
	if (!pInvoice)
		return bRetval; 
	bRetval = WriteSectionInvoice(pStream, 1, "Invoice", pAttr, pInvoice); 
	return bRetval; 
}

/*********************************************************************

	InvoiceType *ReadInvoice(

*********************************************************************/
InvoiceType *ReadInvoice(
	char *pBuffer)
{
InvoiceType *pInvoice = (InvoiceType *) (-99);

	if(pBuffer && *pBuffer && (strstr(pBuffer, "<Invoice") || strstr(pBuffer, "< Invoice"))) {
		XmlTagDataType *pXmlTagData = calloc(1, sizeof(XmlTagDataType));
		if(pXmlTagData) {
			pXmlTagData->pBuffer = pBuffer;
			pXmlTagData = GetNextXmlTag(pXmlTagData);
			if (pXmlTagData->pBuffer && *pXmlTagData->pBuffer)
				pInvoice = ReadSectionInvoice(0, 0, pXmlTagData, "Invoice");
			free(pXmlTagData);
		}
	}
	return pInvoice;
}



/*********************************************************************

	Accounting

*********************************************************************

AccountingType *CreateAccounting(

*********************************************************************/
AccountingType *CreateAccounting(
	void *pStructDocTop, 
	void *pStructParent)
{
AccountingType *pAccounting = calloc(1, sizeof(AccountingType));

	if(!pAccounting)
		return 0;	// Fatal error

	pAccounting->DataType    = SCT_ACCOUNTING;
	if(pStructDocTop)
		pAccounting->pStructDocTop = pStructDocTop;
	else
		pAccounting->pStructDocTop = pAccounting;
	if(pStructParent)
		pAccounting->pStructParent = pStructParent;
	else
		pAccounting->pStructParent = pAccounting;
	pAccounting->pContent = NulString;
	pAccounting->pListComment = LListInit();
	pAccounting->pGaap = NulString;
	pAccounting->pCurrency = NulString;
	pAccounting->pDefaultLanguage = NulString;
	pAccounting->pListFileUrl = LListInit();
	pAccounting->pListAuditApproved = LListInit();

	pAccounting->pAccountsChart			= CreateAccountsChart(pAccounting, pAccounting);
	pAccounting->pObjectsChart			= CreateObjectsChart(pAccounting, pAccounting);
	pAccounting->pLedgersChart			= CreateLedgersChart(pAccounting, pAccounting);
	pAccounting->pIssuedInvoiceChart	= CreateInvoiceChart(pAccounting, pAccounting);
	pAccounting->pBankAccountsChart		= CreateInvoiceChart(pAccounting, pAccounting);

	return pAccounting;
}


/*********************************************************************

AccountingType *DestroyAccounting(

*********************************************************************/
AccountingType *DestroyAccounting(
	AccountingType **ppAccounting)
{
	if(!*ppAccounting)
		return 0;	// Nothing to destroy

	FreeString(&(*ppAccounting)->pContent);		// rac:ContentType
	{
		TextType *pComment
			= LListGetFirstRecordData((*ppAccounting)->pListComment);
		while(pComment) {
			DestroyText(&pComment);		// rac:TextType
			pComment = LListGetNextRecordData((*ppAccounting)->pListComment);
		}
		LListErase((*ppAccounting)->pListComment);
	}
	FreeString(&(*ppAccounting)->pGaap);		// xs:token
	FreeString(&(*ppAccounting)->pCurrency);		// rac:Currency
	FreeString(&(*ppAccounting)->pDefaultLanguage);		// xs:language
	LListDestroy((*ppAccounting)->pListFileUrl);		// rac:FileUrl
	DestroyProgramInfo(&(*ppAccounting)->pProgram);		// rac:ProgramInfoType
	DestroyOperatorInfo(&(*ppAccounting)->pGeneratingUser);		// rac:OperatorInfoType
	{
		AttestType *pAuditApproved
			= LListGetFirstRecordData((*ppAccounting)->pListAuditApproved);
		while(pAuditApproved) {
			DestroyAttest(&pAuditApproved);		// rac:AttestType
			pAuditApproved = LListGetNextRecordData((*ppAccounting)->pListAuditApproved);
		}
		LListErase((*ppAccounting)->pListAuditApproved);
	}
	DestroyParty(&(*ppAccounting)->pEntity);		// rac:PartyType
	DestroyParty(&(*ppAccounting)->pAccountant);		// rac:PartyType
	DestroyParty(&(*ppAccounting)->pAudit);		// rac:PartyType
	DestroyAccountsChart(&(*ppAccounting)->pAccountsChart);		// rac:AccountsChartType
	DestroyObjectsChart(&(*ppAccounting)->pObjectsChart);		// rac:ObjectsChartType
	DestroyLedgersChart(&(*ppAccounting)->pLedgersChart);		// rac:LedgersChartType
	DestroyInvoiceChart(&(*ppAccounting)->pIssuedInvoiceChart);		// rac:InvoiceChartType
	DestroyInvoiceChart(&(*ppAccounting)->pBankAccountsChart);		// rac:InvoiceChartType

	free(*ppAccounting);
	*ppAccounting = 0;

	return 0;
}


/*********************************************************************

AccountingType *CopyAccounting(

*********************************************************************/
AccountingType *CopyAccounting(
	void *pStructDocTop, 
	void *pStructParent, 
	AccountingType *pAccounting)
{
	if(pAccounting) {
		AccountingType *pNewAccounting = CreateAccounting(pStructDocTop, pStructParent);

		if(!pNewAccounting)
			return 0;	// Fatal error

		if(!pStructDocTop)
			pStructDocTop = pNewAccounting;	// Fatal error

		CopyString(&pNewAccounting->pContent, pAccounting->pContent);		// rac:ContentType
		{
			TextType *pComment
				= LListGetFirstRecordData(pAccounting->pListComment);
			while(pComment) {
				LListAddRecord(pNewAccounting->pListComment, CopyText(pStructDocTop, pNewAccounting, pComment));		// rac:TextType
				pComment = LListGetNextRecordData(pAccounting->pListComment);
			}
		}
		CopyString(&pNewAccounting->pGaap, pAccounting->pGaap);		// xs:token
		CopyString(&pNewAccounting->pCurrency, pAccounting->pCurrency);		// rac:Currency
		CopyString(&pNewAccounting->pDefaultLanguage, pAccounting->pDefaultLanguage);		// xs:language
		pNewAccounting->LastEntryDate = pAccounting->LastEntryDate;		// xs:date
		{
			char *pFileUrl
				= LListGetFirstRecordData(pAccounting->pListFileUrl);
			while(pFileUrl) {
				LListAddRecord(pNewAccounting->pListFileUrl, CopyString(0, pFileUrl));		// rac:FileUrl
				pFileUrl = LListGetNextRecordData(pAccounting->pListFileUrl);
			}
		}
		DestroyProgramInfo(&pNewAccounting->pProgram);
		pNewAccounting->pProgram = CopyProgramInfo(pStructDocTop, pNewAccounting, pAccounting->pProgram);		// rac:ProgramInfoType
		DestroyOperatorInfo(&pNewAccounting->pGeneratingUser);
		pNewAccounting->pGeneratingUser = CopyOperatorInfo(pStructDocTop, pNewAccounting, pAccounting->pGeneratingUser);		// rac:OperatorInfoType
		{
			AttestType *pAuditApproved
				= LListGetFirstRecordData(pAccounting->pListAuditApproved);
			while(pAuditApproved) {
				LListAddRecord(pNewAccounting->pListAuditApproved, CopyAttest(pStructDocTop, pNewAccounting, pAuditApproved));		// rac:AttestType
				pAuditApproved = LListGetNextRecordData(pAccounting->pListAuditApproved);
			}
		}
		pNewAccounting->pEntity = CopyParty(pStructDocTop, pNewAccounting, pAccounting->pEntity);		// rac:PartyType
		pNewAccounting->pAccountant = CopyParty(pStructDocTop, pNewAccounting, pAccounting->pAccountant);		// rac:PartyType
		pNewAccounting->pAudit = CopyParty(pStructDocTop, pNewAccounting, pAccounting->pAudit);		// rac:PartyType
		pNewAccounting->pAccountsChart = CopyAccountsChart(pStructDocTop, pNewAccounting, pAccounting->pAccountsChart);		// rac:AccountsChartType
		pNewAccounting->pObjectsChart = CopyObjectsChart(pStructDocTop, pNewAccounting, pAccounting->pObjectsChart);		// rac:ObjectsChartType
		pNewAccounting->pLedgersChart = CopyLedgersChart(pStructDocTop, pNewAccounting, pAccounting->pLedgersChart);		// rac:LedgersChartType
		DestroyInvoiceChart(&pNewAccounting->pIssuedInvoiceChart);
		pNewAccounting->pIssuedInvoiceChart = CopyInvoiceChart(pStructDocTop, pNewAccounting, pAccounting->pIssuedInvoiceChart);		// rac:InvoiceChartType
		DestroyInvoiceChart(&pNewAccounting->pBankAccountsChart);
		pNewAccounting->pBankAccountsChart = CopyInvoiceChart(pStructDocTop, pNewAccounting, pAccounting->pBankAccountsChart);		// rac:InvoiceChartType

		return (pNewAccounting);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataAccounting(

*********************************************************************/
BOOL IsDataAccounting(
	AccountingType *pAccounting)
{
	if(!pAccounting)
		return FALSE;

	if(pAccounting->pContent && *pAccounting->pContent)
		return TRUE;
	{
		TextType *pComment
			= LListGetFirstRecordData(pAccounting->pListComment);
		while(pComment) {
			if(IsDataText(pComment))
				return TRUE;
			pComment = LListGetNextRecordData(pAccounting->pListComment);
		}
	}
	if(pAccounting->pGaap && *pAccounting->pGaap)
		return TRUE;
	if(pAccounting->pCurrency && *pAccounting->pCurrency)
		return TRUE;
	if(pAccounting->pDefaultLanguage && *pAccounting->pDefaultLanguage)
		return TRUE;
	if(pAccounting->LastEntryDate)
		return TRUE;
	if(LListGetFirstRecordData(pAccounting->pListFileUrl))
		return TRUE;
	if(IsDataProgramInfo(pAccounting->pProgram))
		return TRUE;
	if(IsDataOperatorInfo(pAccounting->pGeneratingUser))
		return TRUE;
	{
		AttestType *pAuditApproved
			= LListGetFirstRecordData(pAccounting->pListAuditApproved);
		while(pAuditApproved) {
			if(IsDataAttest(pAuditApproved))
				return TRUE;
			pAuditApproved = LListGetNextRecordData(pAccounting->pListAuditApproved);
		}
	}
	if(IsDataParty(pAccounting->pEntity))
		return TRUE;
	if(IsDataParty(pAccounting->pAccountant))
		return TRUE;
	if(IsDataParty(pAccounting->pAudit))
		return TRUE;
	if(IsDataAccountsChart(pAccounting->pAccountsChart))
		return TRUE;
	if(IsDataObjectsChart(pAccounting->pObjectsChart))
		return TRUE;
	if(IsDataLedgersChart(pAccounting->pLedgersChart))
		return TRUE;
	if(IsDataInvoiceChart(pAccounting->pIssuedInvoiceChart))
		return TRUE;
	if(IsDataInvoiceChart(pAccounting->pBankAccountsChart))
		return TRUE;

	return FALSE;
}


/*********************************************************************

AccountingType *ReadSectionAccounting(

*********************************************************************/
AccountingType *ReadSectionAccounting(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
AccountingType *pAccounting = CreateAccounting(pStructDocTop, pStructParent);

	if(!pAccounting)
		return 0;	// Fatal error

	if(!pStructDocTop)
		pAccounting->pStructDocTop = pAccounting;	// Top struct

	pXmlTagData=GetNextXmlTag(pXmlTagData);

	if(!pXmlTagData)
		return 0;	// Fatal error

	while(strcmp(pXmlTagData->pTag, pEndTag)) { // While is not the end
		if(!strcmp(pXmlTagData->pTag, "Content"))
			CheckEnum(&pAccounting->pContent, EnumContentType, ReadXmlDataString(pXmlTagData->pData));		// rac:ContentType
		else if(!strcmp(pXmlTagData->pTag, "Comment"))
			LListAddRecord(pAccounting->pListComment, ReadSectionText(pStructDocTop, pAccounting, pXmlTagData, "Comment"));		// rac:TextType
		else if(!strcmp(pXmlTagData->pTag, "Gaap"))
			ReadString(&pAccounting->pGaap, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "Currency"))
			ReadString(&pAccounting->pCurrency, ReadXmlDataString(pXmlTagData->pData));		// rac:Currency
		else if(!strcmp(pXmlTagData->pTag, "DefaultLanguage"))
			ReadString(&pAccounting->pDefaultLanguage, ReadXmlDataString(pXmlTagData->pData));		// xs:language
		else if(!strcmp(pXmlTagData->pTag, "LastEntryDate"))
			pAccounting->LastEntryDate = StringToDate(pXmlTagData->pData);		// xs:date
		else if(!strcmp(pXmlTagData->pTag, "FileUrl"))
			LListAddRecord(pAccounting->pListFileUrl, ReadXmlDataString(pXmlTagData->pData));		// rac:FileUrl
		else if(!strcmp(pXmlTagData->pTag, "Program")) {
			DestroyProgramInfo(&pAccounting->pProgram);
			pAccounting->pProgram = ReadSectionProgramInfo(pAccounting, pAccounting, pXmlTagData, "Program");		// rac:ProgramInfoType
			}
		else if(!strcmp(pXmlTagData->pTag, "GeneratingUser")) {
			DestroyOperatorInfo(&pAccounting->pGeneratingUser);
			pAccounting->pGeneratingUser = ReadSectionOperatorInfo(pAccounting, pAccounting, pXmlTagData, "GeneratingUser");		// rac:OperatorInfoType
			}
		else if(!strcmp(pXmlTagData->pTag, "AuditApproved"))
			LListAddRecord(pAccounting->pListAuditApproved, ReadSectionAttest(pStructDocTop, pAccounting, pXmlTagData, "AuditApproved"));		// rac:AttestType
		else if(!strcmp(pXmlTagData->pTag, "Entity"))
			pAccounting->pEntity = ReadSectionParty(pAccounting, pAccounting, pXmlTagData, "Entity");		// rac:PartyType
		else if(!strcmp(pXmlTagData->pTag, "Accountant"))
			pAccounting->pAccountant = ReadSectionParty(pAccounting, pAccounting, pXmlTagData, "Accountant");		// rac:PartyType
		else if(!strcmp(pXmlTagData->pTag, "Audit"))
			pAccounting->pAudit = ReadSectionParty(pAccounting, pAccounting, pXmlTagData, "Audit");		// rac:PartyType
		else if(!strcmp(pXmlTagData->pTag, "AccountsChart"))
			pAccounting->pAccountsChart = ReadSectionAccountsChart(pAccounting, pAccounting, pXmlTagData, "AccountsChart");		// rac:AccountsChartType
		else if(!strcmp(pXmlTagData->pTag, "ObjectsChart"))
			pAccounting->pObjectsChart = ReadSectionObjectsChart(pAccounting, pAccounting, pXmlTagData, "ObjectsChart");		// rac:ObjectsChartType
		else if(!strcmp(pXmlTagData->pTag, "LedgersChart"))
			pAccounting->pLedgersChart = ReadSectionLedgersChart(pAccounting, pAccounting, pXmlTagData, "LedgersChart");		// rac:LedgersChartType
		else if(!strcmp(pXmlTagData->pTag, "IssuedInvoiceChart"))
			pAccounting->pIssuedInvoiceChart = ReadSectionInvoiceChart(pAccounting, pAccounting, pXmlTagData, "IssuedInvoiceChart");		// rac:InvoiceChartType
		else if(!strcmp(pXmlTagData->pTag, "BankAccountsChart"))
			pAccounting->pBankAccountsChart = ReadSectionInvoiceChart(pAccounting, pAccounting, pXmlTagData, "BankAccountsChart");		// rac:InvoiceChartType

		pXmlTagData=GetNextXmlTag(pXmlTagData);

		if(!pXmlTagData)
			return 0;	// Fatal error
	}
	return pAccounting;
}


/*********************************************************************

static BOOL WriteSectionAccounting(

*********************************************************************/
static BOOL WriteSectionAccounting(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	AccountingType *pAccounting, 
	char *pContent)
{
	if(!pAccounting)
		return FALSE;	// Fatal error

	xmlWriteLine(pStream, iTab-1, pAttr, pLabel, 0, 0);
	if(pAccounting->pContent && *pAccounting->pContent)
		xmlWriteLine(pStream, iTab, 0, "Content", pContent, "Content");		// rac:ContentType

	if(pAccounting->pListComment) {
		TextType *pComment
			= LListGetFirstRecordData(pAccounting->pListComment);
		while(pComment) {
			if(IsDataText(pComment))
				WriteSectionText(pStream, iTab+1, "Comment", 0, pComment);		// rac:TextType
			pComment = LListGetNextRecordData(pAccounting->pListComment);
		}
	}
	xmlWriteLine(pStream, iTab, 0, "Gaap", pAccounting->pGaap, "Gaap");		// xs:token - Mandatory
	if(pAccounting->pCurrency && *pAccounting->pCurrency)
		xmlWriteLine(pStream, iTab, 0, "Currency", pAccounting->pCurrency, "Currency");		// rac:Currency
	if(pAccounting->pDefaultLanguage && *pAccounting->pDefaultLanguage)
		xmlWriteLine(pStream, iTab, 0, "DefaultLanguage", pAccounting->pDefaultLanguage, "DefaultLanguage");		// xs:language
	if(pAccounting->LastEntryDate && strcmp(pContent, CONTENT_LABEL_CHARTS))
		xmlWriteLine(pStream, iTab, 0, "LastEntryDate", DateToStr(GetLastEntryDate(pAccounting), szString),"LastEntryDate");		// xs:date

	if(pAccounting->pListFileUrl) {
		char *pFileUrl
			= LListGetFirstRecordData(pAccounting->pListFileUrl);
		while(pFileUrl) {
			xmlWriteLine(pStream, iTab, 0, "FileUrl", pFileUrl, "FileUrl");		// rac:FileUrl

			pFileUrl = LListGetNextRecordData(pAccounting->pListFileUrl);
		}
	}

	if(!pAccounting->pProgram)		// Mandatory
		pAccounting->pProgram = CreateProgramInfo(pAccounting->pStructDocTop, pAccounting);
	GetSystemProgram(&pAccounting->pProgram->pProgramInfo);
	GetSystemProgramVersion(&pAccounting->pProgram->pversion);
	WriteSectionProgramInfo(pStream, iTab+1, "Program", 0, pAccounting->pProgram);		// rac:ProgramInfoType - Mandatory

	if(!pAccounting->pGeneratingUser)		// Mandatory
		pAccounting->pGeneratingUser = CreateOperatorInfo(pAccounting->pStructDocTop, pAccounting);
	GetSystemUser(&pAccounting->pGeneratingUser->pOperatorInfo); 
	pAccounting->pGeneratingUser->date = GetSystemDate();
	WriteSectionOperatorInfo(pStream, iTab+1, "GeneratingUser", 0, pAccounting->pGeneratingUser);		// rac:OperatorInfoType - Mandatory

	if(pAccounting->pListAuditApproved) {
		AttestType *pAuditApproved
			= LListGetFirstRecordData(pAccounting->pListAuditApproved);
		while(pAuditApproved) {
			if(IsDataAttest(pAuditApproved))
				WriteSectionAttest(pStream, iTab+1, "AuditApproved", 0, pAuditApproved);		// rac:AttestType
			pAuditApproved = LListGetNextRecordData(pAccounting->pListAuditApproved);
		}
	}

	if(pAccounting->pEntity && IsDataParty(pAccounting->pEntity) && strcmp(pContent, CONTENT_LABEL_CHARTS))		// Optional
		WriteSectionParty(pStream, iTab+1, "Entity", 0, pAccounting->pEntity);		// rac:PartyType

	if(pAccounting->pAccountant && IsDataParty(pAccounting->pAccountant))		// Optional
		WriteSectionParty(pStream, iTab+1, "Accountant", 0, pAccounting->pAccountant);		// rac:PartyType

	if(pAccounting->pAudit && IsDataParty(pAccounting->pAudit) && strcmp(pContent, CONTENT_LABEL_CHARTS))		// Optional
		WriteSectionParty(pStream, iTab+1, "Audit", 0, pAccounting->pAudit);		// rac:PartyType

	if(pAccounting->pAccountsChart && IsDataAccountsChart(pAccounting->pAccountsChart))		// Optional
		WriteSectionAccountsChart(pStream, iTab+1, "AccountsChart", 0, pAccounting->pAccountsChart, pContent);		// rac:AccountsChartType

	if(pAccounting->pObjectsChart && IsDataObjectsChart(pAccounting->pObjectsChart))		// Optional
		WriteSectionObjectsChart(pStream, iTab+1, "ObjectsChart", 0, pAccounting->pObjectsChart, pContent);		// rac:ObjectsChartType

	if(pAccounting->pLedgersChart && IsDataLedgersChart(pAccounting->pLedgersChart) && strcmp(pContent, CONTENT_LABEL_CHARTS))		// Optional
		WriteSectionLedgersChart(pStream, iTab+1, "LedgersChart", 0, pAccounting->pLedgersChart, pContent);		// rac:LedgersChartType

	if(pAccounting->pIssuedInvoiceChart && IsDataInvoiceChart(pAccounting->pIssuedInvoiceChart))		// Optional
		WriteSectionInvoiceChart(pStream, iTab+1, "IssuedInvoiceChart", 0, pAccounting->pIssuedInvoiceChart);		// rac:InvoiceChartType

	if(pAccounting->pBankAccountsChart && IsDataInvoiceChart(pAccounting->pBankAccountsChart) && (!strcmp(pContent, CONTENT_LABEL_LEDGER)))		// Optional
		WriteSectionInvoiceChart(pStream, iTab+1, "BankAccountsChart", 0, pAccounting->pBankAccountsChart);		// rac:InvoiceChartType

	xmlWriteLine(pStream, iTab-1, 0, 0, 0, pLabel);

	return TRUE;
}


/*********************************************************************

AccountingType *UpdateAccounting(

*********************************************************************/
AccountingType *UpdateAccounting(
	AccountingType *pStructAccounting, 
	char *pContent, 
	char *pGaap, 
	char *pCurrency, 
	char *pDefaultLanguage, 
	DATEINT LastEntryDate)
{
	StringUpdate(&pStructAccounting->pContent, pContent);
	StringUpdate(&pStructAccounting->pGaap, pGaap);
	StringUpdate(&pStructAccounting->pCurrency, pCurrency);
	StringUpdate(&pStructAccounting->pDefaultLanguage, pDefaultLanguage);
	pStructAccounting->LastEntryDate = LastEntryDate;

	return pStructAccounting;
}


/*********************************************************************

char **GetLeadTextAccounting(

*********************************************************************/
char **GetLeadTextAccounting(
	char *pLang)
{
static char *szTexts[] = {
	"Content",
	"Comment",
	"Gaap",
	"Currency",
	"Default Language",
	"Last Entry Date",
	"File Url",
	"Program",
	"Generating User",
	"Audit Approved",
	"Entity",
	"Accountant",
	"Audit",
	"Accounts Chart",
	"Objects Chart",
	"Ledgers Chart",
	"Issued Invoice Chart",
	"Bank Accounts Chart"};

	return szTexts;
}


/*********************************************************************

	Attest

*********************************************************************

AttestType *CreateAttest(

*********************************************************************/
AttestType *CreateAttest(
	void *pStructDocTop, 
	void *pStructParent)
{
AttestType *pAttest = calloc(1, sizeof(AttestType));

	if(!pAttest)
		return 0;	// Fatal error

	pAttest->DataType    = SCT_ATTEST;
	pAttest->pStructDocTop = pStructDocTop;
	pAttest->pStructParent = pStructParent;

	pAttest->pListNote = LListInit();
	pAttest->pListPkiNote = LListInit();
	pAttest->pListFileUrl = LListInit();

	return pAttest;
}


/*********************************************************************

AttestType *DestroyAttest(

*********************************************************************/
AttestType *DestroyAttest(
	AttestType **ppAttest)
{
	if(!*ppAttest)
		return 0;	// Nothing to destroy

	DestroyOperatorInfo(&(*ppAttest)->pAttestant);		// rac:OperatorInfoType
	{
		TextType *pNote
			= LListGetFirstRecordData((*ppAttest)->pListNote);
		while(pNote) {
			DestroyText(&pNote);		// rac:TextType
			pNote = LListGetNextRecordData((*ppAttest)->pListNote);
		}
		LListErase((*ppAttest)->pListNote);
	}
	LListDestroy((*ppAttest)->pListPkiNote);		// xs:token
	LListDestroy((*ppAttest)->pListFileUrl);		// rac:FileUrl

	free(*ppAttest);
	*ppAttest = 0;

	return 0;
}


/*********************************************************************

AttestType *CopyAttest(

*********************************************************************/
AttestType *CopyAttest(
	void *pStructDocTop, 
	void *pStructParent, 
	AttestType *pAttest)
{
	if(pAttest) {
		AttestType *pNewAttest = CreateAttest(pStructDocTop, pStructParent);

		if(!pNewAttest)
			return 0;	// Fatal error

		pNewAttest->pAttestant = CopyOperatorInfo(pStructDocTop, pNewAttest, pAttest->pAttestant);		// rac:OperatorInfoType
		{
			TextType *pNote
				= LListGetFirstRecordData(pAttest->pListNote);
			while(pNote) {
				LListAddRecord(pNewAttest->pListNote, CopyText(pStructDocTop, pNewAttest, pNote));		// rac:TextType
				pNote = LListGetNextRecordData(pAttest->pListNote);
			}
		}
		{
			char *pPkiNote
				= LListGetFirstRecordData(pAttest->pListPkiNote);
			while(pPkiNote) {
				LListAddRecord(pNewAttest->pListPkiNote, CopyString(0, pPkiNote));		// xs:token
				pPkiNote = LListGetNextRecordData(pAttest->pListPkiNote);
			}
		}
		{
			char *pFileUrl
				= LListGetFirstRecordData(pAttest->pListFileUrl);
			while(pFileUrl) {
				LListAddRecord(pNewAttest->pListFileUrl, CopyString(0, pFileUrl));		// rac:FileUrl
				pFileUrl = LListGetNextRecordData(pAttest->pListFileUrl);
			}
		}

		return (pNewAttest);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataAttest(

*********************************************************************/
BOOL IsDataAttest(
	AttestType *pAttest)
{
	if(!pAttest)
		return FALSE;

	if(IsDataOperatorInfo(pAttest->pAttestant))
		return TRUE;
	{
		TextType *pNote
			= LListGetFirstRecordData(pAttest->pListNote);
		while(pNote) {
			if(IsDataText(pNote))
				return TRUE;
			pNote = LListGetNextRecordData(pAttest->pListNote);
		}
	}
	if(LListGetFirstRecordData(pAttest->pListPkiNote))
		return TRUE;
	if(LListGetFirstRecordData(pAttest->pListFileUrl))
		return TRUE;

	return FALSE;
}


/*********************************************************************

static AttestType *ReadSectionAttest(

*********************************************************************/
static AttestType *ReadSectionAttest(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
AttestType *pAttest = CreateAttest(pStructDocTop, pStructParent);

	if(!pAttest)
		return 0;	// Fatal error

	pXmlTagData=GetNextXmlTag(pXmlTagData);

	if(!pXmlTagData)
		return 0;	// Fatal error

	while(strcmp(pXmlTagData->pTag, pEndTag)) { // While is not the end
		if(!strcmp(pXmlTagData->pTag, "Attestant")) {
			DestroyOperatorInfo(&pAttest->pAttestant);
			pAttest->pAttestant = ReadSectionOperatorInfo(pStructDocTop, pAttest, pXmlTagData, "Attestant");		// rac:OperatorInfoType
			}
		else if(!strcmp(pXmlTagData->pTag, "Note"))
			LListAddRecord(pAttest->pListNote, ReadSectionText(pStructDocTop, pAttest, pXmlTagData, "Note"));		// rac:TextType
		else if(!strcmp(pXmlTagData->pTag, "PkiNote"))
			LListAddRecord(pAttest->pListPkiNote, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "FileUrl"))
			LListAddRecord(pAttest->pListFileUrl, ReadXmlDataString(pXmlTagData->pData));		// rac:FileUrl

		pXmlTagData=GetNextXmlTag(pXmlTagData);

		if(!pXmlTagData)
			return 0;	// Fatal error
	}
	return pAttest;
}


/*********************************************************************

static BOOL WriteSectionAttest(

*********************************************************************/
static BOOL WriteSectionAttest(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	AttestType *pAttest)
{
	if(!pAttest)
		return FALSE;	// Fatal error

	xmlWriteLine(pStream, iTab-1, pAttr, pLabel, 0, 0);

	if(!pAttest->pAttestant)		// Mandatory
		pAttest->pAttestant = CreateOperatorInfo(pAttest->pStructDocTop, pAttest);
	WriteSectionOperatorInfo(pStream, iTab+1, "Attestant", 0, pAttest->pAttestant);		// rac:OperatorInfoType - Mandatory

	if(pAttest->pListNote) {
		TextType *pNote
			= LListGetFirstRecordData(pAttest->pListNote);
		while(pNote) {
			if(IsDataText(pNote))
				WriteSectionText(pStream, iTab+1, "Note", 0, pNote);		// rac:TextType
			pNote = LListGetNextRecordData(pAttest->pListNote);
		}
	}

	if(pAttest->pListPkiNote) {
		char *pPkiNote
			= LListGetFirstRecordData(pAttest->pListPkiNote);
		while(pPkiNote) {
			xmlWriteLine(pStream, iTab, 0, "PkiNote", pPkiNote, "PkiNote");		// xs:token

			pPkiNote = LListGetNextRecordData(pAttest->pListPkiNote);
		}
	}

	if(pAttest->pListFileUrl) {
		char *pFileUrl
			= LListGetFirstRecordData(pAttest->pListFileUrl);
		while(pFileUrl) {
			xmlWriteLine(pStream, iTab, 0, "FileUrl", pFileUrl, "FileUrl");		// rac:FileUrl

			pFileUrl = LListGetNextRecordData(pAttest->pListFileUrl);
		}
	}

	xmlWriteLine(pStream, iTab-1, 0, 0, 0, pLabel);

	return TRUE;
}


/*********************************************************************

AttestType *UpdateAttest(

*********************************************************************/
AttestType *UpdateAttest(
	AttestType *pStructAttest)
{

	return pStructAttest;
}


/*********************************************************************

char **GetLeadTextAttest(

*********************************************************************/
char **GetLeadTextAttest(
	char *pLang)
{
static char *szTexts[] = {
	"Attestant",
	"Note",
	"Pki Note",
	"File Url"};

	return szTexts;
}


/*********************************************************************

	Party

*********************************************************************

PartyType *CreateParty(

*********************************************************************/
PartyType *CreateParty(
	void *pStructDocTop, 
	void *pStructParent)
{
PartyType *pParty = calloc(1, sizeof(PartyType));

	if(!pParty)
		return 0;	// Fatal error

	pParty->DataType    = SCT_PARTY;
	pParty->pStructDocTop = pStructDocTop;
	pParty->pStructParent = pStructParent;

	pParty->pName = NulString;
	pParty->pListAddress = LListInit();
	pParty->pPostalCode = NulString;
	pParty->pPostalAddress = NulString;
	pParty->pPostalCountry = NulString;
	pParty->pEntityPhone = NulString;
	pParty->pEntityEmail = NulString;
	pParty->pListLogotypeFileUrl = LListInit();
	pParty->pListWebPage = LListInit();
	pParty->pListCrmRef = LListInit();
	pParty->pListFileUrl = LListInit();
	pParty->pListNote = LListInit();
	pParty->pListContact = LListInit();
	pParty->pProprietaryId = NulString;
	pParty->pLegalRegId = NulString;
	pParty->pJurisdiction = NulString;
	pParty->pEntityType = NulString;
	pParty->pStatisticalClass = NulString;
	pParty->pListLegalFileUrl = LListInit();
	pParty->pVatRegId = NulString;
	pParty->pVatCurrency = NulString;
	pParty->pListVatFileUrl = LListInit();
	pParty->pListIncomeTaxFileUrl = LListInit();

	return pParty;
}


/*********************************************************************

PartyType *DestroyParty(

*********************************************************************/
PartyType *DestroyParty(
	PartyType **ppParty)
{
	if(!*ppParty)
		return 0;	// Nothing to destroy

	FreeString(&(*ppParty)->pName);		// xs:token
	LListDestroy((*ppParty)->pListAddress);		// xs:token
	FreeString(&(*ppParty)->pPostalCode);		// xs:token
	FreeString(&(*ppParty)->pPostalAddress);		// xs:token
	FreeString(&(*ppParty)->pPostalCountry);		// xs:token
	FreeString(&(*ppParty)->pEntityPhone);		// rac:Phone
	FreeString(&(*ppParty)->pEntityEmail);		// rac:Email
	LListDestroy((*ppParty)->pListLogotypeFileUrl);		// rac:FileUrl
	LListDestroy((*ppParty)->pListWebPage);		// rac:FileUrl
	LListDestroy((*ppParty)->pListCrmRef);		// rac:FileUrl
	LListDestroy((*ppParty)->pListFileUrl);		// rac:FileUrl
	LListDestroy((*ppParty)->pListNote);		// xs:string
	{
		ContactType *pContact
			= LListGetFirstRecordData((*ppParty)->pListContact);
		while(pContact) {
			DestroyContact(&pContact);		// rac:ContactType
			pContact = LListGetNextRecordData((*ppParty)->pListContact);
		}
		LListErase((*ppParty)->pListContact);
	}
	FreeString(&(*ppParty)->pProprietaryId);		// xs:token
	FreeString(&(*ppParty)->pLegalRegId);		// xs:token
	FreeString(&(*ppParty)->pJurisdiction);		// rac:Country
	FreeString(&(*ppParty)->pEntityType);		// xs:token
	FreeString(&(*ppParty)->pStatisticalClass);		// xs:token
	LListDestroy((*ppParty)->pListLegalFileUrl);		// rac:FileUrl
	FreeString(&(*ppParty)->pVatRegId);		// xs:token
	FreeString(&(*ppParty)->pVatCurrency);		// rac:Currency
	LListDestroy((*ppParty)->pListVatFileUrl);		// rac:FileUrl
	LListDestroy((*ppParty)->pListIncomeTaxFileUrl);		// rac:FileUrl

	free(*ppParty);
	*ppParty = 0;

	return 0;
}


/*********************************************************************

PartyType *CopyParty(

*********************************************************************/
PartyType *CopyParty(
	void *pStructDocTop, 
	void *pStructParent, 
	PartyType *pParty)
{
	if(pParty) {
		PartyType *pNewParty = CreateParty(pStructDocTop, pStructParent);

		if(!pNewParty)
			return 0;	// Fatal error

		CopyString(&pNewParty->pName, pParty->pName);		// xs:token
		{
			char *pAddress
				= LListGetFirstRecordData(pParty->pListAddress);
			while(pAddress) {
				LListAddRecord(pNewParty->pListAddress, CopyString(0, pAddress));		// xs:token
				pAddress = LListGetNextRecordData(pParty->pListAddress);
			}
		}
		CopyString(&pNewParty->pPostalCode, pParty->pPostalCode);		// xs:token
		CopyString(&pNewParty->pPostalAddress, pParty->pPostalAddress);		// xs:token
		CopyString(&pNewParty->pPostalCountry, pParty->pPostalCountry);		// xs:token
		CopyString(&pNewParty->pEntityPhone, pParty->pEntityPhone);		// rac:Phone
		CopyString(&pNewParty->pEntityEmail, pParty->pEntityEmail);		// rac:Email
		{
			char *pLogotypeFileUrl
				= LListGetFirstRecordData(pParty->pListLogotypeFileUrl);
			while(pLogotypeFileUrl) {
				LListAddRecord(pNewParty->pListLogotypeFileUrl, CopyString(0, pLogotypeFileUrl));		// rac:FileUrl
				pLogotypeFileUrl = LListGetNextRecordData(pParty->pListLogotypeFileUrl);
			}
		}
		{
			char *pWebPage
				= LListGetFirstRecordData(pParty->pListWebPage);
			while(pWebPage) {
				LListAddRecord(pNewParty->pListWebPage, CopyString(0, pWebPage));		// rac:FileUrl
				pWebPage = LListGetNextRecordData(pParty->pListWebPage);
			}
		}
		{
			char *pCrmRef
				= LListGetFirstRecordData(pParty->pListCrmRef);
			while(pCrmRef) {
				LListAddRecord(pNewParty->pListCrmRef, CopyString(0, pCrmRef));		// rac:FileUrl
				pCrmRef = LListGetNextRecordData(pParty->pListCrmRef);
			}
		}
		{
			char *pFileUrl
				= LListGetFirstRecordData(pParty->pListFileUrl);
			while(pFileUrl) {
				LListAddRecord(pNewParty->pListFileUrl, CopyString(0, pFileUrl));		// rac:FileUrl
				pFileUrl = LListGetNextRecordData(pParty->pListFileUrl);
			}
		}
		{
			char *pNote
				= LListGetFirstRecordData(pParty->pListNote);
			while(pNote) {
				LListAddRecord(pNewParty->pListNote, CopyString(0, pNote));		// xs:string
				pNote = LListGetNextRecordData(pParty->pListNote);
			}
		}
		{
			ContactType *pContact
				= LListGetFirstRecordData(pParty->pListContact);
			while(pContact) {
				LListAddRecord(pNewParty->pListContact, CopyContact(pStructDocTop, pNewParty, pContact));		// rac:ContactType
				pContact = LListGetNextRecordData(pParty->pListContact);
			}
		}
		CopyString(&pNewParty->pProprietaryId, pParty->pProprietaryId);		// xs:token
		CopyString(&pNewParty->pLegalRegId, pParty->pLegalRegId);		// xs:token
		CopyString(&pNewParty->pJurisdiction, pParty->pJurisdiction);		// rac:Country
		CopyString(&pNewParty->pEntityType, pParty->pEntityType);		// xs:token
		CopyString(&pNewParty->pStatisticalClass, pParty->pStatisticalClass);		// xs:token
		{
			char *pLegalFileUrl
				= LListGetFirstRecordData(pParty->pListLegalFileUrl);
			while(pLegalFileUrl) {
				LListAddRecord(pNewParty->pListLegalFileUrl, CopyString(0, pLegalFileUrl));		// rac:FileUrl
				pLegalFileUrl = LListGetNextRecordData(pParty->pListLegalFileUrl);
			}
		}
		CopyString(&pNewParty->pVatRegId, pParty->pVatRegId);		// xs:token
		CopyString(&pNewParty->pVatCurrency, pParty->pVatCurrency);		// rac:Currency
		pNewParty->CashAccounting = pParty->CashAccounting;		// xs:boolean
		{
			char *pVatFileUrl
				= LListGetFirstRecordData(pParty->pListVatFileUrl);
			while(pVatFileUrl) {
				LListAddRecord(pNewParty->pListVatFileUrl, CopyString(0, pVatFileUrl));		// rac:FileUrl
				pVatFileUrl = LListGetNextRecordData(pParty->pListVatFileUrl);
			}
		}
		{
			char *pIncomeTaxFileUrl
				= LListGetFirstRecordData(pParty->pListIncomeTaxFileUrl);
			while(pIncomeTaxFileUrl) {
				LListAddRecord(pNewParty->pListIncomeTaxFileUrl, CopyString(0, pIncomeTaxFileUrl));		// rac:FileUrl
				pIncomeTaxFileUrl = LListGetNextRecordData(pParty->pListIncomeTaxFileUrl);
			}
		}

		return (pNewParty);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataParty(

*********************************************************************/
BOOL IsDataParty(
	PartyType *pParty)
{
	if(!pParty)
		return FALSE;

	if(pParty->pName && *pParty->pName)
		return TRUE;
	if(LListGetFirstRecordData(pParty->pListAddress))
		return TRUE;
	if(pParty->pPostalCode && *pParty->pPostalCode)
		return TRUE;
	if(pParty->pPostalAddress && *pParty->pPostalAddress)
		return TRUE;
	if(pParty->pPostalCountry && *pParty->pPostalCountry)
		return TRUE;
	if(pParty->pEntityPhone && *pParty->pEntityPhone)
		return TRUE;
	if(pParty->pEntityEmail && *pParty->pEntityEmail)
		return TRUE;
	if(LListGetFirstRecordData(pParty->pListLogotypeFileUrl))
		return TRUE;
	if(LListGetFirstRecordData(pParty->pListWebPage))
		return TRUE;
	if(LListGetFirstRecordData(pParty->pListCrmRef))
		return TRUE;
	if(LListGetFirstRecordData(pParty->pListFileUrl))
		return TRUE;
	if(LListGetFirstRecordData(pParty->pListNote))
		return TRUE;
	{
		ContactType *pContact
			= LListGetFirstRecordData(pParty->pListContact);
		while(pContact) {
			if(IsDataContact(pContact))
				return TRUE;
			pContact = LListGetNextRecordData(pParty->pListContact);
		}
	}
	if(pParty->pProprietaryId && *pParty->pProprietaryId)
		return TRUE;
	if(pParty->pLegalRegId && *pParty->pLegalRegId)
		return TRUE;
	if(pParty->pJurisdiction && *pParty->pJurisdiction)
		return TRUE;
	if(pParty->pEntityType && *pParty->pEntityType)
		return TRUE;
	if(pParty->pStatisticalClass && *pParty->pStatisticalClass)
		return TRUE;
	if(LListGetFirstRecordData(pParty->pListLegalFileUrl))
		return TRUE;
	if(pParty->pVatRegId && *pParty->pVatRegId)
		return TRUE;
	if(pParty->pVatCurrency && *pParty->pVatCurrency)
		return TRUE;
	if(pParty->CashAccounting)
		return TRUE;
	if(LListGetFirstRecordData(pParty->pListVatFileUrl))
		return TRUE;
	if(LListGetFirstRecordData(pParty->pListIncomeTaxFileUrl))
		return TRUE;

	return FALSE;
}


/*********************************************************************

static PartyType *ReadSectionParty(

*********************************************************************/
static PartyType *ReadSectionParty(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
PartyType *pParty = CreateParty(pStructDocTop, pStructParent);

	if(!pParty)
		return 0;	// Fatal error

	pXmlTagData=GetNextXmlTag(pXmlTagData);

	if(!pXmlTagData)
		return 0;	// Fatal error

	while(strcmp(pXmlTagData->pTag, pEndTag)) { // While is not the end
		if(!strcmp(pXmlTagData->pTag, "Name"))
			ReadString(&pParty->pName, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "Address"))
			LListAddRecord(pParty->pListAddress, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "PostalCode"))
			ReadString(&pParty->pPostalCode, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "PostalAddress"))
			ReadString(&pParty->pPostalAddress, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "PostalCountry"))
			ReadString(&pParty->pPostalCountry, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "EntityPhone"))
			ReadString(&pParty->pEntityPhone, ReadXmlDataString(pXmlTagData->pData));		// rac:Phone
		else if(!strcmp(pXmlTagData->pTag, "EntityEmail"))
			ReadString(&pParty->pEntityEmail, ReadXmlDataString(pXmlTagData->pData));		// rac:Email
		else if(!strcmp(pXmlTagData->pTag, "LogotypeFileUrl"))
			LListAddRecord(pParty->pListLogotypeFileUrl, ReadXmlDataString(pXmlTagData->pData));		// rac:FileUrl
		else if(!strcmp(pXmlTagData->pTag, "WebPage"))
			LListAddRecord(pParty->pListWebPage, ReadXmlDataString(pXmlTagData->pData));		// rac:FileUrl
		else if(!strcmp(pXmlTagData->pTag, "CrmRef"))
			LListAddRecord(pParty->pListCrmRef, ReadXmlDataString(pXmlTagData->pData));		// rac:FileUrl
		else if(!strcmp(pXmlTagData->pTag, "FileUrl"))
			LListAddRecord(pParty->pListFileUrl, ReadXmlDataString(pXmlTagData->pData));		// rac:FileUrl
		else if(!strcmp(pXmlTagData->pTag, "Note"))
			LListAddRecord(pParty->pListNote, ReadXmlDataString(pXmlTagData->pData));		// xs:string
		else if(!strcmp(pXmlTagData->pTag, "Contact"))
			LListAddRecord(pParty->pListContact, ReadSectionContact(pStructDocTop, pParty, pXmlTagData, "Contact"));		// rac:ContactType
		else if(!strcmp(pXmlTagData->pTag, "ProprietaryId"))
			ReadString(&pParty->pProprietaryId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "LegalRegId"))
			ReadString(&pParty->pLegalRegId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "Jurisdiction"))
			ReadString(&pParty->pJurisdiction, ReadXmlDataString(pXmlTagData->pData));		// rac:Country
		else if(!strcmp(pXmlTagData->pTag, "EntityType"))
			ReadString(&pParty->pEntityType, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "StatisticalClass"))
			ReadString(&pParty->pStatisticalClass, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "LegalFileUrl"))
			LListAddRecord(pParty->pListLegalFileUrl, ReadXmlDataString(pXmlTagData->pData));		// rac:FileUrl
		else if(!strcmp(pXmlTagData->pTag, "VatRegId"))
			ReadString(&pParty->pVatRegId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "VatCurrency"))
			ReadString(&pParty->pVatCurrency, ReadXmlDataString(pXmlTagData->pData));		// rac:Currency
		else if(!strcmp(pXmlTagData->pTag, "CashAccounting"))
			pParty->CashAccounting = StringToBool(pXmlTagData->pData);		// xs:boolean
		else if(!strcmp(pXmlTagData->pTag, "VatFileUrl"))
			LListAddRecord(pParty->pListVatFileUrl, ReadXmlDataString(pXmlTagData->pData));		// rac:FileUrl
		else if(!strcmp(pXmlTagData->pTag, "IncomeTaxFileUrl"))
			LListAddRecord(pParty->pListIncomeTaxFileUrl, ReadXmlDataString(pXmlTagData->pData));		// rac:FileUrl

		pXmlTagData=GetNextXmlTag(pXmlTagData);

		if(!pXmlTagData)
			return 0;	// Fatal error
	}
	return pParty;
}


/*********************************************************************

static BOOL WriteSectionParty(

*********************************************************************/
static BOOL WriteSectionParty(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	PartyType *pParty)
{
	if(!pParty)
		return FALSE;	// Fatal error

	xmlWriteLine(pStream, iTab-1, pAttr, pLabel, 0, 0);
	xmlWriteLine(pStream, iTab, 0, "Name", pParty->pName, "Name");		// xs:token - Mandatory

	if(pParty->pListAddress) {
		char *pAddress
			= LListGetFirstRecordData(pParty->pListAddress);
		while(pAddress) {
			xmlWriteLine(pStream, iTab, 0, "Address", pAddress, "Address");		// xs:token

			pAddress = LListGetNextRecordData(pParty->pListAddress);
		}
	}
	if(pParty->pPostalCode && *pParty->pPostalCode)
		xmlWriteLine(pStream, iTab, 0, "PostalCode", pParty->pPostalCode, "PostalCode");		// xs:token
	if(pParty->pPostalAddress && *pParty->pPostalAddress)
		xmlWriteLine(pStream, iTab, 0, "PostalAddress", pParty->pPostalAddress, "PostalAddress");		// xs:token
	if(pParty->pPostalCountry && *pParty->pPostalCountry)
		xmlWriteLine(pStream, iTab, 0, "PostalCountry", pParty->pPostalCountry, "PostalCountry");		// xs:token
	if(pParty->pEntityPhone && *pParty->pEntityPhone)
		xmlWriteLine(pStream, iTab, 0, "EntityPhone", pParty->pEntityPhone, "EntityPhone");		// rac:Phone
	if(pParty->pEntityEmail && *pParty->pEntityEmail)
		xmlWriteLine(pStream, iTab, 0, "EntityEmail", pParty->pEntityEmail, "EntityEmail");		// rac:Email

	if(pParty->pListLogotypeFileUrl) {
		char *pLogotypeFileUrl
			= LListGetFirstRecordData(pParty->pListLogotypeFileUrl);
		while(pLogotypeFileUrl) {
			xmlWriteLine(pStream, iTab, 0, "LogotypeFileUrl", pLogotypeFileUrl, "LogotypeFileUrl");		// rac:FileUrl

			pLogotypeFileUrl = LListGetNextRecordData(pParty->pListLogotypeFileUrl);
		}
	}

	if(pParty->pListWebPage) {
		char *pWebPage
			= LListGetFirstRecordData(pParty->pListWebPage);
		while(pWebPage) {
			xmlWriteLine(pStream, iTab, 0, "WebPage", pWebPage, "WebPage");		// rac:FileUrl

			pWebPage = LListGetNextRecordData(pParty->pListWebPage);
		}
	}

	if(pParty->pListCrmRef) {
		char *pCrmRef
			= LListGetFirstRecordData(pParty->pListCrmRef);
		while(pCrmRef) {
			xmlWriteLine(pStream, iTab, 0, "CrmRef", pCrmRef, "CrmRef");		// rac:FileUrl

			pCrmRef = LListGetNextRecordData(pParty->pListCrmRef);
		}
	}

	if(pParty->pListFileUrl) {
		char *pFileUrl
			= LListGetFirstRecordData(pParty->pListFileUrl);
		while(pFileUrl) {
			xmlWriteLine(pStream, iTab, 0, "FileUrl", pFileUrl, "FileUrl");		// rac:FileUrl

			pFileUrl = LListGetNextRecordData(pParty->pListFileUrl);
		}
	}

	if(pParty->pListNote) {
		char *pNote
			= LListGetFirstRecordData(pParty->pListNote);
		while(pNote) {
			xmlWriteLine(pStream, iTab, 0, "Note", pNote, "Note");		// xs:string

			pNote = LListGetNextRecordData(pParty->pListNote);
		}
	}

	if(pParty->pListContact) {
		ContactType *pContact
			= LListGetFirstRecordData(pParty->pListContact);
		while(pContact) {
			if(IsDataContact(pContact))
				WriteSectionContact(pStream, iTab+1, "Contact", 0, pContact);		// rac:ContactType
			pContact = LListGetNextRecordData(pParty->pListContact);
		}
	}
	if(pParty->pProprietaryId && *pParty->pProprietaryId)
		xmlWriteLine(pStream, iTab, 0, "ProprietaryId", pParty->pProprietaryId, "ProprietaryId");		// xs:token
	if(pParty->pLegalRegId && *pParty->pLegalRegId)
		xmlWriteLine(pStream, iTab, 0, "LegalRegId", pParty->pLegalRegId, "LegalRegId");		// xs:token
	if(pParty->pJurisdiction && *pParty->pJurisdiction)
		xmlWriteLine(pStream, iTab, 0, "Jurisdiction", pParty->pJurisdiction, "Jurisdiction");		// rac:Country
	if(pParty->pEntityType && *pParty->pEntityType)
		xmlWriteLine(pStream, iTab, 0, "EntityType", pParty->pEntityType, "EntityType");		// xs:token
	if(pParty->pStatisticalClass && *pParty->pStatisticalClass)
		xmlWriteLine(pStream, iTab, 0, "StatisticalClass", pParty->pStatisticalClass, "StatisticalClass");		// xs:token

	if(pParty->pListLegalFileUrl) {
		char *pLegalFileUrl
			= LListGetFirstRecordData(pParty->pListLegalFileUrl);
		while(pLegalFileUrl) {
			xmlWriteLine(pStream, iTab, 0, "LegalFileUrl", pLegalFileUrl, "LegalFileUrl");		// rac:FileUrl

			pLegalFileUrl = LListGetNextRecordData(pParty->pListLegalFileUrl);
		}
	}
	if(pParty->pVatRegId && *pParty->pVatRegId)
		xmlWriteLine(pStream, iTab, 0, "VatRegId", pParty->pVatRegId, "VatRegId");		// xs:token
	if(pParty->pVatCurrency && *pParty->pVatCurrency)
		xmlWriteLine(pStream, iTab, 0, "VatCurrency", pParty->pVatCurrency, "VatCurrency");		// rac:Currency
	if(pParty->CashAccounting)
		xmlWriteLine(pStream, iTab, 0, "CashAccounting", BoolToStr(pParty->CashAccounting, szString),"CashAccounting");		// xs:boolean

	if(pParty->pListVatFileUrl) {
		char *pVatFileUrl
			= LListGetFirstRecordData(pParty->pListVatFileUrl);
		while(pVatFileUrl) {
			xmlWriteLine(pStream, iTab, 0, "VatFileUrl", pVatFileUrl, "VatFileUrl");		// rac:FileUrl

			pVatFileUrl = LListGetNextRecordData(pParty->pListVatFileUrl);
		}
	}

	if(pParty->pListIncomeTaxFileUrl) {
		char *pIncomeTaxFileUrl
			= LListGetFirstRecordData(pParty->pListIncomeTaxFileUrl);
		while(pIncomeTaxFileUrl) {
			xmlWriteLine(pStream, iTab, 0, "IncomeTaxFileUrl", pIncomeTaxFileUrl, "IncomeTaxFileUrl");		// rac:FileUrl

			pIncomeTaxFileUrl = LListGetNextRecordData(pParty->pListIncomeTaxFileUrl);
		}
	}

	xmlWriteLine(pStream, iTab-1, 0, 0, 0, pLabel);

	return TRUE;
}


/*********************************************************************

PartyType *UpdateParty(

*********************************************************************/
PartyType *UpdateParty(
	PartyType *pStructParty, 
	char *pName, 
	char *pPostalCode, 
	char *pPostalAddress, 
	char *pPostalCountry, 
	char *pEntityPhone, 
	char *pEntityEmail, 
	char *pProprietaryId, 
	char *pLegalRegId, 
	char *pJurisdiction, 
	char *pEntityType, 
	char *pStatisticalClass, 
	char *pVatRegId, 
	char *pVatCurrency, 
	BOOL CashAccounting)
{
	StringUpdate(&pStructParty->pName, pName);
	StringUpdate(&pStructParty->pPostalCode, pPostalCode);
	StringUpdate(&pStructParty->pPostalAddress, pPostalAddress);
	StringUpdate(&pStructParty->pPostalCountry, pPostalCountry);
	StringUpdate(&pStructParty->pEntityPhone, pEntityPhone);
	StringUpdate(&pStructParty->pEntityEmail, pEntityEmail);
	StringUpdate(&pStructParty->pProprietaryId, pProprietaryId);
	StringUpdate(&pStructParty->pLegalRegId, pLegalRegId);
	StringUpdate(&pStructParty->pJurisdiction, pJurisdiction);
	StringUpdate(&pStructParty->pEntityType, pEntityType);
	StringUpdate(&pStructParty->pStatisticalClass, pStatisticalClass);
	StringUpdate(&pStructParty->pVatRegId, pVatRegId);
	StringUpdate(&pStructParty->pVatCurrency, pVatCurrency);
	pStructParty->CashAccounting = CashAccounting;

	return pStructParty;
}


/*********************************************************************

char **GetLeadTextParty(

*********************************************************************/
char **GetLeadTextParty(
	char *pLang)
{
static char *szTexts[] = {
	"Name",
	"Address",
	"Postal Code",
	"Postal Address",
	"Postal Country",
	"Entity Phone",
	"Entity Email",
	"Logotype File Url",
	"Web Page",
	"Crm Ref",
	"File Url",
	"Note",
	"Contact",
	"Proprietary Id",
	"Legal Reg Id",
	"Jurisdiction",
	"Entity Type",
	"Statistical Class",
	"Legal File Url",
	"Vat Reg Id",
	"Vat Currency",
	"Cash Accounting",
	"Vat File Url",
	"Income Tax File Url"};

	return szTexts;
}


/*********************************************************************

	Contact

*********************************************************************

ContactType *CreateContact(

*********************************************************************/
ContactType *CreateContact(
	void *pStructDocTop, 
	void *pStructParent)
{
ContactType *pContact = calloc(1, sizeof(ContactType));

	if(!pContact)
		return 0;	// Fatal error

	pContact->DataType    = SCT_CONTACT;
	pContact->pStructDocTop = pStructDocTop;
	pContact->pStructParent = pStructParent;

	pContact->pFunction = NulString;
	pContact->pName = NulString;
	pContact->pListAddress = LListInit();
	pContact->pPostalCode = NulString;
	pContact->pPostalAddress = NulString;
	pContact->pPostalCountry = NulString;
	pContact->pListPhone = LListInit();
	pContact->pListEmail = LListInit();
	pContact->pListWebPage = LListInit();
	pContact->pListSocialMedia = LListInit();
	pContact->pListContactLog = LListInit();
	pContact->pListCrmRef = LListInit();
	pContact->pListNote = LListInit();

	return pContact;
}


/*********************************************************************

ContactType *DestroyContact(

*********************************************************************/
ContactType *DestroyContact(
	ContactType **ppContact)
{
	if(!*ppContact)
		return 0;	// Nothing to destroy

	FreeString(&(*ppContact)->pFunction);		// xs:token
	FreeString(&(*ppContact)->pName);		// xs:token
	LListDestroy((*ppContact)->pListAddress);		// xs:token
	FreeString(&(*ppContact)->pPostalCode);		// xs:token
	FreeString(&(*ppContact)->pPostalAddress);		// xs:token
	FreeString(&(*ppContact)->pPostalCountry);		// xs:token
	LListDestroy((*ppContact)->pListPhone);		// rac:Phone
	LListDestroy((*ppContact)->pListEmail);		// rac:Email
	LListDestroy((*ppContact)->pListWebPage);		// rac:FileUrl
	LListDestroy((*ppContact)->pListSocialMedia);		// rac:FileUrl
	LListDestroy((*ppContact)->pListContactLog);		// rac:FileUrl
	LListDestroy((*ppContact)->pListCrmRef);		// rac:FileUrl
	LListDestroy((*ppContact)->pListNote);		// xs:string

	free(*ppContact);
	*ppContact = 0;

	return 0;
}


/*********************************************************************

ContactType *CopyContact(

*********************************************************************/
ContactType *CopyContact(
	void *pStructDocTop, 
	void *pStructParent, 
	ContactType *pContact)
{
	if(pContact) {
		ContactType *pNewContact = CreateContact(pStructDocTop, pStructParent);

		if(!pNewContact)
			return 0;	// Fatal error

		CopyString(&pNewContact->pFunction, pContact->pFunction);		// xs:token
		CopyString(&pNewContact->pName, pContact->pName);		// xs:token
		{
			char *pAddress
				= LListGetFirstRecordData(pContact->pListAddress);
			while(pAddress) {
				LListAddRecord(pNewContact->pListAddress, CopyString(0, pAddress));		// xs:token
				pAddress = LListGetNextRecordData(pContact->pListAddress);
			}
		}
		CopyString(&pNewContact->pPostalCode, pContact->pPostalCode);		// xs:token
		CopyString(&pNewContact->pPostalAddress, pContact->pPostalAddress);		// xs:token
		CopyString(&pNewContact->pPostalCountry, pContact->pPostalCountry);		// xs:token
		{
			char *pPhone
				= LListGetFirstRecordData(pContact->pListPhone);
			while(pPhone) {
				LListAddRecord(pNewContact->pListPhone, CopyString(0, pPhone));		// rac:Phone
				pPhone = LListGetNextRecordData(pContact->pListPhone);
			}
		}
		{
			char *pEmail
				= LListGetFirstRecordData(pContact->pListEmail);
			while(pEmail) {
				LListAddRecord(pNewContact->pListEmail, CopyString(0, pEmail));		// rac:Email
				pEmail = LListGetNextRecordData(pContact->pListEmail);
			}
		}
		{
			char *pWebPage
				= LListGetFirstRecordData(pContact->pListWebPage);
			while(pWebPage) {
				LListAddRecord(pNewContact->pListWebPage, CopyString(0, pWebPage));		// rac:FileUrl
				pWebPage = LListGetNextRecordData(pContact->pListWebPage);
			}
		}
		{
			char *pSocialMedia
				= LListGetFirstRecordData(pContact->pListSocialMedia);
			while(pSocialMedia) {
				LListAddRecord(pNewContact->pListSocialMedia, CopyString(0, pSocialMedia));		// rac:FileUrl
				pSocialMedia = LListGetNextRecordData(pContact->pListSocialMedia);
			}
		}
		{
			char *pContactLog
				= LListGetFirstRecordData(pContact->pListContactLog);
			while(pContactLog) {
				LListAddRecord(pNewContact->pListContactLog, CopyString(0, pContactLog));		// rac:FileUrl
				pContactLog = LListGetNextRecordData(pContact->pListContactLog);
			}
		}
		{
			char *pCrmRef
				= LListGetFirstRecordData(pContact->pListCrmRef);
			while(pCrmRef) {
				LListAddRecord(pNewContact->pListCrmRef, CopyString(0, pCrmRef));		// rac:FileUrl
				pCrmRef = LListGetNextRecordData(pContact->pListCrmRef);
			}
		}
		{
			char *pNote
				= LListGetFirstRecordData(pContact->pListNote);
			while(pNote) {
				LListAddRecord(pNewContact->pListNote, CopyString(0, pNote));		// xs:string
				pNote = LListGetNextRecordData(pContact->pListNote);
			}
		}

		return (pNewContact);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataContact(

*********************************************************************/
BOOL IsDataContact(
	ContactType *pContact)
{
	if(!pContact)
		return FALSE;

	if(pContact->pFunction && *pContact->pFunction)
		return TRUE;
	if(pContact->pName && *pContact->pName)
		return TRUE;
	if(LListGetFirstRecordData(pContact->pListAddress))
		return TRUE;
	if(pContact->pPostalCode && *pContact->pPostalCode)
		return TRUE;
	if(pContact->pPostalAddress && *pContact->pPostalAddress)
		return TRUE;
	if(pContact->pPostalCountry && *pContact->pPostalCountry)
		return TRUE;
	if(LListGetFirstRecordData(pContact->pListPhone))
		return TRUE;
	if(LListGetFirstRecordData(pContact->pListEmail))
		return TRUE;
	if(LListGetFirstRecordData(pContact->pListWebPage))
		return TRUE;
	if(LListGetFirstRecordData(pContact->pListSocialMedia))
		return TRUE;
	if(LListGetFirstRecordData(pContact->pListContactLog))
		return TRUE;
	if(LListGetFirstRecordData(pContact->pListCrmRef))
		return TRUE;
	if(LListGetFirstRecordData(pContact->pListNote))
		return TRUE;

	return FALSE;
}


/*********************************************************************

static ContactType *ReadSectionContact(

*********************************************************************/
static ContactType *ReadSectionContact(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
ContactType *pContact = CreateContact(pStructDocTop, pStructParent);

	if(!pContact)
		return 0;	// Fatal error

	pXmlTagData=GetNextXmlTag(pXmlTagData);

	if(!pXmlTagData)
		return 0;	// Fatal error

	while(strcmp(pXmlTagData->pTag, pEndTag)) { // While is not the end
		if(!strcmp(pXmlTagData->pTag, "Function"))
			ReadString(&pContact->pFunction, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "Name"))
			ReadString(&pContact->pName, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "Address"))
			LListAddRecord(pContact->pListAddress, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "PostalCode"))
			ReadString(&pContact->pPostalCode, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "PostalAddress"))
			ReadString(&pContact->pPostalAddress, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "PostalCountry"))
			ReadString(&pContact->pPostalCountry, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "Phone"))
			LListAddRecord(pContact->pListPhone, ReadXmlDataString(pXmlTagData->pData));		// rac:Phone
		else if(!strcmp(pXmlTagData->pTag, "Email"))
			LListAddRecord(pContact->pListEmail, ReadXmlDataString(pXmlTagData->pData));		// rac:Email
		else if(!strcmp(pXmlTagData->pTag, "WebPage"))
			LListAddRecord(pContact->pListWebPage, ReadXmlDataString(pXmlTagData->pData));		// rac:FileUrl
		else if(!strcmp(pXmlTagData->pTag, "SocialMedia"))
			LListAddRecord(pContact->pListSocialMedia, ReadXmlDataString(pXmlTagData->pData));		// rac:FileUrl
		else if(!strcmp(pXmlTagData->pTag, "ContactLog"))
			LListAddRecord(pContact->pListContactLog, ReadXmlDataString(pXmlTagData->pData));		// rac:FileUrl
		else if(!strcmp(pXmlTagData->pTag, "CrmRef"))
			LListAddRecord(pContact->pListCrmRef, ReadXmlDataString(pXmlTagData->pData));		// rac:FileUrl
		else if(!strcmp(pXmlTagData->pTag, "Note"))
			LListAddRecord(pContact->pListNote, ReadXmlDataString(pXmlTagData->pData));		// xs:string

		pXmlTagData=GetNextXmlTag(pXmlTagData);

		if(!pXmlTagData)
			return 0;	// Fatal error
	}
	return pContact;
}


/*********************************************************************

static BOOL WriteSectionContact(

*********************************************************************/
static BOOL WriteSectionContact(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	ContactType *pContact)
{
	if(!pContact)
		return FALSE;	// Fatal error

	xmlWriteLine(pStream, iTab-1, pAttr, pLabel, 0, 0);
	if(pContact->pFunction && *pContact->pFunction)
		xmlWriteLine(pStream, iTab, 0, "Function", pContact->pFunction, "Function");		// xs:token
	if(pContact->pName && *pContact->pName)
		xmlWriteLine(pStream, iTab, 0, "Name", pContact->pName, "Name");		// xs:token

	if(pContact->pListAddress) {
		char *pAddress
			= LListGetFirstRecordData(pContact->pListAddress);
		while(pAddress) {
			xmlWriteLine(pStream, iTab, 0, "Address", pAddress, "Address");		// xs:token

			pAddress = LListGetNextRecordData(pContact->pListAddress);
		}
	}
	if(pContact->pPostalCode && *pContact->pPostalCode)
		xmlWriteLine(pStream, iTab, 0, "PostalCode", pContact->pPostalCode, "PostalCode");		// xs:token
	if(pContact->pPostalAddress && *pContact->pPostalAddress)
		xmlWriteLine(pStream, iTab, 0, "PostalAddress", pContact->pPostalAddress, "PostalAddress");		// xs:token
	if(pContact->pPostalCountry && *pContact->pPostalCountry)
		xmlWriteLine(pStream, iTab, 0, "PostalCountry", pContact->pPostalCountry, "PostalCountry");		// xs:token

	if(pContact->pListPhone) {
		char *pPhone
			= LListGetFirstRecordData(pContact->pListPhone);
		while(pPhone) {
			xmlWriteLine(pStream, iTab, 0, "Phone", pPhone, "Phone");		// rac:Phone

			pPhone = LListGetNextRecordData(pContact->pListPhone);
		}
	}

	if(pContact->pListEmail) {
		char *pEmail
			= LListGetFirstRecordData(pContact->pListEmail);
		while(pEmail) {
			xmlWriteLine(pStream, iTab, 0, "Email", pEmail, "Email");		// rac:Email

			pEmail = LListGetNextRecordData(pContact->pListEmail);
		}
	}

	if(pContact->pListWebPage) {
		char *pWebPage
			= LListGetFirstRecordData(pContact->pListWebPage);
		while(pWebPage) {
			xmlWriteLine(pStream, iTab, 0, "WebPage", pWebPage, "WebPage");		// rac:FileUrl

			pWebPage = LListGetNextRecordData(pContact->pListWebPage);
		}
	}

	if(pContact->pListSocialMedia) {
		char *pSocialMedia
			= LListGetFirstRecordData(pContact->pListSocialMedia);
		while(pSocialMedia) {
			xmlWriteLine(pStream, iTab, 0, "SocialMedia", pSocialMedia, "SocialMedia");		// rac:FileUrl

			pSocialMedia = LListGetNextRecordData(pContact->pListSocialMedia);
		}
	}

	if(pContact->pListContactLog) {
		char *pContactLog
			= LListGetFirstRecordData(pContact->pListContactLog);
		while(pContactLog) {
			xmlWriteLine(pStream, iTab, 0, "ContactLog", pContactLog, "ContactLog");		// rac:FileUrl

			pContactLog = LListGetNextRecordData(pContact->pListContactLog);
		}
	}

	if(pContact->pListCrmRef) {
		char *pCrmRef
			= LListGetFirstRecordData(pContact->pListCrmRef);
		while(pCrmRef) {
			xmlWriteLine(pStream, iTab, 0, "CrmRef", pCrmRef, "CrmRef");		// rac:FileUrl

			pCrmRef = LListGetNextRecordData(pContact->pListCrmRef);
		}
	}

	if(pContact->pListNote) {
		char *pNote
			= LListGetFirstRecordData(pContact->pListNote);
		while(pNote) {
			xmlWriteLine(pStream, iTab, 0, "Note", pNote, "Note");		// xs:string

			pNote = LListGetNextRecordData(pContact->pListNote);
		}
	}

	xmlWriteLine(pStream, iTab-1, 0, 0, 0, pLabel);

	return TRUE;
}


/*********************************************************************

ContactType *UpdateContact(

*********************************************************************/
ContactType *UpdateContact(
	ContactType *pStructContact, 
	char *pFunction, 
	char *pName, 
	char *pPostalCode, 
	char *pPostalAddress, 
	char *pPostalCountry)
{
	StringUpdate(&pStructContact->pFunction, pFunction);
	StringUpdate(&pStructContact->pName, pName);
	StringUpdate(&pStructContact->pPostalCode, pPostalCode);
	StringUpdate(&pStructContact->pPostalAddress, pPostalAddress);
	StringUpdate(&pStructContact->pPostalCountry, pPostalCountry);

	return pStructContact;
}


/*********************************************************************

char **GetLeadTextContact(

*********************************************************************/
char **GetLeadTextContact(
	char *pLang)
{
static char *szTexts[] = {
	"Function",
	"Name",
	"Address",
	"Postal Code",
	"Postal Address",
	"Postal Country",
	"Phone",
	"Email",
	"Web Page",
	"Social Media",
	"Contact Log",
	"Crm Ref",
	"Note"};

	return szTexts;
}


/*********************************************************************

	AccountsChart

*********************************************************************

AccountsChartType *CreateAccountsChart(

*********************************************************************/
AccountsChartType *CreateAccountsChart(
	void *pStructDocTop, 
	void *pStructParent)
{
AccountsChartType *pAccountsChart = calloc(1, sizeof(AccountsChartType));

	if(!pAccountsChart)
		return 0;	// Fatal error

	pAccountsChart->DataType    = SCT_ACCOUNTSCHART;
	pAccountsChart->pStructDocTop = pStructDocTop;
	pAccountsChart->pStructParent = pStructParent;

	pAccountsChart->pListAccount = LListInit();

	return pAccountsChart;
}


/*********************************************************************

AccountsChartType *DestroyAccountsChart(

*********************************************************************/
AccountsChartType *DestroyAccountsChart(
	AccountsChartType **ppAccountsChart)
{
	if(!*ppAccountsChart)
		return 0;	// Nothing to destroy

	{
		AccountType *pAccount
			= LListGetFirstRecordData((*ppAccountsChart)->pListAccount);
		while(pAccount) {
			DestroyAccount(&pAccount);		// rac:AccountType
			pAccount = LListGetNextRecordData((*ppAccountsChart)->pListAccount);
		}
		LListErase((*ppAccountsChart)->pListAccount);
	}

	free(*ppAccountsChart);
	*ppAccountsChart = 0;

	return 0;
}


/*********************************************************************

AccountsChartType *CopyAccountsChart(

*********************************************************************/
AccountsChartType *CopyAccountsChart(
	void *pStructDocTop, 
	void *pStructParent, 
	AccountsChartType *pAccountsChart)
{
	if(pAccountsChart) {
		AccountsChartType *pNewAccountsChart = ((AccountingType *)pStructDocTop)->pAccountsChart;	// Is predefined in CreateAccounting()

		if(!pNewAccountsChart)
			return 0;	// Fatal error

		{
			AccountType *pAccount
				= LListGetFirstRecordData(pAccountsChart->pListAccount);
			while(pAccount) {
				SearchSetAccount(((AccountingType *)pStructDocTop)->pAccountsChart->pListAccount, CopyAccount(pStructDocTop, pNewAccountsChart, pAccount));		// rac:AccountType
				pAccount = LListGetNextRecordData(pAccountsChart->pListAccount);
			}
		}

		return (pNewAccountsChart);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataAccountsChart(

*********************************************************************/
BOOL IsDataAccountsChart(
	AccountsChartType *pAccountsChart)
{
	if(!pAccountsChart)
		return FALSE;

	{
		AccountType *pAccount
			= LListGetFirstRecordData(pAccountsChart->pListAccount);
		while(pAccount) {
			if(IsDataAccount(pAccount))
				return TRUE;
			pAccount = LListGetNextRecordData(pAccountsChart->pListAccount);
		}
	}

	return FALSE;
}


/*********************************************************************

static AccountsChartType *ReadSectionAccountsChart(

*********************************************************************/
static AccountsChartType *ReadSectionAccountsChart(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
AccountsChartType *pAccountsChart = ((AccountingType *)pStructDocTop)->pAccountsChart;

	if(!pAccountsChart)
		return 0;	// Fatal error

	pXmlTagData=GetNextXmlTag(pXmlTagData);

	if(!pXmlTagData)
		return 0;	// Fatal error

	while(strcmp(pXmlTagData->pTag, pEndTag)) { // While is not the end
		if(!strcmp(pXmlTagData->pTag, "Account"))
			SearchSetAccount(((AccountingType *)pStructDocTop)->pAccountsChart->pListAccount, ReadSectionAccount(pStructDocTop, pAccountsChart, pXmlTagData, "Account"));		// rac:AccountType

		pXmlTagData=GetNextXmlTag(pXmlTagData);

		if(!pXmlTagData)
			return 0;	// Fatal error
	}
	return pAccountsChart;
}


/*********************************************************************

static BOOL WriteSectionAccountsChart(

*********************************************************************/
static BOOL WriteSectionAccountsChart(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	AccountsChartType *pAccountsChart, 
	char *pContent)
{
	if(!pAccountsChart)
		return FALSE;	// Fatal error

	xmlWriteLine(pStream, iTab-1, pAttr, pLabel, 0, 0);

	if(pAccountsChart->pListAccount) {
		AccountType *pAccount
			= LListGetFirstRecordData(pAccountsChart->pListAccount);
		while(pAccount) {
			if(IsDataAccount(pAccount))
				WriteSectionAccount(pStream, iTab+1, "Account", 0, pAccount, FALSE);		// rac:AccountType
			pAccount = LListGetNextRecordData(pAccountsChart->pListAccount);
		}
	}

	xmlWriteLine(pStream, iTab-1, 0, 0, 0, pLabel);

	return TRUE;
}


/*********************************************************************

AccountsChartType *UpdateAccountsChart(

*********************************************************************/
AccountsChartType *UpdateAccountsChart(
	AccountsChartType *pStructAccountsChart)
{

	return pStructAccountsChart;
}


/*********************************************************************

char **GetLeadTextAccountsChart(

*********************************************************************/
char **GetLeadTextAccountsChart(
	char *pLang)
{
static char *szTexts[] = {
	"Account"};

	return szTexts;
}


/*********************************************************************

	Account

*********************************************************************

AccountType *CreateAccount(

*********************************************************************/
AccountType *CreateAccount(
	void *pStructDocTop, 
	void *pStructParent)
{
AccountType *pAccount = calloc(1, sizeof(AccountType));

	if(!pAccount)
		return 0;	// Fatal error

	pAccount->DataType    = SCT_ACCOUNT;
	pAccount->pStructDocTop = pStructDocTop;
	pAccount->pStructParent = pStructParent;

	pAccount->pId = NulString;
	pAccount->pListName = LListInit();
	pAccount->pListQuantityUnit = LListInit();
	pAccount->pListFileUrl = LListInit();
	CopyString(&pAccount->pType, ACCOUNT_TYPE_ASSETS);
	pAccount->pListAccountCode = LListInit();
	pAccount->pListOtherGaapAccountId = LListInit();

	return pAccount;
}


/*********************************************************************

AccountType *DestroyAccount(

*********************************************************************/
AccountType *DestroyAccount(
	AccountType **ppAccount)
{
	if(!*ppAccount)
		return 0;	// Nothing to destroy

	LListErase((*ppAccount)->pListVoucherEntries);

	FreeString(&(*ppAccount)->pId);		// rac:IdToken
	{
		TextType *pName
			= LListGetFirstRecordData((*ppAccount)->pListName);
		while(pName) {
			DestroyText(&pName);		// rac:TextType
			pName = LListGetNextRecordData((*ppAccount)->pListName);
		}
		LListErase((*ppAccount)->pListName);
	}
	{
		TextType *pQuantityUnit
			= LListGetFirstRecordData((*ppAccount)->pListQuantityUnit);
		while(pQuantityUnit) {
			DestroyText(&pQuantityUnit);		// rac:TextType
			pQuantityUnit = LListGetNextRecordData((*ppAccount)->pListQuantityUnit);
		}
		LListErase((*ppAccount)->pListQuantityUnit);
	}
	LListDestroy((*ppAccount)->pListFileUrl);		// rac:FileUrl
	FreeString(&(*ppAccount)->pType);		// rac:AccountTypeType
	{
		AccountCodeType *pAccountCode
			= LListGetFirstRecordData((*ppAccount)->pListAccountCode);
		while(pAccountCode) {
			DestroyAccountCode(&pAccountCode);		// rac:AccountCodeType
			pAccountCode = LListGetNextRecordData((*ppAccount)->pListAccountCode);
		}
		LListErase((*ppAccount)->pListAccountCode);
	}
	{
		AccountCodeType *pOtherGaapAccountId
			= LListGetFirstRecordData((*ppAccount)->pListOtherGaapAccountId);
		while(pOtherGaapAccountId) {
			DestroyAccountCode(&pOtherGaapAccountId);		// rac:AccountCodeType
			pOtherGaapAccountId = LListGetNextRecordData((*ppAccount)->pListOtherGaapAccountId);
		}
		LListErase((*ppAccount)->pListOtherGaapAccountId);
	}
	DestroyDepreciations(&(*ppAccount)->pDepreciation);		// rac:DepreciationsType

	free(*ppAccount);
	*ppAccount = 0;

	return 0;
}


/*********************************************************************

AccountType *CopyAccount(

*********************************************************************/
AccountType *CopyAccount(
	void *pStructDocTop, 
	void *pStructParent, 
	AccountType *pAccount)
{
	if(pAccount) {
		AccountType *pNewAccount = CreateAccount(pStructDocTop, pStructParent);

		if(!pNewAccount)
			return 0;	// Fatal error

		CopyString(&pNewAccount->pId, pAccount->pId);		// rac:IdToken
		{
			TextType *pName
				= LListGetFirstRecordData(pAccount->pListName);
			while(pName) {
				LListAddRecord(pNewAccount->pListName, CopyText(pStructDocTop, pNewAccount, pName));		// rac:TextType
				pName = LListGetNextRecordData(pAccount->pListName);
			}
		}
		{
			TextType *pQuantityUnit
				= LListGetFirstRecordData(pAccount->pListQuantityUnit);
			while(pQuantityUnit) {
				LListAddRecord(pNewAccount->pListQuantityUnit, CopyText(pStructDocTop, pNewAccount, pQuantityUnit));		// rac:TextType
				pQuantityUnit = LListGetNextRecordData(pAccount->pListQuantityUnit);
			}
		}
		pNewAccount->InActive = pAccount->InActive;		// xs:boolean
		{
			char *pFileUrl
				= LListGetFirstRecordData(pAccount->pListFileUrl);
			while(pFileUrl) {
				LListAddRecord(pNewAccount->pListFileUrl, CopyString(0, pFileUrl));		// rac:FileUrl
				pFileUrl = LListGetNextRecordData(pAccount->pListFileUrl);
			}
		}
		CopyString(&pNewAccount->pType, pAccount->pType);		// rac:AccountTypeType
		pNewAccount->MiniChart = pAccount->MiniChart;		// xs:boolean
		{
			AccountCodeType *pAccountCode
				= LListGetFirstRecordData(pAccount->pListAccountCode);
			while(pAccountCode) {
				LListAddRecord(pNewAccount->pListAccountCode, CopyAccountCode(pStructDocTop, pNewAccount, pAccountCode));		// rac:AccountCodeType
				pAccountCode = LListGetNextRecordData(pAccount->pListAccountCode);
			}
		}
		{
			AccountCodeType *pOtherGaapAccountId
				= LListGetFirstRecordData(pAccount->pListOtherGaapAccountId);
			while(pOtherGaapAccountId) {
				LListAddRecord(pNewAccount->pListOtherGaapAccountId, CopyAccountCode(pStructDocTop, pNewAccount, pOtherGaapAccountId));		// rac:AccountCodeType
				pOtherGaapAccountId = LListGetNextRecordData(pAccount->pListOtherGaapAccountId);
			}
		}
		pNewAccount->pDepreciation = CopyDepreciations(pStructDocTop, pNewAccount, pAccount->pDepreciation);		// rac:DepreciationsType

		return (pNewAccount);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataAccount(

*********************************************************************/
BOOL IsDataAccount(
	AccountType *pAccount)
{
	if(!pAccount)
		return FALSE;

	if(pAccount->pId && *pAccount->pId)
		return TRUE;
	{
		TextType *pName
			= LListGetFirstRecordData(pAccount->pListName);
		while(pName) {
			if(IsDataText(pName))
				return TRUE;
			pName = LListGetNextRecordData(pAccount->pListName);
		}
	}
	{
		TextType *pQuantityUnit
			= LListGetFirstRecordData(pAccount->pListQuantityUnit);
		while(pQuantityUnit) {
			if(IsDataText(pQuantityUnit))
				return TRUE;
			pQuantityUnit = LListGetNextRecordData(pAccount->pListQuantityUnit);
		}
	}
	if(LListGetFirstRecordData(pAccount->pListFileUrl))
		return TRUE;
	if(pAccount->pType && *pAccount->pType)
		return TRUE;
	if(pAccount->MiniChart)
		return TRUE;
	{
		AccountCodeType *pAccountCode
			= LListGetFirstRecordData(pAccount->pListAccountCode);
		while(pAccountCode) {
			if(IsDataAccountCode(pAccountCode))
				return TRUE;
			pAccountCode = LListGetNextRecordData(pAccount->pListAccountCode);
		}
	}
	{
		AccountCodeType *pOtherGaapAccountId
			= LListGetFirstRecordData(pAccount->pListOtherGaapAccountId);
		while(pOtherGaapAccountId) {
			if(IsDataAccountCode(pOtherGaapAccountId))
				return TRUE;
			pOtherGaapAccountId = LListGetNextRecordData(pAccount->pListOtherGaapAccountId);
		}
	}
	if(IsDataDepreciations(pAccount->pDepreciation))
		return TRUE;

	return FALSE;
}


/*********************************************************************

static AccountType *ReadSectionAccount(

*********************************************************************/
static AccountType *ReadSectionAccount(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
AccountType *pAccount = CreateAccount(pStructDocTop, pStructParent);

	if(!pAccount)
		return 0;	// Fatal error

	pXmlTagData=GetNextXmlTag(pXmlTagData);

	if(!pXmlTagData)
		return 0;	// Fatal error

	while(strcmp(pXmlTagData->pTag, pEndTag)) { // While is not the end
		if(!strcmp(pXmlTagData->pTag, "Id"))
			ReadString(&pAccount->pId, ReadXmlDataString(pXmlTagData->pData));		// rac:IdToken
		else if(!strcmp(pXmlTagData->pTag, "Name"))
			SearchSetText(pAccount->pListName, ReadSectionText(pStructDocTop, pAccount, pXmlTagData, "Name"));		// rac:TextType
		else if(!strcmp(pXmlTagData->pTag, "QuantityUnit"))
			SearchSetText(pAccount->pListQuantityUnit, ReadSectionText(pStructDocTop, pAccount, pXmlTagData, "QuantityUnit"));		// rac:TextType
		else if(!strcmp(pXmlTagData->pTag, "InActive"))
			pAccount->InActive = StringToBool(pXmlTagData->pData);		// xs:boolean
		else if(!strcmp(pXmlTagData->pTag, "FileUrl"))
			LListAddRecord(pAccount->pListFileUrl, ReadXmlDataString(pXmlTagData->pData));		// rac:FileUrl
		else if(!strcmp(pXmlTagData->pTag, "Type"))
			CheckEnum(&pAccount->pType, EnumAccountTypeType, ReadXmlDataString(pXmlTagData->pData));		// rac:AccountTypeType
		else if(!strcmp(pXmlTagData->pTag, "MiniChart"))
			pAccount->MiniChart = StringToBool(pXmlTagData->pData);		// xs:boolean
		else if(!strcmp(pXmlTagData->pTag, "AccountCode"))
			LListAddRecord(pAccount->pListAccountCode, ReadSectionAccountCode(pStructDocTop, pAccount, pXmlTagData, "AccountCode"));		// rac:AccountCodeType
		else if(!strcmp(pXmlTagData->pTag, "OtherGaapAccountId"))
			LListAddRecord(pAccount->pListOtherGaapAccountId, ReadSectionAccountCode(pStructDocTop, pAccount, pXmlTagData, "OtherGaapAccountId"));		// rac:AccountCodeType
		else if(!strcmp(pXmlTagData->pTag, "Depreciation"))
			pAccount->pDepreciation = ReadSectionDepreciations(pStructDocTop, pAccount, pXmlTagData, "Depreciation");		// rac:DepreciationsType

		pXmlTagData=GetNextXmlTag(pXmlTagData);

		if(!pXmlTagData)
			return 0;	// Fatal error
	}
	return pAccount;
}


/*********************************************************************

static BOOL WriteSectionAccount(

*********************************************************************/
static BOOL WriteSectionAccount(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	AccountType *pAccount, 
	BOOL bLean)
{
	if(!pAccount)
		return FALSE;	// Fatal error

	xmlWriteLine(pStream, iTab-1, pAttr, pLabel, 0, 0);
	xmlWriteLine(pStream, iTab, 0, "Id", pAccount->pId, "Id");		// rac:IdToken - Mandatory

	if(bLean) 
		xmlWriteLine(pStream, iTab, 0, "Name", GetTextListText(pAccount->pListName, 0), "Name");
	else if(pAccount->pListName) {
		TextType *pName
			= LListGetFirstRecordData(pAccount->pListName);
		while(pName) {
			if(IsDataText(pName))
				WriteSectionText(pStream, iTab+1, "Name", 0, pName);		// rac:TextType
			pName = LListGetNextRecordData(pAccount->pListName);
		}
	}

	if(bLean) {
		xmlWriteLine(pStream, iTab - 1, 0, 0, 0, pLabel);
		return TRUE;
	}

	if(pAccount->pListQuantityUnit) {
		TextType *pQuantityUnit
			= LListGetFirstRecordData(pAccount->pListQuantityUnit);
		while(pQuantityUnit) {
			if(IsDataText(pQuantityUnit))
				WriteSectionText(pStream, iTab+1, "QuantityUnit", 0, pQuantityUnit);		// rac:TextType
			pQuantityUnit = LListGetNextRecordData(pAccount->pListQuantityUnit);
		}
	}
	if(pAccount->InActive)
		xmlWriteLine(pStream, iTab, 0, "InActive", BoolToStr(pAccount->InActive, szString),"InActive");		// xs:boolean

	if(pAccount->pListFileUrl) {
		char *pFileUrl
			= LListGetFirstRecordData(pAccount->pListFileUrl);
		while(pFileUrl) {
			xmlWriteLine(pStream, iTab, 0, "FileUrl", pFileUrl, "FileUrl");		// rac:FileUrl

			pFileUrl = LListGetNextRecordData(pAccount->pListFileUrl);
		}
	}
	if(pAccount->pType && *pAccount->pType)
		xmlWriteLine(pStream, iTab, 0, "Type", pAccount->pType, "Type");		// rac:AccountTypeType
	if(pAccount->MiniChart)
		xmlWriteLine(pStream, iTab, 0, "MiniChart", BoolToStr(pAccount->MiniChart, szString),"MiniChart");		// xs:boolean

	if(pAccount->pListAccountCode) {
		AccountCodeType *pAccountCode
			= LListGetFirstRecordData(pAccount->pListAccountCode);
		while(pAccountCode) {
			if(IsDataAccountCode(pAccountCode))
				WriteSectionAccountCode(pStream, iTab+1, "AccountCode", 0, pAccountCode);		// rac:AccountCodeType
			pAccountCode = LListGetNextRecordData(pAccount->pListAccountCode);
		}
	}

	if(pAccount->pListOtherGaapAccountId) {
		AccountCodeType *pOtherGaapAccountId
			= LListGetFirstRecordData(pAccount->pListOtherGaapAccountId);
		while(pOtherGaapAccountId) {
			if(IsDataAccountCode(pOtherGaapAccountId))
				WriteSectionAccountCode(pStream, iTab+1, "OtherGaapAccountId", 0, pOtherGaapAccountId);		// rac:AccountCodeType
			pOtherGaapAccountId = LListGetNextRecordData(pAccount->pListOtherGaapAccountId);
		}
	}

	if(pAccount->pDepreciation && IsDataDepreciations(pAccount->pDepreciation))		// Optional
		WriteSectionDepreciations(pStream, iTab+1, "Depreciation", 0, pAccount->pDepreciation);		// rac:DepreciationsType

	xmlWriteLine(pStream, iTab-1, 0, 0, 0, pLabel);

	return TRUE;
}


/*********************************************************************

AccountType *UpdateAccount(

*********************************************************************/
AccountType *UpdateAccount(
	AccountType *pStructAccount, 
	char *pId, 
	BOOL InActive, 
	char *pType, 
	BOOL MiniChart)
{
	StringUpdate(&pStructAccount->pId, pId);
	pStructAccount->InActive = InActive;
	StringUpdate(&pStructAccount->pType, pType);
	pStructAccount->MiniChart = MiniChart;

	return pStructAccount;
}


/*********************************************************************

char **GetLeadTextAccount(

*********************************************************************/
char **GetLeadTextAccount(
	char *pLang)
{
static char *szTexts[] = {
	"Id",
	"Name",
	"Quantity Unit",
	"In Active",
	"File Url",
	"Type",
	"Mini Chart",
	"Account Code",
	"Other Gaap Account Id",
	"Depreciation"};

	return szTexts;
}


/*********************************************************************

	AccountCode

*********************************************************************

AccountCodeType *CreateAccountCode(

*********************************************************************/
AccountCodeType *CreateAccountCode(
	void *pStructDocTop, 
	void *pStructParent)
{
AccountCodeType *pAccountCode = calloc(1, sizeof(AccountCodeType));

	if(!pAccountCode)
		return 0;	// Fatal error

	pAccountCode->DataType    = SCT_ACCOUNTCODE;
	pAccountCode->pStructDocTop = pStructDocTop;
	pAccountCode->pStructParent = pStructParent;

	pAccountCode->pCodeType = NulString;
	pAccountCode->pCode = NulString;
	pAccountCode->pValidYear = NulString;
	pAccountCode->pListApplicableDomain = LListInit();
	pAccountCode->pIssuer = NulString;
	pAccountCode->pListDescription = LListInit();

	return pAccountCode;
}


/*********************************************************************

AccountCodeType *DestroyAccountCode(

*********************************************************************/
AccountCodeType *DestroyAccountCode(
	AccountCodeType **ppAccountCode)
{
	if(!*ppAccountCode)
		return 0;	// Nothing to destroy

	FreeString(&(*ppAccountCode)->pCodeType);		// xs:token
	FreeString(&(*ppAccountCode)->pCode);		// xs:token
	FreeString(&(*ppAccountCode)->pValidYear);		// rac:Year
	LListDestroy((*ppAccountCode)->pListApplicableDomain);		// rac:Country
	FreeString(&(*ppAccountCode)->pIssuer);		// xs:token
	{
		TextType *pDescription
			= LListGetFirstRecordData((*ppAccountCode)->pListDescription);
		while(pDescription) {
			DestroyText(&pDescription);		// rac:TextType
			pDescription = LListGetNextRecordData((*ppAccountCode)->pListDescription);
		}
		LListErase((*ppAccountCode)->pListDescription);
	}

	free(*ppAccountCode);
	*ppAccountCode = 0;

	return 0;
}


/*********************************************************************

AccountCodeType *CopyAccountCode(

*********************************************************************/
AccountCodeType *CopyAccountCode(
	void *pStructDocTop, 
	void *pStructParent, 
	AccountCodeType *pAccountCode)
{
	if(pAccountCode) {
		AccountCodeType *pNewAccountCode = CreateAccountCode(pStructDocTop, pStructParent);

		if(!pNewAccountCode)
			return 0;	// Fatal error

		CopyString(&pNewAccountCode->pCodeType, pAccountCode->pCodeType);		// xs:token
		CopyString(&pNewAccountCode->pCode, pAccountCode->pCode);		// xs:token
		CopyString(&pNewAccountCode->pValidYear, pAccountCode->pValidYear);		// rac:Year
		{
			char *pApplicableDomain
				= LListGetFirstRecordData(pAccountCode->pListApplicableDomain);
			while(pApplicableDomain) {
				LListAddRecord(pNewAccountCode->pListApplicableDomain, CopyString(0, pApplicableDomain));		// rac:Country
				pApplicableDomain = LListGetNextRecordData(pAccountCode->pListApplicableDomain);
			}
		}
		CopyString(&pNewAccountCode->pIssuer, pAccountCode->pIssuer);		// xs:token
		{
			TextType *pDescription
				= LListGetFirstRecordData(pAccountCode->pListDescription);
			while(pDescription) {
				LListAddRecord(pNewAccountCode->pListDescription, CopyText(pStructDocTop, pNewAccountCode, pDescription));		// rac:TextType
				pDescription = LListGetNextRecordData(pAccountCode->pListDescription);
			}
		}

		return (pNewAccountCode);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataAccountCode(

*********************************************************************/
BOOL IsDataAccountCode(
	AccountCodeType *pAccountCode)
{
	if(!pAccountCode)
		return FALSE;

	if(pAccountCode->pCodeType && *pAccountCode->pCodeType)
		return TRUE;
	if(pAccountCode->pCode && *pAccountCode->pCode)
		return TRUE;
	if(pAccountCode->pValidYear && *pAccountCode->pValidYear)
		return TRUE;
	if(LListGetFirstRecordData(pAccountCode->pListApplicableDomain))
		return TRUE;
	if(pAccountCode->pIssuer && *pAccountCode->pIssuer)
		return TRUE;
	{
		TextType *pDescription
			= LListGetFirstRecordData(pAccountCode->pListDescription);
		while(pDescription) {
			if(IsDataText(pDescription))
				return TRUE;
			pDescription = LListGetNextRecordData(pAccountCode->pListDescription);
		}
	}

	return FALSE;
}


/*********************************************************************

static AccountCodeType *ReadSectionAccountCode(

*********************************************************************/
static AccountCodeType *ReadSectionAccountCode(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
AccountCodeType *pAccountCode = CreateAccountCode(pStructDocTop, pStructParent);

	if(!pAccountCode)
		return 0;	// Fatal error

	pXmlTagData=GetNextXmlTag(pXmlTagData);

	if(!pXmlTagData)
		return 0;	// Fatal error

	while(strcmp(pXmlTagData->pTag, pEndTag)) { // While is not the end
		if(!strcmp(pXmlTagData->pTag, "CodeType"))
			ReadString(&pAccountCode->pCodeType, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "Code"))
			ReadString(&pAccountCode->pCode, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "ValidYear"))
			ReadString(&pAccountCode->pValidYear, ReadXmlDataString(pXmlTagData->pData));		// rac:Year
		else if(!strcmp(pXmlTagData->pTag, "ApplicableDomain"))
			LListAddRecord(pAccountCode->pListApplicableDomain, ReadXmlDataString(pXmlTagData->pData));		// rac:Country
		else if(!strcmp(pXmlTagData->pTag, "Issuer"))
			ReadString(&pAccountCode->pIssuer, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "Description"))
			SearchSetText(pAccountCode->pListDescription, ReadSectionText(pStructDocTop, pAccountCode, pXmlTagData, "Description"));		// rac:TextType

		pXmlTagData=GetNextXmlTag(pXmlTagData);

		if(!pXmlTagData)
			return 0;	// Fatal error
	}
	return pAccountCode;
}


/*********************************************************************

static BOOL WriteSectionAccountCode(

*********************************************************************/
static BOOL WriteSectionAccountCode(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	AccountCodeType *pAccountCode)
{
	if(!pAccountCode)
		return FALSE;	// Fatal error

	xmlWriteLine(pStream, iTab-1, pAttr, pLabel, 0, 0);
	xmlWriteLine(pStream, iTab, 0, "CodeType", pAccountCode->pCodeType, "CodeType");		// xs:token - Mandatory
	xmlWriteLine(pStream, iTab, 0, "Code", pAccountCode->pCode, "Code");		// xs:token - Mandatory
	xmlWriteLine(pStream, iTab, 0, "ValidYear", pAccountCode->pValidYear, "ValidYear");		// rac:Year - Mandatory

	if(pAccountCode->pListApplicableDomain) {
		BOOL bMandatory=1;	// Mandatory at least once
		char *pApplicableDomain
			= LListGetFirstRecordData(pAccountCode->pListApplicableDomain);
		while(pApplicableDomain || bMandatory) {
			xmlWriteLine(pStream, iTab, 0, "ApplicableDomain", pApplicableDomain, "ApplicableDomain");		// rac:Country

			bMandatory=0;
			pApplicableDomain = LListGetNextRecordData(pAccountCode->pListApplicableDomain);
		}
	}
	if(pAccountCode->pIssuer && *pAccountCode->pIssuer)
		xmlWriteLine(pStream, iTab, 0, "Issuer", pAccountCode->pIssuer, "Issuer");		// xs:token

	if(pAccountCode->pListDescription) {
		TextType *pDescription
			= LListGetFirstRecordData(pAccountCode->pListDescription);
		while(pDescription) {
			if(IsDataText(pDescription))
				WriteSectionText(pStream, iTab+1, "Description", 0, pDescription);		// rac:TextType
			pDescription = LListGetNextRecordData(pAccountCode->pListDescription);
		}
	}

	xmlWriteLine(pStream, iTab-1, 0, 0, 0, pLabel);

	return TRUE;
}


/*********************************************************************

AccountCodeType *UpdateAccountCode(

*********************************************************************/
AccountCodeType *UpdateAccountCode(
	AccountCodeType *pStructAccountCode, 
	char *pCodeType, 
	char *pCode, 
	char *pValidYear, 
	char *pIssuer)
{
	StringUpdate(&pStructAccountCode->pCodeType, pCodeType);
	StringUpdate(&pStructAccountCode->pCode, pCode);
	StringUpdate(&pStructAccountCode->pValidYear, pValidYear);
	StringUpdate(&pStructAccountCode->pIssuer, pIssuer);

	return pStructAccountCode;
}


/*********************************************************************

char **GetLeadTextAccountCode(

*********************************************************************/
char **GetLeadTextAccountCode(
	char *pLang)
{
static char *szTexts[] = {
	"Code Type",
	"Code",
	"Valid Year",
	"Applicable Domain",
	"Issuer",
	"Description"};

	return szTexts;
}


/*********************************************************************

	ObjectsChart

*********************************************************************

ObjectsChartType *CreateObjectsChart(

*********************************************************************/
ObjectsChartType *CreateObjectsChart(
	void *pStructDocTop, 
	void *pStructParent)
{
ObjectsChartType *pObjectsChart = calloc(1, sizeof(ObjectsChartType));

	if(!pObjectsChart)
		return 0;	// Fatal error

	pObjectsChart->DataType    = SCT_OBJECTSCHART;
	pObjectsChart->pStructDocTop = pStructDocTop;
	pObjectsChart->pStructParent = pStructParent;

	pObjectsChart->pListDimension = LListInit();

	{
		AccountingType *pAccounting = pStructDocTop;
		DimensionType *pDimension = CreateDimension(pAccounting, pObjectsChart);
		pDimension->Id = 0;
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, ALL_BULLET, ""); // ¤
		{
			ObjectType *pObject = CreateObject(pAccounting, pDimension);
			LListAddRecord(pDimension->pListObject, pObject);
				CopyString(&pObject->pId, "0");
			pObject->pDimension = pDimension;
			pObject->pListName = AddTextListItem(pStructDocTop, pObject, pObject->pListName, ALL_BULLET, ""); // ¤
		}
		LListAddRecord(pObjectsChart->pListDimension, pDimension);
		pDimension = CreateDimension(pAccounting, pObjectsChart);
		pDimension->Id = 1;
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_COSTCENTRE, "en"), "en");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_COSTCENTRE, "sv"), "sv");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_COSTCENTRE, "da"), "da");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_COSTCENTRE, "no"), "no");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_COSTCENTRE, "is"), "is");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_COSTCENTRE, "fi"), "fi");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_COSTCENTRE, "de"), "de");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_COSTCENTRE, "nl"), "nl");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_COSTCENTRE, "fr"), "fr");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_COSTCENTRE, "es"), "es");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_COSTCENTRE, "pt"), "pt");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_COSTCENTRE, "it"), "it");
		LListAddRecord(pObjectsChart->pListDimension, pDimension);
		pDimension = CreateDimension(pAccounting, pObjectsChart);
		pDimension->Id = 2;
		pDimension->pSuperDimension = GetDimension(pObjectsChart->pListDimension, 1);
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_COSTBEARER, "en"), "en");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_COSTBEARER, "sv"), "sv");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_COSTBEARER, "da"), "da");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_COSTBEARER, "no"), "no");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_COSTBEARER, "is"), "is");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_COSTBEARER, "fi"), "fi");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_COSTBEARER, "de"), "de");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_COSTBEARER, "nl"), "nl");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_COSTBEARER, "fr"), "fr");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_COSTBEARER, "es"), "es");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_COSTBEARER, "pt"), "pt");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_COSTBEARER, "it"), "it");
		LListAddRecord(pObjectsChart->pListDimension, pDimension);
		pDimension = CreateDimension(pAccounting, pObjectsChart);
		pDimension->Id = 3;
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_POINTOFSALES, "en"), "en");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_POINTOFSALES, "sv"), "sv");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_POINTOFSALES, "da"), "da");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_POINTOFSALES, "no"), "no");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_POINTOFSALES, "is"), "is");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_POINTOFSALES, "fi"), "fi");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_POINTOFSALES, "de"), "de");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_POINTOFSALES, "nl"), "nl");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_POINTOFSALES, "fr"), "fr");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_POINTOFSALES, "es"), "es");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_POINTOFSALES, "pt"), "pt");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_POINTOFSALES, "it"), "it");
		LListAddRecord(pObjectsChart->pListDimension, pDimension);
		pDimension = CreateDimension(pAccounting, pObjectsChart);
		pDimension->Id = 4;
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_BRANCH, "en"), "en");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_BRANCH, "sv"), "sv");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_BRANCH, "da"), "da");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_BRANCH, "no"), "no");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_BRANCH, "is"), "is");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_BRANCH, "fi"), "fi");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_BRANCH, "de"), "de");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_BRANCH, "nl"), "nl");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_BRANCH, "fr"), "fr");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_BRANCH, "es"), "es");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_BRANCH, "pt"), "pt");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_BRANCH, "it"), "it");
		LListAddRecord(pObjectsChart->pListDimension, pDimension);
		pDimension = CreateDimension(pAccounting, pObjectsChart);
		pDimension->Id = 6;
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_PROJECT, "en"), "en");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_PROJECT, "sv"), "sv");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_PROJECT, "da"), "da");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_PROJECT, "no"), "no");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_PROJECT, "is"), "is");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_PROJECT, "fi"), "fi");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_PROJECT, "de"), "de");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_PROJECT, "nl"), "nl");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_PROJECT, "fr"), "fr");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_PROJECT, "es"), "es");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_PROJECT, "pt"), "pt");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_PROJECT, "it"), "it");
		LListAddRecord(pObjectsChart->pListDimension, pDimension);
		pDimension = CreateDimension(pAccounting, pObjectsChart);
		pDimension->Id = 7;
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_EMPLYEE, "en"), "en");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_EMPLYEE, "sv"), "sv");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_EMPLYEE, "da"), "da");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_EMPLYEE, "no"), "no");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_EMPLYEE, "is"), "is");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_EMPLYEE, "fi"), "fi");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_EMPLYEE, "de"), "de");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_EMPLYEE, "nl"), "nl");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_EMPLYEE, "fr"), "fr");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_EMPLYEE, "es"), "es");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_EMPLYEE, "pt"), "pt");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_EMPLYEE, "it"), "it");
		LListAddRecord(pObjectsChart->pListDimension, pDimension);
		pDimension = CreateDimension(pAccounting, pObjectsChart);
		pDimension->Id = 8;
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_CUSTOMER, "en"), "en");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_CUSTOMER, "sv"), "sv");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_CUSTOMER, "da"), "da");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_CUSTOMER, "no"), "no");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_CUSTOMER, "is"), "is");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_CUSTOMER, "fi"), "fi");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_CUSTOMER, "de"), "de");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_CUSTOMER, "nl"), "nl");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_CUSTOMER, "fr"), "fr");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_CUSTOMER, "es"), "es");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_CUSTOMER, "pt"), "pt");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_CUSTOMER, "it"), "it");
		LListAddRecord(pObjectsChart->pListDimension, pDimension);
		pDimension = CreateDimension(pAccounting, pObjectsChart);
		pDimension->Id = 9;
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_SUPPLIER, "en"), "en");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_SUPPLIER, "sv"), "sv");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_SUPPLIER, "da"), "da");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_SUPPLIER, "no"), "no");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_SUPPLIER, "is"), "is");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_SUPPLIER, "fi"), "fi");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_SUPPLIER, "de"), "de");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_SUPPLIER, "nl"), "nl");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_SUPPLIER, "fr"), "fr");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_SUPPLIER, "es"), "es");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_SUPPLIER, "pt"), "pt");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_SUPPLIER, "it"), "it");
		LListAddRecord(pObjectsChart->pListDimension, pDimension);
		pDimension = CreateDimension(pAccounting, pObjectsChart);
		pDimension->Id = 10;
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_INVOICE, "en"), "en");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_INVOICE, "sv"), "sv");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_INVOICE, "da"), "da");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_INVOICE, "no"), "no");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_INVOICE, "is"), "is");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_INVOICE, "fi"), "fi");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_INVOICE, "de"), "de");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_INVOICE, "nl"), "nl");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_INVOICE, "fr"), "fr");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_INVOICE, "es"), "es");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_INVOICE, "pt"), "pt");
		pDimension->pListName = AddTextListItem(pStructDocTop, pDimension, pDimension->pListName, GetEnumAccountTitleTypeText(DIM_TYPE_INVOICE, "it"), "it");
		LListAddRecord(pObjectsChart->pListDimension, pDimension);
	}
	return pObjectsChart;
}


/*********************************************************************

ObjectsChartType *DestroyObjectsChart(

*********************************************************************/
ObjectsChartType *DestroyObjectsChart(
	ObjectsChartType **ppObjectsChart)
{
	if(!*ppObjectsChart)
		return 0;	// Nothing to destroy

	{
		DimensionType *pDimension
			= LListGetFirstRecordData((*ppObjectsChart)->pListDimension);
		while(pDimension) {
			DestroyDimension(&pDimension);		// rac:DimensionType
			pDimension = LListGetNextRecordData((*ppObjectsChart)->pListDimension);
		}
		LListErase((*ppObjectsChart)->pListDimension);
	}

	free(*ppObjectsChart);
	*ppObjectsChart = 0;

	return 0;
}


/*********************************************************************

ObjectsChartType *CopyObjectsChart(

*********************************************************************/
ObjectsChartType *CopyObjectsChart(
	void *pStructDocTop, 
	void *pStructParent, 
	ObjectsChartType *pObjectsChart)
{
	if(pObjectsChart) {
		ObjectsChartType *pNewObjectsChart = ((AccountingType *)pStructDocTop)->pObjectsChart;	// Is predefined in CreateAccounting()

		if(!pNewObjectsChart)
			return 0;	// Fatal error

		{
			DimensionType *pDimension
				= LListGetFirstRecordData(pObjectsChart->pListDimension);
			while(pDimension) {
				CopyDimension(pStructDocTop, pNewObjectsChart, pDimension);		// rac:DimensionType
				pDimension = LListGetNextRecordData(pObjectsChart->pListDimension);
			}
		}

		return (pNewObjectsChart);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataObjectsChart(

*********************************************************************/
BOOL IsDataObjectsChart(
	ObjectsChartType *pObjectsChart)
{
	if(!pObjectsChart)
		return FALSE;

	{
		DimensionType *pDimension
			= LListGetFirstRecordData(pObjectsChart->pListDimension);
		while(pDimension) {
			if(IsDataDimension(pDimension))
				return TRUE;
			pDimension = LListGetNextRecordData(pObjectsChart->pListDimension);
		}
	}

	return FALSE;
}


/*********************************************************************

static ObjectsChartType *ReadSectionObjectsChart(

*********************************************************************/
static ObjectsChartType *ReadSectionObjectsChart(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
ObjectsChartType *pObjectsChart = ((AccountingType *)pStructDocTop)->pObjectsChart;

	if(!pObjectsChart)
		return 0;	// Fatal error

	pXmlTagData=GetNextXmlTag(pXmlTagData);

	if(!pXmlTagData)
		return 0;	// Fatal error

	while(strcmp(pXmlTagData->pTag, pEndTag)) { // While is not the end
		if(!strcmp(pXmlTagData->pTag, "Dimension"))
			ReadSectionDimension(pStructDocTop, pObjectsChart, pXmlTagData, "Dimension");		// rac:DimensionType

		pXmlTagData=GetNextXmlTag(pXmlTagData);

		if(!pXmlTagData)
			return 0;	// Fatal error
	}
	return pObjectsChart;
}


/*********************************************************************

static BOOL WriteSectionObjectsChart(

*********************************************************************/
static BOOL WriteSectionObjectsChart(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	ObjectsChartType *pObjectsChart, 
	char *pContent)
{
	if(!pObjectsChart)
		return FALSE;	// Fatal error

	xmlWriteLine(pStream, iTab-1, pAttr, pLabel, 0, 0);

	if(pObjectsChart->pListDimension) {
		DimensionType *pDimension
			= LListGetFirstRecordData(pObjectsChart->pListDimension);
		while(pDimension) {
			if(IsDataDimension(pDimension)) {
				if(pDimension->Id)
					WriteSectionDimension(pStream, iTab+1, "Dimension", 0, pDimension, FALSE);		// rac:DimensionType
			}
			pDimension = LListGetNextRecordData(pObjectsChart->pListDimension);
		}
	}

	xmlWriteLine(pStream, iTab-1, 0, 0, 0, pLabel);

	return TRUE;
}


/*********************************************************************

ObjectsChartType *UpdateObjectsChart(

*********************************************************************/
ObjectsChartType *UpdateObjectsChart(
	ObjectsChartType *pStructObjectsChart)
{

	return pStructObjectsChart;
}


/*********************************************************************

char **GetLeadTextObjectsChart(

*********************************************************************/
char **GetLeadTextObjectsChart(
	char *pLang)
{
static char *szTexts[] = {
	"Dimension"};

	return szTexts;
}


/*********************************************************************

	Dimension

*********************************************************************

DimensionType *CreateDimension(

*********************************************************************/
DimensionType *CreateDimension(
	void *pStructDocTop, 
	void *pStructParent)
{
DimensionType *pDimension = calloc(1, sizeof(DimensionType));

	if(!pDimension)
		return 0;	// Fatal error

	pDimension->DataType    = SCT_DIMENSION;
	pDimension->pStructDocTop = pStructDocTop;
	pDimension->pStructParent = pStructParent;

	pDimension->pListName = LListInit();
	pDimension->pListObject = LListInit();

	return pDimension;
}


/*********************************************************************

DimensionType *DestroyDimension(

*********************************************************************/
DimensionType *DestroyDimension(
	DimensionType **ppDimension)
{
	if(!*ppDimension)
		return 0;	// Nothing to destroy

	{
		TextType *pName
			= LListGetFirstRecordData((*ppDimension)->pListName);
		while(pName) {
			DestroyText(&pName);		// rac:TextType
			pName = LListGetNextRecordData((*ppDimension)->pListName);
		}
		LListErase((*ppDimension)->pListName);
	}
	// For 3d data - DestroyDimension((DimensionType **)&(*ppDimension)->pSuperDimension);		// rac:DimensionType - Pointer to a structure of the same type in itself, and must so be declared void *data instaed, and be casted here
	{
		ObjectType *pObject
			= LListGetFirstRecordData((*ppDimension)->pListObject);
		while(pObject) {
			DestroyObject(&pObject);		// rac:ObjectType
			pObject = LListGetNextRecordData((*ppDimension)->pListObject);
		}
		LListErase((*ppDimension)->pListObject);
	}

	free(*ppDimension);
	*ppDimension = 0;

	return 0;
}


/*********************************************************************

DimensionType *CopyDimension(

*********************************************************************/
DimensionType *CopyDimension(
	void *pStructDocTop, 
	void *pStructParent, 
	DimensionType *pDimension)
{
	if(pDimension) {
		DimensionType *pNewDimension = CreateDimension(pStructDocTop, pStructParent);

		if(!pNewDimension)
			return 0;	// Fatal error

		pNewDimension->Id = pDimension->Id;		// xs:positiveInteger
		pNewDimension = SearchSetDimension(((AccountingType *)pStructDocTop)->pObjectsChart->pListDimension, pNewDimension);
		{
			TextType *pName
				= LListGetFirstRecordData(pDimension->pListName);
			while(pName) {
				SearchSetText(pNewDimension->pListName, CopyText(pStructDocTop, pNewDimension, pName));		// rac:TextType
				pName = LListGetNextRecordData(pDimension->pListName);
			}
		}
		pNewDimension->pSuperDimension = SearchSetDimension(((AccountingType *)pStructDocTop)->pObjectsChart->pListDimension, CopyDimension(pStructDocTop, pNewDimension, pDimension->pSuperDimension));		// rac:DimensionType
		pNewDimension->InActive = pDimension->InActive;		// xs:boolean
		{
			ObjectType *pObject
				= LListGetFirstRecordData(pDimension->pListObject);
			while(pObject) {
				SearchSetObject(((AccountingType *)pStructDocTop)->pObjectsChart->pListDimension, CopyObject(pStructDocTop, pNewDimension, pObject));		// rac:ObjectType
				pObject = LListGetNextRecordData(pDimension->pListObject);
			}
		}

		return (pNewDimension);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataDimension(

*********************************************************************/
BOOL IsDataDimension(
	DimensionType *pDimension)
{
	if(!pDimension)
		return FALSE;

	if(!pDimension->Id)
		return FALSE;

	if(IsDataDimension(pDimension->pSuperDimension))
		return TRUE;
	{
		ObjectType *pObject
			= LListGetFirstRecordData(pDimension->pListObject);
		while(pObject) {
			if(IsDataObject(pObject))
				return TRUE;
			pObject = LListGetNextRecordData(pDimension->pListObject);
		}
	}

	return FALSE;
}


/*********************************************************************

static DimensionType *ReadSectionDimension(

*********************************************************************/
static DimensionType *ReadSectionDimension(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
DimensionType *pDimension = CreateDimension(pStructDocTop, pStructParent);

	if(!pDimension)
		return 0;	// Fatal error

	pXmlTagData=GetNextXmlTag(pXmlTagData);

	if(!pXmlTagData)
		return 0;	// Fatal error

	while(strcmp(pXmlTagData->pTag, pEndTag)) { // While is not the end
		if(!strcmp(pXmlTagData->pTag, "Id")) {
			pDimension->Id = StringToCounter(pXmlTagData->pData);		// xs:positiveInteger
			pDimension = SearchSetDimension(((AccountingType *)pStructDocTop)->pObjectsChart->pListDimension, pDimension);
		}
		else if(!strcmp(pXmlTagData->pTag, "Name"))
			SearchSetText(pDimension->pListName, ReadSectionText(pStructDocTop, pDimension, pXmlTagData, "Name"));		// rac:TextType
		else if(!strcmp(pXmlTagData->pTag, "SuperDimension"))
			pDimension->pSuperDimension = SearchSetDimension(((AccountingType *)pStructDocTop)->pObjectsChart->pListDimension, ReadSectionDimension(pStructDocTop, pDimension, pXmlTagData, "SuperDimension"));		// rac:DimensionType
		else if(!strcmp(pXmlTagData->pTag, "InActive"))
			pDimension->InActive = StringToBool(pXmlTagData->pData);		// xs:boolean
		else if(!strcmp(pXmlTagData->pTag, "Object"))
			SearchSetObject(((AccountingType *)pStructDocTop)->pObjectsChart->pListDimension, ReadSectionObject(pStructDocTop, pDimension, pXmlTagData, "Object"));		// rac:ObjectType

		pXmlTagData=GetNextXmlTag(pXmlTagData);

		if(!pXmlTagData)
			return 0;	// Fatal error
	}
	return pDimension;
}


/*********************************************************************

static BOOL WriteSectionDimension(

*********************************************************************/
static BOOL WriteSectionDimension(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	DimensionType *pDimension, 
	BOOL bLean)
{
	if(!pDimension)
		return FALSE;	// Fatal error

	xmlWriteLine(pStream, iTab-1, pAttr, pLabel, 0, 0);
	xmlWriteLine(pStream, iTab, 0, "Id", CounterToStr(pDimension->Id, szString),"Id");		// xs:positiveInteger - Mandatory

	if(bLean) {
		xmlWriteLine(pStream, iTab - 1, 0, 0, 0, pLabel);
		return TRUE;
	}

	if(pDimension->pListName) {
		TextType *pName
			= LListGetFirstRecordData(pDimension->pListName);
		while(pName) {
			if(IsDataText(pName))
				WriteSectionText(pStream, iTab+1, "Name", 0, pName);		// rac:TextType
			pName = LListGetNextRecordData(pDimension->pListName);
		}
	}

	if(pDimension->pSuperDimension && IsDataDimension(pDimension->pSuperDimension))		// Optional
		WriteSectionDimension(pStream, iTab+1, "SuperDimension", 0, pDimension->pSuperDimension, TRUE);		// rac:DimensionType
	if(pDimension->InActive)
		xmlWriteLine(pStream, iTab, 0, "InActive", BoolToStr(pDimension->InActive, szString),"InActive");		// xs:boolean

	if(pDimension->pListObject) {
		ObjectType *pObject
			= LListGetFirstRecordData(pDimension->pListObject);
		while(pObject) {
			if(IsDataObject(pObject))
				WriteSectionObject(pStream, iTab+1, "Object", 0, pObject, bLean);		// rac:ObjectType
			pObject = LListGetNextRecordData(pDimension->pListObject);
		}
	}

	xmlWriteLine(pStream, iTab-1, 0, 0, 0, pLabel);

	return TRUE;
}


/*********************************************************************

DimensionType *UpdateDimension(

*********************************************************************/
DimensionType *UpdateDimension(
	DimensionType *pStructDimension, 
	COUNTER Id, 
	BOOL InActive)
{
	pStructDimension->Id = Id;
	pStructDimension->InActive = InActive;

	return pStructDimension;
}


/*********************************************************************

char **GetLeadTextDimension(

*********************************************************************/
char **GetLeadTextDimension(
	char *pLang)
{
static char *szTexts[] = {
	"Id",
	"Name",
	"Super Dimension",
	"In Active",
	"Object"};

	return szTexts;
}


/*********************************************************************

	Object

*********************************************************************

ObjectType *CreateObject(

*********************************************************************/
ObjectType *CreateObject(
	void *pStructDocTop, 
	void *pStructParent)
{
ObjectType *pObject = calloc(1, sizeof(ObjectType));

	if(!pObject)
		return 0;	// Fatal error

	pObject->DataType    = SCT_OBJECT;
	pObject->pStructDocTop = pStructDocTop;
	pObject->pStructParent = pStructParent;

	pObject->pId = NulString;
	pObject->pListName = LListInit();
	pObject->pListFileUrl = LListInit();

	return pObject;
}


/*********************************************************************

ObjectType *DestroyObject(

*********************************************************************/
ObjectType *DestroyObject(
	ObjectType **ppObject)
{
	if(!*ppObject)
		return 0;	// Nothing to destroy

	// For 3d data - DestroyDimension(&(*ppObject)->pDimension);		// rac:DimensionType
	FreeString(&(*ppObject)->pId);		// rac:IdToken
	{
		TextType *pName
			= LListGetFirstRecordData((*ppObject)->pListName);
		while(pName) {
			DestroyText(&pName);		// rac:TextType
			pName = LListGetNextRecordData((*ppObject)->pListName);
		}
		LListErase((*ppObject)->pListName);
	}
	LListDestroy((*ppObject)->pListFileUrl);		// rac:FileUrl
	DestroyParty(&(*ppObject)->pParty);		// rac:PartyType

	free(*ppObject);
	*ppObject = 0;

	return 0;
}


/*********************************************************************

ObjectType *CopyObject(

*********************************************************************/
ObjectType *CopyObject(
	void *pStructDocTop, 
	void *pStructParent, 
	ObjectType *pObject)
{
	if(pObject) {
		ObjectType *pNewObject = CreateObject(pStructDocTop, pStructParent);

		if(!pNewObject)
			return 0;	// Fatal error

		pNewObject->pDimension = GetDimension(((AccountingType *)pStructDocTop)->pObjectsChart->pListDimension, pObject->pDimension->Id); 
		if (!pNewObject->pDimension)
			pNewObject->pDimension = SearchSetDimension(((AccountingType *)pStructDocTop)->pObjectsChart->pListDimension, CopyDimension(pStructDocTop, ((AccountingType *)pStructDocTop)->pObjectsChart, pObject->pDimension)); 
		CopyString(&pNewObject->pId, pObject->pId);		// rac:IdToken
		{
			TextType *pName
				= LListGetFirstRecordData(pObject->pListName);
			while(pName) {
				LListAddRecord(pNewObject->pListName, CopyText(pStructDocTop, pNewObject, pName));		// rac:TextType
				pName = LListGetNextRecordData(pObject->pListName);
			}
		}
		pNewObject->InActive = pObject->InActive;		// xs:boolean
		{
			char *pFileUrl
				= LListGetFirstRecordData(pObject->pListFileUrl);
			while(pFileUrl) {
				LListAddRecord(pNewObject->pListFileUrl, CopyString(0, pFileUrl));		// rac:FileUrl
				pFileUrl = LListGetNextRecordData(pObject->pListFileUrl);
			}
		}
		pNewObject->pParty = CopyParty(pStructDocTop, pNewObject, pObject->pParty);		// rac:PartyType

		return (pNewObject);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataObject(

*********************************************************************/
BOOL IsDataObject(
	ObjectType *pObject)
{
	if(!pObject)
		return FALSE;

	if(pObject->pId && *pObject->pId)
		return TRUE;
	{
		TextType *pName
			= LListGetFirstRecordData(pObject->pListName);
		while(pName) {
			if(IsDataText(pName))
				return TRUE;
			pName = LListGetNextRecordData(pObject->pListName);
		}
	}
	if(LListGetFirstRecordData(pObject->pListFileUrl))
		return TRUE;
	if(IsDataParty(pObject->pParty))
		return TRUE;

	return FALSE;
}


/*********************************************************************

static ObjectType *ReadSectionObject(

*********************************************************************/
static ObjectType *ReadSectionObject(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
ObjectType *pObject = CreateObject(pStructDocTop, pStructParent);

	if(!pObject)
		return 0;	// Fatal error

	pXmlTagData=GetNextXmlTag(pXmlTagData);

	if(!pXmlTagData)
		return 0;	// Fatal error

	if(pStructParent && (((DimensionType *)pStructParent)->DataType == SCT_DIMENSION))
		pObject->pDimension = pStructParent;

	while(strcmp(pXmlTagData->pTag, pEndTag)) { // While is not the end
		if(!strcmp(pXmlTagData->pTag, "Dimension"))
			pObject->pDimension = SearchSetDimension(((AccountingType *)pStructDocTop)->pObjectsChart->pListDimension, ReadSectionDimension(pStructDocTop, pObject, pXmlTagData, "Dimension"));		// rac:DimensionType
		else if(!strcmp(pXmlTagData->pTag, "Id"))
			ReadString(&pObject->pId, ReadXmlDataString(pXmlTagData->pData));		// rac:IdToken
		else if(!strcmp(pXmlTagData->pTag, "Name"))
			SearchSetText(pObject->pListName, ReadSectionText(pStructDocTop, pObject, pXmlTagData, "Name"));		// rac:TextType
		else if(!strcmp(pXmlTagData->pTag, "InActive"))
			pObject->InActive = StringToBool(pXmlTagData->pData);		// xs:boolean
		else if(!strcmp(pXmlTagData->pTag, "FileUrl"))
			LListAddRecord(pObject->pListFileUrl, ReadXmlDataString(pXmlTagData->pData));		// rac:FileUrl
		else if(!strcmp(pXmlTagData->pTag, "Party"))
			pObject->pParty = ReadSectionParty(pStructDocTop, pObject, pXmlTagData, "Party");		// rac:PartyType

		pXmlTagData=GetNextXmlTag(pXmlTagData);

		if(!pXmlTagData)
			return 0;	// Fatal error
	}
	return pObject;
}


/*********************************************************************

static BOOL WriteSectionObject(

*********************************************************************/
static BOOL WriteSectionObject(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	ObjectType *pObject, 
	BOOL bLean)
{
	if(!pObject)
		return FALSE;	// Fatal error

	xmlWriteLine(pStream, iTab-1, pAttr, pLabel, 0, 0);

	if(!pObject->pDimension)		// Mandatory
		pObject->pDimension = CreateDimension(pObject->pStructDocTop, pObject);
	WriteSectionDimension(pStream, iTab+1, "Dimension", 0, pObject->pDimension, TRUE);		// rac:DimensionType - Mandatory
	xmlWriteLine(pStream, iTab, 0, "Id", pObject->pId, "Id");		// rac:IdToken - Mandatory

	if(bLean) 
		xmlWriteLine(pStream, iTab, 0, "Name", GetTextListText(pObject->pListName, 0), "Name");
	else if(pObject->pListName) {
		TextType *pName
			= LListGetFirstRecordData(pObject->pListName);
		while(pName) {
			if(IsDataText(pName))
				WriteSectionText(pStream, iTab+1, "Name", 0, pName);		// rac:TextType
			pName = LListGetNextRecordData(pObject->pListName);
		}
	}

	if(bLean) {
		xmlWriteLine(pStream, iTab - 1, 0, 0, 0, pLabel);
		return TRUE;
	}
	if(pObject->InActive)
		xmlWriteLine(pStream, iTab, 0, "InActive", BoolToStr(pObject->InActive, szString),"InActive");		// xs:boolean

	if(pObject->pListFileUrl) {
		char *pFileUrl
			= LListGetFirstRecordData(pObject->pListFileUrl);
		while(pFileUrl) {
			xmlWriteLine(pStream, iTab, 0, "FileUrl", pFileUrl, "FileUrl");		// rac:FileUrl

			pFileUrl = LListGetNextRecordData(pObject->pListFileUrl);
		}
	}

	if(pObject->pParty && IsDataParty(pObject->pParty))		// Optional
		WriteSectionParty(pStream, iTab+1, "Party", 0, pObject->pParty);		// rac:PartyType

	xmlWriteLine(pStream, iTab-1, 0, 0, 0, pLabel);

	return TRUE;
}


/*********************************************************************

ObjectType *UpdateObject(

*********************************************************************/
ObjectType *UpdateObject(
	ObjectType *pStructObject, 
	char *pId, 
	BOOL InActive)
{
	StringUpdate(&pStructObject->pId, pId);
	pStructObject->InActive = InActive;

	return pStructObject;
}


/*********************************************************************

char **GetLeadTextObject(

*********************************************************************/
char **GetLeadTextObject(
	char *pLang)
{
static char *szTexts[] = {
	"Dimension",
	"Id",
	"Name",
	"In Active",
	"File Url",
	"Party"};

	return szTexts;
}


/*********************************************************************

	LedgersChart

*********************************************************************

LedgersChartType *CreateLedgersChart(

*********************************************************************/
LedgersChartType *CreateLedgersChart(
	void *pStructDocTop, 
	void *pStructParent)
{
LedgersChartType *pLedgersChart = calloc(1, sizeof(LedgersChartType));

	if(!pLedgersChart)
		return 0;	// Fatal error

	pLedgersChart->DataType    = SCT_LEDGERSCHART;
	pLedgersChart->pStructDocTop = pStructDocTop;
	pLedgersChart->pStructParent = pStructParent;

	pLedgersChart->pListLedger = LListInit();

	return pLedgersChart;
}


/*********************************************************************

LedgersChartType *DestroyLedgersChart(

*********************************************************************/
LedgersChartType *DestroyLedgersChart(
	LedgersChartType **ppLedgersChart)
{
	if(!*ppLedgersChart)
		return 0;	// Nothing to destroy

	{
		LedgerType *pLedger
			= LListGetFirstRecordData((*ppLedgersChart)->pListLedger);
		while(pLedger) {
			DestroyLedger(&pLedger);		// rac:LedgerType
			pLedger = LListGetNextRecordData((*ppLedgersChart)->pListLedger);
		}
		LListErase((*ppLedgersChart)->pListLedger);
	}

	free(*ppLedgersChart);
	*ppLedgersChart = 0;

	return 0;
}


/*********************************************************************

LedgersChartType *CopyLedgersChart(

*********************************************************************/
LedgersChartType *CopyLedgersChart(
	void *pStructDocTop, 
	void *pStructParent, 
	LedgersChartType *pLedgersChart)
{
	if(pLedgersChart) {
		LedgersChartType *pNewLedgersChart = ((AccountingType *)pStructDocTop)->pLedgersChart;	// Is predefined in CreateAccounting()

		if(!pNewLedgersChart)
			return 0;	// Fatal error

		{
			LedgerType *pLedger
				= LListGetFirstRecordData(pLedgersChart->pListLedger);
			while(pLedger) {
				LListAddRecord(pNewLedgersChart->pListLedger, CopyLedger(pStructDocTop, pNewLedgersChart, pLedger));		// rac:LedgerType
				pLedger = LListGetNextRecordData(pLedgersChart->pListLedger);
			}
		}

		return (pNewLedgersChart);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataLedgersChart(

*********************************************************************/
BOOL IsDataLedgersChart(
	LedgersChartType *pLedgersChart)
{
	if(!pLedgersChart)
		return FALSE;

	{
		LedgerType *pLedger
			= LListGetFirstRecordData(pLedgersChart->pListLedger);
		while(pLedger) {
			if(IsDataLedger(pLedger))
				return TRUE;
			pLedger = LListGetNextRecordData(pLedgersChart->pListLedger);
		}
	}

	return FALSE;
}


/*********************************************************************

static LedgersChartType *ReadSectionLedgersChart(

*********************************************************************/
static LedgersChartType *ReadSectionLedgersChart(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
LedgersChartType *pLedgersChart = ((AccountingType *)pStructDocTop)->pLedgersChart;

	if(!pLedgersChart)
		return 0;	// Fatal error

	pXmlTagData=GetNextXmlTag(pXmlTagData);

	if(!pXmlTagData)
		return 0;	// Fatal error

	while(strcmp(pXmlTagData->pTag, pEndTag)) { // While is not the end
		if(!strcmp(pXmlTagData->pTag, "Ledger"))
			LListAddRecord(pLedgersChart->pListLedger, ReadSectionLedger(pStructDocTop, pLedgersChart, pXmlTagData, "Ledger"));		// rac:LedgerType

		pXmlTagData=GetNextXmlTag(pXmlTagData);

		if(!pXmlTagData)
			return 0;	// Fatal error
	}
	return pLedgersChart;
}


/*********************************************************************

static BOOL WriteSectionLedgersChart(

*********************************************************************/
static BOOL WriteSectionLedgersChart(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	LedgersChartType *pLedgersChart, 
	char *pContent)
{
	if(!pLedgersChart)
		return FALSE;	// Fatal error

	xmlWriteLine(pStream, iTab-1, pAttr, pLabel, 0, 0);

	if(pLedgersChart->pListLedger) {
		LedgerType *pLedger
			= LListGetFirstRecordData(pLedgersChart->pListLedger);
		while(pLedger) {
			if(IsDataLedger(pLedger) && (!((!strcmp(pContent, CONTENT_LABEL_VOUCHER)) && (pLedger->Id>0))))
				WriteSectionLedger(pStream, iTab+1, "Ledger", 0, pLedger, pContent);		// rac:LedgerType
			pLedger = LListGetNextRecordData(pLedgersChart->pListLedger);
		}
	}

	xmlWriteLine(pStream, iTab-1, 0, 0, 0, pLabel);

	return TRUE;
}


/*********************************************************************

LedgersChartType *UpdateLedgersChart(

*********************************************************************/
LedgersChartType *UpdateLedgersChart(
	LedgersChartType *pStructLedgersChart)
{

	return pStructLedgersChart;
}


/*********************************************************************

char **GetLeadTextLedgersChart(

*********************************************************************/
char **GetLeadTextLedgersChart(
	char *pLang)
{
static char *szTexts[] = {
	"Ledger"};

	return szTexts;
}


/*********************************************************************

	Ledger

*********************************************************************

LedgerType *CreateLedger(

*********************************************************************/
LedgerType *CreateLedger(
	void *pStructDocTop, 
	void *pStructParent)
{
LedgerType *pLedger = calloc(1, sizeof(LedgerType));

	if(!pLedger)
		return 0;	// Fatal error

	pLedger->DataType    = SCT_LEDGER;
	pLedger->pStructDocTop = pStructDocTop;
	pLedger->pStructParent = pStructParent;


	pLedger->YearStart = ((GetSystemDate()/10000)*10000)+101;
	pLedger->YearEnd = ((GetSystemDate()/10000)*10000)+1231;
	pLedger->pListFileUrl = LListInit();
	pLedger->pListReport = LListInit();
	pLedger->pListVoucher = LListInit();

	return pLedger;
}


/*********************************************************************

LedgerType *DestroyLedger(

*********************************************************************/
LedgerType *DestroyLedger(
	LedgerType **ppLedger)
{
	if(!*ppLedger)
		return 0;	// Nothing to destroy

	LListDestroy((*ppLedger)->pListFileUrl);		// rac:FileUrl
	{
		BalanceReportType *pReport
			= LListGetFirstRecordData((*ppLedger)->pListReport);
		while(pReport) {
			DestroyBalanceReport(&pReport);		// rac:BalanceReportType
			pReport = LListGetNextRecordData((*ppLedger)->pListReport);
		}
		LListErase((*ppLedger)->pListReport);
	}
	{
		VoucherType *pVoucher
			= LListGetFirstRecordData((*ppLedger)->pListVoucher);
		while(pVoucher) {
			DestroyVoucher(&pVoucher);		// rac:VoucherType
			pVoucher = LListGetNextRecordData((*ppLedger)->pListVoucher);
		}
		LListErase((*ppLedger)->pListVoucher);
	}

	free(*ppLedger);
	*ppLedger = 0;

	return 0;
}


/*********************************************************************

LedgerType *CopyLedger(

*********************************************************************/
LedgerType *CopyLedger(
	void *pStructDocTop, 
	void *pStructParent, 
	LedgerType *pLedger)
{
	if(pLedger) {
		LedgerType *pNewLedger = CreateLedger(pStructDocTop, pStructParent);

		if(!pNewLedger)
			return 0;	// Fatal error

		pNewLedger->Id = pLedger->Id;		// xs:nonPositiveInteger
		pNewLedger->YearStart = pLedger->YearStart;		// xs:date
		pNewLedger->YearEnd = pLedger->YearEnd;		// xs:date
		{
			char *pFileUrl
				= LListGetFirstRecordData(pLedger->pListFileUrl);
			while(pFileUrl) {
				LListAddRecord(pNewLedger->pListFileUrl, CopyString(0, pFileUrl));		// rac:FileUrl
				pFileUrl = LListGetNextRecordData(pLedger->pListFileUrl);
			}
		}
		{
			BalanceReportType *pReport
				= LListGetFirstRecordData(pLedger->pListReport);
			while(pReport) {
				LListAddRecord(pNewLedger->pListReport, CopyBalanceReport(pStructDocTop, pNewLedger, pReport));		// rac:BalanceReportType
				pReport = LListGetNextRecordData(pLedger->pListReport);
			}
		}
		{
			VoucherType *pVoucher
				= LListGetFirstRecordData(pLedger->pListVoucher);
			while(pVoucher) {
				LListAddRecord(pNewLedger->pListVoucher, CopyVoucher(pStructDocTop, pNewLedger, pVoucher));		// rac:VoucherType
				pVoucher = LListGetNextRecordData(pLedger->pListVoucher);
			}
		}

		return (pNewLedger);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataLedger(

*********************************************************************/
BOOL IsDataLedger(
	LedgerType *pLedger)
{
	if(!pLedger)
		return FALSE;

	if(LListGetFirstRecordData(pLedger->pListFileUrl))
		return TRUE;
	{
		BalanceReportType *pReport
			= LListGetFirstRecordData(pLedger->pListReport);
		while(pReport) {
			if(IsDataBalanceReport(pReport))
				return TRUE;
			pReport = LListGetNextRecordData(pLedger->pListReport);
		}
	}
	{
		VoucherType *pVoucher
			= LListGetFirstRecordData(pLedger->pListVoucher);
		while(pVoucher) {
			if(IsDataVoucher(pVoucher))
				return TRUE;
			pVoucher = LListGetNextRecordData(pLedger->pListVoucher);
		}
	}

	return FALSE;
}


/*********************************************************************

static LedgerType *ReadSectionLedger(

*********************************************************************/
static LedgerType *ReadSectionLedger(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
LedgerType *pLedger = CreateLedger(pStructDocTop, pStructParent);

	if(!pLedger)
		return 0;	// Fatal error

	pXmlTagData=GetNextXmlTag(pXmlTagData);

	if(!pXmlTagData)
		return 0;	// Fatal error

	while(strcmp(pXmlTagData->pTag, pEndTag)) { // While is not the end
		if(!strcmp(pXmlTagData->pTag, "Id"))
			pLedger->Id = StringToNumeric(pXmlTagData->pData);		// xs:nonPositiveInteger
		else if(!strcmp(pXmlTagData->pTag, "YearStart"))
			pLedger->YearStart = StringToDate(pXmlTagData->pData);		// xs:date
		else if(!strcmp(pXmlTagData->pTag, "YearEnd"))
			pLedger->YearEnd = StringToDate(pXmlTagData->pData);		// xs:date
		else if(!strcmp(pXmlTagData->pTag, "FileUrl"))
			LListAddRecord(pLedger->pListFileUrl, ReadXmlDataString(pXmlTagData->pData));		// rac:FileUrl
		else if(!strcmp(pXmlTagData->pTag, "Report"))
			LListAddRecord(pLedger->pListReport, ReadSectionBalanceReport(pStructDocTop, pLedger, pXmlTagData, "Report"));		// rac:BalanceReportType
		else if(!strcmp(pXmlTagData->pTag, "Voucher"))
			LListAddRecord(pLedger->pListVoucher, ReadSectionVoucher(pStructDocTop, pLedger, pXmlTagData, "Voucher"));		// rac:VoucherType

		pXmlTagData=GetNextXmlTag(pXmlTagData);

		if(!pXmlTagData)
			return 0;	// Fatal error
	}
	return pLedger;
}


/*********************************************************************

static BOOL WriteSectionLedger(

*********************************************************************/
static BOOL WriteSectionLedger(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	LedgerType *pLedger, 
	char *pContent)
{
	if(!pLedger)
		return FALSE;	// Fatal error

	xmlWriteLine(pStream, iTab-1, pAttr, pLabel, 0, 0);
	xmlWriteLine(pStream, iTab, 0, "Id", NumericToStr(pLedger->Id, szString),"Id");		// xs:nonPositiveInteger - Mandatory
	if(pLedger->YearStart)
		xmlWriteLine(pStream, iTab, 0, "YearStart", DateToStr(pLedger->YearStart, szString),"YearStart");		// xs:date
	if(pLedger->YearEnd)
		xmlWriteLine(pStream, iTab, 0, "YearEnd", DateToStr(pLedger->YearEnd, szString),"YearEnd");		// xs:date

	if(pLedger->pListFileUrl) {
		char *pFileUrl
			= LListGetFirstRecordData(pLedger->pListFileUrl);
		while(pFileUrl) {
			xmlWriteLine(pStream, iTab, 0, "FileUrl", pFileUrl, "FileUrl");		// rac:FileUrl

			pFileUrl = LListGetNextRecordData(pLedger->pListFileUrl);
		}
	}

	if(pLedger->pListReport && ((!strcmp(pContent, CONTENT_LABEL_LEDGER)) || (!strcmp(pContent, CONTENT_LABEL_BALANCE)))) {
		BalanceReportType *pReport
			= LListGetFirstRecordData(pLedger->pListReport);
		while(pReport) {
			if(IsDataBalanceReport(pReport))
				WriteSectionBalanceReport(pStream, iTab+1, "Report", 0, pReport);		// rac:BalanceReportType
			pReport = LListGetNextRecordData(pLedger->pListReport);
		}
	}

	if(pLedger->pListVoucher && ((!strcmp(pContent, CONTENT_LABEL_LEDGER)) || (!strcmp(pContent, CONTENT_LABEL_VOUCHER)))) {
		VoucherType *pVoucher
			= LListGetFirstRecordData(pLedger->pListVoucher);
		while(pVoucher) {
			if(IsDataVoucher(pVoucher))
				WriteSectionVoucher(pStream, iTab+1, "Voucher", 0, pVoucher);		// rac:VoucherType
			pVoucher = LListGetNextRecordData(pLedger->pListVoucher);
		}
	}

	xmlWriteLine(pStream, iTab-1, 0, 0, 0, pLabel);

	return TRUE;
}


/*********************************************************************

LedgerType *UpdateLedger(

*********************************************************************/
LedgerType *UpdateLedger(
	LedgerType *pStructLedger, 
	NUMERIC Id, 
	DATEINT YearStart, 
	DATEINT YearEnd)
{
	pStructLedger->Id = Id;
	pStructLedger->YearStart = YearStart;
	pStructLedger->YearEnd = YearEnd;

	return pStructLedger;
}


/*********************************************************************

char **GetLeadTextLedger(

*********************************************************************/
char **GetLeadTextLedger(
	char *pLang)
{
static char *szTexts[] = {
	"Id",
	"Year Start",
	"Year End",
	"File Url",
	"Report",
	"Voucher"};

	return szTexts;
}


/*********************************************************************

	BalanceReport

*********************************************************************

BalanceReportType *CreateBalanceReport(

*********************************************************************/
BalanceReportType *CreateBalanceReport(
	void *pStructDocTop, 
	void *pStructParent)
{
BalanceReportType *pBalanceReport = calloc(1, sizeof(BalanceReportType));

	if(!pBalanceReport)
		return 0;	// Fatal error

	pBalanceReport->DataType    = SCT_BALANCEREPORT;
	pBalanceReport->pStructDocTop = pStructDocTop;
	pBalanceReport->pStructParent = pStructParent;

	pBalanceReport->pListBalanceAccount = LListInit();

	return pBalanceReport;
}


/*********************************************************************

BalanceReportType *DestroyBalanceReport(

*********************************************************************/
BalanceReportType *DestroyBalanceReport(
	BalanceReportType **ppBalanceReport)
{
	if(!*ppBalanceReport)
		return 0;	// Nothing to destroy

	// For 3d data - DestroyObject(&(*ppBalanceReport)->pObject);		// rac:ObjectType
	DestroyBalanceTotal(&(*ppBalanceReport)->pTangible);		// rac:BalanceTotalType
	DestroyBalanceTotal(&(*ppBalanceReport)->pStock);		// rac:BalanceTotalType
	DestroyBalanceTotal(&(*ppBalanceReport)->pReceivables);		// rac:BalanceTotalType
	DestroyBalanceTotal(&(*ppBalanceReport)->pAssets);		// rac:BalanceTotalType
	DestroyBalanceTotal(&(*ppBalanceReport)->pActive);		// rac:BalanceTotalType
	DestroyBalanceTotal(&(*ppBalanceReport)->pEquities);		// rac:BalanceTotalType
	DestroyBalanceTotal(&(*ppBalanceReport)->pProvisions);		// rac:BalanceTotalType
	DestroyBalanceTotal(&(*ppBalanceReport)->pLiabilities);		// rac:BalanceTotalType
	DestroyBalanceTotal(&(*ppBalanceReport)->pPassive);		// rac:BalanceTotalType
	DestroyBalanceTotal(&(*ppBalanceReport)->pBalance);		// rac:BalanceTotalType
	DestroyBalanceTotal(&(*ppBalanceReport)->pRevenues);		// rac:BalanceTotalType
	DestroyBalanceTotal(&(*ppBalanceReport)->pSupplies);		// rac:BalanceTotalType
	DestroyBalanceTotal(&(*ppBalanceReport)->pProfit);		// rac:BalanceTotalType
	DestroyBalanceTotal(&(*ppBalanceReport)->pExpenses);		// rac:BalanceTotalType
	DestroyBalanceTotal(&(*ppBalanceReport)->pStaff);		// rac:BalanceTotalType
	DestroyBalanceTotal(&(*ppBalanceReport)->pEarning);		// rac:BalanceTotalType
	DestroyBalanceTotal(&(*ppBalanceReport)->pLossGains);		// rac:BalanceTotalType
	DestroyBalanceTotal(&(*ppBalanceReport)->pFinancial);		// rac:BalanceTotalType
	DestroyBalanceTotal(&(*ppBalanceReport)->pOutcome);		// rac:BalanceTotalType
	DestroyBalanceTotal(&(*ppBalanceReport)->pAuxiliary);		// rac:BalanceTotalType
	DestroyBalanceTotal(&(*ppBalanceReport)->pResult);		// rac:BalanceTotalType
	DestroyBalanceTotal(&(*ppBalanceReport)->pTotal);		// rac:BalanceTotalType
	{
		BalanceAccountType *pBalanceAccount
			= LListGetFirstRecordData((*ppBalanceReport)->pListBalanceAccount);
		while(pBalanceAccount) {
			DestroyBalanceAccount(&pBalanceAccount);		// rac:BalanceAccountType
			pBalanceAccount = LListGetNextRecordData((*ppBalanceReport)->pListBalanceAccount);
		}
		LListErase((*ppBalanceReport)->pListBalanceAccount);
	}

	free(*ppBalanceReport);
	*ppBalanceReport = 0;

	return 0;
}


/*********************************************************************

BalanceReportType *CopyBalanceReport(

*********************************************************************/
BalanceReportType *CopyBalanceReport(
	void *pStructDocTop, 
	void *pStructParent, 
	BalanceReportType *pBalanceReport)
{
	if(pBalanceReport) {
		BalanceReportType *pNewBalanceReport = CreateBalanceReport(pStructDocTop, pStructParent);

		if(!pNewBalanceReport)
			return 0;	// Fatal error

		pNewBalanceReport->pObject = SearchSetObject(((AccountingType *)pStructDocTop)->pObjectsChart->pListDimension, CopyObject(pStructDocTop, pNewBalanceReport, pBalanceReport->pObject));		// rac:ObjectType
		pNewBalanceReport->pTangible = CopyBalanceTotal(pStructDocTop, pNewBalanceReport, pBalanceReport->pTangible);		// rac:BalanceTotalType
		pNewBalanceReport->pStock = CopyBalanceTotal(pStructDocTop, pNewBalanceReport, pBalanceReport->pStock);		// rac:BalanceTotalType
		pNewBalanceReport->pReceivables = CopyBalanceTotal(pStructDocTop, pNewBalanceReport, pBalanceReport->pReceivables);		// rac:BalanceTotalType
		pNewBalanceReport->pAssets = CopyBalanceTotal(pStructDocTop, pNewBalanceReport, pBalanceReport->pAssets);		// rac:BalanceTotalType
		pNewBalanceReport->pActive = CopyBalanceTotal(pStructDocTop, pNewBalanceReport, pBalanceReport->pActive);		// rac:BalanceTotalType
		pNewBalanceReport->pEquities = CopyBalanceTotal(pStructDocTop, pNewBalanceReport, pBalanceReport->pEquities);		// rac:BalanceTotalType
		pNewBalanceReport->pProvisions = CopyBalanceTotal(pStructDocTop, pNewBalanceReport, pBalanceReport->pProvisions);		// rac:BalanceTotalType
		pNewBalanceReport->pLiabilities = CopyBalanceTotal(pStructDocTop, pNewBalanceReport, pBalanceReport->pLiabilities);		// rac:BalanceTotalType
		pNewBalanceReport->pPassive = CopyBalanceTotal(pStructDocTop, pNewBalanceReport, pBalanceReport->pPassive);		// rac:BalanceTotalType
		pNewBalanceReport->pBalance = CopyBalanceTotal(pStructDocTop, pNewBalanceReport, pBalanceReport->pBalance);		// rac:BalanceTotalType
		pNewBalanceReport->pRevenues = CopyBalanceTotal(pStructDocTop, pNewBalanceReport, pBalanceReport->pRevenues);		// rac:BalanceTotalType
		pNewBalanceReport->pSupplies = CopyBalanceTotal(pStructDocTop, pNewBalanceReport, pBalanceReport->pSupplies);		// rac:BalanceTotalType
		pNewBalanceReport->pProfit = CopyBalanceTotal(pStructDocTop, pNewBalanceReport, pBalanceReport->pProfit);		// rac:BalanceTotalType
		pNewBalanceReport->pExpenses = CopyBalanceTotal(pStructDocTop, pNewBalanceReport, pBalanceReport->pExpenses);		// rac:BalanceTotalType
		pNewBalanceReport->pStaff = CopyBalanceTotal(pStructDocTop, pNewBalanceReport, pBalanceReport->pStaff);		// rac:BalanceTotalType
		pNewBalanceReport->pEarning = CopyBalanceTotal(pStructDocTop, pNewBalanceReport, pBalanceReport->pEarning);		// rac:BalanceTotalType
		pNewBalanceReport->pLossGains = CopyBalanceTotal(pStructDocTop, pNewBalanceReport, pBalanceReport->pLossGains);		// rac:BalanceTotalType
		pNewBalanceReport->pFinancial = CopyBalanceTotal(pStructDocTop, pNewBalanceReport, pBalanceReport->pFinancial);		// rac:BalanceTotalType
		pNewBalanceReport->pOutcome = CopyBalanceTotal(pStructDocTop, pNewBalanceReport, pBalanceReport->pOutcome);		// rac:BalanceTotalType
		pNewBalanceReport->pAuxiliary = CopyBalanceTotal(pStructDocTop, pNewBalanceReport, pBalanceReport->pAuxiliary);		// rac:BalanceTotalType
		pNewBalanceReport->pResult = CopyBalanceTotal(pStructDocTop, pNewBalanceReport, pBalanceReport->pResult);		// rac:BalanceTotalType
		pNewBalanceReport->pTotal = CopyBalanceTotal(pStructDocTop, pNewBalanceReport, pBalanceReport->pTotal);		// rac:BalanceTotalType
		{
			BalanceAccountType *pBalanceAccount
				= LListGetFirstRecordData(pBalanceReport->pListBalanceAccount);
			while(pBalanceAccount) {
				LListAddRecord(pNewBalanceReport->pListBalanceAccount, CopyBalanceAccount(pStructDocTop, pNewBalanceReport, pBalanceAccount));		// rac:BalanceAccountType
				pBalanceAccount = LListGetNextRecordData(pBalanceReport->pListBalanceAccount);
			}
		}

		return (pNewBalanceReport);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataBalanceReport(

*********************************************************************/
BOOL IsDataBalanceReport(
	BalanceReportType *pBalanceReport)
{
	if(!pBalanceReport)
		return FALSE;

	if(IsDataBalanceTotal(pBalanceReport->pTangible))
		return TRUE;
	if(IsDataBalanceTotal(pBalanceReport->pStock))
		return TRUE;
	if(IsDataBalanceTotal(pBalanceReport->pReceivables))
		return TRUE;
	if(IsDataBalanceTotal(pBalanceReport->pAssets))
		return TRUE;
	if(IsDataBalanceTotal(pBalanceReport->pActive))
		return TRUE;
	if(IsDataBalanceTotal(pBalanceReport->pEquities))
		return TRUE;
	if(IsDataBalanceTotal(pBalanceReport->pProvisions))
		return TRUE;
	if(IsDataBalanceTotal(pBalanceReport->pLiabilities))
		return TRUE;
	if(IsDataBalanceTotal(pBalanceReport->pPassive))
		return TRUE;
	if(IsDataBalanceTotal(pBalanceReport->pBalance))
		return TRUE;
	if(IsDataBalanceTotal(pBalanceReport->pRevenues))
		return TRUE;
	if(IsDataBalanceTotal(pBalanceReport->pSupplies))
		return TRUE;
	if(IsDataBalanceTotal(pBalanceReport->pProfit))
		return TRUE;
	if(IsDataBalanceTotal(pBalanceReport->pExpenses))
		return TRUE;
	if(IsDataBalanceTotal(pBalanceReport->pStaff))
		return TRUE;
	if(IsDataBalanceTotal(pBalanceReport->pEarning))
		return TRUE;
	if(IsDataBalanceTotal(pBalanceReport->pLossGains))
		return TRUE;
	if(IsDataBalanceTotal(pBalanceReport->pFinancial))
		return TRUE;
	if(IsDataBalanceTotal(pBalanceReport->pOutcome))
		return TRUE;
	if(IsDataBalanceTotal(pBalanceReport->pAuxiliary))
		return TRUE;
	if(IsDataBalanceTotal(pBalanceReport->pResult))
		return TRUE;
	if(IsDataBalanceTotal(pBalanceReport->pTotal))
		return TRUE;
	{
		BalanceAccountType *pBalanceAccount
			= LListGetFirstRecordData(pBalanceReport->pListBalanceAccount);
		while(pBalanceAccount) {
			if(IsDataBalanceAccount(pBalanceAccount))
				return TRUE;
			pBalanceAccount = LListGetNextRecordData(pBalanceReport->pListBalanceAccount);
		}
	}

	return FALSE;
}


/*********************************************************************

static BalanceReportType *ReadSectionBalanceReport(

*********************************************************************/
static BalanceReportType *ReadSectionBalanceReport(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
BalanceReportType *pBalanceReport = CreateBalanceReport(pStructDocTop, pStructParent);

	if(!pBalanceReport)
		return 0;	// Fatal error

	pXmlTagData=GetNextXmlTag(pXmlTagData);

	if(!pXmlTagData)
		return 0;	// Fatal error

	while(strcmp(pXmlTagData->pTag, pEndTag)) { // While is not the end
		if(!strcmp(pXmlTagData->pTag, "Object"))
			pBalanceReport->pObject = SearchSetObject(((AccountingType *)pStructDocTop)->pObjectsChart->pListDimension, ReadSectionObject(pStructDocTop, pBalanceReport, pXmlTagData, "Object"));		// rac:ObjectType
		else if(!strcmp(pXmlTagData->pTag, "Tangible"))
			pBalanceReport->pTangible = ReadSectionBalanceTotal(pStructDocTop, pBalanceReport, pXmlTagData, "Tangible");		// rac:BalanceTotalType
		else if(!strcmp(pXmlTagData->pTag, "Stock"))
			pBalanceReport->pStock = ReadSectionBalanceTotal(pStructDocTop, pBalanceReport, pXmlTagData, "Stock");		// rac:BalanceTotalType
		else if(!strcmp(pXmlTagData->pTag, "Receivables"))
			pBalanceReport->pReceivables = ReadSectionBalanceTotal(pStructDocTop, pBalanceReport, pXmlTagData, "Receivables");		// rac:BalanceTotalType
		else if(!strcmp(pXmlTagData->pTag, "Assets"))
			pBalanceReport->pAssets = ReadSectionBalanceTotal(pStructDocTop, pBalanceReport, pXmlTagData, "Assets");		// rac:BalanceTotalType
		else if(!strcmp(pXmlTagData->pTag, "Active"))
			pBalanceReport->pActive = ReadSectionBalanceTotal(pStructDocTop, pBalanceReport, pXmlTagData, "Active");		// rac:BalanceTotalType
		else if(!strcmp(pXmlTagData->pTag, "Equities"))
			pBalanceReport->pEquities = ReadSectionBalanceTotal(pStructDocTop, pBalanceReport, pXmlTagData, "Equities");		// rac:BalanceTotalType
		else if(!strcmp(pXmlTagData->pTag, "Provisions"))
			pBalanceReport->pProvisions = ReadSectionBalanceTotal(pStructDocTop, pBalanceReport, pXmlTagData, "Provisions");		// rac:BalanceTotalType
		else if(!strcmp(pXmlTagData->pTag, "Liabilities"))
			pBalanceReport->pLiabilities = ReadSectionBalanceTotal(pStructDocTop, pBalanceReport, pXmlTagData, "Liabilities");		// rac:BalanceTotalType
		else if(!strcmp(pXmlTagData->pTag, "Passive"))
			pBalanceReport->pPassive = ReadSectionBalanceTotal(pStructDocTop, pBalanceReport, pXmlTagData, "Passive");		// rac:BalanceTotalType
		else if(!strcmp(pXmlTagData->pTag, "Balance"))
			pBalanceReport->pBalance = ReadSectionBalanceTotal(pStructDocTop, pBalanceReport, pXmlTagData, "Balance");		// rac:BalanceTotalType
		else if(!strcmp(pXmlTagData->pTag, "Revenues"))
			pBalanceReport->pRevenues = ReadSectionBalanceTotal(pStructDocTop, pBalanceReport, pXmlTagData, "Revenues");		// rac:BalanceTotalType
		else if(!strcmp(pXmlTagData->pTag, "Supplies"))
			pBalanceReport->pSupplies = ReadSectionBalanceTotal(pStructDocTop, pBalanceReport, pXmlTagData, "Supplies");		// rac:BalanceTotalType
		else if(!strcmp(pXmlTagData->pTag, "Profit"))
			pBalanceReport->pProfit = ReadSectionBalanceTotal(pStructDocTop, pBalanceReport, pXmlTagData, "Profit");		// rac:BalanceTotalType
		else if(!strcmp(pXmlTagData->pTag, "Expenses"))
			pBalanceReport->pExpenses = ReadSectionBalanceTotal(pStructDocTop, pBalanceReport, pXmlTagData, "Expenses");		// rac:BalanceTotalType
		else if(!strcmp(pXmlTagData->pTag, "Staff"))
			pBalanceReport->pStaff = ReadSectionBalanceTotal(pStructDocTop, pBalanceReport, pXmlTagData, "Staff");		// rac:BalanceTotalType
		else if(!strcmp(pXmlTagData->pTag, "Earning"))
			pBalanceReport->pEarning = ReadSectionBalanceTotal(pStructDocTop, pBalanceReport, pXmlTagData, "Earning");		// rac:BalanceTotalType
		else if(!strcmp(pXmlTagData->pTag, "LossGains"))
			pBalanceReport->pLossGains = ReadSectionBalanceTotal(pStructDocTop, pBalanceReport, pXmlTagData, "LossGains");		// rac:BalanceTotalType
		else if(!strcmp(pXmlTagData->pTag, "Financial"))
			pBalanceReport->pFinancial = ReadSectionBalanceTotal(pStructDocTop, pBalanceReport, pXmlTagData, "Financial");		// rac:BalanceTotalType
		else if(!strcmp(pXmlTagData->pTag, "Outcome"))
			pBalanceReport->pOutcome = ReadSectionBalanceTotal(pStructDocTop, pBalanceReport, pXmlTagData, "Outcome");		// rac:BalanceTotalType
		else if(!strcmp(pXmlTagData->pTag, "Auxiliary"))
			pBalanceReport->pAuxiliary = ReadSectionBalanceTotal(pStructDocTop, pBalanceReport, pXmlTagData, "Auxiliary");		// rac:BalanceTotalType
		else if(!strcmp(pXmlTagData->pTag, "Result"))
			pBalanceReport->pResult = ReadSectionBalanceTotal(pStructDocTop, pBalanceReport, pXmlTagData, "Result");		// rac:BalanceTotalType
		else if(!strcmp(pXmlTagData->pTag, "Total"))
			pBalanceReport->pTotal = ReadSectionBalanceTotal(pStructDocTop, pBalanceReport, pXmlTagData, "Total");		// rac:BalanceTotalType
		else if(!strcmp(pXmlTagData->pTag, "BalanceAccount"))
			LListAddRecord(pBalanceReport->pListBalanceAccount, ReadSectionBalanceAccount(pStructDocTop, pBalanceReport, pXmlTagData, "BalanceAccount"));		// rac:BalanceAccountType

		pXmlTagData=GetNextXmlTag(pXmlTagData);

		if(!pXmlTagData)
			return 0;	// Fatal error
	}
	return pBalanceReport;
}


/*********************************************************************

static BOOL WriteSectionBalanceReport(

*********************************************************************/
static BOOL WriteSectionBalanceReport(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	BalanceReportType *pBalanceReport)
{
	if(!pBalanceReport)
		return FALSE;	// Fatal error

	xmlWriteLine(pStream, iTab-1, pAttr, pLabel, 0, 0);

	if(pBalanceReport->pObject && IsDataObject(pBalanceReport->pObject) && pBalanceReport->pObject->pDimension && pBalanceReport->pObject->pDimension->Id)		// Optional
		WriteSectionObject(pStream, iTab+1, "Object", 0, pBalanceReport->pObject, TRUE);		// rac:ObjectType

	if(pBalanceReport->pTangible && IsDataBalanceTotal(pBalanceReport->pTangible))		// Optional
		WriteSectionBalanceTotal(pStream, iTab+1, "Tangible", 0, pBalanceReport->pTangible);		// rac:BalanceTotalType

	if(pBalanceReport->pStock && IsDataBalanceTotal(pBalanceReport->pStock))		// Optional
		WriteSectionBalanceTotal(pStream, iTab+1, "Stock", 0, pBalanceReport->pStock);		// rac:BalanceTotalType

	if(pBalanceReport->pReceivables && IsDataBalanceTotal(pBalanceReport->pReceivables))		// Optional
		WriteSectionBalanceTotal(pStream, iTab+1, "Receivables", 0, pBalanceReport->pReceivables);		// rac:BalanceTotalType

	if(pBalanceReport->pAssets && IsDataBalanceTotal(pBalanceReport->pAssets))		// Optional
		WriteSectionBalanceTotal(pStream, iTab+1, "Assets", 0, pBalanceReport->pAssets);		// rac:BalanceTotalType

	if(pBalanceReport->pActive && IsDataBalanceTotal(pBalanceReport->pActive))		// Optional
		WriteSectionBalanceTotal(pStream, iTab+1, "Active", 0, pBalanceReport->pActive);		// rac:BalanceTotalType

	if(pBalanceReport->pEquities && IsDataBalanceTotal(pBalanceReport->pEquities))		// Optional
		WriteSectionBalanceTotal(pStream, iTab+1, "Equities", 0, pBalanceReport->pEquities);		// rac:BalanceTotalType

	if(pBalanceReport->pProvisions && IsDataBalanceTotal(pBalanceReport->pProvisions))		// Optional
		WriteSectionBalanceTotal(pStream, iTab+1, "Provisions", 0, pBalanceReport->pProvisions);		// rac:BalanceTotalType

	if(pBalanceReport->pLiabilities && IsDataBalanceTotal(pBalanceReport->pLiabilities))		// Optional
		WriteSectionBalanceTotal(pStream, iTab+1, "Liabilities", 0, pBalanceReport->pLiabilities);		// rac:BalanceTotalType

	if(pBalanceReport->pPassive && IsDataBalanceTotal(pBalanceReport->pPassive))		// Optional
		WriteSectionBalanceTotal(pStream, iTab+1, "Passive", 0, pBalanceReport->pPassive);		// rac:BalanceTotalType

	if(pBalanceReport->pBalance && IsDataBalanceTotal(pBalanceReport->pBalance))		// Optional
		WriteSectionBalanceTotal(pStream, iTab+1, "Balance", 0, pBalanceReport->pBalance);		// rac:BalanceTotalType

	if(pBalanceReport->pRevenues && IsDataBalanceTotal(pBalanceReport->pRevenues))		// Optional
		WriteSectionBalanceTotal(pStream, iTab+1, "Revenues", 0, pBalanceReport->pRevenues);		// rac:BalanceTotalType

	if(pBalanceReport->pSupplies && IsDataBalanceTotal(pBalanceReport->pSupplies))		// Optional
		WriteSectionBalanceTotal(pStream, iTab+1, "Supplies", 0, pBalanceReport->pSupplies);		// rac:BalanceTotalType

	if(pBalanceReport->pProfit && IsDataBalanceTotal(pBalanceReport->pProfit))		// Optional
		WriteSectionBalanceTotal(pStream, iTab+1, "Profit", 0, pBalanceReport->pProfit);		// rac:BalanceTotalType

	if(pBalanceReport->pExpenses && IsDataBalanceTotal(pBalanceReport->pExpenses))		// Optional
		WriteSectionBalanceTotal(pStream, iTab+1, "Expenses", 0, pBalanceReport->pExpenses);		// rac:BalanceTotalType

	if(pBalanceReport->pStaff && IsDataBalanceTotal(pBalanceReport->pStaff))		// Optional
		WriteSectionBalanceTotal(pStream, iTab+1, "Staff", 0, pBalanceReport->pStaff);		// rac:BalanceTotalType

	if(pBalanceReport->pEarning && IsDataBalanceTotal(pBalanceReport->pEarning))		// Optional
		WriteSectionBalanceTotal(pStream, iTab+1, "Earning", 0, pBalanceReport->pEarning);		// rac:BalanceTotalType

	if(pBalanceReport->pLossGains && IsDataBalanceTotal(pBalanceReport->pLossGains))		// Optional
		WriteSectionBalanceTotal(pStream, iTab+1, "LossGains", 0, pBalanceReport->pLossGains);		// rac:BalanceTotalType

	if(pBalanceReport->pFinancial && IsDataBalanceTotal(pBalanceReport->pFinancial))		// Optional
		WriteSectionBalanceTotal(pStream, iTab+1, "Financial", 0, pBalanceReport->pFinancial);		// rac:BalanceTotalType

	if(pBalanceReport->pOutcome && IsDataBalanceTotal(pBalanceReport->pOutcome))		// Optional
		WriteSectionBalanceTotal(pStream, iTab+1, "Outcome", 0, pBalanceReport->pOutcome);		// rac:BalanceTotalType

	if(pBalanceReport->pAuxiliary && IsDataBalanceTotal(pBalanceReport->pAuxiliary))		// Optional
		WriteSectionBalanceTotal(pStream, iTab+1, "Auxiliary", 0, pBalanceReport->pAuxiliary);		// rac:BalanceTotalType

	if(pBalanceReport->pResult && IsDataBalanceTotal(pBalanceReport->pResult))		// Optional
		WriteSectionBalanceTotal(pStream, iTab+1, "Result", 0, pBalanceReport->pResult);		// rac:BalanceTotalType

	if(pBalanceReport->pTotal && IsDataBalanceTotal(pBalanceReport->pTotal))		// Optional
		WriteSectionBalanceTotal(pStream, iTab+1, "Total", 0, pBalanceReport->pTotal);		// rac:BalanceTotalType

	if(pBalanceReport->pListBalanceAccount) {
		BalanceAccountType *pBalanceAccount
			= LListGetFirstRecordData(pBalanceReport->pListBalanceAccount);
		while(pBalanceAccount) {
			if(IsDataBalanceAccount(pBalanceAccount))
				WriteSectionBalanceAccount(pStream, iTab+1, "BalanceAccount", 0, pBalanceAccount);		// rac:BalanceAccountType
			pBalanceAccount = LListGetNextRecordData(pBalanceReport->pListBalanceAccount);
		}
	}

	xmlWriteLine(pStream, iTab-1, 0, 0, 0, pLabel);

	return TRUE;
}


/*********************************************************************

BalanceReportType *UpdateBalanceReport(

*********************************************************************/
BalanceReportType *UpdateBalanceReport(
	BalanceReportType *pStructBalanceReport)
{

	return pStructBalanceReport;
}


/*********************************************************************

char **GetLeadTextBalanceReport(

*********************************************************************/
char **GetLeadTextBalanceReport(
	char *pLang)
{
static char *szTexts[] = {
	"Object",
	"Tangible",
	"Stock",
	"Receivables",
	"Assets",
	"Active",
	"Equities",
	"Provisions",
	"Liabilities",
	"Passive",
	"Balance",
	"Revenues",
	"Supplies",
	"Profit",
	"Expenses",
	"Staff",
	"Earning",
	"Loss Gains",
	"Financial",
	"Outcome",
	"Auxiliary",
	"Result",
	"Total",
	"Balance Account"};

	return szTexts;
}


/*********************************************************************

	BalanceTotal

*********************************************************************

BalanceTotalType *CreateBalanceTotal(

*********************************************************************/
BalanceTotalType *CreateBalanceTotal(
	void *pStructDocTop, 
	void *pStructParent)
{
BalanceTotalType *pBalanceTotal = calloc(1, sizeof(BalanceTotalType));

	if(!pBalanceTotal)
		return 0;	// Fatal error

	pBalanceTotal->DataType    = SCT_BALANCETOTAL;
	pBalanceTotal->pStructDocTop = pStructDocTop;
	pBalanceTotal->pStructParent = pStructParent;

	pBalanceTotal->pListMonth = LListInit();
	pBalanceTotal->pListQuarter = LListInit();
	pBalanceTotal->pListTertial = LListInit();
	pBalanceTotal->pListSemi = LListInit();
	pBalanceTotal->pListAnnual = LListInit();

	return pBalanceTotal;
}


/*********************************************************************

BalanceTotalType *DestroyBalanceTotal(

*********************************************************************/
BalanceTotalType *DestroyBalanceTotal(
	BalanceTotalType **ppBalanceTotal)
{
	if(!*ppBalanceTotal)
		return 0;	// Nothing to destroy

	{
		BalanceTotalPeriodType *pMonth
			= LListGetFirstRecordData((*ppBalanceTotal)->pListMonth);
		while(pMonth) {
			DestroyBalanceTotalPeriod(&pMonth);		// rac:BalanceTotalPeriodType
			pMonth = LListGetNextRecordData((*ppBalanceTotal)->pListMonth);
		}
		LListErase((*ppBalanceTotal)->pListMonth);
	}
	{
		BalanceTotalPeriodType *pQuarter
			= LListGetFirstRecordData((*ppBalanceTotal)->pListQuarter);
		while(pQuarter) {
			DestroyBalanceTotalPeriod(&pQuarter);		// rac:BalanceTotalPeriodType
			pQuarter = LListGetNextRecordData((*ppBalanceTotal)->pListQuarter);
		}
		LListErase((*ppBalanceTotal)->pListQuarter);
	}
	{
		BalanceTotalPeriodType *pTertial
			= LListGetFirstRecordData((*ppBalanceTotal)->pListTertial);
		while(pTertial) {
			DestroyBalanceTotalPeriod(&pTertial);		// rac:BalanceTotalPeriodType
			pTertial = LListGetNextRecordData((*ppBalanceTotal)->pListTertial);
		}
		LListErase((*ppBalanceTotal)->pListTertial);
	}
	{
		BalanceTotalPeriodType *pSemi
			= LListGetFirstRecordData((*ppBalanceTotal)->pListSemi);
		while(pSemi) {
			DestroyBalanceTotalPeriod(&pSemi);		// rac:BalanceTotalPeriodType
			pSemi = LListGetNextRecordData((*ppBalanceTotal)->pListSemi);
		}
		LListErase((*ppBalanceTotal)->pListSemi);
	}
	{
		BalanceTotalPeriodType *pAnnual
			= LListGetFirstRecordData((*ppBalanceTotal)->pListAnnual);
		while(pAnnual) {
			DestroyBalanceTotalPeriod(&pAnnual);		// rac:BalanceTotalPeriodType
			pAnnual = LListGetNextRecordData((*ppBalanceTotal)->pListAnnual);
		}
		LListErase((*ppBalanceTotal)->pListAnnual);
	}

	free(*ppBalanceTotal);
	*ppBalanceTotal = 0;

	return 0;
}


/*********************************************************************

BalanceTotalType *CopyBalanceTotal(

*********************************************************************/
BalanceTotalType *CopyBalanceTotal(
	void *pStructDocTop, 
	void *pStructParent, 
	BalanceTotalType *pBalanceTotal)
{
	if(pBalanceTotal) {
		BalanceTotalType *pNewBalanceTotal = CreateBalanceTotal(pStructDocTop, pStructParent);

		if(!pNewBalanceTotal)
			return 0;	// Fatal error

		pNewBalanceTotal->Opening = pBalanceTotal->Opening;		// rac:Amount
		pNewBalanceTotal->Forward = pBalanceTotal->Forward;		// rac:Amount
		{
			BalanceTotalPeriodType *pMonth
				= LListGetFirstRecordData(pBalanceTotal->pListMonth);
			while(pMonth) {
				LListAddRecord(pNewBalanceTotal->pListMonth, CopyBalanceTotalPeriod(pStructDocTop, pNewBalanceTotal, pMonth));		// rac:BalanceTotalPeriodType
				pMonth = LListGetNextRecordData(pBalanceTotal->pListMonth);
			}
		}
		{
			BalanceTotalPeriodType *pQuarter
				= LListGetFirstRecordData(pBalanceTotal->pListQuarter);
			while(pQuarter) {
				LListAddRecord(pNewBalanceTotal->pListQuarter, CopyBalanceTotalPeriod(pStructDocTop, pNewBalanceTotal, pQuarter));		// rac:BalanceTotalPeriodType
				pQuarter = LListGetNextRecordData(pBalanceTotal->pListQuarter);
			}
		}
		{
			BalanceTotalPeriodType *pTertial
				= LListGetFirstRecordData(pBalanceTotal->pListTertial);
			while(pTertial) {
				LListAddRecord(pNewBalanceTotal->pListTertial, CopyBalanceTotalPeriod(pStructDocTop, pNewBalanceTotal, pTertial));		// rac:BalanceTotalPeriodType
				pTertial = LListGetNextRecordData(pBalanceTotal->pListTertial);
			}
		}
		{
			BalanceTotalPeriodType *pSemi
				= LListGetFirstRecordData(pBalanceTotal->pListSemi);
			while(pSemi) {
				LListAddRecord(pNewBalanceTotal->pListSemi, CopyBalanceTotalPeriod(pStructDocTop, pNewBalanceTotal, pSemi));		// rac:BalanceTotalPeriodType
				pSemi = LListGetNextRecordData(pBalanceTotal->pListSemi);
			}
		}
		{
			BalanceTotalPeriodType *pAnnual
				= LListGetFirstRecordData(pBalanceTotal->pListAnnual);
			while(pAnnual) {
				LListAddRecord(pNewBalanceTotal->pListAnnual, CopyBalanceTotalPeriod(pStructDocTop, pNewBalanceTotal, pAnnual));		// rac:BalanceTotalPeriodType
				pAnnual = LListGetNextRecordData(pBalanceTotal->pListAnnual);
			}
		}

		return (pNewBalanceTotal);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataBalanceTotal(

*********************************************************************/
BOOL IsDataBalanceTotal(
	BalanceTotalType *pBalanceTotal)
{
	if(!pBalanceTotal)
		return FALSE;

	if(pBalanceTotal->Opening)
		return TRUE;
	if(pBalanceTotal->Forward)
		return TRUE;
	{
		BalanceTotalPeriodType *pMonth
			= LListGetFirstRecordData(pBalanceTotal->pListMonth);
		while(pMonth) {
			if(IsDataBalanceTotalPeriod(pMonth))
				return TRUE;
			pMonth = LListGetNextRecordData(pBalanceTotal->pListMonth);
		}
	}
	{
		BalanceTotalPeriodType *pQuarter
			= LListGetFirstRecordData(pBalanceTotal->pListQuarter);
		while(pQuarter) {
			if(IsDataBalanceTotalPeriod(pQuarter))
				return TRUE;
			pQuarter = LListGetNextRecordData(pBalanceTotal->pListQuarter);
		}
	}
	{
		BalanceTotalPeriodType *pTertial
			= LListGetFirstRecordData(pBalanceTotal->pListTertial);
		while(pTertial) {
			if(IsDataBalanceTotalPeriod(pTertial))
				return TRUE;
			pTertial = LListGetNextRecordData(pBalanceTotal->pListTertial);
		}
	}
	{
		BalanceTotalPeriodType *pSemi
			= LListGetFirstRecordData(pBalanceTotal->pListSemi);
		while(pSemi) {
			if(IsDataBalanceTotalPeriod(pSemi))
				return TRUE;
			pSemi = LListGetNextRecordData(pBalanceTotal->pListSemi);
		}
	}
	{
		BalanceTotalPeriodType *pAnnual
			= LListGetFirstRecordData(pBalanceTotal->pListAnnual);
		while(pAnnual) {
			if(IsDataBalanceTotalPeriod(pAnnual))
				return TRUE;
			pAnnual = LListGetNextRecordData(pBalanceTotal->pListAnnual);
		}
	}

	return FALSE;
}


/*********************************************************************

static BalanceTotalType *ReadSectionBalanceTotal(

*********************************************************************/
static BalanceTotalType *ReadSectionBalanceTotal(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
BalanceTotalType *pBalanceTotal = CreateBalanceTotal(pStructDocTop, pStructParent);

	if(!pBalanceTotal)
		return 0;	// Fatal error

	pXmlTagData=GetNextXmlTag(pXmlTagData);

	if(!pXmlTagData)
		return 0;	// Fatal error

	while(strcmp(pXmlTagData->pTag, pEndTag)) { // While is not the end
		if(!strcmp(pXmlTagData->pTag, "Opening"))
			pBalanceTotal->Opening = StringToAmount(pXmlTagData->pData);		// rac:Amount
		else if(!strcmp(pXmlTagData->pTag, "Forward"))
			pBalanceTotal->Forward = StringToAmount(pXmlTagData->pData);		// rac:Amount
		else if(!strcmp(pXmlTagData->pTag, "Month"))
			LListAddRecord(pBalanceTotal->pListMonth, ReadSectionBalanceTotalPeriod(pStructDocTop, pBalanceTotal, pXmlTagData, "Month"));		// rac:BalanceTotalPeriodType
		else if(!strcmp(pXmlTagData->pTag, "Quarter"))
			LListAddRecord(pBalanceTotal->pListQuarter, ReadSectionBalanceTotalPeriod(pStructDocTop, pBalanceTotal, pXmlTagData, "Quarter"));		// rac:BalanceTotalPeriodType
		else if(!strcmp(pXmlTagData->pTag, "Tertial"))
			LListAddRecord(pBalanceTotal->pListTertial, ReadSectionBalanceTotalPeriod(pStructDocTop, pBalanceTotal, pXmlTagData, "Tertial"));		// rac:BalanceTotalPeriodType
		else if(!strcmp(pXmlTagData->pTag, "Semi"))
			LListAddRecord(pBalanceTotal->pListSemi, ReadSectionBalanceTotalPeriod(pStructDocTop, pBalanceTotal, pXmlTagData, "Semi"));		// rac:BalanceTotalPeriodType
		else if(!strcmp(pXmlTagData->pTag, "Annual"))
			LListAddRecord(pBalanceTotal->pListAnnual, ReadSectionBalanceTotalPeriod(pStructDocTop, pBalanceTotal, pXmlTagData, "Annual"));		// rac:BalanceTotalPeriodType

		pXmlTagData=GetNextXmlTag(pXmlTagData);

		if(!pXmlTagData)
			return 0;	// Fatal error
	}
	return pBalanceTotal;
}


/*********************************************************************

static BOOL WriteSectionBalanceTotal(

*********************************************************************/
static BOOL WriteSectionBalanceTotal(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	BalanceTotalType *pBalanceTotal)
{
	if(!pBalanceTotal)
		return FALSE;	// Fatal error

	xmlWriteLine(pStream, iTab-1, pAttr, pLabel, 0, 0);
	if(pBalanceTotal->Opening)
		xmlWriteLine(pStream, iTab, 0, "Opening", AmountToStr(pBalanceTotal->Opening, szString),"Opening");		// rac:Amount
	if(pBalanceTotal->Forward)
		xmlWriteLine(pStream, iTab, 0, "Forward", AmountToStr(pBalanceTotal->Forward, szString),"Forward");		// rac:Amount

	if(pBalanceTotal->pListMonth) {
		BalanceTotalPeriodType *pMonth
			= LListGetFirstRecordData(pBalanceTotal->pListMonth);
		while(pMonth) {
			if(IsDataBalanceTotalPeriod(pMonth))
				WriteSectionBalanceTotalPeriod(pStream, iTab+1, "Month", 0, pMonth);		// rac:BalanceTotalPeriodType
			pMonth = LListGetNextRecordData(pBalanceTotal->pListMonth);
		}
	}

	if(pBalanceTotal->pListQuarter) {
		BalanceTotalPeriodType *pQuarter
			= LListGetFirstRecordData(pBalanceTotal->pListQuarter);
		while(pQuarter) {
			if(IsDataBalanceTotalPeriod(pQuarter))
				WriteSectionBalanceTotalPeriod(pStream, iTab+1, "Quarter", 0, pQuarter);		// rac:BalanceTotalPeriodType
			pQuarter = LListGetNextRecordData(pBalanceTotal->pListQuarter);
		}
	}

	if(pBalanceTotal->pListTertial) {
		BalanceTotalPeriodType *pTertial
			= LListGetFirstRecordData(pBalanceTotal->pListTertial);
		while(pTertial) {
			if(IsDataBalanceTotalPeriod(pTertial))
				WriteSectionBalanceTotalPeriod(pStream, iTab+1, "Tertial", 0, pTertial);		// rac:BalanceTotalPeriodType
			pTertial = LListGetNextRecordData(pBalanceTotal->pListTertial);
		}
	}

	if(pBalanceTotal->pListSemi) {
		BalanceTotalPeriodType *pSemi
			= LListGetFirstRecordData(pBalanceTotal->pListSemi);
		while(pSemi) {
			if(IsDataBalanceTotalPeriod(pSemi))
				WriteSectionBalanceTotalPeriod(pStream, iTab+1, "Semi", 0, pSemi);		// rac:BalanceTotalPeriodType
			pSemi = LListGetNextRecordData(pBalanceTotal->pListSemi);
		}
	}

	if(pBalanceTotal->pListAnnual) {
		BalanceTotalPeriodType *pAnnual
			= LListGetFirstRecordData(pBalanceTotal->pListAnnual);
		while(pAnnual) {
			if(IsDataBalanceTotalPeriod(pAnnual))
				WriteSectionBalanceTotalPeriod(pStream, iTab+1, "Annual", 0, pAnnual);		// rac:BalanceTotalPeriodType
			pAnnual = LListGetNextRecordData(pBalanceTotal->pListAnnual);
		}
	}

	xmlWriteLine(pStream, iTab-1, 0, 0, 0, pLabel);

	return TRUE;
}


/*********************************************************************

BalanceTotalType *UpdateBalanceTotal(

*********************************************************************/
BalanceTotalType *UpdateBalanceTotal(
	BalanceTotalType *pStructBalanceTotal, 
	AMOUNT Opening, 
	AMOUNT Forward)
{
	pStructBalanceTotal->Opening = Opening;
	pStructBalanceTotal->Forward = Forward;

	return pStructBalanceTotal;
}


/*********************************************************************

char **GetLeadTextBalanceTotal(

*********************************************************************/
char **GetLeadTextBalanceTotal(
	char *pLang)
{
static char *szTexts[] = {
	"Opening",
	"Forward",
	"Month",
	"Quarter",
	"Tertial",
	"Semi",
	"Annual"};

	return szTexts;
}


/*********************************************************************

	BalanceTotalPeriod

*********************************************************************

BalanceTotalPeriodType *CreateBalanceTotalPeriod(

*********************************************************************/
BalanceTotalPeriodType *CreateBalanceTotalPeriod(
	void *pStructDocTop, 
	void *pStructParent)
{
BalanceTotalPeriodType *pBalanceTotalPeriod = calloc(1, sizeof(BalanceTotalPeriodType));

	if(!pBalanceTotalPeriod)
		return 0;	// Fatal error

	pBalanceTotalPeriod->DataType    = SCT_BALANCETOTALPERIOD;
	pBalanceTotalPeriod->pStructDocTop = pStructDocTop;
	pBalanceTotalPeriod->pStructParent = pStructParent;


	return pBalanceTotalPeriod;
}


/*********************************************************************

BalanceTotalPeriodType *DestroyBalanceTotalPeriod(

*********************************************************************/
BalanceTotalPeriodType *DestroyBalanceTotalPeriod(
	BalanceTotalPeriodType **ppBalanceTotalPeriod)
{
	if(!*ppBalanceTotalPeriod)
		return 0;	// Nothing to destroy


	free(*ppBalanceTotalPeriod);
	*ppBalanceTotalPeriod = 0;

	return 0;
}


/*********************************************************************

BalanceTotalPeriodType *CopyBalanceTotalPeriod(

*********************************************************************/
BalanceTotalPeriodType *CopyBalanceTotalPeriod(
	void *pStructDocTop, 
	void *pStructParent, 
	BalanceTotalPeriodType *pBalanceTotalPeriod)
{
	if(pBalanceTotalPeriod) {
		BalanceTotalPeriodType *pNewBalanceTotalPeriod = CreateBalanceTotalPeriod(pStructDocTop, pStructParent);

		if(!pNewBalanceTotalPeriod)
			return 0;	// Fatal error

		pNewBalanceTotalPeriod->End = pBalanceTotalPeriod->End;		// xs:date
		pNewBalanceTotalPeriod->Outcome = pBalanceTotalPeriod->Outcome;		// rac:Amount
		pNewBalanceTotalPeriod->Budget = pBalanceTotalPeriod->Budget;		// rac:Amount

		return (pNewBalanceTotalPeriod);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataBalanceTotalPeriod(

*********************************************************************/
BOOL IsDataBalanceTotalPeriod(
	BalanceTotalPeriodType *pBalanceTotalPeriod)
{
	if(!pBalanceTotalPeriod)
		return FALSE;

	if(pBalanceTotalPeriod->Outcome)
		return TRUE;
	if(pBalanceTotalPeriod->Budget)
		return TRUE;

	return FALSE;
}


/*********************************************************************

static BalanceTotalPeriodType *ReadSectionBalanceTotalPeriod(

*********************************************************************/
static BalanceTotalPeriodType *ReadSectionBalanceTotalPeriod(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
BalanceTotalPeriodType *pBalanceTotalPeriod = CreateBalanceTotalPeriod(pStructDocTop, pStructParent);

	if(!pBalanceTotalPeriod)
		return 0;	// Fatal error

	pXmlTagData=GetNextXmlTag(pXmlTagData);

	if(!pXmlTagData)
		return 0;	// Fatal error

	while(strcmp(pXmlTagData->pTag, pEndTag)) { // While is not the end
		if(!strcmp(pXmlTagData->pTag, "End"))
			pBalanceTotalPeriod->End = StringToDate(pXmlTagData->pData);		// xs:date
		else if(!strcmp(pXmlTagData->pTag, "Outcome"))
			pBalanceTotalPeriod->Outcome = StringToAmount(pXmlTagData->pData);		// rac:Amount
		else if(!strcmp(pXmlTagData->pTag, "Budget"))
			pBalanceTotalPeriod->Budget = StringToAmount(pXmlTagData->pData);		// rac:Amount

		pXmlTagData=GetNextXmlTag(pXmlTagData);

		if(!pXmlTagData)
			return 0;	// Fatal error
	}
	return pBalanceTotalPeriod;
}


/*********************************************************************

static BOOL WriteSectionBalanceTotalPeriod(

*********************************************************************/
static BOOL WriteSectionBalanceTotalPeriod(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	BalanceTotalPeriodType *pBalanceTotalPeriod)
{
	if(!pBalanceTotalPeriod)
		return FALSE;	// Fatal error

	xmlWriteLine(pStream, iTab-1, pAttr, pLabel, 0, 0);
	xmlWriteLine(pStream, iTab, 0, "End", DateToStr(pBalanceTotalPeriod->End, szString),"End");		// xs:date - Mandatory
	if(pBalanceTotalPeriod->Outcome)
		xmlWriteLine(pStream, iTab, 0, "Outcome", AmountToStr(pBalanceTotalPeriod->Outcome, szString),"Outcome");		// rac:Amount
	if(pBalanceTotalPeriod->Budget)
		xmlWriteLine(pStream, iTab, 0, "Budget", AmountToStr(pBalanceTotalPeriod->Budget, szString),"Budget");		// rac:Amount

	xmlWriteLine(pStream, iTab-1, 0, 0, 0, pLabel);

	return TRUE;
}


/*********************************************************************

BalanceTotalPeriodType *UpdateBalanceTotalPeriod(

*********************************************************************/
BalanceTotalPeriodType *UpdateBalanceTotalPeriod(
	BalanceTotalPeriodType *pStructBalanceTotalPeriod, 
	DATEINT End, 
	AMOUNT Outcome, 
	AMOUNT Budget)
{
	pStructBalanceTotalPeriod->End = End;
	pStructBalanceTotalPeriod->Outcome = Outcome;
	pStructBalanceTotalPeriod->Budget = Budget;

	return pStructBalanceTotalPeriod;
}


/*********************************************************************

char **GetLeadTextBalanceTotalPeriod(

*********************************************************************/
char **GetLeadTextBalanceTotalPeriod(
	char *pLang)
{
static char *szTexts[] = {
	"End",
	"Outcome",
	"Budget"};

	return szTexts;
}


/*********************************************************************

	BalanceAccount

*********************************************************************

BalanceAccountType *CreateBalanceAccount(

*********************************************************************/
BalanceAccountType *CreateBalanceAccount(
	void *pStructDocTop, 
	void *pStructParent)
{
BalanceAccountType *pBalanceAccount = calloc(1, sizeof(BalanceAccountType));

	if(!pBalanceAccount)
		return 0;	// Fatal error

	pBalanceAccount->DataType    = SCT_BALANCEACCOUNT;
	pBalanceAccount->pStructDocTop = pStructDocTop;
	pBalanceAccount->pStructParent = pStructParent;

	pBalanceAccount->pListMonth = LListInit();
	pBalanceAccount->pListQuarter = LListInit();
	pBalanceAccount->pListTertial = LListInit();
	pBalanceAccount->pListSemi = LListInit();
	pBalanceAccount->pListAnnual = LListInit();

	return pBalanceAccount;
}


/*********************************************************************

BalanceAccountType *DestroyBalanceAccount(

*********************************************************************/
BalanceAccountType *DestroyBalanceAccount(
	BalanceAccountType **ppBalanceAccount)
{
	if(!*ppBalanceAccount)
		return 0;	// Nothing to destroy

	// For 3d data - DestroyAccount(&(*ppBalanceAccount)->pAccount);		// rac:AccountType
	{
		BalanceAccountPeriodType *pMonth
			= LListGetFirstRecordData((*ppBalanceAccount)->pListMonth);
		while(pMonth) {
			DestroyBalanceAccountPeriod(&pMonth);		// rac:BalanceAccountPeriodType
			pMonth = LListGetNextRecordData((*ppBalanceAccount)->pListMonth);
		}
		LListErase((*ppBalanceAccount)->pListMonth);
	}
	{
		BalanceAccountPeriodType *pQuarter
			= LListGetFirstRecordData((*ppBalanceAccount)->pListQuarter);
		while(pQuarter) {
			DestroyBalanceAccountPeriod(&pQuarter);		// rac:BalanceAccountPeriodType
			pQuarter = LListGetNextRecordData((*ppBalanceAccount)->pListQuarter);
		}
		LListErase((*ppBalanceAccount)->pListQuarter);
	}
	{
		BalanceAccountPeriodType *pTertial
			= LListGetFirstRecordData((*ppBalanceAccount)->pListTertial);
		while(pTertial) {
			DestroyBalanceAccountPeriod(&pTertial);		// rac:BalanceAccountPeriodType
			pTertial = LListGetNextRecordData((*ppBalanceAccount)->pListTertial);
		}
		LListErase((*ppBalanceAccount)->pListTertial);
	}
	{
		BalanceAccountPeriodType *pSemi
			= LListGetFirstRecordData((*ppBalanceAccount)->pListSemi);
		while(pSemi) {
			DestroyBalanceAccountPeriod(&pSemi);		// rac:BalanceAccountPeriodType
			pSemi = LListGetNextRecordData((*ppBalanceAccount)->pListSemi);
		}
		LListErase((*ppBalanceAccount)->pListSemi);
	}
	{
		BalanceAccountPeriodType *pAnnual
			= LListGetFirstRecordData((*ppBalanceAccount)->pListAnnual);
		while(pAnnual) {
			DestroyBalanceAccountPeriod(&pAnnual);		// rac:BalanceAccountPeriodType
			pAnnual = LListGetNextRecordData((*ppBalanceAccount)->pListAnnual);
		}
		LListErase((*ppBalanceAccount)->pListAnnual);
	}

	free(*ppBalanceAccount);
	*ppBalanceAccount = 0;

	return 0;
}


/*********************************************************************

BalanceAccountType *CopyBalanceAccount(

*********************************************************************/
BalanceAccountType *CopyBalanceAccount(
	void *pStructDocTop, 
	void *pStructParent, 
	BalanceAccountType *pBalanceAccount)
{
	if(pBalanceAccount) {
		BalanceAccountType *pNewBalanceAccount = CreateBalanceAccount(pStructDocTop, pStructParent);

		if(!pNewBalanceAccount)
			return 0;	// Fatal error

		pNewBalanceAccount->pAccount = SearchSetAccount(((AccountingType *)pStructDocTop)->pAccountsChart->pListAccount, CopyAccount(pStructDocTop, pNewBalanceAccount, pBalanceAccount->pAccount));		// rac:AccountType
		pNewBalanceAccount->Opening = pBalanceAccount->Opening;		// rac:Amount
		pNewBalanceAccount->OpeningQuantity = pBalanceAccount->OpeningQuantity;		// xs:decimal
		pNewBalanceAccount->Forward = pBalanceAccount->Forward;		// rac:Amount
		pNewBalanceAccount->ForwardQuantity = pBalanceAccount->ForwardQuantity;		// xs:decimal
		{
			BalanceAccountPeriodType *pMonth
				= LListGetFirstRecordData(pBalanceAccount->pListMonth);
			while(pMonth) {
				LListAddRecord(pNewBalanceAccount->pListMonth, CopyBalanceAccountPeriod(pStructDocTop, pNewBalanceAccount, pMonth));		// rac:BalanceAccountPeriodType
				pMonth = LListGetNextRecordData(pBalanceAccount->pListMonth);
			}
		}
		{
			BalanceAccountPeriodType *pQuarter
				= LListGetFirstRecordData(pBalanceAccount->pListQuarter);
			while(pQuarter) {
				LListAddRecord(pNewBalanceAccount->pListQuarter, CopyBalanceAccountPeriod(pStructDocTop, pNewBalanceAccount, pQuarter));		// rac:BalanceAccountPeriodType
				pQuarter = LListGetNextRecordData(pBalanceAccount->pListQuarter);
			}
		}
		{
			BalanceAccountPeriodType *pTertial
				= LListGetFirstRecordData(pBalanceAccount->pListTertial);
			while(pTertial) {
				LListAddRecord(pNewBalanceAccount->pListTertial, CopyBalanceAccountPeriod(pStructDocTop, pNewBalanceAccount, pTertial));		// rac:BalanceAccountPeriodType
				pTertial = LListGetNextRecordData(pBalanceAccount->pListTertial);
			}
		}
		{
			BalanceAccountPeriodType *pSemi
				= LListGetFirstRecordData(pBalanceAccount->pListSemi);
			while(pSemi) {
				LListAddRecord(pNewBalanceAccount->pListSemi, CopyBalanceAccountPeriod(pStructDocTop, pNewBalanceAccount, pSemi));		// rac:BalanceAccountPeriodType
				pSemi = LListGetNextRecordData(pBalanceAccount->pListSemi);
			}
		}
		{
			BalanceAccountPeriodType *pAnnual
				= LListGetFirstRecordData(pBalanceAccount->pListAnnual);
			while(pAnnual) {
				LListAddRecord(pNewBalanceAccount->pListAnnual, CopyBalanceAccountPeriod(pStructDocTop, pNewBalanceAccount, pAnnual));		// rac:BalanceAccountPeriodType
				pAnnual = LListGetNextRecordData(pBalanceAccount->pListAnnual);
			}
		}

		return (pNewBalanceAccount);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataBalanceAccount(

*********************************************************************/
BOOL IsDataBalanceAccount(
	BalanceAccountType *pBalanceAccount)
{
	if(!pBalanceAccount)
		return FALSE;

	if(pBalanceAccount->Opening)
		return TRUE;
	if(!DecimalCmp(pBalanceAccount->OpeningQuantity, 0))
		return TRUE;
	if(pBalanceAccount->Forward)
		return TRUE;
	if(!DecimalCmp(pBalanceAccount->ForwardQuantity, 0))
		return TRUE;
	{
		BalanceAccountPeriodType *pMonth
			= LListGetFirstRecordData(pBalanceAccount->pListMonth);
		while(pMonth) {
			if(IsDataBalanceAccountPeriod(pMonth))
				return TRUE;
			pMonth = LListGetNextRecordData(pBalanceAccount->pListMonth);
		}
	}
	{
		BalanceAccountPeriodType *pQuarter
			= LListGetFirstRecordData(pBalanceAccount->pListQuarter);
		while(pQuarter) {
			if(IsDataBalanceAccountPeriod(pQuarter))
				return TRUE;
			pQuarter = LListGetNextRecordData(pBalanceAccount->pListQuarter);
		}
	}
	{
		BalanceAccountPeriodType *pTertial
			= LListGetFirstRecordData(pBalanceAccount->pListTertial);
		while(pTertial) {
			if(IsDataBalanceAccountPeriod(pTertial))
				return TRUE;
			pTertial = LListGetNextRecordData(pBalanceAccount->pListTertial);
		}
	}
	{
		BalanceAccountPeriodType *pSemi
			= LListGetFirstRecordData(pBalanceAccount->pListSemi);
		while(pSemi) {
			if(IsDataBalanceAccountPeriod(pSemi))
				return TRUE;
			pSemi = LListGetNextRecordData(pBalanceAccount->pListSemi);
		}
	}
	{
		BalanceAccountPeriodType *pAnnual
			= LListGetFirstRecordData(pBalanceAccount->pListAnnual);
		while(pAnnual) {
			if(IsDataBalanceAccountPeriod(pAnnual))
				return TRUE;
			pAnnual = LListGetNextRecordData(pBalanceAccount->pListAnnual);
		}
	}

	return FALSE;
}


/*********************************************************************

static BalanceAccountType *ReadSectionBalanceAccount(

*********************************************************************/
static BalanceAccountType *ReadSectionBalanceAccount(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
BalanceAccountType *pBalanceAccount = CreateBalanceAccount(pStructDocTop, pStructParent);

	if(!pBalanceAccount)
		return 0;	// Fatal error

	pXmlTagData=GetNextXmlTag(pXmlTagData);

	if(!pXmlTagData)
		return 0;	// Fatal error

	while(strcmp(pXmlTagData->pTag, pEndTag)) { // While is not the end
		if(!strcmp(pXmlTagData->pTag, "Account"))
			pBalanceAccount->pAccount = SearchSetAccount(((AccountingType *)pStructDocTop)->pAccountsChart->pListAccount, ReadSectionAccount(pStructDocTop, pBalanceAccount, pXmlTagData, "Account"));		// rac:AccountType
		else if(!strcmp(pXmlTagData->pTag, "Opening"))
			pBalanceAccount->Opening = StringToAmount(pXmlTagData->pData);		// rac:Amount
		else if(!strcmp(pXmlTagData->pTag, "OpeningQuantity"))
			pBalanceAccount->OpeningQuantity = StringToDecimal(pXmlTagData->pData);		// xs:decimal
		else if(!strcmp(pXmlTagData->pTag, "Forward"))
			pBalanceAccount->Forward = StringToAmount(pXmlTagData->pData);		// rac:Amount
		else if(!strcmp(pXmlTagData->pTag, "ForwardQuantity"))
			pBalanceAccount->ForwardQuantity = StringToDecimal(pXmlTagData->pData);		// xs:decimal
		else if(!strcmp(pXmlTagData->pTag, "Month"))
			LListAddRecord(pBalanceAccount->pListMonth, ReadSectionBalanceAccountPeriod(pStructDocTop, pBalanceAccount, pXmlTagData, "Month"));		// rac:BalanceAccountPeriodType
		else if(!strcmp(pXmlTagData->pTag, "Quarter"))
			LListAddRecord(pBalanceAccount->pListQuarter, ReadSectionBalanceAccountPeriod(pStructDocTop, pBalanceAccount, pXmlTagData, "Quarter"));		// rac:BalanceAccountPeriodType
		else if(!strcmp(pXmlTagData->pTag, "Tertial"))
			LListAddRecord(pBalanceAccount->pListTertial, ReadSectionBalanceAccountPeriod(pStructDocTop, pBalanceAccount, pXmlTagData, "Tertial"));		// rac:BalanceAccountPeriodType
		else if(!strcmp(pXmlTagData->pTag, "Semi"))
			LListAddRecord(pBalanceAccount->pListSemi, ReadSectionBalanceAccountPeriod(pStructDocTop, pBalanceAccount, pXmlTagData, "Semi"));		// rac:BalanceAccountPeriodType
		else if(!strcmp(pXmlTagData->pTag, "Annual"))
			LListAddRecord(pBalanceAccount->pListAnnual, ReadSectionBalanceAccountPeriod(pStructDocTop, pBalanceAccount, pXmlTagData, "Annual"));		// rac:BalanceAccountPeriodType

		pXmlTagData=GetNextXmlTag(pXmlTagData);

		if(!pXmlTagData)
			return 0;	// Fatal error
	}
	return pBalanceAccount;
}


/*********************************************************************

static BOOL WriteSectionBalanceAccount(

*********************************************************************/
static BOOL WriteSectionBalanceAccount(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	BalanceAccountType *pBalanceAccount)
{
	if(!pBalanceAccount)
		return FALSE;	// Fatal error

	xmlWriteLine(pStream, iTab-1, pAttr, pLabel, 0, 0);

	if(!pBalanceAccount->pAccount)		// Mandatory
		pBalanceAccount->pAccount = CreateAccount(pBalanceAccount->pStructDocTop, pBalanceAccount);
	WriteSectionAccount(pStream, iTab+1, "Account", 0, pBalanceAccount->pAccount, TRUE);		// rac:AccountType - Mandatory
	if(pBalanceAccount->Opening)
		xmlWriteLine(pStream, iTab, 0, "Opening", AmountToStr(pBalanceAccount->Opening, szString),"Opening");		// rac:Amount
	if(!DecimalCmp(pBalanceAccount->OpeningQuantity, 0))
		xmlWriteLine(pStream, iTab, 0, "OpeningQuantity", DecimalToStr(pBalanceAccount->OpeningQuantity, szString),"OpeningQuantity");		// xs:decimal
	if(pBalanceAccount->Forward)
		xmlWriteLine(pStream, iTab, 0, "Forward", AmountToStr(pBalanceAccount->Forward, szString),"Forward");		// rac:Amount
	if(!DecimalCmp(pBalanceAccount->ForwardQuantity, 0))
		xmlWriteLine(pStream, iTab, 0, "ForwardQuantity", DecimalToStr(pBalanceAccount->ForwardQuantity, szString),"ForwardQuantity");		// xs:decimal

	if(pBalanceAccount->pListMonth) {
		BalanceAccountPeriodType *pMonth
			= LListGetFirstRecordData(pBalanceAccount->pListMonth);
		while(pMonth) {
			if(IsDataBalanceAccountPeriod(pMonth))
				WriteSectionBalanceAccountPeriod(pStream, iTab+1, "Month", 0, pMonth);		// rac:BalanceAccountPeriodType
			pMonth = LListGetNextRecordData(pBalanceAccount->pListMonth);
		}
	}

	if(pBalanceAccount->pListQuarter) {
		BalanceAccountPeriodType *pQuarter
			= LListGetFirstRecordData(pBalanceAccount->pListQuarter);
		while(pQuarter) {
			if(IsDataBalanceAccountPeriod(pQuarter))
				WriteSectionBalanceAccountPeriod(pStream, iTab+1, "Quarter", 0, pQuarter);		// rac:BalanceAccountPeriodType
			pQuarter = LListGetNextRecordData(pBalanceAccount->pListQuarter);
		}
	}

	if(pBalanceAccount->pListTertial) {
		BalanceAccountPeriodType *pTertial
			= LListGetFirstRecordData(pBalanceAccount->pListTertial);
		while(pTertial) {
			if(IsDataBalanceAccountPeriod(pTertial))
				WriteSectionBalanceAccountPeriod(pStream, iTab+1, "Tertial", 0, pTertial);		// rac:BalanceAccountPeriodType
			pTertial = LListGetNextRecordData(pBalanceAccount->pListTertial);
		}
	}

	if(pBalanceAccount->pListSemi) {
		BalanceAccountPeriodType *pSemi
			= LListGetFirstRecordData(pBalanceAccount->pListSemi);
		while(pSemi) {
			if(IsDataBalanceAccountPeriod(pSemi))
				WriteSectionBalanceAccountPeriod(pStream, iTab+1, "Semi", 0, pSemi);		// rac:BalanceAccountPeriodType
			pSemi = LListGetNextRecordData(pBalanceAccount->pListSemi);
		}
	}

	if(pBalanceAccount->pListAnnual) {
		BalanceAccountPeriodType *pAnnual
			= LListGetFirstRecordData(pBalanceAccount->pListAnnual);
		while(pAnnual) {
			if(IsDataBalanceAccountPeriod(pAnnual))
				WriteSectionBalanceAccountPeriod(pStream, iTab+1, "Annual", 0, pAnnual);		// rac:BalanceAccountPeriodType
			pAnnual = LListGetNextRecordData(pBalanceAccount->pListAnnual);
		}
	}

	xmlWriteLine(pStream, iTab-1, 0, 0, 0, pLabel);

	return TRUE;
}


/*********************************************************************

BalanceAccountType *UpdateBalanceAccount(

*********************************************************************/
BalanceAccountType *UpdateBalanceAccount(
	BalanceAccountType *pStructBalanceAccount, 
	AMOUNT Opening, 
	QUANT OpeningQuantity, 
	AMOUNT Forward, 
	QUANT ForwardQuantity)
{
	pStructBalanceAccount->Opening = Opening;
	pStructBalanceAccount->OpeningQuantity = OpeningQuantity;
	pStructBalanceAccount->Forward = Forward;
	pStructBalanceAccount->ForwardQuantity = ForwardQuantity;

	return pStructBalanceAccount;
}


/*********************************************************************

char **GetLeadTextBalanceAccount(

*********************************************************************/
char **GetLeadTextBalanceAccount(
	char *pLang)
{
static char *szTexts[] = {
	"Account",
	"Opening",
	"Opening Quantity",
	"Forward",
	"Forward Quantity",
	"Month",
	"Quarter",
	"Tertial",
	"Semi",
	"Annual"};

	return szTexts;
}


/*********************************************************************

	BalanceAccountPeriod

*********************************************************************

BalanceAccountPeriodType *CreateBalanceAccountPeriod(

*********************************************************************/
BalanceAccountPeriodType *CreateBalanceAccountPeriod(
	void *pStructDocTop, 
	void *pStructParent)
{
BalanceAccountPeriodType *pBalanceAccountPeriod = calloc(1, sizeof(BalanceAccountPeriodType));

	if(!pBalanceAccountPeriod)
		return 0;	// Fatal error

	pBalanceAccountPeriod->DataType    = SCT_BALANCEACCOUNTPERIOD;
	pBalanceAccountPeriod->pStructDocTop = pStructDocTop;
	pBalanceAccountPeriod->pStructParent = pStructParent;


	return pBalanceAccountPeriod;
}


/*********************************************************************

BalanceAccountPeriodType *DestroyBalanceAccountPeriod(

*********************************************************************/
BalanceAccountPeriodType *DestroyBalanceAccountPeriod(
	BalanceAccountPeriodType **ppBalanceAccountPeriod)
{
	if(!*ppBalanceAccountPeriod)
		return 0;	// Nothing to destroy


	free(*ppBalanceAccountPeriod);
	*ppBalanceAccountPeriod = 0;

	return 0;
}


/*********************************************************************

BalanceAccountPeriodType *CopyBalanceAccountPeriod(

*********************************************************************/
BalanceAccountPeriodType *CopyBalanceAccountPeriod(
	void *pStructDocTop, 
	void *pStructParent, 
	BalanceAccountPeriodType *pBalanceAccountPeriod)
{
	if(pBalanceAccountPeriod) {
		BalanceAccountPeriodType *pNewBalanceAccountPeriod = CreateBalanceAccountPeriod(pStructDocTop, pStructParent);

		if(!pNewBalanceAccountPeriod)
			return 0;	// Fatal error

		pNewBalanceAccountPeriod->End = pBalanceAccountPeriod->End;		// xs:date
		pNewBalanceAccountPeriod->Outcome = pBalanceAccountPeriod->Outcome;		// rac:Amount
		pNewBalanceAccountPeriod->OutcomeQuantity = pBalanceAccountPeriod->OutcomeQuantity;		// xs:decimal
		pNewBalanceAccountPeriod->Budget = pBalanceAccountPeriod->Budget;		// rac:Amount
		pNewBalanceAccountPeriod->BudgetQuantity = pBalanceAccountPeriod->BudgetQuantity;		// xs:decimal

		return (pNewBalanceAccountPeriod);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataBalanceAccountPeriod(

*********************************************************************/
BOOL IsDataBalanceAccountPeriod(
	BalanceAccountPeriodType *pBalanceAccountPeriod)
{
	if(!pBalanceAccountPeriod)
		return FALSE;

	if(pBalanceAccountPeriod->Outcome)
		return TRUE;
	if(!DecimalCmp(pBalanceAccountPeriod->OutcomeQuantity, 0))
		return TRUE;
	if(pBalanceAccountPeriod->Budget)
		return TRUE;
	if(!DecimalCmp(pBalanceAccountPeriod->BudgetQuantity, 0))
		return TRUE;

	return FALSE;
}


/*********************************************************************

static BalanceAccountPeriodType *ReadSectionBalanceAccountPeriod(

*********************************************************************/
static BalanceAccountPeriodType *ReadSectionBalanceAccountPeriod(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
BalanceAccountPeriodType *pBalanceAccountPeriod = CreateBalanceAccountPeriod(pStructDocTop, pStructParent);

	if(!pBalanceAccountPeriod)
		return 0;	// Fatal error

	pXmlTagData=GetNextXmlTag(pXmlTagData);

	if(!pXmlTagData)
		return 0;	// Fatal error

	while(strcmp(pXmlTagData->pTag, pEndTag)) { // While is not the end
		if(!strcmp(pXmlTagData->pTag, "End"))
			pBalanceAccountPeriod->End = StringToDate(pXmlTagData->pData);		// xs:date
		else if(!strcmp(pXmlTagData->pTag, "Outcome"))
			pBalanceAccountPeriod->Outcome = StringToAmount(pXmlTagData->pData);		// rac:Amount
		else if(!strcmp(pXmlTagData->pTag, "OutcomeQuantity"))
			pBalanceAccountPeriod->OutcomeQuantity = StringToDecimal(pXmlTagData->pData);		// xs:decimal
		else if(!strcmp(pXmlTagData->pTag, "Budget"))
			pBalanceAccountPeriod->Budget = StringToAmount(pXmlTagData->pData);		// rac:Amount
		else if(!strcmp(pXmlTagData->pTag, "BudgetQuantity"))
			pBalanceAccountPeriod->BudgetQuantity = StringToDecimal(pXmlTagData->pData);		// xs:decimal

		pXmlTagData=GetNextXmlTag(pXmlTagData);

		if(!pXmlTagData)
			return 0;	// Fatal error
	}
	return pBalanceAccountPeriod;
}


/*********************************************************************

static BOOL WriteSectionBalanceAccountPeriod(

*********************************************************************/
static BOOL WriteSectionBalanceAccountPeriod(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	BalanceAccountPeriodType *pBalanceAccountPeriod)
{
	if(!pBalanceAccountPeriod)
		return FALSE;	// Fatal error

	xmlWriteLine(pStream, iTab-1, pAttr, pLabel, 0, 0);
	xmlWriteLine(pStream, iTab, 0, "End", DateToStr(pBalanceAccountPeriod->End, szString),"End");		// xs:date - Mandatory
	if(pBalanceAccountPeriod->Outcome)
		xmlWriteLine(pStream, iTab, 0, "Outcome", AmountToStr(pBalanceAccountPeriod->Outcome, szString),"Outcome");		// rac:Amount
	if(!DecimalCmp(pBalanceAccountPeriod->OutcomeQuantity, 0))
		xmlWriteLine(pStream, iTab, 0, "OutcomeQuantity", DecimalToStr(pBalanceAccountPeriod->OutcomeQuantity, szString),"OutcomeQuantity");		// xs:decimal
	if(pBalanceAccountPeriod->Budget)
		xmlWriteLine(pStream, iTab, 0, "Budget", AmountToStr(pBalanceAccountPeriod->Budget, szString),"Budget");		// rac:Amount
	if(!DecimalCmp(pBalanceAccountPeriod->BudgetQuantity, 0))
		xmlWriteLine(pStream, iTab, 0, "BudgetQuantity", DecimalToStr(pBalanceAccountPeriod->BudgetQuantity, szString),"BudgetQuantity");		// xs:decimal

	xmlWriteLine(pStream, iTab-1, 0, 0, 0, pLabel);

	return TRUE;
}


/*********************************************************************

BalanceAccountPeriodType *UpdateBalanceAccountPeriod(

*********************************************************************/
BalanceAccountPeriodType *UpdateBalanceAccountPeriod(
	BalanceAccountPeriodType *pStructBalanceAccountPeriod, 
	DATEINT End, 
	AMOUNT Outcome, 
	QUANT OutcomeQuantity, 
	AMOUNT Budget, 
	QUANT BudgetQuantity)
{
	pStructBalanceAccountPeriod->End = End;
	pStructBalanceAccountPeriod->Outcome = Outcome;
	pStructBalanceAccountPeriod->OutcomeQuantity = OutcomeQuantity;
	pStructBalanceAccountPeriod->Budget = Budget;
	pStructBalanceAccountPeriod->BudgetQuantity = BudgetQuantity;

	return pStructBalanceAccountPeriod;
}


/*********************************************************************

char **GetLeadTextBalanceAccountPeriod(

*********************************************************************/
char **GetLeadTextBalanceAccountPeriod(
	char *pLang)
{
static char *szTexts[] = {
	"End",
	"Outcome",
	"Outcome Quantity",
	"Budget",
	"Budget Quantity"};

	return szTexts;
}


/*********************************************************************

	Voucher

*********************************************************************

VoucherType *CreateVoucher(

*********************************************************************/
VoucherType *CreateVoucher(
	void *pStructDocTop, 
	void *pStructParent)
{
VoucherType *pVoucher = calloc(1, sizeof(VoucherType));

	if(!pVoucher)
		return 0;	// Fatal error

	pVoucher->DataType    = SCT_VOUCHER;
	pVoucher->pStructDocTop = pStructDocTop;
	pVoucher->pStructParent = pStructParent;

	pVoucher->pListTitle = LListInit();
	pVoucher->pListEntry = LListInit();

	return pVoucher;
}


/*********************************************************************

VoucherType *DestroyVoucher(

*********************************************************************/
VoucherType *DestroyVoucher(
	VoucherType **ppVoucher)
{
	if(!*ppVoucher)
		return 0;	// Nothing to destroy

	DestroySeriesId(&(*ppVoucher)->pId);		// rac:SeriesIdType
	{
		TextType *pTitle
			= LListGetFirstRecordData((*ppVoucher)->pListTitle);
		while(pTitle) {
			DestroyText(&pTitle);		// rac:TextType
			pTitle = LListGetNextRecordData((*ppVoucher)->pListTitle);
		}
		LListErase((*ppVoucher)->pListTitle);
	}
	DestroyOperatorInfo(&(*ppVoucher)->pAccountant);		// rac:OperatorInfoType
	{
		VoucherEntryType *pEntry
			= LListGetFirstRecordData((*ppVoucher)->pListEntry);
		while(pEntry) {
			DestroyVoucherEntry(&pEntry);		// rac:VoucherEntryType
			pEntry = LListGetNextRecordData((*ppVoucher)->pListEntry);
		}
		LListErase((*ppVoucher)->pListEntry);
	}

	free(*ppVoucher);
	*ppVoucher = 0;

	return 0;
}


/*********************************************************************

VoucherType *CopyVoucher(

*********************************************************************/
VoucherType *CopyVoucher(
	void *pStructDocTop, 
	void *pStructParent, 
	VoucherType *pVoucher)
{
	if(pVoucher) {
		VoucherType *pNewVoucher = CreateVoucher(pStructDocTop, pStructParent);

		if(!pNewVoucher)
			return 0;	// Fatal error

		pNewVoucher->pId = CopySeriesId(pStructDocTop, pNewVoucher, pVoucher->pId);		// rac:SeriesIdType
		pNewVoucher->Date = pVoucher->Date;		// xs:date
		{
			TextType *pTitle
				= LListGetFirstRecordData(pVoucher->pListTitle);
			while(pTitle) {
				LListAddRecord(pNewVoucher->pListTitle, CopyText(pStructDocTop, pNewVoucher, pTitle));		// rac:TextType
				pTitle = LListGetNextRecordData(pVoucher->pListTitle);
			}
		}
		pNewVoucher->pAccountant = CopyOperatorInfo(pStructDocTop, pNewVoucher, pVoucher->pAccountant);		// rac:OperatorInfoType
		{
			VoucherEntryType *pEntry
				= LListGetFirstRecordData(pVoucher->pListEntry);
			while(pEntry) {
				LListAddRecord(pNewVoucher->pListEntry, CopyVoucherEntry(pStructDocTop, pNewVoucher, pEntry));		// rac:VoucherEntryType
				pEntry = LListGetNextRecordData(pVoucher->pListEntry);
			}
		}

		return (pNewVoucher);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataVoucher(

*********************************************************************/
BOOL IsDataVoucher(
	VoucherType *pVoucher)
{
	if(!pVoucher)
		return FALSE;

	if(IsDataSeriesId(pVoucher->pId))
		return TRUE;
	if(pVoucher->Date)
		return TRUE;
	{
		TextType *pTitle
			= LListGetFirstRecordData(pVoucher->pListTitle);
		while(pTitle) {
			if(IsDataText(pTitle))
				return TRUE;
			pTitle = LListGetNextRecordData(pVoucher->pListTitle);
		}
	}
	if(IsDataOperatorInfo(pVoucher->pAccountant))
		return TRUE;
	{
		VoucherEntryType *pEntry
			= LListGetFirstRecordData(pVoucher->pListEntry);
		while(pEntry) {
			if(IsDataVoucherEntry(pEntry))
				return TRUE;
			pEntry = LListGetNextRecordData(pVoucher->pListEntry);
		}
	}

	return FALSE;
}


/*********************************************************************

static VoucherType *ReadSectionVoucher(

*********************************************************************/
static VoucherType *ReadSectionVoucher(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
VoucherType *pVoucher = CreateVoucher(pStructDocTop, pStructParent);

	if(!pVoucher)
		return 0;	// Fatal error

	pXmlTagData=GetNextXmlTag(pXmlTagData);

	if(!pXmlTagData)
		return 0;	// Fatal error

	while(strcmp(pXmlTagData->pTag, pEndTag)) { // While is not the end
		if(!strcmp(pXmlTagData->pTag, "Id"))
			pVoucher->pId = ReadSectionSeriesId(pStructDocTop, pVoucher, pXmlTagData, "Id");		// rac:SeriesIdType
		else if(!strcmp(pXmlTagData->pTag, "Date"))
			pVoucher->Date = StringToDate(pXmlTagData->pData);		// xs:date
		else if(!strcmp(pXmlTagData->pTag, "Title"))
			SearchSetText(pVoucher->pListTitle, ReadSectionText(pStructDocTop, pVoucher, pXmlTagData, "Title"));		// rac:TextType
		else if(!strcmp(pXmlTagData->pTag, "Accountant")) {
			DestroyOperatorInfo(&pVoucher->pAccountant);
			pVoucher->pAccountant = ReadSectionOperatorInfo(pStructDocTop, pVoucher, pXmlTagData, "Accountant");		// rac:OperatorInfoType
			}
		else if(!strcmp(pXmlTagData->pTag, "Entry"))
			LListAddRecord(pVoucher->pListEntry, ReadSectionVoucherEntry(pStructDocTop, pVoucher, pXmlTagData, "Entry"));		// rac:VoucherEntryType

		pXmlTagData=GetNextXmlTag(pXmlTagData);

		if(!pXmlTagData)
			return 0;	// Fatal error
	}
	return pVoucher;
}


/*********************************************************************

static BOOL WriteSectionVoucher(

*********************************************************************/
static BOOL WriteSectionVoucher(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	VoucherType *pVoucher)
{
	if(!pVoucher)
		return FALSE;	// Fatal error

	xmlWriteLine(pStream, iTab-1, pAttr, pLabel, 0, 0);

	if(!pVoucher->pId)		// Mandatory
		pVoucher->pId = CreateSeriesId(pVoucher->pStructDocTop, pVoucher);
	WriteSectionSeriesId(pStream, iTab+1, "Id", 0, pVoucher->pId);		// rac:SeriesIdType - Mandatory
	xmlWriteLine(pStream, iTab, 0, "Date", DateToStr(pVoucher->Date, szString),"Date");		// xs:date - Mandatory

	if(pVoucher->pListTitle) {
		TextType *pTitle
			= LListGetFirstRecordData(pVoucher->pListTitle);
		while(pTitle) {
			if(IsDataText(pTitle))
				WriteSectionText(pStream, iTab+1, "Title", 0, pTitle);		// rac:TextType
			pTitle = LListGetNextRecordData(pVoucher->pListTitle);
		}
	}

	if(pVoucher->pAccountant && IsDataOperatorInfo(pVoucher->pAccountant))		// Optional
		WriteSectionOperatorInfo(pStream, iTab+1, "Accountant", 0, pVoucher->pAccountant);		// rac:OperatorInfoType

	if(pVoucher->pListEntry) {
		VoucherEntryType *pEntry
			= LListGetFirstRecordData(pVoucher->pListEntry);
		while(pEntry) {
			if(IsDataVoucherEntry(pEntry))
				WriteSectionVoucherEntry(pStream, iTab+1, "Entry", 0, pEntry);		// rac:VoucherEntryType
			pEntry = LListGetNextRecordData(pVoucher->pListEntry);
		}
	}

	xmlWriteLine(pStream, iTab-1, 0, 0, 0, pLabel);

	return TRUE;
}


/*********************************************************************

VoucherType *UpdateVoucher(

*********************************************************************/
VoucherType *UpdateVoucher(
	VoucherType *pStructVoucher, 
	DATEINT Date)
{
	pStructVoucher->Date = Date;

	return pStructVoucher;
}


/*********************************************************************

char **GetLeadTextVoucher(

*********************************************************************/
char **GetLeadTextVoucher(
	char *pLang)
{
static char *szTexts[] = {
	"Id",
	"Date",
	"Title",
	"Accountant",
	"Entry"};

	return szTexts;
}


/*********************************************************************

	VoucherEntry

*********************************************************************

VoucherEntryType *CreateVoucherEntry(

*********************************************************************/
VoucherEntryType *CreateVoucherEntry(
	void *pStructDocTop, 
	void *pStructParent)
{
VoucherEntryType *pVoucherEntry = calloc(1, sizeof(VoucherEntryType));

	if(!pVoucherEntry)
		return 0;	// Fatal error

	pVoucherEntry->DataType    = SCT_VOUCHERENTRY;
	pVoucherEntry->pStructDocTop = pStructDocTop;
	pVoucherEntry->pStructParent = pStructParent;

	pVoucherEntry->pListTitle = LListInit();
	pVoucherEntry->pListObject = LListInit();

	return pVoucherEntry;
}


/*********************************************************************

VoucherEntryType *DestroyVoucherEntry(

*********************************************************************/
VoucherEntryType *DestroyVoucherEntry(
	VoucherEntryType **ppVoucherEntry)
{
	if(!*ppVoucherEntry)
		return 0;	// Nothing to destroy

	DestroyOperatorInfo(&(*ppVoucherEntry)->pDeprecated);		// rac:OperatorInfoType
	{
		TextType *pTitle
			= LListGetFirstRecordData((*ppVoucherEntry)->pListTitle);
		while(pTitle) {
			DestroyText(&pTitle);		// rac:TextType
			pTitle = LListGetNextRecordData((*ppVoucherEntry)->pListTitle);
		}
		LListErase((*ppVoucherEntry)->pListTitle);
	}
	// For 3d data - DestroyAccount(&(*ppVoucherEntry)->pAccount);		// rac:AccountType
	DestroyInvoice(&(*ppVoucherEntry)->pInvoice);		// rac:InvoiceType
	DestroyOperatorInfo(&(*ppVoucherEntry)->pAccountant);		// rac:OperatorInfoType
	LListErase((*ppVoucherEntry)->pListObject);	// For 3d data - Not destroy data of (*ppVoucherEntry)->pListObject		// rac:ObjectType

	free(*ppVoucherEntry);
	*ppVoucherEntry = 0;

	return 0;
}


/*********************************************************************

VoucherEntryType *CopyVoucherEntry(

*********************************************************************/
VoucherEntryType *CopyVoucherEntry(
	void *pStructDocTop, 
	void *pStructParent, 
	VoucherEntryType *pVoucherEntry)
{
	if(pVoucherEntry) {
		VoucherEntryType *pNewVoucherEntry = CreateVoucherEntry(pStructDocTop, pStructParent);

		if(!pNewVoucherEntry)
			return 0;	// Fatal error

		pNewVoucherEntry->pDeprecated = CopyOperatorInfo(pStructDocTop, pNewVoucherEntry, pVoucherEntry->pDeprecated);		// rac:OperatorInfoType
		pNewVoucherEntry->Amount = pVoucherEntry->Amount;		// rac:Amount
		pNewVoucherEntry->Quantity = pVoucherEntry->Quantity;		// xs:decimal
		{
			TextType *pTitle
				= LListGetFirstRecordData(pVoucherEntry->pListTitle);
			while(pTitle) {
				LListAddRecord(pNewVoucherEntry->pListTitle, CopyText(pStructDocTop, pNewVoucherEntry, pTitle));		// rac:TextType
				pTitle = LListGetNextRecordData(pVoucherEntry->pListTitle);
			}
		}
		pNewVoucherEntry->AuxDate = pVoucherEntry->AuxDate;		// xs:date
		pNewVoucherEntry->pAccount = SearchSetAccount(((AccountingType *)pStructDocTop)->pAccountsChart->pListAccount, CopyAccount(pStructDocTop, pNewVoucherEntry, pVoucherEntry->pAccount));		// rac:AccountType
		pNewVoucherEntry->pInvoice = CopyInvoice(pStructDocTop, pNewVoucherEntry, pVoucherEntry->pInvoice);		// rac:InvoiceType
		pNewVoucherEntry->pAccountant = CopyOperatorInfo(pStructDocTop, pNewVoucherEntry, pVoucherEntry->pAccountant);		// rac:OperatorInfoType
		{
			ObjectType *pObject
				= LListGetFirstRecordData(pVoucherEntry->pListObject);
			while(pObject) {
				LListAddRecord(pNewVoucherEntry->pListObject, SearchSetObject(((AccountingType *)pStructDocTop)->pObjectsChart->pListDimension, CopyObject(pStructDocTop, pNewVoucherEntry, pObject)));		// rac:ObjectType
				pObject = LListGetNextRecordData(pVoucherEntry->pListObject);
			}
		}

		return (pNewVoucherEntry);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataVoucherEntry(

*********************************************************************/
BOOL IsDataVoucherEntry(
	VoucherEntryType *pVoucherEntry)
{
	if(!pVoucherEntry)
		return FALSE;

	if(pVoucherEntry->Amount)
		return TRUE;
	if(!DecimalCmp(pVoucherEntry->Quantity, 0))
		return TRUE;

	return FALSE;
}


/*********************************************************************

static VoucherEntryType *ReadSectionVoucherEntry(

*********************************************************************/
static VoucherEntryType *ReadSectionVoucherEntry(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
VoucherEntryType *pVoucherEntry = CreateVoucherEntry(pStructDocTop, pStructParent);

	if(!pVoucherEntry)
		return 0;	// Fatal error

	pXmlTagData=GetNextXmlTag(pXmlTagData);

	if(!pXmlTagData)
		return 0;	// Fatal error

	while(strcmp(pXmlTagData->pTag, pEndTag)) { // While is not the end
		if(!strcmp(pXmlTagData->pTag, "Deprecated"))
			pVoucherEntry->pDeprecated = ReadSectionOperatorInfo(pStructDocTop, pVoucherEntry, pXmlTagData, "Deprecated");		// rac:OperatorInfoType
		else if(!strcmp(pXmlTagData->pTag, "Amount"))
			pVoucherEntry->Amount = StringToAmount(pXmlTagData->pData);		// rac:Amount
		else if(!strcmp(pXmlTagData->pTag, "Quantity"))
			pVoucherEntry->Quantity = StringToDecimal(pXmlTagData->pData);		// xs:decimal
		else if(!strcmp(pXmlTagData->pTag, "Title"))
			LListAddRecord(pVoucherEntry->pListTitle, ReadSectionText(pStructDocTop, pVoucherEntry, pXmlTagData, "Title"));		// rac:TextType
		else if(!strcmp(pXmlTagData->pTag, "AuxDate"))
			pVoucherEntry->AuxDate = StringToDate(pXmlTagData->pData);		// xs:date
		else if(!strcmp(pXmlTagData->pTag, "Account"))
			pVoucherEntry->pAccount = SearchSetAccount(((AccountingType *)pStructDocTop)->pAccountsChart->pListAccount, ReadSectionAccount(pStructDocTop, pVoucherEntry, pXmlTagData, "Account"));		// rac:AccountType
		else if(!strcmp(pXmlTagData->pTag, "Invoice"))
			pVoucherEntry->pInvoice = ReadSectionInvoice(pStructDocTop, pVoucherEntry, pXmlTagData, "Invoice");		// rac:InvoiceType
		else if(!strcmp(pXmlTagData->pTag, "Accountant")) {
			DestroyOperatorInfo(&pVoucherEntry->pAccountant);
			pVoucherEntry->pAccountant = ReadSectionOperatorInfo(pStructDocTop, pVoucherEntry, pXmlTagData, "Accountant");		// rac:OperatorInfoType
			}
		else if(!strcmp(pXmlTagData->pTag, "Object"))
			LListAddRecord(pVoucherEntry->pListObject, SearchSetObject(((AccountingType *)pStructDocTop)->pObjectsChart->pListDimension, ReadSectionObject(pStructDocTop, pVoucherEntry, pXmlTagData, "Object")));		// rac:ObjectType

		pXmlTagData=GetNextXmlTag(pXmlTagData);

		if(!pXmlTagData)
			return 0;	// Fatal error
	}
	return pVoucherEntry;
}


/*********************************************************************

static BOOL WriteSectionVoucherEntry(

*********************************************************************/
static BOOL WriteSectionVoucherEntry(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	VoucherEntryType *pVoucherEntry)
{
	if(!pVoucherEntry)
		return FALSE;	// Fatal error

	xmlWriteLine(pStream, iTab-1, pAttr, pLabel, 0, 0);

	if(pVoucherEntry->pDeprecated && IsDataOperatorInfo(pVoucherEntry->pDeprecated))		// Optional
		WriteSectionOperatorInfo(pStream, iTab+1, "Deprecated", 0, pVoucherEntry->pDeprecated);		// rac:OperatorInfoType
	if(pVoucherEntry->Amount)
		xmlWriteLine(pStream, iTab, 0, "Amount", AmountToStr(pVoucherEntry->Amount, szString),"Amount");		// rac:Amount
	if(!DecimalCmp(pVoucherEntry->Quantity, 0))
		xmlWriteLine(pStream, iTab, 0, "Quantity", DecimalToStr(pVoucherEntry->Quantity, szString),"Quantity");		// xs:decimal

	if(pVoucherEntry->pListTitle) {
		TextType *pTitle
			= LListGetFirstRecordData(pVoucherEntry->pListTitle);
		while(pTitle) {
			if(IsDataText(pTitle))
				WriteSectionText(pStream, iTab+1, "Title", 0, pTitle);		// rac:TextType
			pTitle = LListGetNextRecordData(pVoucherEntry->pListTitle);
		}
	}
	if(pVoucherEntry->AuxDate)
		xmlWriteLine(pStream, iTab, 0, "AuxDate", DateToStr(pVoucherEntry->AuxDate, szString),"AuxDate");		// xs:date

	if(!pVoucherEntry->pAccount)		// Mandatory
		pVoucherEntry->pAccount = CreateAccount(pVoucherEntry->pStructDocTop, pVoucherEntry);
	WriteSectionAccount(pStream, iTab+1, "Account", 0, pVoucherEntry->pAccount, TRUE);		// rac:AccountType - Mandatory

	if(pVoucherEntry->pInvoice && IsDataInvoice(pVoucherEntry->pInvoice))		// Optional
		WriteSectionInvoice(pStream, iTab+1, "Invoice", 0, pVoucherEntry->pInvoice);		// rac:InvoiceType

	if(pVoucherEntry->pAccountant && IsDataOperatorInfo(pVoucherEntry->pAccountant))		// Optional
		WriteSectionOperatorInfo(pStream, iTab+1, "Accountant", 0, pVoucherEntry->pAccountant);		// rac:OperatorInfoType

	if(pVoucherEntry->pListObject) {
		ObjectType *pObject
			= LListGetFirstRecordData(pVoucherEntry->pListObject);
		while(pObject) {
			if(IsDataObject(pObject))
				WriteSectionObject(pStream, iTab+1, "Object", 0, pObject, TRUE);		// rac:ObjectType
			pObject = LListGetNextRecordData(pVoucherEntry->pListObject);
		}
	}

	xmlWriteLine(pStream, iTab-1, 0, 0, 0, pLabel);

	return TRUE;
}


/*********************************************************************

VoucherEntryType *UpdateVoucherEntry(

*********************************************************************/
VoucherEntryType *UpdateVoucherEntry(
	VoucherEntryType *pStructVoucherEntry, 
	AMOUNT Amount, 
	QUANT Quantity, 
	DATEINT AuxDate)
{
	pStructVoucherEntry->Amount = Amount;
	pStructVoucherEntry->Quantity = Quantity;
	pStructVoucherEntry->AuxDate = AuxDate;

	return pStructVoucherEntry;
}


/*********************************************************************

char **GetLeadTextVoucherEntry(

*********************************************************************/
char **GetLeadTextVoucherEntry(
	char *pLang)
{
static char *szTexts[] = {
	"Deprecated",
	"Amount",
	"Quantity",
	"Title",
	"Aux Date",
	"Account",
	"Invoice",
	"Accountant",
	"Object"};

	return szTexts;
}


/*********************************************************************

	InvoiceChart

*********************************************************************

InvoiceChartType *CreateInvoiceChart(

*********************************************************************/
InvoiceChartType *CreateInvoiceChart(
	void *pStructDocTop, 
	void *pStructParent)
{
InvoiceChartType *pInvoiceChart = calloc(1, sizeof(InvoiceChartType));

	if(!pInvoiceChart)
		return 0;	// Fatal error

	pInvoiceChart->DataType    = SCT_INVOICECHART;
	pInvoiceChart->pStructDocTop = pStructDocTop;
	pInvoiceChart->pStructParent = pStructParent;

	pInvoiceChart->pListInvoice = LListInit();

	return pInvoiceChart;
}


/*********************************************************************

InvoiceChartType *DestroyInvoiceChart(

*********************************************************************/
InvoiceChartType *DestroyInvoiceChart(
	InvoiceChartType **ppInvoiceChart)
{
	if(!*ppInvoiceChart)
		return 0;	// Nothing to destroy

	{
		InvoiceType *pInvoice
			= LListGetFirstRecordData((*ppInvoiceChart)->pListInvoice);
		while(pInvoice) {
			DestroyInvoice(&pInvoice);		// rac:InvoiceType
			pInvoice = LListGetNextRecordData((*ppInvoiceChart)->pListInvoice);
		}
		LListErase((*ppInvoiceChart)->pListInvoice);
	}

	free(*ppInvoiceChart);
	*ppInvoiceChart = 0;

	return 0;
}


/*********************************************************************

InvoiceChartType *CopyInvoiceChart(

*********************************************************************/
InvoiceChartType *CopyInvoiceChart(
	void *pStructDocTop, 
	void *pStructParent, 
	InvoiceChartType *pInvoiceChart)
{
	if(pInvoiceChart) {
		InvoiceChartType *pNewInvoiceChart = CreateInvoiceChart(pStructDocTop, pStructParent);

		if(!pNewInvoiceChart)
			return 0;	// Fatal error

		{
			InvoiceType *pInvoice
				= LListGetFirstRecordData(pInvoiceChart->pListInvoice);
			while(pInvoice) {
				LListAddRecord(pNewInvoiceChart->pListInvoice, CopyInvoice(pStructDocTop, pNewInvoiceChart, pInvoice));		// rac:InvoiceType
				pInvoice = LListGetNextRecordData(pInvoiceChart->pListInvoice);
			}
		}

		return (pNewInvoiceChart);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataInvoiceChart(

*********************************************************************/
BOOL IsDataInvoiceChart(
	InvoiceChartType *pInvoiceChart)
{
	if(!pInvoiceChart)
		return FALSE;

	{
		InvoiceType *pInvoice
			= LListGetFirstRecordData(pInvoiceChart->pListInvoice);
		while(pInvoice) {
			if(IsDataInvoice(pInvoice))
				return TRUE;
			pInvoice = LListGetNextRecordData(pInvoiceChart->pListInvoice);
		}
	}

	return FALSE;
}


/*********************************************************************

static InvoiceChartType *ReadSectionInvoiceChart(

*********************************************************************/
static InvoiceChartType *ReadSectionInvoiceChart(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
InvoiceChartType *pInvoiceChart = CreateInvoiceChart(pStructDocTop, pStructParent);

	if(!pInvoiceChart)
		return 0;	// Fatal error

	pXmlTagData=GetNextXmlTag(pXmlTagData);

	if(!pXmlTagData)
		return 0;	// Fatal error

	while(strcmp(pXmlTagData->pTag, pEndTag)) { // While is not the end
		if(!strcmp(pXmlTagData->pTag, "Invoice"))
			LListAddRecord(pInvoiceChart->pListInvoice, ReadSectionInvoice(pStructDocTop, pInvoiceChart, pXmlTagData, "Invoice"));		// rac:InvoiceType

		pXmlTagData=GetNextXmlTag(pXmlTagData);

		if(!pXmlTagData)
			return 0;	// Fatal error
	}
	return pInvoiceChart;
}


/*********************************************************************

static BOOL WriteSectionInvoiceChart(

*********************************************************************/
static BOOL WriteSectionInvoiceChart(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	InvoiceChartType *pInvoiceChart)
{
	if(!pInvoiceChart)
		return FALSE;	// Fatal error

	xmlWriteLine(pStream, iTab-1, pAttr, pLabel, 0, 0);

	if(pInvoiceChart->pListInvoice) {
		InvoiceType *pInvoice
			= LListGetFirstRecordData(pInvoiceChart->pListInvoice);
		while(pInvoice) {
			if(IsDataInvoice(pInvoice))
				WriteSectionInvoice(pStream, iTab+1, "Invoice", 0, pInvoice);		// rac:InvoiceType
			pInvoice = LListGetNextRecordData(pInvoiceChart->pListInvoice);
		}
	}

	xmlWriteLine(pStream, iTab-1, 0, 0, 0, pLabel);

	return TRUE;
}


/*********************************************************************

InvoiceChartType *UpdateInvoiceChart(

*********************************************************************/
InvoiceChartType *UpdateInvoiceChart(
	InvoiceChartType *pStructInvoiceChart)
{

	return pStructInvoiceChart;
}


/*********************************************************************

char **GetLeadTextInvoiceChart(

*********************************************************************/
char **GetLeadTextInvoiceChart(
	char *pLang)
{
static char *szTexts[] = {
	"Invoice"};

	return szTexts;
}


/*********************************************************************

	Invoice

*********************************************************************

InvoiceType *CreateInvoice(

*********************************************************************/
InvoiceType *CreateInvoice(
	void *pStructDocTop, 
	void *pStructParent)
{
InvoiceType *pInvoice = calloc(1, sizeof(InvoiceType));

	if(!pInvoice)
		return 0;	// Fatal error

	pInvoice->DataType    = SCT_INVOICE;
	if(pStructDocTop)
		pInvoice->pStructDocTop = pStructDocTop;
	else
		pInvoice->pStructDocTop = pInvoice;
	if(pStructParent)
		pInvoice->pStructParent = pStructParent;
	else
		pInvoice->pStructParent = pInvoice;
	pInvoice->pPurpose = NulString;
	pInvoice->pLegalLanguage = NulString;
	pInvoice->pListTitle = LListInit();
	pInvoice->pListPayObject = LListInit();
	pInvoice->DateOfIssue = GetSystemDate();
	pInvoice->DateOfArrival = GetSystemDate();
	pInvoice->DueDate = AddDays(GetSystemDate(), 30);
	pInvoice->pPayReference = NulString;
	pInvoice->pPayCurrency = NulString;
	pInvoice->pListBuyersNote = LListInit();
	pInvoice->pListSellersNote = LListInit();
	pInvoice->pListFactoringNote = LListInit();
	pInvoice->pListCollectingNote = LListInit();
	pInvoice->pListBailiffNote = LListInit();
	pInvoice->pListOriginalInvoiceFileUrl = LListInit();
	pInvoice->pListRelatedDocumentFileUrl = LListInit();
	pInvoice->pListIssuer = LListInit();
	pInvoice->pListPayApproved = LListInit();
	pInvoice->pListPayOrderd = LListInit();
	pInvoice->pListInvoiceEntry = LListInit();
	pInvoice->pListAllowanceCharge = LListInit();
	pInvoice->pListLogisticsServiceCharge = LListInit();
	pInvoice->pListCollectionCharge = LListInit();
	pInvoice->pListDiscounts = LListInit();
	pInvoice->pListReferenceAccounting = LListInit();
	pInvoice->pAmortisationSchedule = NulString;
	pInvoice->pListPay = LListInit();

	return pInvoice;
}


/*********************************************************************

InvoiceType *DestroyInvoice(

*********************************************************************/
InvoiceType *DestroyInvoice(
	InvoiceType **ppInvoice)
{
	if(!*ppInvoice)
		return 0;	// Nothing to destroy

	FreeString(&(*ppInvoice)->pPurpose);		// rac:InvoiceTypeType
	FreeString(&(*ppInvoice)->pLegalLanguage);		// xs:language
	{
		TextType *pTitle
			= LListGetFirstRecordData((*ppInvoice)->pListTitle);
		while(pTitle) {
			DestroyText(&pTitle);		// rac:TextType
			pTitle = LListGetNextRecordData((*ppInvoice)->pListTitle);
		}
		LListErase((*ppInvoice)->pListTitle);
	}
	DestroySeriesId(&(*ppInvoice)->pInvoiceId);		// rac:SeriesIdType
	DestroySeriesId(&(*ppInvoice)->pPayableId);		// rac:SeriesIdType
	LListErase((*ppInvoice)->pListPayObject);	// For 3d data - Not destroy data of (*ppInvoice)->pListPayObject		// rac:ObjectType
	DestroyAmountCurrency(&(*ppInvoice)->pCreditLimit);		// rac:AmountCurrencyType
	FreeString(&(*ppInvoice)->pPayReference);		// xs:token
	FreeString(&(*ppInvoice)->pPayCurrency);		// rac:Currency
	LListDestroy((*ppInvoice)->pListBuyersNote);		// xs:string
	LListDestroy((*ppInvoice)->pListSellersNote);		// xs:string
	LListDestroy((*ppInvoice)->pListFactoringNote);		// xs:string
	LListDestroy((*ppInvoice)->pListCollectingNote);		// xs:string
	LListDestroy((*ppInvoice)->pListBailiffNote);		// xs:string
	LListDestroy((*ppInvoice)->pListOriginalInvoiceFileUrl);		// rac:FileUrl
	LListDestroy((*ppInvoice)->pListRelatedDocumentFileUrl);		// rac:FileUrl
	{
		AttestType *pIssuer
			= LListGetFirstRecordData((*ppInvoice)->pListIssuer);
		while(pIssuer) {
			DestroyAttest(&pIssuer);		// rac:AttestType
			pIssuer = LListGetNextRecordData((*ppInvoice)->pListIssuer);
		}
		LListErase((*ppInvoice)->pListIssuer);
	}
	{
		AttestType *pPayApproved
			= LListGetFirstRecordData((*ppInvoice)->pListPayApproved);
		while(pPayApproved) {
			DestroyAttest(&pPayApproved);		// rac:AttestType
			pPayApproved = LListGetNextRecordData((*ppInvoice)->pListPayApproved);
		}
		LListErase((*ppInvoice)->pListPayApproved);
	}
	{
		AttestType *pPayOrderd
			= LListGetFirstRecordData((*ppInvoice)->pListPayOrderd);
		while(pPayOrderd) {
			DestroyAttest(&pPayOrderd);		// rac:AttestType
			pPayOrderd = LListGetNextRecordData((*ppInvoice)->pListPayOrderd);
		}
		LListErase((*ppInvoice)->pListPayOrderd);
	}
	{
		InvoiceEntryType *pInvoiceEntry
			= LListGetFirstRecordData((*ppInvoice)->pListInvoiceEntry);
		while(pInvoiceEntry) {
			DestroyInvoiceEntry(&pInvoiceEntry);		// rac:InvoiceEntryType
			pInvoiceEntry = LListGetNextRecordData((*ppInvoice)->pListInvoiceEntry);
		}
		LListErase((*ppInvoice)->pListInvoiceEntry);
	}
	{
		InvoiceEntryType *pAllowanceCharge
			= LListGetFirstRecordData((*ppInvoice)->pListAllowanceCharge);
		while(pAllowanceCharge) {
			DestroyInvoiceEntry(&pAllowanceCharge);		// rac:InvoiceEntryType
			pAllowanceCharge = LListGetNextRecordData((*ppInvoice)->pListAllowanceCharge);
		}
		LListErase((*ppInvoice)->pListAllowanceCharge);
	}
	{
		InvoiceEntryType *pLogisticsServiceCharge
			= LListGetFirstRecordData((*ppInvoice)->pListLogisticsServiceCharge);
		while(pLogisticsServiceCharge) {
			DestroyInvoiceEntry(&pLogisticsServiceCharge);		// rac:InvoiceEntryType
			pLogisticsServiceCharge = LListGetNextRecordData((*ppInvoice)->pListLogisticsServiceCharge);
		}
		LListErase((*ppInvoice)->pListLogisticsServiceCharge);
	}
	{
		InvoiceEntryType *pCollectionCharge
			= LListGetFirstRecordData((*ppInvoice)->pListCollectionCharge);
		while(pCollectionCharge) {
			DestroyInvoiceEntry(&pCollectionCharge);		// rac:InvoiceEntryType
			pCollectionCharge = LListGetNextRecordData((*ppInvoice)->pListCollectionCharge);
		}
		LListErase((*ppInvoice)->pListCollectionCharge);
	}
	{
		InvoiceEntryType *pDiscounts
			= LListGetFirstRecordData((*ppInvoice)->pListDiscounts);
		while(pDiscounts) {
			DestroyInvoiceEntry(&pDiscounts);		// rac:InvoiceEntryType
			pDiscounts = LListGetNextRecordData((*ppInvoice)->pListDiscounts);
		}
		LListErase((*ppInvoice)->pListDiscounts);
	}
	DestroyParty(&(*ppInvoice)->pBuyer);		// rac:PartyType
	DestroyParty(&(*ppInvoice)->pSeller);		// rac:PartyType
	DestroyParty(&(*ppInvoice)->pTaxRepresentative);		// rac:PartyType
	DestroyParty(&(*ppInvoice)->pFactor);		// rac:PartyType
	DestroyParty(&(*ppInvoice)->pCollector);		// rac:PartyType
	DestroyParty(&(*ppInvoice)->pBailiff);		// rac:PartyType
	{
		SeriesIdType *pReferenceAccounting
			= LListGetFirstRecordData((*ppInvoice)->pListReferenceAccounting);
		while(pReferenceAccounting) {
			DestroySeriesId(&pReferenceAccounting);		// rac:SeriesIdType
			pReferenceAccounting = LListGetNextRecordData((*ppInvoice)->pListReferenceAccounting);
		}
		LListErase((*ppInvoice)->pListReferenceAccounting);
	}
	FreeString(&(*ppInvoice)->pAmortisationSchedule);		// rac:AmortisationScheduleType
	{
		PayType *pPay
			= LListGetFirstRecordData((*ppInvoice)->pListPay);
		while(pPay) {
			DestroyPay(&pPay);		// rac:PayType
			pPay = LListGetNextRecordData((*ppInvoice)->pListPay);
		}
		LListErase((*ppInvoice)->pListPay);
	}

	free(*ppInvoice);
	*ppInvoice = 0;

	return 0;
}


/*********************************************************************

InvoiceType *CopyInvoice(

*********************************************************************/
InvoiceType *CopyInvoice(
	void *pStructDocTop, 
	void *pStructParent, 
	InvoiceType *pInvoice)
{
	if(pInvoice) {
		InvoiceType *pNewInvoice = CreateInvoice(pStructDocTop, pStructParent);

		if(!pNewInvoice)
			return 0;	// Fatal error

		if(!pStructDocTop)
			pStructDocTop = pNewInvoice;	// Fatal error

		CopyString(&pNewInvoice->pPurpose, pInvoice->pPurpose);		// rac:InvoiceTypeType
		CopyString(&pNewInvoice->pLegalLanguage, pInvoice->pLegalLanguage);		// xs:language
		pNewInvoice->Deprecated = pInvoice->Deprecated;		// xs:date
		{
			TextType *pTitle
				= LListGetFirstRecordData(pInvoice->pListTitle);
			while(pTitle) {
				LListAddRecord(pNewInvoice->pListTitle, CopyText(pStructDocTop, pNewInvoice, pTitle));		// rac:TextType
				pTitle = LListGetNextRecordData(pInvoice->pListTitle);
			}
		}
		pNewInvoice->pInvoiceId = CopySeriesId(pStructDocTop, pNewInvoice, pInvoice->pInvoiceId);		// rac:SeriesIdType
		pNewInvoice->pPayableId = CopySeriesId(pStructDocTop, pNewInvoice, pInvoice->pPayableId);		// rac:SeriesIdType
		{
			ObjectType *pPayObject
				= LListGetFirstRecordData(pInvoice->pListPayObject);
			while(pPayObject) {
				LListAddRecord(pNewInvoice->pListPayObject, SearchSetObject(((AccountingType *)pStructDocTop)->pObjectsChart->pListDimension, CopyObject(pStructDocTop, pNewInvoice, pPayObject)));		// rac:ObjectType
				pPayObject = LListGetNextRecordData(pInvoice->pListPayObject);
			}
		}
		pNewInvoice->PaidDate = pInvoice->PaidDate;		// xs:date
		pNewInvoice->DateOfIssue = pInvoice->DateOfIssue;		// xs:date
		pNewInvoice->DateOfArrival = pInvoice->DateOfArrival;		// xs:date
		pNewInvoice->DueDate = pInvoice->DueDate;		// xs:date
		pNewInvoice->LatePayInterestRate = pInvoice->LatePayInterestRate;		// xs:decimal
		pNewInvoice->pCreditLimit = CopyAmountCurrency(pStructDocTop, pNewInvoice, pInvoice->pCreditLimit);		// rac:AmountCurrencyType
		CopyString(&pNewInvoice->pPayReference, pInvoice->pPayReference);		// xs:token
		CopyString(&pNewInvoice->pPayCurrency, pInvoice->pPayCurrency);		// rac:Currency
		pNewInvoice->PayAmount = pInvoice->PayAmount;		// rac:Amount
		pNewInvoice->VatAmountPayCurrency = pInvoice->VatAmountPayCurrency;		// rac:Amount
		pNewInvoice->NetAmountPayCurrency = pInvoice->NetAmountPayCurrency;		// rac:Amount
		pNewInvoice->VatAmountTaxCurrency = pInvoice->VatAmountTaxCurrency;		// rac:Amount
		pNewInvoice->NetAmountTaxCurrency = pInvoice->NetAmountTaxCurrency;		// rac:Amount
		{
			char *pBuyersNote
				= LListGetFirstRecordData(pInvoice->pListBuyersNote);
			while(pBuyersNote) {
				LListAddRecord(pNewInvoice->pListBuyersNote, CopyString(0, pBuyersNote));		// xs:string
				pBuyersNote = LListGetNextRecordData(pInvoice->pListBuyersNote);
			}
		}
		{
			char *pSellersNote
				= LListGetFirstRecordData(pInvoice->pListSellersNote);
			while(pSellersNote) {
				LListAddRecord(pNewInvoice->pListSellersNote, CopyString(0, pSellersNote));		// xs:string
				pSellersNote = LListGetNextRecordData(pInvoice->pListSellersNote);
			}
		}
		{
			char *pFactoringNote
				= LListGetFirstRecordData(pInvoice->pListFactoringNote);
			while(pFactoringNote) {
				LListAddRecord(pNewInvoice->pListFactoringNote, CopyString(0, pFactoringNote));		// xs:string
				pFactoringNote = LListGetNextRecordData(pInvoice->pListFactoringNote);
			}
		}
		{
			char *pCollectingNote
				= LListGetFirstRecordData(pInvoice->pListCollectingNote);
			while(pCollectingNote) {
				LListAddRecord(pNewInvoice->pListCollectingNote, CopyString(0, pCollectingNote));		// xs:string
				pCollectingNote = LListGetNextRecordData(pInvoice->pListCollectingNote);
			}
		}
		{
			char *pBailiffNote
				= LListGetFirstRecordData(pInvoice->pListBailiffNote);
			while(pBailiffNote) {
				LListAddRecord(pNewInvoice->pListBailiffNote, CopyString(0, pBailiffNote));		// xs:string
				pBailiffNote = LListGetNextRecordData(pInvoice->pListBailiffNote);
			}
		}
		{
			char *pOriginalInvoiceFileUrl
				= LListGetFirstRecordData(pInvoice->pListOriginalInvoiceFileUrl);
			while(pOriginalInvoiceFileUrl) {
				LListAddRecord(pNewInvoice->pListOriginalInvoiceFileUrl, CopyString(0, pOriginalInvoiceFileUrl));		// rac:FileUrl
				pOriginalInvoiceFileUrl = LListGetNextRecordData(pInvoice->pListOriginalInvoiceFileUrl);
			}
		}
		{
			char *pRelatedDocumentFileUrl
				= LListGetFirstRecordData(pInvoice->pListRelatedDocumentFileUrl);
			while(pRelatedDocumentFileUrl) {
				LListAddRecord(pNewInvoice->pListRelatedDocumentFileUrl, CopyString(0, pRelatedDocumentFileUrl));		// rac:FileUrl
				pRelatedDocumentFileUrl = LListGetNextRecordData(pInvoice->pListRelatedDocumentFileUrl);
			}
		}
		{
			AttestType *pIssuer
				= LListGetFirstRecordData(pInvoice->pListIssuer);
			while(pIssuer) {
				LListAddRecord(pNewInvoice->pListIssuer, CopyAttest(pStructDocTop, pNewInvoice, pIssuer));		// rac:AttestType
				pIssuer = LListGetNextRecordData(pInvoice->pListIssuer);
			}
		}
		{
			AttestType *pPayApproved
				= LListGetFirstRecordData(pInvoice->pListPayApproved);
			while(pPayApproved) {
				LListAddRecord(pNewInvoice->pListPayApproved, CopyAttest(pStructDocTop, pNewInvoice, pPayApproved));		// rac:AttestType
				pPayApproved = LListGetNextRecordData(pInvoice->pListPayApproved);
			}
		}
		{
			AttestType *pPayOrderd
				= LListGetFirstRecordData(pInvoice->pListPayOrderd);
			while(pPayOrderd) {
				LListAddRecord(pNewInvoice->pListPayOrderd, CopyAttest(pStructDocTop, pNewInvoice, pPayOrderd));		// rac:AttestType
				pPayOrderd = LListGetNextRecordData(pInvoice->pListPayOrderd);
			}
		}
		{
			InvoiceEntryType *pInvoiceEntry
				= LListGetFirstRecordData(pInvoice->pListInvoiceEntry);
			while(pInvoiceEntry) {
				LListAddRecord(pNewInvoice->pListInvoiceEntry, CopyInvoiceEntry(pStructDocTop, pNewInvoice, pInvoiceEntry));		// rac:InvoiceEntryType
				pInvoiceEntry = LListGetNextRecordData(pInvoice->pListInvoiceEntry);
			}
		}
		{
			InvoiceEntryType *pAllowanceCharge
				= LListGetFirstRecordData(pInvoice->pListAllowanceCharge);
			while(pAllowanceCharge) {
				LListAddRecord(pNewInvoice->pListAllowanceCharge, CopyInvoiceEntry(pStructDocTop, pNewInvoice, pAllowanceCharge));		// rac:InvoiceEntryType
				pAllowanceCharge = LListGetNextRecordData(pInvoice->pListAllowanceCharge);
			}
		}
		{
			InvoiceEntryType *pLogisticsServiceCharge
				= LListGetFirstRecordData(pInvoice->pListLogisticsServiceCharge);
			while(pLogisticsServiceCharge) {
				LListAddRecord(pNewInvoice->pListLogisticsServiceCharge, CopyInvoiceEntry(pStructDocTop, pNewInvoice, pLogisticsServiceCharge));		// rac:InvoiceEntryType
				pLogisticsServiceCharge = LListGetNextRecordData(pInvoice->pListLogisticsServiceCharge);
			}
		}
		{
			InvoiceEntryType *pCollectionCharge
				= LListGetFirstRecordData(pInvoice->pListCollectionCharge);
			while(pCollectionCharge) {
				LListAddRecord(pNewInvoice->pListCollectionCharge, CopyInvoiceEntry(pStructDocTop, pNewInvoice, pCollectionCharge));		// rac:InvoiceEntryType
				pCollectionCharge = LListGetNextRecordData(pInvoice->pListCollectionCharge);
			}
		}
		{
			InvoiceEntryType *pDiscounts
				= LListGetFirstRecordData(pInvoice->pListDiscounts);
			while(pDiscounts) {
				LListAddRecord(pNewInvoice->pListDiscounts, CopyInvoiceEntry(pStructDocTop, pNewInvoice, pDiscounts));		// rac:InvoiceEntryType
				pDiscounts = LListGetNextRecordData(pInvoice->pListDiscounts);
			}
		}
		pNewInvoice->pBuyer = CopyParty(pStructDocTop, pNewInvoice, pInvoice->pBuyer);		// rac:PartyType
		pNewInvoice->pSeller = CopyParty(pStructDocTop, pNewInvoice, pInvoice->pSeller);		// rac:PartyType
		pNewInvoice->pTaxRepresentative = CopyParty(pStructDocTop, pNewInvoice, pInvoice->pTaxRepresentative);		// rac:PartyType
		pNewInvoice->pFactor = CopyParty(pStructDocTop, pNewInvoice, pInvoice->pFactor);		// rac:PartyType
		pNewInvoice->pCollector = CopyParty(pStructDocTop, pNewInvoice, pInvoice->pCollector);		// rac:PartyType
		pNewInvoice->pBailiff = CopyParty(pStructDocTop, pNewInvoice, pInvoice->pBailiff);		// rac:PartyType
		{
			SeriesIdType *pReferenceAccounting
				= LListGetFirstRecordData(pInvoice->pListReferenceAccounting);
			while(pReferenceAccounting) {
				LListAddRecord(pNewInvoice->pListReferenceAccounting, CopySeriesId(pStructDocTop, pNewInvoice, pReferenceAccounting));		// rac:SeriesIdType
				pReferenceAccounting = LListGetNextRecordData(pInvoice->pListReferenceAccounting);
			}
		}
		CopyString(&pNewInvoice->pAmortisationSchedule, pInvoice->pAmortisationSchedule);		// rac:AmortisationScheduleType
		{
			PayType *pPay
				= LListGetFirstRecordData(pInvoice->pListPay);
			while(pPay) {
				LListAddRecord(pNewInvoice->pListPay, CopyPay(pStructDocTop, pNewInvoice, pPay));		// rac:PayType
				pPay = LListGetNextRecordData(pInvoice->pListPay);
			}
		}

		return (pNewInvoice);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataInvoice(

*********************************************************************/
BOOL IsDataInvoice(
	InvoiceType *pInvoice)
{
	if(!pInvoice)
		return FALSE;

	if(pInvoice->pPurpose && *pInvoice->pPurpose)
		return TRUE;
	if(pInvoice->pLegalLanguage && *pInvoice->pLegalLanguage)
		return TRUE;
	if(pInvoice->Deprecated)
		return TRUE;
	{
		TextType *pTitle
			= LListGetFirstRecordData(pInvoice->pListTitle);
		while(pTitle) {
			if(IsDataText(pTitle))
				return TRUE;
			pTitle = LListGetNextRecordData(pInvoice->pListTitle);
		}
	}
	if(IsDataSeriesId(pInvoice->pInvoiceId))
		return TRUE;
	if(IsDataSeriesId(pInvoice->pPayableId))
		return TRUE;
	if(pInvoice->PaidDate)
		return TRUE;
	if(pInvoice->DateOfIssue)
		return TRUE;
	if(pInvoice->DateOfArrival)
		return TRUE;
	if(pInvoice->DueDate)
		return TRUE;
	if(!DecimalCmp(pInvoice->LatePayInterestRate, 0))
		return TRUE;
	if(IsDataAmountCurrency(pInvoice->pCreditLimit))
		return TRUE;
	if(pInvoice->pPayReference && *pInvoice->pPayReference)
		return TRUE;
	if(pInvoice->pPayCurrency && *pInvoice->pPayCurrency)
		return TRUE;
	if(pInvoice->PayAmount)
		return TRUE;
	if(pInvoice->VatAmountPayCurrency)
		return TRUE;
	if(pInvoice->NetAmountPayCurrency)
		return TRUE;
	if(pInvoice->VatAmountTaxCurrency)
		return TRUE;
	if(pInvoice->NetAmountTaxCurrency)
		return TRUE;
	if(LListGetFirstRecordData(pInvoice->pListBuyersNote))
		return TRUE;
	if(LListGetFirstRecordData(pInvoice->pListSellersNote))
		return TRUE;
	if(LListGetFirstRecordData(pInvoice->pListFactoringNote))
		return TRUE;
	if(LListGetFirstRecordData(pInvoice->pListCollectingNote))
		return TRUE;
	if(LListGetFirstRecordData(pInvoice->pListBailiffNote))
		return TRUE;
	if(LListGetFirstRecordData(pInvoice->pListOriginalInvoiceFileUrl))
		return TRUE;
	if(LListGetFirstRecordData(pInvoice->pListRelatedDocumentFileUrl))
		return TRUE;
	{
		AttestType *pIssuer
			= LListGetFirstRecordData(pInvoice->pListIssuer);
		while(pIssuer) {
			if(IsDataAttest(pIssuer))
				return TRUE;
			pIssuer = LListGetNextRecordData(pInvoice->pListIssuer);
		}
	}
	{
		AttestType *pPayApproved
			= LListGetFirstRecordData(pInvoice->pListPayApproved);
		while(pPayApproved) {
			if(IsDataAttest(pPayApproved))
				return TRUE;
			pPayApproved = LListGetNextRecordData(pInvoice->pListPayApproved);
		}
	}
	{
		AttestType *pPayOrderd
			= LListGetFirstRecordData(pInvoice->pListPayOrderd);
		while(pPayOrderd) {
			if(IsDataAttest(pPayOrderd))
				return TRUE;
			pPayOrderd = LListGetNextRecordData(pInvoice->pListPayOrderd);
		}
	}
	{
		InvoiceEntryType *pInvoiceEntry
			= LListGetFirstRecordData(pInvoice->pListInvoiceEntry);
		while(pInvoiceEntry) {
			if(IsDataInvoiceEntry(pInvoiceEntry))
				return TRUE;
			pInvoiceEntry = LListGetNextRecordData(pInvoice->pListInvoiceEntry);
		}
	}
	{
		InvoiceEntryType *pAllowanceCharge
			= LListGetFirstRecordData(pInvoice->pListAllowanceCharge);
		while(pAllowanceCharge) {
			if(IsDataInvoiceEntry(pAllowanceCharge))
				return TRUE;
			pAllowanceCharge = LListGetNextRecordData(pInvoice->pListAllowanceCharge);
		}
	}
	{
		InvoiceEntryType *pLogisticsServiceCharge
			= LListGetFirstRecordData(pInvoice->pListLogisticsServiceCharge);
		while(pLogisticsServiceCharge) {
			if(IsDataInvoiceEntry(pLogisticsServiceCharge))
				return TRUE;
			pLogisticsServiceCharge = LListGetNextRecordData(pInvoice->pListLogisticsServiceCharge);
		}
	}
	{
		InvoiceEntryType *pCollectionCharge
			= LListGetFirstRecordData(pInvoice->pListCollectionCharge);
		while(pCollectionCharge) {
			if(IsDataInvoiceEntry(pCollectionCharge))
				return TRUE;
			pCollectionCharge = LListGetNextRecordData(pInvoice->pListCollectionCharge);
		}
	}
	{
		InvoiceEntryType *pDiscounts
			= LListGetFirstRecordData(pInvoice->pListDiscounts);
		while(pDiscounts) {
			if(IsDataInvoiceEntry(pDiscounts))
				return TRUE;
			pDiscounts = LListGetNextRecordData(pInvoice->pListDiscounts);
		}
	}
	if(IsDataParty(pInvoice->pBuyer))
		return TRUE;
	if(IsDataParty(pInvoice->pSeller))
		return TRUE;
	if(IsDataParty(pInvoice->pTaxRepresentative))
		return TRUE;
	if(IsDataParty(pInvoice->pFactor))
		return TRUE;
	if(IsDataParty(pInvoice->pCollector))
		return TRUE;
	if(IsDataParty(pInvoice->pBailiff))
		return TRUE;
	{
		SeriesIdType *pReferenceAccounting
			= LListGetFirstRecordData(pInvoice->pListReferenceAccounting);
		while(pReferenceAccounting) {
			if(IsDataSeriesId(pReferenceAccounting))
				return TRUE;
			pReferenceAccounting = LListGetNextRecordData(pInvoice->pListReferenceAccounting);
		}
	}
	if(pInvoice->pAmortisationSchedule && *pInvoice->pAmortisationSchedule)
		return TRUE;
	{
		PayType *pPay
			= LListGetFirstRecordData(pInvoice->pListPay);
		while(pPay) {
			if(IsDataPay(pPay))
				return TRUE;
			pPay = LListGetNextRecordData(pInvoice->pListPay);
		}
	}

	return FALSE;
}


/*********************************************************************

InvoiceType *ReadSectionInvoice(

*********************************************************************/
InvoiceType *ReadSectionInvoice(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
InvoiceType *pInvoice = CreateInvoice(pStructDocTop, pStructParent);

	if(!pInvoice)
		return 0;	// Fatal error

	if(!pStructDocTop)
		pInvoice->pStructDocTop = pInvoice;	// Top struct

	pXmlTagData=GetNextXmlTag(pXmlTagData);

	if(!pXmlTagData)
		return 0;	// Fatal error

	while(strcmp(pXmlTagData->pTag, pEndTag)) { // While is not the end
		if(!strcmp(pXmlTagData->pTag, "Purpose"))
			CheckEnum(&pInvoice->pPurpose, EnumInvoiceTypeType, ReadXmlDataString(pXmlTagData->pData));		// rac:InvoiceTypeType
		else if(!strcmp(pXmlTagData->pTag, "LegalLanguage"))
			ReadString(&pInvoice->pLegalLanguage, ReadXmlDataString(pXmlTagData->pData));		// xs:language
		else if(!strcmp(pXmlTagData->pTag, "Deprecated"))
			pInvoice->Deprecated = StringToDate(pXmlTagData->pData);		// xs:date
		else if(!strcmp(pXmlTagData->pTag, "Title"))
			SearchSetText(pInvoice->pListTitle, ReadSectionText(pStructDocTop, pInvoice, pXmlTagData, "Title"));		// rac:TextType
		else if(!strcmp(pXmlTagData->pTag, "InvoiceId"))
			pInvoice->pInvoiceId = ReadSectionSeriesId(pInvoice, pInvoice, pXmlTagData, "InvoiceId");		// rac:SeriesIdType
		else if(!strcmp(pXmlTagData->pTag, "PayableId"))
			pInvoice->pPayableId = ReadSectionSeriesId(pInvoice, pInvoice, pXmlTagData, "PayableId");		// rac:SeriesIdType
		else if(!strcmp(pXmlTagData->pTag, "PayObject"))
			LListAddRecord(pInvoice->pListPayObject, SearchSetObject(((AccountingType *)pStructDocTop)->pObjectsChart->pListDimension, ReadSectionObject(pStructDocTop, pInvoice, pXmlTagData, "PayObject")));		// rac:ObjectType
		else if(!strcmp(pXmlTagData->pTag, "PaidDate"))
			pInvoice->PaidDate = StringToDate(pXmlTagData->pData);		// xs:date
		else if(!strcmp(pXmlTagData->pTag, "DateOfIssue"))
			pInvoice->DateOfIssue = StringToDate(pXmlTagData->pData);		// xs:date
		else if(!strcmp(pXmlTagData->pTag, "DateOfArrival"))
			pInvoice->DateOfArrival = StringToDate(pXmlTagData->pData);		// xs:date
		else if(!strcmp(pXmlTagData->pTag, "DueDate"))
			pInvoice->DueDate = StringToDate(pXmlTagData->pData);		// xs:date
		else if(!strcmp(pXmlTagData->pTag, "LatePayInterestRate"))
			pInvoice->LatePayInterestRate = StringToDecimal(pXmlTagData->pData);		// xs:decimal
		else if(!strcmp(pXmlTagData->pTag, "CreditLimit"))
			pInvoice->pCreditLimit = ReadSectionAmountCurrency(pInvoice, pInvoice, pXmlTagData, "CreditLimit");		// rac:AmountCurrencyType
		else if(!strcmp(pXmlTagData->pTag, "PayReference"))
			ReadString(&pInvoice->pPayReference, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "PayCurrency"))
			ReadString(&pInvoice->pPayCurrency, ReadXmlDataString(pXmlTagData->pData));		// rac:Currency
		else if(!strcmp(pXmlTagData->pTag, "PayAmount"))
			pInvoice->PayAmount = StringToAmount(pXmlTagData->pData);		// rac:Amount
		else if(!strcmp(pXmlTagData->pTag, "VatAmountPayCurrency"))
			pInvoice->VatAmountPayCurrency = StringToAmount(pXmlTagData->pData);		// rac:Amount
		else if(!strcmp(pXmlTagData->pTag, "NetAmountPayCurrency"))
			pInvoice->NetAmountPayCurrency = StringToAmount(pXmlTagData->pData);		// rac:Amount
		else if(!strcmp(pXmlTagData->pTag, "VatAmountTaxCurrency"))
			pInvoice->VatAmountTaxCurrency = StringToAmount(pXmlTagData->pData);		// rac:Amount
		else if(!strcmp(pXmlTagData->pTag, "NetAmountTaxCurrency"))
			pInvoice->NetAmountTaxCurrency = StringToAmount(pXmlTagData->pData);		// rac:Amount
		else if(!strcmp(pXmlTagData->pTag, "BuyersNote"))
			LListAddRecord(pInvoice->pListBuyersNote, ReadXmlDataString(pXmlTagData->pData));		// xs:string
		else if(!strcmp(pXmlTagData->pTag, "SellersNote"))
			LListAddRecord(pInvoice->pListSellersNote, ReadXmlDataString(pXmlTagData->pData));		// xs:string
		else if(!strcmp(pXmlTagData->pTag, "FactoringNote"))
			LListAddRecord(pInvoice->pListFactoringNote, ReadXmlDataString(pXmlTagData->pData));		// xs:string
		else if(!strcmp(pXmlTagData->pTag, "CollectingNote"))
			LListAddRecord(pInvoice->pListCollectingNote, ReadXmlDataString(pXmlTagData->pData));		// xs:string
		else if(!strcmp(pXmlTagData->pTag, "BailiffNote"))
			LListAddRecord(pInvoice->pListBailiffNote, ReadXmlDataString(pXmlTagData->pData));		// xs:string
		else if(!strcmp(pXmlTagData->pTag, "OriginalInvoiceFileUrl"))
			LListAddRecord(pInvoice->pListOriginalInvoiceFileUrl, ReadXmlDataString(pXmlTagData->pData));		// rac:FileUrl
		else if(!strcmp(pXmlTagData->pTag, "RelatedDocumentFileUrl"))
			LListAddRecord(pInvoice->pListRelatedDocumentFileUrl, ReadXmlDataString(pXmlTagData->pData));		// rac:FileUrl
		else if(!strcmp(pXmlTagData->pTag, "Issuer"))
			LListAddRecord(pInvoice->pListIssuer, ReadSectionAttest(pStructDocTop, pInvoice, pXmlTagData, "Issuer"));		// rac:AttestType
		else if(!strcmp(pXmlTagData->pTag, "PayApproved"))
			LListAddRecord(pInvoice->pListPayApproved, ReadSectionAttest(pStructDocTop, pInvoice, pXmlTagData, "PayApproved"));		// rac:AttestType
		else if(!strcmp(pXmlTagData->pTag, "PayOrderd"))
			LListAddRecord(pInvoice->pListPayOrderd, ReadSectionAttest(pStructDocTop, pInvoice, pXmlTagData, "PayOrderd"));		// rac:AttestType
		else if(!strcmp(pXmlTagData->pTag, "InvoiceEntry"))
			LListAddRecord(pInvoice->pListInvoiceEntry, ReadSectionInvoiceEntry(pStructDocTop, pInvoice, pXmlTagData, "InvoiceEntry"));		// rac:InvoiceEntryType
		else if(!strcmp(pXmlTagData->pTag, "AllowanceCharge"))
			LListAddRecord(pInvoice->pListAllowanceCharge, ReadSectionInvoiceEntry(pStructDocTop, pInvoice, pXmlTagData, "AllowanceCharge"));		// rac:InvoiceEntryType
		else if(!strcmp(pXmlTagData->pTag, "LogisticsServiceCharge"))
			LListAddRecord(pInvoice->pListLogisticsServiceCharge, ReadSectionInvoiceEntry(pStructDocTop, pInvoice, pXmlTagData, "LogisticsServiceCharge"));		// rac:InvoiceEntryType
		else if(!strcmp(pXmlTagData->pTag, "CollectionCharge"))
			LListAddRecord(pInvoice->pListCollectionCharge, ReadSectionInvoiceEntry(pStructDocTop, pInvoice, pXmlTagData, "CollectionCharge"));		// rac:InvoiceEntryType
		else if(!strcmp(pXmlTagData->pTag, "Discounts"))
			LListAddRecord(pInvoice->pListDiscounts, ReadSectionInvoiceEntry(pStructDocTop, pInvoice, pXmlTagData, "Discounts"));		// rac:InvoiceEntryType
		else if(!strcmp(pXmlTagData->pTag, "Buyer"))
			pInvoice->pBuyer = ReadSectionParty(pInvoice, pInvoice, pXmlTagData, "Buyer");		// rac:PartyType
		else if(!strcmp(pXmlTagData->pTag, "Seller"))
			pInvoice->pSeller = ReadSectionParty(pInvoice, pInvoice, pXmlTagData, "Seller");		// rac:PartyType
		else if(!strcmp(pXmlTagData->pTag, "TaxRepresentative"))
			pInvoice->pTaxRepresentative = ReadSectionParty(pInvoice, pInvoice, pXmlTagData, "TaxRepresentative");		// rac:PartyType
		else if(!strcmp(pXmlTagData->pTag, "Factor"))
			pInvoice->pFactor = ReadSectionParty(pInvoice, pInvoice, pXmlTagData, "Factor");		// rac:PartyType
		else if(!strcmp(pXmlTagData->pTag, "Collector"))
			pInvoice->pCollector = ReadSectionParty(pInvoice, pInvoice, pXmlTagData, "Collector");		// rac:PartyType
		else if(!strcmp(pXmlTagData->pTag, "Bailiff"))
			pInvoice->pBailiff = ReadSectionParty(pInvoice, pInvoice, pXmlTagData, "Bailiff");		// rac:PartyType
		else if(!strcmp(pXmlTagData->pTag, "ReferenceAccounting"))
			LListAddRecord(pInvoice->pListReferenceAccounting, ReadSectionSeriesId(pStructDocTop, pInvoice, pXmlTagData, "ReferenceAccounting"));		// rac:SeriesIdType
		else if(!strcmp(pXmlTagData->pTag, "AmortisationSchedule"))
			CheckEnum(&pInvoice->pAmortisationSchedule, EnumAmortisationScheduleType, ReadXmlDataString(pXmlTagData->pData));		// rac:AmortisationScheduleType
		else if(!strcmp(pXmlTagData->pTag, "Pay"))
			LListAddRecord(pInvoice->pListPay, ReadSectionPay(pStructDocTop, pInvoice, pXmlTagData, "Pay"));		// rac:PayType

		pXmlTagData=GetNextXmlTag(pXmlTagData);

		if(!pXmlTagData)
			return 0;	// Fatal error
	}
	return pInvoice;
}


/*********************************************************************

static BOOL WriteSectionInvoice(

*********************************************************************/
static BOOL WriteSectionInvoice(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	InvoiceType *pInvoice)
{
	if(!pInvoice)
		return FALSE;	// Fatal error

	xmlWriteLine(pStream, iTab-1, pAttr, pLabel, 0, 0);
	if(pInvoice->pPurpose && *pInvoice->pPurpose)
		xmlWriteLine(pStream, iTab, 0, "Purpose", pInvoice->pPurpose, "Purpose");		// rac:InvoiceTypeType
	if(pInvoice->pLegalLanguage && *pInvoice->pLegalLanguage)
		xmlWriteLine(pStream, iTab, 0, "LegalLanguage", pInvoice->pLegalLanguage, "LegalLanguage");		// xs:language
	if(pInvoice->Deprecated)
		xmlWriteLine(pStream, iTab, 0, "Deprecated", DateToStr(pInvoice->Deprecated, szString),"Deprecated");		// xs:date

	if(pInvoice->pListTitle) {
		TextType *pTitle
			= LListGetFirstRecordData(pInvoice->pListTitle);
		while(pTitle) {
			if(IsDataText(pTitle))
				WriteSectionText(pStream, iTab+1, "Title", 0, pTitle);		// rac:TextType
			pTitle = LListGetNextRecordData(pInvoice->pListTitle);
		}
	}

	if(pInvoice->pInvoiceId && IsDataSeriesId(pInvoice->pInvoiceId))		// Optional
		WriteSectionSeriesId(pStream, iTab+1, "InvoiceId", 0, pInvoice->pInvoiceId);		// rac:SeriesIdType

	if(pInvoice->pPayableId && IsDataSeriesId(pInvoice->pPayableId))		// Optional
		WriteSectionSeriesId(pStream, iTab+1, "PayableId", 0, pInvoice->pPayableId);		// rac:SeriesIdType

	if(pInvoice->pListPayObject) {
		ObjectType *pPayObject
			= LListGetFirstRecordData(pInvoice->pListPayObject);
		while(pPayObject) {
			if(IsDataObject(pPayObject))
				WriteSectionObject(pStream, iTab+1, "PayObject", 0, pPayObject, TRUE);		// rac:ObjectType
			pPayObject = LListGetNextRecordData(pInvoice->pListPayObject);
		}
	}
	if(pInvoice->PaidDate)
		xmlWriteLine(pStream, iTab, 0, "PaidDate", DateToStr(pInvoice->PaidDate, szString),"PaidDate");		// xs:date
	if(pInvoice->DateOfIssue)
		xmlWriteLine(pStream, iTab, 0, "DateOfIssue", DateToStr(pInvoice->DateOfIssue, szString),"DateOfIssue");		// xs:date
	if(pInvoice->DateOfArrival)
		xmlWriteLine(pStream, iTab, 0, "DateOfArrival", DateToStr(pInvoice->DateOfArrival, szString),"DateOfArrival");		// xs:date
	if(pInvoice->DueDate)
		xmlWriteLine(pStream, iTab, 0, "DueDate", DateToStr(pInvoice->DueDate, szString),"DueDate");		// xs:date
	if(!DecimalCmp(pInvoice->LatePayInterestRate, 0))
		xmlWriteLine(pStream, iTab, 0, "LatePayInterestRate", DecimalToStr(pInvoice->LatePayInterestRate, szString),"LatePayInterestRate");		// xs:decimal

	if(pInvoice->pCreditLimit && IsDataAmountCurrency(pInvoice->pCreditLimit))		// Optional
		WriteSectionAmountCurrency(pStream, iTab+1, "CreditLimit", 0, pInvoice->pCreditLimit);		// rac:AmountCurrencyType
	if(pInvoice->pPayReference && *pInvoice->pPayReference)
		xmlWriteLine(pStream, iTab, 0, "PayReference", pInvoice->pPayReference, "PayReference");		// xs:token
	if(pInvoice->pPayCurrency && *pInvoice->pPayCurrency)
		xmlWriteLine(pStream, iTab, 0, "PayCurrency", pInvoice->pPayCurrency, "PayCurrency");		// rac:Currency
	if(pInvoice->PayAmount)
		xmlWriteLine(pStream, iTab, 0, "PayAmount", AmountToStr(pInvoice->PayAmount, szString),"PayAmount");		// rac:Amount
	if(pInvoice->VatAmountPayCurrency)
		xmlWriteLine(pStream, iTab, 0, "VatAmountPayCurrency", AmountToStr(pInvoice->VatAmountPayCurrency, szString),"VatAmountPayCurrency");		// rac:Amount
	if(pInvoice->NetAmountPayCurrency)
		xmlWriteLine(pStream, iTab, 0, "NetAmountPayCurrency", AmountToStr(pInvoice->NetAmountPayCurrency, szString),"NetAmountPayCurrency");		// rac:Amount
	if(pInvoice->VatAmountTaxCurrency)
		xmlWriteLine(pStream, iTab, 0, "VatAmountTaxCurrency", AmountToStr(pInvoice->VatAmountTaxCurrency, szString),"VatAmountTaxCurrency");		// rac:Amount
	if(pInvoice->NetAmountTaxCurrency)
		xmlWriteLine(pStream, iTab, 0, "NetAmountTaxCurrency", AmountToStr(pInvoice->NetAmountTaxCurrency, szString),"NetAmountTaxCurrency");		// rac:Amount

	if(pInvoice->pListBuyersNote) {
		char *pBuyersNote
			= LListGetFirstRecordData(pInvoice->pListBuyersNote);
		while(pBuyersNote) {
			xmlWriteLine(pStream, iTab, 0, "BuyersNote", pBuyersNote, "BuyersNote");		// xs:string

			pBuyersNote = LListGetNextRecordData(pInvoice->pListBuyersNote);
		}
	}

	if(pInvoice->pListSellersNote) {
		char *pSellersNote
			= LListGetFirstRecordData(pInvoice->pListSellersNote);
		while(pSellersNote) {
			xmlWriteLine(pStream, iTab, 0, "SellersNote", pSellersNote, "SellersNote");		// xs:string

			pSellersNote = LListGetNextRecordData(pInvoice->pListSellersNote);
		}
	}

	if(pInvoice->pListFactoringNote) {
		char *pFactoringNote
			= LListGetFirstRecordData(pInvoice->pListFactoringNote);
		while(pFactoringNote) {
			xmlWriteLine(pStream, iTab, 0, "FactoringNote", pFactoringNote, "FactoringNote");		// xs:string

			pFactoringNote = LListGetNextRecordData(pInvoice->pListFactoringNote);
		}
	}

	if(pInvoice->pListCollectingNote) {
		char *pCollectingNote
			= LListGetFirstRecordData(pInvoice->pListCollectingNote);
		while(pCollectingNote) {
			xmlWriteLine(pStream, iTab, 0, "CollectingNote", pCollectingNote, "CollectingNote");		// xs:string

			pCollectingNote = LListGetNextRecordData(pInvoice->pListCollectingNote);
		}
	}

	if(pInvoice->pListBailiffNote) {
		char *pBailiffNote
			= LListGetFirstRecordData(pInvoice->pListBailiffNote);
		while(pBailiffNote) {
			xmlWriteLine(pStream, iTab, 0, "BailiffNote", pBailiffNote, "BailiffNote");		// xs:string

			pBailiffNote = LListGetNextRecordData(pInvoice->pListBailiffNote);
		}
	}

	if(pInvoice->pListOriginalInvoiceFileUrl) {
		char *pOriginalInvoiceFileUrl
			= LListGetFirstRecordData(pInvoice->pListOriginalInvoiceFileUrl);
		while(pOriginalInvoiceFileUrl) {
			xmlWriteLine(pStream, iTab, 0, "OriginalInvoiceFileUrl", pOriginalInvoiceFileUrl, "OriginalInvoiceFileUrl");		// rac:FileUrl

			pOriginalInvoiceFileUrl = LListGetNextRecordData(pInvoice->pListOriginalInvoiceFileUrl);
		}
	}

	if(pInvoice->pListRelatedDocumentFileUrl) {
		char *pRelatedDocumentFileUrl
			= LListGetFirstRecordData(pInvoice->pListRelatedDocumentFileUrl);
		while(pRelatedDocumentFileUrl) {
			xmlWriteLine(pStream, iTab, 0, "RelatedDocumentFileUrl", pRelatedDocumentFileUrl, "RelatedDocumentFileUrl");		// rac:FileUrl

			pRelatedDocumentFileUrl = LListGetNextRecordData(pInvoice->pListRelatedDocumentFileUrl);
		}
	}

	if(pInvoice->pListIssuer) {
		AttestType *pIssuer
			= LListGetFirstRecordData(pInvoice->pListIssuer);
		while(pIssuer) {
			if(IsDataAttest(pIssuer))
				WriteSectionAttest(pStream, iTab+1, "Issuer", 0, pIssuer);		// rac:AttestType
			pIssuer = LListGetNextRecordData(pInvoice->pListIssuer);
		}
	}

	if(pInvoice->pListPayApproved) {
		AttestType *pPayApproved
			= LListGetFirstRecordData(pInvoice->pListPayApproved);
		while(pPayApproved) {
			if(IsDataAttest(pPayApproved))
				WriteSectionAttest(pStream, iTab+1, "PayApproved", 0, pPayApproved);		// rac:AttestType
			pPayApproved = LListGetNextRecordData(pInvoice->pListPayApproved);
		}
	}

	if(pInvoice->pListPayOrderd) {
		AttestType *pPayOrderd
			= LListGetFirstRecordData(pInvoice->pListPayOrderd);
		while(pPayOrderd) {
			if(IsDataAttest(pPayOrderd))
				WriteSectionAttest(pStream, iTab+1, "PayOrderd", 0, pPayOrderd);		// rac:AttestType
			pPayOrderd = LListGetNextRecordData(pInvoice->pListPayOrderd);
		}
	}

	if(pInvoice->pListInvoiceEntry) {
		InvoiceEntryType *pInvoiceEntry
			= LListGetFirstRecordData(pInvoice->pListInvoiceEntry);
		while(pInvoiceEntry) {
			if(IsDataInvoiceEntry(pInvoiceEntry))
				WriteSectionInvoiceEntry(pStream, iTab+1, "InvoiceEntry", 0, pInvoiceEntry);		// rac:InvoiceEntryType
			pInvoiceEntry = LListGetNextRecordData(pInvoice->pListInvoiceEntry);
		}
	}

	if(pInvoice->pListAllowanceCharge) {
		InvoiceEntryType *pAllowanceCharge
			= LListGetFirstRecordData(pInvoice->pListAllowanceCharge);
		while(pAllowanceCharge) {
			if(IsDataInvoiceEntry(pAllowanceCharge))
				WriteSectionInvoiceEntry(pStream, iTab+1, "AllowanceCharge", 0, pAllowanceCharge);		// rac:InvoiceEntryType
			pAllowanceCharge = LListGetNextRecordData(pInvoice->pListAllowanceCharge);
		}
	}

	if(pInvoice->pListLogisticsServiceCharge) {
		InvoiceEntryType *pLogisticsServiceCharge
			= LListGetFirstRecordData(pInvoice->pListLogisticsServiceCharge);
		while(pLogisticsServiceCharge) {
			if(IsDataInvoiceEntry(pLogisticsServiceCharge))
				WriteSectionInvoiceEntry(pStream, iTab+1, "LogisticsServiceCharge", 0, pLogisticsServiceCharge);		// rac:InvoiceEntryType
			pLogisticsServiceCharge = LListGetNextRecordData(pInvoice->pListLogisticsServiceCharge);
		}
	}

	if(pInvoice->pListCollectionCharge) {
		InvoiceEntryType *pCollectionCharge
			= LListGetFirstRecordData(pInvoice->pListCollectionCharge);
		while(pCollectionCharge) {
			if(IsDataInvoiceEntry(pCollectionCharge))
				WriteSectionInvoiceEntry(pStream, iTab+1, "CollectionCharge", 0, pCollectionCharge);		// rac:InvoiceEntryType
			pCollectionCharge = LListGetNextRecordData(pInvoice->pListCollectionCharge);
		}
	}

	if(pInvoice->pListDiscounts) {
		InvoiceEntryType *pDiscounts
			= LListGetFirstRecordData(pInvoice->pListDiscounts);
		while(pDiscounts) {
			if(IsDataInvoiceEntry(pDiscounts))
				WriteSectionInvoiceEntry(pStream, iTab+1, "Discounts", 0, pDiscounts);		// rac:InvoiceEntryType
			pDiscounts = LListGetNextRecordData(pInvoice->pListDiscounts);
		}
	}

	if(pInvoice->pBuyer && IsDataParty(pInvoice->pBuyer))		// Optional
		WriteSectionParty(pStream, iTab+1, "Buyer", 0, pInvoice->pBuyer);		// rac:PartyType

	if(pInvoice->pSeller && IsDataParty(pInvoice->pSeller))		// Optional
		WriteSectionParty(pStream, iTab+1, "Seller", 0, pInvoice->pSeller);		// rac:PartyType

	if(pInvoice->pTaxRepresentative && IsDataParty(pInvoice->pTaxRepresentative))		// Optional
		WriteSectionParty(pStream, iTab+1, "TaxRepresentative", 0, pInvoice->pTaxRepresentative);		// rac:PartyType

	if(pInvoice->pFactor && IsDataParty(pInvoice->pFactor))		// Optional
		WriteSectionParty(pStream, iTab+1, "Factor", 0, pInvoice->pFactor);		// rac:PartyType

	if(pInvoice->pCollector && IsDataParty(pInvoice->pCollector))		// Optional
		WriteSectionParty(pStream, iTab+1, "Collector", 0, pInvoice->pCollector);		// rac:PartyType

	if(pInvoice->pBailiff && IsDataParty(pInvoice->pBailiff))		// Optional
		WriteSectionParty(pStream, iTab+1, "Bailiff", 0, pInvoice->pBailiff);		// rac:PartyType

	if(pInvoice->pListReferenceAccounting) {
		SeriesIdType *pReferenceAccounting
			= LListGetFirstRecordData(pInvoice->pListReferenceAccounting);
		while(pReferenceAccounting) {
			if(IsDataSeriesId(pReferenceAccounting))
				WriteSectionSeriesId(pStream, iTab+1, "ReferenceAccounting", 0, pReferenceAccounting);		// rac:SeriesIdType
			pReferenceAccounting = LListGetNextRecordData(pInvoice->pListReferenceAccounting);
		}
	}
	if(pInvoice->pAmortisationSchedule && *pInvoice->pAmortisationSchedule)
		xmlWriteLine(pStream, iTab, 0, "AmortisationSchedule", pInvoice->pAmortisationSchedule, "AmortisationSchedule");		// rac:AmortisationScheduleType

	if(pInvoice->pListPay) {
		PayType *pPay
			= LListGetFirstRecordData(pInvoice->pListPay);
		while(pPay) {
			if(IsDataPay(pPay))
				WriteSectionPay(pStream, iTab+1, "Pay", 0, pPay);		// rac:PayType
			pPay = LListGetNextRecordData(pInvoice->pListPay);
		}
	}

	xmlWriteLine(pStream, iTab-1, 0, 0, 0, pLabel);

	return TRUE;
}


/*********************************************************************

InvoiceType *UpdateInvoice(

*********************************************************************/
InvoiceType *UpdateInvoice(
	InvoiceType *pStructInvoice, 
	char *pPurpose, 
	char *pLegalLanguage, 
	DATEINT Deprecated, 
	DATEINT PaidDate, 
	DATEINT DateOfIssue, 
	DATEINT DateOfArrival, 
	DATEINT DueDate, 
	QUANT LatePayInterestRate, 
	char *pPayReference, 
	char *pPayCurrency, 
	AMOUNT PayAmount, 
	AMOUNT VatAmountPayCurrency, 
	AMOUNT NetAmountPayCurrency, 
	AMOUNT VatAmountTaxCurrency, 
	AMOUNT NetAmountTaxCurrency, 
	char *pAmortisationSchedule)
{
	StringUpdate(&pStructInvoice->pPurpose, pPurpose);
	StringUpdate(&pStructInvoice->pLegalLanguage, pLegalLanguage);
	pStructInvoice->Deprecated = Deprecated;
	pStructInvoice->PaidDate = PaidDate;
	pStructInvoice->DateOfIssue = DateOfIssue;
	pStructInvoice->DateOfArrival = DateOfArrival;
	pStructInvoice->DueDate = DueDate;
	pStructInvoice->LatePayInterestRate = LatePayInterestRate;
	StringUpdate(&pStructInvoice->pPayReference, pPayReference);
	StringUpdate(&pStructInvoice->pPayCurrency, pPayCurrency);
	pStructInvoice->PayAmount = PayAmount;
	pStructInvoice->VatAmountPayCurrency = VatAmountPayCurrency;
	pStructInvoice->NetAmountPayCurrency = NetAmountPayCurrency;
	pStructInvoice->VatAmountTaxCurrency = VatAmountTaxCurrency;
	pStructInvoice->NetAmountTaxCurrency = NetAmountTaxCurrency;
	StringUpdate(&pStructInvoice->pAmortisationSchedule, pAmortisationSchedule);

	return pStructInvoice;
}


/*********************************************************************

char **GetLeadTextInvoice(

*********************************************************************/
char **GetLeadTextInvoice(
	char *pLang)
{
static char *szTexts[] = {
	"Purpose",
	"Legal Language",
	"Deprecated",
	"Title",
	"Invoice Id",
	"Payable Id",
	"Pay Object",
	"Paid Date",
	"Date Of Issue",
	"Date Of Arrival",
	"Due Date",
	"Late Pay Interest Rate",
	"Credit Limit",
	"Pay Reference",
	"Pay Currency",
	"Pay Amount",
	"Vat Amount Pay Currency",
	"Net Amount Pay Currency",
	"Vat Amount Tax Currency",
	"Net Amount Tax Currency",
	"Buyers Note",
	"Sellers Note",
	"Factoring Note",
	"Collecting Note",
	"Bailiff Note",
	"Original Invoice File Url",
	"Related Document File Url",
	"Issuer",
	"Pay Approved",
	"Pay Orderd",
	"Invoice Entry",
	"Allowance Charge",
	"Logistics Service Charge",
	"Collection Charge",
	"Discounts",
	"Buyer",
	"Seller",
	"Tax Representative",
	"Factor",
	"Collector",
	"Bailiff",
	"Reference Accounting",
	"Amortisation Schedule",
	"Pay"};

	return szTexts;
}


/*********************************************************************

	InvoiceEntry

*********************************************************************

InvoiceEntryType *CreateInvoiceEntry(

*********************************************************************/
InvoiceEntryType *CreateInvoiceEntry(
	void *pStructDocTop, 
	void *pStructParent)
{
InvoiceEntryType *pInvoiceEntry = calloc(1, sizeof(InvoiceEntryType));

	if(!pInvoiceEntry)
		return 0;	// Fatal error

	pInvoiceEntry->DataType    = SCT_INVOICEENTRY;
	pInvoiceEntry->pStructDocTop = pStructDocTop;
	pInvoiceEntry->pStructParent = pStructParent;

	pInvoiceEntry->pListDescription = LListInit();
	pInvoiceEntry->pListTradeItemData = LListInit();
	pInvoiceEntry->pListQuantityUnit = LListInit();
	pInvoiceEntry->pId = NulString;
	pInvoiceEntry->pListSalesReference = LListInit();
	pInvoiceEntry->pListSalesObject = LListInit();
	pInvoiceEntry->pListCostReference = LListInit();
	pInvoiceEntry->pListCostObject = LListInit();
	pInvoiceEntry->pListNote = LListInit();
	pInvoiceEntry->pListDeliveryNote = LListInit();
	pInvoiceEntry->pListLocationNote = LListInit();
	pInvoiceEntry->pLocation = NulString;
	pInvoiceEntry->pListDispatchFileUrl = LListInit();
	pInvoiceEntry->pOrderId = NulString;
	pInvoiceEntry->pContractId = NulString;
	pInvoiceEntry->pPriceListId = NulString;
	pInvoiceEntry->pListOrderResponseFileUrl = LListInit();
	pInvoiceEntry->pListSellersNoteToBuyer = LListInit();
	pInvoiceEntry->pSuggestedBasAccount = NulString;
	pInvoiceEntry->pVatReduced = NulString;
	pInvoiceEntry->pVatSpecial = NulString;
	pInvoiceEntry->pListVehicleVatDocFileUrl = LListInit();
	pInvoiceEntry->pListReceivingApproved = LListInit();

	return pInvoiceEntry;
}


/*********************************************************************

InvoiceEntryType *DestroyInvoiceEntry(

*********************************************************************/
InvoiceEntryType *DestroyInvoiceEntry(
	InvoiceEntryType **ppInvoiceEntry)
{
	if(!*ppInvoiceEntry)
		return 0;	// Nothing to destroy

	{
		TextType *pDescription
			= LListGetFirstRecordData((*ppInvoiceEntry)->pListDescription);
		while(pDescription) {
			DestroyText(&pDescription);		// rac:TextType
			pDescription = LListGetNextRecordData((*ppInvoiceEntry)->pListDescription);
		}
		LListErase((*ppInvoiceEntry)->pListDescription);
	}
	{
		TradeItemDataType *pTradeItemData
			= LListGetFirstRecordData((*ppInvoiceEntry)->pListTradeItemData);
		while(pTradeItemData) {
			DestroyTradeItemData(&pTradeItemData);		// rac:TradeItemDataType
			pTradeItemData = LListGetNextRecordData((*ppInvoiceEntry)->pListTradeItemData);
		}
		LListErase((*ppInvoiceEntry)->pListTradeItemData);
	}
	{
		TextType *pQuantityUnit
			= LListGetFirstRecordData((*ppInvoiceEntry)->pListQuantityUnit);
		while(pQuantityUnit) {
			DestroyText(&pQuantityUnit);		// rac:TextType
			pQuantityUnit = LListGetNextRecordData((*ppInvoiceEntry)->pListQuantityUnit);
		}
		LListErase((*ppInvoiceEntry)->pListQuantityUnit);
	}
	DestroyAmountCurrency(&(*ppInvoiceEntry)->pQuotaAgreedUnitNetAmount);		// rac:AmountCurrencyType
	FreeString(&(*ppInvoiceEntry)->pId);		// xs:token
	DestroySeriesId(&(*ppInvoiceEntry)->pInvoiceId);		// rac:SeriesIdType
	LListDestroy((*ppInvoiceEntry)->pListSalesReference);		// xs:token
	LListErase((*ppInvoiceEntry)->pListSalesObject);	// For 3d data - Not destroy data of (*ppInvoiceEntry)->pListSalesObject		// rac:ObjectType
	LListDestroy((*ppInvoiceEntry)->pListCostReference);		// xs:token
	LListErase((*ppInvoiceEntry)->pListCostObject);	// For 3d data - Not destroy data of (*ppInvoiceEntry)->pListCostObject		// rac:ObjectType
	{
		TextType *pNote
			= LListGetFirstRecordData((*ppInvoiceEntry)->pListNote);
		while(pNote) {
			DestroyText(&pNote);		// rac:TextType
			pNote = LListGetNextRecordData((*ppInvoiceEntry)->pListNote);
		}
		LListErase((*ppInvoiceEntry)->pListNote);
	}
	{
		TextType *pDeliveryNote
			= LListGetFirstRecordData((*ppInvoiceEntry)->pListDeliveryNote);
		while(pDeliveryNote) {
			DestroyText(&pDeliveryNote);		// rac:TextType
			pDeliveryNote = LListGetNextRecordData((*ppInvoiceEntry)->pListDeliveryNote);
		}
		LListErase((*ppInvoiceEntry)->pListDeliveryNote);
	}
	{
		TextType *pLocationNote
			= LListGetFirstRecordData((*ppInvoiceEntry)->pListLocationNote);
		while(pLocationNote) {
			DestroyText(&pLocationNote);		// rac:TextType
			pLocationNote = LListGetNextRecordData((*ppInvoiceEntry)->pListLocationNote);
		}
		LListErase((*ppInvoiceEntry)->pListLocationNote);
	}
	FreeString(&(*ppInvoiceEntry)->pLocation);		// xs:token
	LListDestroy((*ppInvoiceEntry)->pListDispatchFileUrl);		// rac:FileUrl
	FreeString(&(*ppInvoiceEntry)->pOrderId);		// xs:token
	FreeString(&(*ppInvoiceEntry)->pContractId);		// xs:token
	FreeString(&(*ppInvoiceEntry)->pPriceListId);		// xs:token
	LListDestroy((*ppInvoiceEntry)->pListOrderResponseFileUrl);		// rac:FileUrl
	LListDestroy((*ppInvoiceEntry)->pListSellersNoteToBuyer);		// xs:string
	FreeString(&(*ppInvoiceEntry)->pSuggestedBasAccount);		// xs:token
	FreeString(&(*ppInvoiceEntry)->pVatReduced);		// rac:VatReducedType
	FreeString(&(*ppInvoiceEntry)->pVatSpecial);		// rac:VatSpecialType
	LListDestroy((*ppInvoiceEntry)->pListVehicleVatDocFileUrl);		// rac:FileUrl
	{
		AttestType *pReceivingApproved
			= LListGetFirstRecordData((*ppInvoiceEntry)->pListReceivingApproved);
		while(pReceivingApproved) {
			DestroyAttest(&pReceivingApproved);		// rac:AttestType
			pReceivingApproved = LListGetNextRecordData((*ppInvoiceEntry)->pListReceivingApproved);
		}
		LListErase((*ppInvoiceEntry)->pListReceivingApproved);
	}
	DestroyInvoice(&(*ppInvoiceEntry)->pStackedInvoice);		// rac:InvoiceType
	DestroyDepreciations(&(*ppInvoiceEntry)->pDepreciation);		// rac:DepreciationsType

	free(*ppInvoiceEntry);
	*ppInvoiceEntry = 0;

	return 0;
}


/*********************************************************************

InvoiceEntryType *CopyInvoiceEntry(

*********************************************************************/
InvoiceEntryType *CopyInvoiceEntry(
	void *pStructDocTop, 
	void *pStructParent, 
	InvoiceEntryType *pInvoiceEntry)
{
	if(pInvoiceEntry) {
		InvoiceEntryType *pNewInvoiceEntry = CreateInvoiceEntry(pStructDocTop, pStructParent);

		if(!pNewInvoiceEntry)
			return 0;	// Fatal error

		pNewInvoiceEntry->Quantity = pInvoiceEntry->Quantity;		// xs:decimal
		{
			TextType *pDescription
				= LListGetFirstRecordData(pInvoiceEntry->pListDescription);
			while(pDescription) {
				LListAddRecord(pNewInvoiceEntry->pListDescription, CopyText(pStructDocTop, pNewInvoiceEntry, pDescription));		// rac:TextType
				pDescription = LListGetNextRecordData(pInvoiceEntry->pListDescription);
			}
		}
		{
			TradeItemDataType *pTradeItemData
				= LListGetFirstRecordData(pInvoiceEntry->pListTradeItemData);
			while(pTradeItemData) {
				LListAddRecord(pNewInvoiceEntry->pListTradeItemData, CopyTradeItemData(pStructDocTop, pNewInvoiceEntry, pTradeItemData));		// rac:TradeItemDataType
				pTradeItemData = LListGetNextRecordData(pInvoiceEntry->pListTradeItemData);
			}
		}
		pNewInvoiceEntry->Quota = pInvoiceEntry->Quota;		// xs:decimal
		pNewInvoiceEntry->QuotaBalance = pInvoiceEntry->QuotaBalance;		// xs:decimal
		{
			TextType *pQuantityUnit
				= LListGetFirstRecordData(pInvoiceEntry->pListQuantityUnit);
			while(pQuantityUnit) {
				LListAddRecord(pNewInvoiceEntry->pListQuantityUnit, CopyText(pStructDocTop, pNewInvoiceEntry, pQuantityUnit));		// rac:TextType
				pQuantityUnit = LListGetNextRecordData(pInvoiceEntry->pListQuantityUnit);
			}
		}
		pNewInvoiceEntry->pQuotaAgreedUnitNetAmount = CopyAmountCurrency(pStructDocTop, pNewInvoiceEntry, pInvoiceEntry->pQuotaAgreedUnitNetAmount);		// rac:AmountCurrencyType
		CopyString(&pNewInvoiceEntry->pId, pInvoiceEntry->pId);		// xs:token
		pNewInvoiceEntry->pInvoiceId = CopySeriesId(pStructDocTop, pNewInvoiceEntry, pInvoiceEntry->pInvoiceId);		// rac:SeriesIdType
		pNewInvoiceEntry->AccountingDate = pInvoiceEntry->AccountingDate;		// xs:date
		pNewInvoiceEntry->AvailabilityDate = pInvoiceEntry->AvailabilityDate;		// xs:date
		pNewInvoiceEntry->RateOfIntrestDate = pInvoiceEntry->RateOfIntrestDate;		// xs:date
		{
			char *pSalesReference
				= LListGetFirstRecordData(pInvoiceEntry->pListSalesReference);
			while(pSalesReference) {
				LListAddRecord(pNewInvoiceEntry->pListSalesReference, CopyString(0, pSalesReference));		// xs:token
				pSalesReference = LListGetNextRecordData(pInvoiceEntry->pListSalesReference);
			}
		}
		{
			ObjectType *pSalesObject
				= LListGetFirstRecordData(pInvoiceEntry->pListSalesObject);
			while(pSalesObject) {
				LListAddRecord(pNewInvoiceEntry->pListSalesObject, SearchSetObject(((AccountingType *)pStructDocTop)->pObjectsChart->pListDimension, CopyObject(pStructDocTop, pNewInvoiceEntry, pSalesObject)));		// rac:ObjectType
				pSalesObject = LListGetNextRecordData(pInvoiceEntry->pListSalesObject);
			}
		}
		{
			char *pCostReference
				= LListGetFirstRecordData(pInvoiceEntry->pListCostReference);
			while(pCostReference) {
				LListAddRecord(pNewInvoiceEntry->pListCostReference, CopyString(0, pCostReference));		// xs:token
				pCostReference = LListGetNextRecordData(pInvoiceEntry->pListCostReference);
			}
		}
		{
			ObjectType *pCostObject
				= LListGetFirstRecordData(pInvoiceEntry->pListCostObject);
			while(pCostObject) {
				LListAddRecord(pNewInvoiceEntry->pListCostObject, SearchSetObject(((AccountingType *)pStructDocTop)->pObjectsChart->pListDimension, CopyObject(pStructDocTop, pNewInvoiceEntry, pCostObject)));		// rac:ObjectType
				pCostObject = LListGetNextRecordData(pInvoiceEntry->pListCostObject);
			}
		}
		{
			TextType *pNote
				= LListGetFirstRecordData(pInvoiceEntry->pListNote);
			while(pNote) {
				LListAddRecord(pNewInvoiceEntry->pListNote, CopyText(pStructDocTop, pNewInvoiceEntry, pNote));		// rac:TextType
				pNote = LListGetNextRecordData(pInvoiceEntry->pListNote);
			}
		}
		pNewInvoiceEntry->DeliveryDate = pInvoiceEntry->DeliveryDate;		// xs:date
		{
			TextType *pDeliveryNote
				= LListGetFirstRecordData(pInvoiceEntry->pListDeliveryNote);
			while(pDeliveryNote) {
				LListAddRecord(pNewInvoiceEntry->pListDeliveryNote, CopyText(pStructDocTop, pNewInvoiceEntry, pDeliveryNote));		// rac:TextType
				pDeliveryNote = LListGetNextRecordData(pInvoiceEntry->pListDeliveryNote);
			}
		}
		{
			TextType *pLocationNote
				= LListGetFirstRecordData(pInvoiceEntry->pListLocationNote);
			while(pLocationNote) {
				LListAddRecord(pNewInvoiceEntry->pListLocationNote, CopyText(pStructDocTop, pNewInvoiceEntry, pLocationNote));		// rac:TextType
				pLocationNote = LListGetNextRecordData(pInvoiceEntry->pListLocationNote);
			}
		}
		CopyString(&pNewInvoiceEntry->pLocation, pInvoiceEntry->pLocation);		// xs:token
		{
			char *pDispatchFileUrl
				= LListGetFirstRecordData(pInvoiceEntry->pListDispatchFileUrl);
			while(pDispatchFileUrl) {
				LListAddRecord(pNewInvoiceEntry->pListDispatchFileUrl, CopyString(0, pDispatchFileUrl));		// rac:FileUrl
				pDispatchFileUrl = LListGetNextRecordData(pInvoiceEntry->pListDispatchFileUrl);
			}
		}
		CopyString(&pNewInvoiceEntry->pOrderId, pInvoiceEntry->pOrderId);		// xs:token
		CopyString(&pNewInvoiceEntry->pContractId, pInvoiceEntry->pContractId);		// xs:token
		CopyString(&pNewInvoiceEntry->pPriceListId, pInvoiceEntry->pPriceListId);		// xs:token
		{
			char *pOrderResponseFileUrl
				= LListGetFirstRecordData(pInvoiceEntry->pListOrderResponseFileUrl);
			while(pOrderResponseFileUrl) {
				LListAddRecord(pNewInvoiceEntry->pListOrderResponseFileUrl, CopyString(0, pOrderResponseFileUrl));		// rac:FileUrl
				pOrderResponseFileUrl = LListGetNextRecordData(pInvoiceEntry->pListOrderResponseFileUrl);
			}
		}
		{
			char *pSellersNoteToBuyer
				= LListGetFirstRecordData(pInvoiceEntry->pListSellersNoteToBuyer);
			while(pSellersNoteToBuyer) {
				LListAddRecord(pNewInvoiceEntry->pListSellersNoteToBuyer, CopyString(0, pSellersNoteToBuyer));		// xs:string
				pSellersNoteToBuyer = LListGetNextRecordData(pInvoiceEntry->pListSellersNoteToBuyer);
			}
		}
		CopyString(&pNewInvoiceEntry->pSuggestedBasAccount, pInvoiceEntry->pSuggestedBasAccount);		// xs:token
		pNewInvoiceEntry->UnitNetAmount = pInvoiceEntry->UnitNetAmount;		// rac:Amount
		pNewInvoiceEntry->NetAmount = pInvoiceEntry->NetAmount;		// rac:Amount
		CopyString(&pNewInvoiceEntry->pVatReduced, pInvoiceEntry->pVatReduced);		// rac:VatReducedType
		CopyString(&pNewInvoiceEntry->pVatSpecial, pInvoiceEntry->pVatSpecial);		// rac:VatSpecialType
		{
			char *pVehicleVatDocFileUrl
				= LListGetFirstRecordData(pInvoiceEntry->pListVehicleVatDocFileUrl);
			while(pVehicleVatDocFileUrl) {
				LListAddRecord(pNewInvoiceEntry->pListVehicleVatDocFileUrl, CopyString(0, pVehicleVatDocFileUrl));		// rac:FileUrl
				pVehicleVatDocFileUrl = LListGetNextRecordData(pInvoiceEntry->pListVehicleVatDocFileUrl);
			}
		}
		pNewInvoiceEntry->VatRate = pInvoiceEntry->VatRate;		// xs:decimal
		pNewInvoiceEntry->VatAmountTaxCurrency = pInvoiceEntry->VatAmountTaxCurrency;		// rac:Amount
		pNewInvoiceEntry->PayAmount = pInvoiceEntry->PayAmount;		// rac:Amount
		{
			AttestType *pReceivingApproved
				= LListGetFirstRecordData(pInvoiceEntry->pListReceivingApproved);
			while(pReceivingApproved) {
				LListAddRecord(pNewInvoiceEntry->pListReceivingApproved, CopyAttest(pStructDocTop, pNewInvoiceEntry, pReceivingApproved));		// rac:AttestType
				pReceivingApproved = LListGetNextRecordData(pInvoiceEntry->pListReceivingApproved);
			}
		}
		pNewInvoiceEntry->pStackedInvoice = CopyInvoice(pStructDocTop, pNewInvoiceEntry, pInvoiceEntry->pStackedInvoice);		// rac:InvoiceType
		pNewInvoiceEntry->pDepreciation = CopyDepreciations(pStructDocTop, pNewInvoiceEntry, pInvoiceEntry->pDepreciation);		// rac:DepreciationsType

		return (pNewInvoiceEntry);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataInvoiceEntry(

*********************************************************************/
BOOL IsDataInvoiceEntry(
	InvoiceEntryType *pInvoiceEntry)
{
	if(!pInvoiceEntry)
		return FALSE;

	if(!DecimalCmp(pInvoiceEntry->Quantity, 0))
		return TRUE;
	{
		TextType *pDescription
			= LListGetFirstRecordData(pInvoiceEntry->pListDescription);
		while(pDescription) {
			if(IsDataText(pDescription))
				return TRUE;
			pDescription = LListGetNextRecordData(pInvoiceEntry->pListDescription);
		}
	}
	{
		TradeItemDataType *pTradeItemData
			= LListGetFirstRecordData(pInvoiceEntry->pListTradeItemData);
		while(pTradeItemData) {
			if(IsDataTradeItemData(pTradeItemData))
				return TRUE;
			pTradeItemData = LListGetNextRecordData(pInvoiceEntry->pListTradeItemData);
		}
	}
	if(!DecimalCmp(pInvoiceEntry->Quota, 0))
		return TRUE;
	if(!DecimalCmp(pInvoiceEntry->QuotaBalance, 0))
		return TRUE;
	{
		TextType *pQuantityUnit
			= LListGetFirstRecordData(pInvoiceEntry->pListQuantityUnit);
		while(pQuantityUnit) {
			if(IsDataText(pQuantityUnit))
				return TRUE;
			pQuantityUnit = LListGetNextRecordData(pInvoiceEntry->pListQuantityUnit);
		}
	}
	if(IsDataAmountCurrency(pInvoiceEntry->pQuotaAgreedUnitNetAmount))
		return TRUE;
	if(pInvoiceEntry->pId && *pInvoiceEntry->pId)
		return TRUE;
	if(IsDataSeriesId(pInvoiceEntry->pInvoiceId))
		return TRUE;
	if(pInvoiceEntry->AccountingDate)
		return TRUE;
	if(pInvoiceEntry->AvailabilityDate)
		return TRUE;
	if(pInvoiceEntry->RateOfIntrestDate)
		return TRUE;
	if(LListGetFirstRecordData(pInvoiceEntry->pListSalesReference))
		return TRUE;
	if(LListGetFirstRecordData(pInvoiceEntry->pListCostReference))
		return TRUE;
	{
		TextType *pNote
			= LListGetFirstRecordData(pInvoiceEntry->pListNote);
		while(pNote) {
			if(IsDataText(pNote))
				return TRUE;
			pNote = LListGetNextRecordData(pInvoiceEntry->pListNote);
		}
	}
	if(pInvoiceEntry->DeliveryDate)
		return TRUE;
	{
		TextType *pDeliveryNote
			= LListGetFirstRecordData(pInvoiceEntry->pListDeliveryNote);
		while(pDeliveryNote) {
			if(IsDataText(pDeliveryNote))
				return TRUE;
			pDeliveryNote = LListGetNextRecordData(pInvoiceEntry->pListDeliveryNote);
		}
	}
	{
		TextType *pLocationNote
			= LListGetFirstRecordData(pInvoiceEntry->pListLocationNote);
		while(pLocationNote) {
			if(IsDataText(pLocationNote))
				return TRUE;
			pLocationNote = LListGetNextRecordData(pInvoiceEntry->pListLocationNote);
		}
	}
	if(pInvoiceEntry->pLocation && *pInvoiceEntry->pLocation)
		return TRUE;
	if(LListGetFirstRecordData(pInvoiceEntry->pListDispatchFileUrl))
		return TRUE;
	if(pInvoiceEntry->pOrderId && *pInvoiceEntry->pOrderId)
		return TRUE;
	if(pInvoiceEntry->pContractId && *pInvoiceEntry->pContractId)
		return TRUE;
	if(pInvoiceEntry->pPriceListId && *pInvoiceEntry->pPriceListId)
		return TRUE;
	if(LListGetFirstRecordData(pInvoiceEntry->pListOrderResponseFileUrl))
		return TRUE;
	if(LListGetFirstRecordData(pInvoiceEntry->pListSellersNoteToBuyer))
		return TRUE;
	if(pInvoiceEntry->pSuggestedBasAccount && *pInvoiceEntry->pSuggestedBasAccount)
		return TRUE;
	if(pInvoiceEntry->UnitNetAmount)
		return TRUE;
	if(pInvoiceEntry->NetAmount)
		return TRUE;
	if(pInvoiceEntry->pVatReduced && *pInvoiceEntry->pVatReduced)
		return TRUE;
	if(pInvoiceEntry->pVatSpecial && *pInvoiceEntry->pVatSpecial)
		return TRUE;
	if(LListGetFirstRecordData(pInvoiceEntry->pListVehicleVatDocFileUrl))
		return TRUE;
	if(!DecimalCmp(pInvoiceEntry->VatRate, 0))
		return TRUE;
	if(pInvoiceEntry->VatAmountTaxCurrency)
		return TRUE;
	if(pInvoiceEntry->PayAmount)
		return TRUE;
	{
		AttestType *pReceivingApproved
			= LListGetFirstRecordData(pInvoiceEntry->pListReceivingApproved);
		while(pReceivingApproved) {
			if(IsDataAttest(pReceivingApproved))
				return TRUE;
			pReceivingApproved = LListGetNextRecordData(pInvoiceEntry->pListReceivingApproved);
		}
	}
	if(IsDataInvoice(pInvoiceEntry->pStackedInvoice))
		return TRUE;
	if(IsDataDepreciations(pInvoiceEntry->pDepreciation))
		return TRUE;

	return FALSE;
}


/*********************************************************************

static InvoiceEntryType *ReadSectionInvoiceEntry(

*********************************************************************/
static InvoiceEntryType *ReadSectionInvoiceEntry(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
InvoiceEntryType *pInvoiceEntry = CreateInvoiceEntry(pStructDocTop, pStructParent);

	if(!pInvoiceEntry)
		return 0;	// Fatal error

	pXmlTagData=GetNextXmlTag(pXmlTagData);

	if(!pXmlTagData)
		return 0;	// Fatal error

	while(strcmp(pXmlTagData->pTag, pEndTag)) { // While is not the end
		if(!strcmp(pXmlTagData->pTag, "Quantity"))
			pInvoiceEntry->Quantity = StringToDecimal(pXmlTagData->pData);		// xs:decimal
		else if(!strcmp(pXmlTagData->pTag, "Description"))
			SearchSetText(pInvoiceEntry->pListDescription, ReadSectionText(pStructDocTop, pInvoiceEntry, pXmlTagData, "Description"));		// rac:TextType
		else if(!strcmp(pXmlTagData->pTag, "TradeItemData"))
			LListAddRecord(pInvoiceEntry->pListTradeItemData, ReadSectionTradeItemData(pStructDocTop, pInvoiceEntry, pXmlTagData, "TradeItemData"));		// rac:TradeItemDataType
		else if(!strcmp(pXmlTagData->pTag, "Quota"))
			pInvoiceEntry->Quota = StringToDecimal(pXmlTagData->pData);		// xs:decimal
		else if(!strcmp(pXmlTagData->pTag, "QuotaBalance"))
			pInvoiceEntry->QuotaBalance = StringToDecimal(pXmlTagData->pData);		// xs:decimal
		else if(!strcmp(pXmlTagData->pTag, "QuantityUnit"))
			SearchSetText(pInvoiceEntry->pListQuantityUnit, ReadSectionText(pStructDocTop, pInvoiceEntry, pXmlTagData, "QuantityUnit"));		// rac:TextType
		else if(!strcmp(pXmlTagData->pTag, "QuotaAgreedUnitNetAmount"))
			pInvoiceEntry->pQuotaAgreedUnitNetAmount = ReadSectionAmountCurrency(pStructDocTop, pInvoiceEntry, pXmlTagData, "QuotaAgreedUnitNetAmount");		// rac:AmountCurrencyType
		else if(!strcmp(pXmlTagData->pTag, "Id"))
			ReadString(&pInvoiceEntry->pId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "InvoiceId"))
			pInvoiceEntry->pInvoiceId = ReadSectionSeriesId(pStructDocTop, pInvoiceEntry, pXmlTagData, "InvoiceId");		// rac:SeriesIdType
		else if(!strcmp(pXmlTagData->pTag, "AccountingDate"))
			pInvoiceEntry->AccountingDate = StringToDate(pXmlTagData->pData);		// xs:date
		else if(!strcmp(pXmlTagData->pTag, "AvailabilityDate"))
			pInvoiceEntry->AvailabilityDate = StringToDate(pXmlTagData->pData);		// xs:date
		else if(!strcmp(pXmlTagData->pTag, "RateOfIntrestDate"))
			pInvoiceEntry->RateOfIntrestDate = StringToDate(pXmlTagData->pData);		// xs:date
		else if(!strcmp(pXmlTagData->pTag, "SalesReference"))
			LListAddRecord(pInvoiceEntry->pListSalesReference, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "SalesObject"))
			LListAddRecord(pInvoiceEntry->pListSalesObject, SearchSetObject(((AccountingType *)pStructDocTop)->pObjectsChart->pListDimension, ReadSectionObject(pStructDocTop, pInvoiceEntry, pXmlTagData, "SalesObject")));		// rac:ObjectType
		else if(!strcmp(pXmlTagData->pTag, "CostReference"))
			LListAddRecord(pInvoiceEntry->pListCostReference, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "CostObject"))
			LListAddRecord(pInvoiceEntry->pListCostObject, SearchSetObject(((AccountingType *)pStructDocTop)->pObjectsChart->pListDimension, ReadSectionObject(pStructDocTop, pInvoiceEntry, pXmlTagData, "CostObject")));		// rac:ObjectType
		else if(!strcmp(pXmlTagData->pTag, "Note"))
			SearchSetText(pInvoiceEntry->pListNote, ReadSectionText(pStructDocTop, pInvoiceEntry, pXmlTagData, "Note"));		// rac:TextType
		else if(!strcmp(pXmlTagData->pTag, "DeliveryDate"))
			pInvoiceEntry->DeliveryDate = StringToDate(pXmlTagData->pData);		// xs:date
		else if(!strcmp(pXmlTagData->pTag, "DeliveryNote"))
			SearchSetText(pInvoiceEntry->pListDeliveryNote, ReadSectionText(pStructDocTop, pInvoiceEntry, pXmlTagData, "DeliveryNote"));		// rac:TextType
		else if(!strcmp(pXmlTagData->pTag, "LocationNote"))
			SearchSetText(pInvoiceEntry->pListLocationNote, ReadSectionText(pStructDocTop, pInvoiceEntry, pXmlTagData, "LocationNote"));		// rac:TextType
		else if(!strcmp(pXmlTagData->pTag, "Location"))
			ReadString(&pInvoiceEntry->pLocation, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "DispatchFileUrl"))
			LListAddRecord(pInvoiceEntry->pListDispatchFileUrl, ReadXmlDataString(pXmlTagData->pData));		// rac:FileUrl
		else if(!strcmp(pXmlTagData->pTag, "OrderId"))
			ReadString(&pInvoiceEntry->pOrderId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "ContractId"))
			ReadString(&pInvoiceEntry->pContractId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "PriceListId"))
			ReadString(&pInvoiceEntry->pPriceListId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "OrderResponseFileUrl"))
			LListAddRecord(pInvoiceEntry->pListOrderResponseFileUrl, ReadXmlDataString(pXmlTagData->pData));		// rac:FileUrl
		else if(!strcmp(pXmlTagData->pTag, "SellersNoteToBuyer"))
			LListAddRecord(pInvoiceEntry->pListSellersNoteToBuyer, ReadXmlDataString(pXmlTagData->pData));		// xs:string
		else if(!strcmp(pXmlTagData->pTag, "SuggestedBasAccount"))
			ReadString(&pInvoiceEntry->pSuggestedBasAccount, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "UnitNetAmount"))
			pInvoiceEntry->UnitNetAmount = StringToAmount(pXmlTagData->pData);		// rac:Amount
		else if(!strcmp(pXmlTagData->pTag, "NetAmount"))
			pInvoiceEntry->NetAmount = StringToAmount(pXmlTagData->pData);		// rac:Amount
		else if(!strcmp(pXmlTagData->pTag, "VatReduced"))
			CheckEnum(&pInvoiceEntry->pVatReduced, EnumVatReducedType, ReadXmlDataString(pXmlTagData->pData));		// rac:VatReducedType
		else if(!strcmp(pXmlTagData->pTag, "VatSpecial"))
			CheckEnum(&pInvoiceEntry->pVatSpecial, EnumVatSpecialType, ReadXmlDataString(pXmlTagData->pData));		// rac:VatSpecialType
		else if(!strcmp(pXmlTagData->pTag, "VehicleVatDocFileUrl"))
			LListAddRecord(pInvoiceEntry->pListVehicleVatDocFileUrl, ReadXmlDataString(pXmlTagData->pData));		// rac:FileUrl
		else if(!strcmp(pXmlTagData->pTag, "VatRate"))
			pInvoiceEntry->VatRate = StringToDecimal(pXmlTagData->pData);		// xs:decimal
		else if(!strcmp(pXmlTagData->pTag, "VatAmountTaxCurrency"))
			pInvoiceEntry->VatAmountTaxCurrency = StringToAmount(pXmlTagData->pData);		// rac:Amount
		else if(!strcmp(pXmlTagData->pTag, "PayAmount"))
			pInvoiceEntry->PayAmount = StringToAmount(pXmlTagData->pData);		// rac:Amount
		else if(!strcmp(pXmlTagData->pTag, "ReceivingApproved"))
			LListAddRecord(pInvoiceEntry->pListReceivingApproved, ReadSectionAttest(pStructDocTop, pInvoiceEntry, pXmlTagData, "ReceivingApproved"));		// rac:AttestType
		else if(!strcmp(pXmlTagData->pTag, "StackedInvoice"))
			pInvoiceEntry->pStackedInvoice = ReadSectionInvoice(pStructDocTop, pInvoiceEntry, pXmlTagData, "StackedInvoice");		// rac:InvoiceType
		else if(!strcmp(pXmlTagData->pTag, "Depreciation"))
			pInvoiceEntry->pDepreciation = ReadSectionDepreciations(pStructDocTop, pInvoiceEntry, pXmlTagData, "Depreciation");		// rac:DepreciationsType

		pXmlTagData=GetNextXmlTag(pXmlTagData);

		if(!pXmlTagData)
			return 0;	// Fatal error
	}
	return pInvoiceEntry;
}


/*********************************************************************

static BOOL WriteSectionInvoiceEntry(

*********************************************************************/
static BOOL WriteSectionInvoiceEntry(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	InvoiceEntryType *pInvoiceEntry)
{
	if(!pInvoiceEntry)
		return FALSE;	// Fatal error

	xmlWriteLine(pStream, iTab-1, pAttr, pLabel, 0, 0);
	if(!DecimalCmp(pInvoiceEntry->Quantity, 0))
		xmlWriteLine(pStream, iTab, 0, "Quantity", DecimalToStr(pInvoiceEntry->Quantity, szString),"Quantity");		// xs:decimal

	if(pInvoiceEntry->pListDescription) {
		TextType *pDescription
			= LListGetFirstRecordData(pInvoiceEntry->pListDescription);
		while(pDescription) {
			if(IsDataText(pDescription))
				WriteSectionText(pStream, iTab+1, "Description", 0, pDescription);		// rac:TextType
			pDescription = LListGetNextRecordData(pInvoiceEntry->pListDescription);
		}
	}

	if(pInvoiceEntry->pListTradeItemData) {
		TradeItemDataType *pTradeItemData
			= LListGetFirstRecordData(pInvoiceEntry->pListTradeItemData);
		while(pTradeItemData) {
			if(IsDataTradeItemData(pTradeItemData))
				WriteSectionTradeItemData(pStream, iTab+1, "TradeItemData", 0, pTradeItemData);		// rac:TradeItemDataType
			pTradeItemData = LListGetNextRecordData(pInvoiceEntry->pListTradeItemData);
		}
	}
	if(!DecimalCmp(pInvoiceEntry->Quota, 0))
		xmlWriteLine(pStream, iTab, 0, "Quota", DecimalToStr(pInvoiceEntry->Quota, szString),"Quota");		// xs:decimal
	if(!DecimalCmp(pInvoiceEntry->QuotaBalance, 0))
		xmlWriteLine(pStream, iTab, 0, "QuotaBalance", DecimalToStr(pInvoiceEntry->QuotaBalance, szString),"QuotaBalance");		// xs:decimal

	if(pInvoiceEntry->pListQuantityUnit) {
		TextType *pQuantityUnit
			= LListGetFirstRecordData(pInvoiceEntry->pListQuantityUnit);
		while(pQuantityUnit) {
			if(IsDataText(pQuantityUnit))
				WriteSectionText(pStream, iTab+1, "QuantityUnit", 0, pQuantityUnit);		// rac:TextType
			pQuantityUnit = LListGetNextRecordData(pInvoiceEntry->pListQuantityUnit);
		}
	}

	if(pInvoiceEntry->pQuotaAgreedUnitNetAmount && IsDataAmountCurrency(pInvoiceEntry->pQuotaAgreedUnitNetAmount))		// Optional
		WriteSectionAmountCurrency(pStream, iTab+1, "QuotaAgreedUnitNetAmount", 0, pInvoiceEntry->pQuotaAgreedUnitNetAmount);		// rac:AmountCurrencyType
	if(pInvoiceEntry->pId && *pInvoiceEntry->pId)
		xmlWriteLine(pStream, iTab, 0, "Id", pInvoiceEntry->pId, "Id");		// xs:token

	if(pInvoiceEntry->pInvoiceId && IsDataSeriesId(pInvoiceEntry->pInvoiceId))		// Optional
		WriteSectionSeriesId(pStream, iTab+1, "InvoiceId", 0, pInvoiceEntry->pInvoiceId);		// rac:SeriesIdType
	if(pInvoiceEntry->AccountingDate)
		xmlWriteLine(pStream, iTab, 0, "AccountingDate", DateToStr(pInvoiceEntry->AccountingDate, szString),"AccountingDate");		// xs:date
	if(pInvoiceEntry->AvailabilityDate)
		xmlWriteLine(pStream, iTab, 0, "AvailabilityDate", DateToStr(pInvoiceEntry->AvailabilityDate, szString),"AvailabilityDate");		// xs:date
	if(pInvoiceEntry->RateOfIntrestDate)
		xmlWriteLine(pStream, iTab, 0, "RateOfIntrestDate", DateToStr(pInvoiceEntry->RateOfIntrestDate, szString),"RateOfIntrestDate");		// xs:date

	if(pInvoiceEntry->pListSalesReference) {
		char *pSalesReference
			= LListGetFirstRecordData(pInvoiceEntry->pListSalesReference);
		while(pSalesReference) {
			xmlWriteLine(pStream, iTab, 0, "SalesReference", pSalesReference, "SalesReference");		// xs:token

			pSalesReference = LListGetNextRecordData(pInvoiceEntry->pListSalesReference);
		}
	}

	if(pInvoiceEntry->pListSalesObject) {
		ObjectType *pSalesObject
			= LListGetFirstRecordData(pInvoiceEntry->pListSalesObject);
		while(pSalesObject) {
			if(IsDataObject(pSalesObject))
				WriteSectionObject(pStream, iTab+1, "SalesObject", 0, pSalesObject, TRUE);		// rac:ObjectType
			pSalesObject = LListGetNextRecordData(pInvoiceEntry->pListSalesObject);
		}
	}

	if(pInvoiceEntry->pListCostReference) {
		char *pCostReference
			= LListGetFirstRecordData(pInvoiceEntry->pListCostReference);
		while(pCostReference) {
			xmlWriteLine(pStream, iTab, 0, "CostReference", pCostReference, "CostReference");		// xs:token

			pCostReference = LListGetNextRecordData(pInvoiceEntry->pListCostReference);
		}
	}

	if(pInvoiceEntry->pListCostObject) {
		ObjectType *pCostObject
			= LListGetFirstRecordData(pInvoiceEntry->pListCostObject);
		while(pCostObject) {
			if(IsDataObject(pCostObject))
				WriteSectionObject(pStream, iTab+1, "CostObject", 0, pCostObject, TRUE);		// rac:ObjectType
			pCostObject = LListGetNextRecordData(pInvoiceEntry->pListCostObject);
		}
	}

	if(pInvoiceEntry->pListNote) {
		TextType *pNote
			= LListGetFirstRecordData(pInvoiceEntry->pListNote);
		BOOL bMandatory=1;
		if(!pNote) {		// Mandatory at least once
			pNote = CreateText(pInvoiceEntry->pStructDocTop, pInvoiceEntry);
			LListAddRecord(pInvoiceEntry->pListNote, pNote);
		}
		while(pNote) {
			if(IsDataText(pNote) || (bMandatory))bMandatory=0;
				
				WriteSectionText(pStream, iTab+1, "Note", 0, pNote);		// rac:TextType
			pNote = LListGetNextRecordData(pInvoiceEntry->pListNote);
		}
	}
	if(pInvoiceEntry->DeliveryDate)
		xmlWriteLine(pStream, iTab, 0, "DeliveryDate", DateToStr(pInvoiceEntry->DeliveryDate, szString),"DeliveryDate");		// xs:date

	if(pInvoiceEntry->pListDeliveryNote) {
		TextType *pDeliveryNote
			= LListGetFirstRecordData(pInvoiceEntry->pListDeliveryNote);
		while(pDeliveryNote) {
			if(IsDataText(pDeliveryNote))
				WriteSectionText(pStream, iTab+1, "DeliveryNote", 0, pDeliveryNote);		// rac:TextType
			pDeliveryNote = LListGetNextRecordData(pInvoiceEntry->pListDeliveryNote);
		}
	}

	if(pInvoiceEntry->pListLocationNote) {
		TextType *pLocationNote
			= LListGetFirstRecordData(pInvoiceEntry->pListLocationNote);
		while(pLocationNote) {
			if(IsDataText(pLocationNote))
				WriteSectionText(pStream, iTab+1, "LocationNote", 0, pLocationNote);		// rac:TextType
			pLocationNote = LListGetNextRecordData(pInvoiceEntry->pListLocationNote);
		}
	}
	if(pInvoiceEntry->pLocation && *pInvoiceEntry->pLocation)
		xmlWriteLine(pStream, iTab, 0, "Location", pInvoiceEntry->pLocation, "Location");		// xs:token

	if(pInvoiceEntry->pListDispatchFileUrl) {
		char *pDispatchFileUrl
			= LListGetFirstRecordData(pInvoiceEntry->pListDispatchFileUrl);
		while(pDispatchFileUrl) {
			xmlWriteLine(pStream, iTab, 0, "DispatchFileUrl", pDispatchFileUrl, "DispatchFileUrl");		// rac:FileUrl

			pDispatchFileUrl = LListGetNextRecordData(pInvoiceEntry->pListDispatchFileUrl);
		}
	}
	if(pInvoiceEntry->pOrderId && *pInvoiceEntry->pOrderId)
		xmlWriteLine(pStream, iTab, 0, "OrderId", pInvoiceEntry->pOrderId, "OrderId");		// xs:token
	if(pInvoiceEntry->pContractId && *pInvoiceEntry->pContractId)
		xmlWriteLine(pStream, iTab, 0, "ContractId", pInvoiceEntry->pContractId, "ContractId");		// xs:token
	if(pInvoiceEntry->pPriceListId && *pInvoiceEntry->pPriceListId)
		xmlWriteLine(pStream, iTab, 0, "PriceListId", pInvoiceEntry->pPriceListId, "PriceListId");		// xs:token

	if(pInvoiceEntry->pListOrderResponseFileUrl) {
		char *pOrderResponseFileUrl
			= LListGetFirstRecordData(pInvoiceEntry->pListOrderResponseFileUrl);
		while(pOrderResponseFileUrl) {
			xmlWriteLine(pStream, iTab, 0, "OrderResponseFileUrl", pOrderResponseFileUrl, "OrderResponseFileUrl");		// rac:FileUrl

			pOrderResponseFileUrl = LListGetNextRecordData(pInvoiceEntry->pListOrderResponseFileUrl);
		}
	}

	if(pInvoiceEntry->pListSellersNoteToBuyer) {
		char *pSellersNoteToBuyer
			= LListGetFirstRecordData(pInvoiceEntry->pListSellersNoteToBuyer);
		while(pSellersNoteToBuyer) {
			xmlWriteLine(pStream, iTab, 0, "SellersNoteToBuyer", pSellersNoteToBuyer, "SellersNoteToBuyer");		// xs:string

			pSellersNoteToBuyer = LListGetNextRecordData(pInvoiceEntry->pListSellersNoteToBuyer);
		}
	}
	if(pInvoiceEntry->pSuggestedBasAccount && *pInvoiceEntry->pSuggestedBasAccount)
		xmlWriteLine(pStream, iTab, 0, "SuggestedBasAccount", pInvoiceEntry->pSuggestedBasAccount, "SuggestedBasAccount");		// xs:token
	if(pInvoiceEntry->UnitNetAmount)
		xmlWriteLine(pStream, iTab, 0, "UnitNetAmount", AmountToStr(pInvoiceEntry->UnitNetAmount, szString),"UnitNetAmount");		// rac:Amount
	xmlWriteLine(pStream, iTab, 0, "NetAmount", AmountToStr(pInvoiceEntry->NetAmount, szString),"NetAmount");		// rac:Amount - Mandatory
	if(pInvoiceEntry->pVatReduced && *pInvoiceEntry->pVatReduced)
		xmlWriteLine(pStream, iTab, 0, "VatReduced", pInvoiceEntry->pVatReduced, "VatReduced");		// rac:VatReducedType
	if(pInvoiceEntry->pVatSpecial && *pInvoiceEntry->pVatSpecial)
		xmlWriteLine(pStream, iTab, 0, "VatSpecial", pInvoiceEntry->pVatSpecial, "VatSpecial");		// rac:VatSpecialType

	if(pInvoiceEntry->pListVehicleVatDocFileUrl) {
		char *pVehicleVatDocFileUrl
			= LListGetFirstRecordData(pInvoiceEntry->pListVehicleVatDocFileUrl);
		while(pVehicleVatDocFileUrl) {
			xmlWriteLine(pStream, iTab, 0, "VehicleVatDocFileUrl", pVehicleVatDocFileUrl, "VehicleVatDocFileUrl");		// rac:FileUrl

			pVehicleVatDocFileUrl = LListGetNextRecordData(pInvoiceEntry->pListVehicleVatDocFileUrl);
		}
	}
	if(!DecimalCmp(pInvoiceEntry->VatRate, 0))
		xmlWriteLine(pStream, iTab, 0, "VatRate", DecimalToStr(pInvoiceEntry->VatRate, szString),"VatRate");		// xs:decimal
	if(pInvoiceEntry->VatAmountTaxCurrency)
		xmlWriteLine(pStream, iTab, 0, "VatAmountTaxCurrency", AmountToStr(pInvoiceEntry->VatAmountTaxCurrency, szString),"VatAmountTaxCurrency");		// rac:Amount
	xmlWriteLine(pStream, iTab, 0, "PayAmount", AmountToStr(pInvoiceEntry->PayAmount, szString),"PayAmount");		// rac:Amount - Mandatory

	if(pInvoiceEntry->pListReceivingApproved) {
		AttestType *pReceivingApproved
			= LListGetFirstRecordData(pInvoiceEntry->pListReceivingApproved);
		while(pReceivingApproved) {
			if(IsDataAttest(pReceivingApproved))
				WriteSectionAttest(pStream, iTab+1, "ReceivingApproved", 0, pReceivingApproved);		// rac:AttestType
			pReceivingApproved = LListGetNextRecordData(pInvoiceEntry->pListReceivingApproved);
		}
	}

	if(pInvoiceEntry->pStackedInvoice && IsDataInvoice(pInvoiceEntry->pStackedInvoice))		// Optional
		WriteSectionInvoice(pStream, iTab+1, "StackedInvoice", 0, pInvoiceEntry->pStackedInvoice);		// rac:InvoiceType

	if(pInvoiceEntry->pDepreciation && IsDataDepreciations(pInvoiceEntry->pDepreciation))		// Optional
		WriteSectionDepreciations(pStream, iTab+1, "Depreciation", 0, pInvoiceEntry->pDepreciation);		// rac:DepreciationsType

	xmlWriteLine(pStream, iTab-1, 0, 0, 0, pLabel);

	return TRUE;
}


/*********************************************************************

InvoiceEntryType *UpdateInvoiceEntry(

*********************************************************************/
InvoiceEntryType *UpdateInvoiceEntry(
	InvoiceEntryType *pStructInvoiceEntry, 
	QUANT Quantity, 
	QUANT Quota, 
	QUANT QuotaBalance, 
	char *pId, 
	DATEINT AccountingDate, 
	DATEINT AvailabilityDate, 
	DATEINT RateOfIntrestDate, 
	DATEINT DeliveryDate, 
	char *pLocation, 
	char *pOrderId, 
	char *pContractId, 
	char *pPriceListId, 
	char *pSuggestedBasAccount, 
	AMOUNT UnitNetAmount, 
	AMOUNT NetAmount, 
	char *pVatReduced, 
	char *pVatSpecial, 
	QUANT VatRate, 
	AMOUNT VatAmountTaxCurrency, 
	AMOUNT PayAmount)
{
	pStructInvoiceEntry->Quantity = Quantity;
	pStructInvoiceEntry->Quota = Quota;
	pStructInvoiceEntry->QuotaBalance = QuotaBalance;
	StringUpdate(&pStructInvoiceEntry->pId, pId);
	pStructInvoiceEntry->AccountingDate = AccountingDate;
	pStructInvoiceEntry->AvailabilityDate = AvailabilityDate;
	pStructInvoiceEntry->RateOfIntrestDate = RateOfIntrestDate;
	pStructInvoiceEntry->DeliveryDate = DeliveryDate;
	StringUpdate(&pStructInvoiceEntry->pLocation, pLocation);
	StringUpdate(&pStructInvoiceEntry->pOrderId, pOrderId);
	StringUpdate(&pStructInvoiceEntry->pContractId, pContractId);
	StringUpdate(&pStructInvoiceEntry->pPriceListId, pPriceListId);
	StringUpdate(&pStructInvoiceEntry->pSuggestedBasAccount, pSuggestedBasAccount);
	pStructInvoiceEntry->UnitNetAmount = UnitNetAmount;
	pStructInvoiceEntry->NetAmount = NetAmount;
	StringUpdate(&pStructInvoiceEntry->pVatReduced, pVatReduced);
	StringUpdate(&pStructInvoiceEntry->pVatSpecial, pVatSpecial);
	pStructInvoiceEntry->VatRate = VatRate;
	pStructInvoiceEntry->VatAmountTaxCurrency = VatAmountTaxCurrency;
	pStructInvoiceEntry->PayAmount = PayAmount;

	return pStructInvoiceEntry;
}


/*********************************************************************

char **GetLeadTextInvoiceEntry(

*********************************************************************/
char **GetLeadTextInvoiceEntry(
	char *pLang)
{
static char *szTexts[] = {
	"Quantity",
	"Description",
	"Trade Item Data",
	"Quota",
	"Quota Balance",
	"Quantity Unit",
	"Quota Agreed Unit Net Amount",
	"Id",
	"Invoice Id",
	"Accounting Date",
	"Availability Date",
	"Rate Of Intrest Date",
	"Sales Reference",
	"Sales Object",
	"Cost Reference",
	"Cost Object",
	"Note",
	"Delivery Date",
	"Delivery Note",
	"Location Note",
	"Location",
	"Dispatch File Url",
	"Order Id",
	"Contract Id",
	"Price List Id",
	"Order Response File Url",
	"Sellers Note To Buyer",
	"Suggested Bas Account",
	"Unit Net Amount",
	"Net Amount",
	"Vat Reduced",
	"Vat Special",
	"Vehicle Vat Doc File Url",
	"Vat Rate",
	"Vat Amount Tax Currency",
	"Pay Amount",
	"Receiving Approved",
	"Stacked Invoice",
	"Depreciation"};

	return szTexts;
}


/*********************************************************************

	TradeItemData

*********************************************************************

TradeItemDataType *CreateTradeItemData(

*********************************************************************/
TradeItemDataType *CreateTradeItemData(
	void *pStructDocTop, 
	void *pStructParent)
{
TradeItemDataType *pTradeItemData = calloc(1, sizeof(TradeItemDataType));

	if(!pTradeItemData)
		return 0;	// Fatal error

	pTradeItemData->DataType    = SCT_TRADEITEMDATA;
	pTradeItemData->pStructDocTop = pStructDocTop;
	pTradeItemData->pStructParent = pStructParent;

	pTradeItemData->pListDescription = LListInit();
	pTradeItemData->pSerialId = NulString;
	pTradeItemData->pGlobalProductId = NulString;
	pTradeItemData->pProducersProductId = NulString;
	pTradeItemData->pSuppliersProductId = NulString;
	pTradeItemData->pDomesticProductId = NulString;
	pTradeItemData->pRevisionId = NulString;
	pTradeItemData->pListCustomsId = LListInit();
	pTradeItemData->pListTaxId = LListInit();
	pTradeItemData->pListPicture = LListInit();
	pTradeItemData->pListProductDescriptionFileUrl = LListInit();
	pTradeItemData->pListProductSpecificationFileUrl = LListInit();
	pTradeItemData->pListGuaranteeFileUrl = LListInit();
	pTradeItemData->pListRepairFileUrl = LListInit();
	pTradeItemData->pListUpgradeFileUrl = LListInit();
	pTradeItemData->pListUserManualFileUrl = LListInit();
	pTradeItemData->pListProductInformationWebPage = LListInit();
	pTradeItemData->pTransportPackingGroup = NulString;
	pTradeItemData->pListDangerousGoodsClass = LListInit();
	pTradeItemData->pListStoringTransportMessage = LListInit();
	pTradeItemData->pListSaftyAndEnvironmentalMessage = LListInit();
	pTradeItemData->pListSaftyAndEnvironmentalFileUrl = LListInit();
	pTradeItemData->pListAgriculturalFileUrl = LListInit();
	pTradeItemData->pListRecyclingCode = LListInit();
	pTradeItemData->pListDisposalMessage = LListInit();
	pTradeItemData->pListDisposalFileUrl = LListInit();
	pTradeItemData->pListFileUrl = LListInit();

	return pTradeItemData;
}


/*********************************************************************

TradeItemDataType *DestroyTradeItemData(

*********************************************************************/
TradeItemDataType *DestroyTradeItemData(
	TradeItemDataType **ppTradeItemData)
{
	if(!*ppTradeItemData)
		return 0;	// Nothing to destroy

	{
		TextType *pDescription
			= LListGetFirstRecordData((*ppTradeItemData)->pListDescription);
		while(pDescription) {
			DestroyText(&pDescription);		// rac:TextType
			pDescription = LListGetNextRecordData((*ppTradeItemData)->pListDescription);
		}
		LListErase((*ppTradeItemData)->pListDescription);
	}
	FreeString(&(*ppTradeItemData)->pSerialId);		// xs:token
	FreeString(&(*ppTradeItemData)->pGlobalProductId);		// xs:token
	FreeString(&(*ppTradeItemData)->pProducersProductId);		// xs:token
	FreeString(&(*ppTradeItemData)->pSuppliersProductId);		// xs:token
	FreeString(&(*ppTradeItemData)->pDomesticProductId);		// xs:token
	FreeString(&(*ppTradeItemData)->pRevisionId);		// xs:token
	LListDestroy((*ppTradeItemData)->pListCustomsId);		// xs:token
	LListDestroy((*ppTradeItemData)->pListTaxId);		// xs:token
	LListDestroy((*ppTradeItemData)->pListPicture);		// rac:FileUrl
	LListDestroy((*ppTradeItemData)->pListProductDescriptionFileUrl);		// rac:FileUrl
	LListDestroy((*ppTradeItemData)->pListProductSpecificationFileUrl);		// rac:FileUrl
	LListDestroy((*ppTradeItemData)->pListGuaranteeFileUrl);		// rac:FileUrl
	LListDestroy((*ppTradeItemData)->pListRepairFileUrl);		// rac:FileUrl
	LListDestroy((*ppTradeItemData)->pListUpgradeFileUrl);		// rac:FileUrl
	LListDestroy((*ppTradeItemData)->pListUserManualFileUrl);		// rac:FileUrl
	LListDestroy((*ppTradeItemData)->pListProductInformationWebPage);		// rac:FileUrl
	FreeString(&(*ppTradeItemData)->pTransportPackingGroup);		// xs:token
	LListDestroy((*ppTradeItemData)->pListDangerousGoodsClass);		// xs:token
	{
		TextType *pStoringTransportMessage
			= LListGetFirstRecordData((*ppTradeItemData)->pListStoringTransportMessage);
		while(pStoringTransportMessage) {
			DestroyText(&pStoringTransportMessage);		// rac:TextType
			pStoringTransportMessage = LListGetNextRecordData((*ppTradeItemData)->pListStoringTransportMessage);
		}
		LListErase((*ppTradeItemData)->pListStoringTransportMessage);
	}
	{
		TextType *pSaftyAndEnvironmentalMessage
			= LListGetFirstRecordData((*ppTradeItemData)->pListSaftyAndEnvironmentalMessage);
		while(pSaftyAndEnvironmentalMessage) {
			DestroyText(&pSaftyAndEnvironmentalMessage);		// rac:TextType
			pSaftyAndEnvironmentalMessage = LListGetNextRecordData((*ppTradeItemData)->pListSaftyAndEnvironmentalMessage);
		}
		LListErase((*ppTradeItemData)->pListSaftyAndEnvironmentalMessage);
	}
	LListDestroy((*ppTradeItemData)->pListSaftyAndEnvironmentalFileUrl);		// rac:FileUrl
	LListDestroy((*ppTradeItemData)->pListAgriculturalFileUrl);		// rac:FileUrl
	LListDestroy((*ppTradeItemData)->pListRecyclingCode);		// xs:token
	{
		TextType *pDisposalMessage
			= LListGetFirstRecordData((*ppTradeItemData)->pListDisposalMessage);
		while(pDisposalMessage) {
			DestroyText(&pDisposalMessage);		// rac:TextType
			pDisposalMessage = LListGetNextRecordData((*ppTradeItemData)->pListDisposalMessage);
		}
		LListErase((*ppTradeItemData)->pListDisposalMessage);
	}
	LListDestroy((*ppTradeItemData)->pListDisposalFileUrl);		// rac:FileUrl
	LListDestroy((*ppTradeItemData)->pListFileUrl);		// rac:FileUrl

	free(*ppTradeItemData);
	*ppTradeItemData = 0;

	return 0;
}


/*********************************************************************

TradeItemDataType *CopyTradeItemData(

*********************************************************************/
TradeItemDataType *CopyTradeItemData(
	void *pStructDocTop, 
	void *pStructParent, 
	TradeItemDataType *pTradeItemData)
{
	if(pTradeItemData) {
		TradeItemDataType *pNewTradeItemData = CreateTradeItemData(pStructDocTop, pStructParent);

		if(!pNewTradeItemData)
			return 0;	// Fatal error

		{
			TextType *pDescription
				= LListGetFirstRecordData(pTradeItemData->pListDescription);
			while(pDescription) {
				LListAddRecord(pNewTradeItemData->pListDescription, CopyText(pStructDocTop, pNewTradeItemData, pDescription));		// rac:TextType
				pDescription = LListGetNextRecordData(pTradeItemData->pListDescription);
			}
		}
		CopyString(&pNewTradeItemData->pSerialId, pTradeItemData->pSerialId);		// xs:token
		CopyString(&pNewTradeItemData->pGlobalProductId, pTradeItemData->pGlobalProductId);		// xs:token
		CopyString(&pNewTradeItemData->pProducersProductId, pTradeItemData->pProducersProductId);		// xs:token
		CopyString(&pNewTradeItemData->pSuppliersProductId, pTradeItemData->pSuppliersProductId);		// xs:token
		CopyString(&pNewTradeItemData->pDomesticProductId, pTradeItemData->pDomesticProductId);		// xs:token
		CopyString(&pNewTradeItemData->pRevisionId, pTradeItemData->pRevisionId);		// xs:token
		{
			char *pCustomsId
				= LListGetFirstRecordData(pTradeItemData->pListCustomsId);
			while(pCustomsId) {
				LListAddRecord(pNewTradeItemData->pListCustomsId, CopyString(0, pCustomsId));		// xs:token
				pCustomsId = LListGetNextRecordData(pTradeItemData->pListCustomsId);
			}
		}
		{
			char *pTaxId
				= LListGetFirstRecordData(pTradeItemData->pListTaxId);
			while(pTaxId) {
				LListAddRecord(pNewTradeItemData->pListTaxId, CopyString(0, pTaxId));		// xs:token
				pTaxId = LListGetNextRecordData(pTradeItemData->pListTaxId);
			}
		}
		{
			char *pPicture
				= LListGetFirstRecordData(pTradeItemData->pListPicture);
			while(pPicture) {
				LListAddRecord(pNewTradeItemData->pListPicture, CopyString(0, pPicture));		// rac:FileUrl
				pPicture = LListGetNextRecordData(pTradeItemData->pListPicture);
			}
		}
		{
			char *pProductDescriptionFileUrl
				= LListGetFirstRecordData(pTradeItemData->pListProductDescriptionFileUrl);
			while(pProductDescriptionFileUrl) {
				LListAddRecord(pNewTradeItemData->pListProductDescriptionFileUrl, CopyString(0, pProductDescriptionFileUrl));		// rac:FileUrl
				pProductDescriptionFileUrl = LListGetNextRecordData(pTradeItemData->pListProductDescriptionFileUrl);
			}
		}
		{
			char *pProductSpecificationFileUrl
				= LListGetFirstRecordData(pTradeItemData->pListProductSpecificationFileUrl);
			while(pProductSpecificationFileUrl) {
				LListAddRecord(pNewTradeItemData->pListProductSpecificationFileUrl, CopyString(0, pProductSpecificationFileUrl));		// rac:FileUrl
				pProductSpecificationFileUrl = LListGetNextRecordData(pTradeItemData->pListProductSpecificationFileUrl);
			}
		}
		{
			char *pGuaranteeFileUrl
				= LListGetFirstRecordData(pTradeItemData->pListGuaranteeFileUrl);
			while(pGuaranteeFileUrl) {
				LListAddRecord(pNewTradeItemData->pListGuaranteeFileUrl, CopyString(0, pGuaranteeFileUrl));		// rac:FileUrl
				pGuaranteeFileUrl = LListGetNextRecordData(pTradeItemData->pListGuaranteeFileUrl);
			}
		}
		{
			char *pRepairFileUrl
				= LListGetFirstRecordData(pTradeItemData->pListRepairFileUrl);
			while(pRepairFileUrl) {
				LListAddRecord(pNewTradeItemData->pListRepairFileUrl, CopyString(0, pRepairFileUrl));		// rac:FileUrl
				pRepairFileUrl = LListGetNextRecordData(pTradeItemData->pListRepairFileUrl);
			}
		}
		{
			char *pUpgradeFileUrl
				= LListGetFirstRecordData(pTradeItemData->pListUpgradeFileUrl);
			while(pUpgradeFileUrl) {
				LListAddRecord(pNewTradeItemData->pListUpgradeFileUrl, CopyString(0, pUpgradeFileUrl));		// rac:FileUrl
				pUpgradeFileUrl = LListGetNextRecordData(pTradeItemData->pListUpgradeFileUrl);
			}
		}
		{
			char *pUserManualFileUrl
				= LListGetFirstRecordData(pTradeItemData->pListUserManualFileUrl);
			while(pUserManualFileUrl) {
				LListAddRecord(pNewTradeItemData->pListUserManualFileUrl, CopyString(0, pUserManualFileUrl));		// rac:FileUrl
				pUserManualFileUrl = LListGetNextRecordData(pTradeItemData->pListUserManualFileUrl);
			}
		}
		{
			char *pProductInformationWebPage
				= LListGetFirstRecordData(pTradeItemData->pListProductInformationWebPage);
			while(pProductInformationWebPage) {
				LListAddRecord(pNewTradeItemData->pListProductInformationWebPage, CopyString(0, pProductInformationWebPage));		// rac:FileUrl
				pProductInformationWebPage = LListGetNextRecordData(pTradeItemData->pListProductInformationWebPage);
			}
		}
		CopyString(&pNewTradeItemData->pTransportPackingGroup, pTradeItemData->pTransportPackingGroup);		// xs:token
		{
			char *pDangerousGoodsClass
				= LListGetFirstRecordData(pTradeItemData->pListDangerousGoodsClass);
			while(pDangerousGoodsClass) {
				LListAddRecord(pNewTradeItemData->pListDangerousGoodsClass, CopyString(0, pDangerousGoodsClass));		// xs:token
				pDangerousGoodsClass = LListGetNextRecordData(pTradeItemData->pListDangerousGoodsClass);
			}
		}
		pNewTradeItemData->MaxTempC = pTradeItemData->MaxTempC;		// xs:decimal
		pNewTradeItemData->MinTempC = pTradeItemData->MinTempC;		// xs:decimal
		{
			TextType *pStoringTransportMessage
				= LListGetFirstRecordData(pTradeItemData->pListStoringTransportMessage);
			while(pStoringTransportMessage) {
				LListAddRecord(pNewTradeItemData->pListStoringTransportMessage, CopyText(pStructDocTop, pNewTradeItemData, pStoringTransportMessage));		// rac:TextType
				pStoringTransportMessage = LListGetNextRecordData(pTradeItemData->pListStoringTransportMessage);
			}
		}
		{
			TextType *pSaftyAndEnvironmentalMessage
				= LListGetFirstRecordData(pTradeItemData->pListSaftyAndEnvironmentalMessage);
			while(pSaftyAndEnvironmentalMessage) {
				LListAddRecord(pNewTradeItemData->pListSaftyAndEnvironmentalMessage, CopyText(pStructDocTop, pNewTradeItemData, pSaftyAndEnvironmentalMessage));		// rac:TextType
				pSaftyAndEnvironmentalMessage = LListGetNextRecordData(pTradeItemData->pListSaftyAndEnvironmentalMessage);
			}
		}
		{
			char *pSaftyAndEnvironmentalFileUrl
				= LListGetFirstRecordData(pTradeItemData->pListSaftyAndEnvironmentalFileUrl);
			while(pSaftyAndEnvironmentalFileUrl) {
				LListAddRecord(pNewTradeItemData->pListSaftyAndEnvironmentalFileUrl, CopyString(0, pSaftyAndEnvironmentalFileUrl));		// rac:FileUrl
				pSaftyAndEnvironmentalFileUrl = LListGetNextRecordData(pTradeItemData->pListSaftyAndEnvironmentalFileUrl);
			}
		}
		{
			char *pAgriculturalFileUrl
				= LListGetFirstRecordData(pTradeItemData->pListAgriculturalFileUrl);
			while(pAgriculturalFileUrl) {
				LListAddRecord(pNewTradeItemData->pListAgriculturalFileUrl, CopyString(0, pAgriculturalFileUrl));		// rac:FileUrl
				pAgriculturalFileUrl = LListGetNextRecordData(pTradeItemData->pListAgriculturalFileUrl);
			}
		}
		{
			char *pRecyclingCode
				= LListGetFirstRecordData(pTradeItemData->pListRecyclingCode);
			while(pRecyclingCode) {
				LListAddRecord(pNewTradeItemData->pListRecyclingCode, CopyString(0, pRecyclingCode));		// xs:token
				pRecyclingCode = LListGetNextRecordData(pTradeItemData->pListRecyclingCode);
			}
		}
		{
			TextType *pDisposalMessage
				= LListGetFirstRecordData(pTradeItemData->pListDisposalMessage);
			while(pDisposalMessage) {
				LListAddRecord(pNewTradeItemData->pListDisposalMessage, CopyText(pStructDocTop, pNewTradeItemData, pDisposalMessage));		// rac:TextType
				pDisposalMessage = LListGetNextRecordData(pTradeItemData->pListDisposalMessage);
			}
		}
		{
			char *pDisposalFileUrl
				= LListGetFirstRecordData(pTradeItemData->pListDisposalFileUrl);
			while(pDisposalFileUrl) {
				LListAddRecord(pNewTradeItemData->pListDisposalFileUrl, CopyString(0, pDisposalFileUrl));		// rac:FileUrl
				pDisposalFileUrl = LListGetNextRecordData(pTradeItemData->pListDisposalFileUrl);
			}
		}
		{
			char *pFileUrl
				= LListGetFirstRecordData(pTradeItemData->pListFileUrl);
			while(pFileUrl) {
				LListAddRecord(pNewTradeItemData->pListFileUrl, CopyString(0, pFileUrl));		// rac:FileUrl
				pFileUrl = LListGetNextRecordData(pTradeItemData->pListFileUrl);
			}
		}

		return (pNewTradeItemData);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataTradeItemData(

*********************************************************************/
BOOL IsDataTradeItemData(
	TradeItemDataType *pTradeItemData)
{
	if(!pTradeItemData)
		return FALSE;

	{
		TextType *pDescription
			= LListGetFirstRecordData(pTradeItemData->pListDescription);
		while(pDescription) {
			if(IsDataText(pDescription))
				return TRUE;
			pDescription = LListGetNextRecordData(pTradeItemData->pListDescription);
		}
	}
	if(pTradeItemData->pSerialId && *pTradeItemData->pSerialId)
		return TRUE;
	if(pTradeItemData->pGlobalProductId && *pTradeItemData->pGlobalProductId)
		return TRUE;
	if(pTradeItemData->pProducersProductId && *pTradeItemData->pProducersProductId)
		return TRUE;
	if(pTradeItemData->pSuppliersProductId && *pTradeItemData->pSuppliersProductId)
		return TRUE;
	if(pTradeItemData->pDomesticProductId && *pTradeItemData->pDomesticProductId)
		return TRUE;
	if(pTradeItemData->pRevisionId && *pTradeItemData->pRevisionId)
		return TRUE;
	if(LListGetFirstRecordData(pTradeItemData->pListCustomsId))
		return TRUE;
	if(LListGetFirstRecordData(pTradeItemData->pListTaxId))
		return TRUE;
	if(LListGetFirstRecordData(pTradeItemData->pListPicture))
		return TRUE;
	if(LListGetFirstRecordData(pTradeItemData->pListProductDescriptionFileUrl))
		return TRUE;
	if(LListGetFirstRecordData(pTradeItemData->pListProductSpecificationFileUrl))
		return TRUE;
	if(LListGetFirstRecordData(pTradeItemData->pListGuaranteeFileUrl))
		return TRUE;
	if(LListGetFirstRecordData(pTradeItemData->pListRepairFileUrl))
		return TRUE;
	if(LListGetFirstRecordData(pTradeItemData->pListUpgradeFileUrl))
		return TRUE;
	if(LListGetFirstRecordData(pTradeItemData->pListUserManualFileUrl))
		return TRUE;
	if(LListGetFirstRecordData(pTradeItemData->pListProductInformationWebPage))
		return TRUE;
	if(pTradeItemData->pTransportPackingGroup && *pTradeItemData->pTransportPackingGroup)
		return TRUE;
	if(LListGetFirstRecordData(pTradeItemData->pListDangerousGoodsClass))
		return TRUE;
	if(!DecimalCmp(pTradeItemData->MaxTempC, 0))
		return TRUE;
	if(!DecimalCmp(pTradeItemData->MinTempC, 0))
		return TRUE;
	{
		TextType *pStoringTransportMessage
			= LListGetFirstRecordData(pTradeItemData->pListStoringTransportMessage);
		while(pStoringTransportMessage) {
			if(IsDataText(pStoringTransportMessage))
				return TRUE;
			pStoringTransportMessage = LListGetNextRecordData(pTradeItemData->pListStoringTransportMessage);
		}
	}
	{
		TextType *pSaftyAndEnvironmentalMessage
			= LListGetFirstRecordData(pTradeItemData->pListSaftyAndEnvironmentalMessage);
		while(pSaftyAndEnvironmentalMessage) {
			if(IsDataText(pSaftyAndEnvironmentalMessage))
				return TRUE;
			pSaftyAndEnvironmentalMessage = LListGetNextRecordData(pTradeItemData->pListSaftyAndEnvironmentalMessage);
		}
	}
	if(LListGetFirstRecordData(pTradeItemData->pListSaftyAndEnvironmentalFileUrl))
		return TRUE;
	if(LListGetFirstRecordData(pTradeItemData->pListAgriculturalFileUrl))
		return TRUE;
	if(LListGetFirstRecordData(pTradeItemData->pListRecyclingCode))
		return TRUE;
	{
		TextType *pDisposalMessage
			= LListGetFirstRecordData(pTradeItemData->pListDisposalMessage);
		while(pDisposalMessage) {
			if(IsDataText(pDisposalMessage))
				return TRUE;
			pDisposalMessage = LListGetNextRecordData(pTradeItemData->pListDisposalMessage);
		}
	}
	if(LListGetFirstRecordData(pTradeItemData->pListDisposalFileUrl))
		return TRUE;
	if(LListGetFirstRecordData(pTradeItemData->pListFileUrl))
		return TRUE;

	return FALSE;
}


/*********************************************************************

static TradeItemDataType *ReadSectionTradeItemData(

*********************************************************************/
static TradeItemDataType *ReadSectionTradeItemData(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
TradeItemDataType *pTradeItemData = CreateTradeItemData(pStructDocTop, pStructParent);

	if(!pTradeItemData)
		return 0;	// Fatal error

	pXmlTagData=GetNextXmlTag(pXmlTagData);

	if(!pXmlTagData)
		return 0;	// Fatal error

	while(strcmp(pXmlTagData->pTag, pEndTag)) { // While is not the end
		if(!strcmp(pXmlTagData->pTag, "Description"))
			SearchSetText(pTradeItemData->pListDescription, ReadSectionText(pStructDocTop, pTradeItemData, pXmlTagData, "Description"));		// rac:TextType
		else if(!strcmp(pXmlTagData->pTag, "SerialId"))
			ReadString(&pTradeItemData->pSerialId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "GlobalProductId"))
			ReadString(&pTradeItemData->pGlobalProductId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "ProducersProductId"))
			ReadString(&pTradeItemData->pProducersProductId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "SuppliersProductId"))
			ReadString(&pTradeItemData->pSuppliersProductId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "DomesticProductId"))
			ReadString(&pTradeItemData->pDomesticProductId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "RevisionId"))
			ReadString(&pTradeItemData->pRevisionId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "CustomsId"))
			LListAddRecord(pTradeItemData->pListCustomsId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "TaxId"))
			LListAddRecord(pTradeItemData->pListTaxId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "Picture"))
			LListAddRecord(pTradeItemData->pListPicture, ReadXmlDataString(pXmlTagData->pData));		// rac:FileUrl
		else if(!strcmp(pXmlTagData->pTag, "ProductDescriptionFileUrl"))
			LListAddRecord(pTradeItemData->pListProductDescriptionFileUrl, ReadXmlDataString(pXmlTagData->pData));		// rac:FileUrl
		else if(!strcmp(pXmlTagData->pTag, "ProductSpecificationFileUrl"))
			LListAddRecord(pTradeItemData->pListProductSpecificationFileUrl, ReadXmlDataString(pXmlTagData->pData));		// rac:FileUrl
		else if(!strcmp(pXmlTagData->pTag, "GuaranteeFileUrl"))
			LListAddRecord(pTradeItemData->pListGuaranteeFileUrl, ReadXmlDataString(pXmlTagData->pData));		// rac:FileUrl
		else if(!strcmp(pXmlTagData->pTag, "RepairFileUrl"))
			LListAddRecord(pTradeItemData->pListRepairFileUrl, ReadXmlDataString(pXmlTagData->pData));		// rac:FileUrl
		else if(!strcmp(pXmlTagData->pTag, "UpgradeFileUrl"))
			LListAddRecord(pTradeItemData->pListUpgradeFileUrl, ReadXmlDataString(pXmlTagData->pData));		// rac:FileUrl
		else if(!strcmp(pXmlTagData->pTag, "UserManualFileUrl"))
			LListAddRecord(pTradeItemData->pListUserManualFileUrl, ReadXmlDataString(pXmlTagData->pData));		// rac:FileUrl
		else if(!strcmp(pXmlTagData->pTag, "ProductInformationWebPage"))
			LListAddRecord(pTradeItemData->pListProductInformationWebPage, ReadXmlDataString(pXmlTagData->pData));		// rac:FileUrl
		else if(!strcmp(pXmlTagData->pTag, "TransportPackingGroup"))
			ReadString(&pTradeItemData->pTransportPackingGroup, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "DangerousGoodsClass"))
			LListAddRecord(pTradeItemData->pListDangerousGoodsClass, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "MaxTempC"))
			pTradeItemData->MaxTempC = StringToDecimal(pXmlTagData->pData);		// xs:decimal
		else if(!strcmp(pXmlTagData->pTag, "MinTempC"))
			pTradeItemData->MinTempC = StringToDecimal(pXmlTagData->pData);		// xs:decimal
		else if(!strcmp(pXmlTagData->pTag, "StoringTransportMessage"))
			LListAddRecord(pTradeItemData->pListStoringTransportMessage, ReadSectionText(pStructDocTop, pTradeItemData, pXmlTagData, "StoringTransportMessage"));		// rac:TextType
		else if(!strcmp(pXmlTagData->pTag, "SaftyAndEnvironmentalMessage"))
			SearchSetText(pTradeItemData->pListSaftyAndEnvironmentalMessage, ReadSectionText(pStructDocTop, pTradeItemData, pXmlTagData, "SaftyAndEnvironmentalMessage"));		// rac:TextType
		else if(!strcmp(pXmlTagData->pTag, "SaftyAndEnvironmentalFileUrl"))
			LListAddRecord(pTradeItemData->pListSaftyAndEnvironmentalFileUrl, ReadXmlDataString(pXmlTagData->pData));		// rac:FileUrl
		else if(!strcmp(pXmlTagData->pTag, "AgriculturalFileUrl"))
			LListAddRecord(pTradeItemData->pListAgriculturalFileUrl, ReadXmlDataString(pXmlTagData->pData));		// rac:FileUrl
		else if(!strcmp(pXmlTagData->pTag, "RecyclingCode"))
			LListAddRecord(pTradeItemData->pListRecyclingCode, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "DisposalMessage"))
			SearchSetText(pTradeItemData->pListDisposalMessage, ReadSectionText(pStructDocTop, pTradeItemData, pXmlTagData, "DisposalMessage"));		// rac:TextType
		else if(!strcmp(pXmlTagData->pTag, "DisposalFileUrl"))
			LListAddRecord(pTradeItemData->pListDisposalFileUrl, ReadXmlDataString(pXmlTagData->pData));		// rac:FileUrl
		else if(!strcmp(pXmlTagData->pTag, "FileUrl"))
			LListAddRecord(pTradeItemData->pListFileUrl, ReadXmlDataString(pXmlTagData->pData));		// rac:FileUrl

		pXmlTagData=GetNextXmlTag(pXmlTagData);

		if(!pXmlTagData)
			return 0;	// Fatal error
	}
	return pTradeItemData;
}


/*********************************************************************

static BOOL WriteSectionTradeItemData(

*********************************************************************/
static BOOL WriteSectionTradeItemData(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	TradeItemDataType *pTradeItemData)
{
	if(!pTradeItemData)
		return FALSE;	// Fatal error

	xmlWriteLine(pStream, iTab-1, pAttr, pLabel, 0, 0);

	if(pTradeItemData->pListDescription) {
		TextType *pDescription
			= LListGetFirstRecordData(pTradeItemData->pListDescription);
		while(pDescription) {
			if(IsDataText(pDescription))
				WriteSectionText(pStream, iTab+1, "Description", 0, pDescription);		// rac:TextType
			pDescription = LListGetNextRecordData(pTradeItemData->pListDescription);
		}
	}
	if(pTradeItemData->pSerialId && *pTradeItemData->pSerialId)
		xmlWriteLine(pStream, iTab, 0, "SerialId", pTradeItemData->pSerialId, "SerialId");		// xs:token
	if(pTradeItemData->pGlobalProductId && *pTradeItemData->pGlobalProductId)
		xmlWriteLine(pStream, iTab, 0, "GlobalProductId", pTradeItemData->pGlobalProductId, "GlobalProductId");		// xs:token
	if(pTradeItemData->pProducersProductId && *pTradeItemData->pProducersProductId)
		xmlWriteLine(pStream, iTab, 0, "ProducersProductId", pTradeItemData->pProducersProductId, "ProducersProductId");		// xs:token
	if(pTradeItemData->pSuppliersProductId && *pTradeItemData->pSuppliersProductId)
		xmlWriteLine(pStream, iTab, 0, "SuppliersProductId", pTradeItemData->pSuppliersProductId, "SuppliersProductId");		// xs:token
	if(pTradeItemData->pDomesticProductId && *pTradeItemData->pDomesticProductId)
		xmlWriteLine(pStream, iTab, 0, "DomesticProductId", pTradeItemData->pDomesticProductId, "DomesticProductId");		// xs:token
	if(pTradeItemData->pRevisionId && *pTradeItemData->pRevisionId)
		xmlWriteLine(pStream, iTab, 0, "RevisionId", pTradeItemData->pRevisionId, "RevisionId");		// xs:token

	if(pTradeItemData->pListCustomsId) {
		char *pCustomsId
			= LListGetFirstRecordData(pTradeItemData->pListCustomsId);
		while(pCustomsId) {
			xmlWriteLine(pStream, iTab, 0, "CustomsId", pCustomsId, "CustomsId");		// xs:token

			pCustomsId = LListGetNextRecordData(pTradeItemData->pListCustomsId);
		}
	}

	if(pTradeItemData->pListTaxId) {
		char *pTaxId
			= LListGetFirstRecordData(pTradeItemData->pListTaxId);
		while(pTaxId) {
			xmlWriteLine(pStream, iTab, 0, "TaxId", pTaxId, "TaxId");		// xs:token

			pTaxId = LListGetNextRecordData(pTradeItemData->pListTaxId);
		}
	}

	if(pTradeItemData->pListPicture) {
		char *pPicture
			= LListGetFirstRecordData(pTradeItemData->pListPicture);
		while(pPicture) {
			xmlWriteLine(pStream, iTab, 0, "Picture", pPicture, "Picture");		// rac:FileUrl

			pPicture = LListGetNextRecordData(pTradeItemData->pListPicture);
		}
	}

	if(pTradeItemData->pListProductDescriptionFileUrl) {
		char *pProductDescriptionFileUrl
			= LListGetFirstRecordData(pTradeItemData->pListProductDescriptionFileUrl);
		while(pProductDescriptionFileUrl) {
			xmlWriteLine(pStream, iTab, 0, "ProductDescriptionFileUrl", pProductDescriptionFileUrl, "ProductDescriptionFileUrl");		// rac:FileUrl

			pProductDescriptionFileUrl = LListGetNextRecordData(pTradeItemData->pListProductDescriptionFileUrl);
		}
	}

	if(pTradeItemData->pListProductSpecificationFileUrl) {
		char *pProductSpecificationFileUrl
			= LListGetFirstRecordData(pTradeItemData->pListProductSpecificationFileUrl);
		while(pProductSpecificationFileUrl) {
			xmlWriteLine(pStream, iTab, 0, "ProductSpecificationFileUrl", pProductSpecificationFileUrl, "ProductSpecificationFileUrl");		// rac:FileUrl

			pProductSpecificationFileUrl = LListGetNextRecordData(pTradeItemData->pListProductSpecificationFileUrl);
		}
	}

	if(pTradeItemData->pListGuaranteeFileUrl) {
		char *pGuaranteeFileUrl
			= LListGetFirstRecordData(pTradeItemData->pListGuaranteeFileUrl);
		while(pGuaranteeFileUrl) {
			xmlWriteLine(pStream, iTab, 0, "GuaranteeFileUrl", pGuaranteeFileUrl, "GuaranteeFileUrl");		// rac:FileUrl

			pGuaranteeFileUrl = LListGetNextRecordData(pTradeItemData->pListGuaranteeFileUrl);
		}
	}

	if(pTradeItemData->pListRepairFileUrl) {
		char *pRepairFileUrl
			= LListGetFirstRecordData(pTradeItemData->pListRepairFileUrl);
		while(pRepairFileUrl) {
			xmlWriteLine(pStream, iTab, 0, "RepairFileUrl", pRepairFileUrl, "RepairFileUrl");		// rac:FileUrl

			pRepairFileUrl = LListGetNextRecordData(pTradeItemData->pListRepairFileUrl);
		}
	}

	if(pTradeItemData->pListUpgradeFileUrl) {
		char *pUpgradeFileUrl
			= LListGetFirstRecordData(pTradeItemData->pListUpgradeFileUrl);
		while(pUpgradeFileUrl) {
			xmlWriteLine(pStream, iTab, 0, "UpgradeFileUrl", pUpgradeFileUrl, "UpgradeFileUrl");		// rac:FileUrl

			pUpgradeFileUrl = LListGetNextRecordData(pTradeItemData->pListUpgradeFileUrl);
		}
	}

	if(pTradeItemData->pListUserManualFileUrl) {
		char *pUserManualFileUrl
			= LListGetFirstRecordData(pTradeItemData->pListUserManualFileUrl);
		while(pUserManualFileUrl) {
			xmlWriteLine(pStream, iTab, 0, "UserManualFileUrl", pUserManualFileUrl, "UserManualFileUrl");		// rac:FileUrl

			pUserManualFileUrl = LListGetNextRecordData(pTradeItemData->pListUserManualFileUrl);
		}
	}

	if(pTradeItemData->pListProductInformationWebPage) {
		char *pProductInformationWebPage
			= LListGetFirstRecordData(pTradeItemData->pListProductInformationWebPage);
		while(pProductInformationWebPage) {
			xmlWriteLine(pStream, iTab, 0, "ProductInformationWebPage", pProductInformationWebPage, "ProductInformationWebPage");		// rac:FileUrl

			pProductInformationWebPage = LListGetNextRecordData(pTradeItemData->pListProductInformationWebPage);
		}
	}
	if(pTradeItemData->pTransportPackingGroup && *pTradeItemData->pTransportPackingGroup)
		xmlWriteLine(pStream, iTab, 0, "TransportPackingGroup", pTradeItemData->pTransportPackingGroup, "TransportPackingGroup");		// xs:token

	if(pTradeItemData->pListDangerousGoodsClass) {
		char *pDangerousGoodsClass
			= LListGetFirstRecordData(pTradeItemData->pListDangerousGoodsClass);
		while(pDangerousGoodsClass) {
			xmlWriteLine(pStream, iTab, 0, "DangerousGoodsClass", pDangerousGoodsClass, "DangerousGoodsClass");		// xs:token

			pDangerousGoodsClass = LListGetNextRecordData(pTradeItemData->pListDangerousGoodsClass);
		}
	}
	if(!DecimalCmp(pTradeItemData->MaxTempC, 0))
		xmlWriteLine(pStream, iTab, 0, "MaxTempC", DecimalToStr(pTradeItemData->MaxTempC, szString),"MaxTempC");		// xs:decimal
	if(!DecimalCmp(pTradeItemData->MinTempC, 0))
		xmlWriteLine(pStream, iTab, 0, "MinTempC", DecimalToStr(pTradeItemData->MinTempC, szString),"MinTempC");		// xs:decimal

	if(pTradeItemData->pListStoringTransportMessage) {
		TextType *pStoringTransportMessage
			= LListGetFirstRecordData(pTradeItemData->pListStoringTransportMessage);
		while(pStoringTransportMessage) {
			if(IsDataText(pStoringTransportMessage))
				WriteSectionText(pStream, iTab+1, "StoringTransportMessage", 0, pStoringTransportMessage);		// rac:TextType
			pStoringTransportMessage = LListGetNextRecordData(pTradeItemData->pListStoringTransportMessage);
		}
	}

	if(pTradeItemData->pListSaftyAndEnvironmentalMessage) {
		TextType *pSaftyAndEnvironmentalMessage
			= LListGetFirstRecordData(pTradeItemData->pListSaftyAndEnvironmentalMessage);
		while(pSaftyAndEnvironmentalMessage) {
			if(IsDataText(pSaftyAndEnvironmentalMessage))
				WriteSectionText(pStream, iTab+1, "SaftyAndEnvironmentalMessage", 0, pSaftyAndEnvironmentalMessage);		// rac:TextType
			pSaftyAndEnvironmentalMessage = LListGetNextRecordData(pTradeItemData->pListSaftyAndEnvironmentalMessage);
		}
	}

	if(pTradeItemData->pListSaftyAndEnvironmentalFileUrl) {
		char *pSaftyAndEnvironmentalFileUrl
			= LListGetFirstRecordData(pTradeItemData->pListSaftyAndEnvironmentalFileUrl);
		while(pSaftyAndEnvironmentalFileUrl) {
			xmlWriteLine(pStream, iTab, 0, "SaftyAndEnvironmentalFileUrl", pSaftyAndEnvironmentalFileUrl, "SaftyAndEnvironmentalFileUrl");		// rac:FileUrl

			pSaftyAndEnvironmentalFileUrl = LListGetNextRecordData(pTradeItemData->pListSaftyAndEnvironmentalFileUrl);
		}
	}

	if(pTradeItemData->pListAgriculturalFileUrl) {
		char *pAgriculturalFileUrl
			= LListGetFirstRecordData(pTradeItemData->pListAgriculturalFileUrl);
		while(pAgriculturalFileUrl) {
			xmlWriteLine(pStream, iTab, 0, "AgriculturalFileUrl", pAgriculturalFileUrl, "AgriculturalFileUrl");		// rac:FileUrl

			pAgriculturalFileUrl = LListGetNextRecordData(pTradeItemData->pListAgriculturalFileUrl);
		}
	}

	if(pTradeItemData->pListRecyclingCode) {
		char *pRecyclingCode
			= LListGetFirstRecordData(pTradeItemData->pListRecyclingCode);
		while(pRecyclingCode) {
			xmlWriteLine(pStream, iTab, 0, "RecyclingCode", pRecyclingCode, "RecyclingCode");		// xs:token

			pRecyclingCode = LListGetNextRecordData(pTradeItemData->pListRecyclingCode);
		}
	}

	if(pTradeItemData->pListDisposalMessage) {
		TextType *pDisposalMessage
			= LListGetFirstRecordData(pTradeItemData->pListDisposalMessage);
		while(pDisposalMessage) {
			if(IsDataText(pDisposalMessage))
				WriteSectionText(pStream, iTab+1, "DisposalMessage", 0, pDisposalMessage);		// rac:TextType
			pDisposalMessage = LListGetNextRecordData(pTradeItemData->pListDisposalMessage);
		}
	}

	if(pTradeItemData->pListDisposalFileUrl) {
		char *pDisposalFileUrl
			= LListGetFirstRecordData(pTradeItemData->pListDisposalFileUrl);
		while(pDisposalFileUrl) {
			xmlWriteLine(pStream, iTab, 0, "DisposalFileUrl", pDisposalFileUrl, "DisposalFileUrl");		// rac:FileUrl

			pDisposalFileUrl = LListGetNextRecordData(pTradeItemData->pListDisposalFileUrl);
		}
	}

	if(pTradeItemData->pListFileUrl) {
		char *pFileUrl
			= LListGetFirstRecordData(pTradeItemData->pListFileUrl);
		while(pFileUrl) {
			xmlWriteLine(pStream, iTab, 0, "FileUrl", pFileUrl, "FileUrl");		// rac:FileUrl

			pFileUrl = LListGetNextRecordData(pTradeItemData->pListFileUrl);
		}
	}

	xmlWriteLine(pStream, iTab-1, 0, 0, 0, pLabel);

	return TRUE;
}


/*********************************************************************

TradeItemDataType *UpdateTradeItemData(

*********************************************************************/
TradeItemDataType *UpdateTradeItemData(
	TradeItemDataType *pStructTradeItemData, 
	char *pSerialId, 
	char *pGlobalProductId, 
	char *pProducersProductId, 
	char *pSuppliersProductId, 
	char *pDomesticProductId, 
	char *pRevisionId, 
	char *pTransportPackingGroup, 
	QUANT MaxTempC, 
	QUANT MinTempC)
{
	StringUpdate(&pStructTradeItemData->pSerialId, pSerialId);
	StringUpdate(&pStructTradeItemData->pGlobalProductId, pGlobalProductId);
	StringUpdate(&pStructTradeItemData->pProducersProductId, pProducersProductId);
	StringUpdate(&pStructTradeItemData->pSuppliersProductId, pSuppliersProductId);
	StringUpdate(&pStructTradeItemData->pDomesticProductId, pDomesticProductId);
	StringUpdate(&pStructTradeItemData->pRevisionId, pRevisionId);
	StringUpdate(&pStructTradeItemData->pTransportPackingGroup, pTransportPackingGroup);
	pStructTradeItemData->MaxTempC = MaxTempC;
	pStructTradeItemData->MinTempC = MinTempC;

	return pStructTradeItemData;
}


/*********************************************************************

char **GetLeadTextTradeItemData(

*********************************************************************/
char **GetLeadTextTradeItemData(
	char *pLang)
{
static char *szTexts[] = {
	"Description",
	"Serial Id",
	"Global Product Id",
	"Producers Product Id",
	"Suppliers Product Id",
	"Domestic Product Id",
	"Revision Id",
	"Customs Id",
	"Tax Id",
	"Picture",
	"Product Description File Url",
	"Product Specification File Url",
	"Guarantee File Url",
	"Repair File Url",
	"Upgrade File Url",
	"User Manual File Url",
	"Product Information Web Page",
	"Transport Packing Group",
	"Dangerous Goods Class",
	"Max Temp C",
	"Min Temp C",
	"Storing Transport Message",
	"Safty And Environmental Message",
	"Safty And Environmental File Url",
	"Agricultural File Url",
	"Recycling Code",
	"Disposal Message",
	"Disposal File Url",
	"File Url"};

	return szTexts;
}


/*********************************************************************

	Pay

*********************************************************************

PayType *CreatePay(

*********************************************************************/
PayType *CreatePay(
	void *pStructDocTop, 
	void *pStructParent)
{
PayType *pPay = calloc(1, sizeof(PayType));

	if(!pPay)
		return 0;	// Fatal error

	pPay->DataType    = SCT_PAY;
	pPay->pStructDocTop = pStructDocTop;
	pPay->pStructParent = pStructParent;

	pPay->RegDate = GetSystemDate();
	pPay->PayDate = GetSystemDate();
	pPay->pListPaymentMeans = LListInit();

	return pPay;
}


/*********************************************************************

PayType *DestroyPay(

*********************************************************************/
PayType *DestroyPay(
	PayType **ppPay)
{
	if(!*ppPay)
		return 0;	// Nothing to destroy

	{
		CITradeSettlementPaymentMeansType *pPaymentMeans
			= LListGetFirstRecordData((*ppPay)->pListPaymentMeans);
		while(pPaymentMeans) {
			DestroyCITradeSettlementPaymentMeans(&pPaymentMeans);		// rac:CITradeSettlementPaymentMeansType
			pPaymentMeans = LListGetNextRecordData((*ppPay)->pListPaymentMeans);
		}
		LListErase((*ppPay)->pListPaymentMeans);
	}
	DestroyInvoiceEntry(&(*ppPay)->pReferenceBankAccount);		// rac:InvoiceEntryType
	DestroySeriesId(&(*ppPay)->pReferenceAccounting);		// rac:SeriesIdType

	free(*ppPay);
	*ppPay = 0;

	return 0;
}


/*********************************************************************

PayType *CopyPay(

*********************************************************************/
PayType *CopyPay(
	void *pStructDocTop, 
	void *pStructParent, 
	PayType *pPay)
{
	if(pPay) {
		PayType *pNewPay = CreatePay(pStructDocTop, pStructParent);

		if(!pNewPay)
			return 0;	// Fatal error

		pNewPay->RegDate = pPay->RegDate;		// xs:date
		pNewPay->PayDate = pPay->PayDate;		// xs:date
		pNewPay->Amount = pPay->Amount;		// rac:Amount
		{
			CITradeSettlementPaymentMeansType *pPaymentMeans
				= LListGetFirstRecordData(pPay->pListPaymentMeans);
			while(pPaymentMeans) {
				LListAddRecord(pNewPay->pListPaymentMeans, CopyCITradeSettlementPaymentMeans(pStructDocTop, pNewPay, pPaymentMeans));		// rac:CITradeSettlementPaymentMeansType
				pPaymentMeans = LListGetNextRecordData(pPay->pListPaymentMeans);
			}
		}
		pNewPay->pReferenceBankAccount = CopyInvoiceEntry(pStructDocTop, pNewPay, pPay->pReferenceBankAccount);		// rac:InvoiceEntryType
		pNewPay->pReferenceAccounting = CopySeriesId(pStructDocTop, pNewPay, pPay->pReferenceAccounting);		// rac:SeriesIdType

		return (pNewPay);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataPay(

*********************************************************************/
BOOL IsDataPay(
	PayType *pPay)
{
	if(!pPay)
		return FALSE;

	if(pPay->RegDate)
		return TRUE;
	if(pPay->PayDate)
		return TRUE;
	if(pPay->Amount)
		return TRUE;
	{
		CITradeSettlementPaymentMeansType *pPaymentMeans
			= LListGetFirstRecordData(pPay->pListPaymentMeans);
		while(pPaymentMeans) {
			if(IsDataCITradeSettlementPaymentMeans(pPaymentMeans))
				return TRUE;
			pPaymentMeans = LListGetNextRecordData(pPay->pListPaymentMeans);
		}
	}
	if(IsDataInvoiceEntry(pPay->pReferenceBankAccount))
		return TRUE;
	if(IsDataSeriesId(pPay->pReferenceAccounting))
		return TRUE;

	return FALSE;
}


/*********************************************************************

static PayType *ReadSectionPay(

*********************************************************************/
static PayType *ReadSectionPay(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
PayType *pPay = CreatePay(pStructDocTop, pStructParent);

	if(!pPay)
		return 0;	// Fatal error

	pXmlTagData=GetNextXmlTag(pXmlTagData);

	if(!pXmlTagData)
		return 0;	// Fatal error

	while(strcmp(pXmlTagData->pTag, pEndTag)) { // While is not the end
		if(!strcmp(pXmlTagData->pTag, "RegDate"))
			pPay->RegDate = StringToDate(pXmlTagData->pData);		// xs:date
		else if(!strcmp(pXmlTagData->pTag, "PayDate"))
			pPay->PayDate = StringToDate(pXmlTagData->pData);		// xs:date
		else if(!strcmp(pXmlTagData->pTag, "Amount"))
			pPay->Amount = StringToAmount(pXmlTagData->pData);		// rac:Amount
		else if(!strcmp(pXmlTagData->pTag, "PaymentMeans"))
			LListAddRecord(pPay->pListPaymentMeans, ReadSectionCITradeSettlementPaymentMeans(pStructDocTop, pPay, pXmlTagData, "PaymentMeans"));		// rac:CITradeSettlementPaymentMeansType
		else if(!strcmp(pXmlTagData->pTag, "ReferenceBankAccount"))
			pPay->pReferenceBankAccount = ReadSectionInvoiceEntry(pStructDocTop, pPay, pXmlTagData, "ReferenceBankAccount");		// rac:InvoiceEntryType
		else if(!strcmp(pXmlTagData->pTag, "ReferenceAccounting"))
			pPay->pReferenceAccounting = ReadSectionSeriesId(pStructDocTop, pPay, pXmlTagData, "ReferenceAccounting");		// rac:SeriesIdType

		pXmlTagData=GetNextXmlTag(pXmlTagData);

		if(!pXmlTagData)
			return 0;	// Fatal error
	}
	return pPay;
}


/*********************************************************************

static BOOL WriteSectionPay(

*********************************************************************/
static BOOL WriteSectionPay(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	PayType *pPay)
{
	if(!pPay)
		return FALSE;	// Fatal error

	xmlWriteLine(pStream, iTab-1, pAttr, pLabel, 0, 0);
	if(pPay->RegDate)
		xmlWriteLine(pStream, iTab, 0, "RegDate", DateToStr(pPay->RegDate, szString),"RegDate");		// xs:date
	xmlWriteLine(pStream, iTab, 0, "PayDate", DateToStr(pPay->PayDate, szString),"PayDate");		// xs:date - Mandatory
	xmlWriteLine(pStream, iTab, 0, "Amount", AmountToStr(pPay->Amount, szString),"Amount");		// rac:Amount - Mandatory

	if(pPay->pListPaymentMeans) {
		CITradeSettlementPaymentMeansType *pPaymentMeans
			= LListGetFirstRecordData(pPay->pListPaymentMeans);
		while(pPaymentMeans) {
			if(IsDataCITradeSettlementPaymentMeans(pPaymentMeans))
				WriteSectionCITradeSettlementPaymentMeans(pStream, iTab+1, "PaymentMeans", 0, pPaymentMeans);		// rac:CITradeSettlementPaymentMeansType
			pPaymentMeans = LListGetNextRecordData(pPay->pListPaymentMeans);
		}
	}

	if(pPay->pReferenceBankAccount && IsDataInvoiceEntry(pPay->pReferenceBankAccount))		// Optional
		WriteSectionInvoiceEntry(pStream, iTab+1, "ReferenceBankAccount", 0, pPay->pReferenceBankAccount);		// rac:InvoiceEntryType

	if(pPay->pReferenceAccounting && IsDataSeriesId(pPay->pReferenceAccounting))		// Optional
		WriteSectionSeriesId(pStream, iTab+1, "ReferenceAccounting", 0, pPay->pReferenceAccounting);		// rac:SeriesIdType

	xmlWriteLine(pStream, iTab-1, 0, 0, 0, pLabel);

	return TRUE;
}


/*********************************************************************

PayType *UpdatePay(

*********************************************************************/
PayType *UpdatePay(
	PayType *pStructPay, 
	DATEINT RegDate, 
	DATEINT PayDate, 
	AMOUNT Amount)
{
	pStructPay->RegDate = RegDate;
	pStructPay->PayDate = PayDate;
	pStructPay->Amount = Amount;

	return pStructPay;
}


/*********************************************************************

char **GetLeadTextPay(

*********************************************************************/
char **GetLeadTextPay(
	char *pLang)
{
static char *szTexts[] = {
	"Reg Date",
	"Pay Date",
	"Amount",
	"Payment Means",
	"Reference Bank Account",
	"Reference Accounting"};

	return szTexts;
}


/*********************************************************************

	Depreciations

*********************************************************************

DepreciationsType *CreateDepreciations(

*********************************************************************/
DepreciationsType *CreateDepreciations(
	void *pStructDocTop, 
	void *pStructParent)
{
DepreciationsType *pDepreciations = calloc(1, sizeof(DepreciationsType));

	if(!pDepreciations)
		return 0;	// Fatal error

	pDepreciations->DataType    = SCT_DEPRECIATIONS;
	pDepreciations->pStructDocTop = pStructDocTop;
	pDepreciations->pStructParent = pStructParent;

	pDepreciations->pListDescription = LListInit();
	pDepreciations->pDepreciationSchedule = NulString;
	pDepreciations->pDepreciationPeriods = NulString;
	pDepreciations->pListDepreciationQuantityUnit = LListInit();
	pDepreciations->pListDepreciation = LListInit();
	pDepreciations->pListRevaluation = LListInit();

	return pDepreciations;
}


/*********************************************************************

DepreciationsType *DestroyDepreciations(

*********************************************************************/
DepreciationsType *DestroyDepreciations(
	DepreciationsType **ppDepreciations)
{
	if(!*ppDepreciations)
		return 0;	// Nothing to destroy

	{
		TextType *pDescription
			= LListGetFirstRecordData((*ppDepreciations)->pListDescription);
		while(pDescription) {
			DestroyText(&pDescription);		// rac:TextType
			pDescription = LListGetNextRecordData((*ppDepreciations)->pListDescription);
		}
		LListErase((*ppDepreciations)->pListDescription);
	}
	FreeString(&(*ppDepreciations)->pDepreciationSchedule);		// rac:DepreciationScheduleType
	FreeString(&(*ppDepreciations)->pDepreciationPeriods);		// rac:DepreciationPeriodsType
	{
		TextType *pDepreciationQuantityUnit
			= LListGetFirstRecordData((*ppDepreciations)->pListDepreciationQuantityUnit);
		while(pDepreciationQuantityUnit) {
			DestroyText(&pDepreciationQuantityUnit);		// rac:TextType
			pDepreciationQuantityUnit = LListGetNextRecordData((*ppDepreciations)->pListDepreciationQuantityUnit);
		}
		LListErase((*ppDepreciations)->pListDepreciationQuantityUnit);
	}
	{
		DepreciationEntryType *pDepreciation
			= LListGetFirstRecordData((*ppDepreciations)->pListDepreciation);
		while(pDepreciation) {
			DestroyDepreciationEntry(&pDepreciation);		// rac:DepreciationEntryType
			pDepreciation = LListGetNextRecordData((*ppDepreciations)->pListDepreciation);
		}
		LListErase((*ppDepreciations)->pListDepreciation);
	}
	{
		DepreciationEntryType *pRevaluation
			= LListGetFirstRecordData((*ppDepreciations)->pListRevaluation);
		while(pRevaluation) {
			DestroyDepreciationEntry(&pRevaluation);		// rac:DepreciationEntryType
			pRevaluation = LListGetNextRecordData((*ppDepreciations)->pListRevaluation);
		}
		LListErase((*ppDepreciations)->pListRevaluation);
	}

	free(*ppDepreciations);
	*ppDepreciations = 0;

	return 0;
}


/*********************************************************************

DepreciationsType *CopyDepreciations(

*********************************************************************/
DepreciationsType *CopyDepreciations(
	void *pStructDocTop, 
	void *pStructParent, 
	DepreciationsType *pDepreciations)
{
	if(pDepreciations) {
		DepreciationsType *pNewDepreciations = CreateDepreciations(pStructDocTop, pStructParent);

		if(!pNewDepreciations)
			return 0;	// Fatal error

		pNewDepreciations->Deprecated = pDepreciations->Deprecated;		// xs:date
		{
			TextType *pDescription
				= LListGetFirstRecordData(pDepreciations->pListDescription);
			while(pDescription) {
				LListAddRecord(pNewDepreciations->pListDescription, CopyText(pStructDocTop, pNewDepreciations, pDescription));		// rac:TextType
				pDescription = LListGetNextRecordData(pDepreciations->pListDescription);
			}
		}
		CopyString(&pNewDepreciations->pDepreciationSchedule, pDepreciations->pDepreciationSchedule);		// rac:DepreciationScheduleType
		CopyString(&pNewDepreciations->pDepreciationPeriods, pDepreciations->pDepreciationPeriods);		// rac:DepreciationPeriodsType
		pNewDepreciations->Periods = pDepreciations->Periods;		// xs:nonNegativeInteger
		pNewDepreciations->FirstDepreciation = pDepreciations->FirstDepreciation;		// xs:date
		pNewDepreciations->LastDepreciation = pDepreciations->LastDepreciation;		// xs:date
		pNewDepreciations->InterestRate = pDepreciations->InterestRate;		// xs:decimal
		{
			TextType *pDepreciationQuantityUnit
				= LListGetFirstRecordData(pDepreciations->pListDepreciationQuantityUnit);
			while(pDepreciationQuantityUnit) {
				LListAddRecord(pNewDepreciations->pListDepreciationQuantityUnit, CopyText(pStructDocTop, pNewDepreciations, pDepreciationQuantityUnit));		// rac:TextType
				pDepreciationQuantityUnit = LListGetNextRecordData(pDepreciations->pListDepreciationQuantityUnit);
			}
		}
		pNewDepreciations->Base = pDepreciations->Base;		// rac:Amount
		pNewDepreciations->BaseQuantity = pDepreciations->BaseQuantity;		// xs:decimal
		pNewDepreciations->ResIdual = pDepreciations->ResIdual;		// rac:Amount
		pNewDepreciations->ResIdualQuantity = pDepreciations->ResIdualQuantity;		// xs:decimal
		pNewDepreciations->Depreciations = pDepreciations->Depreciations;		// rac:Amount
		pNewDepreciations->DepreciationsQuantity = pDepreciations->DepreciationsQuantity;		// xs:decimal
		pNewDepreciations->Balance = pDepreciations->Balance;		// rac:Amount
		pNewDepreciations->BalanceQuantity = pDepreciations->BalanceQuantity;		// xs:decimal
		{
			DepreciationEntryType *pDepreciation
				= LListGetFirstRecordData(pDepreciations->pListDepreciation);
			while(pDepreciation) {
				LListAddRecord(pNewDepreciations->pListDepreciation, CopyDepreciationEntry(pStructDocTop, pNewDepreciations, pDepreciation));		// rac:DepreciationEntryType
				pDepreciation = LListGetNextRecordData(pDepreciations->pListDepreciation);
			}
		}
		{
			DepreciationEntryType *pRevaluation
				= LListGetFirstRecordData(pDepreciations->pListRevaluation);
			while(pRevaluation) {
				LListAddRecord(pNewDepreciations->pListRevaluation, CopyDepreciationEntry(pStructDocTop, pNewDepreciations, pRevaluation));		// rac:DepreciationEntryType
				pRevaluation = LListGetNextRecordData(pDepreciations->pListRevaluation);
			}
		}

		return (pNewDepreciations);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataDepreciations(

*********************************************************************/
BOOL IsDataDepreciations(
	DepreciationsType *pDepreciations)
{
	if(!pDepreciations)
		return FALSE;

	if(pDepreciations->Deprecated)
		return TRUE;
	{
		TextType *pDescription
			= LListGetFirstRecordData(pDepreciations->pListDescription);
		while(pDescription) {
			if(IsDataText(pDescription))
				return TRUE;
			pDescription = LListGetNextRecordData(pDepreciations->pListDescription);
		}
	}
	if(pDepreciations->pDepreciationSchedule && *pDepreciations->pDepreciationSchedule)
		return TRUE;
	if(pDepreciations->pDepreciationPeriods && *pDepreciations->pDepreciationPeriods)
		return TRUE;
	if(pDepreciations->Periods)
		return TRUE;
	if(pDepreciations->FirstDepreciation)
		return TRUE;
	if(pDepreciations->LastDepreciation)
		return TRUE;
	if(!DecimalCmp(pDepreciations->InterestRate, 0))
		return TRUE;
	{
		TextType *pDepreciationQuantityUnit
			= LListGetFirstRecordData(pDepreciations->pListDepreciationQuantityUnit);
		while(pDepreciationQuantityUnit) {
			if(IsDataText(pDepreciationQuantityUnit))
				return TRUE;
			pDepreciationQuantityUnit = LListGetNextRecordData(pDepreciations->pListDepreciationQuantityUnit);
		}
	}
	if(pDepreciations->Base)
		return TRUE;
	if(!DecimalCmp(pDepreciations->BaseQuantity, 0))
		return TRUE;
	if(pDepreciations->ResIdual)
		return TRUE;
	if(!DecimalCmp(pDepreciations->ResIdualQuantity, 0))
		return TRUE;
	if(pDepreciations->Depreciations)
		return TRUE;
	if(!DecimalCmp(pDepreciations->DepreciationsQuantity, 0))
		return TRUE;
	if(pDepreciations->Balance)
		return TRUE;
	if(!DecimalCmp(pDepreciations->BalanceQuantity, 0))
		return TRUE;
	{
		DepreciationEntryType *pDepreciation
			= LListGetFirstRecordData(pDepreciations->pListDepreciation);
		while(pDepreciation) {
			if(IsDataDepreciationEntry(pDepreciation))
				return TRUE;
			pDepreciation = LListGetNextRecordData(pDepreciations->pListDepreciation);
		}
	}
	{
		DepreciationEntryType *pRevaluation
			= LListGetFirstRecordData(pDepreciations->pListRevaluation);
		while(pRevaluation) {
			if(IsDataDepreciationEntry(pRevaluation))
				return TRUE;
			pRevaluation = LListGetNextRecordData(pDepreciations->pListRevaluation);
		}
	}

	return FALSE;
}


/*********************************************************************

static DepreciationsType *ReadSectionDepreciations(

*********************************************************************/
static DepreciationsType *ReadSectionDepreciations(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
DepreciationsType *pDepreciations = CreateDepreciations(pStructDocTop, pStructParent);

	if(!pDepreciations)
		return 0;	// Fatal error

	pXmlTagData=GetNextXmlTag(pXmlTagData);

	if(!pXmlTagData)
		return 0;	// Fatal error

	while(strcmp(pXmlTagData->pTag, pEndTag)) { // While is not the end
		if(!strcmp(pXmlTagData->pTag, "Deprecated"))
			pDepreciations->Deprecated = StringToDate(pXmlTagData->pData);		// xs:date
		else if(!strcmp(pXmlTagData->pTag, "Description"))
			SearchSetText(pDepreciations->pListDescription, ReadSectionText(pStructDocTop, pDepreciations, pXmlTagData, "Description"));		// rac:TextType
		else if(!strcmp(pXmlTagData->pTag, "DepreciationSchedule"))
			CheckEnum(&pDepreciations->pDepreciationSchedule, EnumDepreciationScheduleType, ReadXmlDataString(pXmlTagData->pData));		// rac:DepreciationScheduleType
		else if(!strcmp(pXmlTagData->pTag, "DepreciationPeriods"))
			CheckEnum(&pDepreciations->pDepreciationPeriods, EnumDepreciationPeriodsType, ReadXmlDataString(pXmlTagData->pData));		// rac:DepreciationPeriodsType
		else if(!strcmp(pXmlTagData->pTag, "Periods"))
			pDepreciations->Periods = StringToCounter(pXmlTagData->pData);		// xs:nonNegativeInteger
		else if(!strcmp(pXmlTagData->pTag, "FirstDepreciation"))
			pDepreciations->FirstDepreciation = StringToDate(pXmlTagData->pData);		// xs:date
		else if(!strcmp(pXmlTagData->pTag, "LastDepreciation"))
			pDepreciations->LastDepreciation = StringToDate(pXmlTagData->pData);		// xs:date
		else if(!strcmp(pXmlTagData->pTag, "InterestRate"))
			pDepreciations->InterestRate = StringToDecimal(pXmlTagData->pData);		// xs:decimal
		else if(!strcmp(pXmlTagData->pTag, "DepreciationQuantityUnit"))
			SearchSetText(pDepreciations->pListDepreciationQuantityUnit, ReadSectionText(pStructDocTop, pDepreciations, pXmlTagData, "DepreciationQuantityUnit"));		// rac:TextType
		else if(!strcmp(pXmlTagData->pTag, "Base"))
			pDepreciations->Base = StringToAmount(pXmlTagData->pData);		// rac:Amount
		else if(!strcmp(pXmlTagData->pTag, "BaseQuantity"))
			pDepreciations->BaseQuantity = StringToDecimal(pXmlTagData->pData);		// xs:decimal
		else if(!strcmp(pXmlTagData->pTag, "ResIdual"))
			pDepreciations->ResIdual = StringToAmount(pXmlTagData->pData);		// rac:Amount
		else if(!strcmp(pXmlTagData->pTag, "ResIdualQuantity"))
			pDepreciations->ResIdualQuantity = StringToDecimal(pXmlTagData->pData);		// xs:decimal
		else if(!strcmp(pXmlTagData->pTag, "Depreciations"))
			pDepreciations->Depreciations = StringToAmount(pXmlTagData->pData);		// rac:Amount
		else if(!strcmp(pXmlTagData->pTag, "DepreciationsQuantity"))
			pDepreciations->DepreciationsQuantity = StringToDecimal(pXmlTagData->pData);		// xs:decimal
		else if(!strcmp(pXmlTagData->pTag, "Balance"))
			pDepreciations->Balance = StringToAmount(pXmlTagData->pData);		// rac:Amount
		else if(!strcmp(pXmlTagData->pTag, "BalanceQuantity"))
			pDepreciations->BalanceQuantity = StringToDecimal(pXmlTagData->pData);		// xs:decimal
		else if(!strcmp(pXmlTagData->pTag, "Depreciation"))
			LListAddRecord(pDepreciations->pListDepreciation, ReadSectionDepreciationEntry(pStructDocTop, pDepreciations, pXmlTagData, "Depreciation"));		// rac:DepreciationEntryType
		else if(!strcmp(pXmlTagData->pTag, "Revaluation"))
			LListAddRecord(pDepreciations->pListRevaluation, ReadSectionDepreciationEntry(pStructDocTop, pDepreciations, pXmlTagData, "Revaluation"));		// rac:DepreciationEntryType

		pXmlTagData=GetNextXmlTag(pXmlTagData);

		if(!pXmlTagData)
			return 0;	// Fatal error
	}
	return pDepreciations;
}


/*********************************************************************

static BOOL WriteSectionDepreciations(

*********************************************************************/
static BOOL WriteSectionDepreciations(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	DepreciationsType *pDepreciations)
{
	if(!pDepreciations)
		return FALSE;	// Fatal error

	xmlWriteLine(pStream, iTab-1, pAttr, pLabel, 0, 0);
	if(pDepreciations->Deprecated)
		xmlWriteLine(pStream, iTab, 0, "Deprecated", DateToStr(pDepreciations->Deprecated, szString),"Deprecated");		// xs:date

	if(pDepreciations->pListDescription) {
		TextType *pDescription
			= LListGetFirstRecordData(pDepreciations->pListDescription);
		while(pDescription) {
			if(IsDataText(pDescription))
				WriteSectionText(pStream, iTab+1, "Description", 0, pDescription);		// rac:TextType
			pDescription = LListGetNextRecordData(pDepreciations->pListDescription);
		}
	}
	if(pDepreciations->pDepreciationSchedule && *pDepreciations->pDepreciationSchedule)
		xmlWriteLine(pStream, iTab, 0, "DepreciationSchedule", pDepreciations->pDepreciationSchedule, "DepreciationSchedule");		// rac:DepreciationScheduleType
	if(pDepreciations->pDepreciationPeriods && *pDepreciations->pDepreciationPeriods)
		xmlWriteLine(pStream, iTab, 0, "DepreciationPeriods", pDepreciations->pDepreciationPeriods, "DepreciationPeriods");		// rac:DepreciationPeriodsType
	if(pDepreciations->Periods)
		xmlWriteLine(pStream, iTab, 0, "Periods", CounterToStr(pDepreciations->Periods, szString),"Periods");		// xs:nonNegativeInteger
	if(pDepreciations->FirstDepreciation)
		xmlWriteLine(pStream, iTab, 0, "FirstDepreciation", DateToStr(pDepreciations->FirstDepreciation, szString),"FirstDepreciation");		// xs:date
	if(pDepreciations->LastDepreciation)
		xmlWriteLine(pStream, iTab, 0, "LastDepreciation", DateToStr(pDepreciations->LastDepreciation, szString),"LastDepreciation");		// xs:date
	if(!DecimalCmp(pDepreciations->InterestRate, 0))
		xmlWriteLine(pStream, iTab, 0, "InterestRate", DecimalToStr(pDepreciations->InterestRate, szString),"InterestRate");		// xs:decimal

	if(pDepreciations->pListDepreciationQuantityUnit) {
		TextType *pDepreciationQuantityUnit
			= LListGetFirstRecordData(pDepreciations->pListDepreciationQuantityUnit);
		while(pDepreciationQuantityUnit) {
			if(IsDataText(pDepreciationQuantityUnit))
				WriteSectionText(pStream, iTab+1, "DepreciationQuantityUnit", 0, pDepreciationQuantityUnit);		// rac:TextType
			pDepreciationQuantityUnit = LListGetNextRecordData(pDepreciations->pListDepreciationQuantityUnit);
		}
	}
	if(pDepreciations->Base)
		xmlWriteLine(pStream, iTab, 0, "Base", AmountToStr(pDepreciations->Base, szString),"Base");		// rac:Amount
	if(!DecimalCmp(pDepreciations->BaseQuantity, 0))
		xmlWriteLine(pStream, iTab, 0, "BaseQuantity", DecimalToStr(pDepreciations->BaseQuantity, szString),"BaseQuantity");		// xs:decimal
	if(pDepreciations->ResIdual)
		xmlWriteLine(pStream, iTab, 0, "ResIdual", AmountToStr(pDepreciations->ResIdual, szString),"ResIdual");		// rac:Amount
	if(!DecimalCmp(pDepreciations->ResIdualQuantity, 0))
		xmlWriteLine(pStream, iTab, 0, "ResIdualQuantity", DecimalToStr(pDepreciations->ResIdualQuantity, szString),"ResIdualQuantity");		// xs:decimal
	if(pDepreciations->Depreciations)
		xmlWriteLine(pStream, iTab, 0, "Depreciations", AmountToStr(pDepreciations->Depreciations, szString),"Depreciations");		// rac:Amount
	if(!DecimalCmp(pDepreciations->DepreciationsQuantity, 0))
		xmlWriteLine(pStream, iTab, 0, "DepreciationsQuantity", DecimalToStr(pDepreciations->DepreciationsQuantity, szString),"DepreciationsQuantity");		// xs:decimal
	xmlWriteLine(pStream, iTab, 0, "Balance", AmountToStr(pDepreciations->Balance, szString),"Balance");		// rac:Amount - Mandatory
	if(!DecimalCmp(pDepreciations->BalanceQuantity, 0))
		xmlWriteLine(pStream, iTab, 0, "BalanceQuantity", DecimalToStr(pDepreciations->BalanceQuantity, szString),"BalanceQuantity");		// xs:decimal

	if(pDepreciations->pListDepreciation) {
		DepreciationEntryType *pDepreciation
			= LListGetFirstRecordData(pDepreciations->pListDepreciation);
		while(pDepreciation) {
			if(IsDataDepreciationEntry(pDepreciation))
				WriteSectionDepreciationEntry(pStream, iTab+1, "Depreciation", 0, pDepreciation);		// rac:DepreciationEntryType
			pDepreciation = LListGetNextRecordData(pDepreciations->pListDepreciation);
		}
	}

	if(pDepreciations->pListRevaluation) {
		DepreciationEntryType *pRevaluation
			= LListGetFirstRecordData(pDepreciations->pListRevaluation);
		while(pRevaluation) {
			if(IsDataDepreciationEntry(pRevaluation))
				WriteSectionDepreciationEntry(pStream, iTab+1, "Revaluation", 0, pRevaluation);		// rac:DepreciationEntryType
			pRevaluation = LListGetNextRecordData(pDepreciations->pListRevaluation);
		}
	}

	xmlWriteLine(pStream, iTab-1, 0, 0, 0, pLabel);

	return TRUE;
}


/*********************************************************************

DepreciationsType *UpdateDepreciations(

*********************************************************************/
DepreciationsType *UpdateDepreciations(
	DepreciationsType *pStructDepreciations, 
	DATEINT Deprecated, 
	char *pDepreciationSchedule, 
	char *pDepreciationPeriods, 
	COUNTER Periods, 
	DATEINT FirstDepreciation, 
	DATEINT LastDepreciation, 
	QUANT InterestRate, 
	AMOUNT Base, 
	QUANT BaseQuantity, 
	AMOUNT ResIdual, 
	QUANT ResIdualQuantity, 
	AMOUNT Depreciations, 
	QUANT DepreciationsQuantity, 
	AMOUNT Balance, 
	QUANT BalanceQuantity)
{
	pStructDepreciations->Deprecated = Deprecated;
	StringUpdate(&pStructDepreciations->pDepreciationSchedule, pDepreciationSchedule);
	StringUpdate(&pStructDepreciations->pDepreciationPeriods, pDepreciationPeriods);
	pStructDepreciations->Periods = Periods;
	pStructDepreciations->FirstDepreciation = FirstDepreciation;
	pStructDepreciations->LastDepreciation = LastDepreciation;
	pStructDepreciations->InterestRate = InterestRate;
	pStructDepreciations->Base = Base;
	pStructDepreciations->BaseQuantity = BaseQuantity;
	pStructDepreciations->ResIdual = ResIdual;
	pStructDepreciations->ResIdualQuantity = ResIdualQuantity;
	pStructDepreciations->Depreciations = Depreciations;
	pStructDepreciations->DepreciationsQuantity = DepreciationsQuantity;
	pStructDepreciations->Balance = Balance;
	pStructDepreciations->BalanceQuantity = BalanceQuantity;

	return pStructDepreciations;
}


/*********************************************************************

char **GetLeadTextDepreciations(

*********************************************************************/
char **GetLeadTextDepreciations(
	char *pLang)
{
static char *szTexts[] = {
	"Deprecated",
	"Description",
	"Depreciation Schedule",
	"Depreciation Periods",
	"Periods",
	"First Depreciation",
	"Last Depreciation",
	"Interest Rate",
	"Depreciation Quantity Unit",
	"Base",
	"Base Quantity",
	"Res Idual",
	"Res Idual Quantity",
	"Depreciations",
	"Depreciations Quantity",
	"Balance",
	"Balance Quantity",
	"Depreciation",
	"Revaluation"};

	return szTexts;
}


/*********************************************************************

	DepreciationEntry

*********************************************************************

DepreciationEntryType *CreateDepreciationEntry(

*********************************************************************/
DepreciationEntryType *CreateDepreciationEntry(
	void *pStructDocTop, 
	void *pStructParent)
{
DepreciationEntryType *pDepreciationEntry = calloc(1, sizeof(DepreciationEntryType));

	if(!pDepreciationEntry)
		return 0;	// Fatal error

	pDepreciationEntry->DataType    = SCT_DEPRECIATIONENTRY;
	pDepreciationEntry->pStructDocTop = pStructDocTop;
	pDepreciationEntry->pStructParent = pStructParent;


	return pDepreciationEntry;
}


/*********************************************************************

DepreciationEntryType *DestroyDepreciationEntry(

*********************************************************************/
DepreciationEntryType *DestroyDepreciationEntry(
	DepreciationEntryType **ppDepreciationEntry)
{
	if(!*ppDepreciationEntry)
		return 0;	// Nothing to destroy

	DestroyInvoiceEntry(&(*ppDepreciationEntry)->pReferenceBankAccount);		// rac:InvoiceEntryType
	DestroySeriesId(&(*ppDepreciationEntry)->pReferenceAccounting);		// rac:SeriesIdType

	free(*ppDepreciationEntry);
	*ppDepreciationEntry = 0;

	return 0;
}


/*********************************************************************

DepreciationEntryType *CopyDepreciationEntry(

*********************************************************************/
DepreciationEntryType *CopyDepreciationEntry(
	void *pStructDocTop, 
	void *pStructParent, 
	DepreciationEntryType *pDepreciationEntry)
{
	if(pDepreciationEntry) {
		DepreciationEntryType *pNewDepreciationEntry = CreateDepreciationEntry(pStructDocTop, pStructParent);

		if(!pNewDepreciationEntry)
			return 0;	// Fatal error

		pNewDepreciationEntry->Date = pDepreciationEntry->Date;		// xs:date
		pNewDepreciationEntry->Amount = pDepreciationEntry->Amount;		// rac:Amount
		pNewDepreciationEntry->AmountQuantity = pDepreciationEntry->AmountQuantity;		// xs:decimal
		pNewDepreciationEntry->pReferenceBankAccount = CopyInvoiceEntry(pStructDocTop, pNewDepreciationEntry, pDepreciationEntry->pReferenceBankAccount);		// rac:InvoiceEntryType
		pNewDepreciationEntry->pReferenceAccounting = CopySeriesId(pStructDocTop, pNewDepreciationEntry, pDepreciationEntry->pReferenceAccounting);		// rac:SeriesIdType

		return (pNewDepreciationEntry);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataDepreciationEntry(

*********************************************************************/
BOOL IsDataDepreciationEntry(
	DepreciationEntryType *pDepreciationEntry)
{
	if(!pDepreciationEntry)
		return FALSE;

	if(pDepreciationEntry->Date)
		return TRUE;
	if(pDepreciationEntry->Amount)
		return TRUE;
	if(!DecimalCmp(pDepreciationEntry->AmountQuantity, 0))
		return TRUE;
	if(IsDataInvoiceEntry(pDepreciationEntry->pReferenceBankAccount))
		return TRUE;
	if(IsDataSeriesId(pDepreciationEntry->pReferenceAccounting))
		return TRUE;

	return FALSE;
}


/*********************************************************************

static DepreciationEntryType *ReadSectionDepreciationEntry(

*********************************************************************/
static DepreciationEntryType *ReadSectionDepreciationEntry(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
DepreciationEntryType *pDepreciationEntry = CreateDepreciationEntry(pStructDocTop, pStructParent);

	if(!pDepreciationEntry)
		return 0;	// Fatal error

	pXmlTagData=GetNextXmlTag(pXmlTagData);

	if(!pXmlTagData)
		return 0;	// Fatal error

	while(strcmp(pXmlTagData->pTag, pEndTag)) { // While is not the end
		if(!strcmp(pXmlTagData->pTag, "Date"))
			pDepreciationEntry->Date = StringToDate(pXmlTagData->pData);		// xs:date
		else if(!strcmp(pXmlTagData->pTag, "Amount"))
			pDepreciationEntry->Amount = StringToAmount(pXmlTagData->pData);		// rac:Amount
		else if(!strcmp(pXmlTagData->pTag, "AmountQuantity"))
			pDepreciationEntry->AmountQuantity = StringToDecimal(pXmlTagData->pData);		// xs:decimal
		else if(!strcmp(pXmlTagData->pTag, "ReferenceBankAccount"))
			pDepreciationEntry->pReferenceBankAccount = ReadSectionInvoiceEntry(pStructDocTop, pDepreciationEntry, pXmlTagData, "ReferenceBankAccount");		// rac:InvoiceEntryType
		else if(!strcmp(pXmlTagData->pTag, "ReferenceAccounting"))
			pDepreciationEntry->pReferenceAccounting = ReadSectionSeriesId(pStructDocTop, pDepreciationEntry, pXmlTagData, "ReferenceAccounting");		// rac:SeriesIdType

		pXmlTagData=GetNextXmlTag(pXmlTagData);

		if(!pXmlTagData)
			return 0;	// Fatal error
	}
	return pDepreciationEntry;
}


/*********************************************************************

static BOOL WriteSectionDepreciationEntry(

*********************************************************************/
static BOOL WriteSectionDepreciationEntry(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	DepreciationEntryType *pDepreciationEntry)
{
	if(!pDepreciationEntry)
		return FALSE;	// Fatal error

	xmlWriteLine(pStream, iTab-1, pAttr, pLabel, 0, 0);
	xmlWriteLine(pStream, iTab, 0, "Date", DateToStr(pDepreciationEntry->Date, szString),"Date");		// xs:date - Mandatory
	xmlWriteLine(pStream, iTab, 0, "Amount", AmountToStr(pDepreciationEntry->Amount, szString),"Amount");		// rac:Amount - Mandatory
	if(!DecimalCmp(pDepreciationEntry->AmountQuantity, 0))
		xmlWriteLine(pStream, iTab, 0, "AmountQuantity", DecimalToStr(pDepreciationEntry->AmountQuantity, szString),"AmountQuantity");		// xs:decimal

	if(pDepreciationEntry->pReferenceBankAccount && IsDataInvoiceEntry(pDepreciationEntry->pReferenceBankAccount))		// Optional
		WriteSectionInvoiceEntry(pStream, iTab+1, "ReferenceBankAccount", 0, pDepreciationEntry->pReferenceBankAccount);		// rac:InvoiceEntryType

	if(pDepreciationEntry->pReferenceAccounting && IsDataSeriesId(pDepreciationEntry->pReferenceAccounting))		// Optional
		WriteSectionSeriesId(pStream, iTab+1, "ReferenceAccounting", 0, pDepreciationEntry->pReferenceAccounting);		// rac:SeriesIdType

	xmlWriteLine(pStream, iTab-1, 0, 0, 0, pLabel);

	return TRUE;
}


/*********************************************************************

DepreciationEntryType *UpdateDepreciationEntry(

*********************************************************************/
DepreciationEntryType *UpdateDepreciationEntry(
	DepreciationEntryType *pStructDepreciationEntry, 
	DATEINT Date, 
	AMOUNT Amount, 
	QUANT AmountQuantity)
{
	pStructDepreciationEntry->Date = Date;
	pStructDepreciationEntry->Amount = Amount;
	pStructDepreciationEntry->AmountQuantity = AmountQuantity;

	return pStructDepreciationEntry;
}


/*********************************************************************

char **GetLeadTextDepreciationEntry(

*********************************************************************/
char **GetLeadTextDepreciationEntry(
	char *pLang)
{
static char *szTexts[] = {
	"Date",
	"Amount",
	"Amount Quantity",
	"Reference Bank Account",
	"Reference Accounting"};

	return szTexts;
}


/*********************************************************************

	CITradeSettlementPaymentMeans

*********************************************************************

CITradeSettlementPaymentMeansType *CreateCITradeSettlementPaymentMeans(

*********************************************************************/
CITradeSettlementPaymentMeansType *CreateCITradeSettlementPaymentMeans(
	void *pStructDocTop, 
	void *pStructParent)
{
CITradeSettlementPaymentMeansType *pCITradeSettlementPaymentMeans = calloc(1, sizeof(CITradeSettlementPaymentMeansType));

	if(!pCITradeSettlementPaymentMeans)
		return 0;	// Fatal error

	pCITradeSettlementPaymentMeans->DataType    = SCT_CITRADESETTLEMENTPAYMENTMEANS;
	pCITradeSettlementPaymentMeans->pStructDocTop = pStructDocTop;
	pCITradeSettlementPaymentMeans->pStructParent = pStructParent;

	pCITradeSettlementPaymentMeans->pPaymentChannelCode = NulString;
	pCITradeSettlementPaymentMeans->pTypeCode = NulString;
	pCITradeSettlementPaymentMeans->pGuaranteeMethodCode = NulString;
	pCITradeSettlementPaymentMeans->pPaymentMethodCode = NulString;
	pCITradeSettlementPaymentMeans->pListId = LListInit();
	pCITradeSettlementPaymentMeans->pListInformation = LListInit();

	return pCITradeSettlementPaymentMeans;
}


/*********************************************************************

CITradeSettlementPaymentMeansType *DestroyCITradeSettlementPaymentMeans(

*********************************************************************/
CITradeSettlementPaymentMeansType *DestroyCITradeSettlementPaymentMeans(
	CITradeSettlementPaymentMeansType **ppCITradeSettlementPaymentMeans)
{
	if(!*ppCITradeSettlementPaymentMeans)
		return 0;	// Nothing to destroy

	FreeString(&(*ppCITradeSettlementPaymentMeans)->pPaymentChannelCode);		// rac:PaymentMeansChannelCodeType
	FreeString(&(*ppCITradeSettlementPaymentMeans)->pTypeCode);		// rac:PaymentMeansCodeType
	FreeString(&(*ppCITradeSettlementPaymentMeans)->pGuaranteeMethodCode);		// rac:PaymentGuaranteeMeansCodeType
	FreeString(&(*ppCITradeSettlementPaymentMeans)->pPaymentMethodCode);		// rac:PaymentMethodCodeType
	LListDestroy((*ppCITradeSettlementPaymentMeans)->pListId);		// xs:token
	LListDestroy((*ppCITradeSettlementPaymentMeans)->pListInformation);		// xs:string
	DestroyCIDebtorFinancialAccount(&(*ppCITradeSettlementPaymentMeans)->pPayerPartyCIDebtorFinancialAccount);		// rac:CIDebtorFinancialAccountType
	DestroyCICreditorFinancialAccount(&(*ppCITradeSettlementPaymentMeans)->pPayeePartyCICreditorFinancialAccount);		// rac:CICreditorFinancialAccountType
	DestroyCIDebtorFinancialInstitution(&(*ppCITradeSettlementPaymentMeans)->pPayerSpecifiedCIDebtorFinancialInstitution);		// rac:CIDebtorFinancialInstitutionType
	DestroyCICreditorFinancialInstitution(&(*ppCITradeSettlementPaymentMeans)->pPayeeSpecifiedCICreditorFinancialInstitution);		// rac:CICreditorFinancialInstitutionType
	DestroyTradeSettlementFinancialCard(&(*ppCITradeSettlementPaymentMeans)->pApplicableTradeSettlementFinancialCard);		// rac:TradeSettlementFinancialCardType

	free(*ppCITradeSettlementPaymentMeans);
	*ppCITradeSettlementPaymentMeans = 0;

	return 0;
}


/*********************************************************************

CITradeSettlementPaymentMeansType *CopyCITradeSettlementPaymentMeans(

*********************************************************************/
CITradeSettlementPaymentMeansType *CopyCITradeSettlementPaymentMeans(
	void *pStructDocTop, 
	void *pStructParent, 
	CITradeSettlementPaymentMeansType *pCITradeSettlementPaymentMeans)
{
	if(pCITradeSettlementPaymentMeans) {
		CITradeSettlementPaymentMeansType *pNewCITradeSettlementPaymentMeans = CreateCITradeSettlementPaymentMeans(pStructDocTop, pStructParent);

		if(!pNewCITradeSettlementPaymentMeans)
			return 0;	// Fatal error

		CopyString(&pNewCITradeSettlementPaymentMeans->pPaymentChannelCode, pCITradeSettlementPaymentMeans->pPaymentChannelCode);		// rac:PaymentMeansChannelCodeType
		CopyString(&pNewCITradeSettlementPaymentMeans->pTypeCode, pCITradeSettlementPaymentMeans->pTypeCode);		// rac:PaymentMeansCodeType
		CopyString(&pNewCITradeSettlementPaymentMeans->pGuaranteeMethodCode, pCITradeSettlementPaymentMeans->pGuaranteeMethodCode);		// rac:PaymentGuaranteeMeansCodeType
		CopyString(&pNewCITradeSettlementPaymentMeans->pPaymentMethodCode, pCITradeSettlementPaymentMeans->pPaymentMethodCode);		// rac:PaymentMethodCodeType
		{
			char *pId
				= LListGetFirstRecordData(pCITradeSettlementPaymentMeans->pListId);
			while(pId) {
				LListAddRecord(pNewCITradeSettlementPaymentMeans->pListId, CopyString(0, pId));		// xs:token
				pId = LListGetNextRecordData(pCITradeSettlementPaymentMeans->pListId);
			}
		}
		{
			char *pInformation
				= LListGetFirstRecordData(pCITradeSettlementPaymentMeans->pListInformation);
			while(pInformation) {
				LListAddRecord(pNewCITradeSettlementPaymentMeans->pListInformation, CopyString(0, pInformation));		// xs:string
				pInformation = LListGetNextRecordData(pCITradeSettlementPaymentMeans->pListInformation);
			}
		}
		pNewCITradeSettlementPaymentMeans->pPayerPartyCIDebtorFinancialAccount = CopyCIDebtorFinancialAccount(pStructDocTop, pNewCITradeSettlementPaymentMeans, pCITradeSettlementPaymentMeans->pPayerPartyCIDebtorFinancialAccount);		// rac:CIDebtorFinancialAccountType
		pNewCITradeSettlementPaymentMeans->pPayeePartyCICreditorFinancialAccount = CopyCICreditorFinancialAccount(pStructDocTop, pNewCITradeSettlementPaymentMeans, pCITradeSettlementPaymentMeans->pPayeePartyCICreditorFinancialAccount);		// rac:CICreditorFinancialAccountType
		pNewCITradeSettlementPaymentMeans->pPayerSpecifiedCIDebtorFinancialInstitution = CopyCIDebtorFinancialInstitution(pStructDocTop, pNewCITradeSettlementPaymentMeans, pCITradeSettlementPaymentMeans->pPayerSpecifiedCIDebtorFinancialInstitution);		// rac:CIDebtorFinancialInstitutionType
		pNewCITradeSettlementPaymentMeans->pPayeeSpecifiedCICreditorFinancialInstitution = CopyCICreditorFinancialInstitution(pStructDocTop, pNewCITradeSettlementPaymentMeans, pCITradeSettlementPaymentMeans->pPayeeSpecifiedCICreditorFinancialInstitution);		// rac:CICreditorFinancialInstitutionType
		pNewCITradeSettlementPaymentMeans->pApplicableTradeSettlementFinancialCard = CopyTradeSettlementFinancialCard(pStructDocTop, pNewCITradeSettlementPaymentMeans, pCITradeSettlementPaymentMeans->pApplicableTradeSettlementFinancialCard);		// rac:TradeSettlementFinancialCardType

		return (pNewCITradeSettlementPaymentMeans);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataCITradeSettlementPaymentMeans(

*********************************************************************/
BOOL IsDataCITradeSettlementPaymentMeans(
	CITradeSettlementPaymentMeansType *pCITradeSettlementPaymentMeans)
{
	if(!pCITradeSettlementPaymentMeans)
		return FALSE;

	if(pCITradeSettlementPaymentMeans->pPaymentChannelCode && *pCITradeSettlementPaymentMeans->pPaymentChannelCode)
		return TRUE;
	if(pCITradeSettlementPaymentMeans->pTypeCode && *pCITradeSettlementPaymentMeans->pTypeCode)
		return TRUE;
	if(pCITradeSettlementPaymentMeans->pGuaranteeMethodCode && *pCITradeSettlementPaymentMeans->pGuaranteeMethodCode)
		return TRUE;
	if(pCITradeSettlementPaymentMeans->pPaymentMethodCode && *pCITradeSettlementPaymentMeans->pPaymentMethodCode)
		return TRUE;
	if(LListGetFirstRecordData(pCITradeSettlementPaymentMeans->pListId))
		return TRUE;
	if(LListGetFirstRecordData(pCITradeSettlementPaymentMeans->pListInformation))
		return TRUE;
	if(IsDataCIDebtorFinancialAccount(pCITradeSettlementPaymentMeans->pPayerPartyCIDebtorFinancialAccount))
		return TRUE;
	if(IsDataCICreditorFinancialAccount(pCITradeSettlementPaymentMeans->pPayeePartyCICreditorFinancialAccount))
		return TRUE;
	if(IsDataCIDebtorFinancialInstitution(pCITradeSettlementPaymentMeans->pPayerSpecifiedCIDebtorFinancialInstitution))
		return TRUE;
	if(IsDataCICreditorFinancialInstitution(pCITradeSettlementPaymentMeans->pPayeeSpecifiedCICreditorFinancialInstitution))
		return TRUE;
	if(IsDataTradeSettlementFinancialCard(pCITradeSettlementPaymentMeans->pApplicableTradeSettlementFinancialCard))
		return TRUE;

	return FALSE;
}


/*********************************************************************

static CITradeSettlementPaymentMeansType *ReadSectionCITradeSettlementPaymentMeans(

*********************************************************************/
static CITradeSettlementPaymentMeansType *ReadSectionCITradeSettlementPaymentMeans(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
CITradeSettlementPaymentMeansType *pCITradeSettlementPaymentMeans = CreateCITradeSettlementPaymentMeans(pStructDocTop, pStructParent);

	if(!pCITradeSettlementPaymentMeans)
		return 0;	// Fatal error

	pXmlTagData=GetNextXmlTag(pXmlTagData);

	if(!pXmlTagData)
		return 0;	// Fatal error

	while(strcmp(pXmlTagData->pTag, pEndTag)) { // While is not the end
		if(!strcmp(pXmlTagData->pTag, "PaymentChannelCode"))
			CheckEnum(&pCITradeSettlementPaymentMeans->pPaymentChannelCode, EnumPaymentMeansChannelCodeType, ReadXmlDataString(pXmlTagData->pData));		// rac:PaymentMeansChannelCodeType
		else if(!strcmp(pXmlTagData->pTag, "TypeCode"))
			CheckEnum(&pCITradeSettlementPaymentMeans->pTypeCode, EnumPaymentMeansCodeType, ReadXmlDataString(pXmlTagData->pData));		// rac:PaymentMeansCodeType
		else if(!strcmp(pXmlTagData->pTag, "GuaranteeMethodCode"))
			CheckEnum(&pCITradeSettlementPaymentMeans->pGuaranteeMethodCode, EnumPaymentGuaranteeMeansCodeType, ReadXmlDataString(pXmlTagData->pData));		// rac:PaymentGuaranteeMeansCodeType
		else if(!strcmp(pXmlTagData->pTag, "PaymentMethodCode"))
			CheckEnum(&pCITradeSettlementPaymentMeans->pPaymentMethodCode, EnumPaymentMethodCodeType, ReadXmlDataString(pXmlTagData->pData));		// rac:PaymentMethodCodeType
		else if(!strcmp(pXmlTagData->pTag, "Id"))
			LListAddRecord(pCITradeSettlementPaymentMeans->pListId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "Information"))
			LListAddRecord(pCITradeSettlementPaymentMeans->pListInformation, ReadXmlDataString(pXmlTagData->pData));		// xs:string
		else if(!strcmp(pXmlTagData->pTag, "PayerPartyCIDebtorFinancialAccount"))
			pCITradeSettlementPaymentMeans->pPayerPartyCIDebtorFinancialAccount = ReadSectionCIDebtorFinancialAccount(pStructDocTop, pCITradeSettlementPaymentMeans, pXmlTagData, "PayerPartyCIDebtorFinancialAccount");		// rac:CIDebtorFinancialAccountType
		else if(!strcmp(pXmlTagData->pTag, "PayeePartyCICreditorFinancialAccount"))
			pCITradeSettlementPaymentMeans->pPayeePartyCICreditorFinancialAccount = ReadSectionCICreditorFinancialAccount(pStructDocTop, pCITradeSettlementPaymentMeans, pXmlTagData, "PayeePartyCICreditorFinancialAccount");		// rac:CICreditorFinancialAccountType
		else if(!strcmp(pXmlTagData->pTag, "PayerSpecifiedCIDebtorFinancialInstitution"))
			pCITradeSettlementPaymentMeans->pPayerSpecifiedCIDebtorFinancialInstitution = ReadSectionCIDebtorFinancialInstitution(pStructDocTop, pCITradeSettlementPaymentMeans, pXmlTagData, "PayerSpecifiedCIDebtorFinancialInstitution");		// rac:CIDebtorFinancialInstitutionType
		else if(!strcmp(pXmlTagData->pTag, "PayeeSpecifiedCICreditorFinancialInstitution"))
			pCITradeSettlementPaymentMeans->pPayeeSpecifiedCICreditorFinancialInstitution = ReadSectionCICreditorFinancialInstitution(pStructDocTop, pCITradeSettlementPaymentMeans, pXmlTagData, "PayeeSpecifiedCICreditorFinancialInstitution");		// rac:CICreditorFinancialInstitutionType
		else if(!strcmp(pXmlTagData->pTag, "ApplicableTradeSettlementFinancialCard"))
			pCITradeSettlementPaymentMeans->pApplicableTradeSettlementFinancialCard = ReadSectionTradeSettlementFinancialCard(pStructDocTop, pCITradeSettlementPaymentMeans, pXmlTagData, "ApplicableTradeSettlementFinancialCard");		// rac:TradeSettlementFinancialCardType

		pXmlTagData=GetNextXmlTag(pXmlTagData);

		if(!pXmlTagData)
			return 0;	// Fatal error
	}
	return pCITradeSettlementPaymentMeans;
}


/*********************************************************************

static BOOL WriteSectionCITradeSettlementPaymentMeans(

*********************************************************************/
static BOOL WriteSectionCITradeSettlementPaymentMeans(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	CITradeSettlementPaymentMeansType *pCITradeSettlementPaymentMeans)
{
	if(!pCITradeSettlementPaymentMeans)
		return FALSE;	// Fatal error

	xmlWriteLine(pStream, iTab-1, pAttr, pLabel, 0, 0);
	if(pCITradeSettlementPaymentMeans->pPaymentChannelCode && *pCITradeSettlementPaymentMeans->pPaymentChannelCode)
		xmlWriteLine(pStream, iTab, 0, "PaymentChannelCode", pCITradeSettlementPaymentMeans->pPaymentChannelCode, "PaymentChannelCode");		// rac:PaymentMeansChannelCodeType
	if(pCITradeSettlementPaymentMeans->pTypeCode && *pCITradeSettlementPaymentMeans->pTypeCode)
		xmlWriteLine(pStream, iTab, 0, "TypeCode", pCITradeSettlementPaymentMeans->pTypeCode, "TypeCode");		// rac:PaymentMeansCodeType
	if(pCITradeSettlementPaymentMeans->pGuaranteeMethodCode && *pCITradeSettlementPaymentMeans->pGuaranteeMethodCode)
		xmlWriteLine(pStream, iTab, 0, "GuaranteeMethodCode", pCITradeSettlementPaymentMeans->pGuaranteeMethodCode, "GuaranteeMethodCode");		// rac:PaymentGuaranteeMeansCodeType
	if(pCITradeSettlementPaymentMeans->pPaymentMethodCode && *pCITradeSettlementPaymentMeans->pPaymentMethodCode)
		xmlWriteLine(pStream, iTab, 0, "PaymentMethodCode", pCITradeSettlementPaymentMeans->pPaymentMethodCode, "PaymentMethodCode");		// rac:PaymentMethodCodeType

	if(pCITradeSettlementPaymentMeans->pListId) {
		char *pId
			= LListGetFirstRecordData(pCITradeSettlementPaymentMeans->pListId);
		while(pId) {
			xmlWriteLine(pStream, iTab, 0, "Id", pId, "Id");		// xs:token

			pId = LListGetNextRecordData(pCITradeSettlementPaymentMeans->pListId);
		}
	}

	if(pCITradeSettlementPaymentMeans->pListInformation) {
		char *pInformation
			= LListGetFirstRecordData(pCITradeSettlementPaymentMeans->pListInformation);
		while(pInformation) {
			xmlWriteLine(pStream, iTab, 0, "Information", pInformation, "Information");		// xs:string

			pInformation = LListGetNextRecordData(pCITradeSettlementPaymentMeans->pListInformation);
		}
	}

	if(pCITradeSettlementPaymentMeans->pPayerPartyCIDebtorFinancialAccount && IsDataCIDebtorFinancialAccount(pCITradeSettlementPaymentMeans->pPayerPartyCIDebtorFinancialAccount))		// Optional
		WriteSectionCIDebtorFinancialAccount(pStream, iTab+1, "PayerPartyCIDebtorFinancialAccount", 0, pCITradeSettlementPaymentMeans->pPayerPartyCIDebtorFinancialAccount);		// rac:CIDebtorFinancialAccountType

	if(pCITradeSettlementPaymentMeans->pPayeePartyCICreditorFinancialAccount && IsDataCICreditorFinancialAccount(pCITradeSettlementPaymentMeans->pPayeePartyCICreditorFinancialAccount))		// Optional
		WriteSectionCICreditorFinancialAccount(pStream, iTab+1, "PayeePartyCICreditorFinancialAccount", 0, pCITradeSettlementPaymentMeans->pPayeePartyCICreditorFinancialAccount);		// rac:CICreditorFinancialAccountType

	if(pCITradeSettlementPaymentMeans->pPayerSpecifiedCIDebtorFinancialInstitution && IsDataCIDebtorFinancialInstitution(pCITradeSettlementPaymentMeans->pPayerSpecifiedCIDebtorFinancialInstitution))		// Optional
		WriteSectionCIDebtorFinancialInstitution(pStream, iTab+1, "PayerSpecifiedCIDebtorFinancialInstitution", 0, pCITradeSettlementPaymentMeans->pPayerSpecifiedCIDebtorFinancialInstitution);		// rac:CIDebtorFinancialInstitutionType

	if(pCITradeSettlementPaymentMeans->pPayeeSpecifiedCICreditorFinancialInstitution && IsDataCICreditorFinancialInstitution(pCITradeSettlementPaymentMeans->pPayeeSpecifiedCICreditorFinancialInstitution))		// Optional
		WriteSectionCICreditorFinancialInstitution(pStream, iTab+1, "PayeeSpecifiedCICreditorFinancialInstitution", 0, pCITradeSettlementPaymentMeans->pPayeeSpecifiedCICreditorFinancialInstitution);		// rac:CICreditorFinancialInstitutionType

	if(pCITradeSettlementPaymentMeans->pApplicableTradeSettlementFinancialCard && IsDataTradeSettlementFinancialCard(pCITradeSettlementPaymentMeans->pApplicableTradeSettlementFinancialCard))		// Optional
		WriteSectionTradeSettlementFinancialCard(pStream, iTab+1, "ApplicableTradeSettlementFinancialCard", 0, pCITradeSettlementPaymentMeans->pApplicableTradeSettlementFinancialCard);		// rac:TradeSettlementFinancialCardType

	xmlWriteLine(pStream, iTab-1, 0, 0, 0, pLabel);

	return TRUE;
}


/*********************************************************************

CITradeSettlementPaymentMeansType *UpdateCITradeSettlementPaymentMeans(

*********************************************************************/
CITradeSettlementPaymentMeansType *UpdateCITradeSettlementPaymentMeans(
	CITradeSettlementPaymentMeansType *pStructCITradeSettlementPaymentMeans, 
	char *pPaymentChannelCode, 
	char *pTypeCode, 
	char *pGuaranteeMethodCode, 
	char *pPaymentMethodCode)
{
	StringUpdate(&pStructCITradeSettlementPaymentMeans->pPaymentChannelCode, pPaymentChannelCode);
	StringUpdate(&pStructCITradeSettlementPaymentMeans->pTypeCode, pTypeCode);
	StringUpdate(&pStructCITradeSettlementPaymentMeans->pGuaranteeMethodCode, pGuaranteeMethodCode);
	StringUpdate(&pStructCITradeSettlementPaymentMeans->pPaymentMethodCode, pPaymentMethodCode);

	return pStructCITradeSettlementPaymentMeans;
}


/*********************************************************************

char **GetLeadTextCITradeSettlementPaymentMeans(

*********************************************************************/
char **GetLeadTextCITradeSettlementPaymentMeans(
	char *pLang)
{
static char *szTexts[] = {
	"Payment Channel Code",
	"Type Code",
	"Guarantee Method Code",
	"Payment Method Code",
	"Id",
	"Information",
	"Payer Party C I Debtor Financial Account",
	"Payee Party C I Creditor Financial Account",
	"Payer Specified C I Debtor Financial Institution",
	"Payee Specified C I Creditor Financial Institution",
	"Applicable Trade Settlement Financial Card"};

	return szTexts;
}


/*********************************************************************

	CIDebtorFinancialAccount

*********************************************************************

CIDebtorFinancialAccountType *CreateCIDebtorFinancialAccount(

*********************************************************************/
CIDebtorFinancialAccountType *CreateCIDebtorFinancialAccount(
	void *pStructDocTop, 
	void *pStructParent)
{
CIDebtorFinancialAccountType *pCIDebtorFinancialAccount = calloc(1, sizeof(CIDebtorFinancialAccountType));

	if(!pCIDebtorFinancialAccount)
		return 0;	// Fatal error

	pCIDebtorFinancialAccount->DataType    = SCT_CIDEBTORFINANCIALACCOUNT;
	pCIDebtorFinancialAccount->pStructDocTop = pStructDocTop;
	pCIDebtorFinancialAccount->pStructParent = pStructParent;

	pCIDebtorFinancialAccount->pIBANId = NulString;
	pCIDebtorFinancialAccount->pAccountName = NulString;
	pCIDebtorFinancialAccount->pProprietaryId = NulString;

	return pCIDebtorFinancialAccount;
}


/*********************************************************************

CIDebtorFinancialAccountType *DestroyCIDebtorFinancialAccount(

*********************************************************************/
CIDebtorFinancialAccountType *DestroyCIDebtorFinancialAccount(
	CIDebtorFinancialAccountType **ppCIDebtorFinancialAccount)
{
	if(!*ppCIDebtorFinancialAccount)
		return 0;	// Nothing to destroy

	FreeString(&(*ppCIDebtorFinancialAccount)->pIBANId);		// xs:token
	FreeString(&(*ppCIDebtorFinancialAccount)->pAccountName);		// xs:string
	FreeString(&(*ppCIDebtorFinancialAccount)->pProprietaryId);		// xs:token

	free(*ppCIDebtorFinancialAccount);
	*ppCIDebtorFinancialAccount = 0;

	return 0;
}


/*********************************************************************

CIDebtorFinancialAccountType *CopyCIDebtorFinancialAccount(

*********************************************************************/
CIDebtorFinancialAccountType *CopyCIDebtorFinancialAccount(
	void *pStructDocTop, 
	void *pStructParent, 
	CIDebtorFinancialAccountType *pCIDebtorFinancialAccount)
{
	if(pCIDebtorFinancialAccount) {
		CIDebtorFinancialAccountType *pNewCIDebtorFinancialAccount = CreateCIDebtorFinancialAccount(pStructDocTop, pStructParent);

		if(!pNewCIDebtorFinancialAccount)
			return 0;	// Fatal error

		CopyString(&pNewCIDebtorFinancialAccount->pIBANId, pCIDebtorFinancialAccount->pIBANId);		// xs:token
		CopyString(&pNewCIDebtorFinancialAccount->pAccountName, pCIDebtorFinancialAccount->pAccountName);		// xs:string
		CopyString(&pNewCIDebtorFinancialAccount->pProprietaryId, pCIDebtorFinancialAccount->pProprietaryId);		// xs:token

		return (pNewCIDebtorFinancialAccount);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataCIDebtorFinancialAccount(

*********************************************************************/
BOOL IsDataCIDebtorFinancialAccount(
	CIDebtorFinancialAccountType *pCIDebtorFinancialAccount)
{
	if(!pCIDebtorFinancialAccount)
		return FALSE;

	if(pCIDebtorFinancialAccount->pIBANId && *pCIDebtorFinancialAccount->pIBANId)
		return TRUE;
	if(pCIDebtorFinancialAccount->pAccountName && *pCIDebtorFinancialAccount->pAccountName)
		return TRUE;
	if(pCIDebtorFinancialAccount->pProprietaryId && *pCIDebtorFinancialAccount->pProprietaryId)
		return TRUE;

	return FALSE;
}


/*********************************************************************

static CIDebtorFinancialAccountType *ReadSectionCIDebtorFinancialAccount(

*********************************************************************/
static CIDebtorFinancialAccountType *ReadSectionCIDebtorFinancialAccount(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
CIDebtorFinancialAccountType *pCIDebtorFinancialAccount = CreateCIDebtorFinancialAccount(pStructDocTop, pStructParent);

	if(!pCIDebtorFinancialAccount)
		return 0;	// Fatal error

	pXmlTagData=GetNextXmlTag(pXmlTagData);

	if(!pXmlTagData)
		return 0;	// Fatal error

	while(strcmp(pXmlTagData->pTag, pEndTag)) { // While is not the end
		if(!strcmp(pXmlTagData->pTag, "IBANId"))
			ReadString(&pCIDebtorFinancialAccount->pIBANId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "AccountName"))
			ReadString(&pCIDebtorFinancialAccount->pAccountName, ReadXmlDataString(pXmlTagData->pData));		// xs:string
		else if(!strcmp(pXmlTagData->pTag, "ProprietaryId"))
			ReadString(&pCIDebtorFinancialAccount->pProprietaryId, ReadXmlDataString(pXmlTagData->pData));		// xs:token

		pXmlTagData=GetNextXmlTag(pXmlTagData);

		if(!pXmlTagData)
			return 0;	// Fatal error
	}
	return pCIDebtorFinancialAccount;
}


/*********************************************************************

static BOOL WriteSectionCIDebtorFinancialAccount(

*********************************************************************/
static BOOL WriteSectionCIDebtorFinancialAccount(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	CIDebtorFinancialAccountType *pCIDebtorFinancialAccount)
{
	if(!pCIDebtorFinancialAccount)
		return FALSE;	// Fatal error

	xmlWriteLine(pStream, iTab-1, pAttr, pLabel, 0, 0);
	if(pCIDebtorFinancialAccount->pIBANId && *pCIDebtorFinancialAccount->pIBANId)
		xmlWriteLine(pStream, iTab, 0, "IBANId", pCIDebtorFinancialAccount->pIBANId, "IBANId");		// xs:token
	if(pCIDebtorFinancialAccount->pAccountName && *pCIDebtorFinancialAccount->pAccountName)
		xmlWriteLine(pStream, iTab, 0, "AccountName", pCIDebtorFinancialAccount->pAccountName, "AccountName");		// xs:string
	if(pCIDebtorFinancialAccount->pProprietaryId && *pCIDebtorFinancialAccount->pProprietaryId)
		xmlWriteLine(pStream, iTab, 0, "ProprietaryId", pCIDebtorFinancialAccount->pProprietaryId, "ProprietaryId");		// xs:token

	xmlWriteLine(pStream, iTab-1, 0, 0, 0, pLabel);

	return TRUE;
}


/*********************************************************************

CIDebtorFinancialAccountType *UpdateCIDebtorFinancialAccount(

*********************************************************************/
CIDebtorFinancialAccountType *UpdateCIDebtorFinancialAccount(
	CIDebtorFinancialAccountType *pStructCIDebtorFinancialAccount, 
	char *pIBANId, 
	char *pAccountName, 
	char *pProprietaryId)
{
	StringUpdate(&pStructCIDebtorFinancialAccount->pIBANId, pIBANId);
	StringUpdate(&pStructCIDebtorFinancialAccount->pAccountName, pAccountName);
	StringUpdate(&pStructCIDebtorFinancialAccount->pProprietaryId, pProprietaryId);

	return pStructCIDebtorFinancialAccount;
}


/*********************************************************************

char **GetLeadTextCIDebtorFinancialAccount(

*********************************************************************/
char **GetLeadTextCIDebtorFinancialAccount(
	char *pLang)
{
static char *szTexts[] = {
	"I B A N Id",
	"Account Name",
	"Proprietary Id"};

	return szTexts;
}


/*********************************************************************

	CIDebtorFinancialInstitution

*********************************************************************

CIDebtorFinancialInstitutionType *CreateCIDebtorFinancialInstitution(

*********************************************************************/
CIDebtorFinancialInstitutionType *CreateCIDebtorFinancialInstitution(
	void *pStructDocTop, 
	void *pStructParent)
{
CIDebtorFinancialInstitutionType *pCIDebtorFinancialInstitution = calloc(1, sizeof(CIDebtorFinancialInstitutionType));

	if(!pCIDebtorFinancialInstitution)
		return 0;	// Fatal error

	pCIDebtorFinancialInstitution->DataType    = SCT_CIDEBTORFINANCIALINSTITUTION;
	pCIDebtorFinancialInstitution->pStructDocTop = pStructDocTop;
	pCIDebtorFinancialInstitution->pStructParent = pStructParent;

	pCIDebtorFinancialInstitution->pBICId = NulString;
	pCIDebtorFinancialInstitution->pClearingSystemName = NulString;
	pCIDebtorFinancialInstitution->pCHIPSUniversalId = NulString;
	pCIDebtorFinancialInstitution->pNewZealandNCCId = NulString;
	pCIDebtorFinancialInstitution->pIrishNSCId = NulString;
	pCIDebtorFinancialInstitution->pUKSortCodeId = NulString;
	pCIDebtorFinancialInstitution->pCHIPSParticipantId = NulString;
	pCIDebtorFinancialInstitution->pSwissBCId = NulString;
	pCIDebtorFinancialInstitution->pFedwireRoutingNumberId = NulString;
	pCIDebtorFinancialInstitution->pPortugueseNCCId = NulString;
	pCIDebtorFinancialInstitution->pRussianCentralBankId = NulString;
	pCIDebtorFinancialInstitution->pItalianDomesticId = NulString;
	pCIDebtorFinancialInstitution->pAustrianBankleitzahlId = NulString;
	pCIDebtorFinancialInstitution->pCanadianPaymentsAssociationId = NulString;
	pCIDebtorFinancialInstitution->pSICId = NulString;
	pCIDebtorFinancialInstitution->pGermanBankleitzahlId = NulString;
	pCIDebtorFinancialInstitution->pSpanishDomesticInterbankingId = NulString;
	pCIDebtorFinancialInstitution->pSouthAfricanNCCId = NulString;
	pCIDebtorFinancialInstitution->pHongKongBankId = NulString;
	pCIDebtorFinancialInstitution->pAustralianBSBId = NulString;
	pCIDebtorFinancialInstitution->pIndianFinancialSystemId = NulString;
	pCIDebtorFinancialInstitution->pHellenicBankId = NulString;
	pCIDebtorFinancialInstitution->pPolishNationalClearingId = NulString;
	pCIDebtorFinancialInstitution->pName = NulString;
	pCIDebtorFinancialInstitution->pJapanFinancialInstitutionCommonId = NulString;

	return pCIDebtorFinancialInstitution;
}


/*********************************************************************

CIDebtorFinancialInstitutionType *DestroyCIDebtorFinancialInstitution(

*********************************************************************/
CIDebtorFinancialInstitutionType *DestroyCIDebtorFinancialInstitution(
	CIDebtorFinancialInstitutionType **ppCIDebtorFinancialInstitution)
{
	if(!*ppCIDebtorFinancialInstitution)
		return 0;	// Nothing to destroy

	FreeString(&(*ppCIDebtorFinancialInstitution)->pBICId);		// xs:token
	FreeString(&(*ppCIDebtorFinancialInstitution)->pClearingSystemName);		// xs:string
	FreeString(&(*ppCIDebtorFinancialInstitution)->pCHIPSUniversalId);		// xs:token
	FreeString(&(*ppCIDebtorFinancialInstitution)->pNewZealandNCCId);		// xs:token
	FreeString(&(*ppCIDebtorFinancialInstitution)->pIrishNSCId);		// xs:token
	FreeString(&(*ppCIDebtorFinancialInstitution)->pUKSortCodeId);		// xs:token
	FreeString(&(*ppCIDebtorFinancialInstitution)->pCHIPSParticipantId);		// xs:token
	FreeString(&(*ppCIDebtorFinancialInstitution)->pSwissBCId);		// xs:token
	FreeString(&(*ppCIDebtorFinancialInstitution)->pFedwireRoutingNumberId);		// xs:token
	FreeString(&(*ppCIDebtorFinancialInstitution)->pPortugueseNCCId);		// xs:token
	FreeString(&(*ppCIDebtorFinancialInstitution)->pRussianCentralBankId);		// xs:token
	FreeString(&(*ppCIDebtorFinancialInstitution)->pItalianDomesticId);		// xs:token
	FreeString(&(*ppCIDebtorFinancialInstitution)->pAustrianBankleitzahlId);		// xs:token
	FreeString(&(*ppCIDebtorFinancialInstitution)->pCanadianPaymentsAssociationId);		// xs:token
	FreeString(&(*ppCIDebtorFinancialInstitution)->pSICId);		// xs:token
	FreeString(&(*ppCIDebtorFinancialInstitution)->pGermanBankleitzahlId);		// xs:token
	FreeString(&(*ppCIDebtorFinancialInstitution)->pSpanishDomesticInterbankingId);		// xs:token
	FreeString(&(*ppCIDebtorFinancialInstitution)->pSouthAfricanNCCId);		// xs:token
	FreeString(&(*ppCIDebtorFinancialInstitution)->pHongKongBankId);		// xs:token
	FreeString(&(*ppCIDebtorFinancialInstitution)->pAustralianBSBId);		// xs:token
	FreeString(&(*ppCIDebtorFinancialInstitution)->pIndianFinancialSystemId);		// xs:token
	FreeString(&(*ppCIDebtorFinancialInstitution)->pHellenicBankId);		// xs:token
	FreeString(&(*ppCIDebtorFinancialInstitution)->pPolishNationalClearingId);		// xs:token
	FreeString(&(*ppCIDebtorFinancialInstitution)->pName);		// xs:string
	FreeString(&(*ppCIDebtorFinancialInstitution)->pJapanFinancialInstitutionCommonId);		// xs:token
	DestroyFinancialInstitutionAddress(&(*ppCIDebtorFinancialInstitution)->pLocationFinancialInstitutionAddress);		// rac:FinancialInstitutionAddressType
	DestroyBranchFinancialInstitution(&(*ppCIDebtorFinancialInstitution)->pSubDivisionBranchFinancialInstitution);		// rac:BranchFinancialInstitutionType

	free(*ppCIDebtorFinancialInstitution);
	*ppCIDebtorFinancialInstitution = 0;

	return 0;
}


/*********************************************************************

CIDebtorFinancialInstitutionType *CopyCIDebtorFinancialInstitution(

*********************************************************************/
CIDebtorFinancialInstitutionType *CopyCIDebtorFinancialInstitution(
	void *pStructDocTop, 
	void *pStructParent, 
	CIDebtorFinancialInstitutionType *pCIDebtorFinancialInstitution)
{
	if(pCIDebtorFinancialInstitution) {
		CIDebtorFinancialInstitutionType *pNewCIDebtorFinancialInstitution = CreateCIDebtorFinancialInstitution(pStructDocTop, pStructParent);

		if(!pNewCIDebtorFinancialInstitution)
			return 0;	// Fatal error

		CopyString(&pNewCIDebtorFinancialInstitution->pBICId, pCIDebtorFinancialInstitution->pBICId);		// xs:token
		CopyString(&pNewCIDebtorFinancialInstitution->pClearingSystemName, pCIDebtorFinancialInstitution->pClearingSystemName);		// xs:string
		CopyString(&pNewCIDebtorFinancialInstitution->pCHIPSUniversalId, pCIDebtorFinancialInstitution->pCHIPSUniversalId);		// xs:token
		CopyString(&pNewCIDebtorFinancialInstitution->pNewZealandNCCId, pCIDebtorFinancialInstitution->pNewZealandNCCId);		// xs:token
		CopyString(&pNewCIDebtorFinancialInstitution->pIrishNSCId, pCIDebtorFinancialInstitution->pIrishNSCId);		// xs:token
		CopyString(&pNewCIDebtorFinancialInstitution->pUKSortCodeId, pCIDebtorFinancialInstitution->pUKSortCodeId);		// xs:token
		CopyString(&pNewCIDebtorFinancialInstitution->pCHIPSParticipantId, pCIDebtorFinancialInstitution->pCHIPSParticipantId);		// xs:token
		CopyString(&pNewCIDebtorFinancialInstitution->pSwissBCId, pCIDebtorFinancialInstitution->pSwissBCId);		// xs:token
		CopyString(&pNewCIDebtorFinancialInstitution->pFedwireRoutingNumberId, pCIDebtorFinancialInstitution->pFedwireRoutingNumberId);		// xs:token
		CopyString(&pNewCIDebtorFinancialInstitution->pPortugueseNCCId, pCIDebtorFinancialInstitution->pPortugueseNCCId);		// xs:token
		CopyString(&pNewCIDebtorFinancialInstitution->pRussianCentralBankId, pCIDebtorFinancialInstitution->pRussianCentralBankId);		// xs:token
		CopyString(&pNewCIDebtorFinancialInstitution->pItalianDomesticId, pCIDebtorFinancialInstitution->pItalianDomesticId);		// xs:token
		CopyString(&pNewCIDebtorFinancialInstitution->pAustrianBankleitzahlId, pCIDebtorFinancialInstitution->pAustrianBankleitzahlId);		// xs:token
		CopyString(&pNewCIDebtorFinancialInstitution->pCanadianPaymentsAssociationId, pCIDebtorFinancialInstitution->pCanadianPaymentsAssociationId);		// xs:token
		CopyString(&pNewCIDebtorFinancialInstitution->pSICId, pCIDebtorFinancialInstitution->pSICId);		// xs:token
		CopyString(&pNewCIDebtorFinancialInstitution->pGermanBankleitzahlId, pCIDebtorFinancialInstitution->pGermanBankleitzahlId);		// xs:token
		CopyString(&pNewCIDebtorFinancialInstitution->pSpanishDomesticInterbankingId, pCIDebtorFinancialInstitution->pSpanishDomesticInterbankingId);		// xs:token
		CopyString(&pNewCIDebtorFinancialInstitution->pSouthAfricanNCCId, pCIDebtorFinancialInstitution->pSouthAfricanNCCId);		// xs:token
		CopyString(&pNewCIDebtorFinancialInstitution->pHongKongBankId, pCIDebtorFinancialInstitution->pHongKongBankId);		// xs:token
		CopyString(&pNewCIDebtorFinancialInstitution->pAustralianBSBId, pCIDebtorFinancialInstitution->pAustralianBSBId);		// xs:token
		CopyString(&pNewCIDebtorFinancialInstitution->pIndianFinancialSystemId, pCIDebtorFinancialInstitution->pIndianFinancialSystemId);		// xs:token
		CopyString(&pNewCIDebtorFinancialInstitution->pHellenicBankId, pCIDebtorFinancialInstitution->pHellenicBankId);		// xs:token
		CopyString(&pNewCIDebtorFinancialInstitution->pPolishNationalClearingId, pCIDebtorFinancialInstitution->pPolishNationalClearingId);		// xs:token
		CopyString(&pNewCIDebtorFinancialInstitution->pName, pCIDebtorFinancialInstitution->pName);		// xs:string
		CopyString(&pNewCIDebtorFinancialInstitution->pJapanFinancialInstitutionCommonId, pCIDebtorFinancialInstitution->pJapanFinancialInstitutionCommonId);		// xs:token
		pNewCIDebtorFinancialInstitution->pLocationFinancialInstitutionAddress = CopyFinancialInstitutionAddress(pStructDocTop, pNewCIDebtorFinancialInstitution, pCIDebtorFinancialInstitution->pLocationFinancialInstitutionAddress);		// rac:FinancialInstitutionAddressType
		pNewCIDebtorFinancialInstitution->pSubDivisionBranchFinancialInstitution = CopyBranchFinancialInstitution(pStructDocTop, pNewCIDebtorFinancialInstitution, pCIDebtorFinancialInstitution->pSubDivisionBranchFinancialInstitution);		// rac:BranchFinancialInstitutionType

		return (pNewCIDebtorFinancialInstitution);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataCIDebtorFinancialInstitution(

*********************************************************************/
BOOL IsDataCIDebtorFinancialInstitution(
	CIDebtorFinancialInstitutionType *pCIDebtorFinancialInstitution)
{
	if(!pCIDebtorFinancialInstitution)
		return FALSE;

	if(pCIDebtorFinancialInstitution->pBICId && *pCIDebtorFinancialInstitution->pBICId)
		return TRUE;
	if(pCIDebtorFinancialInstitution->pClearingSystemName && *pCIDebtorFinancialInstitution->pClearingSystemName)
		return TRUE;
	if(pCIDebtorFinancialInstitution->pCHIPSUniversalId && *pCIDebtorFinancialInstitution->pCHIPSUniversalId)
		return TRUE;
	if(pCIDebtorFinancialInstitution->pNewZealandNCCId && *pCIDebtorFinancialInstitution->pNewZealandNCCId)
		return TRUE;
	if(pCIDebtorFinancialInstitution->pIrishNSCId && *pCIDebtorFinancialInstitution->pIrishNSCId)
		return TRUE;
	if(pCIDebtorFinancialInstitution->pUKSortCodeId && *pCIDebtorFinancialInstitution->pUKSortCodeId)
		return TRUE;
	if(pCIDebtorFinancialInstitution->pCHIPSParticipantId && *pCIDebtorFinancialInstitution->pCHIPSParticipantId)
		return TRUE;
	if(pCIDebtorFinancialInstitution->pSwissBCId && *pCIDebtorFinancialInstitution->pSwissBCId)
		return TRUE;
	if(pCIDebtorFinancialInstitution->pFedwireRoutingNumberId && *pCIDebtorFinancialInstitution->pFedwireRoutingNumberId)
		return TRUE;
	if(pCIDebtorFinancialInstitution->pPortugueseNCCId && *pCIDebtorFinancialInstitution->pPortugueseNCCId)
		return TRUE;
	if(pCIDebtorFinancialInstitution->pRussianCentralBankId && *pCIDebtorFinancialInstitution->pRussianCentralBankId)
		return TRUE;
	if(pCIDebtorFinancialInstitution->pItalianDomesticId && *pCIDebtorFinancialInstitution->pItalianDomesticId)
		return TRUE;
	if(pCIDebtorFinancialInstitution->pAustrianBankleitzahlId && *pCIDebtorFinancialInstitution->pAustrianBankleitzahlId)
		return TRUE;
	if(pCIDebtorFinancialInstitution->pCanadianPaymentsAssociationId && *pCIDebtorFinancialInstitution->pCanadianPaymentsAssociationId)
		return TRUE;
	if(pCIDebtorFinancialInstitution->pSICId && *pCIDebtorFinancialInstitution->pSICId)
		return TRUE;
	if(pCIDebtorFinancialInstitution->pGermanBankleitzahlId && *pCIDebtorFinancialInstitution->pGermanBankleitzahlId)
		return TRUE;
	if(pCIDebtorFinancialInstitution->pSpanishDomesticInterbankingId && *pCIDebtorFinancialInstitution->pSpanishDomesticInterbankingId)
		return TRUE;
	if(pCIDebtorFinancialInstitution->pSouthAfricanNCCId && *pCIDebtorFinancialInstitution->pSouthAfricanNCCId)
		return TRUE;
	if(pCIDebtorFinancialInstitution->pHongKongBankId && *pCIDebtorFinancialInstitution->pHongKongBankId)
		return TRUE;
	if(pCIDebtorFinancialInstitution->pAustralianBSBId && *pCIDebtorFinancialInstitution->pAustralianBSBId)
		return TRUE;
	if(pCIDebtorFinancialInstitution->pIndianFinancialSystemId && *pCIDebtorFinancialInstitution->pIndianFinancialSystemId)
		return TRUE;
	if(pCIDebtorFinancialInstitution->pHellenicBankId && *pCIDebtorFinancialInstitution->pHellenicBankId)
		return TRUE;
	if(pCIDebtorFinancialInstitution->pPolishNationalClearingId && *pCIDebtorFinancialInstitution->pPolishNationalClearingId)
		return TRUE;
	if(pCIDebtorFinancialInstitution->pName && *pCIDebtorFinancialInstitution->pName)
		return TRUE;
	if(pCIDebtorFinancialInstitution->pJapanFinancialInstitutionCommonId && *pCIDebtorFinancialInstitution->pJapanFinancialInstitutionCommonId)
		return TRUE;
	if(IsDataFinancialInstitutionAddress(pCIDebtorFinancialInstitution->pLocationFinancialInstitutionAddress))
		return TRUE;
	if(IsDataBranchFinancialInstitution(pCIDebtorFinancialInstitution->pSubDivisionBranchFinancialInstitution))
		return TRUE;

	return FALSE;
}


/*********************************************************************

static CIDebtorFinancialInstitutionType *ReadSectionCIDebtorFinancialInstitution(

*********************************************************************/
static CIDebtorFinancialInstitutionType *ReadSectionCIDebtorFinancialInstitution(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
CIDebtorFinancialInstitutionType *pCIDebtorFinancialInstitution = CreateCIDebtorFinancialInstitution(pStructDocTop, pStructParent);

	if(!pCIDebtorFinancialInstitution)
		return 0;	// Fatal error

	pXmlTagData=GetNextXmlTag(pXmlTagData);

	if(!pXmlTagData)
		return 0;	// Fatal error

	while(strcmp(pXmlTagData->pTag, pEndTag)) { // While is not the end
		if(!strcmp(pXmlTagData->pTag, "BICId"))
			ReadString(&pCIDebtorFinancialInstitution->pBICId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "ClearingSystemName"))
			ReadString(&pCIDebtorFinancialInstitution->pClearingSystemName, ReadXmlDataString(pXmlTagData->pData));		// xs:string
		else if(!strcmp(pXmlTagData->pTag, "CHIPSUniversalId"))
			ReadString(&pCIDebtorFinancialInstitution->pCHIPSUniversalId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "NewZealandNCCId"))
			ReadString(&pCIDebtorFinancialInstitution->pNewZealandNCCId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "IrishNSCId"))
			ReadString(&pCIDebtorFinancialInstitution->pIrishNSCId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "UKSortCodeId"))
			ReadString(&pCIDebtorFinancialInstitution->pUKSortCodeId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "CHIPSParticipantId"))
			ReadString(&pCIDebtorFinancialInstitution->pCHIPSParticipantId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "SwissBCId"))
			ReadString(&pCIDebtorFinancialInstitution->pSwissBCId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "FedwireRoutingNumberId"))
			ReadString(&pCIDebtorFinancialInstitution->pFedwireRoutingNumberId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "PortugueseNCCId"))
			ReadString(&pCIDebtorFinancialInstitution->pPortugueseNCCId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "RussianCentralBankId"))
			ReadString(&pCIDebtorFinancialInstitution->pRussianCentralBankId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "ItalianDomesticId"))
			ReadString(&pCIDebtorFinancialInstitution->pItalianDomesticId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "AustrianBankleitzahlId"))
			ReadString(&pCIDebtorFinancialInstitution->pAustrianBankleitzahlId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "CanadianPaymentsAssociationId"))
			ReadString(&pCIDebtorFinancialInstitution->pCanadianPaymentsAssociationId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "SICId"))
			ReadString(&pCIDebtorFinancialInstitution->pSICId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "GermanBankleitzahlId"))
			ReadString(&pCIDebtorFinancialInstitution->pGermanBankleitzahlId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "SpanishDomesticInterbankingId"))
			ReadString(&pCIDebtorFinancialInstitution->pSpanishDomesticInterbankingId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "SouthAfricanNCCId"))
			ReadString(&pCIDebtorFinancialInstitution->pSouthAfricanNCCId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "HongKongBankId"))
			ReadString(&pCIDebtorFinancialInstitution->pHongKongBankId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "AustralianBSBId"))
			ReadString(&pCIDebtorFinancialInstitution->pAustralianBSBId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "IndianFinancialSystemId"))
			ReadString(&pCIDebtorFinancialInstitution->pIndianFinancialSystemId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "HellenicBankId"))
			ReadString(&pCIDebtorFinancialInstitution->pHellenicBankId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "PolishNationalClearingId"))
			ReadString(&pCIDebtorFinancialInstitution->pPolishNationalClearingId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "Name"))
			ReadString(&pCIDebtorFinancialInstitution->pName, ReadXmlDataString(pXmlTagData->pData));		// xs:string
		else if(!strcmp(pXmlTagData->pTag, "JapanFinancialInstitutionCommonId"))
			ReadString(&pCIDebtorFinancialInstitution->pJapanFinancialInstitutionCommonId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "LocationFinancialInstitutionAddress"))
			pCIDebtorFinancialInstitution->pLocationFinancialInstitutionAddress = ReadSectionFinancialInstitutionAddress(pStructDocTop, pCIDebtorFinancialInstitution, pXmlTagData, "LocationFinancialInstitutionAddress");		// rac:FinancialInstitutionAddressType
		else if(!strcmp(pXmlTagData->pTag, "SubDivisionBranchFinancialInstitution"))
			pCIDebtorFinancialInstitution->pSubDivisionBranchFinancialInstitution = ReadSectionBranchFinancialInstitution(pStructDocTop, pCIDebtorFinancialInstitution, pXmlTagData, "SubDivisionBranchFinancialInstitution");		// rac:BranchFinancialInstitutionType

		pXmlTagData=GetNextXmlTag(pXmlTagData);

		if(!pXmlTagData)
			return 0;	// Fatal error
	}
	return pCIDebtorFinancialInstitution;
}


/*********************************************************************

static BOOL WriteSectionCIDebtorFinancialInstitution(

*********************************************************************/
static BOOL WriteSectionCIDebtorFinancialInstitution(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	CIDebtorFinancialInstitutionType *pCIDebtorFinancialInstitution)
{
	if(!pCIDebtorFinancialInstitution)
		return FALSE;	// Fatal error

	xmlWriteLine(pStream, iTab-1, pAttr, pLabel, 0, 0);
	if(pCIDebtorFinancialInstitution->pBICId && *pCIDebtorFinancialInstitution->pBICId)
		xmlWriteLine(pStream, iTab, 0, "BICId", pCIDebtorFinancialInstitution->pBICId, "BICId");		// xs:token
	if(pCIDebtorFinancialInstitution->pClearingSystemName && *pCIDebtorFinancialInstitution->pClearingSystemName)
		xmlWriteLine(pStream, iTab, 0, "ClearingSystemName", pCIDebtorFinancialInstitution->pClearingSystemName, "ClearingSystemName");		// xs:string
	if(pCIDebtorFinancialInstitution->pCHIPSUniversalId && *pCIDebtorFinancialInstitution->pCHIPSUniversalId)
		xmlWriteLine(pStream, iTab, 0, "CHIPSUniversalId", pCIDebtorFinancialInstitution->pCHIPSUniversalId, "CHIPSUniversalId");		// xs:token
	if(pCIDebtorFinancialInstitution->pNewZealandNCCId && *pCIDebtorFinancialInstitution->pNewZealandNCCId)
		xmlWriteLine(pStream, iTab, 0, "NewZealandNCCId", pCIDebtorFinancialInstitution->pNewZealandNCCId, "NewZealandNCCId");		// xs:token
	if(pCIDebtorFinancialInstitution->pIrishNSCId && *pCIDebtorFinancialInstitution->pIrishNSCId)
		xmlWriteLine(pStream, iTab, 0, "IrishNSCId", pCIDebtorFinancialInstitution->pIrishNSCId, "IrishNSCId");		// xs:token
	if(pCIDebtorFinancialInstitution->pUKSortCodeId && *pCIDebtorFinancialInstitution->pUKSortCodeId)
		xmlWriteLine(pStream, iTab, 0, "UKSortCodeId", pCIDebtorFinancialInstitution->pUKSortCodeId, "UKSortCodeId");		// xs:token
	if(pCIDebtorFinancialInstitution->pCHIPSParticipantId && *pCIDebtorFinancialInstitution->pCHIPSParticipantId)
		xmlWriteLine(pStream, iTab, 0, "CHIPSParticipantId", pCIDebtorFinancialInstitution->pCHIPSParticipantId, "CHIPSParticipantId");		// xs:token
	if(pCIDebtorFinancialInstitution->pSwissBCId && *pCIDebtorFinancialInstitution->pSwissBCId)
		xmlWriteLine(pStream, iTab, 0, "SwissBCId", pCIDebtorFinancialInstitution->pSwissBCId, "SwissBCId");		// xs:token
	if(pCIDebtorFinancialInstitution->pFedwireRoutingNumberId && *pCIDebtorFinancialInstitution->pFedwireRoutingNumberId)
		xmlWriteLine(pStream, iTab, 0, "FedwireRoutingNumberId", pCIDebtorFinancialInstitution->pFedwireRoutingNumberId, "FedwireRoutingNumberId");		// xs:token
	if(pCIDebtorFinancialInstitution->pPortugueseNCCId && *pCIDebtorFinancialInstitution->pPortugueseNCCId)
		xmlWriteLine(pStream, iTab, 0, "PortugueseNCCId", pCIDebtorFinancialInstitution->pPortugueseNCCId, "PortugueseNCCId");		// xs:token
	if(pCIDebtorFinancialInstitution->pRussianCentralBankId && *pCIDebtorFinancialInstitution->pRussianCentralBankId)
		xmlWriteLine(pStream, iTab, 0, "RussianCentralBankId", pCIDebtorFinancialInstitution->pRussianCentralBankId, "RussianCentralBankId");		// xs:token
	if(pCIDebtorFinancialInstitution->pItalianDomesticId && *pCIDebtorFinancialInstitution->pItalianDomesticId)
		xmlWriteLine(pStream, iTab, 0, "ItalianDomesticId", pCIDebtorFinancialInstitution->pItalianDomesticId, "ItalianDomesticId");		// xs:token
	if(pCIDebtorFinancialInstitution->pAustrianBankleitzahlId && *pCIDebtorFinancialInstitution->pAustrianBankleitzahlId)
		xmlWriteLine(pStream, iTab, 0, "AustrianBankleitzahlId", pCIDebtorFinancialInstitution->pAustrianBankleitzahlId, "AustrianBankleitzahlId");		// xs:token
	if(pCIDebtorFinancialInstitution->pCanadianPaymentsAssociationId && *pCIDebtorFinancialInstitution->pCanadianPaymentsAssociationId)
		xmlWriteLine(pStream, iTab, 0, "CanadianPaymentsAssociationId", pCIDebtorFinancialInstitution->pCanadianPaymentsAssociationId, "CanadianPaymentsAssociationId");		// xs:token
	if(pCIDebtorFinancialInstitution->pSICId && *pCIDebtorFinancialInstitution->pSICId)
		xmlWriteLine(pStream, iTab, 0, "SICId", pCIDebtorFinancialInstitution->pSICId, "SICId");		// xs:token
	if(pCIDebtorFinancialInstitution->pGermanBankleitzahlId && *pCIDebtorFinancialInstitution->pGermanBankleitzahlId)
		xmlWriteLine(pStream, iTab, 0, "GermanBankleitzahlId", pCIDebtorFinancialInstitution->pGermanBankleitzahlId, "GermanBankleitzahlId");		// xs:token
	if(pCIDebtorFinancialInstitution->pSpanishDomesticInterbankingId && *pCIDebtorFinancialInstitution->pSpanishDomesticInterbankingId)
		xmlWriteLine(pStream, iTab, 0, "SpanishDomesticInterbankingId", pCIDebtorFinancialInstitution->pSpanishDomesticInterbankingId, "SpanishDomesticInterbankingId");		// xs:token
	if(pCIDebtorFinancialInstitution->pSouthAfricanNCCId && *pCIDebtorFinancialInstitution->pSouthAfricanNCCId)
		xmlWriteLine(pStream, iTab, 0, "SouthAfricanNCCId", pCIDebtorFinancialInstitution->pSouthAfricanNCCId, "SouthAfricanNCCId");		// xs:token
	if(pCIDebtorFinancialInstitution->pHongKongBankId && *pCIDebtorFinancialInstitution->pHongKongBankId)
		xmlWriteLine(pStream, iTab, 0, "HongKongBankId", pCIDebtorFinancialInstitution->pHongKongBankId, "HongKongBankId");		// xs:token
	if(pCIDebtorFinancialInstitution->pAustralianBSBId && *pCIDebtorFinancialInstitution->pAustralianBSBId)
		xmlWriteLine(pStream, iTab, 0, "AustralianBSBId", pCIDebtorFinancialInstitution->pAustralianBSBId, "AustralianBSBId");		// xs:token
	if(pCIDebtorFinancialInstitution->pIndianFinancialSystemId && *pCIDebtorFinancialInstitution->pIndianFinancialSystemId)
		xmlWriteLine(pStream, iTab, 0, "IndianFinancialSystemId", pCIDebtorFinancialInstitution->pIndianFinancialSystemId, "IndianFinancialSystemId");		// xs:token
	if(pCIDebtorFinancialInstitution->pHellenicBankId && *pCIDebtorFinancialInstitution->pHellenicBankId)
		xmlWriteLine(pStream, iTab, 0, "HellenicBankId", pCIDebtorFinancialInstitution->pHellenicBankId, "HellenicBankId");		// xs:token
	if(pCIDebtorFinancialInstitution->pPolishNationalClearingId && *pCIDebtorFinancialInstitution->pPolishNationalClearingId)
		xmlWriteLine(pStream, iTab, 0, "PolishNationalClearingId", pCIDebtorFinancialInstitution->pPolishNationalClearingId, "PolishNationalClearingId");		// xs:token
	if(pCIDebtorFinancialInstitution->pName && *pCIDebtorFinancialInstitution->pName)
		xmlWriteLine(pStream, iTab, 0, "Name", pCIDebtorFinancialInstitution->pName, "Name");		// xs:string
	if(pCIDebtorFinancialInstitution->pJapanFinancialInstitutionCommonId && *pCIDebtorFinancialInstitution->pJapanFinancialInstitutionCommonId)
		xmlWriteLine(pStream, iTab, 0, "JapanFinancialInstitutionCommonId", pCIDebtorFinancialInstitution->pJapanFinancialInstitutionCommonId, "JapanFinancialInstitutionCommonId");		// xs:token

	if(pCIDebtorFinancialInstitution->pLocationFinancialInstitutionAddress && IsDataFinancialInstitutionAddress(pCIDebtorFinancialInstitution->pLocationFinancialInstitutionAddress))		// Optional
		WriteSectionFinancialInstitutionAddress(pStream, iTab+1, "LocationFinancialInstitutionAddress", 0, pCIDebtorFinancialInstitution->pLocationFinancialInstitutionAddress);		// rac:FinancialInstitutionAddressType

	if(pCIDebtorFinancialInstitution->pSubDivisionBranchFinancialInstitution && IsDataBranchFinancialInstitution(pCIDebtorFinancialInstitution->pSubDivisionBranchFinancialInstitution))		// Optional
		WriteSectionBranchFinancialInstitution(pStream, iTab+1, "SubDivisionBranchFinancialInstitution", 0, pCIDebtorFinancialInstitution->pSubDivisionBranchFinancialInstitution);		// rac:BranchFinancialInstitutionType

	xmlWriteLine(pStream, iTab-1, 0, 0, 0, pLabel);

	return TRUE;
}


/*********************************************************************

CIDebtorFinancialInstitutionType *UpdateCIDebtorFinancialInstitution(

*********************************************************************/
CIDebtorFinancialInstitutionType *UpdateCIDebtorFinancialInstitution(
	CIDebtorFinancialInstitutionType *pStructCIDebtorFinancialInstitution, 
	char *pBICId, 
	char *pClearingSystemName, 
	char *pCHIPSUniversalId, 
	char *pNewZealandNCCId, 
	char *pIrishNSCId, 
	char *pUKSortCodeId, 
	char *pCHIPSParticipantId, 
	char *pSwissBCId, 
	char *pFedwireRoutingNumberId, 
	char *pPortugueseNCCId, 
	char *pRussianCentralBankId, 
	char *pItalianDomesticId, 
	char *pAustrianBankleitzahlId, 
	char *pCanadianPaymentsAssociationId, 
	char *pSICId, 
	char *pGermanBankleitzahlId, 
	char *pSpanishDomesticInterbankingId, 
	char *pSouthAfricanNCCId, 
	char *pHongKongBankId, 
	char *pAustralianBSBId, 
	char *pIndianFinancialSystemId, 
	char *pHellenicBankId, 
	char *pPolishNationalClearingId, 
	char *pName, 
	char *pJapanFinancialInstitutionCommonId)
{
	StringUpdate(&pStructCIDebtorFinancialInstitution->pBICId, pBICId);
	StringUpdate(&pStructCIDebtorFinancialInstitution->pClearingSystemName, pClearingSystemName);
	StringUpdate(&pStructCIDebtorFinancialInstitution->pCHIPSUniversalId, pCHIPSUniversalId);
	StringUpdate(&pStructCIDebtorFinancialInstitution->pNewZealandNCCId, pNewZealandNCCId);
	StringUpdate(&pStructCIDebtorFinancialInstitution->pIrishNSCId, pIrishNSCId);
	StringUpdate(&pStructCIDebtorFinancialInstitution->pUKSortCodeId, pUKSortCodeId);
	StringUpdate(&pStructCIDebtorFinancialInstitution->pCHIPSParticipantId, pCHIPSParticipantId);
	StringUpdate(&pStructCIDebtorFinancialInstitution->pSwissBCId, pSwissBCId);
	StringUpdate(&pStructCIDebtorFinancialInstitution->pFedwireRoutingNumberId, pFedwireRoutingNumberId);
	StringUpdate(&pStructCIDebtorFinancialInstitution->pPortugueseNCCId, pPortugueseNCCId);
	StringUpdate(&pStructCIDebtorFinancialInstitution->pRussianCentralBankId, pRussianCentralBankId);
	StringUpdate(&pStructCIDebtorFinancialInstitution->pItalianDomesticId, pItalianDomesticId);
	StringUpdate(&pStructCIDebtorFinancialInstitution->pAustrianBankleitzahlId, pAustrianBankleitzahlId);
	StringUpdate(&pStructCIDebtorFinancialInstitution->pCanadianPaymentsAssociationId, pCanadianPaymentsAssociationId);
	StringUpdate(&pStructCIDebtorFinancialInstitution->pSICId, pSICId);
	StringUpdate(&pStructCIDebtorFinancialInstitution->pGermanBankleitzahlId, pGermanBankleitzahlId);
	StringUpdate(&pStructCIDebtorFinancialInstitution->pSpanishDomesticInterbankingId, pSpanishDomesticInterbankingId);
	StringUpdate(&pStructCIDebtorFinancialInstitution->pSouthAfricanNCCId, pSouthAfricanNCCId);
	StringUpdate(&pStructCIDebtorFinancialInstitution->pHongKongBankId, pHongKongBankId);
	StringUpdate(&pStructCIDebtorFinancialInstitution->pAustralianBSBId, pAustralianBSBId);
	StringUpdate(&pStructCIDebtorFinancialInstitution->pIndianFinancialSystemId, pIndianFinancialSystemId);
	StringUpdate(&pStructCIDebtorFinancialInstitution->pHellenicBankId, pHellenicBankId);
	StringUpdate(&pStructCIDebtorFinancialInstitution->pPolishNationalClearingId, pPolishNationalClearingId);
	StringUpdate(&pStructCIDebtorFinancialInstitution->pName, pName);
	StringUpdate(&pStructCIDebtorFinancialInstitution->pJapanFinancialInstitutionCommonId, pJapanFinancialInstitutionCommonId);

	return pStructCIDebtorFinancialInstitution;
}


/*********************************************************************

char **GetLeadTextCIDebtorFinancialInstitution(

*********************************************************************/
char **GetLeadTextCIDebtorFinancialInstitution(
	char *pLang)
{
static char *szTexts[] = {
	"B I C Id",
	"Clearing System Name",
	"C H I P S Universal Id",
	"New Zealand N C C Id",
	"Irish N S C Id",
	"U K Sort Code Id",
	"C H I P S Participant Id",
	"Swiss B C Id",
	"Fedwire Routing Number Id",
	"Portuguese N C C Id",
	"Russian Central Bank Id",
	"Italian Domestic Id",
	"Austrian Bankleitzahl Id",
	"Canadian Payments Association Id",
	"S I C Id",
	"German Bankleitzahl Id",
	"Spanish Domestic Interbanking Id",
	"South African N C C Id",
	"Hong Kong Bank Id",
	"Australian B S B Id",
	"Indian Financial System Id",
	"Hellenic Bank Id",
	"Polish National Clearing Id",
	"Name",
	"Japan Financial Institution Common Id",
	"Location Financial Institution Address",
	"Sub Division Branch Financial Institution"};

	return szTexts;
}


/*********************************************************************

	CICreditorFinancialAccount

*********************************************************************

CICreditorFinancialAccountType *CreateCICreditorFinancialAccount(

*********************************************************************/
CICreditorFinancialAccountType *CreateCICreditorFinancialAccount(
	void *pStructDocTop, 
	void *pStructParent)
{
CICreditorFinancialAccountType *pCICreditorFinancialAccount = calloc(1, sizeof(CICreditorFinancialAccountType));

	if(!pCICreditorFinancialAccount)
		return 0;	// Fatal error

	pCICreditorFinancialAccount->DataType    = SCT_CICREDITORFINANCIALACCOUNT;
	pCICreditorFinancialAccount->pStructDocTop = pStructDocTop;
	pCICreditorFinancialAccount->pStructParent = pStructParent;

	pCICreditorFinancialAccount->pIBANId = NulString;
	pCICreditorFinancialAccount->pAccountName = NulString;
	pCICreditorFinancialAccount->pProprietaryId = NulString;

	return pCICreditorFinancialAccount;
}


/*********************************************************************

CICreditorFinancialAccountType *DestroyCICreditorFinancialAccount(

*********************************************************************/
CICreditorFinancialAccountType *DestroyCICreditorFinancialAccount(
	CICreditorFinancialAccountType **ppCICreditorFinancialAccount)
{
	if(!*ppCICreditorFinancialAccount)
		return 0;	// Nothing to destroy

	FreeString(&(*ppCICreditorFinancialAccount)->pIBANId);		// xs:token
	FreeString(&(*ppCICreditorFinancialAccount)->pAccountName);		// xs:string
	FreeString(&(*ppCICreditorFinancialAccount)->pProprietaryId);		// xs:token

	free(*ppCICreditorFinancialAccount);
	*ppCICreditorFinancialAccount = 0;

	return 0;
}


/*********************************************************************

CICreditorFinancialAccountType *CopyCICreditorFinancialAccount(

*********************************************************************/
CICreditorFinancialAccountType *CopyCICreditorFinancialAccount(
	void *pStructDocTop, 
	void *pStructParent, 
	CICreditorFinancialAccountType *pCICreditorFinancialAccount)
{
	if(pCICreditorFinancialAccount) {
		CICreditorFinancialAccountType *pNewCICreditorFinancialAccount = CreateCICreditorFinancialAccount(pStructDocTop, pStructParent);

		if(!pNewCICreditorFinancialAccount)
			return 0;	// Fatal error

		CopyString(&pNewCICreditorFinancialAccount->pIBANId, pCICreditorFinancialAccount->pIBANId);		// xs:token
		CopyString(&pNewCICreditorFinancialAccount->pAccountName, pCICreditorFinancialAccount->pAccountName);		// xs:string
		CopyString(&pNewCICreditorFinancialAccount->pProprietaryId, pCICreditorFinancialAccount->pProprietaryId);		// xs:token

		return (pNewCICreditorFinancialAccount);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataCICreditorFinancialAccount(

*********************************************************************/
BOOL IsDataCICreditorFinancialAccount(
	CICreditorFinancialAccountType *pCICreditorFinancialAccount)
{
	if(!pCICreditorFinancialAccount)
		return FALSE;

	if(pCICreditorFinancialAccount->pIBANId && *pCICreditorFinancialAccount->pIBANId)
		return TRUE;
	if(pCICreditorFinancialAccount->pAccountName && *pCICreditorFinancialAccount->pAccountName)
		return TRUE;
	if(pCICreditorFinancialAccount->pProprietaryId && *pCICreditorFinancialAccount->pProprietaryId)
		return TRUE;

	return FALSE;
}


/*********************************************************************

static CICreditorFinancialAccountType *ReadSectionCICreditorFinancialAccount(

*********************************************************************/
static CICreditorFinancialAccountType *ReadSectionCICreditorFinancialAccount(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
CICreditorFinancialAccountType *pCICreditorFinancialAccount = CreateCICreditorFinancialAccount(pStructDocTop, pStructParent);

	if(!pCICreditorFinancialAccount)
		return 0;	// Fatal error

	pXmlTagData=GetNextXmlTag(pXmlTagData);

	if(!pXmlTagData)
		return 0;	// Fatal error

	while(strcmp(pXmlTagData->pTag, pEndTag)) { // While is not the end
		if(!strcmp(pXmlTagData->pTag, "IBANId"))
			ReadString(&pCICreditorFinancialAccount->pIBANId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "AccountName"))
			ReadString(&pCICreditorFinancialAccount->pAccountName, ReadXmlDataString(pXmlTagData->pData));		// xs:string
		else if(!strcmp(pXmlTagData->pTag, "ProprietaryId"))
			ReadString(&pCICreditorFinancialAccount->pProprietaryId, ReadXmlDataString(pXmlTagData->pData));		// xs:token

		pXmlTagData=GetNextXmlTag(pXmlTagData);

		if(!pXmlTagData)
			return 0;	// Fatal error
	}
	return pCICreditorFinancialAccount;
}


/*********************************************************************

static BOOL WriteSectionCICreditorFinancialAccount(

*********************************************************************/
static BOOL WriteSectionCICreditorFinancialAccount(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	CICreditorFinancialAccountType *pCICreditorFinancialAccount)
{
	if(!pCICreditorFinancialAccount)
		return FALSE;	// Fatal error

	xmlWriteLine(pStream, iTab-1, pAttr, pLabel, 0, 0);
	if(pCICreditorFinancialAccount->pIBANId && *pCICreditorFinancialAccount->pIBANId)
		xmlWriteLine(pStream, iTab, 0, "IBANId", pCICreditorFinancialAccount->pIBANId, "IBANId");		// xs:token
	if(pCICreditorFinancialAccount->pAccountName && *pCICreditorFinancialAccount->pAccountName)
		xmlWriteLine(pStream, iTab, 0, "AccountName", pCICreditorFinancialAccount->pAccountName, "AccountName");		// xs:string
	if(pCICreditorFinancialAccount->pProprietaryId && *pCICreditorFinancialAccount->pProprietaryId)
		xmlWriteLine(pStream, iTab, 0, "ProprietaryId", pCICreditorFinancialAccount->pProprietaryId, "ProprietaryId");		// xs:token

	xmlWriteLine(pStream, iTab-1, 0, 0, 0, pLabel);

	return TRUE;
}


/*********************************************************************

CICreditorFinancialAccountType *UpdateCICreditorFinancialAccount(

*********************************************************************/
CICreditorFinancialAccountType *UpdateCICreditorFinancialAccount(
	CICreditorFinancialAccountType *pStructCICreditorFinancialAccount, 
	char *pIBANId, 
	char *pAccountName, 
	char *pProprietaryId)
{
	StringUpdate(&pStructCICreditorFinancialAccount->pIBANId, pIBANId);
	StringUpdate(&pStructCICreditorFinancialAccount->pAccountName, pAccountName);
	StringUpdate(&pStructCICreditorFinancialAccount->pProprietaryId, pProprietaryId);

	return pStructCICreditorFinancialAccount;
}


/*********************************************************************

char **GetLeadTextCICreditorFinancialAccount(

*********************************************************************/
char **GetLeadTextCICreditorFinancialAccount(
	char *pLang)
{
static char *szTexts[] = {
	"I B A N Id",
	"Account Name",
	"Proprietary Id"};

	return szTexts;
}


/*********************************************************************

	CICreditorFinancialInstitution

*********************************************************************

CICreditorFinancialInstitutionType *CreateCICreditorFinancialInstitution(

*********************************************************************/
CICreditorFinancialInstitutionType *CreateCICreditorFinancialInstitution(
	void *pStructDocTop, 
	void *pStructParent)
{
CICreditorFinancialInstitutionType *pCICreditorFinancialInstitution = calloc(1, sizeof(CICreditorFinancialInstitutionType));

	if(!pCICreditorFinancialInstitution)
		return 0;	// Fatal error

	pCICreditorFinancialInstitution->DataType    = SCT_CICREDITORFINANCIALINSTITUTION;
	pCICreditorFinancialInstitution->pStructDocTop = pStructDocTop;
	pCICreditorFinancialInstitution->pStructParent = pStructParent;

	pCICreditorFinancialInstitution->pBICId = NulString;
	pCICreditorFinancialInstitution->pClearingSystemName = NulString;
	pCICreditorFinancialInstitution->pCHIPSUniversalId = NulString;
	pCICreditorFinancialInstitution->pNewZealandNCCId = NulString;
	pCICreditorFinancialInstitution->pIrishNSCId = NulString;
	pCICreditorFinancialInstitution->pUKSortCodeId = NulString;
	pCICreditorFinancialInstitution->pCHIPSParticipantId = NulString;
	pCICreditorFinancialInstitution->pSwissBCId = NulString;
	pCICreditorFinancialInstitution->pFedwireRoutingNumberId = NulString;
	pCICreditorFinancialInstitution->pPortugueseNCCId = NulString;
	pCICreditorFinancialInstitution->pRussianCentralBankId = NulString;
	pCICreditorFinancialInstitution->pItalianDomesticId = NulString;
	pCICreditorFinancialInstitution->pAustrianBankleitzahlId = NulString;
	pCICreditorFinancialInstitution->pCanadianPaymentsAssociationId = NulString;
	pCICreditorFinancialInstitution->pSICId = NulString;
	pCICreditorFinancialInstitution->pGermanBankleitzahlId = NulString;
	pCICreditorFinancialInstitution->pSpanishDomesticInterbankingId = NulString;
	pCICreditorFinancialInstitution->pSouthAfricanNCCId = NulString;
	pCICreditorFinancialInstitution->pHongKongBankId = NulString;
	pCICreditorFinancialInstitution->pAustralianBSBId = NulString;
	pCICreditorFinancialInstitution->pIndianFinancialSystemId = NulString;
	pCICreditorFinancialInstitution->pHellenicBankId = NulString;
	pCICreditorFinancialInstitution->pPolishNationalClearingId = NulString;
	pCICreditorFinancialInstitution->pName = NulString;
	pCICreditorFinancialInstitution->pJapanFinancialInstitutionCommonId = NulString;

	return pCICreditorFinancialInstitution;
}


/*********************************************************************

CICreditorFinancialInstitutionType *DestroyCICreditorFinancialInstitution(

*********************************************************************/
CICreditorFinancialInstitutionType *DestroyCICreditorFinancialInstitution(
	CICreditorFinancialInstitutionType **ppCICreditorFinancialInstitution)
{
	if(!*ppCICreditorFinancialInstitution)
		return 0;	// Nothing to destroy

	FreeString(&(*ppCICreditorFinancialInstitution)->pBICId);		// xs:token
	FreeString(&(*ppCICreditorFinancialInstitution)->pClearingSystemName);		// xs:string
	FreeString(&(*ppCICreditorFinancialInstitution)->pCHIPSUniversalId);		// xs:token
	FreeString(&(*ppCICreditorFinancialInstitution)->pNewZealandNCCId);		// xs:token
	FreeString(&(*ppCICreditorFinancialInstitution)->pIrishNSCId);		// xs:token
	FreeString(&(*ppCICreditorFinancialInstitution)->pUKSortCodeId);		// xs:token
	FreeString(&(*ppCICreditorFinancialInstitution)->pCHIPSParticipantId);		// xs:token
	FreeString(&(*ppCICreditorFinancialInstitution)->pSwissBCId);		// xs:token
	FreeString(&(*ppCICreditorFinancialInstitution)->pFedwireRoutingNumberId);		// xs:token
	FreeString(&(*ppCICreditorFinancialInstitution)->pPortugueseNCCId);		// xs:token
	FreeString(&(*ppCICreditorFinancialInstitution)->pRussianCentralBankId);		// xs:token
	FreeString(&(*ppCICreditorFinancialInstitution)->pItalianDomesticId);		// xs:token
	FreeString(&(*ppCICreditorFinancialInstitution)->pAustrianBankleitzahlId);		// xs:token
	FreeString(&(*ppCICreditorFinancialInstitution)->pCanadianPaymentsAssociationId);		// xs:token
	FreeString(&(*ppCICreditorFinancialInstitution)->pSICId);		// xs:token
	FreeString(&(*ppCICreditorFinancialInstitution)->pGermanBankleitzahlId);		// xs:token
	FreeString(&(*ppCICreditorFinancialInstitution)->pSpanishDomesticInterbankingId);		// xs:token
	FreeString(&(*ppCICreditorFinancialInstitution)->pSouthAfricanNCCId);		// xs:token
	FreeString(&(*ppCICreditorFinancialInstitution)->pHongKongBankId);		// xs:token
	FreeString(&(*ppCICreditorFinancialInstitution)->pAustralianBSBId);		// xs:token
	FreeString(&(*ppCICreditorFinancialInstitution)->pIndianFinancialSystemId);		// xs:token
	FreeString(&(*ppCICreditorFinancialInstitution)->pHellenicBankId);		// xs:token
	FreeString(&(*ppCICreditorFinancialInstitution)->pPolishNationalClearingId);		// xs:token
	FreeString(&(*ppCICreditorFinancialInstitution)->pName);		// xs:string
	FreeString(&(*ppCICreditorFinancialInstitution)->pJapanFinancialInstitutionCommonId);		// xs:token
	DestroyFinancialInstitutionAddress(&(*ppCICreditorFinancialInstitution)->pLocationFinancialInstitutionAddress);		// rac:FinancialInstitutionAddressType
	DestroyBranchFinancialInstitution(&(*ppCICreditorFinancialInstitution)->pSubDivisionBranchFinancialInstitution);		// rac:BranchFinancialInstitutionType

	free(*ppCICreditorFinancialInstitution);
	*ppCICreditorFinancialInstitution = 0;

	return 0;
}


/*********************************************************************

CICreditorFinancialInstitutionType *CopyCICreditorFinancialInstitution(

*********************************************************************/
CICreditorFinancialInstitutionType *CopyCICreditorFinancialInstitution(
	void *pStructDocTop, 
	void *pStructParent, 
	CICreditorFinancialInstitutionType *pCICreditorFinancialInstitution)
{
	if(pCICreditorFinancialInstitution) {
		CICreditorFinancialInstitutionType *pNewCICreditorFinancialInstitution = CreateCICreditorFinancialInstitution(pStructDocTop, pStructParent);

		if(!pNewCICreditorFinancialInstitution)
			return 0;	// Fatal error

		CopyString(&pNewCICreditorFinancialInstitution->pBICId, pCICreditorFinancialInstitution->pBICId);		// xs:token
		CopyString(&pNewCICreditorFinancialInstitution->pClearingSystemName, pCICreditorFinancialInstitution->pClearingSystemName);		// xs:string
		CopyString(&pNewCICreditorFinancialInstitution->pCHIPSUniversalId, pCICreditorFinancialInstitution->pCHIPSUniversalId);		// xs:token
		CopyString(&pNewCICreditorFinancialInstitution->pNewZealandNCCId, pCICreditorFinancialInstitution->pNewZealandNCCId);		// xs:token
		CopyString(&pNewCICreditorFinancialInstitution->pIrishNSCId, pCICreditorFinancialInstitution->pIrishNSCId);		// xs:token
		CopyString(&pNewCICreditorFinancialInstitution->pUKSortCodeId, pCICreditorFinancialInstitution->pUKSortCodeId);		// xs:token
		CopyString(&pNewCICreditorFinancialInstitution->pCHIPSParticipantId, pCICreditorFinancialInstitution->pCHIPSParticipantId);		// xs:token
		CopyString(&pNewCICreditorFinancialInstitution->pSwissBCId, pCICreditorFinancialInstitution->pSwissBCId);		// xs:token
		CopyString(&pNewCICreditorFinancialInstitution->pFedwireRoutingNumberId, pCICreditorFinancialInstitution->pFedwireRoutingNumberId);		// xs:token
		CopyString(&pNewCICreditorFinancialInstitution->pPortugueseNCCId, pCICreditorFinancialInstitution->pPortugueseNCCId);		// xs:token
		CopyString(&pNewCICreditorFinancialInstitution->pRussianCentralBankId, pCICreditorFinancialInstitution->pRussianCentralBankId);		// xs:token
		CopyString(&pNewCICreditorFinancialInstitution->pItalianDomesticId, pCICreditorFinancialInstitution->pItalianDomesticId);		// xs:token
		CopyString(&pNewCICreditorFinancialInstitution->pAustrianBankleitzahlId, pCICreditorFinancialInstitution->pAustrianBankleitzahlId);		// xs:token
		CopyString(&pNewCICreditorFinancialInstitution->pCanadianPaymentsAssociationId, pCICreditorFinancialInstitution->pCanadianPaymentsAssociationId);		// xs:token
		CopyString(&pNewCICreditorFinancialInstitution->pSICId, pCICreditorFinancialInstitution->pSICId);		// xs:token
		CopyString(&pNewCICreditorFinancialInstitution->pGermanBankleitzahlId, pCICreditorFinancialInstitution->pGermanBankleitzahlId);		// xs:token
		CopyString(&pNewCICreditorFinancialInstitution->pSpanishDomesticInterbankingId, pCICreditorFinancialInstitution->pSpanishDomesticInterbankingId);		// xs:token
		CopyString(&pNewCICreditorFinancialInstitution->pSouthAfricanNCCId, pCICreditorFinancialInstitution->pSouthAfricanNCCId);		// xs:token
		CopyString(&pNewCICreditorFinancialInstitution->pHongKongBankId, pCICreditorFinancialInstitution->pHongKongBankId);		// xs:token
		CopyString(&pNewCICreditorFinancialInstitution->pAustralianBSBId, pCICreditorFinancialInstitution->pAustralianBSBId);		// xs:token
		CopyString(&pNewCICreditorFinancialInstitution->pIndianFinancialSystemId, pCICreditorFinancialInstitution->pIndianFinancialSystemId);		// xs:token
		CopyString(&pNewCICreditorFinancialInstitution->pHellenicBankId, pCICreditorFinancialInstitution->pHellenicBankId);		// xs:token
		CopyString(&pNewCICreditorFinancialInstitution->pPolishNationalClearingId, pCICreditorFinancialInstitution->pPolishNationalClearingId);		// xs:token
		CopyString(&pNewCICreditorFinancialInstitution->pName, pCICreditorFinancialInstitution->pName);		// xs:string
		CopyString(&pNewCICreditorFinancialInstitution->pJapanFinancialInstitutionCommonId, pCICreditorFinancialInstitution->pJapanFinancialInstitutionCommonId);		// xs:token
		pNewCICreditorFinancialInstitution->pLocationFinancialInstitutionAddress = CopyFinancialInstitutionAddress(pStructDocTop, pNewCICreditorFinancialInstitution, pCICreditorFinancialInstitution->pLocationFinancialInstitutionAddress);		// rac:FinancialInstitutionAddressType
		pNewCICreditorFinancialInstitution->pSubDivisionBranchFinancialInstitution = CopyBranchFinancialInstitution(pStructDocTop, pNewCICreditorFinancialInstitution, pCICreditorFinancialInstitution->pSubDivisionBranchFinancialInstitution);		// rac:BranchFinancialInstitutionType

		return (pNewCICreditorFinancialInstitution);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataCICreditorFinancialInstitution(

*********************************************************************/
BOOL IsDataCICreditorFinancialInstitution(
	CICreditorFinancialInstitutionType *pCICreditorFinancialInstitution)
{
	if(!pCICreditorFinancialInstitution)
		return FALSE;

	if(pCICreditorFinancialInstitution->pBICId && *pCICreditorFinancialInstitution->pBICId)
		return TRUE;
	if(pCICreditorFinancialInstitution->pClearingSystemName && *pCICreditorFinancialInstitution->pClearingSystemName)
		return TRUE;
	if(pCICreditorFinancialInstitution->pCHIPSUniversalId && *pCICreditorFinancialInstitution->pCHIPSUniversalId)
		return TRUE;
	if(pCICreditorFinancialInstitution->pNewZealandNCCId && *pCICreditorFinancialInstitution->pNewZealandNCCId)
		return TRUE;
	if(pCICreditorFinancialInstitution->pIrishNSCId && *pCICreditorFinancialInstitution->pIrishNSCId)
		return TRUE;
	if(pCICreditorFinancialInstitution->pUKSortCodeId && *pCICreditorFinancialInstitution->pUKSortCodeId)
		return TRUE;
	if(pCICreditorFinancialInstitution->pCHIPSParticipantId && *pCICreditorFinancialInstitution->pCHIPSParticipantId)
		return TRUE;
	if(pCICreditorFinancialInstitution->pSwissBCId && *pCICreditorFinancialInstitution->pSwissBCId)
		return TRUE;
	if(pCICreditorFinancialInstitution->pFedwireRoutingNumberId && *pCICreditorFinancialInstitution->pFedwireRoutingNumberId)
		return TRUE;
	if(pCICreditorFinancialInstitution->pPortugueseNCCId && *pCICreditorFinancialInstitution->pPortugueseNCCId)
		return TRUE;
	if(pCICreditorFinancialInstitution->pRussianCentralBankId && *pCICreditorFinancialInstitution->pRussianCentralBankId)
		return TRUE;
	if(pCICreditorFinancialInstitution->pItalianDomesticId && *pCICreditorFinancialInstitution->pItalianDomesticId)
		return TRUE;
	if(pCICreditorFinancialInstitution->pAustrianBankleitzahlId && *pCICreditorFinancialInstitution->pAustrianBankleitzahlId)
		return TRUE;
	if(pCICreditorFinancialInstitution->pCanadianPaymentsAssociationId && *pCICreditorFinancialInstitution->pCanadianPaymentsAssociationId)
		return TRUE;
	if(pCICreditorFinancialInstitution->pSICId && *pCICreditorFinancialInstitution->pSICId)
		return TRUE;
	if(pCICreditorFinancialInstitution->pGermanBankleitzahlId && *pCICreditorFinancialInstitution->pGermanBankleitzahlId)
		return TRUE;
	if(pCICreditorFinancialInstitution->pSpanishDomesticInterbankingId && *pCICreditorFinancialInstitution->pSpanishDomesticInterbankingId)
		return TRUE;
	if(pCICreditorFinancialInstitution->pSouthAfricanNCCId && *pCICreditorFinancialInstitution->pSouthAfricanNCCId)
		return TRUE;
	if(pCICreditorFinancialInstitution->pHongKongBankId && *pCICreditorFinancialInstitution->pHongKongBankId)
		return TRUE;
	if(pCICreditorFinancialInstitution->pAustralianBSBId && *pCICreditorFinancialInstitution->pAustralianBSBId)
		return TRUE;
	if(pCICreditorFinancialInstitution->pIndianFinancialSystemId && *pCICreditorFinancialInstitution->pIndianFinancialSystemId)
		return TRUE;
	if(pCICreditorFinancialInstitution->pHellenicBankId && *pCICreditorFinancialInstitution->pHellenicBankId)
		return TRUE;
	if(pCICreditorFinancialInstitution->pPolishNationalClearingId && *pCICreditorFinancialInstitution->pPolishNationalClearingId)
		return TRUE;
	if(pCICreditorFinancialInstitution->pName && *pCICreditorFinancialInstitution->pName)
		return TRUE;
	if(pCICreditorFinancialInstitution->pJapanFinancialInstitutionCommonId && *pCICreditorFinancialInstitution->pJapanFinancialInstitutionCommonId)
		return TRUE;
	if(IsDataFinancialInstitutionAddress(pCICreditorFinancialInstitution->pLocationFinancialInstitutionAddress))
		return TRUE;
	if(IsDataBranchFinancialInstitution(pCICreditorFinancialInstitution->pSubDivisionBranchFinancialInstitution))
		return TRUE;

	return FALSE;
}


/*********************************************************************

static CICreditorFinancialInstitutionType *ReadSectionCICreditorFinancialInstitution(

*********************************************************************/
static CICreditorFinancialInstitutionType *ReadSectionCICreditorFinancialInstitution(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
CICreditorFinancialInstitutionType *pCICreditorFinancialInstitution = CreateCICreditorFinancialInstitution(pStructDocTop, pStructParent);

	if(!pCICreditorFinancialInstitution)
		return 0;	// Fatal error

	pXmlTagData=GetNextXmlTag(pXmlTagData);

	if(!pXmlTagData)
		return 0;	// Fatal error

	while(strcmp(pXmlTagData->pTag, pEndTag)) { // While is not the end
		if(!strcmp(pXmlTagData->pTag, "BICId"))
			ReadString(&pCICreditorFinancialInstitution->pBICId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "ClearingSystemName"))
			ReadString(&pCICreditorFinancialInstitution->pClearingSystemName, ReadXmlDataString(pXmlTagData->pData));		// xs:string
		else if(!strcmp(pXmlTagData->pTag, "CHIPSUniversalId"))
			ReadString(&pCICreditorFinancialInstitution->pCHIPSUniversalId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "NewZealandNCCId"))
			ReadString(&pCICreditorFinancialInstitution->pNewZealandNCCId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "IrishNSCId"))
			ReadString(&pCICreditorFinancialInstitution->pIrishNSCId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "UKSortCodeId"))
			ReadString(&pCICreditorFinancialInstitution->pUKSortCodeId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "CHIPSParticipantId"))
			ReadString(&pCICreditorFinancialInstitution->pCHIPSParticipantId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "SwissBCId"))
			ReadString(&pCICreditorFinancialInstitution->pSwissBCId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "FedwireRoutingNumberId"))
			ReadString(&pCICreditorFinancialInstitution->pFedwireRoutingNumberId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "PortugueseNCCId"))
			ReadString(&pCICreditorFinancialInstitution->pPortugueseNCCId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "RussianCentralBankId"))
			ReadString(&pCICreditorFinancialInstitution->pRussianCentralBankId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "ItalianDomesticId"))
			ReadString(&pCICreditorFinancialInstitution->pItalianDomesticId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "AustrianBankleitzahlId"))
			ReadString(&pCICreditorFinancialInstitution->pAustrianBankleitzahlId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "CanadianPaymentsAssociationId"))
			ReadString(&pCICreditorFinancialInstitution->pCanadianPaymentsAssociationId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "SICId"))
			ReadString(&pCICreditorFinancialInstitution->pSICId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "GermanBankleitzahlId"))
			ReadString(&pCICreditorFinancialInstitution->pGermanBankleitzahlId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "SpanishDomesticInterbankingId"))
			ReadString(&pCICreditorFinancialInstitution->pSpanishDomesticInterbankingId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "SouthAfricanNCCId"))
			ReadString(&pCICreditorFinancialInstitution->pSouthAfricanNCCId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "HongKongBankId"))
			ReadString(&pCICreditorFinancialInstitution->pHongKongBankId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "AustralianBSBId"))
			ReadString(&pCICreditorFinancialInstitution->pAustralianBSBId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "IndianFinancialSystemId"))
			ReadString(&pCICreditorFinancialInstitution->pIndianFinancialSystemId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "HellenicBankId"))
			ReadString(&pCICreditorFinancialInstitution->pHellenicBankId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "PolishNationalClearingId"))
			ReadString(&pCICreditorFinancialInstitution->pPolishNationalClearingId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "Name"))
			ReadString(&pCICreditorFinancialInstitution->pName, ReadXmlDataString(pXmlTagData->pData));		// xs:string
		else if(!strcmp(pXmlTagData->pTag, "JapanFinancialInstitutionCommonId"))
			ReadString(&pCICreditorFinancialInstitution->pJapanFinancialInstitutionCommonId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "LocationFinancialInstitutionAddress"))
			pCICreditorFinancialInstitution->pLocationFinancialInstitutionAddress = ReadSectionFinancialInstitutionAddress(pStructDocTop, pCICreditorFinancialInstitution, pXmlTagData, "LocationFinancialInstitutionAddress");		// rac:FinancialInstitutionAddressType
		else if(!strcmp(pXmlTagData->pTag, "SubDivisionBranchFinancialInstitution"))
			pCICreditorFinancialInstitution->pSubDivisionBranchFinancialInstitution = ReadSectionBranchFinancialInstitution(pStructDocTop, pCICreditorFinancialInstitution, pXmlTagData, "SubDivisionBranchFinancialInstitution");		// rac:BranchFinancialInstitutionType

		pXmlTagData=GetNextXmlTag(pXmlTagData);

		if(!pXmlTagData)
			return 0;	// Fatal error
	}
	return pCICreditorFinancialInstitution;
}


/*********************************************************************

static BOOL WriteSectionCICreditorFinancialInstitution(

*********************************************************************/
static BOOL WriteSectionCICreditorFinancialInstitution(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	CICreditorFinancialInstitutionType *pCICreditorFinancialInstitution)
{
	if(!pCICreditorFinancialInstitution)
		return FALSE;	// Fatal error

	xmlWriteLine(pStream, iTab-1, pAttr, pLabel, 0, 0);
	if(pCICreditorFinancialInstitution->pBICId && *pCICreditorFinancialInstitution->pBICId)
		xmlWriteLine(pStream, iTab, 0, "BICId", pCICreditorFinancialInstitution->pBICId, "BICId");		// xs:token
	if(pCICreditorFinancialInstitution->pClearingSystemName && *pCICreditorFinancialInstitution->pClearingSystemName)
		xmlWriteLine(pStream, iTab, 0, "ClearingSystemName", pCICreditorFinancialInstitution->pClearingSystemName, "ClearingSystemName");		// xs:string
	if(pCICreditorFinancialInstitution->pCHIPSUniversalId && *pCICreditorFinancialInstitution->pCHIPSUniversalId)
		xmlWriteLine(pStream, iTab, 0, "CHIPSUniversalId", pCICreditorFinancialInstitution->pCHIPSUniversalId, "CHIPSUniversalId");		// xs:token
	if(pCICreditorFinancialInstitution->pNewZealandNCCId && *pCICreditorFinancialInstitution->pNewZealandNCCId)
		xmlWriteLine(pStream, iTab, 0, "NewZealandNCCId", pCICreditorFinancialInstitution->pNewZealandNCCId, "NewZealandNCCId");		// xs:token
	if(pCICreditorFinancialInstitution->pIrishNSCId && *pCICreditorFinancialInstitution->pIrishNSCId)
		xmlWriteLine(pStream, iTab, 0, "IrishNSCId", pCICreditorFinancialInstitution->pIrishNSCId, "IrishNSCId");		// xs:token
	if(pCICreditorFinancialInstitution->pUKSortCodeId && *pCICreditorFinancialInstitution->pUKSortCodeId)
		xmlWriteLine(pStream, iTab, 0, "UKSortCodeId", pCICreditorFinancialInstitution->pUKSortCodeId, "UKSortCodeId");		// xs:token
	if(pCICreditorFinancialInstitution->pCHIPSParticipantId && *pCICreditorFinancialInstitution->pCHIPSParticipantId)
		xmlWriteLine(pStream, iTab, 0, "CHIPSParticipantId", pCICreditorFinancialInstitution->pCHIPSParticipantId, "CHIPSParticipantId");		// xs:token
	if(pCICreditorFinancialInstitution->pSwissBCId && *pCICreditorFinancialInstitution->pSwissBCId)
		xmlWriteLine(pStream, iTab, 0, "SwissBCId", pCICreditorFinancialInstitution->pSwissBCId, "SwissBCId");		// xs:token
	if(pCICreditorFinancialInstitution->pFedwireRoutingNumberId && *pCICreditorFinancialInstitution->pFedwireRoutingNumberId)
		xmlWriteLine(pStream, iTab, 0, "FedwireRoutingNumberId", pCICreditorFinancialInstitution->pFedwireRoutingNumberId, "FedwireRoutingNumberId");		// xs:token
	if(pCICreditorFinancialInstitution->pPortugueseNCCId && *pCICreditorFinancialInstitution->pPortugueseNCCId)
		xmlWriteLine(pStream, iTab, 0, "PortugueseNCCId", pCICreditorFinancialInstitution->pPortugueseNCCId, "PortugueseNCCId");		// xs:token
	if(pCICreditorFinancialInstitution->pRussianCentralBankId && *pCICreditorFinancialInstitution->pRussianCentralBankId)
		xmlWriteLine(pStream, iTab, 0, "RussianCentralBankId", pCICreditorFinancialInstitution->pRussianCentralBankId, "RussianCentralBankId");		// xs:token
	if(pCICreditorFinancialInstitution->pItalianDomesticId && *pCICreditorFinancialInstitution->pItalianDomesticId)
		xmlWriteLine(pStream, iTab, 0, "ItalianDomesticId", pCICreditorFinancialInstitution->pItalianDomesticId, "ItalianDomesticId");		// xs:token
	if(pCICreditorFinancialInstitution->pAustrianBankleitzahlId && *pCICreditorFinancialInstitution->pAustrianBankleitzahlId)
		xmlWriteLine(pStream, iTab, 0, "AustrianBankleitzahlId", pCICreditorFinancialInstitution->pAustrianBankleitzahlId, "AustrianBankleitzahlId");		// xs:token
	if(pCICreditorFinancialInstitution->pCanadianPaymentsAssociationId && *pCICreditorFinancialInstitution->pCanadianPaymentsAssociationId)
		xmlWriteLine(pStream, iTab, 0, "CanadianPaymentsAssociationId", pCICreditorFinancialInstitution->pCanadianPaymentsAssociationId, "CanadianPaymentsAssociationId");		// xs:token
	if(pCICreditorFinancialInstitution->pSICId && *pCICreditorFinancialInstitution->pSICId)
		xmlWriteLine(pStream, iTab, 0, "SICId", pCICreditorFinancialInstitution->pSICId, "SICId");		// xs:token
	if(pCICreditorFinancialInstitution->pGermanBankleitzahlId && *pCICreditorFinancialInstitution->pGermanBankleitzahlId)
		xmlWriteLine(pStream, iTab, 0, "GermanBankleitzahlId", pCICreditorFinancialInstitution->pGermanBankleitzahlId, "GermanBankleitzahlId");		// xs:token
	if(pCICreditorFinancialInstitution->pSpanishDomesticInterbankingId && *pCICreditorFinancialInstitution->pSpanishDomesticInterbankingId)
		xmlWriteLine(pStream, iTab, 0, "SpanishDomesticInterbankingId", pCICreditorFinancialInstitution->pSpanishDomesticInterbankingId, "SpanishDomesticInterbankingId");		// xs:token
	if(pCICreditorFinancialInstitution->pSouthAfricanNCCId && *pCICreditorFinancialInstitution->pSouthAfricanNCCId)
		xmlWriteLine(pStream, iTab, 0, "SouthAfricanNCCId", pCICreditorFinancialInstitution->pSouthAfricanNCCId, "SouthAfricanNCCId");		// xs:token
	if(pCICreditorFinancialInstitution->pHongKongBankId && *pCICreditorFinancialInstitution->pHongKongBankId)
		xmlWriteLine(pStream, iTab, 0, "HongKongBankId", pCICreditorFinancialInstitution->pHongKongBankId, "HongKongBankId");		// xs:token
	if(pCICreditorFinancialInstitution->pAustralianBSBId && *pCICreditorFinancialInstitution->pAustralianBSBId)
		xmlWriteLine(pStream, iTab, 0, "AustralianBSBId", pCICreditorFinancialInstitution->pAustralianBSBId, "AustralianBSBId");		// xs:token
	if(pCICreditorFinancialInstitution->pIndianFinancialSystemId && *pCICreditorFinancialInstitution->pIndianFinancialSystemId)
		xmlWriteLine(pStream, iTab, 0, "IndianFinancialSystemId", pCICreditorFinancialInstitution->pIndianFinancialSystemId, "IndianFinancialSystemId");		// xs:token
	if(pCICreditorFinancialInstitution->pHellenicBankId && *pCICreditorFinancialInstitution->pHellenicBankId)
		xmlWriteLine(pStream, iTab, 0, "HellenicBankId", pCICreditorFinancialInstitution->pHellenicBankId, "HellenicBankId");		// xs:token
	if(pCICreditorFinancialInstitution->pPolishNationalClearingId && *pCICreditorFinancialInstitution->pPolishNationalClearingId)
		xmlWriteLine(pStream, iTab, 0, "PolishNationalClearingId", pCICreditorFinancialInstitution->pPolishNationalClearingId, "PolishNationalClearingId");		// xs:token
	if(pCICreditorFinancialInstitution->pName && *pCICreditorFinancialInstitution->pName)
		xmlWriteLine(pStream, iTab, 0, "Name", pCICreditorFinancialInstitution->pName, "Name");		// xs:string
	if(pCICreditorFinancialInstitution->pJapanFinancialInstitutionCommonId && *pCICreditorFinancialInstitution->pJapanFinancialInstitutionCommonId)
		xmlWriteLine(pStream, iTab, 0, "JapanFinancialInstitutionCommonId", pCICreditorFinancialInstitution->pJapanFinancialInstitutionCommonId, "JapanFinancialInstitutionCommonId");		// xs:token

	if(pCICreditorFinancialInstitution->pLocationFinancialInstitutionAddress && IsDataFinancialInstitutionAddress(pCICreditorFinancialInstitution->pLocationFinancialInstitutionAddress))		// Optional
		WriteSectionFinancialInstitutionAddress(pStream, iTab+1, "LocationFinancialInstitutionAddress", 0, pCICreditorFinancialInstitution->pLocationFinancialInstitutionAddress);		// rac:FinancialInstitutionAddressType

	if(pCICreditorFinancialInstitution->pSubDivisionBranchFinancialInstitution && IsDataBranchFinancialInstitution(pCICreditorFinancialInstitution->pSubDivisionBranchFinancialInstitution))		// Optional
		WriteSectionBranchFinancialInstitution(pStream, iTab+1, "SubDivisionBranchFinancialInstitution", 0, pCICreditorFinancialInstitution->pSubDivisionBranchFinancialInstitution);		// rac:BranchFinancialInstitutionType

	xmlWriteLine(pStream, iTab-1, 0, 0, 0, pLabel);

	return TRUE;
}


/*********************************************************************

CICreditorFinancialInstitutionType *UpdateCICreditorFinancialInstitution(

*********************************************************************/
CICreditorFinancialInstitutionType *UpdateCICreditorFinancialInstitution(
	CICreditorFinancialInstitutionType *pStructCICreditorFinancialInstitution, 
	char *pBICId, 
	char *pClearingSystemName, 
	char *pCHIPSUniversalId, 
	char *pNewZealandNCCId, 
	char *pIrishNSCId, 
	char *pUKSortCodeId, 
	char *pCHIPSParticipantId, 
	char *pSwissBCId, 
	char *pFedwireRoutingNumberId, 
	char *pPortugueseNCCId, 
	char *pRussianCentralBankId, 
	char *pItalianDomesticId, 
	char *pAustrianBankleitzahlId, 
	char *pCanadianPaymentsAssociationId, 
	char *pSICId, 
	char *pGermanBankleitzahlId, 
	char *pSpanishDomesticInterbankingId, 
	char *pSouthAfricanNCCId, 
	char *pHongKongBankId, 
	char *pAustralianBSBId, 
	char *pIndianFinancialSystemId, 
	char *pHellenicBankId, 
	char *pPolishNationalClearingId, 
	char *pName, 
	char *pJapanFinancialInstitutionCommonId)
{
	StringUpdate(&pStructCICreditorFinancialInstitution->pBICId, pBICId);
	StringUpdate(&pStructCICreditorFinancialInstitution->pClearingSystemName, pClearingSystemName);
	StringUpdate(&pStructCICreditorFinancialInstitution->pCHIPSUniversalId, pCHIPSUniversalId);
	StringUpdate(&pStructCICreditorFinancialInstitution->pNewZealandNCCId, pNewZealandNCCId);
	StringUpdate(&pStructCICreditorFinancialInstitution->pIrishNSCId, pIrishNSCId);
	StringUpdate(&pStructCICreditorFinancialInstitution->pUKSortCodeId, pUKSortCodeId);
	StringUpdate(&pStructCICreditorFinancialInstitution->pCHIPSParticipantId, pCHIPSParticipantId);
	StringUpdate(&pStructCICreditorFinancialInstitution->pSwissBCId, pSwissBCId);
	StringUpdate(&pStructCICreditorFinancialInstitution->pFedwireRoutingNumberId, pFedwireRoutingNumberId);
	StringUpdate(&pStructCICreditorFinancialInstitution->pPortugueseNCCId, pPortugueseNCCId);
	StringUpdate(&pStructCICreditorFinancialInstitution->pRussianCentralBankId, pRussianCentralBankId);
	StringUpdate(&pStructCICreditorFinancialInstitution->pItalianDomesticId, pItalianDomesticId);
	StringUpdate(&pStructCICreditorFinancialInstitution->pAustrianBankleitzahlId, pAustrianBankleitzahlId);
	StringUpdate(&pStructCICreditorFinancialInstitution->pCanadianPaymentsAssociationId, pCanadianPaymentsAssociationId);
	StringUpdate(&pStructCICreditorFinancialInstitution->pSICId, pSICId);
	StringUpdate(&pStructCICreditorFinancialInstitution->pGermanBankleitzahlId, pGermanBankleitzahlId);
	StringUpdate(&pStructCICreditorFinancialInstitution->pSpanishDomesticInterbankingId, pSpanishDomesticInterbankingId);
	StringUpdate(&pStructCICreditorFinancialInstitution->pSouthAfricanNCCId, pSouthAfricanNCCId);
	StringUpdate(&pStructCICreditorFinancialInstitution->pHongKongBankId, pHongKongBankId);
	StringUpdate(&pStructCICreditorFinancialInstitution->pAustralianBSBId, pAustralianBSBId);
	StringUpdate(&pStructCICreditorFinancialInstitution->pIndianFinancialSystemId, pIndianFinancialSystemId);
	StringUpdate(&pStructCICreditorFinancialInstitution->pHellenicBankId, pHellenicBankId);
	StringUpdate(&pStructCICreditorFinancialInstitution->pPolishNationalClearingId, pPolishNationalClearingId);
	StringUpdate(&pStructCICreditorFinancialInstitution->pName, pName);
	StringUpdate(&pStructCICreditorFinancialInstitution->pJapanFinancialInstitutionCommonId, pJapanFinancialInstitutionCommonId);

	return pStructCICreditorFinancialInstitution;
}


/*********************************************************************

char **GetLeadTextCICreditorFinancialInstitution(

*********************************************************************/
char **GetLeadTextCICreditorFinancialInstitution(
	char *pLang)
{
static char *szTexts[] = {
	"B I C Id",
	"Clearing System Name",
	"C H I P S Universal Id",
	"New Zealand N C C Id",
	"Irish N S C Id",
	"U K Sort Code Id",
	"C H I P S Participant Id",
	"Swiss B C Id",
	"Fedwire Routing Number Id",
	"Portuguese N C C Id",
	"Russian Central Bank Id",
	"Italian Domestic Id",
	"Austrian Bankleitzahl Id",
	"Canadian Payments Association Id",
	"S I C Id",
	"German Bankleitzahl Id",
	"Spanish Domestic Interbanking Id",
	"South African N C C Id",
	"Hong Kong Bank Id",
	"Australian B S B Id",
	"Indian Financial System Id",
	"Hellenic Bank Id",
	"Polish National Clearing Id",
	"Name",
	"Japan Financial Institution Common Id",
	"Location Financial Institution Address",
	"Sub Division Branch Financial Institution"};

	return szTexts;
}


/*********************************************************************

	TradeSettlementFinancialCard

*********************************************************************

TradeSettlementFinancialCardType *CreateTradeSettlementFinancialCard(

*********************************************************************/
TradeSettlementFinancialCardType *CreateTradeSettlementFinancialCard(
	void *pStructDocTop, 
	void *pStructParent)
{
TradeSettlementFinancialCardType *pTradeSettlementFinancialCard = calloc(1, sizeof(TradeSettlementFinancialCardType));

	if(!pTradeSettlementFinancialCard)
		return 0;	// Fatal error

	pTradeSettlementFinancialCard->DataType    = SCT_TRADESETTLEMENTFINANCIALCARD;
	pTradeSettlementFinancialCard->pStructDocTop = pStructDocTop;
	pTradeSettlementFinancialCard->pStructParent = pStructParent;

	pTradeSettlementFinancialCard->pId = NulString;
	pTradeSettlementFinancialCard->pTypeCode = NulString;
	pTradeSettlementFinancialCard->pCardholderName = NulString;
	pTradeSettlementFinancialCard->pListCreditLimitAmount = LListInit();
	pTradeSettlementFinancialCard->pListCreditAvailableAmount = LListInit();
	pTradeSettlementFinancialCard->pIssuingCompanyName = NulString;
	pTradeSettlementFinancialCard->pDescription = NulString;

	return pTradeSettlementFinancialCard;
}


/*********************************************************************

TradeSettlementFinancialCardType *DestroyTradeSettlementFinancialCard(

*********************************************************************/
TradeSettlementFinancialCardType *DestroyTradeSettlementFinancialCard(
	TradeSettlementFinancialCardType **ppTradeSettlementFinancialCard)
{
	if(!*ppTradeSettlementFinancialCard)
		return 0;	// Nothing to destroy

	FreeString(&(*ppTradeSettlementFinancialCard)->pId);		// xs:token
	FreeString(&(*ppTradeSettlementFinancialCard)->pTypeCode);		// xs:token
	FreeString(&(*ppTradeSettlementFinancialCard)->pCardholderName);		// xs:string
	{
		AmountCurrencyType *pCreditLimitAmount
			= LListGetFirstRecordData((*ppTradeSettlementFinancialCard)->pListCreditLimitAmount);
		while(pCreditLimitAmount) {
			DestroyAmountCurrency(&pCreditLimitAmount);		// rac:AmountCurrencyType
			pCreditLimitAmount = LListGetNextRecordData((*ppTradeSettlementFinancialCard)->pListCreditLimitAmount);
		}
		LListErase((*ppTradeSettlementFinancialCard)->pListCreditLimitAmount);
	}
	{
		AmountCurrencyType *pCreditAvailableAmount
			= LListGetFirstRecordData((*ppTradeSettlementFinancialCard)->pListCreditAvailableAmount);
		while(pCreditAvailableAmount) {
			DestroyAmountCurrency(&pCreditAvailableAmount);		// rac:AmountCurrencyType
			pCreditAvailableAmount = LListGetNextRecordData((*ppTradeSettlementFinancialCard)->pListCreditAvailableAmount);
		}
		LListErase((*ppTradeSettlementFinancialCard)->pListCreditAvailableAmount);
	}
	FreeString(&(*ppTradeSettlementFinancialCard)->pIssuingCompanyName);		// xs:string
	FreeString(&(*ppTradeSettlementFinancialCard)->pDescription);		// xs:string

	free(*ppTradeSettlementFinancialCard);
	*ppTradeSettlementFinancialCard = 0;

	return 0;
}


/*********************************************************************

TradeSettlementFinancialCardType *CopyTradeSettlementFinancialCard(

*********************************************************************/
TradeSettlementFinancialCardType *CopyTradeSettlementFinancialCard(
	void *pStructDocTop, 
	void *pStructParent, 
	TradeSettlementFinancialCardType *pTradeSettlementFinancialCard)
{
	if(pTradeSettlementFinancialCard) {
		TradeSettlementFinancialCardType *pNewTradeSettlementFinancialCard = CreateTradeSettlementFinancialCard(pStructDocTop, pStructParent);

		if(!pNewTradeSettlementFinancialCard)
			return 0;	// Fatal error

		pNewTradeSettlementFinancialCard->MicrochipIndicator = pTradeSettlementFinancialCard->MicrochipIndicator;		// xs:boolean
		CopyString(&pNewTradeSettlementFinancialCard->pId, pTradeSettlementFinancialCard->pId);		// xs:token
		CopyString(&pNewTradeSettlementFinancialCard->pTypeCode, pTradeSettlementFinancialCard->pTypeCode);		// xs:token
		CopyString(&pNewTradeSettlementFinancialCard->pCardholderName, pTradeSettlementFinancialCard->pCardholderName);		// xs:string
		pNewTradeSettlementFinancialCard->ExpiryDate = pTradeSettlementFinancialCard->ExpiryDate;		// xs:date
		pNewTradeSettlementFinancialCard->VerificationNumeric = pTradeSettlementFinancialCard->VerificationNumeric;		// xs:integer
		pNewTradeSettlementFinancialCard->ValidFromDateTime = pTradeSettlementFinancialCard->ValidFromDateTime;		// xs:dateTime
		{
			AmountCurrencyType *pCreditLimitAmount
				= LListGetFirstRecordData(pTradeSettlementFinancialCard->pListCreditLimitAmount);
			while(pCreditLimitAmount) {
				LListAddRecord(pNewTradeSettlementFinancialCard->pListCreditLimitAmount, CopyAmountCurrency(pStructDocTop, pNewTradeSettlementFinancialCard, pCreditLimitAmount));		// rac:AmountCurrencyType
				pCreditLimitAmount = LListGetNextRecordData(pTradeSettlementFinancialCard->pListCreditLimitAmount);
			}
		}
		{
			AmountCurrencyType *pCreditAvailableAmount
				= LListGetFirstRecordData(pTradeSettlementFinancialCard->pListCreditAvailableAmount);
			while(pCreditAvailableAmount) {
				LListAddRecord(pNewTradeSettlementFinancialCard->pListCreditAvailableAmount, CopyAmountCurrency(pStructDocTop, pNewTradeSettlementFinancialCard, pCreditAvailableAmount));		// rac:AmountCurrencyType
				pCreditAvailableAmount = LListGetNextRecordData(pTradeSettlementFinancialCard->pListCreditAvailableAmount);
			}
		}
		pNewTradeSettlementFinancialCard->InterestRatePercent = pTradeSettlementFinancialCard->InterestRatePercent;		// xs:decimal
		CopyString(&pNewTradeSettlementFinancialCard->pIssuingCompanyName, pTradeSettlementFinancialCard->pIssuingCompanyName);		// xs:string
		CopyString(&pNewTradeSettlementFinancialCard->pDescription, pTradeSettlementFinancialCard->pDescription);		// xs:string

		return (pNewTradeSettlementFinancialCard);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataTradeSettlementFinancialCard(

*********************************************************************/
BOOL IsDataTradeSettlementFinancialCard(
	TradeSettlementFinancialCardType *pTradeSettlementFinancialCard)
{
	if(!pTradeSettlementFinancialCard)
		return FALSE;

	if(pTradeSettlementFinancialCard->MicrochipIndicator)
		return TRUE;
	if(pTradeSettlementFinancialCard->pId && *pTradeSettlementFinancialCard->pId)
		return TRUE;
	if(pTradeSettlementFinancialCard->pTypeCode && *pTradeSettlementFinancialCard->pTypeCode)
		return TRUE;
	if(pTradeSettlementFinancialCard->pCardholderName && *pTradeSettlementFinancialCard->pCardholderName)
		return TRUE;
	if(pTradeSettlementFinancialCard->ExpiryDate)
		return TRUE;
	if(pTradeSettlementFinancialCard->VerificationNumeric)
		return TRUE;
	if(pTradeSettlementFinancialCard->ValidFromDateTime)
		return TRUE;
	{
		AmountCurrencyType *pCreditLimitAmount
			= LListGetFirstRecordData(pTradeSettlementFinancialCard->pListCreditLimitAmount);
		while(pCreditLimitAmount) {
			if(IsDataAmountCurrency(pCreditLimitAmount))
				return TRUE;
			pCreditLimitAmount = LListGetNextRecordData(pTradeSettlementFinancialCard->pListCreditLimitAmount);
		}
	}
	{
		AmountCurrencyType *pCreditAvailableAmount
			= LListGetFirstRecordData(pTradeSettlementFinancialCard->pListCreditAvailableAmount);
		while(pCreditAvailableAmount) {
			if(IsDataAmountCurrency(pCreditAvailableAmount))
				return TRUE;
			pCreditAvailableAmount = LListGetNextRecordData(pTradeSettlementFinancialCard->pListCreditAvailableAmount);
		}
	}
	if(!DecimalCmp(pTradeSettlementFinancialCard->InterestRatePercent, 0))
		return TRUE;
	if(pTradeSettlementFinancialCard->pIssuingCompanyName && *pTradeSettlementFinancialCard->pIssuingCompanyName)
		return TRUE;
	if(pTradeSettlementFinancialCard->pDescription && *pTradeSettlementFinancialCard->pDescription)
		return TRUE;

	return FALSE;
}


/*********************************************************************

static TradeSettlementFinancialCardType *ReadSectionTradeSettlementFinancialCard(

*********************************************************************/
static TradeSettlementFinancialCardType *ReadSectionTradeSettlementFinancialCard(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
TradeSettlementFinancialCardType *pTradeSettlementFinancialCard = CreateTradeSettlementFinancialCard(pStructDocTop, pStructParent);

	if(!pTradeSettlementFinancialCard)
		return 0;	// Fatal error

	pXmlTagData=GetNextXmlTag(pXmlTagData);

	if(!pXmlTagData)
		return 0;	// Fatal error

	while(strcmp(pXmlTagData->pTag, pEndTag)) { // While is not the end
		if(!strcmp(pXmlTagData->pTag, "MicrochipIndicator"))
			pTradeSettlementFinancialCard->MicrochipIndicator = StringToBool(pXmlTagData->pData);		// xs:boolean
		else if(!strcmp(pXmlTagData->pTag, "Id"))
			ReadString(&pTradeSettlementFinancialCard->pId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "TypeCode"))
			ReadString(&pTradeSettlementFinancialCard->pTypeCode, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "CardholderName"))
			ReadString(&pTradeSettlementFinancialCard->pCardholderName, ReadXmlDataString(pXmlTagData->pData));		// xs:string
		else if(!strcmp(pXmlTagData->pTag, "ExpiryDate"))
			pTradeSettlementFinancialCard->ExpiryDate = StringToDate(pXmlTagData->pData);		// xs:date
		else if(!strcmp(pXmlTagData->pTag, "VerificationNumeric"))
			pTradeSettlementFinancialCard->VerificationNumeric = StringToNumeric(pXmlTagData->pData);		// xs:integer
		else if(!strcmp(pXmlTagData->pTag, "ValidFromDateTime"))
			pTradeSettlementFinancialCard->ValidFromDateTime = StringToDateTime(pXmlTagData->pData);		// xs:dateTime
		else if(!strcmp(pXmlTagData->pTag, "CreditLimitAmount"))
			LListAddRecord(pTradeSettlementFinancialCard->pListCreditLimitAmount, ReadSectionAmountCurrency(pStructDocTop, pTradeSettlementFinancialCard, pXmlTagData, "CreditLimitAmount"));		// rac:AmountCurrencyType
		else if(!strcmp(pXmlTagData->pTag, "CreditAvailableAmount"))
			LListAddRecord(pTradeSettlementFinancialCard->pListCreditAvailableAmount, ReadSectionAmountCurrency(pStructDocTop, pTradeSettlementFinancialCard, pXmlTagData, "CreditAvailableAmount"));		// rac:AmountCurrencyType
		else if(!strcmp(pXmlTagData->pTag, "InterestRatePercent"))
			pTradeSettlementFinancialCard->InterestRatePercent = StringToDecimal(pXmlTagData->pData);		// xs:decimal
		else if(!strcmp(pXmlTagData->pTag, "IssuingCompanyName"))
			ReadString(&pTradeSettlementFinancialCard->pIssuingCompanyName, ReadXmlDataString(pXmlTagData->pData));		// xs:string
		else if(!strcmp(pXmlTagData->pTag, "Description"))
			ReadString(&pTradeSettlementFinancialCard->pDescription, ReadXmlDataString(pXmlTagData->pData));		// xs:string

		pXmlTagData=GetNextXmlTag(pXmlTagData);

		if(!pXmlTagData)
			return 0;	// Fatal error
	}
	return pTradeSettlementFinancialCard;
}


/*********************************************************************

static BOOL WriteSectionTradeSettlementFinancialCard(

*********************************************************************/
static BOOL WriteSectionTradeSettlementFinancialCard(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	TradeSettlementFinancialCardType *pTradeSettlementFinancialCard)
{
	if(!pTradeSettlementFinancialCard)
		return FALSE;	// Fatal error

	xmlWriteLine(pStream, iTab-1, pAttr, pLabel, 0, 0);
	if(pTradeSettlementFinancialCard->MicrochipIndicator)
		xmlWriteLine(pStream, iTab, 0, "MicrochipIndicator", BoolToStr(pTradeSettlementFinancialCard->MicrochipIndicator, szString),"MicrochipIndicator");		// xs:boolean
	if(pTradeSettlementFinancialCard->pId && *pTradeSettlementFinancialCard->pId)
		xmlWriteLine(pStream, iTab, 0, "Id", pTradeSettlementFinancialCard->pId, "Id");		// xs:token
	if(pTradeSettlementFinancialCard->pTypeCode && *pTradeSettlementFinancialCard->pTypeCode)
		xmlWriteLine(pStream, iTab, 0, "TypeCode", pTradeSettlementFinancialCard->pTypeCode, "TypeCode");		// xs:token
	if(pTradeSettlementFinancialCard->pCardholderName && *pTradeSettlementFinancialCard->pCardholderName)
		xmlWriteLine(pStream, iTab, 0, "CardholderName", pTradeSettlementFinancialCard->pCardholderName, "CardholderName");		// xs:string
	if(pTradeSettlementFinancialCard->ExpiryDate)
		xmlWriteLine(pStream, iTab, 0, "ExpiryDate", DateToStr(pTradeSettlementFinancialCard->ExpiryDate, szString),"ExpiryDate");		// xs:date
	if(pTradeSettlementFinancialCard->VerificationNumeric)
		xmlWriteLine(pStream, iTab, 0, "VerificationNumeric", NumericToStr(pTradeSettlementFinancialCard->VerificationNumeric, szString),"VerificationNumeric");		// xs:integer
	if(pTradeSettlementFinancialCard->ValidFromDateTime)
		xmlWriteLine(pStream, iTab, 0, "ValidFromDateTime", DateTimeToStr(pTradeSettlementFinancialCard->ValidFromDateTime, szString),"ValidFromDateTime");		// xs:dateTime

	if(pTradeSettlementFinancialCard->pListCreditLimitAmount) {
		AmountCurrencyType *pCreditLimitAmount
			= LListGetFirstRecordData(pTradeSettlementFinancialCard->pListCreditLimitAmount);
		while(pCreditLimitAmount) {
			if(IsDataAmountCurrency(pCreditLimitAmount))
				WriteSectionAmountCurrency(pStream, iTab+1, "CreditLimitAmount", 0, pCreditLimitAmount);		// rac:AmountCurrencyType
			pCreditLimitAmount = LListGetNextRecordData(pTradeSettlementFinancialCard->pListCreditLimitAmount);
		}
	}

	if(pTradeSettlementFinancialCard->pListCreditAvailableAmount) {
		AmountCurrencyType *pCreditAvailableAmount
			= LListGetFirstRecordData(pTradeSettlementFinancialCard->pListCreditAvailableAmount);
		while(pCreditAvailableAmount) {
			if(IsDataAmountCurrency(pCreditAvailableAmount))
				WriteSectionAmountCurrency(pStream, iTab+1, "CreditAvailableAmount", 0, pCreditAvailableAmount);		// rac:AmountCurrencyType
			pCreditAvailableAmount = LListGetNextRecordData(pTradeSettlementFinancialCard->pListCreditAvailableAmount);
		}
	}
	if(!DecimalCmp(pTradeSettlementFinancialCard->InterestRatePercent, 0))
		xmlWriteLine(pStream, iTab, 0, "InterestRatePercent", DecimalToStr(pTradeSettlementFinancialCard->InterestRatePercent, szString),"InterestRatePercent");		// xs:decimal
	if(pTradeSettlementFinancialCard->pIssuingCompanyName && *pTradeSettlementFinancialCard->pIssuingCompanyName)
		xmlWriteLine(pStream, iTab, 0, "IssuingCompanyName", pTradeSettlementFinancialCard->pIssuingCompanyName, "IssuingCompanyName");		// xs:string
	if(pTradeSettlementFinancialCard->pDescription && *pTradeSettlementFinancialCard->pDescription)
		xmlWriteLine(pStream, iTab, 0, "Description", pTradeSettlementFinancialCard->pDescription, "Description");		// xs:string

	xmlWriteLine(pStream, iTab-1, 0, 0, 0, pLabel);

	return TRUE;
}


/*********************************************************************

TradeSettlementFinancialCardType *UpdateTradeSettlementFinancialCard(

*********************************************************************/
TradeSettlementFinancialCardType *UpdateTradeSettlementFinancialCard(
	TradeSettlementFinancialCardType *pStructTradeSettlementFinancialCard, 
	BOOL MicrochipIndicator, 
	char *pId, 
	char *pTypeCode, 
	char *pCardholderName, 
	DATEINT ExpiryDate, 
	NUMERIC VerificationNumeric, 
	DATETIMEINT ValidFromDateTime, 
	QUANT InterestRatePercent, 
	char *pIssuingCompanyName, 
	char *pDescription)
{
	pStructTradeSettlementFinancialCard->MicrochipIndicator = MicrochipIndicator;
	StringUpdate(&pStructTradeSettlementFinancialCard->pId, pId);
	StringUpdate(&pStructTradeSettlementFinancialCard->pTypeCode, pTypeCode);
	StringUpdate(&pStructTradeSettlementFinancialCard->pCardholderName, pCardholderName);
	pStructTradeSettlementFinancialCard->ExpiryDate = ExpiryDate;
	pStructTradeSettlementFinancialCard->VerificationNumeric = VerificationNumeric;
	pStructTradeSettlementFinancialCard->ValidFromDateTime = ValidFromDateTime;
	pStructTradeSettlementFinancialCard->InterestRatePercent = InterestRatePercent;
	StringUpdate(&pStructTradeSettlementFinancialCard->pIssuingCompanyName, pIssuingCompanyName);
	StringUpdate(&pStructTradeSettlementFinancialCard->pDescription, pDescription);

	return pStructTradeSettlementFinancialCard;
}


/*********************************************************************

char **GetLeadTextTradeSettlementFinancialCard(

*********************************************************************/
char **GetLeadTextTradeSettlementFinancialCard(
	char *pLang)
{
static char *szTexts[] = {
	"Microchip Indicator",
	"Id",
	"Type Code",
	"Cardholder Name",
	"Expiry Date",
	"Verification Numeric",
	"Valid From Date Time",
	"Credit Limit Amount",
	"Credit Available Amount",
	"Interest Rate Percent",
	"Issuing Company Name",
	"Description"};

	return szTexts;
}


/*********************************************************************

	BranchFinancialInstitution

*********************************************************************

BranchFinancialInstitutionType *CreateBranchFinancialInstitution(

*********************************************************************/
BranchFinancialInstitutionType *CreateBranchFinancialInstitution(
	void *pStructDocTop, 
	void *pStructParent)
{
BranchFinancialInstitutionType *pBranchFinancialInstitution = calloc(1, sizeof(BranchFinancialInstitutionType));

	if(!pBranchFinancialInstitution)
		return 0;	// Fatal error

	pBranchFinancialInstitution->DataType    = SCT_BRANCHFINANCIALINSTITUTION;
	pBranchFinancialInstitution->pStructDocTop = pStructDocTop;
	pBranchFinancialInstitution->pStructParent = pStructParent;

	pBranchFinancialInstitution->pId = NulString;
	pBranchFinancialInstitution->pName = NulString;

	return pBranchFinancialInstitution;
}


/*********************************************************************

BranchFinancialInstitutionType *DestroyBranchFinancialInstitution(

*********************************************************************/
BranchFinancialInstitutionType *DestroyBranchFinancialInstitution(
	BranchFinancialInstitutionType **ppBranchFinancialInstitution)
{
	if(!*ppBranchFinancialInstitution)
		return 0;	// Nothing to destroy

	FreeString(&(*ppBranchFinancialInstitution)->pId);		// xs:token
	FreeString(&(*ppBranchFinancialInstitution)->pName);		// xs:string
	DestroyFinancialInstitutionAddress(&(*ppBranchFinancialInstitution)->pLocationFinancialInstitutionAddress);		// rac:FinancialInstitutionAddressType

	free(*ppBranchFinancialInstitution);
	*ppBranchFinancialInstitution = 0;

	return 0;
}


/*********************************************************************

BranchFinancialInstitutionType *CopyBranchFinancialInstitution(

*********************************************************************/
BranchFinancialInstitutionType *CopyBranchFinancialInstitution(
	void *pStructDocTop, 
	void *pStructParent, 
	BranchFinancialInstitutionType *pBranchFinancialInstitution)
{
	if(pBranchFinancialInstitution) {
		BranchFinancialInstitutionType *pNewBranchFinancialInstitution = CreateBranchFinancialInstitution(pStructDocTop, pStructParent);

		if(!pNewBranchFinancialInstitution)
			return 0;	// Fatal error

		CopyString(&pNewBranchFinancialInstitution->pId, pBranchFinancialInstitution->pId);		// xs:token
		CopyString(&pNewBranchFinancialInstitution->pName, pBranchFinancialInstitution->pName);		// xs:string
		pNewBranchFinancialInstitution->pLocationFinancialInstitutionAddress = CopyFinancialInstitutionAddress(pStructDocTop, pNewBranchFinancialInstitution, pBranchFinancialInstitution->pLocationFinancialInstitutionAddress);		// rac:FinancialInstitutionAddressType

		return (pNewBranchFinancialInstitution);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataBranchFinancialInstitution(

*********************************************************************/
BOOL IsDataBranchFinancialInstitution(
	BranchFinancialInstitutionType *pBranchFinancialInstitution)
{
	if(!pBranchFinancialInstitution)
		return FALSE;

	if(pBranchFinancialInstitution->pId && *pBranchFinancialInstitution->pId)
		return TRUE;
	if(pBranchFinancialInstitution->pName && *pBranchFinancialInstitution->pName)
		return TRUE;
	if(IsDataFinancialInstitutionAddress(pBranchFinancialInstitution->pLocationFinancialInstitutionAddress))
		return TRUE;

	return FALSE;
}


/*********************************************************************

static BranchFinancialInstitutionType *ReadSectionBranchFinancialInstitution(

*********************************************************************/
static BranchFinancialInstitutionType *ReadSectionBranchFinancialInstitution(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
BranchFinancialInstitutionType *pBranchFinancialInstitution = CreateBranchFinancialInstitution(pStructDocTop, pStructParent);

	if(!pBranchFinancialInstitution)
		return 0;	// Fatal error

	pXmlTagData=GetNextXmlTag(pXmlTagData);

	if(!pXmlTagData)
		return 0;	// Fatal error

	while(strcmp(pXmlTagData->pTag, pEndTag)) { // While is not the end
		if(!strcmp(pXmlTagData->pTag, "Id"))
			ReadString(&pBranchFinancialInstitution->pId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "Name"))
			ReadString(&pBranchFinancialInstitution->pName, ReadXmlDataString(pXmlTagData->pData));		// xs:string
		else if(!strcmp(pXmlTagData->pTag, "LocationFinancialInstitutionAddress"))
			pBranchFinancialInstitution->pLocationFinancialInstitutionAddress = ReadSectionFinancialInstitutionAddress(pStructDocTop, pBranchFinancialInstitution, pXmlTagData, "LocationFinancialInstitutionAddress");		// rac:FinancialInstitutionAddressType

		pXmlTagData=GetNextXmlTag(pXmlTagData);

		if(!pXmlTagData)
			return 0;	// Fatal error
	}
	return pBranchFinancialInstitution;
}


/*********************************************************************

static BOOL WriteSectionBranchFinancialInstitution(

*********************************************************************/
static BOOL WriteSectionBranchFinancialInstitution(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	BranchFinancialInstitutionType *pBranchFinancialInstitution)
{
	if(!pBranchFinancialInstitution)
		return FALSE;	// Fatal error

	xmlWriteLine(pStream, iTab-1, pAttr, pLabel, 0, 0);
	if(pBranchFinancialInstitution->pId && *pBranchFinancialInstitution->pId)
		xmlWriteLine(pStream, iTab, 0, "Id", pBranchFinancialInstitution->pId, "Id");		// xs:token
	if(pBranchFinancialInstitution->pName && *pBranchFinancialInstitution->pName)
		xmlWriteLine(pStream, iTab, 0, "Name", pBranchFinancialInstitution->pName, "Name");		// xs:string

	if(pBranchFinancialInstitution->pLocationFinancialInstitutionAddress && IsDataFinancialInstitutionAddress(pBranchFinancialInstitution->pLocationFinancialInstitutionAddress))		// Optional
		WriteSectionFinancialInstitutionAddress(pStream, iTab+1, "LocationFinancialInstitutionAddress", 0, pBranchFinancialInstitution->pLocationFinancialInstitutionAddress);		// rac:FinancialInstitutionAddressType

	xmlWriteLine(pStream, iTab-1, 0, 0, 0, pLabel);

	return TRUE;
}


/*********************************************************************

BranchFinancialInstitutionType *UpdateBranchFinancialInstitution(

*********************************************************************/
BranchFinancialInstitutionType *UpdateBranchFinancialInstitution(
	BranchFinancialInstitutionType *pStructBranchFinancialInstitution, 
	char *pId, 
	char *pName)
{
	StringUpdate(&pStructBranchFinancialInstitution->pId, pId);
	StringUpdate(&pStructBranchFinancialInstitution->pName, pName);

	return pStructBranchFinancialInstitution;
}


/*********************************************************************

char **GetLeadTextBranchFinancialInstitution(

*********************************************************************/
char **GetLeadTextBranchFinancialInstitution(
	char *pLang)
{
static char *szTexts[] = {
	"Id",
	"Name",
	"Location Financial Institution Address"};

	return szTexts;
}


/*********************************************************************

	FinancialInstitutionAddress

*********************************************************************

FinancialInstitutionAddressType *CreateFinancialInstitutionAddress(

*********************************************************************/
FinancialInstitutionAddressType *CreateFinancialInstitutionAddress(
	void *pStructDocTop, 
	void *pStructParent)
{
FinancialInstitutionAddressType *pFinancialInstitutionAddress = calloc(1, sizeof(FinancialInstitutionAddressType));

	if(!pFinancialInstitutionAddress)
		return 0;	// Fatal error

	pFinancialInstitutionAddress->DataType    = SCT_FINANCIALINSTITUTIONADDRESS;
	pFinancialInstitutionAddress->pStructDocTop = pStructDocTop;
	pFinancialInstitutionAddress->pStructParent = pStructParent;

	pFinancialInstitutionAddress->pPostcodeCode = NulString;
	pFinancialInstitutionAddress->pBuildingNumber = NulString;
	pFinancialInstitutionAddress->pLineOne = NulString;
	pFinancialInstitutionAddress->pLineTwo = NulString;
	pFinancialInstitutionAddress->pLineThree = NulString;
	pFinancialInstitutionAddress->pLineFour = NulString;
	pFinancialInstitutionAddress->pLineFive = NulString;
	pFinancialInstitutionAddress->pStreetName = NulString;
	pFinancialInstitutionAddress->pCityName = NulString;
	pFinancialInstitutionAddress->pCountrySubDivisionId = NulString;
	pFinancialInstitutionAddress->pCountryId = NulString;
	pFinancialInstitutionAddress->pTypeCode = NulString;
	pFinancialInstitutionAddress->pDepartmentName = NulString;
	pFinancialInstitutionAddress->pPostOfficeBox = NulString;
	pFinancialInstitutionAddress->pCityId = NulString;
	pFinancialInstitutionAddress->pCountrySubDivisionName = NulString;
	pFinancialInstitutionAddress->pCountryName = NulString;

	return pFinancialInstitutionAddress;
}


/*********************************************************************

FinancialInstitutionAddressType *DestroyFinancialInstitutionAddress(

*********************************************************************/
FinancialInstitutionAddressType *DestroyFinancialInstitutionAddress(
	FinancialInstitutionAddressType **ppFinancialInstitutionAddress)
{
	if(!*ppFinancialInstitutionAddress)
		return 0;	// Nothing to destroy

	FreeString(&(*ppFinancialInstitutionAddress)->pPostcodeCode);		// xs:token
	FreeString(&(*ppFinancialInstitutionAddress)->pBuildingNumber);		// xs:string
	FreeString(&(*ppFinancialInstitutionAddress)->pLineOne);		// xs:string
	FreeString(&(*ppFinancialInstitutionAddress)->pLineTwo);		// xs:string
	FreeString(&(*ppFinancialInstitutionAddress)->pLineThree);		// xs:string
	FreeString(&(*ppFinancialInstitutionAddress)->pLineFour);		// xs:string
	FreeString(&(*ppFinancialInstitutionAddress)->pLineFive);		// xs:string
	FreeString(&(*ppFinancialInstitutionAddress)->pStreetName);		// xs:string
	FreeString(&(*ppFinancialInstitutionAddress)->pCityName);		// xs:string
	FreeString(&(*ppFinancialInstitutionAddress)->pCountrySubDivisionId);		// xs:token
	FreeString(&(*ppFinancialInstitutionAddress)->pCountryId);		// rac:Country
	FreeString(&(*ppFinancialInstitutionAddress)->pTypeCode);		// xs:token
	FreeString(&(*ppFinancialInstitutionAddress)->pDepartmentName);		// xs:string
	FreeString(&(*ppFinancialInstitutionAddress)->pPostOfficeBox);		// xs:string
	FreeString(&(*ppFinancialInstitutionAddress)->pCityId);		// xs:token
	FreeString(&(*ppFinancialInstitutionAddress)->pCountrySubDivisionName);		// xs:string
	FreeString(&(*ppFinancialInstitutionAddress)->pCountryName);		// xs:string

	free(*ppFinancialInstitutionAddress);
	*ppFinancialInstitutionAddress = 0;

	return 0;
}


/*********************************************************************

FinancialInstitutionAddressType *CopyFinancialInstitutionAddress(

*********************************************************************/
FinancialInstitutionAddressType *CopyFinancialInstitutionAddress(
	void *pStructDocTop, 
	void *pStructParent, 
	FinancialInstitutionAddressType *pFinancialInstitutionAddress)
{
	if(pFinancialInstitutionAddress) {
		FinancialInstitutionAddressType *pNewFinancialInstitutionAddress = CreateFinancialInstitutionAddress(pStructDocTop, pStructParent);

		if(!pNewFinancialInstitutionAddress)
			return 0;	// Fatal error

		CopyString(&pNewFinancialInstitutionAddress->pPostcodeCode, pFinancialInstitutionAddress->pPostcodeCode);		// xs:token
		CopyString(&pNewFinancialInstitutionAddress->pBuildingNumber, pFinancialInstitutionAddress->pBuildingNumber);		// xs:string
		CopyString(&pNewFinancialInstitutionAddress->pLineOne, pFinancialInstitutionAddress->pLineOne);		// xs:string
		CopyString(&pNewFinancialInstitutionAddress->pLineTwo, pFinancialInstitutionAddress->pLineTwo);		// xs:string
		CopyString(&pNewFinancialInstitutionAddress->pLineThree, pFinancialInstitutionAddress->pLineThree);		// xs:string
		CopyString(&pNewFinancialInstitutionAddress->pLineFour, pFinancialInstitutionAddress->pLineFour);		// xs:string
		CopyString(&pNewFinancialInstitutionAddress->pLineFive, pFinancialInstitutionAddress->pLineFive);		// xs:string
		CopyString(&pNewFinancialInstitutionAddress->pStreetName, pFinancialInstitutionAddress->pStreetName);		// xs:string
		CopyString(&pNewFinancialInstitutionAddress->pCityName, pFinancialInstitutionAddress->pCityName);		// xs:string
		CopyString(&pNewFinancialInstitutionAddress->pCountrySubDivisionId, pFinancialInstitutionAddress->pCountrySubDivisionId);		// xs:token
		CopyString(&pNewFinancialInstitutionAddress->pCountryId, pFinancialInstitutionAddress->pCountryId);		// rac:Country
		CopyString(&pNewFinancialInstitutionAddress->pTypeCode, pFinancialInstitutionAddress->pTypeCode);		// xs:token
		CopyString(&pNewFinancialInstitutionAddress->pDepartmentName, pFinancialInstitutionAddress->pDepartmentName);		// xs:string
		CopyString(&pNewFinancialInstitutionAddress->pPostOfficeBox, pFinancialInstitutionAddress->pPostOfficeBox);		// xs:string
		CopyString(&pNewFinancialInstitutionAddress->pCityId, pFinancialInstitutionAddress->pCityId);		// xs:token
		CopyString(&pNewFinancialInstitutionAddress->pCountrySubDivisionName, pFinancialInstitutionAddress->pCountrySubDivisionName);		// xs:string
		CopyString(&pNewFinancialInstitutionAddress->pCountryName, pFinancialInstitutionAddress->pCountryName);		// xs:string

		return (pNewFinancialInstitutionAddress);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataFinancialInstitutionAddress(

*********************************************************************/
BOOL IsDataFinancialInstitutionAddress(
	FinancialInstitutionAddressType *pFinancialInstitutionAddress)
{
	if(!pFinancialInstitutionAddress)
		return FALSE;

	if(pFinancialInstitutionAddress->pPostcodeCode && *pFinancialInstitutionAddress->pPostcodeCode)
		return TRUE;
	if(pFinancialInstitutionAddress->pBuildingNumber && *pFinancialInstitutionAddress->pBuildingNumber)
		return TRUE;
	if(pFinancialInstitutionAddress->pLineOne && *pFinancialInstitutionAddress->pLineOne)
		return TRUE;
	if(pFinancialInstitutionAddress->pLineTwo && *pFinancialInstitutionAddress->pLineTwo)
		return TRUE;
	if(pFinancialInstitutionAddress->pLineThree && *pFinancialInstitutionAddress->pLineThree)
		return TRUE;
	if(pFinancialInstitutionAddress->pLineFour && *pFinancialInstitutionAddress->pLineFour)
		return TRUE;
	if(pFinancialInstitutionAddress->pLineFive && *pFinancialInstitutionAddress->pLineFive)
		return TRUE;
	if(pFinancialInstitutionAddress->pStreetName && *pFinancialInstitutionAddress->pStreetName)
		return TRUE;
	if(pFinancialInstitutionAddress->pCityName && *pFinancialInstitutionAddress->pCityName)
		return TRUE;
	if(pFinancialInstitutionAddress->pCountrySubDivisionId && *pFinancialInstitutionAddress->pCountrySubDivisionId)
		return TRUE;
	if(pFinancialInstitutionAddress->pCountryId && *pFinancialInstitutionAddress->pCountryId)
		return TRUE;
	if(pFinancialInstitutionAddress->pTypeCode && *pFinancialInstitutionAddress->pTypeCode)
		return TRUE;
	if(pFinancialInstitutionAddress->pDepartmentName && *pFinancialInstitutionAddress->pDepartmentName)
		return TRUE;
	if(pFinancialInstitutionAddress->pPostOfficeBox && *pFinancialInstitutionAddress->pPostOfficeBox)
		return TRUE;
	if(pFinancialInstitutionAddress->pCityId && *pFinancialInstitutionAddress->pCityId)
		return TRUE;
	if(pFinancialInstitutionAddress->pCountrySubDivisionName && *pFinancialInstitutionAddress->pCountrySubDivisionName)
		return TRUE;
	if(pFinancialInstitutionAddress->pCountryName && *pFinancialInstitutionAddress->pCountryName)
		return TRUE;

	return FALSE;
}


/*********************************************************************

static FinancialInstitutionAddressType *ReadSectionFinancialInstitutionAddress(

*********************************************************************/
static FinancialInstitutionAddressType *ReadSectionFinancialInstitutionAddress(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
FinancialInstitutionAddressType *pFinancialInstitutionAddress = CreateFinancialInstitutionAddress(pStructDocTop, pStructParent);

	if(!pFinancialInstitutionAddress)
		return 0;	// Fatal error

	pXmlTagData=GetNextXmlTag(pXmlTagData);

	if(!pXmlTagData)
		return 0;	// Fatal error

	while(strcmp(pXmlTagData->pTag, pEndTag)) { // While is not the end
		if(!strcmp(pXmlTagData->pTag, "PostcodeCode"))
			ReadString(&pFinancialInstitutionAddress->pPostcodeCode, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "BuildingNumber"))
			ReadString(&pFinancialInstitutionAddress->pBuildingNumber, ReadXmlDataString(pXmlTagData->pData));		// xs:string
		else if(!strcmp(pXmlTagData->pTag, "LineOne"))
			ReadString(&pFinancialInstitutionAddress->pLineOne, ReadXmlDataString(pXmlTagData->pData));		// xs:string
		else if(!strcmp(pXmlTagData->pTag, "LineTwo"))
			ReadString(&pFinancialInstitutionAddress->pLineTwo, ReadXmlDataString(pXmlTagData->pData));		// xs:string
		else if(!strcmp(pXmlTagData->pTag, "LineThree"))
			ReadString(&pFinancialInstitutionAddress->pLineThree, ReadXmlDataString(pXmlTagData->pData));		// xs:string
		else if(!strcmp(pXmlTagData->pTag, "LineFour"))
			ReadString(&pFinancialInstitutionAddress->pLineFour, ReadXmlDataString(pXmlTagData->pData));		// xs:string
		else if(!strcmp(pXmlTagData->pTag, "LineFive"))
			ReadString(&pFinancialInstitutionAddress->pLineFive, ReadXmlDataString(pXmlTagData->pData));		// xs:string
		else if(!strcmp(pXmlTagData->pTag, "StreetName"))
			ReadString(&pFinancialInstitutionAddress->pStreetName, ReadXmlDataString(pXmlTagData->pData));		// xs:string
		else if(!strcmp(pXmlTagData->pTag, "CityName"))
			ReadString(&pFinancialInstitutionAddress->pCityName, ReadXmlDataString(pXmlTagData->pData));		// xs:string
		else if(!strcmp(pXmlTagData->pTag, "CountrySubDivisionId"))
			ReadString(&pFinancialInstitutionAddress->pCountrySubDivisionId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "CountryId"))
			ReadString(&pFinancialInstitutionAddress->pCountryId, ReadXmlDataString(pXmlTagData->pData));		// rac:Country
		else if(!strcmp(pXmlTagData->pTag, "TypeCode"))
			ReadString(&pFinancialInstitutionAddress->pTypeCode, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "DepartmentName"))
			ReadString(&pFinancialInstitutionAddress->pDepartmentName, ReadXmlDataString(pXmlTagData->pData));		// xs:string
		else if(!strcmp(pXmlTagData->pTag, "PostOfficeBox"))
			ReadString(&pFinancialInstitutionAddress->pPostOfficeBox, ReadXmlDataString(pXmlTagData->pData));		// xs:string
		else if(!strcmp(pXmlTagData->pTag, "CityId"))
			ReadString(&pFinancialInstitutionAddress->pCityId, ReadXmlDataString(pXmlTagData->pData));		// xs:token
		else if(!strcmp(pXmlTagData->pTag, "CountrySubDivisionName"))
			ReadString(&pFinancialInstitutionAddress->pCountrySubDivisionName, ReadXmlDataString(pXmlTagData->pData));		// xs:string
		else if(!strcmp(pXmlTagData->pTag, "CountryName"))
			ReadString(&pFinancialInstitutionAddress->pCountryName, ReadXmlDataString(pXmlTagData->pData));		// xs:string

		pXmlTagData=GetNextXmlTag(pXmlTagData);

		if(!pXmlTagData)
			return 0;	// Fatal error
	}
	return pFinancialInstitutionAddress;
}


/*********************************************************************

static BOOL WriteSectionFinancialInstitutionAddress(

*********************************************************************/
static BOOL WriteSectionFinancialInstitutionAddress(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	FinancialInstitutionAddressType *pFinancialInstitutionAddress)
{
	if(!pFinancialInstitutionAddress)
		return FALSE;	// Fatal error

	xmlWriteLine(pStream, iTab-1, pAttr, pLabel, 0, 0);
	if(pFinancialInstitutionAddress->pPostcodeCode && *pFinancialInstitutionAddress->pPostcodeCode)
		xmlWriteLine(pStream, iTab, 0, "PostcodeCode", pFinancialInstitutionAddress->pPostcodeCode, "PostcodeCode");		// xs:token
	if(pFinancialInstitutionAddress->pBuildingNumber && *pFinancialInstitutionAddress->pBuildingNumber)
		xmlWriteLine(pStream, iTab, 0, "BuildingNumber", pFinancialInstitutionAddress->pBuildingNumber, "BuildingNumber");		// xs:string
	if(pFinancialInstitutionAddress->pLineOne && *pFinancialInstitutionAddress->pLineOne)
		xmlWriteLine(pStream, iTab, 0, "LineOne", pFinancialInstitutionAddress->pLineOne, "LineOne");		// xs:string
	if(pFinancialInstitutionAddress->pLineTwo && *pFinancialInstitutionAddress->pLineTwo)
		xmlWriteLine(pStream, iTab, 0, "LineTwo", pFinancialInstitutionAddress->pLineTwo, "LineTwo");		// xs:string
	if(pFinancialInstitutionAddress->pLineThree && *pFinancialInstitutionAddress->pLineThree)
		xmlWriteLine(pStream, iTab, 0, "LineThree", pFinancialInstitutionAddress->pLineThree, "LineThree");		// xs:string
	if(pFinancialInstitutionAddress->pLineFour && *pFinancialInstitutionAddress->pLineFour)
		xmlWriteLine(pStream, iTab, 0, "LineFour", pFinancialInstitutionAddress->pLineFour, "LineFour");		// xs:string
	if(pFinancialInstitutionAddress->pLineFive && *pFinancialInstitutionAddress->pLineFive)
		xmlWriteLine(pStream, iTab, 0, "LineFive", pFinancialInstitutionAddress->pLineFive, "LineFive");		// xs:string
	if(pFinancialInstitutionAddress->pStreetName && *pFinancialInstitutionAddress->pStreetName)
		xmlWriteLine(pStream, iTab, 0, "StreetName", pFinancialInstitutionAddress->pStreetName, "StreetName");		// xs:string
	if(pFinancialInstitutionAddress->pCityName && *pFinancialInstitutionAddress->pCityName)
		xmlWriteLine(pStream, iTab, 0, "CityName", pFinancialInstitutionAddress->pCityName, "CityName");		// xs:string
	if(pFinancialInstitutionAddress->pCountrySubDivisionId && *pFinancialInstitutionAddress->pCountrySubDivisionId)
		xmlWriteLine(pStream, iTab, 0, "CountrySubDivisionId", pFinancialInstitutionAddress->pCountrySubDivisionId, "CountrySubDivisionId");		// xs:token
	if(pFinancialInstitutionAddress->pCountryId && *pFinancialInstitutionAddress->pCountryId)
		xmlWriteLine(pStream, iTab, 0, "CountryId", pFinancialInstitutionAddress->pCountryId, "CountryId");		// rac:Country
	if(pFinancialInstitutionAddress->pTypeCode && *pFinancialInstitutionAddress->pTypeCode)
		xmlWriteLine(pStream, iTab, 0, "TypeCode", pFinancialInstitutionAddress->pTypeCode, "TypeCode");		// xs:token
	if(pFinancialInstitutionAddress->pDepartmentName && *pFinancialInstitutionAddress->pDepartmentName)
		xmlWriteLine(pStream, iTab, 0, "DepartmentName", pFinancialInstitutionAddress->pDepartmentName, "DepartmentName");		// xs:string
	if(pFinancialInstitutionAddress->pPostOfficeBox && *pFinancialInstitutionAddress->pPostOfficeBox)
		xmlWriteLine(pStream, iTab, 0, "PostOfficeBox", pFinancialInstitutionAddress->pPostOfficeBox, "PostOfficeBox");		// xs:string
	if(pFinancialInstitutionAddress->pCityId && *pFinancialInstitutionAddress->pCityId)
		xmlWriteLine(pStream, iTab, 0, "CityId", pFinancialInstitutionAddress->pCityId, "CityId");		// xs:token
	if(pFinancialInstitutionAddress->pCountrySubDivisionName && *pFinancialInstitutionAddress->pCountrySubDivisionName)
		xmlWriteLine(pStream, iTab, 0, "CountrySubDivisionName", pFinancialInstitutionAddress->pCountrySubDivisionName, "CountrySubDivisionName");		// xs:string
	if(pFinancialInstitutionAddress->pCountryName && *pFinancialInstitutionAddress->pCountryName)
		xmlWriteLine(pStream, iTab, 0, "CountryName", pFinancialInstitutionAddress->pCountryName, "CountryName");		// xs:string

	xmlWriteLine(pStream, iTab-1, 0, 0, 0, pLabel);

	return TRUE;
}


/*********************************************************************

FinancialInstitutionAddressType *UpdateFinancialInstitutionAddress(

*********************************************************************/
FinancialInstitutionAddressType *UpdateFinancialInstitutionAddress(
	FinancialInstitutionAddressType *pStructFinancialInstitutionAddress, 
	char *pPostcodeCode, 
	char *pBuildingNumber, 
	char *pLineOne, 
	char *pLineTwo, 
	char *pLineThree, 
	char *pLineFour, 
	char *pLineFive, 
	char *pStreetName, 
	char *pCityName, 
	char *pCountrySubDivisionId, 
	char *pCountryId, 
	char *pTypeCode, 
	char *pDepartmentName, 
	char *pPostOfficeBox, 
	char *pCityId, 
	char *pCountrySubDivisionName, 
	char *pCountryName)
{
	StringUpdate(&pStructFinancialInstitutionAddress->pPostcodeCode, pPostcodeCode);
	StringUpdate(&pStructFinancialInstitutionAddress->pBuildingNumber, pBuildingNumber);
	StringUpdate(&pStructFinancialInstitutionAddress->pLineOne, pLineOne);
	StringUpdate(&pStructFinancialInstitutionAddress->pLineTwo, pLineTwo);
	StringUpdate(&pStructFinancialInstitutionAddress->pLineThree, pLineThree);
	StringUpdate(&pStructFinancialInstitutionAddress->pLineFour, pLineFour);
	StringUpdate(&pStructFinancialInstitutionAddress->pLineFive, pLineFive);
	StringUpdate(&pStructFinancialInstitutionAddress->pStreetName, pStreetName);
	StringUpdate(&pStructFinancialInstitutionAddress->pCityName, pCityName);
	StringUpdate(&pStructFinancialInstitutionAddress->pCountrySubDivisionId, pCountrySubDivisionId);
	StringUpdate(&pStructFinancialInstitutionAddress->pCountryId, pCountryId);
	StringUpdate(&pStructFinancialInstitutionAddress->pTypeCode, pTypeCode);
	StringUpdate(&pStructFinancialInstitutionAddress->pDepartmentName, pDepartmentName);
	StringUpdate(&pStructFinancialInstitutionAddress->pPostOfficeBox, pPostOfficeBox);
	StringUpdate(&pStructFinancialInstitutionAddress->pCityId, pCityId);
	StringUpdate(&pStructFinancialInstitutionAddress->pCountrySubDivisionName, pCountrySubDivisionName);
	StringUpdate(&pStructFinancialInstitutionAddress->pCountryName, pCountryName);

	return pStructFinancialInstitutionAddress;
}


/*********************************************************************

char **GetLeadTextFinancialInstitutionAddress(

*********************************************************************/
char **GetLeadTextFinancialInstitutionAddress(
	char *pLang)
{
static char *szTexts[] = {
	"Postcode Code",
	"Building Number",
	"Line One",
	"Line Two",
	"Line Three",
	"Line Four",
	"Line Five",
	"Street Name",
	"City Name",
	"Country Sub Division Id",
	"Country Id",
	"Type Code",
	"Department Name",
	"Post Office Box",
	"City Id",
	"Country Sub Division Name",
	"Country Name"};

	return szTexts;
}


/*********************************************************************

	AmountCurrency

*********************************************************************

AmountCurrencyType *CreateAmountCurrency(

*********************************************************************/
AmountCurrencyType *CreateAmountCurrency(
	void *pStructDocTop, 
	void *pStructParent)
{
AmountCurrencyType *pAmountCurrency = calloc(1, sizeof(AmountCurrencyType));

	if(!pAmountCurrency)
		return 0;	// Fatal error

	pAmountCurrency->DataType    = SCT_AMOUNTCURRENCY;
	pAmountCurrency->pStructDocTop = pStructDocTop;
	pAmountCurrency->pStructParent = pStructParent;

	pAmountCurrency->pcurr = NulString;

	return pAmountCurrency;
}


/*********************************************************************

AmountCurrencyType *DestroyAmountCurrency(

*********************************************************************/
AmountCurrencyType *DestroyAmountCurrency(
	AmountCurrencyType **ppAmountCurrency)
{
	if(!*ppAmountCurrency)
		return 0;	// Nothing to destroy

	FreeString(&(*ppAmountCurrency)->pcurr);		// rac:Currency

	free(*ppAmountCurrency);
	*ppAmountCurrency = 0;

	return 0;
}


/*********************************************************************

AmountCurrencyType *CopyAmountCurrency(

*********************************************************************/
AmountCurrencyType *CopyAmountCurrency(
	void *pStructDocTop, 
	void *pStructParent, 
	AmountCurrencyType *pAmountCurrency)
{
	if(pAmountCurrency) {
		AmountCurrencyType *pNewAmountCurrency = CreateAmountCurrency(pStructDocTop, pStructParent);

		if(!pNewAmountCurrency)
			return 0;	// Fatal error

		pNewAmountCurrency->AmountCurrency = pAmountCurrency->AmountCurrency;		// rac:Amount
		CopyString(&pNewAmountCurrency->pcurr, pAmountCurrency->pcurr);		// rac:Currency

		return (pNewAmountCurrency);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataAmountCurrency(

*********************************************************************/
BOOL IsDataAmountCurrency(
	AmountCurrencyType *pAmountCurrency)
{
	if(!pAmountCurrency)
		return FALSE;

	if(pAmountCurrency->AmountCurrency)
		return TRUE;
	if(pAmountCurrency->pcurr && *pAmountCurrency->pcurr)
		return TRUE;

	return FALSE;
}


/*********************************************************************

static AmountCurrencyType *ReadSectionAmountCurrency(

*********************************************************************/
static AmountCurrencyType *ReadSectionAmountCurrency(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
AmountCurrencyType *pAmountCurrency = CreateAmountCurrency(pStructDocTop, pStructParent);

	if(!pAmountCurrency)
		return 0;	// Fatal error

	if(!pXmlTagData)
		return 0;	// Fatal error

	pAmountCurrency->AmountCurrency = StringToAmount(pXmlTagData->pData);		// rac:Amount
	if(pXmlTagData->Attr) {
		char *pAttr = CloseXmlAttrString(pXmlTagData->Attr, "curr");
		if(pAttr) {
			ReadString(&pAmountCurrency->pcurr, ReadXmlDataString(pAttr));
			pAttr[strlen(pAttr)] = '"';
			}
	}
	return pAmountCurrency;
}


/*********************************************************************

static BOOL WriteSectionAmountCurrency(

*********************************************************************/
static BOOL WriteSectionAmountCurrency(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	AmountCurrencyType *pAmountCurrency)
{
	if(!pAmountCurrency)
		return FALSE;	// Fatal error

	if(pAmountCurrency->AmountCurrency) {
		strcpy(szAttribData, "curr");
		strcat(szAttribData, "=\"");
		strcat(szAttribData, pAmountCurrency->pcurr);	// rac:Currency - Mandatory
		strcat(szAttribData, "\"");
	
		xmlWriteLine(pStream, iTab-1, szAttribData, pLabel, AmountToStr(pAmountCurrency->AmountCurrency, szString), pLabel);		// rac:Amount
		memset(szAttribData, 0, TEMPSTRING_LENGTH);
	}


	return TRUE;
}


/*********************************************************************

AmountCurrencyType *UpdateAmountCurrency(

*********************************************************************/
AmountCurrencyType *UpdateAmountCurrency(
	AmountCurrencyType *pStructAmountCurrency, 
	AMOUNT AmountCurrency, 
	char *pcurr)
{
	pStructAmountCurrency->AmountCurrency = AmountCurrency;
	StringUpdate(&pStructAmountCurrency->pcurr, pcurr);

	return pStructAmountCurrency;
}


/*********************************************************************

char **GetLeadTextAmountCurrency(

*********************************************************************/
char **GetLeadTextAmountCurrency(
	char *pLang)
{
static char *szTexts[] = {
	"Amount Currency",
	"curr"};

	return szTexts;
}


/*********************************************************************

	Text

*********************************************************************

TextType *CreateText(

*********************************************************************/
TextType *CreateText(
	void *pStructDocTop, 
	void *pStructParent)
{
TextType *pText = calloc(1, sizeof(TextType));

	if(!pText)
		return 0;	// Fatal error

	pText->DataType    = SCT_TEXT;
	pText->pStructDocTop = pStructDocTop;
	pText->pStructParent = pStructParent;

	pText->pText = NulString;
	pText->plang = NulString;

	return pText;
}


/*********************************************************************

TextType *DestroyText(

*********************************************************************/
TextType *DestroyText(
	TextType **ppText)
{
	if(!*ppText)
		return 0;	// Nothing to destroy

	FreeString(&(*ppText)->pText);		// xs:token
	FreeString(&(*ppText)->plang);		// xs:language

	free(*ppText);
	*ppText = 0;

	return 0;
}


/*********************************************************************

TextType *CopyText(

*********************************************************************/
TextType *CopyText(
	void *pStructDocTop, 
	void *pStructParent, 
	TextType *pText)
{
	if(pText) {
		TextType *pNewText = CreateText(pStructDocTop, pStructParent);

		if(!pNewText)
			return 0;	// Fatal error

		CopyString(&pNewText->pText, pText->pText);		// xs:token
		CopyString(&pNewText->plang, pText->plang);		// xs:language

		return (pNewText);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataText(

*********************************************************************/
BOOL IsDataText(
	TextType *pText)
{
	if(!pText)
		return FALSE;

	if(pText->pText && *pText->pText)
		return TRUE;
	if(pText->plang && *pText->plang)
		return TRUE;

	return FALSE;
}


/*********************************************************************

static TextType *ReadSectionText(

*********************************************************************/
static TextType *ReadSectionText(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
TextType *pText = CreateText(pStructDocTop, pStructParent);

	if(!pText)
		return 0;	// Fatal error

	if(!pXmlTagData)
		return 0;	// Fatal error

	ReadString(&pText->pText, ReadXmlDataString(pXmlTagData->pData));		// xs:token
	if(pXmlTagData->Attr) {
		char *pAttr = CloseXmlAttrString(pXmlTagData->Attr, "lang");
		if(pAttr) {
			ReadString(&pText->plang, ReadXmlDataString(pAttr));
			pAttr[strlen(pAttr)] = '"';
			}
	}
	return pText;
}


/*********************************************************************

static BOOL WriteSectionText(

*********************************************************************/
static BOOL WriteSectionText(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	TextType *pText)
{
	if(!pText)
		return FALSE;	// Fatal error

	if(pText->pText && *pText->pText) {
		if(pText->plang && *pText->plang) {
			strcpy(szAttribData, "lang");
			strcat(szAttribData, "=\"");
			strcat(szAttribData, pText->plang);	// xs:language
			strcat(szAttribData, "\"");
		}
		xmlWriteLine(pStream, iTab-1, szAttribData, pLabel, pText->pText, pLabel);		// xs:token
		memset(szAttribData, 0, TEMPSTRING_LENGTH);
	}


	return TRUE;
}


/*********************************************************************

TextType *UpdateText(

*********************************************************************/
TextType *UpdateText(
	TextType *pStructText, 
	char *pText, 
	char *plang)
{
	StringUpdate(&pStructText->pText, pText);
	StringUpdate(&pStructText->plang, plang);

	return pStructText;
}


/*********************************************************************

char **GetLeadTextText(

*********************************************************************/
char **GetLeadTextText(
	char *pLang)
{
static char *szTexts[] = {
	"Text",
	"lang"};

	return szTexts;
}


/*********************************************************************

	OperatorInfo

*********************************************************************

OperatorInfoType *CreateOperatorInfo(

*********************************************************************/
OperatorInfoType *CreateOperatorInfo(
	void *pStructDocTop, 
	void *pStructParent)
{
OperatorInfoType *pOperatorInfo = calloc(1, sizeof(OperatorInfoType));

	if(!pOperatorInfo)
		return 0;	// Fatal error

	pOperatorInfo->DataType    = SCT_OPERATORINFO;
	pOperatorInfo->pStructDocTop = pStructDocTop;
	pOperatorInfo->pStructParent = pStructParent;

	pOperatorInfo->pOperatorInfo = NulString;

	return pOperatorInfo;
}


/*********************************************************************

OperatorInfoType *DestroyOperatorInfo(

*********************************************************************/
OperatorInfoType *DestroyOperatorInfo(
	OperatorInfoType **ppOperatorInfo)
{
	if(!*ppOperatorInfo)
		return 0;	// Nothing to destroy

	FreeString(&(*ppOperatorInfo)->pOperatorInfo);		// rac:IdToken

	free(*ppOperatorInfo);
	*ppOperatorInfo = 0;

	return 0;
}


/*********************************************************************

OperatorInfoType *CopyOperatorInfo(

*********************************************************************/
OperatorInfoType *CopyOperatorInfo(
	void *pStructDocTop, 
	void *pStructParent, 
	OperatorInfoType *pOperatorInfo)
{
	if(pOperatorInfo) {
		OperatorInfoType *pNewOperatorInfo = CreateOperatorInfo(pStructDocTop, pStructParent);

		if(!pNewOperatorInfo)
			return 0;	// Fatal error

		CopyString(&pNewOperatorInfo->pOperatorInfo, pOperatorInfo->pOperatorInfo);		// rac:IdToken
		pNewOperatorInfo->date = pOperatorInfo->date;		// xs:date

		return (pNewOperatorInfo);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataOperatorInfo(

*********************************************************************/
BOOL IsDataOperatorInfo(
	OperatorInfoType *pOperatorInfo)
{
	if(!pOperatorInfo)
		return FALSE;

	if(pOperatorInfo->pOperatorInfo && *pOperatorInfo->pOperatorInfo)
		return TRUE;
	if(pOperatorInfo->date)
		return TRUE;

	return FALSE;
}


/*********************************************************************

static OperatorInfoType *ReadSectionOperatorInfo(

*********************************************************************/
static OperatorInfoType *ReadSectionOperatorInfo(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
OperatorInfoType *pOperatorInfo = CreateOperatorInfo(pStructDocTop, pStructParent);

	if(!pOperatorInfo)
		return 0;	// Fatal error

	if(!pXmlTagData)
		return 0;	// Fatal error

	ReadString(&pOperatorInfo->pOperatorInfo, ReadXmlDataString(pXmlTagData->pData));		// rac:IdToken
	if(pXmlTagData->Attr) {
		char *pAttr = CloseXmlAttrString(pXmlTagData->Attr, "date");
		if(pAttr) {
			pOperatorInfo->date = StringToDate(pAttr);
			pAttr[strlen(pAttr)] = '"';
			}
	}
	return pOperatorInfo;
}


/*********************************************************************

static BOOL WriteSectionOperatorInfo(

*********************************************************************/
static BOOL WriteSectionOperatorInfo(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	OperatorInfoType *pOperatorInfo)
{
	if(!pOperatorInfo)
		return FALSE;	// Fatal error

	if(pOperatorInfo->pOperatorInfo && *pOperatorInfo->pOperatorInfo) {
		if(pOperatorInfo->date) {
			strcat(szAttribData, "date");
			strcat(szAttribData, "=\"");
			DateToStr(pOperatorInfo->date, &szAttribData[strlen(szAttribData)]);	//xs:date
			strcat(szAttribData, "\"");
		}
		xmlWriteLine(pStream, iTab-1, szAttribData, pLabel, pOperatorInfo->pOperatorInfo, pLabel);		// rac:IdToken
		memset(szAttribData, 0, TEMPSTRING_LENGTH);
	}


	return TRUE;
}


/*********************************************************************

OperatorInfoType *UpdateOperatorInfo(

*********************************************************************/
OperatorInfoType *UpdateOperatorInfo(
	OperatorInfoType *pStructOperatorInfo, 
	char *pOperatorInfo, 
	DATEINT date)
{
	StringUpdate(&pStructOperatorInfo->pOperatorInfo, pOperatorInfo);
	pStructOperatorInfo->date = date;

	return pStructOperatorInfo;
}


/*********************************************************************

char **GetLeadTextOperatorInfo(

*********************************************************************/
char **GetLeadTextOperatorInfo(
	char *pLang)
{
static char *szTexts[] = {
	"Operator Info",
	"date"};

	return szTexts;
}


/*********************************************************************

	ProgramInfo

*********************************************************************

ProgramInfoType *CreateProgramInfo(

*********************************************************************/
ProgramInfoType *CreateProgramInfo(
	void *pStructDocTop, 
	void *pStructParent)
{
ProgramInfoType *pProgramInfo = calloc(1, sizeof(ProgramInfoType));

	if(!pProgramInfo)
		return 0;	// Fatal error

	pProgramInfo->DataType    = SCT_PROGRAMINFO;
	pProgramInfo->pStructDocTop = pStructDocTop;
	pProgramInfo->pStructParent = pStructParent;

	pProgramInfo->pProgramInfo = NulString;
	pProgramInfo->pversion = NulString;

	return pProgramInfo;
}


/*********************************************************************

ProgramInfoType *DestroyProgramInfo(

*********************************************************************/
ProgramInfoType *DestroyProgramInfo(
	ProgramInfoType **ppProgramInfo)
{
	if(!*ppProgramInfo)
		return 0;	// Nothing to destroy

	FreeString(&(*ppProgramInfo)->pProgramInfo);		// rac:IdToken
	FreeString(&(*ppProgramInfo)->pversion);		// rac:IdToken

	free(*ppProgramInfo);
	*ppProgramInfo = 0;

	return 0;
}


/*********************************************************************

ProgramInfoType *CopyProgramInfo(

*********************************************************************/
ProgramInfoType *CopyProgramInfo(
	void *pStructDocTop, 
	void *pStructParent, 
	ProgramInfoType *pProgramInfo)
{
	if(pProgramInfo) {
		ProgramInfoType *pNewProgramInfo = CreateProgramInfo(pStructDocTop, pStructParent);

		if(!pNewProgramInfo)
			return 0;	// Fatal error

		CopyString(&pNewProgramInfo->pProgramInfo, pProgramInfo->pProgramInfo);		// rac:IdToken
		CopyString(&pNewProgramInfo->pversion, pProgramInfo->pversion);		// rac:IdToken

		return (pNewProgramInfo);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataProgramInfo(

*********************************************************************/
BOOL IsDataProgramInfo(
	ProgramInfoType *pProgramInfo)
{
	if(!pProgramInfo)
		return FALSE;

	if(pProgramInfo->pProgramInfo && *pProgramInfo->pProgramInfo)
		return TRUE;
	if(pProgramInfo->pversion && *pProgramInfo->pversion)
		return TRUE;

	return FALSE;
}


/*********************************************************************

static ProgramInfoType *ReadSectionProgramInfo(

*********************************************************************/
static ProgramInfoType *ReadSectionProgramInfo(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
ProgramInfoType *pProgramInfo = CreateProgramInfo(pStructDocTop, pStructParent);

	if(!pProgramInfo)
		return 0;	// Fatal error

	if(!pXmlTagData)
		return 0;	// Fatal error

	ReadString(&pProgramInfo->pProgramInfo, ReadXmlDataString(pXmlTagData->pData));		// rac:IdToken
	if(pXmlTagData->Attr) {
		char *pAttr = CloseXmlAttrString(pXmlTagData->Attr, "version");
		if(pAttr) {
			ReadString(&pProgramInfo->pversion, ReadXmlDataString(pAttr));
			pAttr[strlen(pAttr)] = '"';
			}
	}
	return pProgramInfo;
}


/*********************************************************************

static BOOL WriteSectionProgramInfo(

*********************************************************************/
static BOOL WriteSectionProgramInfo(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	ProgramInfoType *pProgramInfo)
{
	if(!pProgramInfo)
		return FALSE;	// Fatal error

	if(pProgramInfo->pProgramInfo && *pProgramInfo->pProgramInfo) {
		strcpy(szAttribData, "version");
		strcat(szAttribData, "=\"");
		strcat(szAttribData, pProgramInfo->pversion);	// rac:IdToken - Mandatory
		strcat(szAttribData, "\"");
	
		xmlWriteLine(pStream, iTab-1, szAttribData, pLabel, pProgramInfo->pProgramInfo, pLabel);		// rac:IdToken
		memset(szAttribData, 0, TEMPSTRING_LENGTH);
	}


	return TRUE;
}


/*********************************************************************

ProgramInfoType *UpdateProgramInfo(

*********************************************************************/
ProgramInfoType *UpdateProgramInfo(
	ProgramInfoType *pStructProgramInfo, 
	char *pProgramInfo, 
	char *pversion)
{
	StringUpdate(&pStructProgramInfo->pProgramInfo, pProgramInfo);
	StringUpdate(&pStructProgramInfo->pversion, pversion);

	return pStructProgramInfo;
}


/*********************************************************************

char **GetLeadTextProgramInfo(

*********************************************************************/
char **GetLeadTextProgramInfo(
	char *pLang)
{
static char *szTexts[] = {
	"Program Info",
	"version"};

	return szTexts;
}


/*********************************************************************

	SeriesId

*********************************************************************

SeriesIdType *CreateSeriesId(

*********************************************************************/
SeriesIdType *CreateSeriesId(
	void *pStructDocTop, 
	void *pStructParent)
{
SeriesIdType *pSeriesId = calloc(1, sizeof(SeriesIdType));

	if(!pSeriesId)
		return 0;	// Fatal error

	pSeriesId->DataType    = SCT_SERIESID;
	pSeriesId->pStructDocTop = pStructDocTop;
	pSeriesId->pStructParent = pStructParent;

	pSeriesId->pseries = NulString;

	return pSeriesId;
}


/*********************************************************************

SeriesIdType *DestroySeriesId(

*********************************************************************/
SeriesIdType *DestroySeriesId(
	SeriesIdType **ppSeriesId)
{
	if(!*ppSeriesId)
		return 0;	// Nothing to destroy

	FreeString(&(*ppSeriesId)->pseries);		// rac:IdToken

	free(*ppSeriesId);
	*ppSeriesId = 0;

	return 0;
}


/*********************************************************************

SeriesIdType *CopySeriesId(

*********************************************************************/
SeriesIdType *CopySeriesId(
	void *pStructDocTop, 
	void *pStructParent, 
	SeriesIdType *pSeriesId)
{
	if(pSeriesId) {
		SeriesIdType *pNewSeriesId = CreateSeriesId(pStructDocTop, pStructParent);

		if(!pNewSeriesId)
			return 0;	// Fatal error

		pNewSeriesId->SeriesId = pSeriesId->SeriesId;		// xs:positiveInteger
		CopyString(&pNewSeriesId->pseries, pSeriesId->pseries);		// rac:IdToken

		return (pNewSeriesId);
	}
	return 0;	// Nothing to Copy
}


/*********************************************************************

BOOL IsDataSeriesId(

*********************************************************************/
BOOL IsDataSeriesId(
	SeriesIdType *pSeriesId)
{
	if(!pSeriesId)
		return FALSE;

	if(pSeriesId->SeriesId)
		return TRUE;
	if(pSeriesId->pseries && *pSeriesId->pseries)
		return TRUE;

	return FALSE;
}


/*********************************************************************

static SeriesIdType *ReadSectionSeriesId(

*********************************************************************/
static SeriesIdType *ReadSectionSeriesId(
	void *pStructDocTop, 
	void *pStructParent, 
	XmlTagDataType *pXmlTagData, 
	char *pEndTag)
{
SeriesIdType *pSeriesId = CreateSeriesId(pStructDocTop, pStructParent);

	if(!pSeriesId)
		return 0;	// Fatal error

	if(!pXmlTagData)
		return 0;	// Fatal error

	pSeriesId->SeriesId = StringToCounter(pXmlTagData->pData);		// xs:positiveInteger
	if(pXmlTagData->Attr) {
		char *pAttr = CloseXmlAttrString(pXmlTagData->Attr, "series");
		if(pAttr) {
			ReadString(&pSeriesId->pseries, ReadXmlDataString(pAttr));
			pAttr[strlen(pAttr)] = '"';
			}
	}
	return pSeriesId;
}


/*********************************************************************

static BOOL WriteSectionSeriesId(

*********************************************************************/
static BOOL WriteSectionSeriesId(
	FILE *pStream, 
	int iTab, 
	char *pLabel, 
	char *pAttr, 
	SeriesIdType *pSeriesId)
{
	if(!pSeriesId)
		return FALSE;	// Fatal error

	if(pSeriesId->SeriesId) {
		if(pSeriesId->pseries && *pSeriesId->pseries) {
			strcpy(szAttribData, "series");
			strcat(szAttribData, "=\"");
			strcat(szAttribData, pSeriesId->pseries);	// rac:IdToken
			strcat(szAttribData, "\"");
		}
		xmlWriteLine(pStream, iTab-1, szAttribData, pLabel, CounterToStr(pSeriesId->SeriesId, szString), pLabel);		// xs:positiveInteger
		memset(szAttribData, 0, TEMPSTRING_LENGTH);
	}


	return TRUE;
}


/*********************************************************************

SeriesIdType *UpdateSeriesId(

*********************************************************************/
SeriesIdType *UpdateSeriesId(
	SeriesIdType *pStructSeriesId, 
	COUNTER SeriesId, 
	char *pseries)
{
	pStructSeriesId->SeriesId = SeriesId;
	StringUpdate(&pStructSeriesId->pseries, pseries);

	return pStructSeriesId;
}


/*********************************************************************

char **GetLeadTextSeriesId(

*********************************************************************/
char **GetLeadTextSeriesId(
	char *pLang)
{
static char *szTexts[] = {
	"Series Id",
	"series"};

	return szTexts;
}
